/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(Y){for(var e=[],g=0,R=Y.length;g<R;g++)e[g]=me[Y[g]];return e};define(me[54],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(R,k){if(!R)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=g}),define(me[55],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function R(i){const I=[];for(let c in i)g.call(i,c)&&I.push(i[c]);return I}e.values=R;function k(i,I){for(let c in i)if(g.call(i,c)&&I({key:c,value:i[c]},function(){delete i[c]})===!1)return}e.forEach=k;function C(i,I){const c=Object.create(null);for(const m of i){const h=I(m);let v=c[h];v||(v=c[h]=[]),v.push(m)}return c}e.groupBy=C;function T(i){const I=Object.create(null);return i&&i.forEach((c,m)=>{I[m]=c}),I}e.fromMap=T;function y(i,I){const c=[],m=[];for(let h of i)I.has(h)||c.push(h);for(let h of I)i.has(h)||m.push(h);return{removed:c,added:m}}e.diffSets=y;function S(i,I){const c=[],m=[];for(let[h,v]of i)I.has(h)||c.push(v);for(let[h,v]of I)i.has(h)||m.push(v);return{removed:c,added:m}}e.diffMaps=S;class A{constructor(){this.map=new Map}add(I,c){let m=this.map.get(I);m||(m=new Set,this.map.set(I,m)),m.add(c)}delete(I,c){const m=this.map.get(I);!m||(m.delete(c),m.size===0&&this.map.delete(I))}forEach(I,c){const m=this.map.get(I);!m||m.forEach(c)}}e.SetMap=A}),define(me[56],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(T){return(y,S,A)=>{let i=null,I=null;if(typeof A.value=="function"?(i="value",I=A.value):typeof A.get=="function"&&(i="get",I=A.get),!I)throw new Error("not supported");A[i]=T(I,S)}}e.createDecorator=g;function R(T,y,S){let A=null,i=null;if(typeof S.value=="function"?(A="value",i=S.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(A="get",i=S.get),!i)throw new Error("not supported");const I=`$memoize$${y}`;S[A]=function(...c){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,c)}),this[I]}}e.memoize=R;function k(T,y,S){return g((A,i)=>{const I=`$debounce$${i}`,c=`$debounce$result$${i}`;return function(...m){this[c]||(this[c]=S?S():void 0),clearTimeout(this[I]),y&&(this[c]=y(this[c],...m),m=[this[c]]),this[I]=setTimeout(()=>{A.apply(this,m),this[c]=S?S():void 0},T)}})}e.debounce=k;function C(T,y,S){return g((A,i)=>{const I=`$throttle$timer$${i}`,c=`$throttle$result$${i}`,m=`$throttle$lastRun$${i}`,h=`$throttle$pending$${i}`;return function(...v){if(this[c]||(this[c]=S?S():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),y&&(this[c]=y(this[c],...v)),this[h])return;const _=this[m]+T;_<=Date.now()?(this[m]=Date.now(),A.apply(this,[this[c]]),this[c]=S?S():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[m]=Date.now(),A.apply(this,[this[c]]),this[c]=S?S():void 0},_-Date.now()))}})}e.throttle=C}),define(me[16],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function R(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=R;function k(p){S(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=k;function C(p){S(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=C;function T(p){if(p instanceof Error){let{name:t,message:s}=p;const o=p.stacktrace||p.stack;return{$isError:!0,name:t,message:s,stack:o}}return p}e.transformErrorForSerialization=T;const y="Canceled";function S(p){return p instanceof Error&&p.name===y&&p.message===y}e.isPromiseCanceledError=S;class A extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=A;function i(){const p=new Error(y);return p.name=p.message,p}e.canceled=i;function I(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=I;function c(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=c;function m(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function h(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function v(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=v;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function l(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function f(p,t=Object.create(null)){const s=new Error(p);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=f}),define(me[20],ge([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R($,G=0){return $[$.length-(1+G)]}e.tail=R;function k($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=k;function C($,G,J=(fe,ye)=>fe===ye){if($===G)return!0;if(!$||!G||$.length!==G.length)return!1;for(let fe=0,ye=$.length;fe<ye;fe++)if(!J($[fe],G[fe]))return!1;return!0}e.equals=C;function T($,G,J){let fe=0,ye=$.length-1;for(;fe<=ye;){const ke=(fe+ye)/2|0,Re=J($[ke],G);if(Re<0)fe=ke+1;else if(Re>0)ye=ke-1;else return ke}return-(fe+1)}e.binarySearch=T;function y($,G){let J=0,fe=$.length;if(fe===0)return 0;for(;J<fe;){const ye=Math.floor((J+fe)/2);G($[ye])?fe=ye:J=ye+1}return J}e.findFirstInSorted=y;function S($,G,J){if($=$|0,$>=G.length)throw new TypeError("invalid index");let fe=G[Math.floor(G.length*Math.random())],ye=[],ke=[],Re=[];for(let Ve of G){const Be=J(Ve,fe);Be<0?ye.push(Ve):Be>0?ke.push(Ve):Re.push(Ve)}return $<ye.length?S($,ye,J):$<ye.length+Re.length?Re[0]:S($-(ye.length+Re.length),ke,J)}e.quickSelect=S;function A($,G){const J=[];let fe;for(const ye of $.slice(0).sort(G))!fe||G(fe[0],ye)!==0?(fe=[ye],J.push(fe)):fe.push(ye);return J}e.groupBy=A;function i($,G,J){const fe=[];function ye(Ve,Be,Ke){if(Be===0&&Ke.length===0)return;const W=fe[fe.length-1];W&&W.start+W.deleteCount===Ve?(W.deleteCount+=Be,W.toInsert.push(...Ke)):fe.push({start:Ve,deleteCount:Be,toInsert:Ke})}let ke=0,Re=0;for(;;){if(ke===$.length){ye(ke,0,G.slice(Re));break}if(Re===G.length){ye(ke,$.length-ke,[]);break}const Ve=$[ke],Be=G[Re],Ke=J(Ve,Be);Ke===0?(ke+=1,Re+=1):Ke<0?(ye(ke,1,[]),ke+=1):Ke>0&&(ye(ke,0,[Be]),Re+=1)}return fe}e.sortedDiff=i;function I($,G,J){const fe=i($,G,J),ye=[],ke=[];for(const Re of fe)ye.push(...$.slice(Re.start,Re.start+Re.deleteCount)),ke.push(...Re.toInsert);return{removed:ye,added:ke}}e.delta=I;function c($,G,J){if(J===0)return[];const fe=$.slice(0,J).sort(G);return h($,G,fe,J,$.length),fe}e.top=c;function m($,G,J,fe,ye){return J===0?Promise.resolve([]):new Promise((ke,Re)=>{(async()=>{const Ve=$.length,Be=$.slice(0,J).sort(G);for(let Ke=J,W=Math.min(J+fe,Ve);Ke<Ve;Ke=W,W=Math.min(W+fe,Ve)){if(Ke>J&&await new Promise(Z=>setTimeout(Z)),ye&&ye.isCancellationRequested)throw(0,g.canceled)();h($,G,Be,Ke,W)}return Be})().then(ke,Re)})}e.topAsync=m;function h($,G,J,fe,ye){for(const ke=J.length;fe<ye;fe++){const Re=$[fe];if(G(Re,J[ke-1])<0){J.pop();const Ve=y(J,Be=>G(Re,Be)<0);J.splice(Ve,0,Re)}}}function v($){return $.filter(G=>!!G)}e.coalesce=v;function _($){let G=0;for(let J=0;J<$.length;J++)$[J]&&($[G]=$[J],G+=1);$.length=G}e.coalesceInPlace=_;function b($,G,J){$.splice(J,0,$.splice(G,1)[0])}e.move=b;function P($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=P;function l($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=l;function f($,G){if(!G)return $.filter((fe,ye)=>$.indexOf(fe)===ye);const J=Object.create(null);return $.filter(fe=>{const ye=G(fe);return J[ye]?!1:(J[ye]=!0,!0)})}e.distinct=f;function p($){const G=new Set;return $.filter(J=>G.has(J)?!1:(G.add(J),!0))}e.distinctES6=p;function t($){const G=Object.create(null);return J=>{const fe=$(J);return G[fe]?!1:(G[fe]=!0,!0)}}e.uniqueFilter=t;function s($,G){for(let J=$.length-1;J>=0;J--){const fe=$[J];if(G(fe))return J}return-1}e.lastIndex=s;function o($,G){return $.length>0?$[0]:G}e.firstOrDefault=o;function n($,G,J=(fe,ye)=>fe===ye){let fe=0;for(let ye=0,ke=Math.min($.length,G.length);ye<ke&&J($[ye],G[ye]);ye++)fe++;return fe}e.commonPrefixLength=n;function a($){return[].concat(...$)}e.flatten=a;function d($,G){let J=typeof G=="number"?$:0;typeof G=="number"?J=$:(J=0,G=$);const fe=[];if(J<=G)for(let ye=J;ye<G;ye++)fe.push(ye);else for(let ye=J;ye>G;ye--)fe.push(ye);return fe}e.range=d;function u($,G,J){return $.reduce((fe,ye)=>(fe[G(ye)]=J?J(ye):ye,fe),Object.create(null))}e.index=u;function w($,G){return $.push(G),()=>E($,G)}e.insert=w;function E($,G){const J=$.indexOf(G);if(J>-1)return $.splice(J,1),G}e.remove=E;function r($,G,J){const fe=$.slice(0,G),ye=$.slice(G);return fe.concat(J,ye)}e.arrayInsert=r;function D($,G){let J;if(typeof G=="number"){let fe=G;J=()=>{const ye=Math.sin(fe++)*179426549;return ye-Math.floor(ye)}}else J=Math.random;for(let fe=$.length-1;fe>0;fe-=1){const ye=Math.floor(J()*(fe+1)),ke=$[fe];$[fe]=$[ye],$[ye]=ke}}e.shuffle=D;function L($,G){const J=$.indexOf(G);J>-1&&($.splice(J,1),$.unshift(G))}e.pushToStart=L;function U($,G){const J=$.indexOf(G);J>-1&&($.splice(J,1),$.push(G))}e.pushToEnd=U;function j($,G){return Array.isArray($)?$.map(G):G($)}e.mapArrayOrNot=j;function te($){return Array.isArray($)?$:[$]}e.asArray=te;function K($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=K;function O($,G){for(const J of $){const fe=G(J);if(fe!==void 0)return fe}}e.mapFind=O;function x($,G,J){const fe=z($,G),ye=$.length,ke=J.length;$.length=ye+ke;for(let Re=ye-1;Re>=fe;Re--)$[Re+ke]=$[Re];for(let Re=0;Re<ke;Re++)$[Re+fe]=J[Re]}e.insertInto=x;function F($,G,J,fe){const ye=z($,G),ke=$.splice(ye,J);return x($,ye,fe),ke}e.splice=F;function z($,G){return G<0?Math.max(G+$.length,0):Math.min(G,$.length)}function M($,G){let J=Number.MAX_SAFE_INTEGER,fe=0;return $.forEach((ye,ke)=>{const Re=G(ye);Re<J&&(J=Re,fe=ke)}),fe}e.minIndex=M;function N($,G){let J=Number.MIN_SAFE_INTEGER,fe=0;return $.forEach((ye,ke)=>{const Re=G(ye);Re>J&&(J=Re,fe=ke)}),fe}e.maxIndex=N;class V{constructor(G){this.items=G,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(G){let J=this.firstIdx;for(;J<this.items.length&&G(this.items[J]);)J++;const fe=J===this.firstIdx?null:this.items.slice(this.firstIdx,J);return this.firstIdx=J,fe}takeFromEndWhile(G){let J=this.lastIdx;for(;J>=0&&G(this.items[J]);)J--;const fe=J===this.lastIdx?null:this.items.slice(J+1,this.lastIdx+1);return this.lastIdx=J,fe}}e.ArrayQueue=V}),define(me[73],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(R){const k=this;let C=!1,T;return function(){return C||(C=!0,T=R.apply(k,arguments)),T}}e.once=g}),define(me[74],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(me[75],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(R){function k(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}R.is=k;const C=Object.freeze([]);function T(){return C}R.empty=T;function*y(p){yield p}R.single=y;function S(p){return p||C}R.from=S;function A(p){return!p||p[Symbol.iterator]().next().done===!0}R.isEmpty=A;function i(p){return p[Symbol.iterator]().next().value}R.first=i;function I(p,t){for(const s of p)if(t(s))return!0;return!1}R.some=I;function c(p,t){for(const s of p)if(t(s))return s}R.find=c;function*m(p,t){for(const s of p)t(s)&&(yield s)}R.filter=m;function*h(p,t){let s=0;for(const o of p)yield t(o,s++)}R.map=h;function*v(...p){for(const t of p)for(const s of t)yield s}R.concat=v;function*_(p){for(const t of p)for(const s of t)yield s}R.concatNested=_;function b(p,t,s){let o=s;for(const n of p)o=t(o,n);return o}R.reduce=b;function*P(p,t,s=p.length){for(t<0&&(t+=p.length),s<0?s+=p.length:s>p.length&&(s=p.length);t<s;t++)yield p[t]}R.slice=P;function l(p,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,p];const o=p[Symbol.iterator]();for(let n=0;n<t;n++){const a=o.next();if(a.done)return[s,R.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return o}}]}R.consume=l;function f(p,t,s=(o,n)=>o===n){const o=p[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const a=o.next(),d=n.next();if(a.done!==d.done)return!1;if(a.done)return!0;if(!s(a.value,d.value))return!1}}R.equals=f})(g=e.Iterable||(e.Iterable={}))}),define(me[57],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function T(t,s=!1){let o=0,n=t.length,a="",d=0,u=16,w=0;function E(K){let O=0,x=0;for(;O<K;){const F=t.charCodeAt(o);if(F>=48&&F<=57)x=x*16+F-48;else if(F>=65&&F<=70)x=x*16+F-65+10;else if(F>=97&&F<=102)x=x*16+F-97+10;else break;o++,O++}return O<K&&(x=-1),x}function r(K){o=K,a="",d=0,u=16,w=0}function D(){const K=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&A(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&A(t.charCodeAt(o)))for(o++;o<t.length&&A(t.charCodeAt(o));)o++;else return w=3,t.substring(K,o);let O=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&A(t.charCodeAt(o))){for(o++;o<t.length&&A(t.charCodeAt(o));)o++;O=o}else w=3;return t.substring(K,O)}function L(){let K="",O=o;for(;;){if(o>=n){K+=t.substring(O,o),w=2;break}const x=t.charCodeAt(o);if(x===34){K+=t.substring(O,o),o++;break}if(x===92){if(K+=t.substring(O,o),o++,o>=n){w=2;break}switch(t.charCodeAt(o++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const z=E(4);z>=0?K+=String.fromCharCode(z):w=4;break;default:w=5}O=o;continue}if(x>=0&&x<=31)if(S(x)){K+=t.substring(O,o),w=2;break}else w=6;o++}return K}function U(){if(a="",w=0,d=o,o>=n)return d=n,u=17;let K=t.charCodeAt(o);if(y(K)){do o++,a+=String.fromCharCode(K),K=t.charCodeAt(o);while(y(K));return u=15}if(S(K))return o++,a+=String.fromCharCode(K),K===13&&t.charCodeAt(o)===10&&(o++,a+=`
`),u=14;switch(K){case 123:return o++,u=1;case 125:return o++,u=2;case 91:return o++,u=3;case 93:return o++,u=4;case 58:return o++,u=6;case 44:return o++,u=5;case 34:return o++,a=L(),u=10;case 47:const O=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<n&&!S(t.charCodeAt(o));)o++;return a=t.substring(O,o),u=12}if(t.charCodeAt(o+1)===42){o+=2;const x=n-1;let F=!1;for(;o<x;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,F=!0;break}o++}return F||(o++,w=1),a=t.substring(O,o),u=13}return a+=String.fromCharCode(K),o++,u=16;case 45:if(a+=String.fromCharCode(K),o++,o===n||!A(t.charCodeAt(o)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=D(),u=11;default:for(;o<n&&j(K);)o++,K=t.charCodeAt(o);if(d!==o){switch(a=t.substring(d,o),a){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return a+=String.fromCharCode(K),o++,u=16}}function j(K){if(y(K)||S(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function te(){let K;do K=U();while(K>=12&&K<=15);return K}return{setPosition:r,getPosition:()=>o,scan:s?te:U,getToken:()=>u,getTokenValue:()=>a,getTokenOffset:()=>d,getTokenLength:()=>o-d,getTokenError:()=>w}}e.createScanner=T;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function A(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,s){const o=[],n=new Object;let a;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function w(E,r,D,L){d.value=E,d.offset=r,d.length=D,d.type=L,d.colonOffset=void 0,a=d}try{l(t,{onObjectBegin:(E,r)=>{if(s<=E)throw n;a=void 0,u=s>E,o.push("")},onObjectProperty:(E,r,D)=>{if(s<r||(w(E,r,D,"property"),o[o.length-1]=E,s<=r+D))throw n},onObjectEnd:(E,r)=>{if(s<=E)throw n;a=void 0,o.pop()},onArrayBegin:(E,r)=>{if(s<=E)throw n;a=void 0,o.push(0)},onArrayEnd:(E,r)=>{if(s<=E)throw n;a=void 0,o.pop()},onLiteralValue:(E,r,D)=>{if(s<r||(w(E,r,D,p(E)),s<=r+D))throw n},onSeparator:(E,r,D)=>{if(s<=r)throw n;if(E===":"&&a&&a.type==="property")a.colonOffset=r,u=!1,a=void 0;else if(E===","){const L=o[o.length-1];typeof L=="number"?o[o.length-1]=L+1:(u=!0,o[o.length-1]=""),a=void 0}}})}catch(E){if(E!==n)throw E}return{path:o,previousNode:a,isAtPropertyKey:u,matches:E=>{let r=0;for(let D=0;r<E.length&&D<o.length;D++)if(E[r]===o[D]||E[r]==="*")r++;else if(E[r]!=="**")return!1;return r===E.length}}}e.getLocation=I;function c(t,s=[],o=C.DEFAULT){let n=null,a=[];const d=[];function u(E){Array.isArray(a)?a.push(E):n!==null&&(a[n]=E)}return l(t,{onObjectBegin:()=>{const E={};u(E),d.push(a),a=E,n=null},onObjectProperty:E=>{n=E},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const E=[];u(E),d.push(a),a=E,n=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:u,onError:(E,r,D)=>{s.push({error:E,offset:r,length:D})}},o),a[0]}e.parse=c;function m(t,s=[],o=C.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(E){n.type==="property"&&(n.length=E-n.offset,n=n.parent)}function d(E){return n.children.push(E),E}l(t,{onObjectBegin:E=>{n=d({type:"object",offset:E,length:-1,parent:n,children:[]})},onObjectProperty:(E,r,D)=>{n=d({type:"property",offset:r,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:E,offset:r,length:D,parent:n})},onObjectEnd:(E,r)=>{n.length=E+r-n.offset,n=n.parent,a(E+r)},onArrayBegin:(E,r)=>{n=d({type:"array",offset:E,length:-1,parent:n,children:[]})},onArrayEnd:(E,r)=>{n.length=E+r-n.offset,n=n.parent,a(E+r)},onLiteralValue:(E,r,D)=>{d({type:p(E),offset:r,length:D,parent:n,value:E}),a(r+D)},onSeparator:(E,r,D)=>{n.type==="property"&&(E===":"?n.colonOffset=r:E===","&&a(r))},onError:(E,r,D)=>{s.push({error:E,offset:r,length:D})}},o);const w=n.children[0];return w&&delete w.parent,w}e.parseTree=m;function h(t,s){if(!t)return;let o=t;for(let n of s)if(typeof n=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let a=!1;for(const d of o.children)if(Array.isArray(d.children)&&d.children[0].value===n){o=d.children[1],a=!0;break}if(!a)return}else{const a=n;if(o.type!=="array"||a<0||!Array.isArray(o.children)||a>=o.children.length)return;o=o.children[a]}return o}e.findNodeAtLocation=h;function v(t){if(!t.parent||!t.parent.children)return[];const s=v(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;s.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&s.push(o)}return s}e.getNodePath=v;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const s=Object.create(null);for(let o of t.children){const n=o.children[1];n&&(s[o.children[0].value]=_(n))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function b(t,s,o=!1){return s>=t.offset&&s<t.offset+t.length||o&&s===t.offset+t.length}e.contains=b;function P(t,s,o=!1){if(b(t,s,o)){const n=t.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=s;a++){const d=P(n[a],s,o);if(d)return d}return t}}e.findNodeAtOffset=P;function l(t,s,o=C.DEFAULT){const n=T(t,!1);function a(J){return J?()=>J(n.getTokenOffset(),n.getTokenLength()):()=>!0}function d(J){return J?fe=>J(fe,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=a(s.onObjectBegin),w=d(s.onObjectProperty),E=a(s.onObjectEnd),r=a(s.onArrayBegin),D=a(s.onArrayEnd),L=d(s.onLiteralValue),U=d(s.onSeparator),j=a(s.onComment),te=d(s.onError),K=o&&o.disallowComments,O=o&&o.allowTrailingComma;function x(){for(;;){const J=n.scan();switch(n.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:K||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(J){case 12:case 13:K?F(10):j();break;case 16:F(1);break;case 15:case 14:break;default:return J}}}function F(J,fe=[],ye=[]){if(te(J),fe.length+ye.length>0){let ke=n.getToken();for(;ke!==17;){if(fe.indexOf(ke)!==-1){x();break}else if(ye.indexOf(ke)!==-1)break;ke=x()}}}function z(J){const fe=n.getTokenValue();return J?L(fe):w(fe),x(),!0}function M(){switch(n.getToken()){case 11:let J=0;try{J=JSON.parse(n.getTokenValue()),typeof J!="number"&&(F(2),J=0)}catch(fe){F(2)}L(J);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return x(),!0}function N(){return n.getToken()!==10?(F(3,[],[2,5]),!1):(z(!1),n.getToken()===6?(U(":"),x(),G()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function V(){u(),x();let J=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(J||F(4,[],[]),U(","),x(),n.getToken()===2&&O)break}else J&&F(6,[],[]);N()||F(4,[],[2,5]),J=!0}return E(),n.getToken()!==2?F(7,[2],[]):x(),!0}function $(){r(),x();let J=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(J||F(4,[],[]),U(","),x(),n.getToken()===4&&O)break}else J&&F(6,[],[]);G()||F(4,[],[4,5]),J=!0}return D(),n.getToken()!==4?F(8,[4],[]):x(),!0}function G(){switch(n.getToken()){case 3:return $();case 1:return V();case 10:return z(!0);default:return M()}}return x(),n.getToken()===17?o.allowEmptyContent?!0:(F(4,[],[]),!1):G()?(n.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=l;function f(t,s){let o=T(t),n=[],a,d=0,u;do switch(u=o.getPosition(),a=o.scan(),a){case 12:case 13:case 17:d!==u&&n.push(t.substring(d,u)),s!==void 0&&n.push(o.getTokenValue().replace(/[^\r\n]/g,s)),d=o.getPosition();break}while(a!==17);return n.join("")}e.stripComments=f;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(me[137],ge([0,1,57]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(S,A,i){let I,c,m,h,v;if(A){for(h=A.offset,v=h+A.length,m=h;m>0&&!y(S,m-1);)m--;let d=v;for(;d<S.length&&!y(S,d);)d++;c=S.substring(m,d),I=C(c,i)}else c=S,I=0,m=0,h=0,v=S.length;const _=T(i,S);let b=!1,P=0,l;i.insertSpaces?l=k(" ",i.tabSize||4):l="	";const f=(0,g.createScanner)(c,!1);let p=!1;function t(){return _+k(l,I+P)}function s(){let d=f.scan();for(b=!1;d===15||d===14;)b=b||d===14,d=f.scan();return p=d===16||f.getTokenError()!==0,d}const o=[];function n(d,u,w){!p&&u<v&&w>h&&S.substring(u,w)!==d&&o.push({offset:u,length:w-u,content:d})}let a=s();if(a!==17){const d=f.getTokenOffset()+m,u=k(l,I);n(u,m,d)}for(;a!==17;){let d=f.getTokenOffset()+f.getTokenLength()+m,u=s(),w="";for(;!b&&(u===12||u===13);){const r=f.getTokenOffset()+m;n(" ",d,r),d=f.getTokenOffset()+f.getTokenLength()+m,w=u===12?t():"",u=s()}if(u===2)a!==1&&(P--,w=t());else if(u===4)a!==3&&(P--,w=t());else{switch(a){case 3:case 1:P++,w=t();break;case 5:case 12:w=t();break;case 13:b?w=t():w=" ";break;case 6:w=" ";break;case 10:if(u===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?w=" ":u!==5&&u!==17&&(p=!0);break;case 16:p=!0;break}b&&(u===12||u===13)&&(w=t())}const E=f.getTokenOffset()+m;n(w,d,E),a=u}return o}e.format=R;function k(S,A){let i="";for(let I=0;I<A;I++)i+=S;return i}function C(S,A){let i=0,I=0;const c=A.tabSize||4;for(;i<S.length;){const m=S.charAt(i);if(m===" ")I++;else if(m==="	")I+=c;else break;i++}return Math.floor(I/c)}function T(S,A){for(let i=0;i<A.length;i++){const I=A.charAt(i);if(I==="\r")return i+1<A.length&&A.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=T;function y(S,A){return`\r
`.indexOf(S.charAt(A))!==-1}e.isEOL=y}),define(me[138],ge([0,1,57,137]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(A,i,I){return C(A,i,void 0,I)}e.removeProperty=k;function C(A,i,I,c,m){const h=i.slice(),v=[],_=(0,g.parseTree)(A,v);let b,P;for(;h.length>0&&(P=h.pop(),b=(0,g.findNodeAtLocation)(_,h),b===void 0&&I!==void 0);)typeof P=="string"?I={[P]:I}:I=[I];if(b)if(b.type==="object"&&typeof P=="string"&&Array.isArray(b.children)){const l=(0,g.findNodeAtLocation)(b,[P]);if(l!==void 0)if(I===void 0){if(!l.parent)throw new Error("Malformed AST");const f=b.children.indexOf(l.parent);let p,t=l.parent.offset+l.parent.length;if(f>0){const s=b.children[f-1];p=s.offset+s.length}else p=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return T(A,{offset:p,length:t-p,content:""},c)}else return T(A,{offset:l.offset,length:l.length,content:JSON.stringify(I)},c);else{if(I===void 0)return[];const f=`${JSON.stringify(P)}: ${JSON.stringify(I)}`,p=m?m(b.children.map(s=>s.children[0].value)):b.children.length;let t;if(p>0){const s=b.children[p-1];t={offset:s.offset+s.length,length:0,content:","+f}}else b.children.length===0?t={offset:b.offset+1,length:0,content:f}:t={offset:b.offset+1,length:0,content:f+","};return T(A,t,c)}}else if(b.type==="array"&&typeof P=="number"&&Array.isArray(b.children))if(I!==void 0){const l=`${JSON.stringify(I)}`;let f;if(b.children.length===0||P===0)f={offset:b.offset+1,length:0,content:b.children.length===0?l:l+","};else{const p=P===-1||P>b.children.length?b.children.length:P,t=b.children[p-1];f={offset:t.offset+t.length,length:0,content:","+l}}return T(A,f,c)}else{const l=P,f=b.children[l];let p;if(b.children.length===1)p={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===l){const t=b.children[l-1],s=t.offset+t.length,o=b.offset+b.length;p={offset:s,length:o-2-s,content:""}}else p={offset:f.offset,length:b.children[l+1].offset-f.offset,content:""};return T(A,p,c)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${b.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return T(A,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(I)},c)}}e.setProperty=C;function T(A,i,I){let c=y(A,i),m=i.offset,h=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;m>0&&!(0,R.isEOL)(c,m-1);)m--;for(;h<c.length&&!(0,R.isEOL)(c,h);)h++}const v=(0,R.format)(c,{offset:m,length:h-m},I);for(let b=v.length-1;b>=0;b--){const P=v[b];c=y(c,P),m=Math.min(m,P.offset),h=Math.max(h,P.offset+P.length),h+=P.content.length-P.length}const _=A.length-(c.length-h)-m;return[{offset:m,length:_,content:c.substring(m,h)}]}e.withFormatting=T;function y(A,i){return A.substring(0,i.offset)+i.content+A.substring(i.offset+i.length)}e.applyEdit=y;function S(A,i){let I=i.slice(0).sort((m,h)=>{const v=m.offset-h.offset;return v===0?m.length-h.length:v}),c=A.length;for(let m=I.length-1;m>=0;m--){let h=I[m];if(h.offset+h.length<=c)A=y(A,h);else throw new Error("Overlapping edit");c=h.offset}return A}e.applyEdits=S}),define(me[139],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new g(()=>k(this.getValue()))}}e.Lazy=g}),define(me[6],ge([0,1,73,75]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let C=null;function T(o){C=o}if(e.setDisposableTracker=T,k){const o="__is_disposable_tracked__";T(new class{trackDisposable(n){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[o]||console.log(a)},3e3)}setParent(n,a){if(n&&n!==P.None)try{n[o]=!0}catch{}}markAsDisposed(n){if(n&&n!==P.None)try{n[o]=!0}catch{}}markAsSingleton(n){}})}function y(o){return C?.trackDisposable(o),o}function S(o){C?.markAsDisposed(o)}function A(o,n){C?.setParent(o,n)}function i(o,n){if(!!C)for(const a of o)C.setParent(a,n)}function I(o){return C?.markAsSingleton(o),o}e.markAsSingleton=I;class c extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=c;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=m;function h(o){if(R.Iterable.is(o)){let n=[];for(const a of o)if(a)try{a.dispose()}catch(d){n.push(d)}if(n.length===1)throw n[0];if(n.length>1)throw new c(n);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=h;function v(...o){const n=_(()=>h(o));return i(o,n),n}e.combinedDisposable=v;function _(o){const n=y({dispose:(0,g.once)(()=>{S(n),o()})});return n}e.toDisposable=_;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return A(n,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new b,y(this),A(this._store,this)}dispose(){S(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&A(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&A(n,null),n}}e.MutableDisposable=l;class f{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class p{constructor(){this.references=new Map}acquire(n,...a){let d=this.references.get(n);d||(d={counter:0,object:this.createReferencedObject(n,...a)},this.references.set(n,d));const{object:u}=d,w=(0,g.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(n,d.object),this.references.delete(n))});return d.counter++,{object:u,dispose:w}}}e.ReferenceCollection=p;class t{constructor(n){this.referenceCollection=n}async acquire(n,...a){const d=this.referenceCollection.acquire(n,...a);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(u){throw d.dispose(),u}}}e.AsyncReferenceCollection=t;class s{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=s}),define(me[94],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(C){this.element=C,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class R{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let C=this._first;for(;C!==g.Undefined;){const T=C.next;C.prev=g.Undefined,C.next=g.Undefined,C=T}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,T){const y=new g(C);if(this._first===g.Undefined)this._first=y,this._last=y;else if(T){const A=this._last;this._last=y,y.prev=A,A.next=y}else{const A=this._first;this._first=y,y.next=A,A.prev=y}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(y))}}shift(){if(this._first!==g.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==g.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==g.Undefined&&C.next!==g.Undefined){const T=C.prev;T.next=C.next,C.next.prev=T}else C.prev===g.Undefined&&C.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):C.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):C.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==g.Undefined;)yield C.element,C=C.next}}e.LinkedList=R}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Te,De){for(var Ie=0;Ie<De.length;Ie++){var ne=De[Ie];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Te,ne.key,ne)}}function e(Te,De,Ie){return De&&Y(Te.prototype,De),Ie&&Y(Te,Ie),Te}function g(Te,De){if(!!Te){if(typeof Te=="string")return R(Te,De);var Ie=Object.prototype.toString.call(Te).slice(8,-1);if(Ie==="Object"&&Te.constructor&&(Ie=Te.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(Te);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return R(Te,De)}}function R(Te,De){(De==null||De>Te.length)&&(De=Te.length);for(var Ie=0,ne=new Array(De);Ie<De;Ie++)ne[Ie]=Te[Ie];return ne}function k(Te,De){var Ie=typeof Symbol!="undefined"&&Te[Symbol.iterator]||Te["@@iterator"];if(Ie)return(Ie=Ie.call(Te)).next.bind(Ie);if(Array.isArray(Te)||(Ie=g(Te))||De&&Te&&typeof Te.length=="number"){Ie&&(Te=Ie);var ne=0;return function(){return ne>=Te.length?{done:!0}:{done:!1,value:Te[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function y(Te){C.exports.defaults=Te}C.exports={defaults:T(),getDefaults:T,changeDefaults:y};var S=/[&<>"']/,A=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(De){return c[De]};function h(Te,De){if(De){if(S.test(Te))return Te.replace(A,m)}else if(i.test(Te))return Te.replace(I,m);return Te}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function _(Te){return Te.replace(v,function(De,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var b=/(^|[^\[])\^/g;function P(Te,De){Te=Te.source||Te,De=De||"";var Ie={replace:function(ue,Ee){return Ee=Ee.source||Ee,Ee=Ee.replace(b,"$1"),Te=Te.replace(ue,Ee),Ie},getRegex:function(){return new RegExp(Te,De)}};return Ie}var l=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Te,De,Ie){if(Te){var ne;try{ne=decodeURIComponent(_(Ie)).replace(l,"").toLowerCase()}catch(ue){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}De&&!f.test(Ie)&&(Ie=a(De,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch(ue){return null}return Ie}var t={},s=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(Te,De){t[" "+Te]||(s.test(Te)?t[" "+Te]=Te+"/":t[" "+Te]=E(Te,"/",!0)),Te=t[" "+Te];var Ie=Te.indexOf(":")===-1;return De.substring(0,2)==="//"?Ie?De:Te.replace(o,"$1")+De:De.charAt(0)==="/"?Ie?De:Te.replace(n,"$1")+De:Te+De}var d={exec:function(){}};function u(Te){for(var De=1,Ie,ne;De<arguments.length;De++){Ie=arguments[De];for(ne in Ie)Object.prototype.hasOwnProperty.call(Ie,ne)&&(Te[ne]=Ie[ne])}return Te}function w(Te,De){var Ie=Te.replace(/\|/g,function(Ee,be,Fe){for(var Ge=!1,$e=be;--$e>=0&&Fe[$e]==="\\";)Ge=!Ge;return Ge?"|":" |"}),ne=Ie.split(/ \|/),ue=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>De)ne.splice(De);else for(;ne.length<De;)ne.push("");for(;ue<ne.length;ue++)ne[ue]=ne[ue].trim().replace(/\\\|/g,"|");return ne}function E(Te,De,Ie){var ne=Te.length;if(ne===0)return"";for(var ue=0;ue<ne;){var Ee=Te.charAt(ne-ue-1);if(Ee===De&&!Ie)ue++;else if(Ee!==De&&Ie)ue++;else break}return Te.substr(0,ne-ue)}function r(Te,De){if(Te.indexOf(De[1])===-1)return-1;for(var Ie=Te.length,ne=0,ue=0;ue<Ie;ue++)if(Te[ue]==="\\")ue++;else if(Te[ue]===De[0])ne++;else if(Te[ue]===De[1]&&(ne--,ne<0))return ue;return-1}function D(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Te,De){if(De<1)return"";for(var Ie="";De>1;)De&1&&(Ie+=Te),De>>=1,Te+=Te;return Ie+Te}var U={escape:h,unescape:_,edit:P,cleanUrl:p,resolveUrl:a,noopTest:d,merge:u,splitCells:w,rtrim:E,findClosingBracket:r,checkSanitizeDeprecation:D,repeatString:L},j=C.exports.defaults,te=U.rtrim,K=U.splitCells,O=U.escape,x=U.findClosingBracket;function F(Te,De,Ie,ne){var ue=De.href,Ee=De.title?O(De.title):null,be=Te[1].replace(/\\([\[\]])/g,"$1");return Te[0].charAt(0)!=="!"?(ne.state.inLink=!0,{type:"link",raw:Ie,href:ue,title:Ee,text:be,tokens:ne.inlineTokens(be,[])}):{type:"image",raw:Ie,href:ue,title:Ee,text:O(be)}}function z(Te,De){var Ie=Te.match(/^(\s+)(?:```)/);if(Ie===null)return De;var ne=Ie[1];return De.split(`
`).map(function(ue){var Ee=ue.match(/^\s+/);if(Ee===null)return ue;var be=Ee[0];return be.length>=ne.length?ue.slice(ne.length):ue}).join(`
`)}var M=function(){function Te(Ie){this.options=Ie||j}var De=Te.prototype;return De.space=function(ne){var ue=this.rules.block.newline.exec(ne);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},De.code=function(ne){var ue=this.rules.block.code.exec(ne);if(ue){var Ee=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?Ee:te(Ee,`
`)}}},De.fences=function(ne){var ue=this.rules.block.fences.exec(ne);if(ue){var Ee=ue[0],be=z(Ee,ue[3]||"");return{type:"code",raw:Ee,lang:ue[2]?ue[2].trim():ue[2],text:be}}},De.heading=function(ne){var ue=this.rules.block.heading.exec(ne);if(ue){var Ee=ue[2].trim();if(/#$/.test(Ee)){var be=te(Ee,"#");(this.options.pedantic||!be||/ $/.test(be))&&(Ee=be.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:Ee,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},De.hr=function(ne){var ue=this.rules.block.hr.exec(ne);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(ne){var ue=this.rules.block.blockquote.exec(ne);if(ue){var Ee=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(Ee,[]),text:Ee}}},De.list=function(ne){var ue=this.rules.block.list.exec(ne);if(ue){var Ee,be,Fe,Ge,$e,Ze,pe,de,ce,q,_e=ue[1].trim(),Le=_e.length>1,Qe={type:"list",raw:"",ordered:Le,start:Le?+_e.slice(0,-1):"",loose:!1,items:[]};_e=Le?"\\d{1,9}\\"+_e.slice(-1):"\\"+_e,this.options.pedantic&&(_e=Le?_e:"[*+-]");for(var qe=new RegExp("^( {0,3}"+_e+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(ue=qe.exec(ne)));){ce=ue[2].split(`
`),this.options.pedantic?(Ge=2,q=ce[0].trimLeft()):(Ge=ue[2].search(/[^ ]/),Ge=ue[1].length+(Ge>4?1:Ge),q=ce[0].slice(Ge-ue[1].length)),Ze=!1,Ee=ue[0],!ce[0]&&/^ *$/.test(ce[1])&&(Ee=ue[1]+ce.slice(0,2).join(`
`)+`
`,Qe.loose=!0,ce=[]);var ft=new RegExp("^ {0,"+Math.min(3,Ge-1)+"}(?:[*+-]|\\d{1,9}[.)])");for($e=1;$e<ce.length;$e++){if(de=ce[$e],this.options.pedantic&&(de=de.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),ft.test(de)){Ee=ue[1]+ce.slice(0,$e).join(`
`)+`
`;break}if(!Ze){de.trim()||(Ze=!0),de.search(/[^ ]/)>=Ge?q+=`
`+de.slice(Ge):q+=`
`+de;continue}if(de.search(/[^ ]/)>=Ge||!de.trim()){q+=`
`+de.slice(Ge);continue}else{Ee=ue[1]+ce.slice(0,$e).join(`
`)+`
`;break}}Qe.loose||(pe?Qe.loose=!0:/\n *\n *$/.test(Ee)&&(pe=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(q),be&&(Fe=be[0]!=="[ ] ",q=q.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:Ee,task:!!be,checked:Fe,loose:!1,text:q}),Qe.raw+=Ee,ne=ne.slice(Ee.length)}Qe.items[Qe.items.length-1].raw=Ee.trimRight(),Qe.items[Qe.items.length-1].text=q.trimRight(),Qe.raw=Qe.raw.trimRight();var ht=Qe.items.length;for($e=0;$e<ht;$e++)this.lexer.state.top=!1,Qe.items[$e].tokens=this.lexer.blockTokens(Qe.items[$e].text,[]),Qe.items[$e].tokens.some(function(yt){return yt.type==="space"})&&(Qe.loose=!0,Qe.items[$e].loose=!0);return Qe}},De.html=function(ne){var ue=this.rules.block.html.exec(ne);if(ue){var Ee={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(Ee.type="paragraph",Ee.text=this.options.sanitizer?this.options.sanitizer(ue[0]):O(ue[0]),Ee.tokens=[],this.lexer.inline(Ee.text,Ee.tokens)),Ee}},De.def=function(ne){var ue=this.rules.block.def.exec(ne);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var Ee=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Ee,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(ne){var ue=this.rules.block.table.exec(ne);if(ue){var Ee={type:"table",header:K(ue[1]).map(function(pe){return{text:pe}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(Ee.header.length===Ee.align.length){Ee.raw=ue[0];var be=Ee.align.length,Fe,Ge,$e,Ze;for(Fe=0;Fe<be;Fe++)/^ *-+: *$/.test(Ee.align[Fe])?Ee.align[Fe]="right":/^ *:-+: *$/.test(Ee.align[Fe])?Ee.align[Fe]="center":/^ *:-+ *$/.test(Ee.align[Fe])?Ee.align[Fe]="left":Ee.align[Fe]=null;for(be=Ee.rows.length,Fe=0;Fe<be;Fe++)Ee.rows[Fe]=K(Ee.rows[Fe],Ee.header.length).map(function(pe){return{text:pe}});for(be=Ee.header.length,Ge=0;Ge<be;Ge++)Ee.header[Ge].tokens=[],this.lexer.inlineTokens(Ee.header[Ge].text,Ee.header[Ge].tokens);for(be=Ee.rows.length,Ge=0;Ge<be;Ge++)for(Ze=Ee.rows[Ge],$e=0;$e<Ze.length;$e++)Ze[$e].tokens=[],this.lexer.inlineTokens(Ze[$e].text,Ze[$e].tokens);return Ee}}},De.lheading=function(ne){var ue=this.rules.block.lheading.exec(ne);if(ue){var Ee={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},De.paragraph=function(ne){var ue=this.rules.block.paragraph.exec(ne);if(ue){var Ee={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},De.text=function(ne){var ue=this.rules.block.text.exec(ne);if(ue){var Ee={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},De.escape=function(ne){var ue=this.rules.inline.escape.exec(ne);if(ue)return{type:"escape",raw:ue[0],text:O(ue[1])}},De.tag=function(ne){var ue=this.rules.inline.tag.exec(ne);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):O(ue[0]):ue[0]}},De.link=function(ne){var ue=this.rules.inline.link.exec(ne);if(ue){var Ee=ue[2].trim();if(!this.options.pedantic&&/^</.test(Ee)){if(!/>$/.test(Ee))return;var be=te(Ee.slice(0,-1),"\\");if((Ee.length-be.length)%2==0)return}else{var Fe=x(ue[2],"()");if(Fe>-1){var Ge=ue[0].indexOf("!")===0?5:4,$e=Ge+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,$e).trim(),ue[3]=""}}var Ze=ue[2],pe="";if(this.options.pedantic){var de=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ze);de&&(Ze=de[1],pe=de[3])}else pe=ue[3]?ue[3].slice(1,-1):"";return Ze=Ze.trim(),/^</.test(Ze)&&(this.options.pedantic&&!/>$/.test(Ee)?Ze=Ze.slice(1):Ze=Ze.slice(1,-1)),F(ue,{href:Ze&&Ze.replace(this.rules.inline._escapes,"$1"),title:pe&&pe.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},De.reflink=function(ne,ue){var Ee;if((Ee=this.rules.inline.reflink.exec(ne))||(Ee=this.rules.inline.nolink.exec(ne))){var be=(Ee[2]||Ee[1]).replace(/\s+/g," ");if(be=ue[be.toLowerCase()],!be||!be.href){var Fe=Ee[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return F(Ee,be,Ee[0],this.lexer)}},De.emStrong=function(ne,ue,Ee){Ee===void 0&&(Ee="");var be=this.rules.inline.emStrong.lDelim.exec(ne);if(!!be&&!(be[3]&&Ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=be[1]||be[2]||"";if(!Fe||Fe&&(Ee===""||this.rules.inline.punctuation.exec(Ee))){var Ge=be[0].length-1,$e,Ze,pe=Ge,de=0,ce=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,ue=ue.slice(-1*ne.length+Ge);(be=ce.exec(ue))!=null;)if($e=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!$e){if(Ze=$e.length,be[3]||be[4]){pe+=Ze;continue}else if((be[5]||be[6])&&Ge%3&&!((Ge+Ze)%3)){de+=Ze;continue}if(pe-=Ze,!(pe>0)){if(Ze=Math.min(Ze,Ze+pe+de),Math.min(Ge,Ze)%2){var q=ne.slice(1,Ge+be.index+Ze);return{type:"em",raw:ne.slice(0,Ge+be.index+Ze+1),text:q,tokens:this.lexer.inlineTokens(q,[])}}var _e=ne.slice(2,Ge+be.index+Ze-1);return{type:"strong",raw:ne.slice(0,Ge+be.index+Ze+1),text:_e,tokens:this.lexer.inlineTokens(_e,[])}}}}}},De.codespan=function(ne){var ue=this.rules.inline.code.exec(ne);if(ue){var Ee=ue[2].replace(/\n/g," "),be=/[^ ]/.test(Ee),Fe=/^ /.test(Ee)&&/ $/.test(Ee);return be&&Fe&&(Ee=Ee.substring(1,Ee.length-1)),Ee=O(Ee,!0),{type:"codespan",raw:ue[0],text:Ee}}},De.br=function(ne){var ue=this.rules.inline.br.exec(ne);if(ue)return{type:"br",raw:ue[0]}},De.del=function(ne){var ue=this.rules.inline.del.exec(ne);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},De.autolink=function(ne,ue){var Ee=this.rules.inline.autolink.exec(ne);if(Ee){var be,Fe;return Ee[2]==="@"?(be=O(this.options.mangle?ue(Ee[1]):Ee[1]),Fe="mailto:"+be):(be=O(Ee[1]),Fe=be),{type:"link",raw:Ee[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},De.url=function(ne,ue){var Ee;if(Ee=this.rules.inline.url.exec(ne)){var be,Fe;if(Ee[2]==="@")be=O(this.options.mangle?ue(Ee[0]):Ee[0]),Fe="mailto:"+be;else{var Ge;do Ge=Ee[0],Ee[0]=this.rules.inline._backpedal.exec(Ee[0])[0];while(Ge!==Ee[0]);be=O(Ee[0]),Ee[1]==="www."?Fe="http://"+be:Fe=be}return{type:"link",raw:Ee[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},De.inlineText=function(ne,ue){var Ee=this.rules.inline.text.exec(ne);if(Ee){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Ee[0]):O(Ee[0]):Ee[0]:be=O(this.options.smartypants?ue(Ee[0]):Ee[0]),{type:"text",raw:Ee[0],text:be}}},Te}(),N=U.noopTest,V=U.edit,$=U.merge,G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=V(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=V(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=V(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=V(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=V(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=V(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=$({},G),G.gfm=$({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=V(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=$({},G.normal,{html:V(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:V(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var J={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};J._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",J.punctuation=V(J.punctuation).replace(/punctuation/g,J._punctuation).getRegex(),J.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,J.escapedEmSt=/\\\*|\\_/g,J._comment=V(G._comment).replace("(?:-->|$)","-->").getRegex(),J.emStrong.lDelim=V(J.emStrong.lDelim).replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimAst=V(J.emStrong.rDelimAst,"g").replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimUnd=V(J.emStrong.rDelimUnd,"g").replace(/punct/g,J._punctuation).getRegex(),J._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,J._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,J._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,J.autolink=V(J.autolink).replace("scheme",J._scheme).replace("email",J._email).getRegex(),J._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,J.tag=V(J.tag).replace("comment",J._comment).replace("attribute",J._attribute).getRegex(),J._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,J._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,J._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,J.link=V(J.link).replace("label",J._label).replace("href",J._href).replace("title",J._title).getRegex(),J.reflink=V(J.reflink).replace("label",J._label).getRegex(),J.reflinkSearch=V(J.reflinkSearch,"g").replace("reflink",J.reflink).replace("nolink",J.nolink).getRegex(),J.normal=$({},J),J.pedantic=$({},J.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:V(/^!?\[(label)\]\((.*?)\)/).replace("label",J._label).getRegex(),reflink:V(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",J._label).getRegex()}),J.gfm=$({},J.normal,{escape:V(J.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),J.gfm.url=V(J.gfm.url,"i").replace("email",J.gfm._extended_email).getRegex(),J.breaks=$({},J.gfm,{br:V(J.br).replace("{2,}","*").getRegex(),text:V(J.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:G,inline:J},ye=M,ke=C.exports.defaults,Re=fe.block,Ve=fe.inline,Be=U.repeatString;function Ke(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Te){var De="",Ie,ne,ue=Te.length;for(Ie=0;Ie<ue;Ie++)ne=Te.charCodeAt(Ie),Math.random()>.5&&(ne="x"+ne.toString(16)),De+="&#"+ne+";";return De}var Z=function(){function Te(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||ke,this.options.tokenizer=this.options.tokenizer||new ye,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Re.normal,inline:Ve.normal};this.options.pedantic?(ne.block=Re.pedantic,ne.inline=Ve.pedantic):this.options.gfm&&(ne.block=Re.gfm,this.options.breaks?ne.inline=Ve.breaks:ne.inline=Ve.gfm),this.tokenizer.rules=ne}Te.lex=function(ne,ue){var Ee=new Te(ue);return Ee.lex(ne)},Te.lexInline=function(ne,ue){var Ee=new Te(ue);return Ee.inlineTokens(ne)};var De=Te.prototype;return De.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},De.blockTokens=function(ne,ue){var Ee=this;ue===void 0&&(ue=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var be,Fe,Ge,$e;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(pe){return(be=pe.call({lexer:Ee},ne,ue))?(ne=ne.substring(be.raw.length),ue.push(be),!0):!1}))){if(be=this.tokenizer.space(ne)){ne=ne.substring(be.raw.length),be.type&&ue.push(be);continue}if(be=this.tokenizer.code(ne)){ne=ne.substring(be.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(be);continue}if(be=this.tokenizer.fences(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.heading(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.hr(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.blockquote(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.list(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.html(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.def(ne)){ne=ne.substring(be.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.lheading(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var pe=Infinity,de=ne.slice(1),ce=void 0;Ee.options.extensions.startBlock.forEach(function(q){ce=q.call({lexer:this},de),typeof ce=="number"&&ce>=0&&(pe=Math.min(pe,ce))}),pe<Infinity&&pe>=0&&(Ge=ne.substring(0,pe+1))}(),this.state.top&&(be=this.tokenizer.paragraph(Ge))){Fe=ue[ue.length-1],$e&&Fe.type==="paragraph"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(be),$e=Ge.length!==ne.length,ne=ne.substring(be.raw.length);continue}if(be=this.tokenizer.text(ne)){ne=ne.substring(be.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(be);continue}if(ne){var Ze="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Ze);break}else throw new Error(Ze)}}return this.state.top=!0,ue},De.inline=function(ne,ue){this.inlineQueue.push({src:ne,tokens:ue})},De.inlineTokens=function(ne,ue){var Ee=this;ue===void 0&&(ue=[]);var be,Fe,Ge,$e=ne,Ze,pe,de;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(Ze=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)ce.includes(Ze[0].slice(Ze[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Ze.index)+"["+Be("a",Ze[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ze=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Ze.index)+"["+Be("a",Ze[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ze=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Ze.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(pe||(de=""),pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_e){return(be=_e.call({lexer:Ee},ne,ue))?(ne=ne.substring(be.raw.length),ue.push(be),!0):!1}))){if(be=this.tokenizer.escape(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.tag(ne)){ne=ne.substring(be.raw.length),Fe=ue[ue.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ue.push(be);continue}if(be=this.tokenizer.link(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(be.raw.length),Fe=ue[ue.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ue.push(be);continue}if(be=this.tokenizer.emStrong(ne,$e,de)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.codespan(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.br(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.del(ne)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.autolink(ne,W)){ne=ne.substring(be.raw.length),ue.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(ne,W))){ne=ne.substring(be.raw.length),ue.push(be);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var _e=Infinity,Le=ne.slice(1),Qe=void 0;Ee.options.extensions.startInline.forEach(function(qe){Qe=qe.call({lexer:this},Le),typeof Qe=="number"&&Qe>=0&&(_e=Math.min(_e,Qe))}),_e<Infinity&&_e>=0&&(Ge=ne.substring(0,_e+1))}(),be=this.tokenizer.inlineText(Ge,Ke)){ne=ne.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(de=be.raw.slice(-1)),pe=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ue.push(be);continue}if(ne){var q="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return ue},e(Te,null,[{key:"rules",get:function(){return{block:Re,inline:Ve}}}]),Te}(),re=C.exports.defaults,ae=U.cleanUrl,Q=U.escape,oe=function(){function Te(Ie){this.options=Ie||re}var De=Te.prototype;return De.code=function(ne,ue,Ee){var be=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ne,be);Fe!=null&&Fe!==ne&&(Ee=!0,ne=Fe)}return ne=ne.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+Q(be,!0)+'">'+(Ee?ne:Q(ne,!0))+`</code></pre>
`:"<pre><code>"+(Ee?ne:Q(ne,!0))+`</code></pre>
`},De.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},De.html=function(ne){return ne},De.heading=function(ne,ue,Ee,be){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+be.slug(Ee)+'">'+ne+"</h"+ue+`>
`:"<h"+ue+">"+ne+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ne,ue,Ee){var be=ue?"ol":"ul",Fe=ue&&Ee!==1?' start="'+Ee+'"':"";return"<"+be+Fe+`>
`+ne+"</"+be+`>
`},De.listitem=function(ne){return"<li>"+ne+`</li>
`},De.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ne){return"<p>"+ne+`</p>
`},De.table=function(ne,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+ue+`</table>
`},De.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},De.tablecell=function(ne,ue){var Ee=ue.header?"th":"td",be=ue.align?"<"+Ee+' align="'+ue.align+'">':"<"+Ee+">";return be+ne+"</"+Ee+`>
`},De.strong=function(ne){return"<strong>"+ne+"</strong>"},De.em=function(ne){return"<em>"+ne+"</em>"},De.codespan=function(ne){return"<code>"+ne+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ne){return"<del>"+ne+"</del>"},De.link=function(ne,ue,Ee){if(ne=ae(this.options.sanitize,this.options.baseUrl,ne),ne===null)return Ee;var be='<a href="'+Q(ne)+'"';return ue&&(be+=' title="'+ue+'"'),be+=">"+Ee+"</a>",be},De.image=function(ne,ue,Ee){if(ne=ae(this.options.sanitize,this.options.baseUrl,ne),ne===null)return Ee;var be='<img src="'+ne+'" alt="'+Ee+'"';return ue&&(be+=' title="'+ue+'"'),be+=this.options.xhtml?"/>":">",be},De.text=function(ne){return ne},Te}(),we=function(){function Te(){}var De=Te.prototype;return De.strong=function(ne){return ne},De.em=function(ne){return ne},De.codespan=function(ne){return ne},De.del=function(ne){return ne},De.html=function(ne){return ne},De.text=function(ne){return ne},De.link=function(ne,ue,Ee){return""+Ee},De.image=function(ne,ue,Ee){return""+Ee},De.br=function(){return""},Te}(),Me=function(){function Te(){this.seen={}}var De=Te.prototype;return De.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ne,ue){var Ee=ne,be=0;if(this.seen.hasOwnProperty(Ee)){be=this.seen[ne];do be++,Ee=ne+"-"+be;while(this.seen.hasOwnProperty(Ee))}return ue||(this.seen[ne]=be,this.seen[Ee]=0),Ee},De.slug=function(ne,ue){ue===void 0&&(ue={});var Ee=this.serialize(ne);return this.getNextSafeSlug(Ee,ue.dryrun)},Te}(),je=oe,Xe=we,Se=Me,tt=C.exports.defaults,X=U.unescape,ee=function(){function Te(Ie){this.options=Ie||tt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Xe,this.slugger=new Se}Te.parse=function(ne,ue){var Ee=new Te(ue);return Ee.parse(ne)},Te.parseInline=function(ne,ue){var Ee=new Te(ue);return Ee.parseInline(ne)};var De=Te.prototype;return De.parse=function(ne,ue){ue===void 0&&(ue=!0);var Ee="",be,Fe,Ge,$e,Ze,pe,de,ce,q,_e,Le,Qe,qe,ft,ht,yt,gt,ct,ut,vt=ne.length;for(be=0;be<vt;be++){if(_e=ne[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_e.type]&&(ut=this.options.extensions.renderers[_e.type].call({parser:this},_e),ut!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_e.type))){Ee+=ut||"";continue}switch(_e.type){case"space":continue;case"hr":{Ee+=this.renderer.hr();continue}case"heading":{Ee+=this.renderer.heading(this.parseInline(_e.tokens),_e.depth,X(this.parseInline(_e.tokens,this.textRenderer)),this.slugger);continue}case"code":{Ee+=this.renderer.code(_e.text,_e.lang,_e.escaped);continue}case"table":{for(ce="",de="",$e=_e.header.length,Fe=0;Fe<$e;Fe++)de+=this.renderer.tablecell(this.parseInline(_e.header[Fe].tokens),{header:!0,align:_e.align[Fe]});for(ce+=this.renderer.tablerow(de),q="",$e=_e.rows.length,Fe=0;Fe<$e;Fe++){for(pe=_e.rows[Fe],de="",Ze=pe.length,Ge=0;Ge<Ze;Ge++)de+=this.renderer.tablecell(this.parseInline(pe[Ge].tokens),{header:!1,align:_e.align[Ge]});q+=this.renderer.tablerow(de)}Ee+=this.renderer.table(ce,q);continue}case"blockquote":{q=this.parse(_e.tokens),Ee+=this.renderer.blockquote(q);continue}case"list":{for(Le=_e.ordered,Qe=_e.start,qe=_e.loose,$e=_e.items.length,q="",Fe=0;Fe<$e;Fe++)ht=_e.items[Fe],yt=ht.checked,gt=ht.task,ft="",ht.task&&(ct=this.renderer.checkbox(yt),qe?ht.tokens.length>0&&ht.tokens[0].type==="paragraph"?(ht.tokens[0].text=ct+" "+ht.tokens[0].text,ht.tokens[0].tokens&&ht.tokens[0].tokens.length>0&&ht.tokens[0].tokens[0].type==="text"&&(ht.tokens[0].tokens[0].text=ct+" "+ht.tokens[0].tokens[0].text)):ht.tokens.unshift({type:"text",text:ct}):ft+=ct),ft+=this.parse(ht.tokens,qe),q+=this.renderer.listitem(ft,gt,yt);Ee+=this.renderer.list(q,Le,Qe);continue}case"html":{Ee+=this.renderer.html(_e.text);continue}case"paragraph":{Ee+=this.renderer.paragraph(this.parseInline(_e.tokens));continue}case"text":{for(q=_e.tokens?this.parseInline(_e.tokens):_e.text;be+1<vt&&ne[be+1].type==="text";)_e=ne[++be],q+=`
`+(_e.tokens?this.parseInline(_e.tokens):_e.text);Ee+=ue?this.renderer.paragraph(q):q;continue}default:{var It='Token with "'+_e.type+'" type was not found.';if(this.options.silent){console.error(It);return}else throw new Error(It)}}}return Ee},De.parseInline=function(ne,ue){ue=ue||this.renderer;var Ee="",be,Fe,Ge,$e=ne.length;for(be=0;be<$e;be++){if(Fe=ne[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ge=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){Ee+=Ge||"";continue}switch(Fe.type){case"escape":{Ee+=ue.text(Fe.text);break}case"html":{Ee+=ue.html(Fe.text);break}case"link":{Ee+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{Ee+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{Ee+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{Ee+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{Ee+=ue.codespan(Fe.text);break}case"br":{Ee+=ue.br();break}case"del":{Ee+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{Ee+=ue.text(Fe.text);break}default:{var Ze='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return Ee},Te}(),ve=Z,Ue=ee,Je=M,nt=oe,at=we,pt=Me,_t=U.merge,St=U.checkSanitizeDeprecation,le=U.escape,Pe=C.exports.getDefaults,Ne=C.exports.changeDefaults,Ye=C.exports.defaults;function We(Te,De,Ie){if(typeof Te=="undefined"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof De=="function"&&(Ie=De,De=null),De=_t({},We.defaults,De||{}),St(De),Ie){var ne=De.highlight,ue;try{ue=ve.lex(Te,De)}catch(Ge){return Ie(Ge)}var Ee=function($e){var Ze;if(!$e)try{De.walkTokens&&We.walkTokens(ue,De.walkTokens),Ze=Ue.parse(ue,De)}catch(pe){$e=pe}return De.highlight=ne,$e?Ie($e):Ie(null,Ze)};if(!ne||ne.length<3||(delete De.highlight,!ue.length))return Ee();var be=0;We.walkTokens(ue,function(Ge){Ge.type==="code"&&(be++,setTimeout(function(){ne(Ge.text,Ge.lang,function($e,Ze){if($e)return Ee($e);Ze!=null&&Ze!==Ge.text&&(Ge.text=Ze,Ge.escaped=!0),be--,be===0&&Ee()})},0))}),be===0&&Ee();return}try{var Fe=ve.lex(Te,De);return De.walkTokens&&We.walkTokens(Fe,De.walkTokens),Ue.parse(Fe,De)}catch(Ge){if(Ge.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+le(Ge.message+"",!0)+"</pre>";throw Ge}}We.options=We.setOptions=function(Te){return _t(We.defaults,Te),Ne(We.defaults),We},We.getDefaults=Pe,We.defaults=Ye,We.use=function(){for(var Te=this,De=arguments.length,Ie=new Array(De),ne=0;ne<De;ne++)Ie[ne]=arguments[ne];var ue=_t.apply(void 0,[{}].concat(Ie)),Ee=We.defaults.extensions||{renderers:{},childTokens:{}},be;Ie.forEach(function(Fe){if(Fe.extensions&&(be=!0,Fe.extensions.forEach(function($e){if(!$e.name)throw new Error("extension name required");if($e.renderer){var Ze=Ee.renderers?Ee.renderers[$e.name]:null;Ze?Ee.renderers[$e.name]=function(){for(var pe=arguments.length,de=new Array(pe),ce=0;ce<pe;ce++)de[ce]=arguments[ce];var q=$e.renderer.apply(this,de);return q===!1&&(q=Ze.apply(this,de)),q}:Ee.renderers[$e.name]=$e.renderer}if($e.tokenizer){if(!$e.level||$e.level!=="block"&&$e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Ee[$e.level]?Ee[$e.level].unshift($e.tokenizer):Ee[$e.level]=[$e.tokenizer],$e.start&&($e.level==="block"?Ee.startBlock?Ee.startBlock.push($e.start):Ee.startBlock=[$e.start]:$e.level==="inline"&&(Ee.startInline?Ee.startInline.push($e.start):Ee.startInline=[$e.start]))}$e.childTokens&&(Ee.childTokens[$e.name]=$e.childTokens)})),Fe.renderer&&function(){var $e=We.defaults.renderer||new nt,Ze=function(ce){var q=$e[ce];$e[ce]=function(){for(var _e=arguments.length,Le=new Array(_e),Qe=0;Qe<_e;Qe++)Le[Qe]=arguments[Qe];var qe=Fe.renderer[ce].apply($e,Le);return qe===!1&&(qe=q.apply($e,Le)),qe}};for(var pe in Fe.renderer)Ze(pe);ue.renderer=$e}(),Fe.tokenizer&&function(){var $e=We.defaults.tokenizer||new Je,Ze=function(ce){var q=$e[ce];$e[ce]=function(){for(var _e=arguments.length,Le=new Array(_e),Qe=0;Qe<_e;Qe++)Le[Qe]=arguments[Qe];var qe=Fe.tokenizer[ce].apply($e,Le);return qe===!1&&(qe=q.apply($e,Le)),qe}};for(var pe in Fe.tokenizer)Ze(pe);ue.tokenizer=$e}(),Fe.walkTokens){var Ge=We.defaults.walkTokens;ue.walkTokens=function($e){Fe.walkTokens.call(Te,$e),Ge&&Ge($e)}}be&&(ue.extensions=Ee),We.setOptions(ue)})},We.walkTokens=function(Te,De){for(var Ie=function(){var be=ue.value;switch(De(be),be.type){case"table":{for(var Fe=k(be.header),Ge;!(Ge=Fe()).done;){var $e=Ge.value;We.walkTokens($e.tokens,De)}for(var Ze=k(be.rows),pe;!(pe=Ze()).done;)for(var de=pe.value,ce=k(de),q;!(q=ce()).done;){var _e=q.value;We.walkTokens(_e.tokens,De)}break}case"list":{We.walkTokens(be.items,De);break}default:We.defaults.extensions&&We.defaults.extensions.childTokens&&We.defaults.extensions.childTokens[be.type]?We.defaults.extensions.childTokens[be.type].forEach(function(Le){We.walkTokens(be[Le],De)}):be.tokens&&We.walkTokens(be.tokens,De)}},ne=k(Te),ue;!(ue=ne()).done;)Ie()},We.parseInline=function(Te,De){if(typeof Te=="undefined"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");De=_t({},We.defaults,De||{}),St(De);try{var Ie=ve.lexInline(Te,De);return De.walkTokens&&We.walkTokens(Ie,De.walkTokens),Ue.parseInline(Ie,De)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+le(ne.message+"",!0)+"</pre>";throw ne}},We.Parser=Ue,We.parser=Ue.parse,We.Renderer=nt,We.TextRenderer=at,We.Lexer=ve,We.lexer=ve.lex,We.Tokenizer=Je,We.Slugger=pt,We.parse=We;var st=We;return st}),define(me[76],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(T,y,S){return Math.min(Math.max(T,y),S)}e.clamp=g;function R(T,y){return(y+T%y)%y}e.rot=R;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class C{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Y(k){const C=[];typeof k=="number"&&C.push("code/timeOrigin",k);function T(S){C.push(S,Date.now())}function y(){const S=[];for(let A=0;A<C.length;A+=2)S.push({name:C[A],startTime:C[A+1]});return S}return{mark:T,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))C.push({name:T.name,startTime:Math.round(k+T.startTime)});return C}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function g(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=g(R))}(),define(me[11],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let R=!1,k=!1,C=!1,T=!1,y=!1,S=!1,A=!1,i,I=g,c,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const v=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=v&&h?.sandboxed,typeof navigator=="object"&&!v)m=navigator.userAgent,R=m.indexOf("Windows")>=0,k=m.indexOf("Macintosh")>=0,A=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=m.indexOf("Linux")>=0,S=!0,i=navigator.language,I=i;else if(typeof h=="object"){R=h.platform==="win32",k=h.platform==="darwin",C=h.platform==="linux",T=C&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,i=g,I=g;const o=h.env.VSCODE_NLS_CONFIG;if(o)try{const n=JSON.parse(o),a=n.availableLanguages["*"];i=n.locale,I=a||g,c=n._translationsConfigFile}catch(n){}y=!0}else console.error("Unable to resolve platform.");var _;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function b(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let P=0;k?P=1:R?P=3:C&&(P=2),e.isWindows=R,e.isMacintosh=k,e.isLinux=C,e.isLinuxSnap=T,e.isNative=y,e.isWeb=S,e.isIOS=A,e.platform=P,e.userAgent=m,e.language=I;var l;(function(o){function n(){return e.language}o.value=n;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=a;function d(){return e.language==="en"}o.isDefault=d})(l=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=c,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let w=0,E=a.length;w<E;w++){const r=a[w];if(r.id===u.data.vscodeSetImmediateId){a.splice(w,1),r.callback();return}}});let d=0;return u=>{const w=++d;a.push({id:w,callback:u}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const n=Promise.resolve();return a=>n.then(a)}();var f;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||A?2:R?1:3;let p=!0,t=!1;function s(){if(!t){t=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,p=new Uint16Array(o.buffer)[0]===(2<<8)+1}return p}e.isLittleEndian=s}),define(me[38],ge([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const k=g.globals.vscode.process;R={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(C){return(0,g.setImmediate)(C)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:R={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(k){return(0,g.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(me[8],ge([0,1,38]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,k=97,C=90,T=122,y=46,S=47,A=92,i=58,I=63;class c extends Error{constructor(f,p,t){let s;typeof p=="string"&&p.indexOf("not ")===0?(s="must not be",p=p.replace(/^not /,"")):s="must be";const o=f.indexOf(".")!==-1?"property":"argument";let n=`The "${f}" ${o} ${s} of type ${p}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function m(l,f){if(typeof l!="string")throw new c(f,"string",l)}function h(l){return l===S||l===A}function v(l){return l===S}function _(l){return l>=R&&l<=C||l>=k&&l<=T}function b(l,f,p,t){let s="",o=0,n=-1,a=0,d=0;for(let u=0;u<=l.length;++u){if(u<l.length)d=l.charCodeAt(u);else{if(t(d))break;d=S}if(t(d)){if(!(n===u-1||a===1))if(a===2){if(s.length<2||o!==2||s.charCodeAt(s.length-1)!==y||s.charCodeAt(s.length-2)!==y){if(s.length>2){const w=s.lastIndexOf(p);w===-1?(s="",o=0):(s=s.slice(0,w),o=s.length-1-s.lastIndexOf(p)),n=u,a=0;continue}else if(s.length!==0){s="",o=0,n=u,a=0;continue}}f&&(s+=s.length>0?`${p}..`:"..",o=2)}else s.length>0?s+=`${p}${l.slice(n+1,u)}`:s=l.slice(n+1,u),o=u-n-1;n=u,a=0}else d===y&&a!==-1?++a:a=-1}return s}function P(l,f){if(f===null||typeof f!="object")throw new c("pathObject","Object",f);const p=f.dir||f.root,t=f.base||`${f.name||""}${f.ext||""}`;return p?p===f.root?`${p}${t}`:`${p}${l}${t}`:t}e.win32={resolve(...l){let f="",p="",t=!1;for(let s=l.length-1;s>=-1;s--){let o;if(s>=0){if(o=l[s],m(o,"path"),o.length===0)continue}else f.length===0?o=g.cwd():(o=g.env[`=${f}`]||g.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==f.toLowerCase()&&o.charCodeAt(2)===A)&&(o=`${f}\\`));const n=o.length;let a=0,d="",u=!1;const w=o.charCodeAt(0);if(n===1)h(w)&&(a=1,u=!0);else if(h(w))if(u=!0,h(o.charCodeAt(1))){let E=2,r=E;for(;E<n&&!h(o.charCodeAt(E));)E++;if(E<n&&E!==r){const D=o.slice(r,E);for(r=E;E<n&&h(o.charCodeAt(E));)E++;if(E<n&&E!==r){for(r=E;E<n&&!h(o.charCodeAt(E));)E++;(E===n||E!==r)&&(d=`\\\\${D}\\${o.slice(r,E)}`,a=E)}}}else a=1;else _(w)&&o.charCodeAt(1)===i&&(d=o.slice(0,2),a=2,n>2&&h(o.charCodeAt(2))&&(u=!0,a=3));if(d.length>0)if(f.length>0){if(d.toLowerCase()!==f.toLowerCase())continue}else f=d;if(t){if(f.length>0)break}else if(p=`${o.slice(a)}\\${p}`,t=u,u&&f.length>0)break}return p=b(p,!t,"\\",h),t?`${f}\\${p}`:`${f}${p}`||"."},normalize(l){m(l,"path");const f=l.length;if(f===0)return".";let p=0,t,s=!1;const o=l.charCodeAt(0);if(f===1)return v(o)?"\\":l;if(h(o))if(s=!0,h(l.charCodeAt(1))){let a=2,d=a;for(;a<f&&!h(l.charCodeAt(a));)a++;if(a<f&&a!==d){const u=l.slice(d,a);for(d=a;a<f&&h(l.charCodeAt(a));)a++;if(a<f&&a!==d){for(d=a;a<f&&!h(l.charCodeAt(a));)a++;if(a===f)return`\\\\${u}\\${l.slice(d)}\\`;a!==d&&(t=`\\\\${u}\\${l.slice(d,a)}`,p=a)}}}else p=1;else _(o)&&l.charCodeAt(1)===i&&(t=l.slice(0,2),p=2,f>2&&h(l.charCodeAt(2))&&(s=!0,p=3));let n=p<f?b(l.slice(p),!s,"\\",h):"";return n.length===0&&!s&&(n="."),n.length>0&&h(l.charCodeAt(f-1))&&(n+="\\"),t===void 0?s?`\\${n}`:n:s?`${t}\\${n}`:`${t}${n}`},isAbsolute(l){m(l,"path");const f=l.length;if(f===0)return!1;const p=l.charCodeAt(0);return h(p)||f>2&&_(p)&&l.charCodeAt(1)===i&&h(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let f,p;for(let o=0;o<l.length;++o){const n=l[o];m(n,"path"),n.length>0&&(f===void 0?f=p=n:f+=`\\${n}`)}if(f===void 0)return".";let t=!0,s=0;if(typeof p=="string"&&h(p.charCodeAt(0))){++s;const o=p.length;o>1&&h(p.charCodeAt(1))&&(++s,o>2&&(h(p.charCodeAt(2))?++s:t=!1))}if(t){for(;s<f.length&&h(f.charCodeAt(s));)s++;s>=2&&(f=`\\${f.slice(s)}`)}return e.win32.normalize(f)},relative(l,f){if(m(l,"from"),m(f,"to"),l===f)return"";const p=e.win32.resolve(l),t=e.win32.resolve(f);if(p===t||(l=p.toLowerCase(),f=t.toLowerCase(),l===f))return"";let s=0;for(;s<l.length&&l.charCodeAt(s)===A;)s++;let o=l.length;for(;o-1>s&&l.charCodeAt(o-1)===A;)o--;const n=o-s;let a=0;for(;a<f.length&&f.charCodeAt(a)===A;)a++;let d=f.length;for(;d-1>a&&f.charCodeAt(d-1)===A;)d--;const u=d-a,w=n<u?n:u;let E=-1,r=0;for(;r<w;r++){const L=l.charCodeAt(s+r);if(L!==f.charCodeAt(a+r))break;L===A&&(E=r)}if(r!==w){if(E===-1)return t}else{if(u>w){if(f.charCodeAt(a+r)===A)return t.slice(a+r+1);if(r===2)return t.slice(a+r)}n>w&&(l.charCodeAt(s+r)===A?E=r:r===2&&(E=3)),E===-1&&(E=0)}let D="";for(r=s+E+1;r<=o;++r)(r===o||l.charCodeAt(r)===A)&&(D+=D.length===0?"..":"\\..");return a+=E,D.length>0?`${D}${t.slice(a,d)}`:(t.charCodeAt(a)===A&&++a,t.slice(a,d))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const f=e.win32.resolve(l);if(f.length<=2)return l;if(f.charCodeAt(0)===A){if(f.charCodeAt(1)===A){const p=f.charCodeAt(2);if(p!==I&&p!==y)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(_(f.charCodeAt(0))&&f.charCodeAt(1)===i&&f.charCodeAt(2)===A)return`\\\\?\\${f}`;return l},dirname(l){m(l,"path");const f=l.length;if(f===0)return".";let p=-1,t=0;const s=l.charCodeAt(0);if(f===1)return h(s)?l:".";if(h(s)){if(p=t=1,h(l.charCodeAt(1))){let a=2,d=a;for(;a<f&&!h(l.charCodeAt(a));)a++;if(a<f&&a!==d){for(d=a;a<f&&h(l.charCodeAt(a));)a++;if(a<f&&a!==d){for(d=a;a<f&&!h(l.charCodeAt(a));)a++;if(a===f)return l;a!==d&&(p=t=a+1)}}}}else _(s)&&l.charCodeAt(1)===i&&(p=f>2&&h(l.charCodeAt(2))?3:2,t=p);let o=-1,n=!0;for(let a=f-1;a>=t;--a)if(h(l.charCodeAt(a))){if(!n){o=a;break}}else n=!1;if(o===-1){if(p===-1)return".";o=p}return l.slice(0,o)},basename(l,f){f!==void 0&&m(f,"ext"),m(l,"path");let p=0,t=-1,s=!0,o;if(l.length>=2&&_(l.charCodeAt(0))&&l.charCodeAt(1)===i&&(p=2),f!==void 0&&f.length>0&&f.length<=l.length){if(f===l)return"";let n=f.length-1,a=-1;for(o=l.length-1;o>=p;--o){const d=l.charCodeAt(o);if(h(d)){if(!s){p=o+1;break}}else a===-1&&(s=!1,a=o+1),n>=0&&(d===f.charCodeAt(n)?--n==-1&&(t=o):(n=-1,t=a))}return p===t?t=a:t===-1&&(t=l.length),l.slice(p,t)}for(o=l.length-1;o>=p;--o)if(h(l.charCodeAt(o))){if(!s){p=o+1;break}}else t===-1&&(s=!1,t=o+1);return t===-1?"":l.slice(p,t)},extname(l){m(l,"path");let f=0,p=-1,t=0,s=-1,o=!0,n=0;l.length>=2&&l.charCodeAt(1)===i&&_(l.charCodeAt(0))&&(f=t=2);for(let a=l.length-1;a>=f;--a){const d=l.charCodeAt(a);if(h(d)){if(!o){t=a+1;break}continue}s===-1&&(o=!1,s=a+1),d===y?p===-1?p=a:n!==1&&(n=1):p!==-1&&(n=-1)}return p===-1||s===-1||n===0||n===1&&p===s-1&&p===t+1?"":l.slice(p,s)},format:P.bind(null,"\\"),parse(l){m(l,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return f;const p=l.length;let t=0,s=l.charCodeAt(0);if(p===1)return h(s)?(f.root=f.dir=l,f):(f.base=f.name=l,f);if(h(s)){if(t=1,h(l.charCodeAt(1))){let E=2,r=E;for(;E<p&&!h(l.charCodeAt(E));)E++;if(E<p&&E!==r){for(r=E;E<p&&h(l.charCodeAt(E));)E++;if(E<p&&E!==r){for(r=E;E<p&&!h(l.charCodeAt(E));)E++;E===p?t=E:E!==r&&(t=E+1)}}}}else if(_(s)&&l.charCodeAt(1)===i){if(p<=2)return f.root=f.dir=l,f;if(t=2,h(l.charCodeAt(2))){if(p===3)return f.root=f.dir=l,f;t=3}}t>0&&(f.root=l.slice(0,t));let o=-1,n=t,a=-1,d=!0,u=l.length-1,w=0;for(;u>=t;--u){if(s=l.charCodeAt(u),h(s)){if(!d){n=u+1;break}continue}a===-1&&(d=!1,a=u+1),s===y?o===-1?o=u:w!==1&&(w=1):o!==-1&&(w=-1)}return a!==-1&&(o===-1||w===0||w===1&&o===a-1&&o===n+1?f.base=f.name=l.slice(n,a):(f.name=l.slice(n,o),f.base=l.slice(n,a),f.ext=l.slice(o,a))),n>0&&n!==t?f.dir=l.slice(0,n-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let f="",p=!1;for(let t=l.length-1;t>=-1&&!p;t--){const s=t>=0?l[t]:g.cwd();m(s,"path"),s.length!==0&&(f=`${s}/${f}`,p=s.charCodeAt(0)===S)}return f=b(f,!p,"/",v),p?`/${f}`:f.length>0?f:"."},normalize(l){if(m(l,"path"),l.length===0)return".";const f=l.charCodeAt(0)===S,p=l.charCodeAt(l.length-1)===S;return l=b(l,!f,"/",v),l.length===0?f?"/":p?"./":".":(p&&(l+="/"),f?`/${l}`:l)},isAbsolute(l){return m(l,"path"),l.length>0&&l.charCodeAt(0)===S},join(...l){if(l.length===0)return".";let f;for(let p=0;p<l.length;++p){const t=l[p];m(t,"path"),t.length>0&&(f===void 0?f=t:f+=`/${t}`)}return f===void 0?".":e.posix.normalize(f)},relative(l,f){if(m(l,"from"),m(f,"to"),l===f||(l=e.posix.resolve(l),f=e.posix.resolve(f),l===f))return"";const p=1,t=l.length,s=t-p,o=1,n=f.length-o,a=s<n?s:n;let d=-1,u=0;for(;u<a;u++){const E=l.charCodeAt(p+u);if(E!==f.charCodeAt(o+u))break;E===S&&(d=u)}if(u===a)if(n>a){if(f.charCodeAt(o+u)===S)return f.slice(o+u+1);if(u===0)return f.slice(o+u)}else s>a&&(l.charCodeAt(p+u)===S?d=u:u===0&&(d=0));let w="";for(u=p+d+1;u<=t;++u)(u===t||l.charCodeAt(u)===S)&&(w+=w.length===0?"..":"/..");return`${w}${f.slice(o+d)}`},toNamespacedPath(l){return l},dirname(l){if(m(l,"path"),l.length===0)return".";const f=l.charCodeAt(0)===S;let p=-1,t=!0;for(let s=l.length-1;s>=1;--s)if(l.charCodeAt(s)===S){if(!t){p=s;break}}else t=!1;return p===-1?f?"/":".":f&&p===1?"//":l.slice(0,p)},basename(l,f){f!==void 0&&m(f,"ext"),m(l,"path");let p=0,t=-1,s=!0,o;if(f!==void 0&&f.length>0&&f.length<=l.length){if(f===l)return"";let n=f.length-1,a=-1;for(o=l.length-1;o>=0;--o){const d=l.charCodeAt(o);if(d===S){if(!s){p=o+1;break}}else a===-1&&(s=!1,a=o+1),n>=0&&(d===f.charCodeAt(n)?--n==-1&&(t=o):(n=-1,t=a))}return p===t?t=a:t===-1&&(t=l.length),l.slice(p,t)}for(o=l.length-1;o>=0;--o)if(l.charCodeAt(o)===S){if(!s){p=o+1;break}}else t===-1&&(s=!1,t=o+1);return t===-1?"":l.slice(p,t)},extname(l){m(l,"path");let f=-1,p=0,t=-1,s=!0,o=0;for(let n=l.length-1;n>=0;--n){const a=l.charCodeAt(n);if(a===S){if(!s){p=n+1;break}continue}t===-1&&(s=!1,t=n+1),a===y?f===-1?f=n:o!==1&&(o=1):f!==-1&&(o=-1)}return f===-1||t===-1||o===0||o===1&&f===t-1&&f===p+1?"":l.slice(f,t)},format:P.bind(null,"/"),parse(l){m(l,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return f;const p=l.charCodeAt(0)===S;let t;p?(f.root="/",t=1):t=0;let s=-1,o=0,n=-1,a=!0,d=l.length-1,u=0;for(;d>=t;--d){const w=l.charCodeAt(d);if(w===S){if(!a){o=d+1;break}continue}n===-1&&(a=!1,n=d+1),w===y?s===-1?s=d:u!==1&&(u=1):s!==-1&&(u=-1)}if(n!==-1){const w=o===0&&p?1:o;s===-1||u===0||u===1&&s===n-1&&s===o+1?f.base=f.name=l.slice(w,n):(f.name=l.slice(w,s),f.base=l.slice(w,n),f.ext=l.slice(s,n))}return o>0?f.dir=l.slice(0,o-1):p&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[140],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var R;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(C,...T){const y=T.reduce((i,I)=>(i[I]=!0,i),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(i=>!y[i]).forEach(i=>{for(let I=0;I<S.length;I++)if(i.search(S[I])!==-1){delete C[i];break}})}e.sanitizeProcessEnvironment=k}),define(me[46],ge([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=g.globals.performance&&typeof g.globals.performance.now=="function";class k{constructor(T){this._highResolution=R&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new k(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=k}),define(me[3],ge([0,1,16,73,6,94,46]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var y;(function(l){l.None=()=>k.Disposable.None;function f(K){return(O,x=null,F)=>{let z=!1,M;return M=K(N=>{if(!z)return M?M.dispose():z=!0,O.call(x,N)},null,F),z&&M.dispose(),M}}l.once=f;function p(K,O){return d((x,F=null,z)=>K(M=>x.call(F,O(M)),null,z))}l.map=p;function t(K,O){return d((x,F=null,z)=>K(M=>{O(M),x.call(F,M)},null,z))}l.forEach=t;function s(K,O){return d((x,F=null,z)=>K(M=>O(M)&&x.call(F,M),null,z))}l.filter=s;function o(K){return K}l.signal=o;function n(...K){return(O,x=null,F)=>(0,k.combinedDisposable)(...K.map(z=>z(M=>O.call(x,M),null,F)))}l.any=n;function a(K,O,x){let F=x;return p(K,z=>(F=O(F,z),F))}l.reduce=a;function d(K){let O;const x=new c({onFirstListenerAdd(){O=K(x.fire,x)},onLastListenerRemove(){O.dispose()}});return x.event}function u(K,O,x=100,F=!1,z){let M,N,V,$=0;const G=new c({leakWarningThreshold:z,onFirstListenerAdd(){M=K(J=>{$++,N=O(N,J),F&&!V&&(G.fire(N),N=void 0),clearTimeout(V),V=setTimeout(()=>{const fe=N;N=void 0,V=void 0,(!F||$>1)&&G.fire(fe),$=0},x)})},onLastListenerRemove(){M.dispose()}});return G.event}l.debounce=u;function w(K,O=(x,F)=>x===F){let x=!0,F;return s(K,z=>{const M=x||!O(z,F);return x=!1,F=z,M})}l.latch=w;function E(K,O){return[l.filter(K,O),l.filter(K,x=>!O(x))]}l.split=E;function r(K,O=!1,x=[]){let F=x.slice(),z=K(V=>{F?F.push(V):N.fire(V)});const M=()=>{F&&F.forEach(V=>N.fire(V)),F=null},N=new c({onFirstListenerAdd(){z||(z=K(V=>N.fire(V)))},onFirstListenerDidAdd(){F&&(O?setTimeout(M):M())},onLastListenerRemove(){z&&z.dispose(),z=null}});return N.event}l.buffer=r;class D{constructor(O){this.event=O}map(O){return new D(p(this.event,O))}forEach(O){return new D(t(this.event,O))}filter(O){return new D(s(this.event,O))}reduce(O,x){return new D(a(this.event,O,x))}latch(){return new D(w(this.event))}debounce(O,x=100,F=!1,z){return new D(u(this.event,O,x,F,z))}on(O,x,F){return this.event(O,x,F)}once(O,x,F){return f(this.event)(O,x,F)}}function L(K){return new D(K)}l.chain=L;function U(K,O,x=F=>F){const F=(...V)=>N.fire(x(...V)),z=()=>K.on(O,F),M=()=>K.removeListener(O,F),N=new c({onFirstListenerAdd:z,onLastListenerRemove:M});return N.event}l.fromNodeEventEmitter=U;function j(K,O,x=F=>F){const F=(...V)=>N.fire(x(...V)),z=()=>K.addEventListener(O,F),M=()=>K.removeEventListener(O,F),N=new c({onFirstListenerAdd:z,onLastListenerRemove:M});return N.event}l.fromDOMEventEmitter=j;function te(K){return new Promise(O=>f(K)(O))}l.toPromise=te})(y=e.Event||(e.Event={}));class S{constructor(f){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${f}_${S._idPool++}`}start(f){this._stopWatch=new T.StopWatch(!0),this._listenerCount=f}stop(){if(this._stopWatch){const f=this._stopWatch.elapsed();this._elapsedOverall+=f,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${f.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let A=-1;function i(l){const f=A;return A=l,{dispose(){A=f}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(f,p=Math.random().toString(18).slice(2,5)){this.customThreshold=f,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(f){let p=A;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||f<p)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let o,n=0;for(const[a,d]of this._stacks)(!o||n<d)&&(o=a,n=d);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${n}):`),console.warn(o)}return()=>{const o=this._stacks.get(t)||0;this._stacks.set(t,o-1)}}}class c{constructor(f){this._disposed=!1,this._options=f,this._leakageMon=A>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(f,p,t)=>{this._listeners||(this._listeners=new C.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(p?[f,p]:f);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,f,p);const n=this._leakageMon?.check(this._listeners.size),a=(0,k.toDisposable)(()=>{n&&n(),this._disposed||(o(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof k.DisposableStore?t.add(a):Array.isArray(t)&&t.push(a),a}),this._event}fire(f){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,f]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(s){(0,g.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class m extends c{async fireAsync(f,p,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,f]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[s,o]=this._asyncDeliveryQueue.shift(),n=[],a={...o,waitUntil:d=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");t&&(d=t(d,typeof s=="function"?s:s[0])),n.push(d)}};try{typeof s=="function"?s.call(void 0,a):s[0].call(s[1],a)}catch(d){(0,g.onUnexpectedError)(d);continue}Object.freeze(n),await Promise.allSettled(n).then(d=>{for(const u of d)u.status==="rejected"&&(0,g.onUnexpectedError)(u.reason)})}}}}e.AsyncEmitter=m;class h extends c{constructor(f){super(f);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=f?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const f=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(f))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(f){this._listeners&&(this._isPaused!==0?this._eventQueue.push(f):super.fire(f))}}e.PauseableEmitter=h;class v extends h{constructor(f){super(f);this._delay=f.delay??100}fire(f){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(f)}}e.DebounceEmitter=v;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(f){const p={event:f,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const t=()=>{this.hasListeners&&this.unhook(p);const s=this.events.indexOf(p);this.events.splice(s,1)};return(0,k.toDisposable)((0,R.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(f=>this.hook(f))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(f=>this.unhook(f))}hook(f){f.listener=f.event(p=>this.emitter.fire(p))}unhook(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=_;class b{constructor(){this.buffers=[]}wrapEvent(f){return(p,t,s)=>f(o=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>p.call(t,o)):p.call(t,o)},void 0,s)}bufferEvents(f){const p=[];this.buffers.push(p);const t=f();return this.buffers.pop(),p.forEach(s=>s()),t}}e.EventBufferer=b;class P{constructor(){this.listening=!1,this.inputEvent=y.None,this.inputEventListener=k.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(f){this.inputEvent=f,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=f(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(me[21],ge([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(y,S){const A=setTimeout(y.bind(S),0);return{dispose(){clearTimeout(A)}}});var k;(function(y){function S(A){return A===y.None||A===y.Cancelled||A instanceof C?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}y.isCancellationToken=S,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(k=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=k.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(me[47],ge([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const c=this._icons.get(I.id);c?I.description?c.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new R;e.iconRegistry=k;function C(i,I){return new y(i,I)}e.registerCodicon=C;function T(i){return i?i.replace(/\$\((.*?)\)/g,(I,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=T;class y{constructor(I,c,m){this.id=I,this.definition=c,this.description=m,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=y;function S(i,I){const c=["codicon","codicon-"+i];return I&&c.push("codicon-modifier-"+I),c}e.getClassNamesArray=S;var A;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function c(v){if(v instanceof y)return["codicon","codicon-"+v.id];const _=I.exec(v.id);if(!_)return c(y.error);let[,b,P]=_;const l=["codicon","codicon-"+b];return P&&l.push("codicon-modifier-"+P.substr(1)),l}i.asClassNameArray=c;function m(v){return c(v).join(" ")}i.asClassName=m;function h(v){return"."+c(v).join(".")}i.asCSSSelector=h})(A=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(y=e.Codicon||(e.Codicon={}))}),define(me[95],ge([0,1,16,6]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(l){const f=l;return f?[f.on,f.pause,f.resume,f.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=k;function C(l){const f=l;return f?k(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=C;function T(l,f){return new y(l,f)}e.newWriteableStream=T;class y{constructor(f,p){this.reducer=f,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(p=>p(f))}emitError(f){this.listeners.error.length===0?(0,g.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(p=>p(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,p){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(f,p){if(this.state.destroyed)return;let t;switch(f){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(p);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(l,f){const p=[];let t;for(;(t=l.read())!==null;)p.push(t);return f(p)}e.consumeReadable=S;function A(l,f,p){const t=[];let s;for(;(s=l.read())!==null&&t.length<p;)t.push(s);return s===null&&t.length>0?f(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const o=s;return s=void 0,o}return l.read()}}}e.peekReadable=A;function i(l,f){return new Promise((p,t)=>{const s=[];I(l,{onData:o=>{f&&s.push(o)},onError:o=>{f?t(o):p(void 0)},onEnd:()=>{p(f?f(s):void 0)}})})}e.consumeStream=i;function I(l,f){l.on("error",p=>f.onError(p)),l.on("end",()=>f.onEnd()),l.on("data",p=>f.onData(p))}e.listenStream=I;function c(l,f){return new Promise((p,t)=>{const s=new R.DisposableStore,o=[],n=u=>{if(o.push(u),o.length>f)return s.dispose(),l.pause(),p({stream:l,buffer:o,ended:!1})},a=u=>t(u),d=()=>p({stream:l,buffer:o,ended:!0});s.add((0,R.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),s.add((0,R.toDisposable)(()=>l.removeListener("end",d))),l.on("end",d),s.add((0,R.toDisposable)(()=>l.removeListener("data",n))),l.on("data",n)})}e.peekStream=c;function m(l,f){const p=T(f);return p.end(l),p}e.toStream=m;function h(){const l=T(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=h;function v(l){let f=!1;return{read:()=>f?null:(f=!0,l)}}e.toReadable=v;function _(l,f,p){const t=T(p);return I(l,{onData:s=>t.write(f.data(s)),onError:s=>t.error(f.error?f.error(s):s),onEnd:()=>t.end()}),t}e.transform=_;function b(l,f,p){let t=!1;return{read:()=>{const s=f.read();return t?s:(t=!0,s!==null?p([l,s]):l)}}}e.prefixedReadable=b;function P(l,f,p){let t=!1;const s=T(p);return I(f,{onData:o=>t?s.write(o):(t=!0,s.write(p([l,o]))),onError:o=>s.error(o),onEnd:()=>{t||(t=!0,s.write(l)),s.end()}}),s}e.prefixedStream=P}),define(me[25],ge([0,1,95]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined";let k,C;class T{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return R?new T(Buffer.allocUnsafe(n)):new T(new Uint8Array(n))}static wrap(n){return R&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new T(n)}static fromString(n,a){return!(a?.dontUseNodeBuffer||!1)&&R?new T(Buffer.from(n)):(k||(k=new TextEncoder),new T(k.encode(n)))}static concat(n,a){if(typeof a=="undefined"){a=0;for(let w=0,E=n.length;w<E;w++)a+=n[w].byteLength}const d=T.alloc(a);let u=0;for(let w=0,E=n.length;w<E;w++){const r=n[w];d.set(r,u),u+=r.byteLength}return d}toString(){return R?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(n,a){return new T(this.buffer.subarray(n,a))}set(n,a){n instanceof T?this.buffer.set(n.buffer,a):this.buffer.set(n,a)}readUInt32BE(n){return A(this.buffer,n)}writeUInt32BE(n,a){i(this.buffer,n,a)}readUInt32LE(n){return I(this.buffer,n)}writeUInt32LE(n,a){c(this.buffer,n,a)}readUInt8(n){return m(this.buffer,n)}writeUInt8(n,a){h(this.buffer,n,a)}}e.VSBuffer=T;function y(o,n){return o[n+0]<<0>>>0|o[n+1]<<8>>>0}e.readUInt16LE=y;function S(o,n,a){o[a+0]=n&255,n=n>>>8,o[a+1]=n&255}e.writeUInt16LE=S;function A(o,n){return o[n]*2**24+o[n+1]*2**16+o[n+2]*2**8+o[n+3]}e.readUInt32BE=A;function i(o,n,a){o[a+3]=n,n=n>>>8,o[a+2]=n,n=n>>>8,o[a+1]=n,n=n>>>8,o[a]=n}e.writeUInt32BE=i;function I(o,n){return o[n+0]<<0>>>0|o[n+1]<<8>>>0|o[n+2]<<16>>>0|o[n+3]<<24>>>0}e.readUInt32LE=I;function c(o,n,a){o[a+0]=n&255,n=n>>>8,o[a+1]=n&255,n=n>>>8,o[a+2]=n&255,n=n>>>8,o[a+3]=n&255}e.writeUInt32LE=c;function m(o,n){return o[n]}e.readUInt8=m;function h(o,n,a){o[a]=n}e.writeUInt8=h;function v(o){return g.consumeReadable(o,n=>T.concat(n))}e.readableToBuffer=v;function _(o){return g.toReadable(o)}e.bufferToReadable=_;function b(o){return g.consumeStream(o,n=>T.concat(n))}e.streamToBuffer=b;async function P(o){return o.ended?T.concat(o.buffer):T.concat([...o.buffer,await b(o.stream)])}e.bufferedStreamToBuffer=P;function l(o){return g.toStream(o,n=>T.concat(n))}e.bufferToStream=l;function f(o){return g.transform(o,{data:n=>typeof n=="string"?T.fromString(n):T.wrap(n)},n=>T.concat(n))}e.streamToBufferReadableStream=f;function p(o){return g.newWriteableStream(n=>T.concat(n),o)}e.newWriteableBufferStream=p;function t(o,n){return g.prefixedReadable(o,n,a=>T.concat(a))}e.prefixedBufferReadable=t;function s(o,n){return g.prefixedStream(o,n,a=>T.concat(a))}e.prefixedBufferStream=s}),define(me[9],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(le){return!le||typeof le!="string"?!0:le.trim().length===0}e.isFalsyOrWhitespace=g;const R=/{(\d+)}/g;function k(le,...Pe){return Pe.length===0?le:le.replace(R,function(Ne,Ye){const We=parseInt(Ye,10);return isNaN(We)||We<0||We>=Pe.length?Ne:Pe[We]})}e.format=k;const C=/{([^}]+)}/g;function T(le,Pe){return le.replace(C,(Ne,Ye)=>Pe[Ye]??Ne)}e.format2=T;function y(le){return le.replace(/[<>&]/g,function(Pe){switch(Pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Pe}})}e.escape=y;function S(le){return le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function A(le,Pe){let Ne=0;const Ye=Pe.charCodeAt(0);for(let We=le.length-1;We>=0;We--)le.charCodeAt(We)===Ye&&Ne++;return Ne}e.count=A;function i(le,Pe,Ne="\u2026"){return le.length<=Pe?le:`${le.substr(0,Pe)}${Ne}`}e.truncate=i;function I(le,Pe=" "){const Ne=c(le,Pe);return m(Ne,Pe)}e.trim=I;function c(le,Pe){if(!le||!Pe)return le;const Ne=Pe.length;if(Ne===0||le.length===0)return le;let Ye=0;for(;le.indexOf(Pe,Ye)===Ye;)Ye=Ye+Ne;return le.substring(Ye)}e.ltrim=c;function m(le,Pe){if(!le||!Pe)return le;const Ne=Pe.length,Ye=le.length;if(Ne===0||Ye===0)return le;let We=Ye,st=-1;for(;st=le.lastIndexOf(Pe,We-1),!(st===-1||st+Ne!==We);){if(st===0)return"";We=st}return le.substring(0,We)}e.rtrim=m;function h(le){return le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function v(le){return le.replace(/\*/g,"")}e.stripWildcards=v;function _(le,Pe,Ne={}){if(!le)throw new Error("Cannot create regex from empty string");Pe||(le=S(le)),Ne.wholeWord&&(/\B/.test(le.charAt(0))||(le="\\b"+le),/\B/.test(le.charAt(le.length-1))||(le=le+"\\b"));let Ye="";return Ne.global&&(Ye+="g"),Ne.matchCase||(Ye+="i"),Ne.multiline&&(Ye+="m"),Ne.unicode&&(Ye+="u"),new RegExp(le,Ye)}e.createRegExp=_;function b(le){return le.source==="^"||le.source==="^$"||le.source==="$"||le.source==="^\\s*$"?!1:!!(le.exec("")&&le.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function P(le){return!!le.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function l(le){return(le.global?"g":"")+(le.ignoreCase?"i":"")+(le.multiline?"m":"")+(le.unicode?"u":"")}e.regExpFlags=l;function f(le){return le.split(/\r\n|\r|\n/)}e.splitLines=f;function p(le){for(let Pe=0,Ne=le.length;Pe<Ne;Pe++){const Ye=le.charCodeAt(Pe);if(Ye!==32&&Ye!==9)return Pe}return-1}e.firstNonWhitespaceIndex=p;function t(le,Pe=0,Ne=le.length){for(let Ye=Pe;Ye<Ne;Ye++){const We=le.charCodeAt(Ye);if(We!==32&&We!==9)return le.substring(Pe,Ye)}return le.substring(Pe,Ne)}e.getLeadingWhitespace=t;function s(le,Pe=le.length-1){for(let Ne=Pe;Ne>=0;Ne--){const Ye=le.charCodeAt(Ne);if(Ye!==32&&Ye!==9)return Ne}return-1}e.lastNonWhitespaceIndex=s;function o(le,Pe){return le<Pe?-1:le>Pe?1:0}e.compare=o;function n(le,Pe,Ne=0,Ye=le.length,We=0,st=Pe.length){for(;Ne<Ye&&We<st;Ne++,We++){let Ie=le.charCodeAt(Ne),ne=Pe.charCodeAt(We);if(Ie<ne)return-1;if(Ie>ne)return 1}const Te=Ye-Ne,De=st-We;return Te<De?-1:Te>De?1:0}e.compareSubstring=n;function a(le,Pe){return d(le,Pe,0,le.length,0,Pe.length)}e.compareIgnoreCase=a;function d(le,Pe,Ne=0,Ye=le.length,We=0,st=Pe.length){for(;Ne<Ye&&We<st;Ne++,We++){let Ie=le.charCodeAt(Ne),ne=Pe.charCodeAt(We);if(Ie===ne)continue;const ue=Ie-ne;if(!(ue===32&&w(ne))&&!(ue===-32&&w(Ie)))return u(Ie)&&u(ne)?ue:n(le.toLowerCase(),Pe.toLowerCase(),Ne,Ye,We,st)}const Te=Ye-Ne,De=st-We;return Te<De?-1:Te>De?1:0}e.compareSubstringIgnoreCase=d;function u(le){return le>=97&&le<=122}e.isLowerAsciiLetter=u;function w(le){return le>=65&&le<=90}e.isUpperAsciiLetter=w;function E(le){return u(le)||w(le)}function r(le,Pe){return le.length===Pe.length&&D(le,Pe)}e.equalsIgnoreCase=r;function D(le,Pe,Ne=le.length){for(let Ye=0;Ye<Ne;Ye++){const We=le.charCodeAt(Ye),st=Pe.charCodeAt(Ye);if(We!==st){if(E(We)&&E(st)){const Te=Math.abs(We-st);if(Te!==0&&Te!==32)return!1}else if(String.fromCharCode(We).toLowerCase()!==String.fromCharCode(st).toLowerCase())return!1}}return!0}function L(le,Pe){const Ne=Pe.length;return Pe.length>le.length?!1:D(le,Pe,Ne)}e.startsWithIgnoreCase=L;function U(le,Pe){let Ne,Ye=Math.min(le.length,Pe.length);for(Ne=0;Ne<Ye;Ne++)if(le.charCodeAt(Ne)!==Pe.charCodeAt(Ne))return Ne;return Ye}e.commonPrefixLength=U;function j(le,Pe){let Ne,Ye=Math.min(le.length,Pe.length);const We=le.length-1,st=Pe.length-1;for(Ne=0;Ne<Ye;Ne++)if(le.charCodeAt(We-Ne)!==Pe.charCodeAt(st-Ne))return Ne;return Ye}e.commonSuffixLength=j;function te(le){return 55296<=le&&le<=56319}e.isHighSurrogate=te;function K(le){return 56320<=le&&le<=57343}e.isLowSurrogate=K;function O(le,Pe){return(le-55296<<10)+(Pe-56320)+65536}e.computeCodePoint=O;function x(le,Pe,Ne){const Ye=le.charCodeAt(Ne);if(te(Ye)&&Ne+1<Pe){const We=le.charCodeAt(Ne+1);if(K(We))return O(Ye,We)}return Ye}e.getNextCodePoint=x;function F(le,Pe){const Ne=le.charCodeAt(Pe-1);if(K(Ne)&&Pe>1){const Ye=le.charCodeAt(Pe-2);if(te(Ye))return O(Ye,Ne)}return Ne}function z(le,Pe){const Ne=Ue.getInstance(),Ye=Pe,We=le.length,st=x(le,We,Pe);Pe+=st>=65536?2:1;let Te=Ne.getGraphemeBreakType(st);for(;Pe<We;){const De=x(le,We,Pe),Ie=Ne.getGraphemeBreakType(De);if(ee(Te,Ie))break;Pe+=De>=65536?2:1,Te=Ie}return Pe-Ye}e.nextCharLength=z;function M(le,Pe){const Ne=Ue.getInstance(),Ye=Pe,We=F(le,Pe);Pe-=We>=65536?2:1;let st=Ne.getGraphemeBreakType(We);for(;Pe>0;){const Te=F(le,Pe),De=Ne.getGraphemeBreakType(Te);if(ee(De,st))break;Pe-=Te>=65536?2:1,st=De}return Ye-Pe}e.prevCharLength=M;function N(le,Pe){const Ne=Ue.getInstance(),Ye=le.length,We=Pe,st=x(le,Ye,Pe),Te=Ne.getGraphemeBreakType(st);Pe+=st>=65536?2:1;let De=Te;for(;Pe<Ye;){const ne=x(le,Ye,Pe),ue=Ne.getGraphemeBreakType(ne);if(ee(De,ue))break;Pe+=ne>=65536?2:1,De=ue}const Ie=Pe;for(Pe=We,De=Te;Pe>0;){const ne=F(le,Pe),ue=Ne.getGraphemeBreakType(ne);if(ee(ue,De))break;Pe-=ne>=65536?2:1,De=ue}return[Pe,Ie]}function V(le,Pe){return Pe>0&&K(le.charCodeAt(Pe))?N(le,Pe-1):N(le,Pe)}e.getCharContainingOffset=V;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(le){return $.test(le)}e.containsRTL=G;const J=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function fe(le){return J.test(le)}e.containsEmoji=fe;const ye=/^[\t\n\r\x20-\x7E]*$/;function ke(le){return ye.test(le)}e.isBasicASCII=ke,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Re(le){return e.UNUSUAL_LINE_TERMINATORS.test(le)}e.containsUnusualLineTerminators=Re;function Ve(le){for(let Pe=0,Ne=le.length;Pe<Ne;Pe++)if(Be(le.charCodeAt(Pe)))return!0;return!1}e.containsFullWidthCharacter=Ve;function Be(le){return le=+le,le>=11904&&le<=55215||le>=63744&&le<=64255||le>=65281&&le<=65374}e.isFullWidthCharacter=Be;function Ke(le){return le>=127462&&le<=127487||le===8986||le===8987||le===9200||le===9203||le>=9728&&le<=10175||le===11088||le===11093||le>=127744&&le<=128591||le>=128640&&le<=128764||le>=128992&&le<=129003||le>=129280&&le<=129535||le>=129648&&le<=129750}e.isEmojiImprecise=Ke;function W(le,Pe){if(le.length<Pe)return le;const Ne=/\b/g;let Ye=0;for(;Ne.test(le)&&!(le.length-Ne.lastIndex<Pe);)Ye=Ne.lastIndex,Ne.lastIndex+=1;return le.substring(Ye).replace(/^\s/,"")}e.lcut=W;const Z=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function Q(le){return le&&(le=le.replace(Z,""),le=le.replace(re,""),le=le.replace(ae,"")),le}e.removeAnsiEscapeCodes=Q,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(le){return!!(le&&le.length>0&&le.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function we(le){return oe(le)?le.substr(1):le}e.stripUTF8BOM=we;function Me(le,Pe){if(!le||!Pe||le.length<Pe.length)return!1;const Ne=Pe.length,Ye=le.toLowerCase();let We=0,st=-1;for(;We<Ne;){const Te=Ye.indexOf(Pe[We],st+1);if(Te<0)return!1;st=Te,We++}return!0}e.fuzzyContains=Me;function je(le,Pe=!1){return le?(Pe&&(le=le.replace(/\\./g,"")),le.toLowerCase()!==le):!1}e.containsUppercaseCharacter=je;function Xe(le){return le.charAt(0).toUpperCase()+le.slice(1)}e.uppercaseFirstLetter=Xe;function Se(le,Pe=1){if(Pe===0)return"";let Ne=-1;do Ne=le.indexOf(`
`,Ne+1),Pe--;while(Pe>0&&Ne>=0);return Ne===-1?le:(le[Ne-1]==="\r"&&Ne--,le.substr(0,Ne))}e.getNLines=Se;function tt(le){const Pe=90-65+1;return le=le%(2*Pe),le<Pe?String.fromCharCode(97+le):String.fromCharCode(65+le-Pe)}e.singleLetterHash=tt;function X(le){return Ue.getInstance().getGraphemeBreakType(le)}e.getGraphemeBreakType=X;function ee(le,Pe){return le===0?Pe!==5&&Pe!==7:le===2&&Pe===3?!1:le===4||le===2||le===3||Pe===4||Pe===2||Pe===3?!0:!(le===8&&(Pe===8||Pe===9||Pe===11||Pe===12)||(le===11||le===9)&&(Pe===9||Pe===10)||(le===12||le===10)&&Pe===10||Pe===5||Pe===13||Pe===7||le===1||le===13&&Pe===14||le===6&&Pe===6)}e.breakBetweenGraphemeBreakType=ee;var ve;(function(le){le[le.Other=0]="Other",le[le.Prepend=1]="Prepend",le[le.CR=2]="CR",le[le.LF=3]="LF",le[le.Control=4]="Control",le[le.Extend=5]="Extend",le[le.Regional_Indicator=6]="Regional_Indicator",le[le.SpacingMark=7]="SpacingMark",le[le.L=8]="L",le[le.V=9]="V",le[le.T=10]="T",le[le.LV=11]="LV",le[le.LVT=12]="LVT",le[le.ZWJ=13]="ZWJ",le[le.Extended_Pictographic=14]="Extended_Pictographic"})(ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=Je()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(Pe){if(Pe<32)return Pe===10?3:Pe===13?2:4;if(Pe<127)return 0;const Ne=this._data,Ye=Ne.length/3;let We=1;for(;We<=Ye;)if(Pe<Ne[3*We])We=2*We;else if(Pe>Ne[3*We+1])We=2*We+1;else return Ne[3*We+2];return 0}}Ue._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function nt(le,Pe){if(le===0)return 0;const Ne=at(le,Pe);if(Ne!==void 0)return Ne;const Ye=F(Pe,le);return le-=pt(Ye),le}e.getLeftDeleteOffset=nt;function at(le,Pe){let Ne=F(Pe,le);for(le-=pt(Ne);_t(Ne)||Ne===65039||Ne===8419;){if(le===0)return;Ne=F(Pe,le),le-=pt(Ne)}if(!!Ke(Ne)){if(le>=0){const Ye=F(Pe,le);Ye===8205&&(le-=pt(Ye))}return le}}function pt(le){return le>=65536?2:1}function _t(le){return 127995<=le&&le<=127999}var St;(function(le){le[le.zwj=8205]="zwj",le[le.emojiVariantSelector=65039]="emojiVariantSelector",le[le.enclosingKeyCap=8419]="enclosingKeyCap"})(St||(St={}))}),define(me[58],ge([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(b){return k(b,0)}e.hash=R;function k(b,P){switch(typeof b){case"object":return b===null?C(349,P):Array.isArray(b)?S(b,P):A(b,P);case"string":return y(b,P);case"boolean":return T(b,P);case"number":return C(b,P);case"undefined":return C(937,P);default:return C(617,P)}}e.doHash=k;function C(b,P){return(P<<5)-P+b|0}function T(b,P){return C(b?433:863,P)}function y(b,P){P=C(149417,P);for(let l=0,f=b.length;l<f;l++)P=C(b.charCodeAt(l),P);return P}e.stringHash=y;function S(b,P){return P=C(104579,P),b.reduce((l,f)=>k(f,l),P)}function A(b,P){return P=C(181387,P),Object.keys(b).sort().reduce((l,f)=>(l=y(f,l),k(b[f],l)),P)}class i{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=k(P,this._value),this._value}}e.Hasher=i;var I;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function c(b,P,l=32){const f=l-P,p=~((1<<f)-1);return(b<<P|(p&b)>>>f)>>>0}function m(b,P=0,l=b.byteLength,f=0){for(let p=0;p<l;p++)b[P+p]=f}function h(b,P,l="0"){for(;b.length<P;)b=l+b;return b}function v(b,P=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(l=>l.toString(16).padStart(2,"0")).join(""):h((b>>>0).toString(16),P/4)}e.toHexString=v;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const l=P.length;if(l===0)return;const f=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,s,o;for(t!==0?(s=t,o=-1,t=0):(s=P.charCodeAt(0),o=0);;){let n=s;if(g.isHighSurrogate(s))if(o+1<l){const a=P.charCodeAt(o+1);g.isLowSurrogate(a)?(o++,n=g.computeCodePoint(s,a)):n=65533}else{t=s;break}else g.isLowSurrogate(s)&&(n=65533);if(p=this._push(f,p,n),o++,o<l)s=P.charCodeAt(o);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(P,l,f){return f<128?P[l++]=f:f<2048?(P[l++]=192|(f&1984)>>>6,P[l++]=128|(f&63)>>>0):f<65536?(P[l++]=224|(f&61440)>>>12,P[l++]=128|(f&4032)>>>6,P[l++]=128|(f&63)>>>0):(P[l++]=240|(f&1835008)>>>18,P[l++]=128|(f&258048)>>>12,P[l++]=128|(f&4032)>>>6,P[l++]=128|(f&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=_._bigBlock32,l=this._buffDV;for(let u=0;u<64;u+=4)P.setUint32(u,l.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)P.setUint32(u,c(P.getUint32(u-12,!1)^P.getUint32(u-32,!1)^P.getUint32(u-56,!1)^P.getUint32(u-64,!1),1),!1);let f=this._h0,p=this._h1,t=this._h2,s=this._h3,o=this._h4,n,a,d;for(let u=0;u<80;u++)u<20?(n=p&t|~p&s,a=1518500249):u<40?(n=p^t^s,a=1859775393):u<60?(n=p&t|p&s|t&s,a=2400959708):(n=p^t^s,a=3395469782),d=c(f,5)+n+o+a+P.getUint32(u*4,!1)&4294967295,o=s,s=t,t=c(p,30),p=f,f=d;this._h0=this._h0+f&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[48],ge([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const C="error",T="warning",y="warn",S="info",A="ignore";function i(c){return c?g.equalsIgnoreCase(C,c)?k.Error:g.equalsIgnoreCase(T,c)||g.equalsIgnoreCase(y,c)?k.Warning:g.equalsIgnoreCase(S,c)?k.Info:k.Ignore:k.Ignore}k.fromValue=i;function I(c){switch(c){case k.Error:return C;case k.Warning:return T;case k.Info:return S;default:return A}}k.toString=I}(R||(R={})),e.default=R}),define(me[14],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(u){return Array.isArray(u)}e.isArray=g;function R(u){return typeof u=="string"}e.isString=R;function k(u){return Array.isArray(u)&&u.every(w=>R(w))}e.isStringArray=k;function C(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=C;function T(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=T;function y(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=y;function S(u){return u===!0||u===!1}e.isBoolean=S;function A(u){return typeof u=="undefined"}e.isUndefined=A;function i(u){return!I(u)}e.isDefined=i;function I(u){return A(u)||u===null}e.isUndefinedOrNull=I;function c(u,w){if(!u)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=c;function m(u){if(I(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=m;function h(...u){const w=[];for(let E=0;E<u.length;E++){const r=u[E];if(I(r))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);w.push(r)}return w}e.assertAllDefined=h;const v=Object.prototype.hasOwnProperty;function _(u){if(!C(u))return!1;for(let w in u)if(v.call(u,w))return!1;return!0}e.isEmptyObject=_;function b(u){return typeof u=="function"}e.isFunction=b;function P(...u){return u.length>0&&u.every(b)}e.areFunctions=P;function l(u,w){const E=Math.min(u.length,w.length);for(let r=0;r<E;r++)f(u[r],w[r])}e.validateConstraints=l;function f(u,w){if(R(w)){if(typeof u!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(b(w)){try{if(u instanceof w)return}catch{}if(!I(u)&&u.constructor===w||w.length===1&&w.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function p(u){let w=[],E=Object.getPrototypeOf(u);for(;Object.prototype!==E;)w=w.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return w}e.getAllPropertyNames=p;function t(u){const w=[];for(const E of p(u))typeof u[E]=="function"&&w.push(E);return w}e.getAllMethodNames=t;function s(u,w){const E=D=>function(){const L=Array.prototype.slice.call(arguments,0);return w(D,L)};let r={};for(const D of u)r[D]=E(D);return r}e.createProxyObject=s;function o(u){return u===null?void 0:u}e.withNullAsUndefined=o;function n(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=n;function a(u){return class{constructor(){return new Proxy({},{get(w,E){if(w[E])return w[E];throw new Error(`Not Implemented: ${u}->${String(E)}`)}})}}}e.NotImplementedProxy=a;function d(u,w="Unreachable"){throw new Error(w)}e.assertNever=d}),define(me[29],ge([0,1,8,11,9,14]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function y(o){return o.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=y;function S(o){return o.indexOf("/")===-1&&(o=y(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=S;function A(o,n=g.posix.sep){if(!o)return"";const a=o.length,d=o.charCodeAt(0);if(T(d)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let w=3;const E=w;for(;w<a&&!T(o.charCodeAt(w));w++);if(E!==w&&!T(o.charCodeAt(w+1))){for(w+=1;w<a;w++)if(T(o.charCodeAt(w)))return o.slice(0,w+1).replace(/[\\/]/g,n)}}return n}else if(b(d)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+n:o.slice(0,2);let u=o.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(T(o.charCodeAt(u)))return o.slice(0,u+1)}return""}e.getRoot=A;function i(o){if(!R.isWindows||!o||o.length<5)return!1;let n=o.charCodeAt(0);if(n!==92||(n=o.charCodeAt(1),n!==92))return!1;let a=2;const d=a;for(;a<o.length&&(n=o.charCodeAt(a),n!==92);a++);return!(d===a||(n=o.charCodeAt(a+1),isNaN(n)||n===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(o,n=R.isWindows){const a=n?I:c;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||n&&m.test(o)||o==="."||o===".."||n&&o[o.length-1]==="."||n&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=h;function v(o,n,a){const d=o===n;return!a||d?d:!o||!n?!1:(0,k.equalsIgnoreCase)(o,n)}e.isEqual=v;function _(o,n,a,d=g.sep){if(o===n)return!0;if(!o||!n||n.length>o.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(o,n))return!1;if(n.length===o.length)return!0;let w=n.length;return n.charAt(n.length-1)===d&&w--,o.charAt(w)===d}return n.charAt(n.length-1)!==d&&(n+=d),o.indexOf(n)===0}e.isEqualOrParent=_;function b(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=b;function P(o,n){return R.isWindows&&o.endsWith(":")&&(o+=g.sep),(0,g.isAbsolute)(o)||(o=(0,g.join)(n,o)),o=(0,g.normalize)(o),R.isWindows?(o=(0,k.rtrim)(o,g.sep),o.endsWith(":")&&(o+=g.sep)):(o=(0,k.rtrim)(o,g.sep),o||(o=g.sep)),o}e.sanitizeFilePath=P;function l(o){const n=(0,g.normalize)(o);return R.isWindows?o.length>3?!1:f(n)&&(o.length===2||n.charCodeAt(2)===92):n===g.posix.sep}e.isRootOrDriveLetter=l;function f(o){return R.isWindows?b(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function p(o){return f(o)?o[0]:void 0}e.getDriveLetter=p;function t(o,n,a){return n.length>o.length?-1:o===n?0:(a&&(o=o.toLowerCase(),n=n.toLowerCase()),o.indexOf(n))}e.indexOfPath=t;function s(o){const n=o.split(":");let a,d,u;if(n.forEach(w=>{const E=Number(w);(0,C.isNumber)(E)?d===void 0?d=E:u===void 0&&(u=E):a=a?[a,w].join(":"):w}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:d!==void 0?d:void 0,column:u!==void 0?u:d!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(me[22],ge([0,1,14]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const _=Array.isArray(v)?[]:{};return Object.keys(v).forEach(b=>{v[b]&&typeof v[b]=="object"?_[b]=R(v[b]):_[b]=v[b]}),_}e.deepClone=R;function k(v){if(!v||typeof v!="object")return v;const _=[v];for(;_.length>0;){const b=_.shift();Object.freeze(b);for(const P in b)if(C.call(b,P)){const l=b[P];typeof l=="object"&&!Object.isFrozen(l)&&_.push(l)}}return v}e.deepFreeze=k;const C=Object.prototype.hasOwnProperty;function T(v,_){return y(v,_,new Set)}e.cloneAndChange=T;function y(v,_,b){if((0,g.isUndefinedOrNull)(v))return v;const P=_(v);if(typeof P!="undefined")return P;if((0,g.isArray)(v)){const l=[];for(const f of v)l.push(y(f,_,b));return l}if((0,g.isObject)(v)){if(b.has(v))throw new Error("Cannot clone recursive data-structure");b.add(v);const l={};for(let f in v)C.call(v,f)&&(l[f]=y(v[f],_,b));return b.delete(v),l}return v}function S(v,_,b=!0){return(0,g.isObject)(v)?((0,g.isObject)(_)&&Object.keys(_).forEach(P=>{P in v?b&&((0,g.isObject)(v[P])&&(0,g.isObject)(_[P])?S(v[P],_[P],b):v[P]=_[P]):v[P]=_[P]}),v):_}e.mixin=S;function A(v,_){if(v===_)return!0;if(v==null||_===null||_===void 0||typeof v!=typeof _||typeof v!="object"||Array.isArray(v)!==Array.isArray(_))return!1;let b,P;if(Array.isArray(v)){if(v.length!==_.length)return!1;for(b=0;b<v.length;b++)if(!A(v[b],_[b]))return!1}else{const l=[];for(P in v)l.push(P);l.sort();const f=[];for(P in _)f.push(P);if(f.sort(),!A(l,f))return!1;for(b=0;b<l.length;b++)if(!A(v[l[b]],_[l[b]]))return!1}return!0}e.equals=A;function i(v){const _=new Set;return JSON.stringify(v,(b,P)=>{if((0,g.isObject)(P)||Array.isArray(P)){if(_.has(P))return"[Circular]";_.add(P)}return P})}e.safeStringify=i;function I(v,_,b){const P=_(v);return typeof P=="undefined"?b:P}e.getOrDefault=I;function c(v,_){const b=Object.create(null);return!v||!_||Object.keys(_).forEach(l=>{const f=v[l],p=_[l];A(f,p)||(b[l]=p)}),b}e.distinct=c;function m(v,_){const b=_.toLowerCase(),P=Object.keys(v).find(l=>l.toLowerCase()===b);return P?v[P]:v[_]}e.getCaseInsensitive=m;function h(v,_){const b=Object.create(null);for(const P of Object.keys(v))_(P,v[P])&&(b[P]=v[P]);return b}e.filter=h}),define(me[96],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function R(C){return C<0?0:C>255?255:C|0}e.toUint8=R;function k(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=k}),define(me[2],ge([0,1,8,11]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,C=/^\//,T=/^\/\//;function y(o,n){if(!o.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!k.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!C.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(o,n){return!o&&!n?"file":o}function A(o,n){switch(o){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const i="",I="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(n,a,d,u,w,E=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=S(n,E),this.authority=a||i,this.path=A(this.scheme,d||i),this.query=u||i,this.fragment=w||i,y(this,E))}static isUri(n){return n instanceof m?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return l(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:d,path:u,query:w,fragment:E}=n;return a===void 0?a=this.scheme:a===null&&(a=i),d===void 0?d=this.authority:d===null&&(d=i),u===void 0?u=this.path:u===null&&(u=i),w===void 0?w=this.query:w===null&&(w=i),E===void 0?E=this.fragment:E===null&&(E=i),a===this.scheme&&d===this.authority&&u===this.path&&w===this.query&&E===this.fragment?this:new v(a,d,u,w,E)}static parse(n,a=!1){const d=c.exec(n);return d?new v(d[2]||i,s(d[4]||i),s(d[5]||i),s(d[7]||i),s(d[9]||i),a):new v(i,i,i,i,i)}static file(n){let a=i;if(R.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const d=n.indexOf(I,2);d===-1?(a=n.substring(2),n=I):(a=n.substring(2,d),n=n.substring(d)||I)}return new v("file",a,n,i,i)}static from(n){const a=new v(n.scheme,n.authority,n.path,n.query,n.fragment);return y(a,!0),a}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return R.isWindows&&n.scheme==="file"?d=m.file(g.win32.join(l(n,!0),...a)).path:d=g.posix.join(n.path,...a),n.with({path:d})}toString(n=!1){return f(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof m)return n;{const a=new v(n);return a._formatted=n.external,a._fsPath=n._sep===h?n.fsPath:null,a}}else return n}}e.URI=m;const h=R.isWindows?1:void 0;class v extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(n=!1){return n?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=h),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(o,n){let a,d=-1;for(let u=0;u<o.length;u++){const w=o.charCodeAt(u);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||n&&w===47)d!==-1&&(a+=encodeURIComponent(o.substring(d,u)),d=-1),a!==void 0&&(a+=o.charAt(u));else{a===void 0&&(a=o.substr(0,u));const E=_[w];E!==void 0?(d!==-1&&(a+=encodeURIComponent(o.substring(d,u)),d=-1),a+=E):d===-1&&(d=u)}}return d!==-1&&(a+=encodeURIComponent(o.substring(d))),a!==void 0?a:o}function P(o){let n;for(let a=0;a<o.length;a++){const d=o.charCodeAt(a);d===35||d===63?(n===void 0&&(n=o.substr(0,a)),n+=_[d]):n!==void 0&&(n+=o[a])}return n!==void 0?n:o}function l(o,n){let a;return o.authority&&o.path.length>1&&o.scheme==="file"?a=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?n?a=o.path.substr(1):a=o.path[1].toLowerCase()+o.path.substr(2):a=o.path,R.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=l;function f(o,n){const a=n?P:b;let d="",{scheme:u,authority:w,path:E,query:r,fragment:D}=o;if(u&&(d+=u,d+=":"),(w||u==="file")&&(d+=I,d+=I),w){let L=w.indexOf("@");if(L!==-1){const U=w.substr(0,L);w=w.substr(L+1),L=U.indexOf(":"),L===-1?d+=a(U,!1):(d+=a(U.substr(0,L),!1),d+=":",d+=a(U.substr(L+1),!1)),d+="@"}w=w.toLowerCase(),L=w.indexOf(":"),L===-1?d+=a(w,!1):(d+=a(w.substr(0,L),!1),d+=w.substr(L))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const L=E.charCodeAt(1);L>=65&&L<=90&&(E=`/${String.fromCharCode(L+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const L=E.charCodeAt(0);L>=65&&L<=90&&(E=`${String.fromCharCode(L+32)}:${E.substr(2)}`)}d+=a(E,!0)}return r&&(d+="?",d+=a(r,!1)),D&&(d+="#",d+=n?D:b(D,!1)),d}function p(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+p(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(o){return o.match(t)?o.replace(t,n=>p(n)):o}});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},He=this&&this.__classPrivateFieldGet||function(Y,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(Y):R?R.value:e.get(Y)};define(me[23],ge([0,1,9,2]),function(Y,e,g,R){"use strict";var k,C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(t,s,o){let n=t.get(s);return n===void 0&&(n=o,t.set(s,n)),n}e.getOrSet=y;function S(t){const s=[];return t.forEach((o,n)=>{s.push(`${n} => ${o}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=S;function A(t){const s=[];return t.forEach(o=>{s.push(o)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=A;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const o=s.charCodeAt(0),n=this._value.charCodeAt(this._pos);return o-n}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,g.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,g.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class c{constructor(s=!0,o=!0){this._splitOnBackslash=s,this._caseSensitive=o}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,g.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,g.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class h{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,g.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,g.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,g.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,g.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(s){this._iter=s}static forUris(s=()=>!1){return new _(new h(s))}static forPaths(){return new _(new c)}static forStrings(){return new _(new i)}static forConfigKeys(){return new _(new I)}clear(){this._root=void 0}set(s,o){const n=this._iter.reset(s);let a;for(this._root||(this._root=new v,this._root.segment=n.value()),a=this._root;;){const u=n.cmp(a.segment);if(u>0)a.left||(a.left=new v,a.left.segment=n.value()),a=a.left;else if(u<0)a.right||(a.right=new v,a.right.segment=n.value()),a=a.right;else if(n.hasNext())n.next(),a.mid||(a.mid=new v,a.mid.segment=n.value()),a=a.mid;else break}const d=a.value;return a.value=o,a.key=s,d}get(s){return this._getNode(s)?.value}_getNode(s){const o=this._iter.reset(s);let n=this._root;for(;n;){const a=o.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(o.hasNext())o.next(),n=n.mid;else break}return n}has(s){const o=this._getNode(s);return!(o?.value===void 0&&o?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,o){const n=this._iter.reset(s),a=[];let d=this._root;for(;d;){const u=n.cmp(d.segment);if(u>0)a.push([1,d]),d=d.left;else if(u<0)a.push([-1,d]),d=d.right;else if(n.hasNext())n.next(),a.push([0,d]),d=d.mid;else{for(o?(d.left=void 0,d.mid=void 0,d.right=void 0):d.value=void 0;a.length>0&&d.isEmpty();){let[w,E]=a.pop();switch(w){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}d=E}break}}}findSubstr(s){const o=this._iter.reset(s);let n=this._root,a;for(;n;){const d=o.cmp(n.segment);if(d>0)n=n.left;else if(d<0)n=n.right;else if(o.hasNext())o.next(),a=n.value||a,n=n.mid;else break}return n&&n.value||a}findSuperstr(s){const o=this._iter.reset(s);let n=this._root;for(;n;){const a=o.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(o.hasNext())o.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(s){for(const[o,n]of this)s(n,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const o=[s];for(;o.length>0;){const n=o.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&o.push(n.left),n.mid&&o.push(n.mid),n.right&&o.push(n.right))}}}e.TernarySearchTree=_;class b{constructor(s,o){this[k]="ResourceMap",s instanceof b?(this.map=new Map(s.map),this.toKey=o??b.defaultToKey):(this.map=new Map,this.toKey=s??b.defaultToKey)}set(s,o){return this.map.set(this.toKey(s),o),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,o){typeof o!="undefined"&&(s=s.bind(o));for(let[n,a]of this.map)s(a,R.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield R.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[R.URI.parse(s[0]),s[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[R.URI.parse(s[0]),s[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var P;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class l{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,o=0){const n=this._map.get(s);if(!!n)return o!==0&&this.touch(n,o),n.value}set(s,o,n=0){let a=this._map.get(s);if(a)a.value=o,n!==0&&this.touch(a,n);else{switch(a={key:s,value:o,next:void 0,previous:void 0},n){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(s,a),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this._map.get(s);if(!!o)return this._map.delete(s),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,o){const n=this._state;let a=this._head;for(;a;){if(o?s.bind(o)(a.value,a.key,this):s(a.value,a.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const s=this,o=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(n){const d={value:n.key,done:!1};return n=n.next,d}else return{value:void 0,done:!0}}};return a}values(){const s=this,o=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(n){const d={value:n.value,done:!1};return n=n.next,d}else return{value:void 0,done:!0}}};return a}entries(){const s=this,o=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(n){const d={value:[n.key,n.value],done:!1};return n=n.next,d}else return{value:void 0,done:!0}}};return a}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this._head,n=this.size;for(;o&&n>s;)this._map.delete(o.key),o=o.next,n--;this._head=o,this._size=n,o&&(o.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const o=s.next,n=s.previous;if(!o||!n)throw new Error("Invalid list");o.previous=n,n.next=o}s.next=void 0,s.previous=void 0,this._state++}touch(s,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this._head)return;const n=s.next,a=s.previous;s===this._tail?(a.next=void 0,this._tail=a):(n.previous=a,a.next=n),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(o===2){if(s===this._tail)return;const n=s.next,a=s.previous;s===this._head?(n.previous=void 0,this._head=n):(n.previous=a,a.next=n),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((o,n)=>{s.push([n,o])}),s}fromJSON(s){this.clear();for(const[o,n]of s)this.set(o,n)}}e.LinkedMap=l;class f extends l{constructor(s,o=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class p{constructor(s){T.set(this,void 0),rt(this,T,s,"f")}get size(){return He(this,T,"f").size}forEach(s,o){He(this,T,"f").forEach(s,o)}get(s){return He(this,T,"f").get(s)}has(s){return He(this,T,"f").has(s)}entries(){return He(this,T,"f").entries()}keys(){return He(this,T,"f").keys()}values(){return He(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return He(this,T,"f").entries()}}e.ReadonlyMapView=p}),define(me[97],ge([0,1,23,9]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Q){return function(oe,we){for(let Me=0,je=Q.length;Me<je;Me++){const Xe=Q[Me](oe,we);if(Xe)return Xe}return null}}e.or=k,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(Q,oe,we){if(!we||we.length<oe.length)return null;let Me;return Q?Me=R.startsWithIgnoreCase(we,oe):Me=we.indexOf(oe)===0,Me?oe.length>0?[{start:0,end:oe.length}]:[]:null}function T(Q,oe){const we=oe.toLowerCase().indexOf(Q.toLowerCase());return we===-1?null:[{start:we,end:we+Q.length}]}e.matchesContiguousSubString=T;function y(Q,oe){return S(Q.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=y;function S(Q,oe,we,Me){if(we===Q.length)return[];if(Me===oe.length)return null;if(Q[we]===oe[Me]){let je=null;return(je=S(Q,oe,we+1,Me+1))?b({start:Me,end:Me+1},je):null}return S(Q,oe,we,Me+1)}function A(Q){return 97<=Q&&Q<=122}function i(Q){return 65<=Q&&Q<=90}e.isUpper=i;function I(Q){return 48<=Q&&Q<=57}function c(Q){return Q===32||Q===9||Q===10||Q===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Q=>m.add(Q.charCodeAt(0)));function h(Q){return c(Q)||m.has(Q)}function v(Q,oe){return Q===oe||h(Q)&&h(oe)}function _(Q){return A(Q)||i(Q)||I(Q)}function b(Q,oe){return oe.length===0?oe=[Q]:Q.end===oe[0].start?oe[0].start=Q.start:oe.unshift(Q),oe}function P(Q,oe){for(let we=oe;we<Q.length;we++){const Me=Q.charCodeAt(we);if(i(Me)||I(Me)||we>0&&!_(Q.charCodeAt(we-1)))return we}return Q.length}function l(Q,oe,we,Me){if(we===Q.length)return[];if(Me===oe.length)return null;if(Q[we]!==oe[Me].toLowerCase())return null;{let je=null,Xe=Me+1;for(je=l(Q,oe,we+1,Me+1);!je&&(Xe=P(oe,Xe))<oe.length;)je=l(Q,oe,we+1,Xe),Xe++;return je===null?null:b({start:Me,end:Me+1},je)}}function f(Q){let oe=0,we=0,Me=0,je=0,Xe=0;for(let ve=0;ve<Q.length;ve++)Xe=Q.charCodeAt(ve),i(Xe)&&oe++,A(Xe)&&we++,_(Xe)&&Me++,I(Xe)&&je++;const Se=oe/Q.length,tt=we/Q.length,X=Me/Q.length,ee=je/Q.length;return{upperPercent:Se,lowerPercent:tt,alphaPercent:X,numericPercent:ee}}function p(Q){const{upperPercent:oe,lowerPercent:we}=Q;return we===0&&oe>.6}function t(Q){const{upperPercent:oe,lowerPercent:we,alphaPercent:Me,numericPercent:je}=Q;return we>.2&&oe<.8&&Me>.6&&je<.2}function s(Q){let oe=0,we=0,Me=0,je=0;for(let Xe=0;Xe<Q.length;Xe++)Me=Q.charCodeAt(Xe),i(Me)&&oe++,A(Me)&&we++,c(Me)&&je++;return(oe===0||we===0)&&je===0?Q.length<=30:oe<=5}function o(Q,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!s(Q)||oe.length>60)return null;const we=f(oe);if(!t(we)){if(!p(we))return null;oe=oe.toLowerCase()}let Me=null,je=0;for(Q=Q.toLowerCase();je<oe.length&&(Me=l(Q,oe,0,je))===null;)je=P(oe,je+1);return Me}e.matchesCamelCase=o;function n(Q,oe,we=!1){if(!oe||oe.length===0)return null;let Me=null,je=0;for(Q=Q.toLowerCase(),oe=oe.toLowerCase();je<oe.length&&(Me=a(Q,oe,0,je,we))===null;)je=d(oe,je+1);return Me}e.matchesWords=n;function a(Q,oe,we,Me,je){if(we===Q.length)return[];if(Me===oe.length)return null;if(v(Q.charCodeAt(we),oe.charCodeAt(Me))){let Xe=null,Se=Me+1;if(Xe=a(Q,oe,we+1,Me+1,je),!je)for(;!Xe&&(Se=d(oe,Se))<oe.length;)Xe=a(Q,oe,we+1,Se,je),Se++;return Xe===null?null:b({start:Me,end:Me+1},Xe)}else return null}function d(Q,oe){for(let we=oe;we<Q.length;we++)if(h(Q.charCodeAt(we))||we>0&&h(Q.charCodeAt(we-1)))return we;return Q.length}const u=k(e.matchesPrefix,o,T),w=k(e.matchesPrefix,o,y),E=new g.LRUCache(1e4);function r(Q,oe,we=!1){if(typeof Q!="string"||typeof oe!="string")return null;let Me=E.get(Q);Me||(Me=new RegExp(R.convertSimple2RegExpPattern(Q),"i"),E.set(Q,Me));const je=Me.exec(oe);return je?[{start:je.index,end:je.index+je[0].length}]:we?w(Q,oe):u(Q,oe)}e.matchesFuzzy=r;function D(Q,oe){const we=Ve(Q,Q.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return we?U(we):null}e.matchesFuzzy2=D;function L(Q,oe,we,Me,je,Xe){const Se=Math.min(13,Q.length);for(;we<Se;we++){const tt=Ve(Q,oe,we,Me,je,Xe,!1);if(tt)return tt}return[0,Xe]}e.anyScore=L;function U(Q){if(typeof Q=="undefined")return[];const oe=[],we=Q[1];for(let Me=Q.length-1;Me>1;Me--){const je=Q[Me]+we,Xe=oe[oe.length-1];Xe&&Xe.end===je?Xe.end=je+1:oe.push({start:je,end:je+1})}return oe}e.createMatches=U;const j=128;function te(){const Q=[],oe=[];for(let we=0;we<=j;we++)oe[we]=0;for(let we=0;we<=j;we++)Q.push(oe.slice(0));return Q}function K(Q){const oe=[];for(let we=0;we<=Q;we++)oe[we]=0;return oe}const O=K(2*j),x=K(2*j),F=te(),z=te(),M=te(),N=!1;function V(Q,oe,we,Me,je){function Xe(tt,X,ee=" "){for(;tt.length<X;)tt=ee+tt;return tt}let Se=` |   |${Me.split("").map(tt=>Xe(tt,3)).join("|")}
`;for(let tt=0;tt<=we;tt++)tt===0?Se+=" |":Se+=`${oe[tt-1]}|`,Se+=Q[tt].slice(0,je+1).map(X=>Xe(X.toString(),3)).join("|")+`
`;return Se}function $(Q,oe,we,Me){Q=Q.substr(oe),we=we.substr(Me),console.log(V(z,Q,Q.length,we,we.length)),console.log(V(M,Q,Q.length,we,we.length)),console.log(V(F,Q,Q.length,we,we.length))}function G(Q,oe){if(oe<0||oe>=Q.length)return!1;const we=Q.codePointAt(oe);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(we)}}function J(Q,oe){if(oe<0||oe>=Q.length)return!1;switch(Q.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function fe(Q,oe,we){return oe[Q]!==we[Q]}function ye(Q,oe,we,Me,je,Xe,Se=!1){for(;oe<we&&je<Xe;)Q[oe]===Me[je]&&(Se&&(O[oe]=je),oe+=1),je+=1;return oe===we}e.isPatternInWord=ye;var ke;(function(Q){Q[Q.Diag=1]="Diag",Q[Q.Left=2]="Left",Q[Q.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var Re;(function(Q){Q.Default=[-100,0];function oe(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}Q.isDefault=oe})(Re=e.FuzzyScore||(e.FuzzyScore={}));function Ve(Q,oe,we,Me,je,Xe,Se){const tt=Q.length>j?j:Q.length,X=Me.length>j?j:Me.length;if(we>=tt||Xe>=X||tt-we>X-Xe||!ye(oe,we,tt,je,Xe,X,!0))return;Be(tt,X,we,Xe,oe,je);let ee=1,ve=1,Ue=we,Je=Xe;const nt=[!1];for(ee=1,Ue=we;Ue<tt;ee++,Ue++){const le=O[Ue],Pe=x[Ue],Ne=Ue+1<tt?x[Ue+1]:X;for(ve=le-Xe+1,Je=le;Je<Ne;ve++,Je++){let Ye=Number.MIN_SAFE_INTEGER,We=!1;Je<=Pe&&(Ye=Ke(Q,oe,Ue,we,Me,je,Je,X,Xe,F[ee-1][ve-1]===0,nt));let st=0;Ye!==Number.MAX_SAFE_INTEGER&&(We=!0,st=Ye+z[ee-1][ve-1]);const Te=Je>le,De=Te?z[ee][ve-1]+(F[ee][ve-1]>0?-5:0):0,Ie=Je>le+1&&F[ee][ve-1]>0,ne=Ie?z[ee][ve-2]+(F[ee][ve-2]>0?-5:0):0;if(Ie&&(!Te||ne>=De)&&(!We||ne>=st))z[ee][ve]=ne,M[ee][ve]=3,F[ee][ve]=0;else if(Te&&(!We||De>=st))z[ee][ve]=De,M[ee][ve]=2,F[ee][ve]=0;else if(We)z[ee][ve]=st,M[ee][ve]=1,F[ee][ve]=F[ee-1][ve-1]+1;else throw new Error("not possible")}}if(N&&$(Q,we,Me,Xe),!nt[0]&&!Se)return;ee--,ve--;const at=[z[ee][ve],Xe];let pt=0,_t=0;for(;ee>=1;){let le=ve;do{const Pe=M[ee][le];if(Pe===3)le=le-2;else if(Pe===2)le=le-1;else break}while(le>=1);pt>1&&oe[we+ee-1]===je[Xe+ve-1]&&!fe(le+Xe-1,Me,je)&&pt+1>F[ee][le]&&(le=ve),le===ve?pt++:pt=1,_t||(_t=le),ee--,ve=le-1,at.push(ve)}X===tt&&(at[0]+=2);const St=_t-tt;return at[0]-=St,at}e.fuzzyScore=Ve;function Be(Q,oe,we,Me,je,Xe){let Se=Q-1,tt=oe-1;for(;Se>=we&&tt>=Me;)je[Se]===Xe[tt]&&(x[Se]=tt,Se--),tt--}function Ke(Q,oe,we,Me,je,Xe,Se,tt,X,ee,ve){if(oe[we]!==Xe[Se])return Number.MIN_SAFE_INTEGER;let Ue=1,Je=!1;return Se===we-Me?Ue=Q[we]===je[Se]?7:5:fe(Se,je,Xe)&&(Se===0||!fe(Se-1,je,Xe))?(Ue=Q[we]===je[Se]?7:5,Je=!0):G(Xe,Se)&&(Se===0||!G(Xe,Se-1))?Ue=5:(G(Xe,Se-1)||J(Xe,Se-1))&&(Ue=5,Je=!0),Ue>1&&we===Me&&(ve[0]=!0),Je||(Je=fe(Se,je,Xe)||G(Xe,Se-1)||J(Xe,Se-1)),we===Me?Se>X&&(Ue-=Je?3:5):ee?Ue+=Je?2:0:Ue+=Je?0:1,Se+1===tt&&(Ue-=Je?3:5),Ue}function W(Q,oe,we,Me,je,Xe,Se){return re(Q,oe,we,Me,je,Xe,!0,Se)}e.fuzzyScoreGracefulAggressive=W;function Z(Q,oe,we,Me,je,Xe,Se){return re(Q,oe,we,Me,je,Xe,!1,Se)}e.fuzzyScoreGraceful=Z;function re(Q,oe,we,Me,je,Xe,Se,tt){let X=Ve(Q,oe,we,Me,je,Xe,tt);if(X&&!Se)return X;if(Q.length>=3){const ee=Math.min(7,Q.length-1);for(let ve=we+1;ve<ee;ve++){const Ue=ae(Q,ve);if(Ue){const Je=Ve(Ue,Ue.toLowerCase(),we,Me,je,Xe,tt);Je&&(Je[0]-=3,(!X||Je[0]>X[0])&&(X=Je))}}}return X}function ae(Q,oe){if(oe+1>=Q.length)return;const we=Q[oe],Me=Q[oe+1];if(we!==Me)return Q.slice(0,oe)+Me+we+Q.slice(oe+2)}}),define(me[141],ge([0,1,47,97,9]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${C.source}`,"g");function y(v){return v.replace(T,(_,b)=>b?_:`\\${_}`)}e.escapeIcons=y;const S=new RegExp(`\\\\${C.source}`,"g");function A(v){return v.replace(S,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=A;const i=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function I(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(i,(_,b,P,l)=>P?_:b||l||"")}e.stripIcons=I;function c(v){const _=v.indexOf(e.iconStartMarker);return _===-1?{text:v}:m(v,_)}e.parseLabelWithIcons=c;function m(v,_){const b=[];let P="";function l(d){if(d){P+=d;for(const u of d)b.push(t)}}let f=-1,p="",t=0,s,o,n=_;const a=v.length;for(l(v.substr(0,_));n<a;)s=v[n],o=v[n+1],s===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(f=n,l(p),p=e.iconStartMarker,n++):s===")"&&f!==-1?(t+=n-f+1,f=-1,p=""):f!==-1?/^[a-z0-9\-]$/i.test(s)?p+=s:(l(p),f=-1,p=""):l(s),n++;return l(p),{text:P,iconOffsets:b}}function h(v,_,b=!1){const{text:P,iconOffsets:l}=_;if(!l||l.length===0)return(0,R.matchesFuzzy)(v,P,b);const f=(0,k.ltrim)(P," "),p=P.length-f.length,t=(0,R.matchesFuzzy)(v,f,b);if(t)for(const s of t){const o=l[s.start+p]+p;s.start+=o,s.end+=o}return t}e.matchesFuzzyIconAware=h}),define(me[98],ge([0,1,16,141]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(m="",h=!1){if(this.value=m,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1)}appendText(m,h=0){return this.value+=A(this.supportThemeIcons?(0,R.escapeIcons)(m):m).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,h){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=C;function T(c){return y(c)?!c.value:Array.isArray(c)?c.every(T):!0}e.isEmptyMarkdownString=T;function y(c){return c instanceof C?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function S(c,m){return c===m?!0:!c||!m?!1:c.value===m.value&&c.isTrusted===m.isTrusted&&c.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=S;function A(c){return c.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function i(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function I(c){const m=[],h=c.split("|").map(_=>_.trim());c=h[0];const v=h[1];if(v){const _=/height=(\d+)/.exec(v),b=/width=(\d+)/.exec(v),P=_?_[1]:"",l=b?b[1]:"",f=isFinite(parseInt(l)),p=isFinite(parseInt(P));f&&m.push(`width="${l}"`),p&&m.push(`height="${P}"`)}return{href:c,dimensions:m}}e.parseHrefAndDimensions=I}),define(me[59],ge([0,1,25,9,2]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(i){return JSON.stringify(i,S)}e.stringify=C;function T(i){let I=JSON.parse(i);return I=A(I),I}e.parse=T;var y;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(y=e.MarshalledId||(e.MarshalledId={}));function S(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,R.regExpFlags)(I)}:I}function A(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return k.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof g.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let c=0;c<i.length;++c)i[c]=A(i[c],I+1);else for(const c in i)Object.hasOwnProperty.call(i,c)&&(i[c]=A(i[c],I+1))}return i}e.revive=A}),define(me[10],ge([0,1,11,2]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.userData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,A,i){this._hosts[S]=A,this._ports[S]=i}setConnectionToken(S,A){this._connectionTokens[S]=A}rewrite(S){if(this._delegate)return this._delegate(S);const A=S.authority;let i=this._hosts[A];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[A],c=this._connectionTokens[A];let m=`path=${encodeURIComponent(S.path)}`;return typeof c=="string"&&(m+=`&tkn=${encodeURIComponent(c)}`),R.URI.from({scheme:g.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new C;class T{asBrowserUri(S,A){const i=this.toUri(S,A);return i.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===k.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${k.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?i.with({scheme:k.vscodeFileResource,authority:i.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(S,A){const i=this.toUri(S,A);return i.scheme===k.vscodeFileResource?i.with({scheme:k.file,authority:i.authority!==T.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,A){return R.URI.isUri(S)?S:R.URI.parse(A.toUrl(S))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(me[77],ge([0,1,23]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new g.LRUCache(1e4);function k(A){return S(A,"NFC",R)}e.normalizeNFC=k;const C=new g.LRUCache(1e4);function T(A){return S(A,"NFD",C)}e.normalizeNFD=T;const y=/[^\u0000-\u0080]/;function S(A,i,I){if(!A)return A;const c=I.get(A);if(c)return c;let m;return y.test(A)?m=A.normalize(i):m=A,I.set(A,m),m}e.removeAccents=function(){const A=/[\u0300-\u036f]/g;return function(i){return T(i).replace(A,"")}}()}),define(me[24],ge([0,1,29,10,8,11,9,2]),function(Y,e,g,R,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(m){return(0,y.uriToFsPath)(m,!0)}e.originalFSPath=S;class A{constructor(h){this._ignorePathCasing=h}compare(h,v,_=!1){return h===v?0:(0,T.compare)(this.getComparisonKey(h,_),this.getComparisonKey(v,_))}isEqual(h,v,_=!1){return h===v?!0:!h||!v?!1:this.getComparisonKey(h,_)===this.getComparisonKey(v,_)}getComparisonKey(h,v=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,v,_=!1){if(h.scheme===v.scheme){if(h.scheme===R.Schemas.file)return g.isEqualOrParent(S(h),S(v),this._ignorePathCasing(h))&&h.query===v.query&&(_||h.fragment===v.fragment);if((0,e.isEqualAuthority)(h.authority,v.authority))return g.isEqualOrParent(h.path,v.path,this._ignorePathCasing(h),"/")&&h.query===v.query&&(_||h.fragment===v.fragment)}return!1}joinPath(h,...v){return y.URI.joinPath(h,...v)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){const v=k.posix.extname(h.path),_=v.indexOf("?");return _!==-1?v.substr(0,_):v}dirname(h){if(h.path.length===0)return h;let v;return h.scheme===R.Schemas.file?v=y.URI.file(k.dirname(S(h))).path:(v=k.posix.dirname(h.path),h.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),v="/")),h.with({path:v})}normalizePath(h){if(!h.path.length)return h;let v;return h.scheme===R.Schemas.file?v=y.URI.file(k.normalize(S(h))).path:v=k.posix.normalize(h.path),h.with({path:v})}relativePath(h,v){if(h.scheme!==v.scheme||!(0,e.isEqualAuthority)(h.authority,v.authority))return;if(h.scheme===R.Schemas.file){const P=k.relative(S(h),S(v));return C.isWindows?g.toSlashes(P):P}let _=h.path||"/",b=v.path||"/";if(this._ignorePathCasing(h)){let P=0;for(const l=Math.min(_.length,b.length);P<l&&!(_.charCodeAt(P)!==b.charCodeAt(P)&&_.charAt(P).toLowerCase()!==b.charAt(P).toLowerCase());P++);_=b.substr(0,P)+_.substr(P)}return k.posix.relative(_,b)}resolvePath(h,v){if(h.scheme===R.Schemas.file){const _=y.URI.file(k.resolve(S(h),v));return h.with({authority:_.authority,path:_.path})}return v=g.toPosixPath(v),h.with({path:k.posix.resolve(h.path,v)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,v){return h===v||(0,T.equalsIgnoreCase)(h,v)}hasTrailingPathSeparator(h,v=k.sep){if(h.scheme===R.Schemas.file){const _=S(h);return _.length>g.getRoot(_).length&&_[_.length-1]===v}else{const _=h.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,v=k.sep){return(0,e.hasTrailingPathSeparator)(h,v)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,v=k.sep){let _=!1;if(h.scheme===R.Schemas.file){const b=S(h);_=b!==void 0&&b.length===g.getRoot(b).length&&b[b.length-1]===v}else{v="/";const b=h.path;_=b.length===1&&b.charCodeAt(b.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(h,v)?h.with({path:h.path+"/"}):h}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(m=>m.scheme===R.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new A(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(m,h){const v=[];for(let _=0;_<m.length;_++){const b=h(m[_]);m.some((P,l)=>l===_?!1:(0,e.isEqualOrParent)(b,h(P)))||v.push(m[_])}return v}e.distinctParents=i;var I;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function h(v){const _=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(l=>{const[f,p]=l.split(":");f&&p&&_.set(f,p)});const P=v.path.substring(0,v.path.indexOf(";"));return P&&_.set(m.META_DATA_MIME,P),_}m.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function c(m,h,v){if(h){let _=m.path;return _&&_[0]!==k.posix.sep&&(_=k.posix.sep+_),m.with({scheme:v,authority:h,path:_})}return m.with({scheme:v})}e.toLocalResource=c}),define(me[17],ge([0,1,21,16,3,6,24]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(x){return!!x&&typeof x.then=="function"}e.isThenable=y;function S(x){const F=new g.CancellationTokenSource,z=x(F.token),M=new Promise((N,V)=>{const $=F.token.onCancellationRequested(()=>{$.dispose(),F.dispose(),V((0,R.canceled)())});Promise.resolve(z).then(G=>{$.dispose(),F.dispose(),N(G)},G=>{$.dispose(),F.dispose(),V(G)})});return new class{cancel(){F.cancel()}then(N,V){return M.then(N,V)}catch(N){return this.then(void 0,N)}finally(N){return M.finally(N)}}}e.createCancelablePromise=S;function A(x,F,z){return Promise.race([x,new Promise(M=>F.onCancellationRequested(()=>M(z)))])}e.raceCancellation=A;async function i(x){let F=-1;const z=x.map((N,V)=>N.then($=>(F=V,$))),M=await Promise.race(z);return x.forEach((N,V)=>{V!==F&&N.cancel()}),M}e.raceCancellablePromises=i;function I(x,F,z){let M;const N=setTimeout(()=>{M?.(void 0),z?.()},F);return Promise.race([x.finally(()=>clearTimeout(N)),new Promise(V=>M=V)])}e.raceTimeout=I;function c(x){return new Promise((F,z)=>{const M=x();y(M)?M.then(F,z):F(M)})}e.asPromise=c;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const M=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,M};this.queuedPromise=new Promise(M=>{this.activePromise.then(z,z).then(M)})}return new Promise((z,M)=>{this.queuedPromise.then(z,M)})}return this.activePromise=F(),new Promise((z,M)=>{this.activePromise.then(N=>{this.activePromise=null,z(N)},N=>{this.activePromise=null,M(N)})})}}e.Throttler=m;class h{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=h;class v{constructor(){this.promiseMap=new Map}queue(F,z){const N=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(F)===N&&this.promiseMap.delete(F)});return this.promiseMap.set(F,N),N}}e.SequencerByKey=v;class _{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,z=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,N)=>{this.doResolve=M,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=_;class b{constructor(F){this.delayer=new _(F),this.throttler=new m}trigger(F,z){return this.delayer.trigger(()=>this.throttler.queue(F),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class P{constructor(){this._isOpen=!1,this._promise=new Promise((F,z)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=P;class l extends P{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function f(x,F){return F?new Promise((z,M)=>{const N=setTimeout(()=>{V.dispose(),z()},x),V=F.onCancellationRequested(()=>{clearTimeout(N),V.dispose(),M((0,R.canceled)())})}):S(z=>f(x,z))}e.timeout=f;function p(x,F=0){const z=setTimeout(x,F);return(0,C.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=p;function t(x){const F=[];let z=0;const M=x.length;function N(){return z<M?x[z++]():null}function V($){$!=null&&F.push($);const G=N();return G?G.then(V):Promise.resolve(F)}return Promise.resolve(null).then(V)}e.sequence=t;function s(x,F=M=>!!M,z=null){let M=0;const N=x.length,V=()=>{if(M>=N)return Promise.resolve(z);const $=x[M++];return Promise.resolve($()).then(J=>F(J)?Promise.resolve(J):V())};return V()}e.first=s;function o(x,F=M=>!!M,z=null){if(x.length===0)return Promise.resolve(z);let M=x.length;const N=()=>{M=-1;for(const V of x)V.cancel?.()};return new Promise((V,$)=>{for(const G of x)G.then(J=>{--M>=0&&F(J)?(N(),V(J)):M===0&&V(z)}).catch(J=>{--M>=0&&(N(),$(J))})})}e.firstParallel=o;class n{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((z,M)=>{this.outstandingPromises.push({factory:F,c:z,e:M}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const z=F.factory();z.then(F.c,F.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class a extends n{constructor(){super(1)}}e.Queue=a;class d{constructor(){this.queues=new Map}queueFor(F,z=T.extUri){const M=z.getComparisonKey(F);let N=this.queues.get(M);return N||(N=new a,k.Event.once(N.onFinished)(()=>{N?.dispose(),this.queues.delete(M)}),this.queues.set(M,N)),N}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=d;class u{constructor(F,z){this._token=-1,typeof F=="function"&&typeof z=="number"&&this.setIfNotSet(F,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},z)}setIfNotSet(F,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},z))}}e.TimeoutTimer=u;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,z){this.cancel(),this._token=setInterval(()=>{F()},z)}}e.IntervalTimer=w;class E{constructor(F,z){this.timeoutToken=-1,this.runner=F,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class r extends E{constructor(F,z){super(F,z);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=r;class D extends C.Disposable{constructor(F,z,M,N){super();this.maxWorkChunkSize=F,this.maxPendingWork=z,this.throttleDelay=M,this.handler=N,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=D,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const z=setTimeout(()=>F(x));let M=!1;return{dispose(){M||(M=!0,clearTimeout(z))}}}}else e.runWhenIdle=(x,F)=>{const z=requestIdleCallback(x,typeof F=="number"?{timeout:F}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(z))}}}}();class L{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function U(x,F,z){let M;for(let N=0;N<z;N++)try{return await x()}catch(V){M=V,await f(F)}throw M}e.retry=U;class j{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,z,M){return this._pending={taskId:F,cancel:()=>M?.(),promise:z},z.then(()=>this.donePending(F),()=>this.donePending(F)),z}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let z,M;const N=new Promise((V,$)=>{z=V,M=$});this._next={run:F,promise:N,promiseResolve:z,promiseReject:M}}return this._next.promise}}e.TaskSequentializer=j;class te{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=te;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,z)=>{this.completeCallback=F,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(z=>{this.completeCallback(F),this.resolved=!0,z()})}error(F){return new Promise(z=>{this.errorCallback(F),this.rejected=!0,z()})}cancel(){new Promise(F=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=K;var O;(function(x){async function F(z){let M;const N=await Promise.all(z.map(V=>V.then($=>$,$=>{M||(M=$)})));if(typeof M!="undefined")throw M;return N}x.settled=F})(O=e.Promises||(e.Promises={}))}),define(me[99],ge([0,1,17,8]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new g.IdleValue(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),C=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function y(E,r,D=!1){const L=E||"",U=r||"",j=k.value.collator.compare(L,U);return k.value.collatorIsNumeric&&j===0&&L!==U?L<U?-1:1:j}e.compareFileNames=y;function S(E,r){const D=C.value.collator;return E=E||"",r=r||"",p(D,E,r)}e.compareFileNamesDefault=S;function A(E,r){const D=C.value.collator;return E=E||"",r=r||"",n(E,r)||p(D,E,r)}e.compareFileNamesUpper=A;function i(E,r){const D=C.value.collator;return E=E||"",r=r||"",o(E,r)||p(D,E,r)}e.compareFileNamesLower=i;function I(E,r){return E=E||"",r=r||"",E===r?0:E<r?-1:1}e.compareFileNamesUnicode=I;function c(E,r,D=!1){D||(E=E&&E.toLowerCase(),r=r&&r.toLowerCase());const[L,U]=l(E),[j,te]=l(r);return L!==j?L<j?-1:1:U===te?0:U<te?-1:1}e.noIntlCompareFileNames=c;function m(E,r){const[D,L]=l(E),[U,j]=l(r);let te=k.value.collator.compare(L,j);if(te===0){if(k.value.collatorIsNumeric&&L!==j)return L<j?-1:1;if(te=k.value.collator.compare(D,U),k.value.collatorIsNumeric&&te===0&&D!==U)return D<U?-1:1}return te}e.compareFileExtensions=m;function h(E,r){E=E||"",r=r||"";const D=f(E),L=f(r),U=C.value.collator,j=T.value.collator;return p(j,D,L)||p(U,E,r)}e.compareFileExtensionsDefault=h;function v(E,r){E=E||"",r=r||"";const D=f(E),L=f(r),U=C.value.collator,j=T.value.collator;return p(j,D,L)||n(E,r)||p(U,E,r)}e.compareFileExtensionsUpper=v;function _(E,r){E=E||"",r=r||"";const D=f(E),L=f(r),U=C.value.collator,j=T.value.collator;return p(j,D,L)||o(E,r)||p(U,E,r)}e.compareFileExtensionsLower=_;function b(E,r){E=E||"",r=r||"";const D=f(E).toLowerCase(),L=f(r).toLowerCase();return D!==L?D<L?-1:1:E!==r?E<r?-1:1:0}e.compareFileExtensionsUnicode=b;const P=/^(.*?)(\.([^.]*))?$/;function l(E,r=!1){const D=E?P.exec(E):[];let L=[D&&D[1]||"",D&&D[3]||""];return r&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function f(E){const r=E?P.exec(E):[];return r&&r[1]&&r[1].charAt(0)!=="."&&r[3]||""}function p(E,r,D){let L=E.compare(r,D);return L!==0?L:r.length!==D.length?r.length<D.length?-1:1:0}function t(E){const r=E.charAt(0);return r.toLocaleUpperCase()!==r}function s(E){const r=E.charAt(0);return r.toLocaleLowerCase()!==r}function o(E,r){return t(E)&&s(r)?-1:s(E)&&t(r)?1:0}function n(E,r){return s(E)&&t(r)?-1:t(E)&&s(r)?1:0}function a(E,r,D=!1){return D||(E=E&&E.toLowerCase(),r=r&&r.toLowerCase()),E===r?0:E<r?-1:1}function d(E,r,D=!1){const L=E.split(R.sep),U=r.split(R.sep),j=L.length-1,te=U.length-1;let K,O;for(let x=0;;x++){if(K=j===x,O=te===x,K&&O)return y(L[x],U[x],D);if(K)return-1;if(O)return 1;const F=a(L[x],U[x],D);if(F!==0)return F}}e.comparePaths=d;function u(E,r,D){const L=E.toLowerCase(),U=r.toLowerCase(),j=w(E,r,D);if(j)return j;const te=L.endsWith(D),K=U.endsWith(D);if(te!==K)return te?-1:1;const O=y(L,U);return O!==0?O:L.localeCompare(U)}e.compareAnything=u;function w(E,r,D){const L=E.toLowerCase(),U=r.toLowerCase(),j=L.startsWith(D),te=U.startsWith(D);if(j!==te)return j?-1:1;if(j&&te){if(L.length<U.length)return-1;if(L.length>U.length)return 1}return 0}e.compareByPrefix=w}),define(me[100],ge([0,1,99,97,8,11,9]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,S=[y,[]];function A(K,O,x,F){if(!K||!O)return S;const z=K.length,M=O.length;if(z<M)return S;const N=K.toLowerCase();return!F&&!N.includes(x)?S:i(O,x,M,K,N,z)}e.scoreFuzzy=A;function i(K,O,x,F,z,M){const N=[],V=[];for(let fe=0;fe<x;fe++){const ye=fe*M,ke=ye-M,Re=fe>0,Ve=K[fe],Be=O[fe];for(let Ke=0;Ke<M;Ke++){const W=Ke>0,Z=ye+Ke,re=Z-1,ae=ke+Ke-1,Q=W?N[re]:0,oe=Re&&W?N[ae]:0,we=Re&&W?V[ae]:0;let Me;!oe&&Re?Me=0:Me=I(Ve,Be,F,z,Ke,we),Me&&oe+Me>=Q?(V[Z]=we+1,N[Z]=oe+Me):(V[Z]=y,N[Z]=Q)}}const $=[];let G=x-1,J=M-1;for(;G>=0&&J>=0;){const fe=G*M+J;V[fe]===y||($.push(J),G--),J--}return[N[x*M-1],$.reverse()]}function I(K,O,x,F,z,M){let N=0;if(!c(O,F[z]))return N;if(N+=1,M>0&&(N+=M*5),K===x[z]&&(N+=1),z===0)N+=8;else{const V=m(x.charCodeAt(z-1));V?N+=V:(0,R.isUpper)(x.charCodeAt(z))&&(N+=2)}return N}function c(K,O){return K===O?!0:K==="/"||K==="\\"?O==="/"||O==="\\":!1}function m(K){switch(K){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function v(K,O,x=0,F=0){const z=O;return z.values&&z.values.length>1?_(K,z.values,x,F):b(K,O,x,F)}e.scoreFuzzy2=v;function _(K,O,x,F){let z=0;const M=[];for(const N of O){const[V,$]=b(K,N,x,F);if(typeof V!="number")return h;z+=V,M.push(...$)}return[z,d(M)]}function b(K,O,x,F){const z=(0,R.fuzzyScore)(O.original,O.originalLowercase,x,K,K.toLowerCase(),F,!0);return z?[z[0],(0,R.createMatches)(z)]:h}const P=Object.freeze({score:0}),l=1<<18,f=1<<17,p=1<<16;function t(K,O,x,F,z){if(!K||!O.normalized)return P;const M=F.getItemLabel(K);if(!M)return P;const N=F.getItemDescription(K);let V;N?V=`${M}${N}${O.normalized}${Array.isArray(O.values)?O.values.length:""}${x}`:V=`${M}${O.normalized}${Array.isArray(O.values)?O.values.length:""}${x}`;const $=z[V];if($)return $;const G=s(M,N,F.getItemPath(K),O,x);return z[V]=G,G}e.scoreItemFuzzy=t;function s(K,O,x,F,z){const M=!x||!F.containsPathSeparator;return x&&(C.isLinux?F.pathNormalized===x:(0,T.equalsIgnoreCase)(F.pathNormalized,x))?{score:l,labelMatch:[{start:0,end:K.length}],descriptionMatch:O?[{start:0,end:O.length}]:void 0}:F.values&&F.values.length>1?o(K,O,x,F.values,M,z):n(K,O,x,F,M,z)}function o(K,O,x,F,z,M){let N=0;const V=[],$=[];for(const G of F){const{score:J,labelMatch:fe,descriptionMatch:ye}=n(K,O,x,G,z,M);if(J===y)return P;N+=J,fe&&V.push(...fe),ye&&$.push(...ye)}return{score:N,labelMatch:d(V),descriptionMatch:d($)}}function n(K,O,x,F,z,M){if(z||!O){const[N,V]=A(K,F.normalized,F.normalizedLowercase,M);if(N){const $=(0,R.matchesPrefix)(F.normalized,K);let G;return $?(G=f,G+=Math.round(F.normalized.length/K.length*100)):G=p,{score:G+N,labelMatch:$||a(V)}}}if(O){let N=O;x&&(N=`${O}${k.sep}`);const V=N.length,$=`${N}${K}`,[G,J]=A($,F.normalized,F.normalizedLowercase,M);if(G){const fe=a(J),ye=[],ke=[];return fe.forEach(Re=>{Re.start<V&&Re.end>V?(ye.push({start:0,end:Re.end-V}),ke.push({start:Re.start,end:V})):Re.start>=V?ye.push({start:Re.start-V,end:Re.end-V}):ke.push(Re)}),{score:G,labelMatch:ye,descriptionMatch:ke}}}return P}function a(K){const O=[];if(!K)return O;let x;for(const F of K)x&&x.end===F?x.end+=1:(x={start:F,end:F+1},O.push(x));return O}function d(K){const O=K.sort((z,M)=>z.start-M.start),x=[];let F;for(const z of O)!F||!u(F,z)?(F=z,x.push(z)):(F.start=Math.min(F.start,z.start),F.end=Math.max(F.end,z.end));return x}function u(K,O){return!(K.end<O.start||O.end<K.start)}function w(K,O,x,F,z,M){const N=t(K,x,F,z,M),V=t(O,x,F,z,M),$=N.score,G=V.score;if(($===l||G===l)&&$!==G)return $===l?-1:1;if($>p||G>p){if($!==G)return $>G?-1:1;if($<f&&G<f){const Be=r(N.labelMatch,V.labelMatch);if(Be!==0)return Be}const Re=z.getItemLabel(K)||"",Ve=z.getItemLabel(O)||"";if(Re.length!==Ve.length)return Re.length-Ve.length}if($!==G)return $>G?-1:1;const J=Array.isArray(N.labelMatch)&&N.labelMatch.length>0,fe=Array.isArray(V.labelMatch)&&V.labelMatch.length>0;if(J&&!fe)return-1;if(fe&&!J)return 1;const ye=E(K,N,z),ke=E(O,V,z);return ye&&ke&&ye!==ke?ke>ye?-1:1:D(K,O,x,z)}e.compareItemsByFuzzyScore=w;function E(K,O,x){let F=-1,z=-1;if(O.descriptionMatch&&O.descriptionMatch.length?F=O.descriptionMatch[0].start:O.labelMatch&&O.labelMatch.length&&(F=O.labelMatch[0].start),O.labelMatch&&O.labelMatch.length){if(z=O.labelMatch[O.labelMatch.length-1].end,O.descriptionMatch&&O.descriptionMatch.length){const M=x.getItemDescription(K);M&&(z+=M.length)}}else O.descriptionMatch&&O.descriptionMatch.length&&(z=O.descriptionMatch[O.descriptionMatch.length-1].end);return z-F}function r(K,O){if(!K&&!O||(!K||!K.length)&&(!O||!O.length))return 0;if(!O||!O.length)return-1;if(!K||!K.length)return 1;const x=K[0].start,z=K[K.length-1].end-x,M=O[0].start,V=O[O.length-1].end-M;return z===V?0:V<z?1:-1}function D(K,O,x,F){const z=F.getItemLabel(K)||"",M=F.getItemLabel(O)||"",N=F.getItemDescription(K),V=F.getItemDescription(O),$=z.length+(N?N.length:0),G=M.length+(V?V.length:0);if($!==G)return $-G;const J=F.getItemPath(K),fe=F.getItemPath(O);return J&&fe&&J.length!==fe.length?J.length-fe.length:z!==M?(0,g.compareAnything)(z,M,x.normalized):N&&V&&N!==V?(0,g.compareAnything)(N,V,x.normalized):J&&fe&&J!==fe?(0,g.compareAnything)(J,fe,x.normalized):0}const L=" ";function U(K){typeof K!="string"&&(K="");const O=K.toLowerCase(),{pathNormalized:x,normalized:F,normalizedLowercase:z}=j(K),M=x.indexOf(k.sep)>=0;let N;const V=K.split(L);if(V.length>1)for(const $ of V){const{pathNormalized:G,normalized:J,normalizedLowercase:fe}=j($);J&&(N||(N=[]),N.push({original:$,originalLowercase:$.toLowerCase(),pathNormalized:G,normalized:J,normalizedLowercase:fe}))}return{original:K,originalLowercase:O,pathNormalized:x,normalized:F,normalizedLowercase:z,values:N,containsPathSeparator:M}}e.prepareQuery=U;function j(K){let O;C.isWindows?O=K.replace(/\//g,k.sep):O=K.replace(/\\/g,k.sep);const x=(0,T.stripWildcards)(O).replace(/\s/g,"");return{pathNormalized:O,normalized:x,normalizedLowercase:x.toLowerCase()}}function te(K){return Array.isArray(K)?U(K.map(O=>O.original).join(L)):U(K.original)}e.pieceToQuery=te}),define(me[30],ge([0,1,17,29,23,8,9]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y;const S="**",A="/",i="[/\\\\]",I="[^/\\\\]",c=/\//g;function m(N){switch(N){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function h(N,V){if(!N)return[];const $=[];let G=!1,J=!1,fe="";for(const ye of N){switch(ye){case V:if(!G&&!J){$.push(fe),fe="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":J=!0;break;case"]":J=!1;break}fe+=ye}return fe&&$.push(fe),$}e.splitGlobAware=h;function v(N){if(!N)return"";let V="";const $=h(N,A);if($.every(G=>G===S))V=".*";else{let G=!1;$.forEach((J,fe)=>{if(J===S){G||(V+=m(2),G=!0);return}let ye=!1,ke="",Re=!1,Ve="";for(const Be of J){if(Be!=="}"&&ye){ke+=Be;continue}if(Re&&(Be!=="]"||!Ve)){let Ke;Be==="-"?Ke=Be:(Be==="^"||Be==="!")&&!Ve?Ke="^":Be===A?Ke="":Ke=T.escapeRegExpCharacters(Be),Ve+=Ke;continue}switch(Be){case"{":ye=!0;continue;case"[":Re=!0;continue;case"}":V+=`(?:${h(ke,",").map(Z=>v(Z)).join("|")})`,ye=!1,ke="";break;case"]":V+="["+Ve+"]",Re=!1,Ve="";break;case"?":V+=I;continue;case"*":V+=m(1);continue;default:V+=T.escapeRegExpCharacters(Be)}}fe<$.length-1&&($[fe+1]!==S||fe+2<$.length)&&(V+=i),G=!1})}return V}const _=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),s=function(){return!1},o=function(){return null};function n(N,V){if(!N)return o;let $;typeof N!="string"?$=N.pattern:$=N,$=$.trim();const G=`${$}_${!!V.trimForExclusions}`;let J=t.get(G);if(J)return a(J,N);let fe;if(_.test($)){const ye=$.substr(4);J=function(ke,Re){return typeof ke=="string"&&ke.endsWith(ye)?$:null}}else(fe=b.exec(d($,V)))?J=u(fe[1],$):(V.trimForExclusions?l:P).test($)?J=w($,V):(fe=f.exec(d($,V)))?J=E(fe[1].substr(1),$,!0):(fe=p.exec(d($,V)))?J=E(fe[1],$,!1):J=r($);return t.set(G,J),a(J,N)}function a(N,V){return typeof V=="string"?N:function($,G){return R.isEqualOrParent($,V.base)?N(C.relative(V.base,$),G):null}}function d(N,V){return V.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function u(N,V){const $=`/${N}`,G=`\\${N}`,J=function(ye,ke){return typeof ye!="string"?null:ke?ke===N?V:null:ye===N||ye.endsWith($)||ye.endsWith(G)?V:null},fe=[N];return J.basenames=fe,J.patterns=[V],J.allBasenames=fe,J}function w(N,V){const $=M(N.slice(1,-1).split(",").map(ke=>n(ke,V)).filter(ke=>ke!==o),N),G=$.length;if(!G)return o;if(G===1)return $[0];const J=function(ke,Re){for(let Ve=0,Be=$.length;Ve<Be;Ve++)if($[Ve](ke,Re))return N;return null},fe=$.find(ke=>!!ke.allBasenames);fe&&(J.allBasenames=fe.allBasenames);const ye=$.reduce((ke,Re)=>Re.allPaths?ke.concat(Re.allPaths):ke,[]);return ye.length&&(J.allPaths=ye),J}function E(N,V,$){const G=C.sep===C.posix.sep,J=G?N:N.replace(c,C.sep),fe=C.sep+J,ye=C.posix.sep+N,ke=$?function(Re,Ve){return typeof Re=="string"&&(Re===J||Re.endsWith(fe)||!G&&(Re===N||Re.endsWith(ye)))?V:null}:function(Re,Ve){return typeof Re=="string"&&(Re===J||!G&&Re===N)?V:null};return ke.allPaths=[($?"*/":"./")+N],ke}function r(N){try{const V=new RegExp(`^${v(N)}$`);return function($){return V.lastIndex=0,typeof $=="string"&&V.test($)?N:null}}catch(V){return o}}function D(N,V,$){return!N||typeof V!="string"?!1:L(N)(V,void 0,$)}e.match=D;function L(N,V={}){if(!N)return s;if(typeof N=="string"||K(N)){const $=n(N,V);if($===o)return s;const G=function(J,fe){return!!$(J,fe)};return $.allBasenames&&(G.allBasenames=$.allBasenames),$.allPaths&&(G.allPaths=$.allPaths),G}return F(N,V)}e.parse=L;function U(N){if(!N)return;let V;return $=>(V||(V=(N()||Promise.resolve([])).then(G=>G?te(G):{})),V.then(G=>!!G[$]))}e.hasSiblingPromiseFn=U;function j(N){if(!N)return;let V;return $=>{if(!V){const G=N();V=G?te(G):{}}return!!V[$]}}e.hasSiblingFn=j;function te(N){const V={};for(const $ of N)V[$]=!0;return V}function K(N){const V=N;return V&&typeof V.base=="string"&&typeof V.pattern=="string"}e.isRelativePattern=K;function O(N){return N.allBasenames||[]}e.getBasenameTerms=O;function x(N){return N.allPaths||[]}e.getPathTerms=x;function F(N,V){const $=M(Object.getOwnPropertyNames(N).map(ke=>z(ke,N[ke],V)).filter(ke=>ke!==o)),G=$.length;if(!G)return o;if(!$.some(ke=>!!ke.requiresSiblings)){if(G===1)return $[0];const ke=function(Be,Ke){for(let W=0,Z=$.length;W<Z;W++){const re=$[W](Be,Ke);if(re)return re}return null},Re=$.find(Be=>!!Be.allBasenames);Re&&(ke.allBasenames=Re.allBasenames);const Ve=$.reduce((Be,Ke)=>Ke.allPaths?Be.concat(Ke.allPaths):Be,[]);return Ve.length&&(ke.allPaths=Ve),ke}const J=function(ke,Re,Ve){let Be;for(let Ke=0,W=$.length;Ke<W;Ke++){const Z=$[Ke];Z.requiresSiblings&&Ve&&(Re||(Re=C.basename(ke)),Be||(Be=Re.substr(0,Re.length-C.extname(ke).length)));const re=Z(ke,Re,Be,Ve);if(re)return re}return null},fe=$.find(ke=>!!ke.allBasenames);fe&&(J.allBasenames=fe.allBasenames);const ye=$.reduce((ke,Re)=>Re.allPaths?ke.concat(Re.allPaths):ke,[]);return ye.length&&(J.allPaths=ye),J}function z(N,V,$){if(V===!1)return o;const G=n(N,$);if(G===o)return o;if(typeof V=="boolean")return G;if(V){const J=V.when;if(typeof J=="string"){const fe=(ye,ke,Re,Ve)=>{if(!Ve||!G(ye,ke))return null;const Be=J.replace("$(basename)",Re),Ke=Ve(Be);return(0,g.isThenable)(Ke)?Ke.then(W=>W?N:null):Ke?N:null};return fe.requiresSiblings=!0,fe}}return G}function M(N,V){const $=N.filter(ke=>!!ke.basenames);if($.length<2)return N;const G=$.reduce((ke,Re)=>{const Ve=Re.basenames;return Ve?ke.concat(Ve):ke},[]);let J;if(V){J=[];for(let ke=0,Re=G.length;ke<Re;ke++)J.push(V)}else J=$.reduce((ke,Re)=>{const Ve=Re.patterns;return Ve?ke.concat(Ve):ke},[]);const fe=function(ke,Re){if(typeof ke!="string")return null;if(!Re){let Be;for(Be=ke.length;Be>0;Be--){const Ke=ke.charCodeAt(Be-1);if(Ke===47||Ke===92)break}Re=ke.substr(Be)}const Ve=G.indexOf(Re);return Ve!==-1?J[Ve]:null};fe.basenames=G,fe.patterns=J,fe.allBasenames=G;const ye=N.filter(ke=>!ke.basenames);return ye.push(fe),ye}}),define(me[78],ge([0,1,29,10,8,11,24,9,2]),function(Y,e,g,R,k,C,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(n,a,d){if(typeof n=="string"&&(n=S.URI.file(n)),d){const w=d.getWorkspaceFolder(n);if(w){const E=d.getWorkspace().folders.length>1;let r;if((0,T.isEqual)(w.uri,n)?r="":r=(0,T.relativePath)(w.uri,n),E){const D=w.name?w.name:(0,T.basename)(w.uri);r=r?D+" \u2022 "+r:D}return r}}if(n.scheme!==R.Schemas.file&&n.scheme!==R.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(n.fsPath))return(0,k.normalize)(I(n.fsPath));let u=(0,k.normalize)(n.fsPath);return!C.isWindows&&a?.userHome&&(u=m(u,a.userHome.fsPath)),u}e.getPathLabel=A;function i(n){if(!n)return;typeof n=="string"&&(n=S.URI.file(n));const a=(0,T.basename)(n)||(n.scheme===R.Schemas.file?n.fsPath:n.path);return C.isWindows&&(0,g.isRootOrDriveLetter)(a)?I(a):a}e.getBaseLabel=i;function I(n){return(0,g.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=I;let c=Object.create(null);function m(n,a){if(C.isWindows||!n||!a)return n;let d=c.original===a?c.normalized:void 0;return d||(d=`${(0,y.rtrim)(a,k.posix.sep)}${k.posix.sep}`,c={original:a,normalized:d}),(C.isLinux?n.startsWith(d):(0,y.startsWithIgnoreCase)(n,d))&&(n=`~/${n.substr(d.length)}`),n}e.tildify=m;function h(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=h;const v="\u2026",_="\\\\",b="~";function P(n,a=k.sep){const d=new Array(n.length);let u=!1;for(let w=0;w<n.length;w++){let E=n[w];if(E===""){d[w]=`.${a}`;continue}if(!E){d[w]=E;continue}u=!0;let r="";E.indexOf(_)===0?(r=E.substr(0,E.indexOf(_)+_.length),E=E.substr(E.indexOf(_)+_.length)):E.indexOf(a)===0?(r=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(b)===0&&(r=E.substr(0,E.indexOf(b)+b.length),E=E.substr(E.indexOf(b)+b.length));const D=E.split(a);for(let L=1;u&&L<=D.length;L++)for(let U=D.length-L;u&&U>=0;U--){u=!1;let j=D.slice(U,U+L).join(a);for(let te=0;!u&&te<n.length;te++)if(te!==w&&n[te]&&n[te].indexOf(j)>-1){const K=U+L===D.length,O=U>0&&n[te].indexOf(a)>-1?a+j:j,x=n[te].endsWith(O);u=!K||x}if(!u){let te="";(D[0].endsWith(":")||r!=="")&&(U===1&&(U=0,L++,j=D[0]+a+j),U>0&&(te=D[0]+a),te=r+te),U>0&&(te=te+v+a),te=te+j,U+L<D.length&&(te=te+a+v),d[w]=te}}u&&(d[w]=E)}return d}e.shorten=P;var l;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function f(n,a=Object.create(null)){const d=[];let u=!1,w="";for(const E of n)if(E==="$"||u&&E==="{")w&&d.push({value:w,type:l.TEXT}),w="",u=!0;else if(E==="}"&&u){const r=a[w];if(typeof r=="string")r.length&&d.push({value:r,type:l.VARIABLE});else if(r){const D=d[d.length-1];(!D||D.type!==l.SEPARATOR)&&d.push({value:r.label,type:l.SEPARATOR})}w="",u=!1}else w+=E;return w&&!u&&d.push({value:w,type:l.TEXT}),d.filter((E,r)=>{if(E.type===l.SEPARATOR){const D=d[r-1],L=d[r+1];return[D,L].every(U=>U&&(U.type===l.VARIABLE||U.type===l.TEXT)&&U.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=f;function p(n,a){return C.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):n.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(n,a){return C.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):C.isWindows?n.replace(/&&|&/g,d=>d==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=s;function o(n){const a=n.indexOf("/")!==-1?k.posix:k.win32,d=a.basename(n),u=a.dirname(n);return d.length?{name:d,parentPath:u}:{name:u,parentPath:""}}e.splitName=o}),define(me[101],ge([0,1,30,10,8,24,9]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var y;(function(n){n.text="text/plain",n.binary="application/octet-stream",n.unknown="application/unknown",n.markdown="text/markdown"})(y=e.Mimes||(e.Mimes={}));let S=[],A=[],i=[];function I(n,a=!1){const d=c(n);S.push(d),d.userConfigured?i.push(d):A.push(d),a&&!d.userConfigured&&S.forEach(u=>{u.mime===d.mime||u.userConfigured||(d.extension&&u.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&u.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&u.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&u.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=I;function c(n){return{id:n.id,mime:n.mime,filename:n.filename,extension:n.extension,filepattern:n.filepattern,firstline:n.firstline,userConfigured:n.userConfigured,filenameLowercase:n.filename?n.filename.toLowerCase():void 0,extensionLowercase:n.extension?n.extension.toLowerCase():void 0,filepatternLowercase:n.filepattern?n.filepattern.toLowerCase():void 0,filepatternOnPath:n.filepattern?n.filepattern.indexOf(k.posix.sep)>=0:!1}}function m(n){n?(S=S.filter(a=>!a.userConfigured),i=[]):(S=[],A=[],i=[])}e.clearTextMimes=m;function h(n,a){let d;if(n)switch(n.scheme){case R.Schemas.file:d=n.fsPath;break;case R.Schemas.data:d=C.DataUri.parseMetaData(n).get(C.DataUri.META_DATA_LABEL);break;default:d=n.path}if(!d)return[y.unknown];d=d.toLowerCase();const u=(0,k.basename)(d),w=v(d,u,i);if(w)return[w,y.text];const E=v(d,u,A);if(E)return[E,y.text];if(a){const r=_(a);if(r)return[r,y.text]}return[y.unknown]}e.guessMimeTypes=h;function v(n,a,d){let u=null,w=null,E=null;for(let r=d.length-1;r>=0;r--){const D=d[r];if(a===D.filenameLowercase){u=D;break}if(D.filepattern&&(!w||D.filepattern.length>w.filepattern.length)){const L=D.filepatternOnPath?n:a;(0,g.match)(D.filepatternLowercase,L)&&(w=D)}D.extension&&(!E||D.extension.length>E.extension.length)&&a.endsWith(D.extensionLowercase)&&(E=D)}return u?u.mime:w?w.mime:E?E.mime:null}function _(n){if((0,T.startsWithUTF8BOM)(n)&&(n=n.substr(1)),n.length>0)for(let a=S.length-1;a>=0;a--){const d=S[a];if(!d.firstline)continue;const u=n.match(d.firstline);if(u&&u.length>0)return d.mime}return null}function b(n){return n?typeof n=="string"?n===y.binary||n===y.text||n===y.unknown:n.length===1&&b(n[0]):!0}e.isUnspecific=b;const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(n){const a=(0,k.extname)(n),d=P[a.toLowerCase()];return d!==void 0?d:p(n)}e.getMediaOrTextMime=f;function p(n){const a=(0,k.extname)(n);return l[a.toLowerCase()]}e.getMediaMime=p;function t(n){for(const a in l)if(l[a]===n)return a}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function o(n,a){const d=s.exec(n);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:a?void 0:n}e.normalizeMimeType=o}),define(me[102],ge([0,1,2]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(i){return i.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const c=this._uriTransformer.transformIncoming(I);return c===I?I:R(g.URI.from(c))}transformOutgoing(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:R(g.URI.from(c))}transformOutgoingURI(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:g.URI.from(c)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function C(i,I,c){if(!i||c>200)return null;if(typeof i=="object"){if(i instanceof g.URI)return I.transformOutgoing(i);for(let m in i)if(Object.hasOwnProperty.call(i,m)){const h=C(i[m],I,c+1);h!==null&&(i[m]=h)}}return null}function T(i,I){const c=C(i,I,0);return c===null?i:c}e.transformOutgoingURIs=T;function y(i,I,c,m){if(!i||m>200)return null;if(typeof i=="object"){if(i.$mid===1)return c?g.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const v=y(i[h],I,c,m+1);v!==null&&(i[h]=v)}}return null}function S(i,I){const c=y(i,I,!1,0);return c===null?i:c}e.transformIncomingURIs=S;function A(i,I){const c=y(i,I,!0,0);return c===null?i:c}e.transformAndReviveIncomingURIs=A}),define(me[32],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(S){return g.test(S)}e.isUUID=R;const k=new Uint8Array(16),C=[];for(let S=0;S<256;S++)C.push(S.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(S){for(let A=0;A<S.length;A++)S[A]=Math.floor(Math.random()*256);return S};function y(){T(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let S=0,A="";return A+=C[k[S++]],A+=C[k[S++]],A+=C[k[S++]],A+=C[k[S++]],A+="-",A+=C[k[S++]],A+=C[k[S++]],A+="-",A+=C[k[S++]],A+=C[k[S++]],A+="-",A+=C[k[S++]],A+=C[k[S++]],A+="-",A+=C[k[S++]],A+=C[k[S++]],A+=C[k[S++]],A+=C[k[S++]],A+=C[k[S++]],A+=C[k[S++]],A}e.generateUuid=y}),define(me[142],ge([0,1,103]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(C="utf8"){this.stringDecoder=new g.StringDecoder(C),this.remaining=null}write(C){const T=[],y=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(y.length<1)return T;let S=0,A,i=S;for(;i<y.length;)if(A=y.charCodeAt(i),A===13||A===10){if(T.push(y.substring(S,i)),i++,i<y.length){const I=A;A=y.charCodeAt(i),(I===13&&A===10||I===10&&A===13)&&i++}S=i}else i++;return this.remaining=S<y.length?y.substr(S):null,T}end(){return this.remaining}}e.LineDecoder=R}),define(me[28],ge([0,1,49,79,290,17,29,77,8,11,24,2,32]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function h(O,x=m.UNLINK){if((0,T.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?_(O):v(O)}async function v(O){try{const x=(0,S.join)((0,R.tmpdir)(),(0,c.generateUuid)());try{await e.Promises.rename(O,x)}catch(F){return _(O)}_(x).catch(F=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function _(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function b(O){if((0,T.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(O,{recursive:!0})}e.rimrafSync=b;async function P(O,x){return p(await(x?l(O):(0,k.promisify)(g.readdir)(O)))}async function l(O){try{return await(0,k.promisify)(g.readdir)(O,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const x=[],F=await P(O);for(const z of F){let M=!1,N=!1,V=!1;try{const $=await e.Promises.lstat((0,S.join)(O,z));M=$.isFile(),N=$.isDirectory(),V=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}x.push({name:z,isFile:()=>M,isDirectory:()=>N,isSymbolicLink:()=>V})}return x}function f(O){return p(g.readdirSync(O))}e.readdirSync=f;function p(O){return O.map(x=>typeof x=="string"?A.isMacintosh?(0,y.normalizeNFC)(x):x:(x.name=A.isMacintosh?(0,y.normalizeNFC)(x.name):x.name,x))}async function t(O){const x=await P(O),F=[];for(const z of x)await o.existsDirectory((0,S.join)(O,z))&&F.push(z);return F}function s(O,x=1e3){return new Promise(F=>{let z=!1;const M=setInterval(()=>{z||(z=!0,g.access(O,N=>{z=!1,N&&(clearInterval(M),F(void 0))}))},x)})}e.whenDeleted=s;var o;(function(O){async function x(M){let N;try{if(N=await e.Promises.lstat(M),!N.isSymbolicLink())return{stat:N}}catch(V){}try{return{stat:await e.Promises.stat(M),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(A.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw $}throw V}}O.stat=x;async function F(M){try{const{stat:N,symbolicLink:V}=await O.stat(M);return N.isFile()&&V?.dangling!==!0}catch(N){}return!1}O.existsFile=F;async function z(M){try{const{stat:N,symbolicLink:V}=await O.stat(M);return N.isDirectory()&&V?.dangling!==!0}catch(N){}return!1}O.existsDirectory=z})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new C.ResourceQueue;function a(O,x,F){return n.queueFor(I.URI.file(O),i.extUriBiasedIgnorePathCase).queue(()=>{const z=E(F);return new Promise((M,N)=>u(O,x,z,V=>V?N(V):M()))})}let d=!0;function u(O,x,F,z){if(!d)return g.writeFile(O,x,{mode:F.mode,flag:F.flag},z);g.open(O,F.flag,F.mode,(M,N)=>{if(M)return z(M);g.writeFile(N,x,V=>{if(V)return g.close(N,()=>z(V));g.fdatasync(N,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),d=!1),g.close(N,G=>z(G))))})})}function w(O,x,F){const z=E(F);if(!d)return g.writeFileSync(O,x,{mode:z.mode,flag:z.flag});const M=g.openSync(O,z.flag,z.mode);try{g.writeFileSync(M,x);try{g.fdatasyncSync(M)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),d=!1}}finally{g.closeSync(M)}}e.writeFileSync=w;function E(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function r(O,x){if(O===x)return;async function F(z){try{const M=await e.Promises.lstat(z);if(M.isDirectory()||M.isSymbolicLink())return;await e.Promises.utimes(z,M.atime,new Date)}catch(M){}}try{await e.Promises.rename(O,x),await F(x)}catch(z){if(O.toLowerCase()!==x.toLowerCase()&&z.code==="EXDEV"||O.endsWith("."))await D(O,x,{preserveSymlinks:!1}),await h(O,m.MOVE),await F(x);else throw z}}async function D(O,x,F){return U(O,x,{root:{source:O,target:x},options:F,handledSourcePaths:new Set})}const L=511;async function U(O,x,F){if(F.handledSourcePaths.has(O))return;F.handledSourcePaths.add(O);const{stat:z,symbolicLink:M}=await o.stat(O);if(M){if(F.options.preserveSymlinks)try{return await K(O,x,F)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(M.dangling)return}return z.isDirectory()?j(O,x,z.mode&L,F):te(O,x,z.mode&L)}async function j(O,x,F,z){await e.Promises.mkdir(x,{recursive:!0,mode:F});const M=await P(O);for(const N of M)await U((0,S.join)(O,N),(0,S.join)(x,N),z)}async function te(O,x,F){await e.Promises.copyFile(O,x),await e.Promises.chmod(x,F)}async function K(O,x,F){let z=await e.Promises.readlink(O);(0,T.isEqualOrParent)(z,F.root.source,!A.isLinux)&&(z=(0,S.join)(F.root.target,z.substr(F.root.source.length+1))),await e.Promises.symlink(z,x)}e.Promises=new class{get access(){return(0,k.promisify)(g.access)}get stat(){return(0,k.promisify)(g.stat)}get lstat(){return(0,k.promisify)(g.lstat)}get utimes(){return(0,k.promisify)(g.utimes)}get read(){return(0,k.promisify)(g.read)}get readFile(){return(0,k.promisify)(g.readFile)}get write(){return(0,k.promisify)(g.write)}get appendFile(){return(0,k.promisify)(g.appendFile)}get fdatasync(){return(0,k.promisify)(g.fdatasync)}get truncate(){return(0,k.promisify)(g.truncate)}get rename(){return(0,k.promisify)(g.rename)}get copyFile(){return(0,k.promisify)(g.copyFile)}get open(){return(0,k.promisify)(g.open)}get close(){return(0,k.promisify)(g.close)}get symlink(){return(0,k.promisify)(g.symlink)}get readlink(){return(0,k.promisify)(g.readlink)}get chmod(){return(0,k.promisify)(g.chmod)}get mkdir(){return(0,k.promisify)(g.mkdir)}get unlink(){return(0,k.promisify)(g.unlink)}get rmdir(){return(0,k.promisify)(g.rmdir)}get realpath(){return(0,k.promisify)(g.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return h}get move(){return r}get copy(){return D}}}),define(me[104],ge([0,1,49,8,9,28]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(i){const I=(0,R.dirname)(i);if(i===I)return i;const c=((0,R.basename)(i)||i).toLowerCase();try{const h=(0,C.readdirSync)(I).filter(v=>v.toLowerCase()===c);if(h.length===1){const v=T(I);if(v)return(0,R.join)(v,h[0])}else if(h.length>1){const v=h.indexOf(c);if(v>=0){const _=T(I);if(_)return(0,R.join)(_,h[v])}}}catch(m){}return null}e.realcaseSync=T;async function y(i){try{return await C.Promises.realpath(i)}catch(I){const c=A(i);return await C.Promises.access(c,g.constants.R_OK),c}}e.realpath=y;function S(i){try{return g.realpathSync(i)}catch(I){const c=A(i);return g.accessSync(c,g.constants.R_OK),c}}e.realpathSync=S;function A(i){return(0,k.rtrim)((0,R.normalize)(i),R.sep)}});var ze=this&&this.__decorate||function(Y,e,g,R){var k=arguments.length,C=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,g):R,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Y,e,g,R);else for(var y=Y.length-1;y>=0;y--)(T=Y[y])&&(C=(k<3?T(C):k>3?T(e,g,C):T(e,g))||C);return k>3&&C&&Object.defineProperty(e,g,C),C};define(me[105],ge([0,1,20,17,25,21,56,16,3,6,59,9,14]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function h(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function _(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(b||(b={}));class P{constructor(N){this.buffer=N,this.pos=0}read(N){const V=this.buffer.slice(this.pos,this.pos+N);return this.pos+=V.byteLength,V}}class l{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var f;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(f||(f={}));function p(M){const N=k.VSBuffer.alloc(4);return N.writeUInt32BE(M,0),N}function t(M){return M.read(4).readUInt32BE(0)}function s(M){const N=k.VSBuffer.alloc(1);return N.writeUInt8(M,0),N}const o={Undefined:s(f.Undefined),String:s(f.String),Buffer:s(f.Buffer),VSBuffer:s(f.VSBuffer),Array:s(f.Array),Object:s(f.Object)},n=typeof Buffer!="undefined";function a(M,N){if(typeof N=="undefined")M.write(o.Undefined);else if(typeof N=="string"){const V=k.VSBuffer.fromString(N);M.write(o.String),M.write(p(V.byteLength)),M.write(V)}else if(n&&Buffer.isBuffer(N)){const V=k.VSBuffer.wrap(N);M.write(o.Buffer),M.write(p(V.byteLength)),M.write(V)}else if(N instanceof k.VSBuffer)M.write(o.VSBuffer),M.write(p(N.byteLength)),M.write(N);else if(Array.isArray(N)){M.write(o.Array),M.write(p(N.length));for(const V of N)a(M,V)}else{const V=k.VSBuffer.fromString(JSON.stringify(N));M.write(o.Object),M.write(p(V.byteLength)),M.write(V)}}function d(M){switch(M.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return M.read(t(M)).toString();case f.Buffer:return M.read(t(M)).buffer;case f.VSBuffer:return M.read(t(M));case f.Array:{const V=t(M),$=[];for(let G=0;G<V;G++)$.push(d(M));return $}case f.Object:return JSON.parse(M.read(t(M)).toString())}}class u{constructor(N,V,$=null,G=1e3){this.protocol=N,this.ctx=V,this.logger=$,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(N,V){this.channels.set(N,V),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const V=this.send([N.type]);this.logger&&this.logger.logOutgoing(V,0,1,_(N.type));return}case 201:case 202:case 204:case 203:{const V=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(V,N.id,1,_(N.type),N.data);return}}}send(N,V=void 0){const $=new l;return a($,N),a($,V),this.sendBuffer($.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(V){return 0}}onRawMessage(N){const V=new P(N),$=d(V),G=d(V),J=$[0];switch(J){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${h(J)}: ${$[2]}.${$[3]}`,G),this.onPromise({type:J,id:$[1],channelName:$[2],name:$[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${h(J)}: ${$[2]}.${$[3]}`,G),this.onEventListen({type:J,id:$[1],channelName:$[2],name:$[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${h(J)}`),this.disposeActiveRequest({type:J,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${h(J)}`),this.disposeActiveRequest({type:J,id:$[1]})}}onPromise(N){const V=this.channels.get(N.channelName);if(!V){this.collectPendingRequest(N);return}const $=new C.CancellationTokenSource;let G;try{G=V.call(this.ctx,N.name,N.arg,$.token)}catch(ye){G=Promise.reject(ye)}const J=N.id;G.then(ye=>{this.sendResponse({id:J,data:ye,type:201}),this.activeRequests.delete(N.id)},ye=>{ye instanceof Error?this.sendResponse({id:J,data:{message:ye.message,name:ye.name,stack:ye.stack?ye.stack.split?ye.stack.split(`
`):ye.stack:void 0},type:202}):this.sendResponse({id:J,data:ye,type:203}),this.activeRequests.delete(N.id)});const fe=(0,A.toDisposable)(()=>$.cancel());this.activeRequests.set(N.id,fe)}onEventListen(N){const V=this.channels.get(N.channelName);if(!V){this.collectPendingRequest(N);return}const $=N.id,J=V.listen(this.ctx,N.name,N.arg)(fe=>this.sendResponse({id:$,data:fe,type:204}));this.activeRequests.set(N.id,J)}disposeActiveRequest(N){const V=this.activeRequests.get(N.id);V&&(V.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let V=this.pendingRequests.get(N.channelName);V||(V=[],this.pendingRequests.set(N.channelName,V));const $=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);V.push({request:N,timeoutTimer:$})}flushPendingRequests(N){const V=this.pendingRequests.get(N);if(V){for(const $ of V)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var w;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(N,V=null){this.protocol=N,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=V}getChannel(N){const V=this;return{call($,G,J){return V.isDisposed?Promise.reject(y.canceled()):V.requestPromise(N,$,G,J)},listen($,G){return V.isDisposed?Promise.reject(y.canceled()):V.requestEvent(N,$,G)}}}requestPromise(N,V,$,G=C.CancellationToken.None){const J=this.lastRequestId++,ye={id:J,type:100,channelName:N,name:V,arg:$};if(G.isCancellationRequested)return Promise.reject(y.canceled());let ke;return new Promise((Ve,Be)=>{if(G.isCancellationRequested)return Be(y.canceled());const Ke=()=>{const ae=Q=>{switch(Q.type){case 201:this.handlers.delete(J),Ve(Q.data);break;case 202:this.handlers.delete(J);const oe=new Error(Q.data.message);oe.stack=Q.data.stack,oe.name=Q.data.name,Be(oe);break;case 203:this.handlers.delete(J),Be(Q.data);break}};this.handlers.set(J,ae),this.sendRequest(ye)};let W=null;this.state===b.Idle?Ke():(W=(0,R.createCancelablePromise)(ae=>this.whenInitialized()),W.then(()=>{W=null,Ke()}));const Z=()=>{W?(W.cancel(),W=null):this.sendRequest({id:J,type:101}),Be(y.canceled())},re=G.onCancellationRequested(Z);ke=(0,A.combinedDisposable)((0,A.toDisposable)(Z),re),this.activeRequests.add(ke)}).finally(()=>{this.activeRequests.delete(ke)})}requestEvent(N,V,$){const G=this.lastRequestId++,fe={id:G,type:102,channelName:N,name:V,arg:$};let ye=null;const ke=new S.Emitter({onFirstListenerAdd:()=>{ye=(0,R.createCancelablePromise)(Ve=>this.whenInitialized()),ye.then(()=>{ye=null,this.activeRequests.add(ke),this.sendRequest(fe)})},onLastListenerRemove:()=>{ye?(ye.cancel(),ye=null):(this.activeRequests.delete(ke),this.sendRequest({id:G,type:103}))}}),Re=Ve=>ke.fire(Ve.data);return this.handlers.set(G,Re),ke.event}sendRequest(N){switch(N.type){case 100:case 102:{const V=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(V,N.id,0,`${h(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const V=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(V,N.id,0,h(N.type));return}}}send(N,V=void 0){const $=new l;return a($,N),a($,V),this.sendBuffer($.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(V){return 0}}onBuffer(N){const V=new P(N),$=d(V),G=d(V),J=$[0];switch(J){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,_(J)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],0,_(J),G),this.onResponse({type:$[0],id:$[1],data:G})}}onResponse(N){if(N.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const V=this.handlers.get(N.id);V&&V(N)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}ze([T.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class r{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:V,onDidClientDisconnect:$})=>{S.Event.once(V.onMessage)(J=>{const fe=new P(J),ye=d(fe),ke=new u(V,ye),Re=new E(V);this.channels.forEach((Be,Ke)=>ke.registerChannel(Ke,Be));const Ve={channelServer:ke,channelClient:Re,ctx:ye};this._connections.add(Ve),this._onDidAddConnection.fire(Ve),$(()=>{ke.dispose(),Re.dispose(),this._connections.delete(Ve),this._onDidRemoveConnection.fire(Ve)})})})}get connections(){const N=[];return this._connections.forEach(V=>N.push(V)),N}getChannel(N,V){const $=this;return{call(G,J,fe){let ye;if((0,c.isFunction)(V)){let Re=(0,g.getRandomElement)($.connections.filter(V));ye=Re?Promise.resolve(Re):S.Event.toPromise(S.Event.filter($.onDidAddConnection,V))}else ye=V.routeCall($,G,J);const ke=ye.then(Re=>Re.channelClient.getChannel(N));return L(ke).call(G,J,fe)},listen(G,J){if((0,c.isFunction)(V))return $.getMulticastEvent(N,V,G,J);const fe=V.routeEvent($,G,J).then(ye=>ye.channelClient.getChannel(N));return L(fe).listen(G,J)}}}getMulticastEvent(N,V,$,G){const J=this;let fe=new A.DisposableStore;const ye=new S.Emitter({onFirstListenerAdd:()=>{fe=new A.DisposableStore;const ke=new S.EventMultiplexer,Re=new Map,Ve=Ke=>{const Z=Ke.channelClient.getChannel(N).listen($,G),re=ke.add(Z);Re.set(Ke,re)},Be=Ke=>{const W=Re.get(Ke);!W||(W.dispose(),Re.delete(Ke))};J.connections.filter(V).forEach(Ve),S.Event.filter(J.onDidAddConnection,V)(Ve,void 0,fe),J.onDidRemoveConnection(Be,void 0,fe),ke.event(ye.fire,ye,fe),fe.add(ke)},onLastListenerRemove:()=>{fe.dispose()}});return ye.event}registerChannel(N,V){this.channels.set(N,V),this._connections.forEach($=>{$.channelServer.registerChannel(N,V)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=r;class D{constructor(N,V,$=null){const G=new l;a(G,V),N.send(G.buffer),this.channelClient=new E(N,$),this.channelServer=new u(N,V,$)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,V){this.channelServer.registerChannel(N,V)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function L(M){return{call(N,V,$){return M.then(G=>G.call(N,V,$))},listen(N,V){const $=new S.Relay;return M.then(G=>$.input=G.listen(N,V)),$.event}}}e.getDelayedChannel=L;function U(M){let N=!1;return{call(V,$,G){return N?M.call(V,$,G):(0,R.timeout)(0).then(()=>N=!0).then(()=>M.call(V,$,G))},listen(V,$){if(N)return M.listen(V,$);const G=new S.Relay;return(0,R.timeout)(0).then(()=>N=!0).then(()=>G.input=M.listen(V,$)),G.event}}}e.getNextTickChannel=U;class j{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const V of N.connections)if(await Promise.resolve(this.fn(V.ctx)))return Promise.resolve(V);return await S.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=j;var te;(function(M){function N(G,J){const fe=G,ye=J&&J.disableMarshalling,ke=new Map;for(const Re in fe)$(Re)&&ke.set(Re,S.Event.buffer(fe[Re],!0));return new class{listen(Re,Ve){const Be=ke.get(Ve);if(Be)return Be;throw new Error(`Event not found: ${Ve}`)}call(Re,Ve,Be){const Ke=fe[Ve];if(typeof Ke=="function"){if(!ye&&Array.isArray(Be))for(let W=0;W<Be.length;W++)Be[W]=(0,i.revive)(Be[W]);return Ke.apply(fe,Be)}throw new Error(`Method not found: ${Ve}`)}}}M.fromService=N;function V(G,J){const fe=J&&J.disableMarshalling;return new Proxy({},{get(ye,ke){if(typeof ke=="string")return J?.properties?.has(ke)?J.properties.get(ke):$(ke)?G.listen(ke):async function(...Re){let Ve;J&&!(0,c.isUndefinedOrNull)(J.context)?Ve=[J.context,...Re]:Ve=Re;const Be=await G.call(ke,Ve);return fe?Be:(0,i.revive)(Be)};throw new Error(`Property not found: ${String(ke)}`)}})}M.toService=V;function $(G){return G[0]==="o"&&G[1]==="n"&&I.isUpperAsciiLetter(G.charCodeAt(2))}})(te=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let N=M.toString();if(N!=="[object Object]")return N}return M}function x(M){return Array.isArray(M)?M.map(O):O(M)}function F(M,N,V,$,G,J,fe){fe=x(fe);const ye=K[G],ke=ye[$%ye.length];let Re=[`%c[${M}]%c[${String(N).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String($).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${ke}`];/\($/.test(J)?(Re=Re.concat(fe),Re.push(")")):Re.push(fe),console.log.apply(console,Re)}e.logWithColors=F;class z{constructor(N,V){this._outgoingPrefix=N,this._incomingPrefix=V,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,V,$,G,J){this._totalOutgoing+=N,F(this._outgoingPrefix,this._totalOutgoing,N,V,$,G,J)}logIncoming(N,V,$,G,J){this._totalIncoming+=N,F(this._incomingPrefix,this._totalIncoming,N,V,$,G,J)}}e.IPCLogger=z}),define(me[106],ge([0,1,25,3,6,11,38,105]),function(Y,e,g,R,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let A=null;function i(){return A||(A=g.VSBuffer.alloc(0)),A}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,a){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const E=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=n),E}if(this._chunks[0].byteLength>n){const E=this._chunks[0].slice(0,n);return a&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),E}let d=g.VSBuffer.alloc(n),u=0,w=0;for(;n>0;){const E=this._chunks[w];if(E.byteLength>n){const r=E.slice(0,n);d.set(r,u),u+=n,a&&(this._chunks[w]=E.slice(n),this._totalLength-=n),n-=n}else d.set(E,u),u+=E.byteLength,a?(this._chunks.shift(),this._totalLength-=E.byteLength):w++,n-=E.byteLength}return d}}e.ChunkStream=I;var c;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.KeepAlive=4]="KeepAlive",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest"})(c||(c={}));var m;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",o[o.KeepAliveTime=5e3]="KeepAliveTime",o[o.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(n,a,d,u){this.type=n,this.id=a,this.ack=d,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends k.Disposable{constructor(n){super();this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const d=this._state.messageType,u=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(d,u,w,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class _{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=g.VSBuffer.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this._writeSoon(a,n.data)}_bufferAdd(n,a){const d=this._totalLength===0;return this._data.push(n,a),this._totalLength+=n.byteLength+a.byteLength,d}_bufferTake(){const n=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,a){this._bufferAdd(n,a)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends k.Disposable{constructor(n){super();this._onMessage=new R.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new _(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new h(1,0,0,n))}}e.Protocol=b;class P extends y.IPCClient{constructor(n,a,d=null){super(n,a,d);this.protocol=n}static fromSocket(n,a){return new P(new b(n),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=P;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new R.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,T.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class f{constructor(n){this.data=n,this.next=null}}class p{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],a=0,d=this._first;for(;d;)n[a++]=d.data,d=d.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const a=new f(n);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=n-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let d=0;for(let u=0;u<t._HISTORY_LENGTH;u++)n-this.lastRuns[u]<=a&&d++;return 1-d/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(n,a=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new p,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new h(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const a=new h(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,a){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let a=0,d=n.length;a<d;a++)this._socketWriter.write(n[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new h(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const a=this._outgoingUnackMsg.toArray();for(let d=0,u=a.length;d<u;d++)this._socketWriter.write(a[d]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new h(1,a,this._incomingAckId,n);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(n){const a=new h(2,0,0,n);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),a=Date.now()-n.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new h(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(me[107],ge([0,1,96]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(y){let S=(0,g.toUint8)(y);this._defaultValue=S,this._asciiMap=R._createAsciiMap(S),this._map=new Map}static _createAsciiMap(y){let S=new Uint8Array(256);for(let A=0;A<256;A++)S[A]=y;return S}set(y,S){let A=(0,g.toUint8)(S);y>=0&&y<256?this._asciiMap[y]=A:this._map.set(y,A)}get(y){return y>=0&&y<256?this._asciiMap[y]:this._map.get(y)||this._defaultValue}}e.CharacterClassifier=R;var k;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(k||(k={}));class C{constructor(){this._actual=new R(0)}add(y){this._actual.set(y,1)}has(y){return this._actual.get(y)===1}}e.CharacterSet=C}),define(me[143],ge([0,1,107]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends g.CharacterClassifier{constructor(y){super(0);for(let S=0,A=y.length;S<A;S++)this.set(y.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function C(T){let y={};return S=>(y.hasOwnProperty(S)||(y[S]=T(S)),y[S])}e.getMapForWordSeparators=C(T=>new k(T))}),define(me[50],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(k,C){this.lineNumber=k,this.column=C}with(k=this.lineNumber,C=this.column){return k===this.lineNumber&&C===this.column?this:new g(k,C)}delta(k=0,C=0){return this.with(this.lineNumber+k,this.column+C)}equals(k){return g.equals(this,k)}static equals(k,C){return!k&&!C?!0:!!k&&!!C&&k.lineNumber===C.lineNumber&&k.column===C.column}isBefore(k){return g.isBefore(this,k)}static isBefore(k,C){return k.lineNumber<C.lineNumber?!0:C.lineNumber<k.lineNumber?!1:k.column<C.column}isBeforeOrEqual(k){return g.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,C){return k.lineNumber<C.lineNumber?!0:C.lineNumber<k.lineNumber?!1:k.column<=C.column}static compare(k,C){let T=k.lineNumber|0,y=C.lineNumber|0;if(T===y){let S=k.column|0,A=C.column|0;return S-A}return T-y}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new g(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=g}),define(me[41],ge([0,1,50]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(C,T,y,S){C>y||C===y&&T>S?(this.startLineNumber=y,this.startColumn=S,this.endLineNumber=C,this.endColumn=T):(this.startLineNumber=C,this.startColumn=T,this.endLineNumber=y,this.endColumn=S)}isEmpty(){return R.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return R.containsPosition(this,C)}static containsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<C.startColumn||T.lineNumber===C.endLineNumber&&T.column>C.endColumn)}containsRange(C){return R.containsRange(this,C)}static containsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>C.endColumn)}strictContainsRange(C){return R.strictContainsRange(this,C)}static strictContainsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<=C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>=C.endColumn)}plusRange(C){return R.plusRange(this,C)}static plusRange(C,T){let y,S,A,i;return T.startLineNumber<C.startLineNumber?(y=T.startLineNumber,S=T.startColumn):T.startLineNumber===C.startLineNumber?(y=T.startLineNumber,S=Math.min(T.startColumn,C.startColumn)):(y=C.startLineNumber,S=C.startColumn),T.endLineNumber>C.endLineNumber?(A=T.endLineNumber,i=T.endColumn):T.endLineNumber===C.endLineNumber?(A=T.endLineNumber,i=Math.max(T.endColumn,C.endColumn)):(A=C.endLineNumber,i=C.endColumn),new R(y,S,A,i)}intersectRanges(C){return R.intersectRanges(this,C)}static intersectRanges(C,T){let y=C.startLineNumber,S=C.startColumn,A=C.endLineNumber,i=C.endColumn,I=T.startLineNumber,c=T.startColumn,m=T.endLineNumber,h=T.endColumn;return y<I?(y=I,S=c):y===I&&(S=Math.max(S,c)),A>m?(A=m,i=h):A===m&&(i=Math.min(i,h)),y>A||y===A&&S>i?null:new R(y,S,A,i)}equalsRange(C){return R.equalsRange(this,C)}static equalsRange(C,T){return!!C&&!!T&&C.startLineNumber===T.startLineNumber&&C.startColumn===T.startColumn&&C.endLineNumber===T.endLineNumber&&C.endColumn===T.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(C){return new g.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(C){return new g.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,T){return new R(this.startLineNumber,this.startColumn,C,T)}setStartPosition(C,T){return new R(C,T,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(C){return new R(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,T=C){return new R(C.lineNumber,C.column,T.lineNumber,T.column)}static lift(C){return C?new R(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<C.startColumn)}static areIntersecting(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<=T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,T){if(C&&T){const A=C.startLineNumber|0,i=T.startLineNumber|0;if(A===i){const I=C.startColumn|0,c=T.startColumn|0;if(I===c){const m=C.endLineNumber|0,h=T.endLineNumber|0;if(m===h){const v=C.endColumn|0,_=T.endColumn|0;return v-_}return m-h}return I-c}return A-i}return(C?1:0)-(T?1:0)}static compareRangesUsingEnds(C,T){return C.endLineNumber===T.endLineNumber?C.endColumn===T.endColumn?C.startLineNumber===T.startLineNumber?C.startColumn-T.startColumn:C.startLineNumber-T.startLineNumber:C.endColumn-T.endColumn:C.endLineNumber-T.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=R}),define(me[144],ge([0,1,50,41]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class C extends R.Range{constructor(y,S,A,i){super(y,S,A,i);this.selectionStartLineNumber=y,this.selectionStartColumn=S,this.positionLineNumber=A,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return C.selectionsEqual(this,y)}static selectionsEqual(y,S){return y.selectionStartLineNumber===S.selectionStartLineNumber&&y.selectionStartColumn===S.selectionStartColumn&&y.positionLineNumber===S.positionLineNumber&&y.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,S){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,y,S):new C(y,S,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(y,S){return this.getDirection()===0?new C(y,S,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,y,S)}static fromPositions(y,S=y){return new C(y.lineNumber,y.column,S.lineNumber,S.column)}static liftSelection(y){return new C(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,S){if(y&&!S||!y&&S)return!1;if(!y&&!S)return!0;if(y.length!==S.length)return!1;for(let A=0,i=y.length;A<i;A++)if(!this.selectionsEqual(y[A],S[A]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,S,A,i,I){return I===0?new C(y,S,A,i):new C(A,i,y,S)}}e.Selection=C}),define(me[108],ge([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var R;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(R=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),this.indentSize=_.tabSize|0,this.insertSpaces=Boolean(_.insertSpaces),this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=Boolean(_.trimAutoWhitespace),this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class A{constructor(_,b){this._findMatchBrand=void 0,this.range=_,this.matches=b}}e.FindMatch=A;var i;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None"})(I=e.PositionAffinity||(e.PositionAffinity={}));var c;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c=e.ModelConstants||(e.ModelConstants={}));class m{constructor(_,b,P,l,f,p){this.identifier=_,this.range=b,this.text=P,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=f,this._isTracked=p}}e.ValidAnnotatedEditOperation=m;class h{constructor(_,b,P){this.reverseEdits=_,this.changes=b,this.trimAutoWhitespaceLineNumbers=P}}e.ApplyEditsResult=h}),define(me[145],ge([0,1,9,143,50,41,108]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const y=999;class S{constructor(l,f,p,t){this.searchString=l,this.isRegex=f,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=A(this.searchString):l=this.searchString.indexOf(`
`)>=0;let f=null;try{f=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(t){return null}if(!f)return null;let p=!this.isRegex&&!l;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new i(f,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=S;function A(P){if(!P||P.length===0)return!1;for(let l=0,f=P.length;l<f;l++)if(P.charCodeAt(l)===92){if(l++,l>=f)break;const t=P.charCodeAt(l);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=A;class i{constructor(l,f,p){this.regex=l,this.wordSeparators=f,this.simpleSearch=p}}e.SearchData=i;function I(P,l,f){if(!f)return new T.FindMatch(P,null);let p=[];for(let t=0,s=l.length;t<s;t++)p[t]=l[t];return new T.FindMatch(P,p)}e.createFindMatch=I;class c{constructor(l){let f=[],p=0;for(let t=0,s=l.length;t<s;t++)l.charCodeAt(t)===10&&(f[p++]=t);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(l){const f=this._lineFeedsOffsets;let p=0,t=f.length-1;if(t===-1||l<=f[0])return 0;for(;p<t;){const s=p+((t-p)/2>>0);f[s]>=l?t=s-1:f[s+1]>=l?(p=s,t=s):p=s+1}return p+1}}class m{static findMatches(l,f,p,t,s){const o=f.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(l,p,new b(o.wordSeparators,o.regex),t,s):this._doFindMatchesLineByLine(l,p,o,t,s):[]}static _getMultilineMatchRange(l,f,p,t,s,o){let n,a=0;t?(a=t.findLineFeedCountBeforeOffset(s),n=f+s+a):n=f+s;let d;if(t){let r=t.findLineFeedCountBeforeOffset(s+o.length)-a;d=n+o.length+r}else d=n+o.length;const u=l.getPositionAt(n),w=l.getPositionAt(d);return new C.Range(u.lineNumber,u.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(l,f,p,t,s){const o=l.getOffsetAt(f.getStartPosition()),n=l.getValueInRange(f,1),a=l.getEOL()===`\r
`?new c(n):null,d=[];let u=0,w;for(p.reset(0);w=p.next(n);)if(d[u++]=I(this._getMultilineMatchRange(l,o,n,a,w.index,w[0]),w,t),u>=s)return d;return d}static _doFindMatchesLineByLine(l,f,p,t,s){const o=[];let n=0;if(f.startLineNumber===f.endLineNumber){const d=l.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return n=this._findMatchesInLine(p,d,f.startLineNumber,f.startColumn-1,n,o,t,s),o}const a=l.getLineContent(f.startLineNumber).substring(f.startColumn-1);n=this._findMatchesInLine(p,a,f.startLineNumber,f.startColumn-1,n,o,t,s);for(let d=f.startLineNumber+1;d<f.endLineNumber&&n<s;d++)n=this._findMatchesInLine(p,l.getLineContent(d),d,0,n,o,t,s);if(n<s){const d=l.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);n=this._findMatchesInLine(p,d,f.endLineNumber,0,n,o,t,s)}return o}static _findMatchesInLine(l,f,p,t,s,o,n,a){const d=l.wordSeparators;if(!n&&l.simpleSearch){const E=l.simpleSearch,r=E.length,D=f.length;let L=-r;for(;(L=f.indexOf(E,L+r))!==-1;)if((!d||_(d,f,D,L,r))&&(o[s++]=new T.FindMatch(new C.Range(p,L+1+t,p,L+1+r+t),null),s>=a))return s;return s}const u=new b(l.wordSeparators,l.regex);let w;u.reset(0);do if(w=u.next(f),w&&(o[s++]=I(new C.Range(p,w.index+1+t,p,w.index+1+w[0].length+t),w,n),s>=a))return s;while(w);return s}static findNextMatch(l,f,p,t){const s=f.parseSearchRequest();if(!s)return null;const o=new b(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(l,p,o,t):this._doFindNextMatchLineByLine(l,p,o,t)}static _doFindNextMatchMultiline(l,f,p,t){const s=new k.Position(f.lineNumber,1),o=l.getOffsetAt(s),n=l.getLineCount(),a=l.getValueInRange(new C.Range(s.lineNumber,s.column,n,l.getLineMaxColumn(n)),1),d=l.getEOL()===`\r
`?new c(a):null;p.reset(f.column-1);let u=p.next(a);return u?I(this._getMultilineMatchRange(l,o,a,d,u.index,u[0]),u,t):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(l,new k.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(l,f,p,t){const s=l.getLineCount(),o=f.lineNumber,n=l.getLineContent(o),a=this._findFirstMatchInLine(p,n,o,f.column,t);if(a)return a;for(let d=1;d<=s;d++){const u=(o+d-1)%s,w=l.getLineContent(u+1),E=this._findFirstMatchInLine(p,w,u+1,1,t);if(E)return E}return null}static _findFirstMatchInLine(l,f,p,t,s){l.reset(t-1);const o=l.next(f);return o?I(new C.Range(p,o.index+1,p,o.index+1+o[0].length),o,s):null}static findPreviousMatch(l,f,p,t){const s=f.parseSearchRequest();if(!s)return null;const o=new b(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(l,p,o,t):this._doFindPreviousMatchLineByLine(l,p,o,t)}static _doFindPreviousMatchMultiline(l,f,p,t){const s=this._doFindMatchesMultiline(l,new C.Range(1,1,f.lineNumber,f.column),p,t,10*y);if(s.length>0)return s[s.length-1];const o=l.getLineCount();return f.lineNumber!==o||f.column!==l.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(l,new k.Position(o,l.getLineMaxColumn(o)),p,t):null}static _doFindPreviousMatchLineByLine(l,f,p,t){const s=l.getLineCount(),o=f.lineNumber,n=l.getLineContent(o).substring(0,f.column-1),a=this._findLastMatchInLine(p,n,o,t);if(a)return a;for(let d=1;d<=s;d++){const u=(s+o-d-1)%s,w=l.getLineContent(u+1),E=this._findLastMatchInLine(p,w,u+1,t);if(E)return E}return null}static _findLastMatchInLine(l,f,p,t){let s=null,o;for(l.reset(0);o=l.next(f);)s=I(new C.Range(p,o.index+1,p,o.index+1+o[0].length),o,t);return s}}e.TextModelSearch=m;function h(P,l,f,p,t){if(p===0)return!0;const s=l.charCodeAt(p-1);if(P.get(s)!==0||s===13||s===10)return!0;if(t>0){const o=l.charCodeAt(p);if(P.get(o)!==0)return!0}return!1}function v(P,l,f,p,t){if(p+t===f)return!0;const s=l.charCodeAt(p+t);if(P.get(s)!==0||s===13||s===10)return!0;if(t>0){const o=l.charCodeAt(p+t-1);if(P.get(o)!==0)return!0}return!1}function _(P,l,f,p,t){return h(P,l,f,p,t)&&v(P,l,f,p,t)}e.isValidMatch=_;class b{constructor(l,f){this._wordSeparators=l,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const f=l.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(p=this._searchRegex.exec(l),!p))return null;const t=p.index,s=p[0].length;if(t===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){g.getNextCodePoint(l,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=s,!this._wordSeparators||_(this._wordSeparators,l,f,t,s))return p}while(p);return null}}e.Searcher=b}),define(me[109],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(y=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const A of e.USUAL_WORD_SEPARATORS)y.indexOf(A)>=0||(S+="\\"+A);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=g();function R(y){let S=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)S=y;else{let A="g";y.ignoreCase&&(A+="i"),y.multiline&&(A+="m"),y.unicode&&(A+="u"),S=new RegExp(y.source,A)}return S.lastIndex=0,S}e.ensureValidWordDefinition=R;const k={maxLen:1e3,windowSize:15,timeBudget:150};function C(y,S,A,i,I=k){if(A.length>I.maxLen){let _=y-I.maxLen/2;return _<0?_=0:i+=_,A=A.substring(_,y+I.maxLen/2),C(y,S,A,i,I)}const c=Date.now(),m=y-1-i;let h=-1,v=null;for(let _=1;!(Date.now()-c>=I.timeBudget);_++){const b=m-I.windowSize*_;S.lastIndex=Math.max(0,b);const P=T(S,A,m,h);if(!P&&v||(v=P,b<=0))break;h=b}if(v){let _={word:v[0],startColumn:i+1+v.index,endColumn:i+1+v.index+v[0].length};return S.lastIndex=0,_}return null}e.getWordAtText=C;function T(y,S,A,i){let I;for(;I=y.exec(S);){const c=I.index||0;if(c<=A&&y.lastIndex>=A)return I;if(i>0&&c>i)return null}return null}}),define(me[146],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class R{constructor(y){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=y.open,this.close=y.close,this._standardTokenMask=0,Array.isArray(y.notIn))for(let S=0,A=y.notIn.length;S<A;S++)switch(y.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(y){return(this._standardTokenMask&y)==0}}e.StandardAutoClosingPairConditional=R;class k{constructor(y){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of y)C(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),C(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),C(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),C(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&C(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=k;function C(T,y,S){T.has(y)?T.get(y).push(S):T.set(y,[S])}}),define(me[80],ge([0,1,30,8]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(C,T,y,S){if(Array.isArray(C)){let A=0;for(const i of C){const I=k(i,T,y,S);if(I===10)return I;I>A&&(A=I)}return A}else{if(typeof C=="string")return S?C==="*"?5:C===y?10:0:0;if(C){const{language:A,pattern:i,scheme:I,hasAccessToAllModels:c}=C;if(!S&&!c)return 0;let m=0;if(I)if(I===T.scheme)m=10;else if(I==="*")m=5;else return 0;if(A)if(A===y)m=10;else if(A==="*")m=Math.max(m,5);else return 0;if(i){let h;if(typeof i=="string"?h=i:h={...i,base:(0,R.normalize)(i.base)},h===T.fsPath||(0,g.match)(h,T.fsPath))m=10;else return 0}return m}else return 0}}e.score=k}),define(me[147],ge([0,1,107]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class k{constructor(h,v,_){const b=new Uint8Array(h*v);for(let P=0,l=h*v;P<l;P++)b[P]=_;this._data=b,this.rows=h,this.cols=v}get(h,v){return this._data[h*this.cols+v]}set(h,v,_){this._data[h*this.cols+v]=_}}e.Uint8Matrix=k;class C{constructor(h){let v=0,_=0;for(let P=0,l=h.length;P<l;P++){let[f,p,t]=h[P];p>v&&(v=p),f>_&&(_=f),t>_&&(_=t)}v++,_++;let b=new k(_,v,0);for(let P=0,l=h.length;P<l;P++){let[f,p,t]=h[P];b.set(f,p,t)}this._states=b,this._maxCharCode=v}nextState(h,v){return v<0||v>=this._maxCharCode?0:this._states.get(h,v)}}e.StateMachine=C;let T=null;function y(){return T===null&&(T=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var S;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let A=null;function i(){if(A===null){A=new g.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<m.length;v++)A.set(m.charCodeAt(v),1);const h=".,;";for(let v=0;v<h.length;v++)A.set(h.charCodeAt(v),2)}return A}class I{static _createLink(h,v,_,b,P){let l=P-1;do{const f=v.charCodeAt(l);if(h.get(f)!==2)break;l--}while(l>b);if(b>0){const f=v.charCodeAt(b-1),p=v.charCodeAt(l);(f===40&&p===41||f===91&&p===93||f===123&&p===125)&&l--}return{range:{startLineNumber:_,startColumn:b+1,endLineNumber:_,endColumn:l+2},url:v.substring(b,l+1)}}static computeLinks(h,v=y()){const _=i();let b=[];for(let P=1,l=h.getLineCount();P<=l;P++){const f=h.getLineContent(P),p=f.length;let t=0,s=0,o=0,n=1,a=!1,d=!1,u=!1,w=!1;for(;t<p;){let E=!1;const r=f.charCodeAt(t);if(n===13){let D;switch(r){case 40:a=!0,D=0;break;case 41:D=a?0:1;break;case 91:u=!0,d=!0,D=0;break;case 93:u=!1,D=d?0:1;break;case 123:w=!0,D=0;break;case 125:D=w?0:1;break;case 39:D=o===34||o===96?0:1;break;case 34:D=o===39||o===96?0:1;break;case 96:D=o===39||o===34?0:1;break;case 42:D=o===42?1:0;break;case 124:D=o===124?1:0;break;case 32:D=u?0:1;break;default:D=_.get(r)}D===1&&(b.push(I._createLink(_,f,P,s,t)),E=!0)}else if(n===12){let D;r===91?(d=!0,D=0):D=_.get(r),D===1?E=!0:n=13}else n=v.nextState(n,r),n===0&&(E=!0);E&&(n=1,a=!1,d=!1,w=!1,s=t+1,o=r),t++}n===13&&b.push(I._createLink(_,f,P,s,p))}return b}}e.LinkComputer=I;function c(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:I.computeLinks(m)}e.computeLinks=c}),define(me[148],ge([0,1,3,6]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,y){return this._map.set(T,y),this.fire([T]),(0,R.toDisposable)(()=>{this._map.get(T)===y&&(this._map.delete(T),this.fire([T]))})}registerPromise(T,y){let S=null,A=!1;return this._promises.set(T,y.then(i=>{this._promises.delete(T),!(A||!i)&&(S=this.register(T,i))})),(0,R.toDisposable)(()=>{A=!0,S&&S.dispose()})}getPromise(T){const y=this.get(T);if(y)return Promise.resolve(y);const S=this._promises.get(T);return S?S.then(A=>this.get(T)):null}get(T){return this._map.get(T)||null}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(me[110],ge([0,1,25,11]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(k||(k={}));function C(I){for(let c=0,m=I.length;c<m;c+=4){const h=I[c+0],v=I[c+1],_=I[c+2],b=I[c+3];I[c+0]=b,I[c+1]=_,I[c+2]=v,I[c+3]=h}}function T(I){const c=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return R.isLittleEndian()||C(c),g.VSBuffer.wrap(c)}function y(I){const c=I.buffer;if(R.isLittleEndian()||C(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const m=new Uint8Array(c.byteLength);return m.set(c),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function S(I){const c=new Uint32Array(A(I));let m=0;if(c[m++]=I.id,I.type==="full")c[m++]=1,c[m++]=I.data.length,c.set(I.data,m),m+=I.data.length;else{c[m++]=2,c[m++]=I.deltas.length;for(const h of I.deltas)c[m++]=h.start,c[m++]=h.deleteCount,h.data?(c[m++]=h.data.length,c.set(h.data,m),m+=h.data.length):c[m++]=0}return T(c)}e.encodeSemanticTokensDto=S;function A(I){let c=0;if(c+=1+1,I.type==="full")c+=1+I.data.length;else{c+=1,c+=(1+1+1)*I.deltas.length;for(const m of I.deltas)m.data&&(c+=m.data.length)}return c}function i(I){const c=y(I);let m=0;const h=c[m++];if(c[m++]===1){const P=c[m++],l=c.subarray(m,m+P);return m+=P,{id:h,type:"full",data:l}}const _=c[m++];let b=[];for(let P=0;P<_;P++){const l=c[m++],f=c[m++],p=c[m++];let t;p>0&&(t=c.subarray(m,m+p),m+=p),b[P]={start:l,deleteCount:f,data:t}}return{id:h,type:"delta",deltas:b}}e.decodeSemanticTokensDto=i}),define(me[111],ge([0,1,96]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(T,y){this._prefixSumIndexOfResultBrand=void 0,this.index=T,this.remainder=y}}e.PrefixSumIndexOfResult=R;class k{constructor(T){this.values=T,this.prefixSum=new Uint32Array(T.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(T,y){T=(0,g.toUint32)(T);const S=this.values,A=this.prefixSum,i=y.length;return i===0?!1:(this.values=new Uint32Array(S.length+i),this.values.set(S.subarray(0,T),0),this.values.set(S.subarray(T),T+i),this.values.set(y,T),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(T,y){return T=(0,g.toUint32)(T),y=(0,g.toUint32)(y),this.values[T]===y?!1:(this.values[T]=y,T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),!0)}removeValues(T,y){T=(0,g.toUint32)(T),y=(0,g.toUint32)(y);const S=this.values,A=this.prefixSum;if(T>=S.length)return!1;let i=S.length-T;return y>=i&&(y=i),y===0?!1:(this.values=new Uint32Array(S.length-y),this.values.set(S.subarray(0,T),0),this.values.set(S.subarray(T+y),T),this.prefixSum=new Uint32Array(this.values.length),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(T){return T<0?0:(T=(0,g.toUint32)(T),this._getPrefixSum(T))}_getPrefixSum(T){if(T<=this.prefixSumValidIndex[0])return this.prefixSum[T];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),T>=this.values.length&&(T=this.values.length-1);for(let S=y;S<=T;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],T),this.prefixSum[T]}getIndexOf(T){T=Math.floor(T),this.getTotalSum();let y=0,S=this.values.length-1,A=0,i=0,I=0;for(;y<=S;)if(A=y+(S-y)/2|0,i=this.prefixSum[A],I=i-this.values[A],T<I)S=A-1;else if(T>=i)y=A+1;else break;return new R(A,T-I)}}e.PrefixSumComputer=k}),define(me[149],ge([0,1,9,50,111]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(y,S,A,i){this._uri=y,this._lines=S,this._eol=A,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const S=y.changes;for(const A of S)this._acceptDeleteRange(A.range),this._acceptInsertText(new R.Position(A.range.startLineNumber,A.range.startColumn),A.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,S=this._lines.length,A=new Uint32Array(S);for(let i=0;i<S;i++)A[i]=this._lines[i].length+y;this._lineStarts=new k.PrefixSumComputer(A)}}_setLineText(y,S){this._lines[y]=S,this._lineStarts&&this._lineStarts.changeValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,S){if(S.length===0)return;let A=(0,g.splitLines)(S);if(A.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+A[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}A[A.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+A[0]);let i=new Uint32Array(A.length-1);for(let I=1;I<A.length;I++)this._lines.splice(y.lineNumber+I-1,0,A[I]),i[I-1]=A[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,i)}}e.MirrorTextModel=C}),define(me[150],ge([18,19]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(me[151],ge([0,1,150]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,k=R*60,C=k*24,T=C*7,y=C*30,S=C*365;function A(I,c){typeof I!="number"&&(I=I.getTime());const m=Math.round((new Date().getTime()-I)/1e3);if(m<-30)return(0,g.localize)(0,null,A(new Date().getTime()+m*1e3,!1));if(m<30)return(0,g.localize)(1,null);let h;return m<R?(h=m,c?h===1?(0,g.localize)(2,null,h):(0,g.localize)(3,null,h):h===1?(0,g.localize)(4,null,h):(0,g.localize)(5,null,h)):m<k?(h=Math.floor(m/R),c?h===1?(0,g.localize)(6,null,h):(0,g.localize)(7,null,h):h===1?(0,g.localize)(8,null,h):(0,g.localize)(9,null,h)):m<C?(h=Math.floor(m/k),c?h===1?(0,g.localize)(10,null,h):(0,g.localize)(11,null,h):h===1?(0,g.localize)(12,null,h):(0,g.localize)(13,null,h)):m<T?(h=Math.floor(m/C),c?h===1?(0,g.localize)(14,null,h):(0,g.localize)(15,null,h):h===1?(0,g.localize)(16,null,h):(0,g.localize)(17,null,h)):m<y?(h=Math.floor(m/T),c?h===1?(0,g.localize)(18,null,h):(0,g.localize)(19,null,h):h===1?(0,g.localize)(20,null,h):(0,g.localize)(21,null,h)):m<S?(h=Math.floor(m/y),c?h===1?(0,g.localize)(22,null,h):(0,g.localize)(23,null,h):h===1?(0,g.localize)(24,null,h):(0,g.localize)(25,null,h)):(h=Math.floor(m/S),c?h===1?(0,g.localize)(26,null,h):(0,g.localize)(27,null,h):h===1?(0,g.localize)(28,null,h):(0,g.localize)(29,null,h))}e.fromNow=A;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(me[152],ge([18,19]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,20,14,152]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(A,i){return i&&(A.stack||A.stacktrace)?k.localize(0,null,y(A),T(A.stack)||T(A.stacktrace)):y(A)}function T(A){return Array.isArray(A)?A.join(`
`):A}function y(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?k.localize(1,null,A.message):A.message||k.localize(2,null)}function S(A=null,i=!1){if(!A)return k.localize(3,null);if(Array.isArray(A)){const I=g.coalesce(A),c=S(I[0],i);return I.length>1?k.localize(4,null,c,I.length):c}if(R.isString(A))return A;if(A.detail){const I=A.detail;if(I.error)return C(I.error,i);if(I.exception)return C(I.exception,i)}return A.stack?C(A,i):A.message?A.message:k.localize(5,null)}e.toErrorMessage=S}),define(me[153],ge([18,19]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(me[112],ge([0,1,39,29,10,22,8,11,38,14,142,28,153]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(f){switch(f){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(f,p){if(y.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};p&&(t.cwd=p);const s=g.execFile("taskkill",["/T","/F","/PID",f.pid.toString()],t);return new Promise(o=>{s.once("error",n=>{o({success:!1,error:n})}),s.once("exit",(n,a)=>{o(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(y.isLinux||y.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(s=>{g.execFile(t,[f.pid.toString()],{encoding:"utf8",shell:!0},(o,n,a)=>{s(o?{success:!1,error:o}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else f.kill("SIGKILL");return Promise.resolve({success:!0})}function v(f=S.env){return f.comspec||"cmd.exe"}e.getWindowsShell=v;class _{constructor(p,t,s,o){if(t!==void 0&&s!==void 0&&o!==void 0)this.cmd=p,this.args=t,this.shell=s,this.options=o;else{const n=p;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(S.env).forEach(a=>{n[a]=S.env[a]}),Object.keys(this.options.env).forEach(a=>{n[a]=this.options.env[a]}),this.options.env=n}}getSanitizedCommand(){let p=this.cmd.toLowerCase();const t=p.lastIndexOf(T.sep);return t!==-1&&(p=p.substring(t+1)),_.WellKnowCommands[p]?p:"other"}start(p){return y.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(S.cwd()))?Promise.reject(new Error(c.localize(0,null))):this.useExec().then(t=>{let s,o;const n=new Promise((a,d)=>{s=a,o=d});if(t){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=g.exec(a,this.options,(d,u,w)=>{this.childProcess=null;const E=d;E&&E.killed?o({killed:this.terminateRequested,stdout:u.toString(),stderr:w.toString()}):this.handleExec(s,p,d,u,w)})}else{let a=null;const d=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,s,p,o);const w={terminated:this.terminateRequested};A.isNumber(u)&&(w.cmdCode=u),s(w)};if(this.shell&&y.isWindows){const u=C.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let w=!1,E=!1;const r=[];let D=this.ensureQuotes(this.cmd);r.push(D.value),w=D.quoted,this.args&&this.args.forEach(U=>{D=this.ensureQuotes(U),r.push(D.value),E=E&&D.quoted});const L=["/s","/c"];w?E?L.push('"'+r.join(" ")+'"'):r.length>1?L.push('"'+r[0]+'" '+r.slice(1).join(" ")):L.push('"'+r[0]+'"'):L.push(r.join(" ")),a=g.spawn(v(),L,u)}else this.cmd&&(a=g.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(A.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",u=>{this.childProcess=null,o({terminated:this.terminateRequested,error:u})}),a.pid&&(this.childProcess.on("close",d),this.handleSpawn(a,s,p,o,!0)))}return n})}handleClose(p,t,s,o){}ensureQuotes(p){return _.regexp.test(p)?{value:'"'+p+'"',quoted:!0}:{value:p,quoted:p.length>0&&p[0]==='"'&&p[p.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(p=>p.pid,p=>-1):new Promise(p=>{this.pidResolve=p})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(p=>(this.terminateRequested=!0,h(p,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),p=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(p=>{if(!this.shell||!y.isWindows)return p(!1);const t=g.spawn(v(),["/s","/c"]);t.on("error",s=>p(!0)),t.on("exit",s=>p(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class b extends _{constructor(p,t,s,o){super(p,t,s,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(p,t,s,o,n){[o,n].forEach((a,d)=>{const u=new i.LineDecoder;u.write(a).forEach(r=>{t({line:r,source:d===0?0:1})});const E=u.end();E&&t({line:E,source:d===0?0:1})}),p({terminated:this.terminateRequested,error:s})}handleSpawn(p,t,s,o,n){const a=new i.LineDecoder,d=new i.LineDecoder;p.stdout.on("data",u=>{a.write(u).forEach(E=>s({line:E,source:0}))}),p.stderr.on("data",u=>{d.write(u).forEach(E=>s({line:E,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=d}handleClose(p,t,s,o){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&s({line:n,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&s({line:a,source:1})}}e.LineProcess=b;function P(f){let p=[],t=!1;const s=function(o){if(t){p.push(o);return}(!f.send(o,a=>{if(a&&console.error(a),t=!1,p.length>0){const d=p.slice(0);p=[],d.forEach(u=>s(u))}})||y.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=P;var l;(function(f){async function p(t,s,o){if(T.isAbsolute(t))return t;if(s===void 0&&(s=S.cwd()),T.dirname(t)!=="."||(o===void 0&&A.isString(S.env.PATH)&&(o=S.env.PATH.split(T.delimiter)),o===void 0||o.length===0))return T.join(s,t);async function a(d){if(await I.Promises.exists(d)){let u;try{u=await I.Promises.stat(d)}catch(w){w.message.startsWith("EACCES")&&(u=await I.Promises.lstat(d))}return u?!u.isDirectory():!1}return!1}for(let d of o){let u;if(T.isAbsolute(d)?u=T.join(d,t):u=T.join(s,d,t),await a(u))return u;let w=u+".com";if(await a(w)||(w=u+".exe",await a(w)))return w}return T.join(s,t)}f.findExecutable=p})(l=e.win32||(e.win32={}))}),define(me[154],ge([18,19]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(me[113],ge([0,1,154,11,109]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=T;class y{constructor(){this._values=[]}_read(ee){return this._values[ee]}get(ee){return this._values[ee]}_write(ee,ve){this._values[ee]=ve}}e.ValidatedEditorOptions=y;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class A{constructor(ee,ve,Ue,Je){this.id=ee,this.name=ve,this.defaultValue=Ue,this.schema=Je}compute(ee,ve,Ue){return Ue}}class i{constructor(ee,ve=null){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(ee){return this.defaultValue}}class I{constructor(ee,ve,Ue,Je){this.id=ee,this.name=ve,this.defaultValue=Ue,this.schema=Je}validate(ee){return typeof ee=="undefined"?this.defaultValue:ee}compute(ee,ve,Ue){return Ue}}function c(X,ee){return typeof X=="undefined"?ee:X==="false"?!1:Boolean(X)}e.boolean=c;class m extends I{constructor(ee,ve,Ue,Je=void 0){typeof Je!="undefined"&&(Je.type="boolean",Je.default=Ue),super(ee,ve,Ue,Je)}validate(ee){return c(ee,this.defaultValue)}}class h extends I{constructor(ee,ve,Ue,Je,nt,at=void 0){typeof at!="undefined"&&(at.type="integer",at.default=Ue,at.minimum=Je,at.maximum=nt),super(ee,ve,Ue,at),this.minimum=Je,this.maximum=nt}static clampedInt(ee,ve,Ue,Je){if(typeof ee=="undefined")return ve;let nt=parseInt(ee,10);return isNaN(nt)?ve:(nt=Math.max(Ue,nt),nt=Math.min(Je,nt),nt|0)}validate(ee){return h.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}class v extends I{constructor(ee,ve,Ue,Je,nt){typeof nt!="undefined"&&(nt.type="number",nt.default=Ue),super(ee,ve,Ue,nt),this.validationFn=Je}static clamp(ee,ve,Ue){return ee<ve?ve:ee>Ue?Ue:ee}static float(ee,ve){if(typeof ee=="number")return ee;if(typeof ee=="undefined")return ve;const Ue=parseFloat(ee);return isNaN(Ue)?ve:Ue}validate(ee){return this.validationFn(v.float(ee,this.defaultValue))}}class _ extends I{static string(ee,ve){return typeof ee!="string"?ve:ee}constructor(ee,ve,Ue,Je=void 0){typeof Je!="undefined"&&(Je.type="string",Je.default=Ue),super(ee,ve,Ue,Je)}validate(ee){return _.string(ee,this.defaultValue)}}function b(X,ee,ve){return typeof X!="string"||ve.indexOf(X)===-1?ee:X}e.stringSet=b;class P extends I{constructor(ee,ve,Ue,Je,nt=void 0){typeof nt!="undefined"&&(nt.type="string",nt.enum=Je,nt.default=Ue),super(ee,ve,Ue,nt),this._allowedValues=Je}validate(ee){return b(ee,this.defaultValue,this._allowedValues)}}class l extends A{constructor(ee,ve,Ue,Je,nt,at,pt=void 0){typeof pt!="undefined"&&(pt.type="string",pt.enum=nt,pt.default=Je),super(ee,ve,Ue,pt),this._allowedValues=nt,this._convert=at}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function f(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends A{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(ee){switch(ee){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ee,ve,Ue){return Ue===0?ee.accessibilitySupport:Ue}}class t extends A{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{insertSpace:c(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(X){switch(X){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function d(X){switch(X){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class u extends i{constructor(){super(127,[65,32])}compute(ee,ve,Ue){const Je=["monaco-editor"];return ve.get(32)&&Je.push(ve.get(32)),ee.extraEditorClassName&&Je.push(ee.extraEditorClassName),ve.get(65)==="default"?Je.push("mouse-default"):ve.get(65)==="copy"&&Je.push("mouse-copy"),ve.get(100)&&Je.push("showUnused"),ve.get(125)&&Je.push("showDeprecated"),Je.join(" ")}}class w extends m{constructor(){super(31,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ee,ve,Ue){return Ue&&ee.emptySelectionClipboard}}class E extends A{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ee.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:g.localize(16,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:g.localize(18,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{cursorMoveOnType:c(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ee.seedSearchStringFromSelection=="boolean"?ee.seedSearchStringFromSelection?"always":"never":b(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":b(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(ve.loop,this.defaultValue.loop)}}}class r extends A{constructor(){super(43,"fontLigatures",r.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(ee){return typeof ee=="undefined"?this.defaultValue:typeof ee=="string"?ee==="false"?r.OFF:ee==="true"?r.ON:ee:Boolean(ee)?r.ON:r.OFF}}e.EditorFontLigatures=r,r.OFF='"liga" off, "calt" off',r.ON='"liga" on, "calt" on';class D extends i{constructor(){super(42)}compute(ee,ve,Ue){return ee.fontInfo}}class L extends I{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(ee){let ve=v.float(ee,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(ve,6,100)}compute(ee,ve,Ue){return ee.fontInfo.fontSize}}class U extends A{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(h.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class j extends A{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...ve},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...ve},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Ue,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Ue,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Ue,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Ue,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Ue,description:g.localize(38,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{multiple:b(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??b(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??b(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??b(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??b(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??b(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class te extends A{constructor(){const ee={enabled:!0,delay:300,sticky:!0};super(52,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:ee.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:g.localize(41,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:c(ve.enabled,this.defaultValue.enabled),delay:h.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:c(ve.sticky,this.defaultValue.sticky)}}}var K;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class O extends i{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(ee,ve,Ue){return O.computeLayout(ve,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio})}static computeContainedMinimapLineCount(ee){const ve=ee.height/ee.lineHeight,Ue=ee.scrollBeyondLastLine?ve-1:0,Je=(ee.viewLineCount+Ue)/(ee.pixelRatio*ee.height),nt=Math.floor(ee.viewLineCount/Je);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Ue,desiredRatio:Je,minimapLineCount:nt}}static _computeMinimapLayout(ee,ve){const Ue=ee.outerWidth,Je=ee.outerHeight,nt=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Je};const at=ve.stableMinimapLayoutInput,pt=at&&ee.outerHeight===at.outerHeight&&ee.lineHeight===at.lineHeight&&ee.typicalHalfwidthCharacterWidth===at.typicalHalfwidthCharacterWidth&&ee.pixelRatio===at.pixelRatio&&ee.scrollBeyondLastLine===at.scrollBeyondLastLine&&ee.minimap.enabled===at.minimap.enabled&&ee.minimap.side===at.minimap.side&&ee.minimap.size===at.minimap.size&&ee.minimap.showSlider===at.minimap.showSlider&&ee.minimap.renderCharacters===at.minimap.renderCharacters&&ee.minimap.maxColumn===at.minimap.maxColumn&&ee.minimap.scale===at.minimap.scale&&ee.verticalScrollbarWidth===at.verticalScrollbarWidth&&ee.isViewportWrapping===at.isViewportWrapping,_t=ee.lineHeight,St=ee.typicalHalfwidthCharacterWidth,le=ee.scrollBeyondLastLine,Pe=ee.minimap.renderCharacters;let Ne=nt>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const Ye=ee.minimap.maxColumn,We=ee.minimap.size,st=ee.minimap.side,Te=ee.verticalScrollbarWidth,De=ee.viewLineCount,Ie=ee.remainingWidth,ne=ee.isViewportWrapping,ue=Pe?2:3;let Ee=Math.floor(nt*Je);const be=Ee/nt;let Fe=!1,Ge=!1,$e=ue*Ne,Ze=Ne/nt,pe=1;if(We==="fill"||We==="fit"){const{typicalViewportLineCount:qe,extraLinesBeyondLastLine:ft,desiredRatio:ht,minimapLineCount:yt}=O.computeContainedMinimapLineCount({viewLineCount:De,scrollBeyondLastLine:le,height:Je,lineHeight:_t,pixelRatio:nt});if(De/yt>1)Fe=!0,Ge=!0,Ne=1,$e=1,Ze=Ne/nt;else{let ct=!1,ut=Ne+1;if(We==="fit"){const vt=Math.ceil((De+ft)*$e);ne&&pt&&Ie<=ve.stableFitRemainingWidth?(ct=!0,ut=ve.stableFitMaxMinimapScale):ct=vt>Ee}if(We==="fill"||ct){Fe=!0;const vt=Ne;$e=Math.min(_t*nt,Math.max(1,Math.floor(1/ht))),ne&&pt&&Ie<=ve.stableFitRemainingWidth&&(ut=ve.stableFitMaxMinimapScale),Ne=Math.min(ut,Math.max(1,Math.floor($e/ue))),Ne>vt&&(pe=Math.min(2,Ne/vt)),Ze=Ne/nt/pe,Ee=Math.ceil(Math.max(qe,De+ft)*$e),ne?(ve.stableMinimapLayoutInput=ee,ve.stableFitRemainingWidth=Ie,ve.stableFitMaxMinimapScale=Ne):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const de=Math.floor(Ye*Ze),ce=Math.min(de,Math.max(0,Math.floor((Ie-Te-2)*Ze/(St+Ze)))+e.MINIMAP_GUTTER_WIDTH);let q=Math.floor(nt*ce);const _e=q/nt;q=Math.floor(q*pe);const Le=Pe?1:2,Qe=st==="left"?0:Ue-ce-Te;return{renderMinimap:Le,minimapLeft:Qe,minimapWidth:ce,minimapHeightIsEditorHeight:Fe,minimapIsSampling:Ge,minimapScale:Ne,minimapLineHeight:$e,minimapCanvasInnerWidth:q,minimapCanvasInnerHeight:Ee,minimapCanvasOuterWidth:_e,minimapCanvasOuterHeight:be}}static computeLayout(ee,ve){const Ue=ve.outerWidth|0,Je=ve.outerHeight|0,nt=ve.lineHeight|0,at=ve.lineNumbersDigitCount|0,pt=ve.typicalHalfwidthCharacterWidth,_t=ve.maxDigitWidth,St=ve.pixelRatio,le=ve.viewLineCount,Pe=ee.get(122),Ne=Pe==="inherit"?ee.get(121):Pe,Ye=Ne==="inherit"?ee.get(117):Ne,We=ee.get(120),st=ee.get(2),Te=ve.isDominatedByLongLines,De=ee.get(48),Ie=ee.get(59).renderType!==0,ne=ee.get(60),ue=ee.get(94),Ee=ee.get(64),be=ee.get(92),Fe=be.verticalScrollbarSize,Ge=be.verticalHasArrows,$e=be.arrowSize,Ze=be.horizontalScrollbarSize,pe=ee.get(57),de=ee.get(36);let ce;if(typeof pe=="string"&&/^\d+(\.\d+)?ch$/.test(pe)){const Wt=parseFloat(pe.substr(0,pe.length-2));ce=h.clampedInt(Wt*pt,0,0,1e3)}else ce=h.clampedInt(pe,0,0,1e3);de&&(ce+=16);let q=0;if(Ie){const Wt=Math.max(at,ne);q=Math.round(Wt*_t)}let _e=0;De&&(_e=nt);let Le=0,Qe=Le+_e,qe=Qe+q,ft=qe+ce;const ht=Ue-_e-q-ce;let yt=!1,gt=!1,ct=-1;st!==2&&(Ne==="inherit"&&Te?(yt=!0,gt=!0):Ye==="on"||Ye==="bounded"?gt=!0:Ye==="wordWrapColumn"&&(ct=We));const ut=O._computeMinimapLayout({outerWidth:Ue,outerHeight:Je,lineHeight:nt,typicalHalfwidthCharacterWidth:pt,pixelRatio:St,scrollBeyondLastLine:ue,minimap:Ee,verticalScrollbarWidth:Fe,viewLineCount:le,remainingWidth:ht,isViewportWrapping:gt},ve.memory||new S);ut.renderMinimap!==0&&ut.minimapLeft===0&&(Le+=ut.minimapWidth,Qe+=ut.minimapWidth,qe+=ut.minimapWidth,ft+=ut.minimapWidth);const vt=ht-ut.minimapWidth,It=Math.max(1,Math.floor((vt-Fe-2)/pt)),At=Ge?$e:0;return gt&&(ct=Math.max(1,It),Ye==="bounded"&&(ct=Math.min(ct,We))),{width:Ue,height:Je,glyphMarginLeft:Le,glyphMarginWidth:_e,lineNumbersLeft:Qe,lineNumbersWidth:q,decorationsLeft:qe,decorationsWidth:ce,contentLeft:ft,contentWidth:vt,minimap:ut,viewportColumn:It,isWordWrapMinified:yt,isViewportWrapping:gt,wrappingColumn:ct,verticalScrollbarWidth:Fe,horizontalScrollbarHeight:Ze,overviewRuler:{top:At,width:Fe,height:Je-2*At,right:0}}}}e.EditorLayoutInfoComputer=O;class x extends A{constructor(){const ee={enabled:!0};super(56,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"boolean",default:ee.enabled,description:g.localize(42,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:c(ee.enabled,this.defaultValue.enabled)}}}class F extends A{constructor(){const ee={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"boolean",default:ee.enabled,description:g.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,markdownDescription:g.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,description:g.localize(45,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:c(ve.enabled,this.defaultValue.enabled),fontSize:h.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class z extends v{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ee=>v.clamp(ee,0,150),{markdownDescription:g.localize(46,null)})}compute(ee,ve,Ue){return ee.fontInfo.lineHeight}}class M extends A{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:g.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(48,null),g.localize(49,null),g.localize(50,null)],default:ee.size,description:g.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:g.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:g.localize(53,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:g.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:g.localize(56,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:c(ve.enabled,this.defaultValue.enabled),size:b(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(ve.side,this.defaultValue.side,["right","left"]),showSlider:b(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(ve.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(ve.scale,1,1,3),maxColumn:h.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function N(X){return X==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class V extends A{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{top:h.clampedInt(ve.top,0,0,1e3),bottom:h.clampedInt(ve.bottom,0,0,1e3)}}}class $ extends A{constructor(){const ee={enabled:!0,cycle:!1};super(75,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:g.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:g.localize(60,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:c(ve.enabled,this.defaultValue.enabled),cycle:c(ve.cycle,this.defaultValue.cycle)}}}class G extends i{constructor(){super(128)}compute(ee,ve,Ue){return ee.pixelRatio}}class J extends A{constructor(){const ee={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ee,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ee.strings,description:g.localize(61,null)},comments:{type:"boolean",default:ee.comments,description:g.localize(62,null)},other:{type:"boolean",default:ee.other,description:g.localize(63,null)}}}],default:ee,description:g.localize(64,null)});this.defaultValue=ee}validate(ee){if(typeof ee=="boolean")return ee;if(ee&&typeof ee=="object"){const ve=ee,Ue={other:c(ve.other,this.defaultValue.other),comments:c(ve.comments,this.defaultValue.comments),strings:c(ve.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var fe;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ye extends A{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(65,null),g.localize(66,null),g.localize(67,null),g.localize(68,null)],default:"on",description:g.localize(69,null)})}validate(ee){let ve=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof ee!="undefined"&&(typeof ee=="function"?(ve=4,Ue=ee):ee==="interval"?ve=3:ee==="relative"?ve=2:ee==="on"?ve=1:ve=0),{renderType:ve,renderFn:Ue}}}function ke(X){const ee=X.get(87);return ee==="editable"?X.get(80):ee!=="on"}e.filterValidationDecorations=ke;class Re extends A{constructor(){const ee=[],ve={type:"number",description:g.localize(70,null)};super(91,"rulers",ee,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:g.localize(71,null),format:"color-hex"}}}]},default:ee,description:g.localize(72,null)})}validate(ee){if(Array.isArray(ee)){let ve=[];for(let Ue of ee)if(typeof Ue=="number")ve.push({column:h.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Je=Ue;ve.push({column:h.clampedInt(Je.column,0,0,1e4),color:Je.color})}return ve.sort((Ue,Je)=>Ue.column-Je.column),ve}return this.defaultValue}}function Ve(X,ee){if(typeof X!="string")return ee;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Be extends A{constructor(){const ee={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",ee,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(73,null),g.localize(74,null),g.localize(75,null)],default:"auto",description:g.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(77,null),g.localize(78,null),g.localize(79,null)],default:"auto",description:g.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ee.verticalScrollbarSize,description:g.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ee.horizontalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ee.scrollByPage,description:g.localize(83,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee,Ue=h.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Je=h.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ve(ve.vertical,this.defaultValue.vertical),horizontal:Ve(ve.horizontal,this.defaultValue.horizontal),useShadows:c(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:h.clampedInt(ve.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Je,verticalSliderSize:h.clampedInt(ve.verticalSliderSize,Je,0,1e3),scrollByPage:c(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class Ke extends A{constructor(){const ee={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:g.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(85,null),g.localize(86,null),g.localize(87,null)],default:ee.mode,description:g.localize(88,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:c(ve.enabled,this.defaultValue.enabled),mode:b(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class W extends A{constructor(){const ee={enabled:!1};super(12,"bracketPairColorization",ee,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ee.enabled,description:g.localize(89,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:c(ee.enabled,this.defaultValue.enabled)}}}class Z extends A{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(90,null),g.localize(91,null)],default:ee.insertMode,description:g.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:g.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:g.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:g.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:g.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:g.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:g.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:g.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(100,null),g.localize(101,null),g.localize(102,null)],default:ee.previewMode,description:g.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:g.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(135,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{insertMode:b(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(ve.showIcons,this.defaultValue.showIcons),showStatusBar:c(ve.showStatusBar,this.defaultValue.showStatusBar),preview:c(ve.preview,this.defaultValue.preview),previewMode:b(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(ve.showMethods,this.defaultValue.showMethods),showFunctions:c(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:c(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:c(ve.showFields,this.defaultValue.showFields),showVariables:c(ve.showVariables,this.defaultValue.showVariables),showClasses:c(ve.showClasses,this.defaultValue.showClasses),showStructs:c(ve.showStructs,this.defaultValue.showStructs),showInterfaces:c(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:c(ve.showModules,this.defaultValue.showModules),showProperties:c(ve.showProperties,this.defaultValue.showProperties),showEvents:c(ve.showEvents,this.defaultValue.showEvents),showOperators:c(ve.showOperators,this.defaultValue.showOperators),showUnits:c(ve.showUnits,this.defaultValue.showUnits),showValues:c(ve.showValues,this.defaultValue.showValues),showConstants:c(ve.showConstants,this.defaultValue.showConstants),showEnums:c(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:c(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(ve.showKeywords,this.defaultValue.showKeywords),showWords:c(ve.showWords,this.defaultValue.showWords),showColors:c(ve.showColors,this.defaultValue.showColors),showFiles:c(ve.showFiles,this.defaultValue.showFiles),showReferences:c(ve.showReferences,this.defaultValue.showReferences),showFolders:c(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:c(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(ve.showSnippets,this.defaultValue.showSnippets),showUsers:c(ve.showUsers,this.defaultValue.showUsers),showIssues:c(ve.showIssues,this.defaultValue.showIssues)}}}class re extends A{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(136,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends i{constructor(){super(129,[80])}compute(ee,ve,Ue){return ve.get(80)?!0:ee.tabFocusMode}}var Q;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Q=e.WrappingIndent||(e.WrappingIndent={}));function oe(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class we extends i{constructor(){super(131,[130])}compute(ee,ve,Ue){const Je=ve.get(130);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:Je.isWordWrapMinified,isViewportWrapping:Je.isViewportWrapping,wrappingColumn:Je.wrappingColumn}}}const Me="Consolas, 'Courier New', monospace",je="Menlo, Monaco, 'Courier New', monospace",Xe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?je:R.isLinux?Xe:Me,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Se(X){return e.editorOptionsRegistry[X.id]=X,X}var tt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.codeLens=13]="codeLens",X[X.codeLensFontFamily=14]="codeLensFontFamily",X[X.codeLensFontSize=15]="codeLensFontSize",X[X.colorDecorators=16]="colorDecorators",X[X.columnSelection=17]="columnSelection",X[X.comments=18]="comments",X[X.contextmenu=19]="contextmenu",X[X.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",X[X.cursorBlinking=21]="cursorBlinking",X[X.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",X[X.cursorStyle=23]="cursorStyle",X[X.cursorSurroundingLines=24]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",X[X.cursorWidth=26]="cursorWidth",X[X.disableLayerHinting=27]="disableLayerHinting",X[X.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",X[X.domReadOnly=29]="domReadOnly",X[X.dragAndDrop=30]="dragAndDrop",X[X.emptySelectionClipboard=31]="emptySelectionClipboard",X[X.extraEditorClassName=32]="extraEditorClassName",X[X.fastScrollSensitivity=33]="fastScrollSensitivity",X[X.find=34]="find",X[X.fixedOverflowWidgets=35]="fixedOverflowWidgets",X[X.folding=36]="folding",X[X.foldingStrategy=37]="foldingStrategy",X[X.foldingHighlight=38]="foldingHighlight",X[X.foldingImportsByDefault=39]="foldingImportsByDefault",X[X.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=41]="fontFamily",X[X.fontInfo=42]="fontInfo",X[X.fontLigatures=43]="fontLigatures",X[X.fontSize=44]="fontSize",X[X.fontWeight=45]="fontWeight",X[X.formatOnPaste=46]="formatOnPaste",X[X.formatOnType=47]="formatOnType",X[X.glyphMargin=48]="glyphMargin",X[X.gotoLocation=49]="gotoLocation",X[X.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",X[X.hover=52]="hover",X[X.inDiffEditor=53]="inDiffEditor",X[X.inlineSuggest=54]="inlineSuggest",X[X.letterSpacing=55]="letterSpacing",X[X.lightbulb=56]="lightbulb",X[X.lineDecorationsWidth=57]="lineDecorationsWidth",X[X.lineHeight=58]="lineHeight",X[X.lineNumbers=59]="lineNumbers",X[X.lineNumbersMinChars=60]="lineNumbersMinChars",X[X.linkedEditing=61]="linkedEditing",X[X.links=62]="links",X[X.matchBrackets=63]="matchBrackets",X[X.minimap=64]="minimap",X[X.mouseStyle=65]="mouseStyle",X[X.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=67]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",X[X.multiCursorModifier=69]="multiCursorModifier",X[X.multiCursorPaste=70]="multiCursorPaste",X[X.occurrencesHighlight=71]="occurrencesHighlight",X[X.overviewRulerBorder=72]="overviewRulerBorder",X[X.overviewRulerLanes=73]="overviewRulerLanes",X[X.padding=74]="padding",X[X.parameterHints=75]="parameterHints",X[X.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",X[X.quickSuggestions=78]="quickSuggestions",X[X.quickSuggestionsDelay=79]="quickSuggestionsDelay",X[X.readOnly=80]="readOnly",X[X.renameOnType=81]="renameOnType",X[X.renderControlCharacters=82]="renderControlCharacters",X[X.renderIndentGuides=83]="renderIndentGuides",X[X.renderFinalNewline=84]="renderFinalNewline",X[X.renderLineHighlight=85]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=87]="renderValidationDecorations",X[X.renderWhitespace=88]="renderWhitespace",X[X.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",X[X.roundedSelection=90]="roundedSelection",X[X.rulers=91]="rulers",X[X.scrollbar=92]="scrollbar",X[X.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=94]="scrollBeyondLastLine",X[X.scrollPredominantAxis=95]="scrollPredominantAxis",X[X.selectionClipboard=96]="selectionClipboard",X[X.selectionHighlight=97]="selectionHighlight",X[X.selectOnLineNumbers=98]="selectOnLineNumbers",X[X.showFoldingControls=99]="showFoldingControls",X[X.showUnused=100]="showUnused",X[X.snippetSuggestions=101]="snippetSuggestions",X[X.smartSelect=102]="smartSelect",X[X.smoothScrolling=103]="smoothScrolling",X[X.stickyTabStops=104]="stickyTabStops",X[X.stopRenderingLineAfter=105]="stopRenderingLineAfter",X[X.suggest=106]="suggest",X[X.suggestFontSize=107]="suggestFontSize",X[X.suggestLineHeight=108]="suggestLineHeight",X[X.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",X[X.suggestSelection=110]="suggestSelection",X[X.tabCompletion=111]="tabCompletion",X[X.tabIndex=112]="tabIndex",X[X.unusualLineTerminators=113]="unusualLineTerminators",X[X.useShadowDOM=114]="useShadowDOM",X[X.useTabStops=115]="useTabStops",X[X.wordSeparators=116]="wordSeparators",X[X.wordWrap=117]="wordWrap",X[X.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=120]="wordWrapColumn",X[X.wordWrapOverride1=121]="wordWrapOverride1",X[X.wordWrapOverride2=122]="wordWrapOverride2",X[X.wrappingIndent=123]="wrappingIndent",X[X.wrappingStrategy=124]="wrappingStrategy",X[X.showDeprecated=125]="showDeprecated",X[X.inlayHints=126]="inlayHints",X[X.editorClassName=127]="editorClassName",X[X.pixelRatio=128]="pixelRatio",X[X.tabFocusMode=129]="tabFocusMode",X[X.layoutInfo=130]="layoutInfo",X[X.wrappingInfo=131]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(137,null)})),acceptSuggestionOnEnter:Se(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(138,null),""],markdownDescription:g.localize(139,null)})),accessibilitySupport:Se(new p),accessibilityPageSize:Se(new h(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(140,null)})),ariaLabel:Se(new _(4,"ariaLabel",g.localize(141,null))),autoClosingBrackets:Se(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(142,null),g.localize(143,null),""],description:g.localize(144,null)})),autoClosingDelete:Se(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(145,null),""],description:g.localize(146,null)})),autoClosingOvertype:Se(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(147,null),""],description:g.localize(148,null)})),autoClosingQuotes:Se(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(149,null),g.localize(150,null),""],description:g.localize(151,null)})),autoIndent:Se(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[g.localize(152,null),g.localize(153,null),g.localize(154,null),g.localize(155,null),g.localize(156,null)],description:g.localize(157,null)})),automaticLayout:Se(new m(10,"automaticLayout",!1)),autoSurround:Se(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(158,null),g.localize(159,null),g.localize(160,null),""],description:g.localize(161,null)})),bracketPairColorization:Se(new W),stickyTabStops:Se(new m(104,"stickyTabStops",!1,{description:g.localize(162,null)})),codeLens:Se(new m(13,"codeLens",!0,{description:g.localize(163,null)})),codeLensFontFamily:Se(new _(14,"codeLensFontFamily","",{description:g.localize(164,null)})),codeLensFontSize:Se(new h(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(165,null)})),colorDecorators:Se(new m(16,"colorDecorators",!0,{description:g.localize(166,null)})),columnSelection:Se(new m(17,"columnSelection",!1,{description:g.localize(167,null)})),comments:Se(new t),contextmenu:Se(new m(19,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new m(20,"copyWithSyntaxHighlighting",!0,{description:g.localize(168,null)})),cursorBlinking:Se(new l(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:g.localize(169,null)})),cursorSmoothCaretAnimation:Se(new m(22,"cursorSmoothCaretAnimation",!1,{description:g.localize(170,null)})),cursorStyle:Se(new l(23,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],d,{description:g.localize(171,null)})),cursorSurroundingLines:Se(new h(24,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(172,null)})),cursorSurroundingLinesStyle:Se(new P(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(173,null),g.localize(174,null)],description:g.localize(175,null)})),cursorWidth:Se(new h(26,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(176,null)})),disableLayerHinting:Se(new m(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new m(28,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new m(29,"domReadOnly",!1)),dragAndDrop:Se(new m(30,"dragAndDrop",!0,{description:g.localize(177,null)})),emptySelectionClipboard:Se(new w),extraEditorClassName:Se(new _(32,"extraEditorClassName","")),fastScrollSensitivity:Se(new v(33,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:g.localize(178,null)})),find:Se(new E),fixedOverflowWidgets:Se(new m(35,"fixedOverflowWidgets",!1)),folding:Se(new m(36,"folding",!0,{description:g.localize(179,null)})),foldingStrategy:Se(new P(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(180,null),g.localize(181,null)],description:g.localize(182,null)})),foldingHighlight:Se(new m(38,"foldingHighlight",!0,{description:g.localize(183,null)})),foldingImportsByDefault:Se(new m(39,"foldingImportsByDefault",!1,{description:g.localize(184,null)})),unfoldOnClickAfterEndOfLine:Se(new m(40,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(185,null)})),fontFamily:Se(new _(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(186,null)})),fontInfo:Se(new D),fontLigatures2:Se(new r),fontSize:Se(new L),fontWeight:Se(new U),formatOnPaste:Se(new m(46,"formatOnPaste",!1,{description:g.localize(187,null)})),formatOnType:Se(new m(47,"formatOnType",!1,{description:g.localize(188,null)})),glyphMargin:Se(new m(48,"glyphMargin",!0,{description:g.localize(189,null)})),gotoLocation:Se(new j),hideCursorInOverviewRuler:Se(new m(50,"hideCursorInOverviewRuler",!1,{description:g.localize(190,null)})),highlightActiveIndentGuide:Se(new m(51,"highlightActiveIndentGuide",!0,{description:g.localize(191,null)})),hover:Se(new te),inDiffEditor:Se(new m(53,"inDiffEditor",!1)),letterSpacing:Se(new v(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>v.clamp(X,-5,20),{description:g.localize(192,null)})),lightbulb:Se(new x),lineDecorationsWidth:Se(new I(57,"lineDecorationsWidth",10)),lineHeight:Se(new z),lineNumbers:Se(new ye),lineNumbersMinChars:Se(new h(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new m(61,"linkedEditing",!1,{description:g.localize(193,null)})),links:Se(new m(62,"links",!0,{description:g.localize(194,null)})),matchBrackets:Se(new P(63,"matchBrackets","always",["always","near","never"],{description:g.localize(195,null)})),minimap:Se(new M),mouseStyle:Se(new P(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new v(66,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:g.localize(196,null)})),mouseWheelZoom:Se(new m(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(197,null)})),multiCursorMergeOverlapping:Se(new m(68,"multiCursorMergeOverlapping",!0,{description:g.localize(198,null)})),multiCursorModifier:Se(new l(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],N,{markdownEnumDescriptions:[g.localize(199,null),g.localize(200,null)],markdownDescription:g.localize(201,null)})),multiCursorPaste:Se(new P(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(202,null),g.localize(203,null)],markdownDescription:g.localize(204,null)})),occurrencesHighlight:Se(new m(71,"occurrencesHighlight",!0,{description:g.localize(205,null)})),overviewRulerBorder:Se(new m(72,"overviewRulerBorder",!0,{description:g.localize(206,null)})),overviewRulerLanes:Se(new h(73,"overviewRulerLanes",3,0,3)),padding:Se(new V),parameterHints:Se(new $),peekWidgetDefaultFocus:Se(new P(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(207,null),g.localize(208,null)],description:g.localize(209,null)})),definitionLinkOpensInPeek:Se(new m(77,"definitionLinkOpensInPeek",!1,{description:g.localize(210,null)})),quickSuggestions:Se(new J),quickSuggestionsDelay:Se(new h(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(211,null)})),readOnly:Se(new m(80,"readOnly",!1)),renameOnType:Se(new m(81,"renameOnType",!1,{description:g.localize(212,null),markdownDeprecationMessage:g.localize(213,null)})),renderControlCharacters:Se(new m(82,"renderControlCharacters",!1,{description:g.localize(214,null)})),renderIndentGuides:Se(new m(83,"renderIndentGuides",!0,{description:g.localize(215,null)})),renderFinalNewline:Se(new m(84,"renderFinalNewline",!0,{description:g.localize(216,null)})),renderLineHighlight:Se(new P(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(217,null)],description:g.localize(218,null)})),renderLineHighlightOnlyWhenFocus:Se(new m(86,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(219,null)})),renderValidationDecorations:Se(new P(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new P(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(220,null),g.localize(221,null),g.localize(222,null),""],description:g.localize(223,null)})),revealHorizontalRightPadding:Se(new h(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new m(90,"roundedSelection",!0,{description:g.localize(224,null)})),rulers:Se(new Re),scrollbar:Se(new Be),scrollBeyondLastColumn:Se(new h(93,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(225,null)})),scrollBeyondLastLine:Se(new m(94,"scrollBeyondLastLine",!0,{description:g.localize(226,null)})),scrollPredominantAxis:Se(new m(95,"scrollPredominantAxis",!0,{description:g.localize(227,null)})),selectionClipboard:Se(new m(96,"selectionClipboard",!0,{description:g.localize(228,null),included:R.isLinux})),selectionHighlight:Se(new m(97,"selectionHighlight",!0,{description:g.localize(229,null)})),selectOnLineNumbers:Se(new m(98,"selectOnLineNumbers",!0)),showFoldingControls:Se(new P(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(230,null),g.localize(231,null)],description:g.localize(232,null)})),showUnused:Se(new m(100,"showUnused",!0,{description:g.localize(233,null)})),showDeprecated:Se(new m(125,"showDeprecated",!0,{description:g.localize(234,null)})),inlayHints:Se(new F),snippetSuggestions:Se(new P(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(235,null),g.localize(236,null),g.localize(237,null),g.localize(238,null)],description:g.localize(239,null)})),smartSelect:Se(new re),smoothScrolling:Se(new m(103,"smoothScrolling",!1,{description:g.localize(240,null)})),stopRenderingLineAfter:Se(new h(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new Z),inlineSuggest:Se(new Ke),suggestFontSize:Se(new h(107,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(241,null)})),suggestLineHeight:Se(new h(108,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(242,null)})),suggestOnTriggerCharacters:Se(new m(109,"suggestOnTriggerCharacters",!0,{description:g.localize(243,null)})),suggestSelection:Se(new P(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),tabCompletion:Se(new P(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(248,null),g.localize(249,null),g.localize(250,null)],description:g.localize(251,null)})),tabIndex:Se(new h(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new P(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(252,null),g.localize(253,null),g.localize(254,null)],description:g.localize(255,null)})),useShadowDOM:Se(new m(114,"useShadowDOM",!0)),useTabStops:Se(new m(115,"useTabStops",!0,{description:g.localize(256,null)})),wordSeparators:Se(new _(116,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:g.localize(257,null)})),wordWrap:Se(new P(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(258,null),g.localize(259,null),g.localize(260,null),g.localize(261,null)],description:g.localize(262,null)})),wordWrapBreakAfterCharacters:Se(new _(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new _(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new h(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(263,null)})),wordWrapOverride1:Se(new P(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new P(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new l(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],oe,{enumDescriptions:[g.localize(264,null),g.localize(265,null),g.localize(266,null),g.localize(267,null)],description:g.localize(268,null)})),wrappingStrategy:Se(new P(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(269,null),g.localize(270,null)],description:g.localize(271,null)})),editorClassName:Se(new u),pixelRatio:Se(new G),tabFocusMode:Se(new ae),layoutInfo:Se(new O),wrappingInfo:Se(new we)}}),define(me[155],ge([18,19]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[156],ge([18,19]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[157],ge([18,19]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[158],ge([18,19]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[159],ge([18,19]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(me[160],ge([18,19]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(me[161],ge([18,19]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(me[162],ge([18,19]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(me[163],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[164],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[165],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(me[166],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[167],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[168],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[169],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[170],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[171],ge([18,19]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(me[172],ge([18,19]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(me[173],ge([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[174],ge([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[175],ge([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[176],ge([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[177],ge([18,19]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[178],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var R;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(R=e.EditorResolution||(e.EditorResolution={}));var k;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[179],ge([0,1,157]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function C(c){return c=c.trim(),c==="*"||R.test(c)}e.isValidVersionStr=C;function T(c){if(!C(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=c.match(R);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=T;function y(c){if(!c)return null;let m=c.majorBase,h=c.majorMustEqual,v=c.minorBase,_=c.minorMustEqual,b=c.patchBase,P=c.patchMustEqual;c.hasCaret&&(m===0||(_=!1),P=!1);let l=0;if(c.preRelease){const f=k.exec(c.preRelease);if(f){const[,p,t,s]=f;l=Date.UTC(Number(p),Number(t)-1,Number(s))}}return{majorBase:m,majorMustEqual:h,minorBase:v,minorMustEqual:_,patchBase:b,patchMustEqual:P,isMinimum:c.hasGreaterEquals,notBefore:l}}e.normalizeVersion=y;function S(c,m,h){let v;typeof c=="string"?v=y(T(c)):v=c;let _;m instanceof Date?_=m.getTime():typeof m=="string"&&(_=new Date(m).getTime());let b;if(typeof h=="string"?b=y(T(h)):b=h,!v||!b)return!1;let P=v.majorBase,l=v.minorBase,f=v.patchBase,p=b.majorBase,t=b.minorBase,s=b.patchBase,o=b.notBefore,n=b.majorMustEqual,a=b.minorMustEqual,d=b.patchMustEqual;return b.isMinimum?P>p?!0:P<p?!1:l>t?!0:l<t||_&&_<o?!1:f>=s:(P===1&&p===0&&(!n||!a||!d)&&(p=1,t=0,s=0,n=!0,a=!1,d=!1),P<p?!1:P>p?!n:l<t?!1:l>t?!a:f<s?!1:f>s?!d:!(_&&_<o))}e.isValidVersion=S;function A(c,m,h,v){return h.isBuiltin||typeof h.main=="undefined"?!0:I(c,m,h.engines.vscode,v)}e.isValidExtensionVersion=A;function i(c,m,h){return c==="*"||I(m,h,c)}e.isEngineValid=i;function I(c,m,h,v=[]){let _=y(T(h));if(!_)return v.push(g.localize(0,null,h)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return v.push(g.localize(1,null,h)),!1}else if(!_.majorMustEqual)return v.push(g.localize(2,null,h)),!1;return S(c,m,_)?!0:(v.push(g.localize(3,null,c,h)),!1)}}),define(me[114],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(k,C=[],T=!1){this.ctor=k,this.staticArguments=C,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=g}),define(me[81],ge([0,1,114]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function k(T,y,S){y instanceof g.SyncDescriptor||(y=new g.SyncDescriptor(y,[],S)),R.push([T,y])}e.registerSingleton=k;function C(){return R}e.getSingletonServiceDescriptors=C}),define(me[180],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=g;class R{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let T of this._nodes.values())T.outgoing.size===0&&C.push(T);return C}insertEdge(C,T){const y=this.lookupOrInsertNode(C),S=this.lookupOrInsertNode(T);y.outgoing.set(this._hashFn(T),S),S.incoming.set(this._hashFn(C),y)}removeNode(C){const T=this._hashFn(C);this._nodes.delete(T);for(let y of this._nodes.values())y.outgoing.delete(T),y.incoming.delete(T)}lookupOrInsertNode(C){const T=this._hashFn(C);let y=this._nodes.get(T);return y||(y=new g(C),this._nodes.set(T,y)),y}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[T,y]of this._nodes)C.push(`${T}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,T]of this._nodes){const y=new Set([C]),S=this._findCycle(T,y);if(S)return S}}_findCycle(C,T){for(let[y,S]of C.outgoing){if(T.has(y))return[...T,y].join(" -> ");T.add(y);const A=this._findCycle(S,T);if(A)return A;T.delete(y)}}}e.Graph=R}),define(me[4],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function S(A){return A[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=S})(g=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function R(y,S,A,i){S[g.DI_TARGET]===S?S[g.DI_DEPENDENCIES].push({id:y,index:A,optional:i}):(S[g.DI_DEPENDENCIES]=[{id:y,index:A,optional:i}],S[g.DI_TARGET]=S)}function k(y){if(g.serviceIds.has(y))return g.serviceIds.get(y);const S=function(A,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(S,A,I,!1)};return S.toString=()=>y,g.serviceIds.set(y,S),S}e.createDecorator=k;function C(y){return y}e.refineServiceDecorator=C;function T(y){return function(S,A,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(y,S,i,!0)}}e.optional=T}),define(me[181],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function R(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(me[182],ge([0,1,3,58,6,23,76,80,181]),function(Y,e,g,R,k,C,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function A(c){return typeof c=="string"?!1:Array.isArray(c)?c.every(A):!!c.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(m,h){let v={selector:m,provider:h,_score:-1,_time:this._clock++};return this._entries.push(v),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,k.toDisposable)(()=>{if(v){let _=this._entries.indexOf(v);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),v=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const h=[];for(let v of this._entries)v._score>0&&h.push(v.provider);return h}ordered(m){const h=[];return this._orderedForEach(m,v=>h.push(v.provider)),h}orderedGroups(m){const h=[];let v,_;return this._orderedForEach(m,b=>{v&&_===b._score?v.push(b.provider):(_=b._score,v=[b.provider],h.push(v))}),h}_orderedForEach(m,h){if(!!m){this._updateScores(m);for(const v of this._entries)v._score>0&&h(v)}}_updateScores(m){let h={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===h.language&&this._lastCandidate.uri===h.uri)){this._lastCandidate=h;for(let v of this._entries)if(v._score=(0,y.score)(v.selector,m.uri,m.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(m)),A(v.selector)&&v._score>0){for(let _ of this._entries)_._score=0;v._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(m,h){return m._score<h._score?1:m._score>h._score?-1:m._time<h._time?1:m._time>h._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(m,h,v=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=h,this.max=v,this._cache=new C.LRUCache(50,.7)}_key(m){return m.id+(0,R.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const h=this._key(m),v=this._cache.get(h);return this._clamp(v?.value)}update(m,h){const v=this._key(m);let _=this._cache.get(v);return _||(_=new T.MovingAverage,this._cache.set(v,_)),_.update(h),this.get(m)}}e.LanguageFeatureRequestDelays=I}),define(me[82],ge([0,1,2,41,182,148,47]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var y;(function(r){r[r.Null=0]="Null",r[r.PlainText=1]="PlainText"})(y=e.LanguageId||(e.LanguageId={}));class S{constructor(D,L){this.language=D,this.id=L}}e.LanguageIdentifier=S;var A;(function(r){r[r.NotSet=-1]="NotSet",r[r.None=0]="None",r[r.Italic=1]="Italic",r[r.Bold=2]="Bold",r[r.Underline=4]="Underline"})(A=e.FontStyle||(e.FontStyle={}));var i;(function(r){r[r.None=0]="None",r[r.DefaultForeground=1]="DefaultForeground",r[r.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(r){r[r.Other=0]="Other",r[r.Comment=1]="Comment",r[r.String=2]="String",r[r.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(r){r[r.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",r[r.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",r[r.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",r[r.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",r[r.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",r[r.ITALIC_MASK=2048]="ITALIC_MASK",r[r.BOLD_MASK=4096]="BOLD_MASK",r[r.UNDERLINE_MASK=8192]="UNDERLINE_MASK",r[r.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",r[r.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",r[r.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",r[r.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",r[r.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",r[r.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",r[r.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",r[r.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",r[r.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",r[r.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&1792)>>>8}static getFontStyle(D){return(D&14336)>>>11}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){let L=this.getForeground(D),U="mtk"+L,j=this.getFontStyle(D);return j&1&&(U+=" mtki"),j&2&&(U+=" mtkb"),j&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(D,L){const U=this.getForeground(D),j=this.getFontStyle(D);let te=`color: ${L[U]};`;return j&1&&(te+="font-style: italic;"),j&2&&(te+="font-weight: bold;"),j&4&&(te+="text-decoration: underline;"),te}}e.TokenMetadata=m;var h;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(h=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let r=Object.create(null);return r[0]="symbol-method",r[1]="symbol-function",r[2]="symbol-constructor",r[3]="symbol-field",r[4]="symbol-variable",r[5]="symbol-class",r[6]="symbol-struct",r[7]="symbol-interface",r[8]="symbol-module",r[9]="symbol-property",r[10]="symbol-event",r[11]="symbol-operator",r[12]="symbol-unit",r[13]="symbol-value",r[14]="symbol-constant",r[15]="symbol-enum",r[16]="symbol-enum-member",r[17]="symbol-keyword",r[27]="symbol-snippet",r[18]="symbol-text",r[19]="symbol-color",r[20]="symbol-file",r[21]="symbol-reference",r[22]="symbol-customcolor",r[23]="symbol-folder",r[24]="symbol-type-parameter",r[25]="account",r[26]="issues",function(D){const L=r[D];let U=L&&T.iconRegistry.get(L);return U||(console.info("No codicon found for CompletionItemKind "+D),U=T.Codicon.symbolProperty),U.classNames}}(),e.completionKindFromString=function(){let r=Object.create(null);return r.method=0,r.function=1,r.constructor=2,r.field=3,r.variable=4,r.class=5,r.struct=6,r.interface=7,r.module=8,r.property=9,r.event=10,r.operator=11,r.unit=12,r.value=13,r.constant=14,r.enum=15,r["enum-member"]=16,r.enumMember=16,r.keyword=17,r.snippet=27,r.text=18,r.color=19,r.file=20,r.reference=21,r.customcolor=22,r.folder=23,r["type-parameter"]=24,r.typeParameter=24,r.account=25,r.issue=26,function(D,L){let U=r[D];return typeof U=="undefined"&&!L&&(U=9),U}}();var v;(function(r){r[r.Deprecated=1]="Deprecated"})(v=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var l;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(l=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(r){return r&&g.URI.isUri(r.uri)&&R.Range.isIRange(r.range)&&(R.Range.isIRange(r.originSelectionRange)||R.Range.isIRange(r.targetSelectionRange))}e.isLocationLink=t;var s;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var o;(function(r){r[r.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var n;(function(r){const D=new Map;D.set("file",0),D.set("module",1),D.set("namespace",2),D.set("package",3),D.set("class",4),D.set("method",5),D.set("property",6),D.set("field",7),D.set("constructor",8),D.set("enum",9),D.set("interface",10),D.set("function",11),D.set("variable",12),D.set("constant",13),D.set("string",14),D.set("number",15),D.set("boolean",16),D.set("array",17),D.set("object",18),D.set("key",19),D.set("null",20),D.set("enum-member",21),D.set("struct",22),D.set("event",23),D.set("operator",24),D.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function U(K){return D.get(K)}r.fromString=U;function j(K){return L.get(K)}r.toString=j;function te(K,O){const x=L.get(K);let F=x&&T.iconRegistry.get("symbol-"+x);return F||(console.info("No codicon found for SymbolKind "+K),F=T.Codicon.symbolProperty),`${O?"inline":"block"} ${F.classNames}`}r.toCssClassName=te})(n=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(D){this.value=D}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var d;(function(r){r[r.Collapsed=0]="Collapsed",r[r.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(r){r[r.Editing=0]="Editing",r[r.Preview=1]="Preview"})(u=e.CommentMode||(e.CommentMode={}));var w;(function(r){r[r.Other=0]="Other",r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var E;(function(r){r[r.None=0]="None",r[r.Option=1]="Option",r[r.Default=2]="Default",r[r.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[61],ge([0,1,11,9,4]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=g.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",g.isMacintosh),T.set("isLinux",g.isLinux),T.set("isWindows",g.isWindows),T.set("isWeb",g.isWeb),T.set("isMacNative",g.isMacintosh&&!g.isWeb),T.set("isEdge",C.indexOf("Edg/")>=0),T.set("isFirefox",C.indexOf("Firefox")>=0),T.set("isChrome",C.indexOf("Chrome")>=0),T.set("isSafari",C.indexOf("Safari")>=0);const y=Object.prototype.hasOwnProperty;var S;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return I.INSTANCE}static true(){return c.INSTANCE}static has(r){return m.create(r)}static equals(r,D){return h.create(r,D)}static notEquals(r,D){return b.create(r,D)}static regex(r,D){return s.create(r,D)}static in(r,D){return v.create(r,D)}static not(r){return P.create(r)}static and(...r){return n.create(r)}static or(...r){return a.create(r)}static greater(r,D){return l.create(r,D)}static less(r,D){return p.create(r,D)}static deserialize(r,D=!1){if(!!r)return this._deserializeOrExpression(r,D)}static _deserializeOrExpression(r,D){let L=r.split("||");return a.create(L.map(U=>this._deserializeAndExpression(U,D)))}static _deserializeAndExpression(r,D){let L=r.split("&&");return n.create(L.map(U=>this._deserializeOne(U,D)))}static _deserializeOne(r,D){if(r=r.trim(),r.indexOf("!=")>=0){let L=r.split("!=");return b.create(L[0].trim(),this._deserializeValue(L[1],D))}if(r.indexOf("==")>=0){let L=r.split("==");return h.create(L[0].trim(),this._deserializeValue(L[1],D))}if(r.indexOf("=~")>=0){let L=r.split("=~");return s.create(L[0].trim(),this._deserializeRegexValue(L[1],D))}if(r.indexOf(" in ")>=0){let L=r.split(" in ");return v.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(r)){const L=r.split(">=");return f.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(r)){const L=r.split(">");return l.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(r)){const L=r.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(r)){const L=r.split("<");return p.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(r)?P.create(r.substr(1).trim()):m.create(r)}static _deserializeValue(r,D){if(r=r.trim(),r==="true")return!0;if(r==="false")return!1;let L=/^'([^']*)'$/.exec(r);return L?L[1].trim():r}static _deserializeRegexValue(r,D){if((0,R.isFalsyOrWhitespace)(r)){if(D)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=r.indexOf("/"),U=r.lastIndexOf("/");if(L===U||L<0){if(D)throw new Error(`bad regexp-value '${r}', missing /-enclosure`);return console.warn(`bad regexp-value '${r}', missing /-enclosure`),null}let j=r.slice(L+1,U),te=r[U+1]==="i"?"i":"";try{return new RegExp(j,te)}catch(K){if(D)throw new Error(`bad regexp-value '${r}', parse error: ${K}`);return console.warn(`bad regexp-value '${r}', parse error: ${K}`),null}}}e.ContextKeyExpr=A;function i(E,r){return E.cmp(r)}class I{constructor(){this.type=0}cmp(r){return this.type-r.type}equals(r){return r.type===this.type}evaluate(r){return!1}serialize(){return"false"}keys(){return[]}map(r){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class c{constructor(){this.type=1}cmp(r){return this.type-r.type}equals(r){return r.type===this.type}evaluate(r){return!0}serialize(){return"true"}keys(){return[]}map(r){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class m{constructor(r){this.key=r,this.type=2}static create(r){const D=T.get(r);return typeof D=="boolean"?D?c.INSTANCE:I.INSTANCE:new m(r)}cmp(r){return r.type!==this.type?this.type-r.type:u(this.key,r.key)}equals(r){return r.type===this.type?this.key===r.key:!1}evaluate(r){return!!r.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(r){return r.mapDefined(this.key)}negate(){return P.create(this.key)}}e.ContextKeyDefinedExpr=m;class h{constructor(r,D){this.key=r,this.value=D,this.type=4}static create(r,D){if(typeof D=="boolean")return D?m.create(r):P.create(r);const L=T.get(r);return typeof L=="boolean"?D===(L?"true":"false")?c.INSTANCE:I.INSTANCE:new h(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return r.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(r){return r.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=h;class v{constructor(r,D){this.key=r,this.valueKey=D,this.type=10}static create(r,D){return new v(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.valueKey,r.key,r.valueKey)}equals(r){return r.type===this.type?this.key===r.key&&this.valueKey===r.valueKey:!1}evaluate(r){const D=r.getValue(this.valueKey),L=r.getValue(this.key);return Array.isArray(D)?D.indexOf(L)>=0:typeof L=="string"&&typeof D=="object"&&D!==null?y.call(D,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(r){return r.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=v;class _{constructor(r){this._actual=r,this.type=11}static create(r){return new _(r)}cmp(r){return r.type!==this.type?this.type-r.type:this._actual.cmp(r._actual)}equals(r){return r.type===this.type?this._actual.equals(r._actual):!1}evaluate(r){return!this._actual.evaluate(r)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(r){return new _(this._actual.map(r))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class b{constructor(r,D){this.key=r,this.value=D,this.type=5}static create(r,D){if(typeof D=="boolean")return D?P.create(r):m.create(r);const L=T.get(r);return typeof L=="boolean"?D===(L?"true":"false")?I.INSTANCE:c.INSTANCE:new b(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return r.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(r){return r.mapNotEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class P{constructor(r){this.key=r,this.type=3}static create(r){const D=T.get(r);return typeof D=="boolean"?D?I.INSTANCE:c.INSTANCE:new P(r)}cmp(r){return r.type!==this.type?this.type-r.type:u(this.key,r.key)}equals(r){return r.type===this.type?this.key===r.key:!1}evaluate(r){return!r.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(r){return r.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=P;class l{constructor(r,D){this.key=r,this.value=D,this.type=12}static create(r,D){return new l(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return parseFloat(r.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(r){return r.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=l;class f{constructor(r,D){this.key=r,this.value=D,this.type=13}static create(r,D){return new f(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return parseFloat(r.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(r){return r.mapGreaterEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=f;class p{constructor(r,D){this.key=r,this.value=D,this.type=14}static create(r,D){return new p(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return parseFloat(r.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(r){return r.mapSmaller(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerExpr=p;class t{constructor(r,D){this.key=r,this.value=D,this.type=15}static create(r,D){return new t(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return parseFloat(r.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(r){return r.mapSmallerEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(r,D){this.key=r,this.regexp=D,this.type=7}static create(r,D){return new s(r,D)}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.key<r.key)return-1;if(this.key>r.key)return 1;const D=this.regexp?this.regexp.source:"",L=r.regexp?r.regexp.source:"";return D<L?-1:D>L?1:0}equals(r){if(r.type===this.type){const D=this.regexp?this.regexp.source:"",L=r.regexp?r.regexp.source:"";return this.key===r.key&&D===L}return!1}evaluate(r){let D=r.getValue(this.key);return this.regexp?this.regexp.test(D):!1}serialize(){const r=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${r}`}keys(){return[this.key]}map(r){return r.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=s;class o{constructor(r){this._actual=r,this.type=8}static create(r){return new o(r)}cmp(r){return r.type!==this.type?this.type-r.type:this._actual.cmp(r._actual)}equals(r){return r.type===this.type?this._actual.equals(r._actual):!1}evaluate(r){return!this._actual.evaluate(r)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(r){return new o(this._actual.map(r))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class n{constructor(r){this.expr=r,this.type=6}static create(r){return n._normalizeArr(r)}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.expr.length<r.expr.length)return-1;if(this.expr.length>r.expr.length)return 1;for(let D=0,L=this.expr.length;D<L;D++){const U=i(this.expr[D],r.expr[D]);if(U!==0)return U}return 0}equals(r){if(r.type===this.type){if(this.expr.length!==r.expr.length)return!1;for(let D=0,L=this.expr.length;D<L;D++)if(!this.expr[D].equals(r.expr[D]))return!1;return!0}return!1}evaluate(r){for(let D=0,L=this.expr.length;D<L;D++)if(!this.expr[D].evaluate(r))return!1;return!0}static _normalizeArr(r){const D=[];let L=!1;for(const U of r)if(!!U){if(U.type===1){L=!0;continue}if(U.type===0)return I.INSTANCE;if(U.type===6){D.push(...U.expr);continue}D.push(U)}if(D.length===0&&L)return c.INSTANCE;if(D.length!==0){if(D.length===1)return D[0];for(D.sort(i);D.length>1;){const U=D[D.length-1];if(U.type!==9)break;D.pop();const j=D.pop(),te=a.create(U.expr.map(K=>n.create([K,j])));te&&(D.push(te),D.sort(i))}return D.length===1?D[0]:new n(D)}}serialize(){return this.expr.map(r=>r.serialize()).join(" && ")}keys(){const r=[];for(let D of this.expr)r.push(...D.keys());return r}map(r){return new n(this.expr.map(D=>D.map(r)))}negate(){let r=[];for(let D of this.expr)r.push(D.negate());return a.create(r)}}e.ContextKeyAndExpr=n;class a{constructor(r){this.expr=r,this.type=9}static create(r){const D=a._normalizeArr(r);if(D.length!==0)return D.length===1?D[0]:new a(D)}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.expr.length<r.expr.length)return-1;if(this.expr.length>r.expr.length)return 1;for(let D=0,L=this.expr.length;D<L;D++){const U=i(this.expr[D],r.expr[D]);if(U!==0)return U}return 0}equals(r){if(r.type===this.type){if(this.expr.length!==r.expr.length)return!1;for(let D=0,L=this.expr.length;D<L;D++)if(!this.expr[D].equals(r.expr[D]))return!1;return!0}return!1}evaluate(r){for(let D=0,L=this.expr.length;D<L;D++)if(this.expr[D].evaluate(r))return!0;return!1}static _normalizeArr(r){let D=[],L=!1;if(r){for(let U=0,j=r.length;U<j;U++){const te=r[U];if(!!te){if(te.type===0){L=!0;continue}if(te.type===1)return[c.INSTANCE];if(te.type===9){D=D.concat(te.expr);continue}D.push(te)}}if(D.length===0&&L)return[I.INSTANCE];D.sort(i)}return D}serialize(){return this.expr.map(r=>r.serialize()).join(" || ")}keys(){const r=[];for(let D of this.expr)r.push(...D.keys());return r}map(r){return new a(this.expr.map(D=>D.map(r)))}negate(){let r=[];for(let L of this.expr)r.push(L.negate());const D=L=>L.type===9?L.expr:[L];for(;r.length>1;){const L=r.shift(),U=r.shift(),j=[];for(const te of D(L))for(const K of D(U))j.push(A.and(te,K));r.unshift(A.or(...j))}return r[0]}}e.ContextKeyOrExpr=a;class d extends m{constructor(r,D,L){super(r);this._defaultValue=D,typeof L=="object"?d._info.push({...L,key:r}):L!==!0&&d._info.push({key:r,description:L,type:D!=null?typeof D:void 0})}static all(){return d._info.values()}bindTo(r){return r.createKey(this.key,this._defaultValue)}getValue(r){return r.getContextKeyValue(this.key)}toNegated(){return A.not(this.key)}isEqualTo(r){return A.equals(this.key,r)}notEqualsTo(r){return A.notEquals(this.key,r)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(E,r){return E<r?-1:E>r?1:0}function w(E,r,D,L){return E<D?-1:E>D?1:r<L?-1:r>L?1:0}}),define(me[183],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(me[184],ge([0,1,10,156,4]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=C;var T;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var y;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var S;(function(I){I.Install="install",I.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var A;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(A=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(c,m){super(c);this.code=m,this.name=m}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,9,4]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=k;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,c){if(typeof I=="undefined"||I===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof I=="string"||typeof c=="string"){let m=typeof I=="string"?I:I.value,h=typeof c=="string"?c:c.value;return g.equalsIgnoreCase(m,h)}return I._lower===c._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=y;function S(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function A(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=A,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[185],ge([0,1,9,26]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(h,v){return h.uuid&&v.uuid?h.uuid===v.uuid:h.id===v.id?!0:(0,g.compareIgnoreCase)(h.id,v.id)===0}e.areSameExtensions=k;class C{constructor(v,_){this.version=_,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof C?k(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=C;function T(h,v){return`${h}.${v}`}e.getExtensionId=T;function y(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function S(h,v){return y(T(h,v))}e.getGalleryExtensionId=S;function A(h,v){const _=[],b=P=>{for(const l of _)if(l.some(f=>k(v(f),v(P))))return l;return null};for(const P of h){const l=b(P);l?l.push(P):_.push([P])}return _}e.groupByExtension=A;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function c(h){const v=new Set;for(const _ of h)_.malicious&&v.add(_.id.id);return v}e.getMaliciousExtensionsSet=c;function m(h,v){const _=[],b=v.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const P=b.shift();if(P&&_.every(l=>!k(l.identifier,{id:P}))){const l=h.filter(f=>k(f.identifier,{id:P}));l.length===1&&(_.push(l[0]),b.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=m}),define(me[186],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(me[187],ge([0,1,39,10,8,11,140,28,112,158,186]),function(Y,e,g,R,k,C,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=A.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends c{openTerminal(f,p){return this.spawnTerminal(g,f,S.getWindowsShell(),p)}spawnTerminal(f,p,t,s){const o=p.windowsExec||m.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const n=k.basename(o).toLowerCase();if(n==="cmder"||n==="cmder.exe")return f.spawn(o,s?[s]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return o.indexOf(" ")>=0&&a.push('""'),a.push(o),(n==="wt"||n==="wt.exe")&&a.push("-d ."),new Promise((d,u)=>{const w=_(process),E=f.spawn(t,a,{cwd:s,env:w});E.on("error",u),E.on("exit",()=>d())})}runInTerminal(f,p,t,s,o){const n="windowsExec"in o&&o.windowsExec?o.windowsExec:m.getDefaultTerminalWindows();return new Promise((a,d)=>{const u=`"${p} - ${I}"`,w=`""${t.join('" "')}" & pause"`,E=["/c","start",u,"/wait",n,"/c",w],r=Object.assign({},_(process),s);Object.keys(r).filter(U=>r[U]===null).forEach(U=>delete r[U]);const D={cwd:p,env:r,windowsVerbatimArguments:!0};g.spawn(m.CMD,E,D).on("error",U=>{d(b(U))}),a(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class h extends c{openTerminal(f,p){return this.spawnTerminal(g,f,p)}runInTerminal(f,p,t,s,o){const n=o.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((a,d)=>{if(n===i.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const u=n===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[R.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,Y).fsPath,"-t",f||I,"-w",p];for(let L of t)E.push("-a"),E.push(L);if(s){const L=Object.assign({},_(process),s);for(let U in L){const j=L[U];j===null?(E.push("-u"),E.push(U)):(E.push("-e"),E.push(`${U}=${j}`))}}let r="";const D=g.spawn(h.OSASCRIPT,E);D.on("error",L=>{d(b(L))}),D.stderr.on("data",L=>{r+=L.toString()}),D.on("exit",L=>{if(L===0)a(void 0);else if(r){const U=r.split(`
`,1);d(new Error(U[0]))}else d(new Error(A.localize(1,null,u,L)))})}else d(new Error(A.localize(2,null,n)))})}spawnTerminal(f,p,t){const s=p.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((o,n)=>{const a=["-a",s];t&&a.push(t);const d=_(process),u=f.spawn("/usr/bin/open",a,{cwd:t,env:d});u.on("error",n),u.on("exit",()=>o())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class v extends c{openTerminal(f,p){return this.spawnTerminal(g,f,p)}runInTerminal(f,p,t,s,o){const n=o.linuxExec?Promise.resolve(o.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,d)=>{let u=[];n.then(w=>{w.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const E=`${P(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;u.push(`''${E}''`);const r=Object.assign({},_(process),s);Object.keys(r).filter(j=>r[j]===null).forEach(j=>delete r[j]);const D={cwd:p,env:r};let L="";const U=g.spawn(w,u,D);U.on("error",j=>{d(b(j))}),U.stderr.on("data",j=>{L+=j.toString()}),U.on("exit",j=>{if(j===0)a(void 0);else if(L){const te=L.split(`
`,1);d(new Error(te[0]))}else d(new Error(A.localize(4,null,w,j)))})})})}static async getDefaultTerminalLinuxReady(){return v._DEFAULT_TERMINAL_LINUX_READY||(v._DEFAULT_TERMINAL_LINUX_READY=new Promise(async f=>{C.isLinux?await y.Promises.exists("/etc/debian_version")?f("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?f("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?f("konsole"):process.env.COLORTERM?f(process.env.COLORTERM):process.env.TERM?f(process.env.TERM):f("xterm"):f("xterm")})),v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(f,p,t){const s=p.linuxExec?Promise.resolve(p.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((o,n)=>{s.then(a=>{const d=_(process),u=f.spawn(a,[],{cwd:t,env:d});u.on("error",n),u.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=A.localize(3,null);function _(l){const f={...l.env};return(0,T.sanitizeProcessEnvironment)(f),f}function b(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(A.localize(5,null,l.path)):l}function P(l){let f="";for(let p of l)p.indexOf(" ")>=0?f+='"'+p+'"':f+=p,f+=" ";return f}}),define(me[42],ge([0,1,23,8,9,14,2,159,4]),function(Y,e,g,R,k,C,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function A(O){return O.create===!0}e.isFileOpenForWriteOptions=A;var i;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(O){O[O.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var c;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=m;function h(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=h;function v(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function _(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=_;var b;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(x,F){super(x);this.code=F}}e.FileSystemProviderError=P;function l(O,x){const F=new P(O.toString(),x);return p(F,x),F}e.createFileSystemProviderError=l;function f(O){return O||l((0,y.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=f;function p(O,x){return O.name=x?`${x} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=p;function t(O){if(!O)return b.Unknown;if(O instanceof P)return O.code;const x=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!x)return b.Unknown;switch(x[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function s(O){if(O instanceof w)return O.fileOperationResult;switch(t(O)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var o;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(o=e.FileOperation||(e.FileOperation={}));class n{constructor(x,F,z){this.resource=x,this.operation=F,this.target=z}isOperation(x){return this.operation===x}}e.FileOperationEvent=n;var a;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class d{constructor(x,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of x)switch(z.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>F)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>F)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>F)),this.deleted.set(z.resource,z);break}}contains(x,...F){return this.doContains(x,{includeChildren:!1},...F)}affects(x,...F){return this.doContains(x,{includeChildren:!0},...F)}doContains(x,F,...z){if(!x)return!1;const M=z.length>0;return!!((!M||z.includes(1))&&(this.added?.get(x)||F.includeChildren&&this.added?.findSuperstr(x))||(!M||z.includes(0))&&(this.updated?.get(x)||F.includeChildren&&this.updated?.findSuperstr(x))||(!M||z.includes(2))&&(this.deleted?.findSubstr(x)||F.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function u(O,x,F){return!O||!x||O===x||x.length>O.length?!1:(x.charAt(x.length-1)!==R.sep&&(x+=R.sep),F?(0,k.startsWithIgnoreCase)(O,x):O.indexOf(x)===0)}e.isParent=u;class w extends Error{constructor(x,F,z){super(x);this.fileOperationResult=F,this.options=z}}e.FileOperationError=w;class E extends w{constructor(x,F,z){super(x,2,z);this.stat=F}}e.NotModifiedSinceFileOperationError=E;var r;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(r=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var D;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(D=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=L;async function U(O,x){if(!x.canHandleResource(T.URI.from({scheme:O.scheme})))return new Promise(F=>{const z=x.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===O.scheme&&M.added&&(z.dispose(),F())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize(x){return(0,C.isNumber)(x)||(x=0),x<j.KB?(0,y.localize)(1,null,x.toFixed(0)):x<j.MB?(0,y.localize)(2,null,(x/j.KB).toFixed(2)):x<j.GB?(0,y.localize)(3,null,(x/j.MB).toFixed(2)):x<j.TB?(0,y.localize)(4,null,(x/j.GB).toFixed(2)):(0,y.localize)(5,null,(x/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB;var te;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(te=e.Arch||(e.Arch={}));function K(O){return{maxFileSize:O===0?300*j.MB:16*j.GB,maxHeapSize:O===0?700*j.MB:2*700*j.MB}}e.getPlatformLimits=K}),define(me[83],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...k){this._entries=new Map;for(let[C,T]of k)this.set(C,T)}set(k,C){const T=this._entries.get(k);return this._entries.set(k,C),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=g}),define(me[188],ge([0,1,17,16,114,180,4,83]),function(Y,e,g,R,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class A extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class i{constructor(h=new y.ServiceCollection,v=!1,_){this._activeInstantiations=new Set,this._services=h,this._strict=v,this._parent=_,this._services.set(T.IInstantiationService,this)}createChild(h){return new i(h,this._strict,this)}invokeFunction(h,...v){let _=c.traceInvocation(h),b=!1;try{return h({get:(l,f)=>{if(b)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(l,_);if(!p&&f!==T.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return p}},...v)}finally{b=!0,_.stop()}}createInstance(h,...v){let _,b;return h instanceof k.SyncDescriptor?(_=c.traceCreation(h.ctor),b=this._createInstance(h.ctor,h.staticArguments.concat(v),_)):(_=c.traceCreation(h),b=this._createInstance(h,v,_)),_.stop(),b}_createInstance(h,v=[],_){let b=T._util.getServiceDependencies(h).sort((f,p)=>f.index-p.index),P=[];for(const f of b){let p=this._getOrCreateServiceInstance(f.id,_);if(!p&&this._strict&&!f.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${f.id}.`);P.push(p)}let l=b.length>0?b[0].index:v.length;if(v.length!==l){console.warn(`[createInstance] First service dependency of ${h.name} at position ${l+1} conflicts with ${v.length} static arguments`);let f=l-v.length;f>0?v=v.concat(new Array(f)):v=v.slice(0,l)}return new h(...[...v,...P])}_setServiceInstance(h,v){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,v);else if(this._parent)this._parent._setServiceInstance(h,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let v=this._services.get(h);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):v}_getOrCreateServiceInstance(h,v){let _=this._getServiceInstanceOrDescriptor(h);return _ instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,_,v.branch(h,!0)):(v.branch(h,!1),_)}_safeCreateAndCacheServiceInstance(h,v,_){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,v,_)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,v,_){const b=new C.Graph(f=>f.id.toString());let P=0;const l=[{id:h,desc:v,_trace:_}];for(;l.length;){const f=l.pop();if(b.lookupOrInsertNode(f),P++>1e3)throw new A(b);for(let p of T._util.getServiceDependencies(f.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${h} depends on ${p.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const s={id:p.id,desc:t,_trace:f._trace.branch(p.id,!0)};b.insertEdge(f,s),l.push(s)}}}for(;;){const f=b.roots();if(f.length===0){if(!b.isEmpty())throw new A(b);break}for(const{data:p}of f){if(this._getServiceInstanceOrDescriptor(p.id)instanceof k.SyncDescriptor){const s=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,s)}b.removeNode(p)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,v,_=[],b,P){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(v,_,b,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,v,_,b,P);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(h,v=[],_,b){if(_){const P=new g.IdleValue(()=>this._createInstance(h,v,b));return new Proxy(Object.create(null),{get(l,f){if(f in l)return l[f];let p=P.value,t=p[f];return typeof t!="function"||(t=t.bind(p),l[f]=t),t},set(l,f,p){return P.value[f]=p,!0}})}else return this._createInstance(h,v,b)}}e.InstantiationService=i;var I;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(I||(I={}));class c{constructor(h,v){this.type=h,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new c(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(h){return S?new c(0,h.name):c._None}branch(h,v){let _=new c(2,h.toString());return this._dep.push([h,v,_]),_}stop(){let h=Date.now()-this._start;c._totals+=h;let v=!1;function _(P,l){let f=[],p=new Array(P+1).join("	");for(const[t,s,o]of l._dep)if(s&&o){v=!0,f.push(`${p}CREATES -> ${t}`);let n=_(P+1,o);n&&f.push(n)}else f.push(`${p}uses -> ${t}`);return f.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(h>2||v)&&console.log(b.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(me[12],ge([0,1,60,3,6,11,4]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function y(){return new Date().toISOString()}var S;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class A extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=A;class i extends A{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(S.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(S.Error,this.format(o))}else this.log(S.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let o=0;o<t.length;o++){let n=t[o];if(typeof n=="object")try{n=JSON.stringify(n)}catch(a){}s+=(o>0?" ":"")+n}return s}}e.AbstractMessageLogger=i;class I extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...s){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...s):console.log(`[main ${y()}]`,t,...s))}debug(t,...s){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...s):console.log(`[main ${y()}]`,t,...s))}info(t,...s){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...s):console.log(`[main ${y()}]`,t,...s))}warn(t,...s){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,t,...s):console.warn(`[main ${y()}]`,t,...s))}error(t,...s){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,t,...s):console.error(`[main ${y()}]`,t,...s))}critical(t,...s){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,t,...s):console.error(`[main ${y()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class c extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=c;class m extends A{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,g.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class h extends A{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const o of this.logServices)o.trace(t,...s)}debug(t,...s){for(const o of this.logServices)o.debug(t,...s)}info(t,...s){for(const o of this.logServices)o.info(t,...s)}warn(t,...s){for(const o of this.logServices)o.warn(t,...s)}error(t,...s){for(const o of this.logServices)o.error(t,...s)}critical(t,...s){for(const o of this.logServices)o.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class v extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=v;class _ extends k.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,s?.always?S.Trace:this.logLevel,s),this.loggers.set(t.toString(),o),s?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class b{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=b;function P(p){if(p.verbose)return S.Trace;if(typeof p.logLevel=="string"){const t=l(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=P;function l(p){switch(p){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function f(p){switch(p){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=f}),define(me[115],ge([0,1,42,12]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(S,A,i,I){try{const c=await new Promise((m,h)=>{Y(["spdlog"],m,h)});return c.setFlushOn(R.LogLevel.Trace),c.createAsyncRotatingLogger(S,A,i,I)}catch(c){console.error(c)}return null}function C(S,A,i,I){const c=Y.__$__nodeRequire("spdlog");return c.setFlushOn(R.LogLevel.Trace),c.createRotatingLogger(S,A,i,I)}e.createRotatingLogger=C;function T(S,A,i){switch(A){case R.LogLevel.Trace:S.trace(i);break;case R.LogLevel.Debug:S.debug(i);break;case R.LogLevel.Info:S.info(i);break;case R.LogLevel.Warning:S.warn(i);break;case R.LogLevel.Error:S.error(i);break;case R.LogLevel.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}class y extends R.AbstractMessageLogger{constructor(A,i,I,c){super();this.name=A,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const A=this.rotating?6:1,i=30/A*g.ByteSize.MB;return k(this.name,this.filepath,i,A).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:c,message:m}of this.buffer)T(this._logger,c,m);this.buffer=[]}})}log(A,i){this._logger?T(this._logger,A,i):this.getLevel()<=A&&this.buffer.push({level:A,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(me[116],ge([0,1,48,160,4]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var T;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function A(h,v){return v-h}S.compare=A;const i=Object.create(null);i[S.Error]=(0,R.localize)(0,null),i[S.Warning]=(0,R.localize)(1,null),i[S.Info]=(0,R.localize)(2,null);function I(h){return i[h]||""}S.toString=I;function c(h){switch(h){case g.default.Error:return S.Error;case g.default.Warning:return S.Warning;case g.default.Info:return S.Info;case g.default.Ignore:return S.Hint}}S.fromSeverity=c;function m(h){switch(h){case S.Error:return g.default.Error;case S.Warning:return g.default.Warning;case S.Info:return g.default.Info;case S.Hint:return g.default.Ignore}}S.toSeverity=m}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var y;(function(S){const A="";function i(c){return I(c,!0)}S.makeKey=i;function I(c,m){let h=[A];return c.source?h.push(c.source.replace("\xA6","\\\xA6")):h.push(A),c.code?typeof c.code=="string"?h.push(c.code.replace("\xA6","\\\xA6")):h.push(c.code.value.replace("\xA6","\\\xA6")):h.push(A),c.severity!==void 0&&c.severity!==null?h.push(T.toString(c.severity)):h.push(A),c.message&&m?h.push(c.message.replace("\xA6","\\\xA6")):h.push(A),c.startLineNumber!==void 0&&c.startLineNumber!==null?h.push(c.startLineNumber.toString()):h.push(A),c.startColumn!==void 0&&c.startColumn!==null?h.push(c.startColumn.toString()):h.push(A),c.endLineNumber!==void 0&&c.endLineNumber!==null?h.push(c.endLineNumber.toString()):h.push(A),c.endColumn!==void 0&&c.endColumn!==null?h.push(c.endColumn.toString()):h.push(A),h.push(A),h.join("\xA6")}S.makeKeyOptionalMessage=I})(y=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(me[189],ge([0,1,3,48,4]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=R.default,e.INotificationService=(0,k.createDecorator)("notificationService");var C;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new S,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=y;class S{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=S}),define(me[190],ge([0,1,6,9,2,4]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(y){return{resolved:y,dispose(){}}}});function T(y,S){return k.URI.isUri(y)?(0,R.equalsIgnoreCase)(y.scheme,S):(0,R.startsWithIgnoreCase)(y,S+":")}e.matchesScheme=T}),define(me[191],ge([0,1,10,11,38,24]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const y=R.globals.vscode.context.configuration();if(y)T=y.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const y=(0,C.dirname)(g.FileAccess.asFileUri("",Y));T=Y.__$__nodeRequire((0,C.joinPath)(y,"product.json").fsPath);const S=Y.__$__nodeRequire((0,C.joinPath)(y,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:S.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.60.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var xe=this&&this.__param||function(Y,e){return function(g,R){e(g,R,Y)}};define(me[117],ge([0,1,17,21,6,4]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var T;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class y{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=y,y.None=Object.freeze({report(){}});let S=class extends k.Disposable{constructor(I,c){super();this.deferred=new g.DeferredPromise,c.withProgress(I,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};S=ze([xe(1,e.IProgressService)],S),e.UnmanagedProgress=S;class A extends k.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(I){this.stop();const c=++this.currentOperationId,m=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:m.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(me[34],ge([0,1,54,14]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,y){g.ok(R.isString(T)),g.ok(R.isObject(y)),g.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,y)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(me[118],ge([0,1,3,34]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class C{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,A){this.schemasById[k(S)]=A,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new C;R.Registry.add(e.Extensions.JSONContribution,T)}),define(me[84],ge([0,1,3,14,155,118,34]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const A=T.Registry.as(C.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new g.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new g.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(P,l=!0){this.registerConfigurations([P],l)}registerConfigurations(P,l=!0){const f=[];P.forEach(p=>{f.push(...this.validateAndRegisterProperties(p,l,p.extensionInfo)),this.configurationContributors.push(p),this.registerJSONConfiguration(p)}),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(P){const l=[],f=p=>{if(p.properties)for(const t in p.properties)l.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,p.properties[t]);p.allOf&&p.allOf.forEach(t=>f(t))};for(const p of P){f(p);const t=this.configurationContributors.indexOf(p);t!==-1&&this.configurationContributors.splice(t,1)}A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}registerDefaultConfigurations(P){const l=[],f=[];for(const p of P)for(const t in p)if(l.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...p[t]};const s={type:"object",default:this.defaultValues[t],description:k.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};f.push(c(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=p[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(P){const l=[];for(const f of P)for(const p in f)if(l.push(p),delete this.defaultValues[p],e.OVERRIDE_PROPERTY_PATTERN.test(p))delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p];else{const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const l of P)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(P,l=!0,f,p=3){p=R.isUndefinedOrNull(P.scope)?p:P.scope;let t=[],s=P.properties;if(s)for(let n in s){if(l&&v(n)){delete s[n];continue}const a=s[n];if(this.updatePropertyDefaultValue(n,a),e.OVERRIDE_PROPERTY_PATTERN.test(n)?a.scope=void 0:(a.scope=R.isUndefinedOrNull(a.scope)?p:a.scope,a.restricted=R.isUndefinedOrNull(a.restricted)?!!f?.restrictedConfigurations?.includes(n):a.restricted),s[n].hasOwnProperty("included")&&!s[n].included){this.excludedConfigurationProperties[n]=s[n],delete s[n];continue}else this.configurationProperties[n]=s[n];!s[n].deprecationMessage&&s[n].markdownDeprecationMessage&&(s[n].deprecationMessage=s[n].markdownDeprecationMessage),t.push(n)}let o=P.allOf;if(o)for(let n of o)t.push(...this.validateAndRegisterProperties(n,l,f,p));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const l=f=>{let p=f.properties;if(p)for(const s in p)this.updateSchema(s,p[s]);let t=f.allOf;t&&t.forEach(l)};l(P)}updateSchema(P,l){switch(e.allSettings.properties[P]=l,l.scope){case 1:e.applicationSettings.properties[P]=l;break;case 2:e.machineSettings.properties[P]=l;break;case 6:e.machineOverridableSettings.properties[P]=l;break;case 3:e.windowSettings.properties[P]=l;break;case 4:e.resourceSettings.properties[P]=l;break;case 5:e.resourceSettings.properties[P]=l,this.resourceLanguageSettingsSchema.properties[P]=l;break}}removeFromSchema(P,l){switch(delete e.allSettings.properties[P],l.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const l=`[${P}]`,f={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,f),e.allSettings.properties[l]=f,e.applicationSettings.properties[l]=f,e.machineSettings.properties[l]=f,e.machineOverridableSettings.properties[l]=f,e.windowSettings.properties[l]=f,e.resourceSettings.properties[l]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,l){let f=this.defaultValues[P];R.isUndefined(f)&&(f=l.default),R.isUndefined(f)&&(f=m(l.type)),l.default=f}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function c(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=c;function m(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const h=new i;T.Registry.add(e.Extensions.Configuration,h);function v(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?k.localize(5,null,b):h.getConfigurationProperties()[b]!==void 0?k.localize(6,null,b):null:k.localize(4,null)}e.validateProperty=v;function _(){const b=[],P=h.getConfigurationProperties();for(const l of Object.keys(P))b.push([l,P[l].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=_}),define(me[119],ge([0,1,22,14,2,84,4,34]),function(Y,e,g,R,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function S(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof k.URI)}e.isConfigurationOverrides=S;var A;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(s,o){const n=o?s?o.keys.filter(D=>s.keys.indexOf(D)===-1):[...o.keys]:[],a=s?o?s.keys.filter(D=>o.keys.indexOf(D)===-1):[...s.keys]:[],d=[];if(o&&s){for(const D of s.keys)if(o.keys.indexOf(D)!==-1){const L=b(s.contents,D),U=b(o.contents,D);g.equals(L,U)||d.push(D)}}const u=[],w=D=>{const L={};for(const U of D)for(const j of U.identifiers)L[p(j)]=U;return L},E=o?w(o.overrides):{},r=s?w(s.overrides):{};if(Object.keys(E).length)for(const D of n){const L=E[D];L&&u.push([(0,C.overrideIdentifierFromKey)(D),L.keys])}if(Object.keys(r).length)for(const D of a){const L=r[D];L&&u.push([(0,C.overrideIdentifierFromKey)(D),L.keys])}if(Object.keys(E).length&&Object.keys(r).length)for(const D of d){const L=r[D],U=E[D];if(L&&U){const j=I({contents:L.contents,keys:L.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});u.push([(0,C.overrideIdentifierFromKey)(D),[...j.added,...j.removed,...j.updated]])}}return{added:n,removed:a,updated:d,overrides:u}}e.compare=I;function c(s,o){const n=[];for(const a of Object.keys(s))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const d={};for(const u in s[a])d[u]=s[a][u];n.push({identifiers:[(0,C.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(d),contents:m(d,o)})}return n}e.toOverrides=c;function m(s,o){const n=Object.create(null);for(let a in s)h(n,a,s[a],o);return n}e.toValuesTree=m;function h(s,o,n,a){const d=o.split("."),u=d.pop();let w=s;for(let E=0;E<d.length;E++){let r=d[E],D=w[r];switch(typeof D){case"undefined":D=w[r]=Object.create(null);break;case"object":break;default:a(`Ignoring ${o} as ${d.slice(0,E+1).join(".")} is ${JSON.stringify(D)}`);return}w=D}if(typeof w=="object"&&w!==null)try{w[u]=n}catch(E){a(`Ignoring ${o} as ${d.join(".")} is ${JSON.stringify(w)}`)}else a(`Ignoring ${o} as ${d.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=h;function v(s,o){const n=o.split(".");_(s,n)}e.removeFromValueTree=v;function _(s,o){const n=o.shift();if(o.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const a=s[n];typeof a=="object"&&!Array.isArray(a)&&(_(a,o),Object.keys(a).length===0&&delete s[n])}}function b(s,o,n){function a(w,E){let r=w;for(const D of E){if(typeof r!="object"||r===null)return;r=r[D]}return r}const d=o.split("."),u=a(s,d);return typeof u=="undefined"?n:u}e.getConfigurationValue=b;function P(s,o,n){Object.keys(o).forEach(a=>{a!=="__proto__"&&(a in s?R.isObject(s[a])&&R.isObject(o[a])?P(s[a],o[a],n):n&&(s[a]=o[a]):s[a]=o[a])})}e.merge=P;function l(){const s=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=l;function f(){const s=Object.create(null),o=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let n in o){let a=o[n].default;h(s,n,a,d=>console.error(`Conflict in default settings: ${d}`))}return s}e.getDefaultValues=f;function p(s){return`[${s}]`}e.keyFromOverrideIdentifier=p;function t(s,o,n){const a=s.inspect(o),d=s.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:a.defaultValue}e.getMigratedSettingValue=t}),define(me[192],ge([0,1,20,3,57,6,23,22,14,2,119,84,34]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},s=[],o=[]){this._contents=t,this._keys=s,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const o=this.getContentsForOverrideIdentifer(s);return o?t?(0,i.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let o={};for(const n of g.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[n],d=s[n];d&&(typeof a=="object"&&typeof d=="object"?(a=y.deepClone(a),this.mergeContents(a,d)):a=d),o[n]=a}return new m(o,this.keys,this.overrides)}merge(...t){const s=y.deepClone(this.contents),o=y.deepClone(this.overrides),n=[...this.keys];for(const a of t){this.mergeContents(s,a.contents);for(const d of a.overrides){const[u]=o.filter(w=>g.equals(w.identifiers,d.identifiers));u?this.mergeContents(u.contents,d.contents):o.push(y.deepClone(d))}for(const d of a.keys)n.indexOf(d)===-1&&n.push(d)}return new m(s,n,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const o of Object.keys(s)){if(o in t&&S.isObject(t[o])&&S.isObject(s[o])){this.mergeContents(t[o],s[o]);continue}t[o]=y.deepClone(s[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,i.addToValueTree)(this.contents,t,s,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let o=0;o<s;o++)t.indexOf(this.keys[o])===0&&(s=o);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=m;class h extends m{constructor(){const t=(0,i.getDefaultValues)(),s=(0,i.getConfigurationKeys)(),o=[];for(const n of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(n)&&o.push({identifiers:[(0,I.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,i.toValuesTree)(t[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,s,o)}}e.DefaultConfigurationModel=h;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!S.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:o,keys:n,overrides:a,restricted:d}=this.doParseRaw(t,s);this._configurationModel=new m(o,n,a),this._restrictedConfigurations=d||[]}doParseContent(t){let s={},o=null,n=[],a=[],d=[];function u(E){Array.isArray(n)?n.push(E):o!==null&&(n[o]=E)}let w={onObjectBegin:()=>{let E={};u(E),a.push(n),n=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let E=[];u(E),a.push(n),n=E,o=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:u,onError:(E,r,D)=>{d.push({error:E,offset:r,length:D})}};if(t)try{k.visit(t,w),s=n[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return s}doParseRaw(t,s){const o=c.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,o,!0,s);t=n.raw;const a=(0,i.toValuesTree)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),d=Object.keys(t),u=(0,i.toOverrides)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:a,keys:d,overrides:u,restricted:n.restricted}}filter(t,s,o,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const a={},d=[];for(let u in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(u)&&o){const w=this.filter(t[u],s,!1,n);a[u]=w.raw,d.push(...w.restricted)}else{const w=s[u],E=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&d.push(u),(E===void 0||n.scopes===void 0||n.scopes.includes(E))&&(n.skipRestricted&&w?.restricted||(a[u]=t[u]))}return{raw:a,restricted:d}}}e.ConfigurationModelParser=v;class _ extends C.Disposable{constructor(t,s,o,n){super();this.userSettingsResource=t,this.scopes=s,this.fileService=n,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class b{constructor(t,s,o=new m,n=new m,a=new T.ResourceMap,d=new m,u=new T.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=o,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=d,this._memoryConfigurationByResource=u,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,s,o){return this.getConsolidateConfigurationModel(s,o).getValue(t)}updateValue(t,s,o={}){let n;o.resource?(n=this._memoryConfigurationByResource.get(o.resource),n||(n=new m,this._memoryConfigurationByResource.set(o.resource,n))):n=this._memoryConfiguration,s===void 0?n.removeValue(t):n.setValue(t,s),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,o){const n=this.getConsolidateConfigurationModel(s,o),a=this.getFolderConfigurationModelForResource(s.resource,o),d=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),r=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),D=o?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,U=s.overrideIdentifier?d.override(s.overrideIdentifier).getValue(t):d.getValue(t),j=n.getValue(t),te=g.distinct(g.flatten(n.overrides.map(K=>K.identifiers))).filter(K=>n.getOverrideValue(t,K)!==void 0);return{defaultValue:u,userValue:w,userLocalValue:E,userRemoteValue:r,workspaceValue:D,workspaceFolderValue:L,memoryValue:U,value:j,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:r!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:D!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:a?.freeze().getValue(t),override:s.overrideIdentifier?a?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:d.getValue(t),override:s.overrideIdentifier?d.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:te.length?te:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const o=s.filter(n=>I.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=(0,I.overrideIdentifierFromKey)(n),d=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=t.getKeysForOverrideIdentifier(a),w=[...u.filter(E=>d.indexOf(E)===-1),...d.filter(E=>u.indexOf(E)===-1),...d.filter(E=>!y.equals(this._defaultConfiguration.override(a).getValue(E),t.override(a).getValue(E)))];return[a,w]});return this.updateDefaultConfiguration(t),{keys:s,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:o,removed:n,overrides:a}=(0,i.compare)(this.localUserConfiguration,t),d=[...s,...o,...n];return d.length&&this.updateLocalUserConfiguration(t),{keys:d,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:o,removed:n,overrides:a}=(0,i.compare)(this.remoteUserConfiguration,t);let d=[...s,...o,...n];return d.length&&this.updateRemoteUserConfiguration(t),{keys:d,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:o,removed:n,overrides:a}=(0,i.compare)(this.workspaceConfiguration,t);let d=[...s,...o,...n];return d.length&&this.updateWorkspaceConfiguration(t),{keys:d,overrides:a}}compareAndUpdateFolderConfiguration(t,s){const o=this.folderConfigurations.get(t),{added:n,updated:a,removed:d,overrides:u}=(0,i.compare)(o,s);let w=[...n,...a,...d];return(w.length||!o)&&this.updateFolderConfiguration(t,s),{keys:w,overrides:u}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:n,removed:a,overrides:d}=(0,i.compare)(s,void 0);return{keys:[...o,...n,...a],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let o=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},s){let o=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const n=s.getFolder(t);n&&(o=this.getFolderConsolidatedConfiguration(n.uri)||o);const a=this._memoryConfigurationByResource.get(t);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const o=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(s=o.merge(n),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=o}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const o=s.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:o,overrides:n,keys:a}=this._folderConfigurations.get(s);return t.push([s,{contents:o,overrides:n,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((d,u)=>(d.set(A.URI.revive(u[0]),this.parseConfigurationModel(u[1])),d),new T.ResourceMap);return new b(s,o,new m,n,a,new m,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function P(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,s=new Map;for(const n of p)n.keys.forEach(a=>t.add(a)),n.overrides.forEach(([a,d])=>{const u=(0,T.getOrSet)(s,a,new Set);d.forEach(w=>u.add(w))});const o=[];return s.forEach((n,a)=>o.push([a,[...n.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=P;class l{constructor(t,s,o,n){this.change=t,this.previous=s,this.currentConfiguraiton=o,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(u=>a.add(u)),t.overrides.forEach(([,u])=>u.forEach(w=>a.add(w))),this.affectedKeys=[...a.values()];const d=new m;this.affectedKeys.forEach(u=>d.setValue(u,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!y.equals(o,n)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let o=(0,i.toValuesTree)({[s]:!0},()=>{}),n;for(;typeof o=="object"&&(n=Object.keys(o)[0]);){if(t=t[n],!t)return!1;o=o[n]}return!0}}e.ConfigurationChangeEvent=l;class f extends l{constructor(t,s,o,n){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=o,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=f}),define(me[120],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(T,y=R.Unknown,S){super(T);this._message=T,this._code=y,this._detail=S,this.isHandled=y===R.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(T){return T instanceof k&&T._code===R.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof k&&T._code===R.NoResolverFound}static isHandled(T){return T instanceof k&&T.isHandled}}e.RemoteAuthorityResolverError=k}),define(me[85],ge([0,1,10]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(A){return A.scheme===g.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=R;function k(A){if(!A)return;const i=A.indexOf("+");return i<0?A:A.substr(0,i)}e.getRemoteName=k;function C(A){return A.scheme!==g.Schemas.file&&A.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=C;function T(A){if(A.folders.length)return A.folders.every(i=>C(i.uri))?A.folders[0].uri:void 0;if(A.configuration&&C(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=T;function y(A){return T(A)?.scheme}e.getVirtualWorkspaceScheme=y;function S(A){return T(A)!==void 0}e.isVirtualWorkspace=S}),define(me[193],ge([0,1,3,11,4,12]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var T;(function(m){m.Http="http",m.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var y;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=i;function I(m,h){return h?h!==1&&m<1024:!R.isWindows&&m<1024}e.isPortPrivileged=I;let c=class{constructor(h){this.logService=h,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h,v){return this._tunnelProvider=h,h?(this._canElevate=v.elevation,this._canMakePublic=v.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async h=>{const v=[],_=Array.from(this._tunnels.values());for(let b of _){const P=Array.from(b.values());for(let l of P){const f=await l.value;f&&v.push(f)}}h(v)})}async dispose(){for(const h of this._tunnels.values()){for(const{value:v}of h.values())await v.then(_=>_?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,v,_,b,P=!1,l=!1,f){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${_} on local port ${b}.`),!h)return;v||(v="localhost");const p=this.retainOrCreateTunnel(h,v,_,b,P,l,f);return p?p.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,_);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==v||t.tunnelRemotePort!==_)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,public:h.public,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const v=this._tunnels.get(h.tunnelRemoteHost);if(v){const _=v.get(h.tunnelRemotePort);_&&(_.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,_))}}}}async tryDisposeTunnel(h,v,_){if(_.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${v}.`);const b=_.value.then(async P=>{P&&(await P.dispose(!0),this._onTunnelClosed.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(v),b}}async closeTunnel(h,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${v} `);const _=this._tunnels.get(h);if(_&&_.has(v)){const b=_.get(v);b.refcount=0,await this.tryDisposeTunnel(h,v,b)}}addTunnelToMap(h,v,_){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(v,{refcount:1,value:_})}async removeEmptyTunnelFromMap(h,v){const _=this._tunnels.get(h);_&&(await _.get(v)||_.delete(v),_.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,v){let _=[h];A(h)?(_.push(...e.LOCALHOST_ADDRESSES),_.push(...e.ALL_INTERFACES_ADDRESSES)):i(h)&&_.push(...e.ALL_INTERFACES_ADDRESSES);const b=_.map(P=>this._tunnels.get(P));for(const P of b){const l=P?.get(v);if(l)return l}}canTunnel(h){return!!S(h)}createWithProvider(h,v,_,b,P,l,f){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${_} on local port ${b}.`);const t={elevationRequired:P?I(b===void 0?_:b):!1},s={remoteAddress:{host:v,port:_},localAddressPort:b,public:l,protocol:f},o=h.forwardPort(s,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),o&&this.addTunnelToMap(v,_,o),o}};c=ze([xe(0,C.ILogService)],c),e.AbstractTunnelService=c}),define(me[194],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{vsda(){return new Promise((k,C)=>Y(["vsda"],k,C))}async sign(k){try{const C=await this.vsda(),T=new C.signer;if(T)return T.sign(k)}catch(C){}return k}}e.SignService=g}),define(me[195],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,C,T=5){let y;return y=C(S=>{const A=typeof S=="string"?S:S.data;let i=this._terminalBufferMap.get(k);if(i){i.data.push(A);return}const I=setTimeout(()=>this.flushBuffer(k),T);i={data:[A],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(k),y.dispose()}},this._terminalBufferMap.set(k,i)}),y}stopBuffering(k){const C=this._terminalBufferMap.get(k);C&&C.dispose()}flushBuffer(k){const C=this._terminalBufferMap.get(k);C&&(this._terminalBufferMap.delete(k),this._callback(k,C.data.join("")))}}e.TerminalDataBufferer=g}),define(me[196],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(me[62],ge([0,1,47,3,6,4,34,196]),function(Y,e,g,R,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var S;(function(_){function b(P){return P&&typeof P=="object"&&typeof P.id=="string"}_.isThemeColor=b})(S=e.ThemeColor||(e.ThemeColor={}));function A(_){return{id:_}}e.themeColorFromId=A;var i;(function(_){function b(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||S.isThemeColor(s.color))}_.isThemeIcon=b;const P=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function l(s){const o=P.exec(s);if(!o)return;let[,n]=o;return{id:n}}_.fromString=l;function f(s,o){let n=s.id;const a=n.lastIndexOf("~");return a!==-1&&(n=n.substring(0,a)),o&&(n=`${n}~${o}`),{id:n}}_.modify=f;function p(s,o){return s.id===o.id&&s.color?.id===o.color?.id}_.isEqual=p;function t(s,o){return{id:s.id,color:o?A(o):void 0}}_.asThemeIcon=t,_.asClassNameArray=g.CSSIcon.asClassNameArray,_.asClassName=g.CSSIcon.asClassName,_.asCSSSelector=g.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function I(_){switch(_){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new R.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,k.toDisposable)(()=>{const P=this.themingParticipants.indexOf(b);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new c;T.Registry.add(e.Extensions.ThemingContribution,m);function h(_){return m.onColorThemeChange(_)}e.registerThemingParticipant=h;class v extends k.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,P){let l=this.theme.getColor(b);return l&&P&&(l=P(l,this.theme)),l?l.toString():null}}e.Themable=v}),define(me[197],ge([0,1,17,47,3,161,118,34,62]),function(Y,e,g,R,k,C,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class A{constructor(){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,C.localize)(0,null)},fontCharacter:{type:"string",description:(0,C.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${R.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(b,P,l,f){const p=this.iconsById[b];if(p){if(l&&!p.description){p.description=l,this.iconSchema.properties[b].markdownDescription=`${l} $(${b})`;const o=this.iconReferenceSchema.enum.indexOf(b);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=l),this._onDidChange.fire()}return p}let t={id:b,description:l,defaults:P,deprecationMessage:f};this.iconsById[b]=t;let s={$ref:"#/definitions/icons"};return f&&(s.deprecationMessage=f),l&&(s.markdownDescription=`${l}: $(${b})`),this.iconSchema.properties[b]=s,this.iconReferenceSchema.enum.push(b),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:b}}deregisterIcon(b){delete this.iconsById[b],delete this.iconSchema.properties[b];const P=this.iconReferenceSchema.enum.indexOf(b);P!==-1&&(this.iconReferenceSchema.enum.splice(P,1),this.iconReferenceSchema.enumDescriptions.splice(P,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(b=>this.iconsById[b])}getIcon(b){return this.iconsById[b]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(b,P){const l=this.iconFontsById[b];if(l)return l;let f={id:b,definition:P};return this.iconFontsById[b]=f,this._onDidChange.fire(),f}deregisterIconFont(b){delete this.iconFontsById[b]}getIconFonts(){return Object.keys(this.iconFontsById).map(b=>this.iconFontsById[b])}getIconFont(b){return this.iconFontsById[b]}toString(){const b=(p,t)=>p.id.localeCompare(t.id),P=p=>{for(;S.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of f.filter(t=>!!t.description).sort(b))l.push(`|<i class="${P(p)}"></i>|${p.id}|${S.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const p of f.filter(t=>!S.ThemeIcon.isThemeIcon(t.defaults)).sort(b))l.push(`|<i class="${P(p)}"></i>|${p.id}|`);return l.join(`
`)}}const i=new A;y.Registry.add(e.Extensions.IconContribution,i);function I(_,b,P,l){return i.registerIcon(_,b,P,l)}e.registerIcon=I;function c(){return i}e.getIconRegistry=c;function m(){for(const _ of R.iconRegistry.all)i.registerIcon(_.id,_.definition,_.description);R.iconRegistry.onDidRegister(_=>i.registerIcon(_.id,_.definition,_.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let h=y.Registry.as(T.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,i.getIconSchema());const v=new g.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=I("widget-close",R.Codicon.close,(0,C.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",R.Codicon.arrowUp,(0,C.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",R.Codicon.arrowDown,(0,C.localize)(4,null)),e.syncing=S.ThemeIcon.modify(R.Codicon.sync,"spin")}),define(me[43],ge([0,1,23,24,2,4]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var T;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function y(c){const m=c;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=y;function S(c){const m=c;return!!(m&&typeof m=="object"&&k.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=S;class A{constructor(m,h,v,_){this._id=m,this._configuration=v,this._ignorePathCasing=_,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=A;class i{constructor(m,h){this.raw=h,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,R.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(c){return new i({uri:c,index:0,name:(0,R.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=I}),define(me[198],ge([0,1,29,57,138,78,10,8,11,24,2,162,4,85,43]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(O){return(typeof O=="string"?(0,y.extname)(O):(0,A.extname)(O))===v}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function b(O){return O.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function P(O){return O.hasOwnProperty("folderUri")}e.isRecentFolder=P;function l(O){return O.hasOwnProperty("fileUri")}e.isRecentFile=l;function f(O){const x=O;return typeof x?.id=="string"&&i.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=f;function p(O){if(O.configuration)return{id:O.id,configPath:O.configuration};if(O.folders.length===1)return{id:O.id,uri:O.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(O){const x=O;return typeof x?.id=="string"&&i.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function s(O){const x=O;if(x?.uri)return{id:x.id,uri:i.URI.revive(x.uri)};const F=O;if(F?.configPath)return{id:F.id,configPath:i.URI.revive(F.configPath)};if(O?.id)return{id:O.id}}e.reviveIdentifier=s;function o(O,x){return A.extUriBiasedIgnorePathCase.isEqualOrParent(O,x.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function n(O){return a(O)||d(O)}e.isStoredWorkspaceFolder=n;function a(O){const x=O;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=a;function d(O){const x=O;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=d;function u(O,x,F,z,M=!S.isWindows,N){if(O.scheme!==z.scheme)return{name:F,uri:O.toString(!0)};let V=x?void 0:N.relativePath(z,O);if(V!==void 0)V.length===0?V=".":S.isWindows&&O.scheme===T.Schemas.file&&!M&&(V=V.replace(/\//g,"\\"));else if(O.scheme===T.Schemas.file)V=O.fsPath,S.isWindows&&(V=(0,C.normalizeDriveLetter)(V),M&&(V=(0,g.toSlashes)(V)));else{if(!N.isEqualAuthority(O.authority,z.authority))return{name:F,uri:O.toString(!0)};V=O.path}return{name:F,path:V}}e.getStoredWorkspaceFolder=u;function w(O,x,F){let z=[],M=new Set;const N=F.dirname(x);for(let V of O){let $;if(a(V))V.path&&($=F.resolvePath(N,V.path));else if(d(V))try{$=i.URI.parse(V.uri),$.path[0]!=="/"&&($=$.with({path:"/"+$.path}))}catch(G){console.warn(G)}if($){let G=F.getComparisonKey($);if(!M.has(G)){M.add(G);const J=V.name||F.basenameOrAuthority($);z.push(new h.WorkspaceFolder({uri:$,name:J,index:z.length},V))}}}return z}e.toWorkspaceFolders=w;function E(O,x,F,z,M){let N=r(x,O);const V=M.dirname(x),$=M.dirname(z),G=[],J=D(N.folders);for(const Re of N.folders){const Ve=a(Re)?M.resolvePath(V,Re.path):i.URI.parse(Re.uri);let Be;F?Be=!1:Be=!a(Re)||(0,y.isAbsolute)(Re.path),G.push(u(Ve,Be,Re.name,$,J,M))}const fe={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},ye=k.setProperty(O,["folders"],G,fe);let ke=k.applyEdits(O,ye);return N.remoteAuthority===(0,m.getRemoteAuthority)(z)&&(ke=k.applyEdits(ke,k.removeProperty(ke,["remoteAuthority"],fe))),ke}e.rewriteWorkspaceFileForNewLocation=E;function r(O,x){let F=R.parse(x);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(z=>n(z));else throw new Error(`${O} looks like an invalid workspace file.`);return F}function D(O){return S.isWindows?O.some(x=>a(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=D;function L(O){return O.workspace&&typeof O.workspace=="object"&&typeof O.workspace.id=="string"&&typeof O.workspace.configPath=="string"}function U(O){return typeof O.folderUri=="string"}function j(O){return typeof O.fileUri=="string"}function te(O,x){const F={workspaces:[],files:[]};if(O){const z=function(N,V){for(let $=0;$<N.length;$++)try{V(N[$],$)}catch(G){x.warn(`Error restoring recent entry ${JSON.stringify(N[$])}: ${G.toString()}. Skip entry.`)}},M=O;if(Array.isArray(M.entries))z(M.entries,N=>{const V=N.label,$=N.remoteAuthority;L(N)?F.workspaces.push({label:V,remoteAuthority:$,workspace:{id:N.workspace.id,configPath:i.URI.parse(N.workspace.configPath)}}):U(N)?F.workspaces.push({label:V,remoteAuthority:$,folderUri:i.URI.parse(N.folderUri)}):j(N)&&F.files.push({label:V,remoteAuthority:$,fileUri:i.URI.parse(N.fileUri)})});else{const N=O;Array.isArray(N.workspaces3)&&z(N.workspaces3,(V,$)=>{const G=Array.isArray(N.workspaceLabels)&&N.workspaceLabels[$]||void 0;typeof V=="object"&&typeof V.id=="string"&&typeof V.configURIPath=="string"?F.workspaces.push({label:G,workspace:{id:V.id,configPath:i.URI.parse(V.configURIPath)}}):typeof V=="string"&&F.workspaces.push({label:G,folderUri:i.URI.parse(V)})}),Array.isArray(N.files2)&&z(N.files2,(V,$)=>{const G=Array.isArray(N.fileLabels)&&N.fileLabels[$]||void 0;typeof V=="string"&&F.files.push({label:G,fileUri:i.URI.parse(V)})})}}return F}e.restoreRecentlyOpened=te;function K(O){const x={entries:[]};for(const F of O.workspaces)P(F)?x.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):x.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of O.files)x.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return x}e.toStoreData=K}),define(me[86],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const C=this._idPool++;return this._data.set(C,k),this.logDebugInfo(),C}get(k,C){return this._data.has(k)?this._data.get(k)[C]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(me[51],ge([0,1,2,3,4]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class C{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(S=>({name:S.name,group:S.group,resource:g.URI.revive(S.resource),isActive:S.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=C}),define(me[63],ge([0,1,10,4]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(T,y){y===null?this._providerInfo.delete(T):this._providerInfo.set(T,y)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(me[199],ge([0,1,17]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(T,y,S){this._deferredPromises=new Map,this._id=T,this._shared=y,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of A.values())i.complete()}catch(i){for(const I of A.values())I.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,y){let S=this._value[T];return typeof S=="undefined"&&(S=y),S}update(T,y){this._value[T]=y;let S=this._deferredPromises.get(T);if(S!==void 0)return S.p;const A=new g.DeferredPromise;return this._deferredPromises.set(T,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class k extends R{constructor(T,y){super(T.identifier.value,!0,y);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=k}),define(me[200],ge([0,1,3,2,12]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(y,S){this._logService=y,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(y,S,A){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(y)).acceptModelChanged(S,A)}$acceptDirtyStateChanged(y,S){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(y)).acceptDirty(S)}$acceptModelSaved(y){const S=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(y));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(y,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",y.path,S);const A=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(y));A.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};C=ze([xe(0,k.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(me[13],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class R{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=R});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},He=this&&this.__classPrivateFieldGet||function(Y,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(Y):R?R.value:e.get(Y)};define(me[201],ge([0,1,26,3]),function(Y,e,g,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(y,S){k.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(y.identifier),rt(this,k,S,"f"),He(this,k,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(y){return He(this,k,"f").get(this._id,y)}store(y,S){return He(this,k,"f").store(this._id,y,S)}delete(y){return He(this,k,"f").delete(this._id,y)}}e.ExtensionSecrets=C,k=new WeakMap}),define(me[121],ge([0,1,4,3]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(me[87],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(P){P[P.Upsert=0]="Upsert",P[P.RemoveChild=1]="RemoveChild",P[P.Invalidated=2]="Invalidated",P[P.SetProp=3]="SetProp",P[P.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const R=new WeakMap,k=(P,l)=>{const f={controllerId:l};return R.set(P,f),f};e.createPrivateApiFor=k;const C=P=>R.get(P);e.getPrivateApiFor=C;const T=(P,l,f,p)=>{let t=f;return{enumerable:!0,configurable:!1,get(){return t},set(s){p(t,s)||(t=s,P.listener?.({op:3,key:l,value:s}))}}},y=(P,l)=>P===l,S={range:(P,l)=>P===l?!0:!P||!l?!1:P.isEqual(l),label:y,description:y,busy:y,error:y,canResolveChildren:y,tags:(P,l)=>!(P.length!==l.length||P.some(f=>!l.find(p=>f.id===p.id)))},A=Object.keys(S),i=(P,l)=>({range:T(P,"range",void 0,S.range),label:T(P,"label",l,S.label),description:T(P,"description",void 0,S.description),canResolveChildren:T(P,"canResolveChildren",!1,S.canResolveChildren),busy:T(P,"busy",!1,S.busy),error:T(P,"error",void 0,S.error),tags:T(P,"tags",[],S.tags)}),I=(P,l)=>{const f=new Map;for(const p of A)S[p](P[p],l[p])||f.set(p,l[p]);return f};e.diffTestItems=I;class c extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=c;class m extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class h extends Error{constructor(l,f,p){super(`TestItem with ID "${l}" is from controller "${f}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=h;const v=P=>{const l=(0,e.getPrivateApiFor)(P);let f=new Map;return{get size(){return f.size},forEach(p,t){for(const s of f.values())p.call(t,s,this)},replace(p){const t=new Map,s=new Set(f.keys()),o={op:4,ops:[]};for(const n of p){if(!(n instanceof _))throw new m(n.id);const a=(0,e.getPrivateApiFor)(n).controllerId;if(a!==l.controllerId)throw new h(n.id,a,l.controllerId);if(t.has(n.id))throw new c(n.id);t.set(n.id,n),s.delete(n.id),o.ops.push({op:0,item:n})}for(const n of s.keys())o.ops.push({op:1,id:n});l.listener?.(o),f=t},add(p){if(!(p instanceof _))throw new m(p.id);f.set(p.id,p),l.listener?.({op:0,item:p})},delete(p){f.delete(p)&&l.listener?.({op:1,id:p})},get(p){return f.get(p)},toJSON(){return Array.from(f.values())},[Symbol.iterator](){return f.values()}}};class _{constructor(l,f,p,t){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const s=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof b?void 0:s.parent}},children:{value:v(this),enumerable:!0,writable:!1},...i(s,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class b extends _{constructor(l,f){super(l,l,f,void 0)}}e.TestItemRootImpl=b}),define(me[52],ge([0,1,4,3,13]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var C;(function(y){function S(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,protocol:i.protocol}}y.fromApiTunnel=S;function A(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public,protocol:i.protocol}}y.fromServiceTunnel=A})(C=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let T=class{constructor(S){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,A){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,A){return{dispose:()=>{}}}async $providePortAttributes(S,A,i,I,c){return[]}async $forwardPort(S,A){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=ze([xe(0,k.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},He=this&&this.__classPrivateFieldGet||function(Y,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(Y):R?R.value:e.get(Y)};define(me[7],ge([0,1,20,16,98,23,101,14,2,32,42,120]),function(Y,e,g,R,k,C,T,y,S,A,i,I){"use strict";var c,m,h,v,_,b,P,l,f,p,t,s,o,n,a,d,u,w,E,r;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(H){function B(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf(B,H),Object.setPrototypeOf(B.prototype,H.prototype),B}let L=_=class{constructor(B){c.set(this,void 0),rt(this,c,B,"f")}static from(...B){let se=B;return new _(function(){if(se){for(const Ce of se)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();se=void 0}})}dispose(){typeof He(this,c,"f")=="function"&&(He(this,c,"f").call(this),rt(this,c,void 0,"f"))}};c=new WeakMap,L=_=ze([D],L),e.Disposable=L;let U=b=class{constructor(B,se){if(B<0)throw(0,R.illegalArgument)("line must be non-negative");if(se<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=B,this._character=se}static Min(...B){if(B.length===0)throw new TypeError;let se=B[0];for(let Ce=1;Ce<B.length;Ce++){const et=B[Ce];et.isBefore(se)&&(se=et)}return se}static Max(...B){if(B.length===0)throw new TypeError;let se=B[0];for(let Ce=1;Ce<B.length;Ce++){const et=B[Ce];et.isAfter(se)&&(se=et)}return se}static isPosition(B){if(!B)return!1;if(B instanceof b)return!0;let{line:se,character:Ce}=B;return typeof se=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,se=0){if(B===null||se===null)throw(0,R.illegalArgument)();let Ce;return typeof B=="undefined"?Ce=0:typeof B=="number"?Ce=B:(Ce=typeof B.lineDelta=="number"?B.lineDelta:0,se=typeof B.characterDelta=="number"?B.characterDelta:0),Ce===0&&se===0?this:new b(this.line+Ce,this.character+se)}with(B,se=this.character){if(B===null||se===null)throw(0,R.illegalArgument)();let Ce;return typeof B=="undefined"?Ce=this.line:typeof B=="number"?Ce=B:(Ce=typeof B.line=="number"?B.line:this.line,se=typeof B.character=="number"?B.character:this.character),Ce===this.line&&se===this.character?this:new b(Ce,se)}toJSON(){return{line:this.line,character:this.character}}};U=b=ze([D],U),e.Position=U;let j=P=class{constructor(B,se,Ce,et){let it,ot;if(typeof B=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"?(it=new U(B,se),ot=new U(Ce,et)):B instanceof U&&se instanceof U&&(it=B,ot=se),!it||!ot)throw new Error("Invalid arguments");it.isBefore(ot)?(this._start=it,this._end=ot):(this._start=ot,this._end=it)}static isRange(B){return B instanceof P?!0:B?U.isPosition(B.start)&&U.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof P?this.contains(B._start)&&this.contains(B._end):B instanceof U?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const se=U.Max(B.start,this._start),Ce=U.Min(B.end,this._end);if(!se.isAfter(Ce))return new P(se,Ce)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const se=U.Min(B.start,this._start),Ce=U.Max(B.end,this.end);return new P(se,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,se=this.end){if(B===null||se===null)throw(0,R.illegalArgument)();let Ce;return B?U.isPosition(B)?Ce=B:(Ce=B.start||this.start,se=B.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&se.isEqual(this.end)?this:new P(Ce,se)}toJSON(){return[this.start,this.end]}};j=P=ze([D],j),e.Range=j;let te=l=class extends j{constructor(B,se,Ce,et){let it,ot;if(typeof B=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"?(it=new U(B,se),ot=new U(Ce,et)):B instanceof U&&se instanceof U&&(it=B,ot=se),!it||!ot)throw new Error("Invalid arguments");super(it,ot);this._anchor=it,this._active=ot}static isSelection(B){return B instanceof l?!0:B?j.isRange(B)&&U.isPosition(B.anchor)&&U.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};te=l=ze([D],te),e.Selection=te;class K{constructor(B,se,Ce){if(typeof B!="string"||B.length===0)throw(0,R.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,R.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,R.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(se),this.connectionToken=Ce}}e.ResolvedAuthority=K;class O extends Error{constructor(B,se=I.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(B);this._message=B,this._code=se,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,O.prototype)}static NotAvailable(B,se){return new O(B,I.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(B){return new O(B,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=O;var x;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var F;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(F=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let z=f=class{constructor(B,se){this._range=B,this._newText=se}static isTextEdit(B){return B instanceof f?!0:B?j.isRange(B)&&typeof B.newText=="string":!1}static replace(B,se){return new f(B,se)}static insert(B,se){return f.replace(new j(B,B),se)}static delete(B){return f.replace(B,"")}static setEndOfLine(B){const se=new f(new j(new U(0,0),new U(0,0)),"");return se.newEol=B,se}get range(){return this._range}set range(B){if(B&&!j.isRange(B))throw(0,R.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,R.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,R.illegalArgument)("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};z=f=ze([D],z),e.TextEdit=z;var M;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace"})(M=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,se,Ce,et){this._edits.push({_type:1,from:B,to:se,options:Ce,metadata:et})}createFile(B,se,Ce){this._edits.push({_type:1,from:void 0,to:B,options:se,metadata:Ce})}deleteFile(B,se,Ce){this._edits.push({_type:1,from:B,to:void 0,options:se,metadata:Ce})}replaceNotebookMetadata(B,se,Ce){this._edits.push({_type:3,metadata:Ce,uri:B,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(B,se,Ce,et,it){let ot,dt,Ct=[],Tt;if(Bt.isNotebookRange(se)&&Lt.isNotebookCellDataArray(Ce)&&!Lt.isNotebookCellDataArray(et)?(ot=se.start,dt=se.end,Ct=Ce,Tt=et):typeof se=="number"&&typeof Ce=="number"&&Lt.isNotebookCellDataArray(et)&&(ot=se,dt=Ce,Ct=et,Tt=it),ot===void 0||dt===void 0)throw new Error("Invalid arguments");(ot!==dt||Ct.length>0)&&this._edits.push({_type:5,uri:B,index:ot,count:dt-ot,cells:Ct,metadata:Tt})}replaceNotebookCellMetadata(B,se,Ce,et){this._edits.push({_type:3,metadata:et,uri:B,edit:{editType:8,index:se,metadata:Ce}})}replace(B,se,Ce,et){this._edits.push({_type:2,uri:B,edit:new z(se,Ce),metadata:et})}insert(B,se,Ce,et){this.replace(B,new j(se,se),Ce,et)}delete(B,se,Ce){this.replace(B,se,"",Ce)}has(B){return this._edits.some(se=>se._type===2&&se.uri.toString()===B.toString())}set(B,se){if(se)for(const Ce of se)Ce&&this._edits.push({_type:2,uri:B,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const et=this._edits[Ce];et._type===2&&et.uri.toString()===B.toString()&&(this._edits[Ce]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(B){const se=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===B.toString()&&se.push(Ce.edit);return se}entries(){const B=new C.ResourceMap;for(let se of this._edits)if(se._type===2){let Ce=B.get(se.uri);Ce||(Ce=[se.uri,[]],B.set(se.uri,Ce)),Ce[1].push(se.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=ze([D],N),e.WorkspaceEdit=N;let V=p=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof p?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=p._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,se=this._tabstop++){if(typeof B=="function"){const Ce=new p;Ce._tabstop=this._tabstop,B(Ce),this._tabstop=Ce._tabstop,B=Ce.value}else B=p._escape(B);return this.value+="${",this.value+=se,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,se=this._tabstop++){const Ce=B.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(B,se){if(typeof se=="function"){const Ce=new p;Ce._tabstop=this._tabstop,se(Ce),this._tabstop=Ce._tabstop,se=Ce.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,se&&(this.value+=":",this.value+=se),this.value+="}",this}};V=p=ze([D],V),e.SnippetString=V;var $;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var G;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(G=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let J=t=class{constructor(B,se){if(this.uri=B,se)if(se instanceof j)this.range=se;else if(se instanceof U)this.range=new j(se,se);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof t?!0:B?j.isRange(B.range)&&S.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};J=t=ze([D],J),e.Location=J;let fe=class{constructor(B,se){this.location=B,this.message=se}static is(B){return B?typeof B.message=="string"&&B.location&&j.isRange(B.location.range)&&S.URI.isUri(B.location.uri):!1}static isEqual(B,se){return B===se?!0:!B||!se?!1:B.message===se.message&&B.location.range.isEqual(se.location.range)&&B.location.uri.toString()===se.location.uri.toString()}};fe=ze([D],fe),e.DiagnosticRelatedInformation=fe;let ye=class{constructor(B,se,Ce=G.Error){if(!j.isRange(B))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=B,this.message=se,this.severity=Ce}toJSON(){return{severity:G[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,se){return B===se?!0:!B||!se?!1:B.message===se.message&&B.severity===se.severity&&B.code===se.code&&B.severity===se.severity&&B.source===se.source&&B.range.isEqual(se.range)&&(0,g.equals)(B.tags,se.tags)&&(0,g.equals)(B.relatedInformation,se.relatedInformation,fe.isEqual)}};ye=ze([D],ye),e.Diagnostic=ye;let ke=class{constructor(B,se){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=se}};ke=ze([D],ke),e.Hover=ke;var Re;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(Re=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ve=class{constructor(B,se=Re.Text){this.range=B,this.kind=se}toJSON(){return{range:this.range,kind:Re[this.kind]}}};Ve=ze([D],Ve),e.DocumentHighlight=Ve;var Be;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Be=e.SymbolKind||(e.SymbolKind={}));var Ke;(function(H){H[H.Deprecated=1]="Deprecated"})(Ke=e.SymbolTag||(e.SymbolTag={}));let W=s=class{constructor(B,se,Ce,et,it){this.name=B,this.kind=se,this.containerName=it,typeof Ce=="string"&&(this.containerName=Ce),et instanceof J?this.location=et:Ce instanceof j&&(this.location=new J(et,Ce)),s.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Be[this.kind],location:this.location,containerName:this.containerName}}};W=s=ze([D],W),e.SymbolInformation=W;let Z=o=class{constructor(B,se,Ce,et,it){this.name=B,this.detail=se,this.kind=Ce,this.range=et,this.selectionRange=it,this.children=[],o.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(o.validate)}};Z=o=ze([D],Z),e.DocumentSymbol=Z;var re;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(B,se){this.title=B,this.kind=se}};ae=ze([D],ae),e.CodeAction=ae;let Q=n=class{constructor(B){this.value=B}append(B){return new n(this.value?this.value+n.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+n.sep)}};Q.sep=".",Q=n=ze([D],Q),e.CodeActionKind=Q,Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll");let oe=class{constructor(B,se){if(this.range=B,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=ze([D],oe),e.SelectionRange=oe;class we{constructor(B,se,Ce,et,it,ot){this.kind=B,this.name=se,this.detail=Ce,this.uri=et,this.range=it,this.selectionRange=ot}}e.CallHierarchyItem=we;class Me{constructor(B,se){this.fromRanges=se,this.from=B}}e.CallHierarchyIncomingCall=Me;class je{constructor(B,se){this.fromRanges=se,this.to=B}}e.CallHierarchyOutgoingCall=je;var Xe;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Se=class{constructor(B,se){this.range=B,this.command=se}get isResolved(){return!!this.command}};Se=ze([D],Se),e.CodeLens=Se;let tt=a=class{constructor(B,se=!1){m.set(this,void 0),rt(this,m,new k.MarkdownString(B,{supportThemeIcons:se}),"f")}static isMarkdownString(B){return B instanceof a?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return He(this,m,"f").value}set value(B){He(this,m,"f").value=B}get isTrusted(){return He(this,m,"f").isTrusted}set isTrusted(B){He(this,m,"f").isTrusted=B}get supportThemeIcons(){return He(this,m,"f").supportThemeIcons}set supportThemeIcons(B){He(this,m,"f").supportThemeIcons=B}appendText(B){return He(this,m,"f").appendText(B),this}appendMarkdown(B){return He(this,m,"f").appendMarkdown(B),this}appendCodeblock(B,se){return He(this,m,"f").appendCodeblock(se??"",B),this}};m=new WeakMap,tt=a=ze([D],tt),e.MarkdownString=tt;let X=class{constructor(B,se){this.label=B,this.documentation=se}};X=ze([D],X),e.ParameterInformation=X;let ee=class{constructor(B,se){this.label=B,this.documentation=se,this.parameters=[]}};ee=ze([D],ee),e.SignatureInformation=ee;let ve=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ve=ze([D],ve),e.SignatureHelp=ve;var Ue;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Ue=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Je;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(Je=e.InlayHintKind||(e.InlayHintKind={}));let nt=class{constructor(B,se,Ce){this.text=B,this.position=se,this.kind=Ce}};nt=ze([D],nt),e.InlayHint=nt;var at;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var pt;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(pt=e.CompletionItemKind||(e.CompletionItemKind={}));var _t;(function(H){H[H.Deprecated=1]="Deprecated"})(_t=e.CompletionItemTag||(e.CompletionItemTag={}));let St=class{constructor(B,se){this.label=B,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};St=ze([D],St),e.CompletionItem=St;let le=class{constructor(B=[],se=!1){this.items=B,this.isIncomplete=se}};le=ze([D],le),e.CompletionList=le;let Pe=class{constructor(B,se,Ce){this.text=B,this.range=se,this.command=Ce}};Pe=ze([D],Pe),e.InlineSuggestion=Pe;let Ne=class{constructor(B){this.items=B}};Ne=ze([D],Ne),e.InlineSuggestions=Ne;var Ye;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var We;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(We=e.StatusBarAlignment||(e.StatusBarAlignment={}));var st;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(st=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Te;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Te=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var De;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(De=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ie;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Ie=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ne;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(ne=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function B(se){switch(se){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=B}(Ie=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ee=class{constructor(B,se){if(se&&!S.URI.isUri(se))throw(0,R.illegalArgument)("target");if(!j.isRange(B)||B.isEmpty)throw(0,R.illegalArgument)("range");this.range=B,this.target=se}};Ee=ze([D],Ee),e.DocumentLink=Ee;let be=class{constructor(B,se,Ce,et){this.red=B,this.green=se,this.blue=Ce,this.alpha=et}};be=ze([D],be),e.Color=be;let Fe=class{constructor(B,se){if(se&&!(se instanceof be))throw(0,R.illegalArgument)("color");if(!j.isRange(B)||B.isEmpty)throw(0,R.illegalArgument)("range");this.range=B,this.color=se}};Fe=ze([D],Fe),e.ColorInformation=Fe;let Ge=class{constructor(B){if(!B||typeof B!="string")throw(0,R.illegalArgument)("label");this.label=B}};Ge=ze([D],Ge),e.ColorPresentation=Ge;var $e;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})($e=e.ColorFormat||(e.ColorFormat={}));var Ze;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Ze=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class pe{constructor(B,se,Ce){if(this.startIndex=B,this.length=se,this.tooltip=Ce,typeof B!="number"||B<0)throw(0,R.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,R.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=pe;class de{constructor(B){this.options=B,typeof B!="object"&&(0,R.illegalArgument)("options")}}e.TerminalProfile=de;var ce;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var q;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(q=e.TaskPanelKind||(e.TaskPanelKind={}));let _e=d=class{constructor(B,se){if(typeof B!="string"||typeof se!="string")throw(0,R.illegalArgument)("name");this._id=B}static from(B){switch(B){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};_e.Clean=new d("clean","Clean"),_e.Build=new d("build","Build"),_e.Rebuild=new d("rebuild","Rebuild"),_e.Test=new d("test","Test"),_e=d=ze([D],_e),e.TaskGroup=_e;function Le(H){let B="";for(let se=0;se<H.length;se++)B+=H[se].replace(/,/g,",,")+",";return B}let Qe=class{constructor(B,se,Ce){if(typeof B!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=B,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ce):this._options=se)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,R.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let se of this._args)B.push(se);return Le(B)}};Qe=ze([D],Qe),e.ProcessExecution=Qe;let qe=class{constructor(B,se,Ce){if(this._args=[],Array.isArray(se)){if(!B)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,R.illegalArgument)("command");this._command=B,this._args=se,this._options=Ce}else{if(typeof B!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=B,this._options=se}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,R.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)B.push(typeof se=="string"?se:se.value);return Le(B)}};qe=ze([D],qe),e.ShellExecution=qe;var ft;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(ft=e.ShellQuoting||(e.ShellQuoting={}));var ht;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(ht=e.TaskScope||(e.TaskScope={}));class yt{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=yt;let gt=u=class{constructor(B,se,Ce,et,it,ot){this.__deprecated=!1,this._definition=this.definition=B;let dt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ce,this.execution=et,dt=it,this.__deprecated=!0):se===ht.Global||se===ht.Workspace?(this.target=se,this._name=this.name=Ce,this._source=this.source=et,this.execution=it,dt=ot):(this.target=se,this._name=this.name=Ce,this._source=this.source=et,this.execution=it,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Qe?this._definition={type:u.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:u.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:u.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:u.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const se=this._definition.type;(u.EmptyType===se||u.ProcessType===se||u.ShellType===se||u.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=u=ze([D],gt),e.Task=gt;var ct;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(ct=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(B,se=vt.None){this.collapsibleState=se,S.URI.isUri(B)?this.resourceUri=B:this.label=B}};ut=ze([D],ut),e.TreeItem=ut;var vt;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(vt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let It=class{constructor(B,se){this.id=B,this.color=se}};It=ze([D],It),e.ThemeIcon=It,It.File=new It("file"),It.Folder=new It("folder");let At=class{constructor(B){this.id=B}};At=ze([D],At),e.ThemeColor=At;var Wt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Wt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let jt=class{constructor(B,se){if(typeof B!="string"&&(!B||!S.URI.isUri(B)&&!S.URI.isUri(B.uri)))throw(0,R.illegalArgument)("base");if(typeof se!="string")throw(0,R.illegalArgument)("pattern");typeof B=="string"?(this.baseFolder=S.URI.file(B),this.base=B):S.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=se}};jt=ze([D],jt),e.RelativePattern=jt;let Dt=class{constructor(B,se,Ce,et){this.enabled=typeof B=="boolean"?B:!0,typeof se=="string"&&(this.condition=se),typeof Ce=="string"&&(this.hitCondition=Ce),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};Dt=ze([D],Dt),e.Breakpoint=Dt;let Yt=class extends Dt{constructor(B,se,Ce,et,it){super(se,Ce,et,it);if(B===null)throw(0,R.illegalArgument)("location");this.location=B}};Yt=ze([D],Yt),e.SourceBreakpoint=Yt;let Jt=class extends Dt{constructor(B,se,Ce,et,it){super(se,Ce,et,it);this.functionName=B}};Jt=ze([D],Jt),e.FunctionBreakpoint=Jt;let wt=class extends Dt{constructor(B,se,Ce,et,it,ot,dt){super(et,it,ot,dt);if(!se)throw(0,R.illegalArgument)("dataId");this.label=B,this.dataId=se,this.canPersist=Ce}};wt=ze([D],wt),e.DataBreakpoint=wt;let qt=class{constructor(B,se,Ce){this.command=B,this.args=se||[],this.options=Ce}};qt=ze([D],qt),e.DebugAdapterExecutable=qt;let Ht=class{constructor(B,se){this.port=B,this.host=se}};Ht=ze([D],Ht),e.DebugAdapterServer=Ht;let Zt=class{constructor(B){this.path=B}};Zt=ze([D],Zt),e.DebugAdapterNamedPipeServer=Zt;let en=class{constructor(B){this.implementation=B}};en=ze([D],en),e.DebugAdapterInlineImplementation=en;let Pt=class{constructor(B,se){this.range=B,this.expression=se}};Pt=ze([D],Pt),e.EvaluatableExpression=Pt;var fn;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(fn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let tn=class{constructor(B,se){this.range=B,this.text=se}};tn=ze([D],tn),e.InlineValueText=tn;let xt=class{constructor(B,se,Ce=!0){this.range=B,this.variableName=se,this.caseSensitiveLookup=Ce}};xt=ze([D],xt),e.InlineValueVariableLookup=xt;let mt=class{constructor(B,se){this.range=B,this.expression=se}};mt=ze([D],mt),e.InlineValueEvaluatableExpression=mt;let nn=class{constructor(B,se){this.frameId=B,this.stoppedLocation=se}};nn=ze([D],nn),e.InlineValueContext=nn;var Mt;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Mt=e.FileChangeType||(e.FileChangeType={}));let Ot=w=class extends Error{constructor(B,se=i.FileSystemProviderErrorCode.Unknown,Ce){super(S.URI.isUri(B)?B.toString(!0):B);this.code=Ce?.name??"Unknown",(0,i.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(B){return new w(B,i.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(B){return new w(B,i.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(B){return new w(B,i.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(B){return new w(B,i.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(B){return new w(B,i.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(B){return new w(B,i.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Ot=w=ze([D],Ot),e.FileSystemError=Ot;let Gt=class{constructor(B,se,Ce){this.start=B,this.end=se,this.kind=Ce}};Gt=ze([D],Gt),e.FoldingRange=Gt;var _n;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(_n=e.FoldingRangeKind||(e.FoldingRangeKind={}));var mn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(mn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Sn;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(Sn=e.CommentMode||(e.CommentMode={}));class gn{constructor(B,se=[]){this.tokenTypes=B,this.tokenModifiers=se}}e.SemanticTokensLegend=gn;function rn(H){return typeof H=="undefined"||(0,y.isStringArray)(H)}class sn{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let se=0,Ce=B.tokenTypes.length;se<Ce;se++)this._tokenTypeStrToInt.set(B.tokenTypes[se],se);for(let se=0,Ce=B.tokenModifiers.length;se<Ce;se++)this._tokenModifierStrToInt.set(B.tokenModifiers[se],se)}}push(B,se,Ce,et,it){if(typeof B=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(B,se,Ce,et,it);if(j.isRange(B)&&typeof se=="string"&&rn(Ce))return this._push(B,se,Ce);throw(0,R.illegalArgument)()}_push(B,se,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const et=B.start.line,it=B.start.character,ot=B.end.character-B.start.character,dt=this._tokenTypeStrToInt.get(se);let Ct=0;if(Ce)for(const Tt of Ce){if(!this._tokenModifierStrToInt.has(Tt))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(Tt);Ct|=1<<Rt>>>0}this._pushEncoded(et,it,ot,dt,Ct)}_pushEncoded(B,se,Ce,et,it){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let Tt=0,Rt=0;for(let Ft=0;Ft<Ct;Ft++){let Nt=this._data[5*Ft],dn=this._data[5*Ft+1];Nt===0?(Nt=Tt,dn+=Rt):Nt+=Tt,this._data[5*Ft]=Nt,this._data[5*Ft+1]=dn,Tt=Nt,Rt=dn}}let ot=B,dt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=et,this._data[this._dataLen++]=it,this._prevLine=B,this._prevChar=se}static _sortAndDeltaEncode(B){let se=[];const Ce=B.length/5|0;for(let dt=0;dt<Ce;dt++)se[dt]=dt;se.sort((dt,Ct)=>{const Tt=B[5*dt],Rt=B[5*Ct];if(Tt===Rt){const Ft=B[5*dt+1],Nt=B[5*Ct+1];return Ft-Nt}return Tt-Rt});const et=new Uint32Array(B.length);let it=0,ot=0;for(let dt=0;dt<Ce;dt++){const Ct=5*se[dt],Tt=B[Ct+0],Rt=B[Ct+1],Ft=B[Ct+2],Nt=B[Ct+3],dn=B[Ct+4],Un=Tt-it,qn=Un===0?Rt-ot:Rt,hn=5*dt;et[hn+0]=Un,et[hn+1]=qn,et[hn+2]=Ft,et[hn+3]=Nt,et[hn+4]=dn,it=Tt,ot=Rt}return et}build(B){return this._dataIsSortedAndDeltaEncoded?new zt(new Uint32Array(this._data),B):new zt(sn._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=sn;class zt{constructor(B,se){this.resultId=se,this.data=B}}e.SemanticTokens=zt;class on{constructor(B,se,Ce){this.start=B,this.deleteCount=se,this.data=Ce}}e.SemanticTokensEdit=on;class yn{constructor(B,se){this.resultId=se,this.edits=B}}e.SemanticTokensEdits=yn;var Dn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Dn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Vt;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(Vt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new It("arrow-left")},Kt=ze([D],Kt),e.QuickInputButtons=Kt;var Cn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(B,se,Ce){this.badge=B,this.tooltip=se,this.color=Ce}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let an=class{constructor(B){this.kind=B}};an=ze([D],an),e.ColorTheme=an;var ln;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(ln=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(B,se){if(B<0)throw(0,R.illegalArgument)("start must be positive");if(se<0)throw(0,R.illegalArgument)("end must be positive");B<=se?(this._start=B,this._end=se):(this._start=se,this._end=B)}static isNotebookRange(B){return B instanceof Bt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let se=this._start,Ce=this._end;return B.start!==void 0&&(se=B.start),B.end!==void 0&&(Ce=B.end),se===this._start&&Ce===this._end?this:new Bt(se,Ce)}}e.NotebookRange=Bt;class Lt{constructor(B,se,Ce,et,it,ot,dt){this.kind=B,this.value=se,this.languageId=Ce,this.mime=et,this.outputs=it??[],this.metadata=ot,this.executionSummary=dt,Lt.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(se=>Lt.isNotebookCellData(se))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Lt;class Qt{constructor(B){this.cells=B}}e.NotebookData=Qt;class Oe{constructor(B,se){this.data=B,this.mime=se;const Ce=(0,T.normalizeMimeType)(se,!0);if(!Ce)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(B){return B instanceof Oe?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const se={name:B.name,message:B.message,stack:B.stack};return Oe.json(se,"application/vnd.code.notebook.error")}static stdout(B){return Oe.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return Oe.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,se="application/octet-stream"){return new Oe(B,se)}static text(B,se=T.Mimes.text){const Ce=He(Oe,h,"f",v).encode(String(B));return new Oe(Ce,se)}static json(B,se="application/json"){const Ce=JSON.stringify(B,void 0,"	");return Oe.text(Ce,se)}}e.NotebookCellOutputItem=Oe,h=Oe,v={value:new TextEncoder};class $t{constructor(B,se,Ce){this.items=$t.ensureUniqueMimeTypes(B,!0),typeof se=="string"?(this.id=se,this.metadata=Ce):(this.id=(0,A.generateUuid)(),this.metadata=se??Ce)}static isNotebookCellOutput(B){return B instanceof $t?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&(0,y.isArray)(B.items)}static ensureUniqueMimeTypes(B,se=!1){const Ce=new Set,et=new Set;for(let it=0;it<B.length;it++){const ot=B[it],dt=(0,T.normalizeMimeType)(ot.mime);if(!Ce.has(dt)){Ce.add(dt);continue}et.add(it),se&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return et.size===0?B:B.filter((it,ot)=>!et.has(ot))}}e.NotebookCellOutput=$t;var pn;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(pn=e.NotebookCellKind||(e.NotebookCellKind={}));var bt;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(bt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class vn{constructor(B,se){this.text=B,this.alignment=se}}e.NotebookCellStatusBarItem=vn;var wn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(wn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor(B,se=[]){this.uri=B,this.provides=(0,g.asArray)(se)}}e.NotebookRendererScript=An;let cn=class{constructor(B,se){this.label=B,this.timestamp=se}};cn=ze([D],cn),e.TimelineItem=cn;var Tn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var bn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(bn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(B,se){this.ranges=B,this.wordPattern=se}}e.LinkedEditingRanges=Ln;class Fn{constructor(B,se){this._port=B,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let un=class{constructor(B,se,Ce){this.include=B,this.exclude=se,this.profile=Ce}};un=ze([D],un),e.TestRunRequest=un;let ie=E=class{constructor(B){this.message=B}static diff(B,se,Ce){const et=new E(B);return et.expectedOutput=se,et.actualOutput=Ce,et}};ie=E=ze([D],ie),e.TestMessage=ie;let he=class{constructor(B,se){this.id=B,this.label=se}};he=ze([D],he),e.TestTag=he;let Ae=class{constructor(B,se){this.covered=B,this.total=se}};Ae=ze([D],Ae),e.CoveredCount=Ae;let lt=r=class{constructor(B,se,Ce,et){this.uri=B,this.statementCoverage=se,this.branchCoverage=Ce,this.functionCoverage=et}static fromDetails(B,se){const Ce=new Ae(0,0),et=new Ae(0,0),it=new Ae(0,0);for(const dt of se)if("branches"in dt){Ce.total+=1,Ce.covered+=dt.executionCount>0?1:0;for(const Ct of dt.branches)et.total+=1,et.covered+=Ct.executionCount>0?1:0}else it.total+=1,it.covered+=dt.executionCount>0?1:0;const ot=new r(B,Ce,et.total>0?et:void 0,it.total>0?it:void 0);return ot.detailedCoverage=se,ot}};lt=r=ze([D],lt),e.FileCoverage=lt;let Et=class{constructor(B,se,Ce=[]){this.executionCount=B,this.location=se,this.branches=Ce}};Et=ze([D],Et),e.StatementCoverage=Et;let kt=class{constructor(B,se){this.executionCount=B,this.location=se}};kt=ze([D],kt),e.BranchCoverage=kt;let Nn=class{constructor(B,se){this.executionCount=B,this.location=se}};Nn=ze([D],Nn),e.FunctionCoverage=Nn;var Hn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(zn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class jn{constructor(B,se,Ce,et,it,ot){this.kind=B,this.name=se,this.detail=Ce,this.uri=et,this.range=it,this.selectionRange=ot}}e.TypeHierarchyItem=jn}),define(me[122],ge([0,1,54,10,9,149,109,7,20]),function(Y,e,g,R,k,C,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function i(h,v){v?A.set(h,v):A.delete(h)}e.setWordDefinitionFor=i;function I(h){return A.get(h)}e.getWordDefinitionFor=I;class c extends C.MirrorTextModel{constructor(v,_,b,P,l,f,p,t){super(_,b,P,l);this._proxy=v,this._languageId=f,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,S.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===R.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(_){return _?v._getTextInRange(_):v.getText()},get eol(){return v._eol===`
`?y.EndOfLine.LF:y.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(_){return v._lineAt(_)},offsetAt(_){return v._offsetAt(_)},positionAt(_){return v._positionAt(_)},validateRange(_){return v._validateRange(_)},validatePosition(_){return v._validatePosition(_)},getWordRangeAtPosition(_,b){return v._getWordRangeAtPosition(_,b)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,g.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,g.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const _=this._validateRange(v);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const b=this._eol,P=_.start.line,l=_.end.line,f=[];f.push(this._lines[P].substring(_.start.character));for(let p=P+1;p<l;p++)f.push(this._lines[p]);return f.push(this._lines[l].substring(0,_.end.character)),f.join(b)}_lineAt(v){let _;if(v instanceof y.Position?_=v.line:typeof v=="number"&&(_=v),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new m(_,this._lines[_],_===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(v),b=this._lines[_.index].length;return new y.Position(_.index,Math.min(_.remainder,b))}_validateRange(v){if(!(v instanceof y.Range))throw new Error("Invalid argument");const _=this._validatePosition(v.start),b=this._validatePosition(v.end);return _===v.start&&b===v.end?v:new y.Range(_.line,_.character,b.line,b.character)}_validatePosition(v){if(!(v instanceof y.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:_,character:b}=v,P=!1;if(_<0)_=0,b=0,P=!0;else if(_>=this._lines.length)_=this._lines.length-1,b=this._lines[_].length,P=!0;else{const l=this._lines[_].length;b<0?(b=0,P=!0):b>l&&(b=l,P=!0)}return P?new y.Position(_,b):v}_getWordRangeAtPosition(v,_){const b=this._validatePosition(v);if(!_)_=I(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const P=(0,T.getWordAtText)(b.character+1,(0,T.ensureValidWordDefinition)(_),this._lines[b.line],0);if(P)return new y.Range(b.line,P.startColumn-1,b.line,P.endColumn-1)}}e.ExtHostDocumentData=c;class m{constructor(v,_,b){this._line=v,this._text=_,this._isLastLine=b}get lineNumber(){return this._line}get text(){return this._text}get range(){return new y.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new y.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(me[202],ge([0,1,7,3,111,6,80,23,2,32]),function(Y,e,g,R,k,C,T,y,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(c,m,h,v){this._notebook=h,this._selector=v,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(b=>{const P=this._cellUris.get(b.document.uri);P!==void 0&&(this._cellLengths.changeValue(P,this._cells[P].document.getText().length+1),this._cellLines.changeValue(P,this._cells[P].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=b=>{b===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(b=>_(b.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new y.ResourceMap;const c=[],m=[];for(const h of this._notebook.getCells())h.kind===g.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),c.push(h.document.getText().length+1),m.push(h.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(c){if(!c){let P="";for(const l of this._cells)P+=l.document.getText()+`
`;return P=P.slice(0,-1),P}if(c.isEmpty)return"";const m=this.locationAt(c.start),h=this.locationAt(c.end),v=this._cellUris.get(m.uri),_=this._cellUris.get(h.uri);if(v===void 0||_===void 0)return"";if(v===_)return this._cells[v].document.getText(new g.Range(m.range.start,h.range.end));const b=[this._cells[v].document.getText(new g.Range(m.range.start,new g.Position(this._cells[v].document.lineCount,0)))];for(let P=v+1;P<_;P++)b.push(this._cells[P].document.getText());return b.push(this._cells[_].document.getText(new g.Range(new g.Position(0,0),h.range.end))),b.join(`
`)}offsetAt(c){const m=this._cellLines.getIndexOf(c.line),h=this._cellLengths.getPrefixSum(m.index-1),v=this._cells[m.index].document.offsetAt(c.with(m.remainder));return h+v}positionAt(c){if(typeof c=="number"){const h=this._cellLengths.getIndexOf(c),v=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(v)}const m=this._cellUris.get(c.uri);if(m!==void 0){const h=this._cellLines.getPrefixSum(m-1);return new g.Position(h+c.range.start.line,c.range.start.character)}return new g.Position(0,0)}locationAt(c){g.Range.isRange(c)||(c=new g.Range(c,c));const m=this._cellLines.getIndexOf(c.start.line);let h=m;c.isEmpty||(h=this._cellLines.getIndexOf(c.end.line));const v=new g.Position(m.remainder,c.start.character),_=new g.Position(h.remainder,c.end.character),b=new g.Range(v,_),P=this._cells[m.index];return new g.Location(P.document.uri,P.document.validateRange(b))}contains(c){return this._cellUris.has(c)}validateRange(c){const m=this.validatePosition(c.start),h=this.validatePosition(c.end);return c.with(m,h)}validatePosition(c){const m=this._cellLines.getIndexOf(c.line),h=new g.Position(m.remainder,c.character),v=this._cells[m.index].document.validatePosition(h),_=this._cellLines.getPrefixSum(m.index-1);return new g.Position(_+v.line,v.character)}}e.ExtHostNotebookConcatDocument=i}),define(me[203],ge([0,1,7,13,3]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(y){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(y){let S=y==="light"?g.ColorThemeKind.Light:y==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=ze([xe(0,R.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(me[64],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class R{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=R}),define(me[204],ge([0,1,25]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(S){let A=this.buffers.indexOf(S);return A<0&&(A=this.buffers.length,this.buffers.push(S)),A}}function k(y,S){if(S.serializeBuffersForPostMessage){const A=new R,i=(m,h)=>{if(h instanceof ArrayBuffer){const v=A.add(h);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(h)){const v=C(h);if(v){const _=A.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:v,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},I=JSON.stringify(y,i),c=A.buffers.map(m=>{const h=new Uint8Array(m);return g.VSBuffer.wrap(h)});return{message:I,buffers:c}}else return{message:JSON.stringify(y),buffers:[]}}e.serializeWebviewMessage=k;function C(y){switch(y.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(y,S){const A=S.map(c=>{const m=new ArrayBuffer(c.byteLength);return new Uint8Array(m).set(c.buffer),m}),i=S.length?(c,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const h=m,{index:v}=h,_=A[v];if(h.view)switch(h.view.type){case 1:return new Int8Array(_,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return m}:void 0;return{message:JSON.parse(y,i),arrayBuffers:A}}e.deserializeWebviewMessage=T}),define(me[205],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(R){function k(T){const y={items:new Map};return T.types.forEach((S,A)=>{y.items.set(S,{asString:async()=>T.items[A].asString})}),y}R.toITreeDataTransfer=k;async function C(T){const y={types:[],items:[]},S=Array.from(T.items.entries());for(const A of S)y.types.push(A[0]),y.items.push({asString:await A[1].asString()});return y}R.toTreeDataTransferDTO=C})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[88],ge([0,1,10,2]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(y,S){return y.scheme===g.Schemas.http||y.scheme===g.Schemas.https?y:(S&&S.authority&&S.isRemote&&y.scheme===g.Schemas.file&&(y=R.URI.from({scheme:g.Schemas.vscodeRemote,authority:S.authority,path:y.path})),R.URI.from({scheme:g.Schemas.https,authority:`${y.scheme}+${C(y.authority)}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=k;function C(y){return y.replace(/./g,S=>{const A=S.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?S:"-"+A.toString(16).padStart(4,"0")})}function T(y){return y.replace(/-([0-9a-f]{4})/g,(S,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=T}),define(me[206],ge([0,1,3,6,88]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(y,S,A){this._proxy=y,this._editors=S,this._initData=A,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const i=S.getVisibleTextEditors();for(const I of this._insets.values())i.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,S,A,i,I){let c;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===y){c=l;break}if(!c)throw new Error("not a visible editor");const m=this,h=this._handlePool++,v=new g.Emitter,_=new g.Emitter,b=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,k.asWebviewUri)(l,m._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(l){this._options=l,m._proxy.$setOptions(h,l)}get options(){return this._options}set html(l){this._html=l,m._proxy.$setHtml(h,l)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(l){return m._proxy.$postMessage(h,l)}},P=new class{constructor(){this.editor=y,this.line=S,this.height=A,this.webview=b,this.onDidDispose=_.event}dispose(){m._insets.has(h)&&(m._insets.delete(h),m._proxy.$disposeEditorInset(h),_.fire(),_.dispose(),v.dispose())}};return this._proxy.$createEditorInset(h,c.id,c.value.document.uri,S+1,A,i||{},I.identifier,I.extensionLocation),this._insets.set(h,{editor:y,inset:P,onDidReceiveMessage:v}),P}$onDidDispose(y){const S=this._insets.get(y);S&&S.inset.dispose()}$onDidReceiveMessage(y,S){const A=this._insets.get(y);A&&A.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=C}),define(me[207],ge([0,1,171,14,2,6,4,61,34,20,10]),function(Y,e,g,R,k,C,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new y.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new y.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new y.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new y.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new y.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorContext=new y.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new y.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new y.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new y.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.EditorGroupEditorsCountContext=new y.RawContextKey("groupEditorsCount",0,(0,g.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new y.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(12,null)),e.ActiveEditorGroupIndexContext=new y.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(13,null)),e.ActiveEditorGroupLastContext=new y.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(14,null)),e.MultipleEditorGroupsContext=new y.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new y.RawContextKey("editorIsOpen",!1,(0,g.localize)(16,null)),e.InEditorZenModeContext=new y.RawContextKey("inZenMode",!1,(0,g.localize)(17,null)),e.IsCenteredLayoutContext=new y.RawContextKey("isCenteredLayout",!1,(0,g.localize)(18,null)),e.SplitEditorsVertically=new y.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(19,null)),e.EditorAreaVisibleContext=new y.RawContextKey("editorAreaVisible",!0,(0,g.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function I(r){return typeof r?.getViewState=="function"}e.isTextEditorPane=I;function c(r){if(l(r))return!1;const D=r;return k.URI.isUri(D?.resource)}e.isResourceEditorInput=c;function m(r){if(l(r))return!1;const D=r;return D?.original!==void 0&&D.modified!==void 0}e.isResourceDiffEditorInput=m;function h(r){if(l(r))return!1;const D=r;return D?D.resource===void 0||D.resource.scheme===i.Schemas.untitled||D.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=h;var v;(function(r){r[r.SHORT=0]="SHORT",r[r.MEDIUM=1]="MEDIUM",r[r.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var _;(function(r){r[r.EXPLICIT=1]="EXPLICIT",r[r.AUTO=2]="AUTO",r[r.FOCUS_CHANGE=3]="FOCUS_CHANGE",r[r.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var b;(function(r){r[r.None=0]="None",r[r.Readonly=2]="Readonly",r[r.Untitled=4]="Untitled",r[r.Singleton=8]="Singleton",r[r.RequiresTrust=16]="RequiresTrust"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class P extends C.Disposable{}e.AbstractEditorInput=P;function l(r){return r instanceof P}e.isEditorInput=l;function f(r){const D=r;return k.URI.isUri(D?.preferredResource)}function p(r){const D=r;return l(D?.primary)&&l(D?.secondary)}e.isSideBySideEditorInput=p;function t(r){return l(r?.editor)}e.isEditorInputWithOptions=t;function s(r){const D=r;return t(r)&&D?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function o(r){const D=r;return typeof D?.groupId=="number"&&l(D.editor)}e.isEditorIdentifier=o;var n;(function(r){r[r.PRIMARY=1]="PRIMARY",r[r.SECONDARY=2]="SECONDARY",r[r.BOTH=3]="BOTH"})(n=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(D,L){if(!D)return;const U=p(D)?D.primary:m(D)?D.modified:void 0,j=p(D)?D.secondary:m(D)?D.original:void 0;if(L?.supportSideBySide&&U&&j){if(L?.supportSideBySide===n.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:L.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:L.filterByScheme})};D=L.supportSideBySide===n.PRIMARY?U:j}if(m(D))return;const te=f(D)?D.preferredResource:D.resource;return!te||!L||!L.filterByScheme?te:this.filterUri(te,L.filterByScheme)}getCanonicalUri(D,L){if(!D)return;const U=p(D)?D.primary:m(D)?D.modified:void 0,j=p(D)?D.secondary:m(D)?D.original:void 0;if(L?.supportSideBySide&&U&&j){if(L?.supportSideBySide===n.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:L.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:L.filterByScheme})};D=L.supportSideBySide===n.PRIMARY?U:j}if(m(D))return;const te=D.resource;return!te||!L||!L.filterByScheme?te:this.filterUri(te,L.filterByScheme)}filterUri(D,L){if(Array.isArray(L)){if(L.some(U=>D.scheme===U))return D}else if(L===D.scheme)return D}}e.EditorResourceAccessor=new a;var d;(function(r){r[r.LEFT=0]="LEFT",r[r.RIGHT=1]="RIGHT"})(d=e.CloseDirection||(e.CloseDirection={}));class u{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(D){const L=this.instantiationService=D.get(T.IInstantiationService);for(const[U,j]of this.editorSerializerConstructors)this.createEditorSerializer(U,j,L);this.editorSerializerConstructors.clear()}createEditorSerializer(D,L,U){const j=U.createInstance(L);this.editorSerializerInstances.set(D,j)}registerFileEditorFactory(D){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=D}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(D,L){if(this.editorSerializerConstructors.has(D)||this.editorSerializerInstances.has(D))throw new Error(`A editor serializer with type ID '${D}' was already registered.`);return this.instantiationService?this.createEditorSerializer(D,L,this.instantiationService):this.editorSerializerConstructors.set(D,L),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(D),this.editorSerializerInstances.delete(D)})}getEditorSerializer(D){return this.editorSerializerInstances.get(typeof D=="string"?D:D.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new u);async function w(r,D){if(!r||!r.length)return[];const L=await Promise.all(r.map(async U=>{const j=k.URI.revive(U.fileUri);if(!j||(await D.activateProvider(j.scheme),!D.canHandleResource(j)))return;const te=typeof U.exists=="boolean"?U.exists:await D.exists(j);if(!te&&U.openOnlyIfExists)return;const K=te&&!(0,R.isUndefined)(U.selection)?{selection:U.selection,pinned:!0,override:U.editorOverrideId}:{pinned:!0,override:U.editorOverrideId};let O;return te?O={resource:j,options:K,forceFile:!0}:O={resource:j,options:K,forceUntitled:!0},O}));return(0,A.coalesce)(L)}e.pathsToEditors=w;var E;(function(r){r[r.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",r[r.SEQUENTIAL=1]="SEQUENTIAL"})(E=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[208],ge([0,1,3,61,172,4,6,23,34,20,55,22,47,197]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",c.Codicon.window,(0,k.localize)(0,null));var h;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(h=e.Extensions||(e.Extensions={}));var v;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function b(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=b;class P extends T.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,A.flatten)([...this.viewContainers.values()])}registerViewContainer(d,u,w){const E=this.get(d.id);if(E)return E;const r=d;return r.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:r.openCommandActionDescriptor??{id:r.id},(0,y.getOrSet)(this.viewContainers,u,[]).push(r),w?.isDefault&&this.defaultViewContainers.push(r),this._onDidRegister.fire({viewContainer:r,viewContainerLocation:u}),r}deregisterViewContainer(d){for(const u of this.viewContainers.keys()){const w=this.viewContainers.get(u),E=w?.indexOf(d);if(E!==-1){w?.splice(E,1),w.length===0&&this.viewContainers.delete(u),this._onDidDeregister.fire({viewContainer:d,viewContainerLocation:u});return}}}get(d){return this.all.filter(u=>u.id===d)[0]}getViewContainers(d){return[...this.viewContainers.get(d)||[]]}getViewContainerLocation(d){return[...this.viewContainers.keys()].filter(u=>this.getViewContainers(u).filter(w=>w?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.defaultViewContainers.find(u=>this.getViewContainerLocation(u)===d)}}S.Registry.add(h.ViewContainersRegistry,new P);var l;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function f(a,d){const u=a.group??l.More,w=d.group??l.More;return u!==w?u.localeCompare(w):(a.order??5)-(d.order??5)}class p extends T.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(d,u){this.registerViews2([{views:d,viewContainer:u}])}registerViews2(d){d.forEach(({views:u,viewContainer:w})=>this.addViews(u,w)),this._onViewsRegistered.fire(d)}deregisterViews(d,u){const w=this.removeViews(d,u);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:u})}moveViews(d,u){for(const w of this._views.keys())if(w!==u){const E=this.removeViews(d,w);E.length&&(this.addViews(E,u),this._onDidChangeContainer.fire({views:E,from:w,to:u}))}}getViews(d){return this._views.get(d)||[]}getView(d){for(const u of this._viewContainers){const w=(this._views.get(u)||[]).filter(E=>E.id===d)[0];if(w)return w}return null}getViewContainer(d){for(const u of this._viewContainers)if((this._views.get(u)||[]).filter(E=>E.id===d)[0])return u;return null}registerViewWelcomeContent(d,u){return this._viewWelcomeContents.add(d,u),this._onDidChangeViewWelcomeContent.fire(d),(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(d,u),this._onDidChangeViewWelcomeContent.fire(d)})}registerViewWelcomeContent2(d,u){const w=new Map;for(const[E,r]of u)this._viewWelcomeContents.add(d,r),w.set(E,(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(d,r),this._onDidChangeViewWelcomeContent.fire(d)}));return this._onDidChangeViewWelcomeContent.fire(d),w}getViewWelcomeContent(d){const u=[];return this._viewWelcomeContents.forEach(d,w=>u.push(w)),u.sort(f)}addViews(d,u){let w=this._views.get(u);w||(w=[],this._views.set(u,w),this._viewContainers.push(u));for(const E of d){if(this.getView(E.id)!==null)throw new Error((0,k.localize)(1,null,E.id));w.push(E)}}removeViews(d,u){const w=this._views.get(u);if(!w)return[];const E=[],r=[];for(const D of w)d.includes(D)?E.push(D):r.push(D);return E.length&&(r.length?this._views.set(u,r):(this._views.delete(u),this._viewContainers.splice(this._viewContainers.indexOf(u),1))),E}}S.Registry.add(h.ViewsRegistry,new p),e.IViewsService=(0,C.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,k.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var s;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(s=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(d,u){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,d),this._hasResolve=!!u,this.resolve=async w=>{if(u&&!this.resolved){const E=await u(w);E&&(this.tooltip=this.tooltip??E.tooltip,this.command=this.command??E.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[123],ge([0,1,3,17,173]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(y){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=y}onEvent(y){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=y}onRequest(y){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=y}sendResponse(y){y.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${y.command}`)):this.internalSend("response",y)}sendRequest(y,S,A,i){const I={command:y};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.internalSend("request",I),typeof i=="number"){const c=setTimeout(()=>{clearTimeout(c);const m=this.pendingRequests.get(I.seq);if(m){this.pendingRequests.delete(I.seq);const h={type:"response",seq:0,request_seq:I.seq,success:!1,command:y,message:(0,k.localize)(0,null,i,y)};m(h)}},i)}return A&&this.pendingRequests.set(I.seq,A),I.seq}acceptMessage(y){this.messageCallback?this.messageCallback(y):(this.queue.push(y),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(y,S){return y.type!=="event"||S.type!=="event"}async processQueue(){let y;for(;this.queue.length;){if((!y||this.needsTaskBoundaryBetween(this.queue[0],y))&&await(0,R.timeout)(0),y=this.queue.shift(),!y)return;switch(y.type){case"event":this.eventCallback&&this.eventCallback(y);break;case"request":this.requestCallback&&this.requestCallback(y);break;case"response":const S=y,A=this.pendingRequests.get(S.request_seq);A&&(this.pendingRequests.delete(S.request_seq),A(S));break}}}internalSend(y,S){S.type=y,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const y=new Map;this.pendingRequests.forEach((S,A)=>y.set(A,S)),await(0,R.timeout)(500),y.forEach((S,A)=>{S({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(me[209],ge([0,1,9,2,8,22,10]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const y=/{([^}]+)}/g;function S(o,n,a){return o.replace(y,function(d,u){return n&&u.length>0&&u[0]!=="_"?d:a&&a.hasOwnProperty(u)?a[u]:d})}e.formatPII=S;function A(o){const n={};for(const a of Object.keys(o))a.startsWith("!")||(n[a]=o[a]);return n}e.filterExceptionsFromTelemetry=A;function i(o){return o.configuration.request==="attach"&&!I(o)&&(!o.parentSession||i(o.parentSession))}e.isSessionAttach=i;function I(o){let n=o.configuration.type;if(!!n)return n==="vslsShare"&&(n=o.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(n,"extensionhost")||(0,g.equalsIgnoreCase)(n,"pwa-extensionhost")?o:o.parentSession?I(o.parentSession):void 0}e.getExtensionHostDebugSession=I;function c(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=c;function m(o,n,a){let d,u=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=w.exec(o);){let r=E.index+1,D=r+E[0].length;if(r<=n&&D>=a){d=E[0],u=r;break}}if(d){let r=/\w+/g,D=null;for(;(D=r.exec(d))&&!(D.index+1+u+D[0].length>=a););D&&(d=d.substring(0,r.lastIndex))}return d?{start:u,end:u+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(o){return!!(o&&o.match(h))}e.isUri=v;function _(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(v(o.path))return R.URI.parse(o.path);if((0,k.isAbsolute)(o.path))return R.URI.file(o.path)}return o.path}function b(o){if(typeof o.path=="object"){const n=R.URI.revive(o.path);if(n)return n.scheme===T.Schemas.file?n.fsPath:n.toString()}return o.path}function P(o,n){const a=n?_:b,d=(0,C.deepClone)(o);return f(d,(u,w)=>{u&&w&&(w.path=a(w))}),d}e.convertToDAPaths=P;function l(o,n){const a=n?_:b,d=(0,C.deepClone)(o);return f(d,(u,w)=>{!u&&w&&(w.path=a(w))}),d}e.convertToVSCPaths=l;function f(o,n){switch(o.type){case"event":const a=o;switch(a.event){case"output":n(!1,a.body.source);break;case"loadedSource":n(!1,a.body.source);break;case"breakpoint":n(!1,a.body.breakpoint.source);break;default:break}break;case"request":const d=o;switch(d.command){case"setBreakpoints":n(!0,d.arguments.source);break;case"breakpointLocations":n(!0,d.arguments.source);break;case"source":n(!0,d.arguments.source);break;case"gotoTargets":n(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(w=>n(!1,w));break;default:break}break;case"response":const u=o;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(w=>n(!1,w.source));break;case"loadedSources":u.body.sources.forEach(w=>n(!1,w));break;case"scopes":u.body.scopes.forEach(w=>n(!1,w.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(w=>n(!1,w.source));break;case"setBreakpoints":u.body.breakpoints.forEach(w=>n(!1,w.source));break;default:break}break}}function p(o){return o.filter(n=>!n.presentation?.hidden).sort((n,a)=>n.presentation?a.presentation?n.presentation.group?a.presentation.group?n.presentation.group!==a.presentation.group?n.presentation.group.localeCompare(a.presentation.group):t(n.presentation.order,a.presentation.order):-1:a.presentation.group?1:t(n.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=p;function t(o,n){return typeof o!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:o-n}async function s(o,n){const a=o.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorMode});if(a!=="none"&&(await n.saveAll(),a==="allEditorsInActiveGroup")){const d=n.activeEditorPane;d&&await n.save({editor:d.input,groupId:d.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(me[210],ge([0,1,28,39,174,124,8,9,22,11,184,123]),function(Y,e,g,R,k,C,T,y,S,A,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(P,l){this.outputStream=l,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,P.on("data",f=>this.handleData(f))}sendMessage(P){if(this.outputStream){const l=JSON.stringify(P);this.outputStream.write(`Content-Length: ${Buffer.byteLength(l,"utf8")}${c.TWO_CRLF}${l}`,"utf8")}}handleData(P){for(this.rawData=Buffer.concat([this.rawData,P]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const l=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,l.length>0)try{this.acceptMessage(JSON.parse(l))}catch(f){this._onError.fire(new Error((f.message||f)+`
`+l))}continue}}else{const l=this.rawData.indexOf(c.TWO_CRLF);if(l!==-1){const p=this.rawData.toString("utf8",0,l).split(c.HEADER_LINESEPARATOR);for(const t of p){const s=t.split(c.HEADER_FIELDSEPARATOR);s[0]==="Content-Length"&&(this.contentLength=Number(s[1]))}this.rawData=this.rawData.slice(l+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class m extends c{startSession(){return new Promise((P,l)=>{let f=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),P(),f=!0}),this.socket.on("close",()=>{f?this._onError.fire(new Error("connection closed")):l(new Error("connection closed"))}),this.socket.on("error",p=>{f?this._onError.fire(p):l(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class h extends m{constructor(P){super();this.adapterServer=P}createConnection(P){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",P)}}e.SocketDebugAdapter=h;class v extends m{constructor(P){super();this.adapterServer=P}createConnection(P){return C.createConnection(this.adapterServer.path,P)}}e.NamedPipeDebugAdapter=v;class _ extends c{constructor(P,l,f){super();this.adapterExecutable=P,this.debugType=l,this.outputService=f}async startSession(){const P=this.adapterExecutable.command,l=this.adapterExecutable.args,f=this.adapterExecutable.options||{};try{if(P)if(T.isAbsolute(P)){if(!await g.Promises.exists(P))throw new Error(k.localize(0,null,P))}else P.indexOf("/")<0&&P.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let p=process.env;if(f.env&&Object.keys(f.env).length>0&&(p=S.mixin(S.deepClone(process.env),f.env)),P==="node")if(Array.isArray(l)&&l.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:p,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};f.cwd&&(o.cwd=f.cwd);const n=R.fork(l[0],l.slice(1),o);if(!n.pid)throw new Error(k.localize(2,null,l[0]));this.serverProcess=n}else throw new Error(k.localize(3,null));else{const s={env:p};f.cwd&&(s.cwd=f.cwd),this.serverProcess=R.spawn(P,l,s)}this.serverProcess.on("error",s=>{this._onError.fire(s)}),this.serverProcess.on("exit",(s,o)=>{this._onExit.fire(s)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",s=>{this._onError.fire(s)}),this.serverProcess.stdin.on("error",s=>{this._onError.fire(s)});const t=this.outputService;if(t){const s=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const n=t.getChannel(i.ExtensionsChannelId);n&&n.append(s(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((P,l)=>{const f=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,t,s){if(p)return l(p)});f.on("exit",P),f.on("error",l)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(P,l){if(!P)return;const f=Object.create(null);P.runtime&&(P.runtime.indexOf("./")===0?f.runtime=T.join(l,P.runtime):f.runtime=P.runtime),P.runtimeArgs&&(f.runtimeArgs=P.runtimeArgs),P.program&&(T.isAbsolute(P.program)?f.program=P.program:f.program=T.join(l,P.program)),P.args&&(f.args=P.args);const p=P;return p.win&&(f.win=_.extract(p.win,l)),p.winx86&&(f.winx86=_.extract(p.winx86,l)),p.windows&&(f.windows=_.extract(p.windows,l)),p.osx&&(f.osx=_.extract(p.osx,l)),p.linux&&(f.linux=_.extract(p.linux,l)),f}static platformAdapterExecutable(P,l){let f=Object.create(null);l=l.toLowerCase();for(const a of P)if(a.contributes){const d=a.contributes.debuggers;d&&d.length>0&&d.filter(u=>typeof u.type=="string"&&y.equalsIgnoreCase(u.type,l)).forEach(u=>{const w=_.extract(u,a.extensionLocation.fsPath);f=S.mixin(f,w,a.isBuiltin)})}let p;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=f.winx86||f.win||f.windows:A.isWindows?p=f.win||f.windows:A.isMacintosh?p=f.osx:A.isLinux&&(p=f.linux),p=p||f;let t=p.program||f.program;const s=p.args||f.args;let o=p.runtime||f.runtime;const n=p.runtimeArgs||f.runtimeArgs;if(o)return{type:"executable",command:o,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(s||[])};if(t)return{type:"executable",command:t,args:s||[]}}}e.ExecutableDebugAdapter=_}),define(me[211],ge([0,1,39,11,29,187]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(c,m){return new Promise((h,v)=>{let _="";const b=g.spawn(c,m);b.pid&&b.stdout.on("data",P=>{_+=P.toString()}),b.on("error",P=>{v(P)}),b.on("close",P=>{h(_)})})}let y;function S(c,m){if(!y)if(R.isWindows)y=new C.WindowsExternalTerminalService;else if(R.isMacintosh)y=new C.MacExternalTerminalService;else if(R.isLinux)y=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=m.getConfiguration("terminal");return y.runInTerminal(c.title,c.cwd,c.args,c.env||{},h.external||{})}e.runInExternalTerminal=S;function A(c){return c?R.isWindows?new Promise(async m=>{(await new Promise((v,_)=>{Y(["windows-process-tree"],v,_)})).getProcessTree(c,v=>{m(v.children.length>0)})}):T("/usr/bin/pgrep",["-lP",String(c)]).then(m=>{const h=m.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=A;var i;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(i||(i={}));function I(c,m,h,v){c=c.trim().toLowerCase();let _;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?_=1:c.indexOf("cmd.exe")>=0?_=0:c.indexOf("bash")>=0?_=2:R.isWindows?_=0:_=2;let b,P=" ";switch(_){case 1:if(b=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),h){const f=(0,k.getDriveLetter)(h);f&&(P+=`${f}:; `),P+=`cd ${b(h)}; `}if(v)for(let f in v){const p=v[f];p===null?P+=`Remove-Item env:${f}; `:P+=`\${env:${f}}='${p}'; `}if(m.length>0){const f=b(m.shift());P+=f[0]==="'"?`& ${f} `:`${f} `;for(let p of m)P+=`${b(p)} `}break;case 0:if(b=f=>(f=f.replace(/\"/g,'""'),f.indexOf(" ")>=0||f.indexOf('"')>=0||f.length===0?`"${f}"`:f),h){const f=(0,k.getDriveLetter)(h);f&&(P+=`${f}: && `),P+=`cd ${b(h)} && `}if(v){P+='cmd /C "';for(let f in v){let p=v[f];p===null?P+=`set "${f}=" && `:(p=p.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),P+=`set "${f}=${p}" && `)}}for(let f of m)P+=`${b(f)} `;v&&(P+='"');break;case 2:b=f=>(f=f.replace(/(["'\\\$])/g,"\\$1"),f.indexOf(" ")>=0||f.indexOf(";")>=0||f.length===0?`"${f}"`:f);const l=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(h&&(P+=`cd ${b(h)} ; `),v){P+="/usr/bin/env";for(let f in v){const p=v[f];p===null?P+=` -u ${l(f)}`:P+=` ${l(`${f}=${p}`)}`}P+=" "}for(let f of m)P+=`${b(f)} `;break}return P}e.prepareCommand=I}),define(me[125],ge([0,1,30,101,10,8,11,61]),function(Y,e,g,R,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(r){r[r.Markup=1]="Markup",r[r.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(r){r[r.Running=1]="Running",r[r.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(r){r[r.Pending=2]="Pending",r[r.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(r){r[r.WithHardKernelDependency=0]="WithHardKernelDependency",r[r.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",r[r.Pure=2]="Pure",r[r.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var c;(function(r){r.Always="always",r.Never="never",r.Optional="optional"})(c=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(r){r[r.ModelChange=1]="ModelChange",r[r.Move=2]="Move",r[r.ChangeLanguage=5]="ChangeLanguage",r[r.Initialize=6]="Initialize",r[r.ChangeCellMetadata=7]="ChangeCellMetadata",r[r.Output=8]="Output",r[r.OutputItem=9]="OutputItem",r[r.ChangeCellContent=10]="ChangeCellContent",r[r.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",r[r.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",r[r.ChangeCellMime=13]="ChangeCellMime",r[r.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(r){r[r.Handle=0]="Handle",r[r.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(r){r[r.Replace=1]="Replace",r[r.Output=2]="Output",r[r.Metadata=3]="Metadata",r[r.CellLanguage=4]="CellLanguage",r[r.DocumentMetadata=5]="DocumentMetadata",r[r.Move=6]="Move",r[r.OutputItems=7]="OutputItems",r[r.PartialMetadata=8]="PartialMetadata",r[r.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var _;(function(r){r.scheme=k.Schemas.vscodeNotebookCell;const D=/^ch(\d{7,})/;function L(O,x){return O.with({scheme:r.scheme,fragment:`ch${x.toString().padStart(7,"0")}${O.scheme!==k.Schemas.file?O.scheme:""}`})}r.generate=L;function U(O){if(O.scheme!==r.scheme)return;const x=D.exec(O.fragment);return x?{handle:Number(x[1]),notebook:O.with({scheme:O.fragment.substr(x[0].length)||k.Schemas.file,fragment:null})}:void 0}r.parse=U;function j(O){if(O.scheme!==k.Schemas.vscodeNotebookCellMetadata)return;const x=D.exec(O.fragment);return x?{handle:Number(x[1]),notebook:O.with({scheme:O.fragment.substr(x[0].length)||k.Schemas.file,fragment:null})}:void 0}r.parseCellMetadataUri=j;function te(O,x,F){return O.with({scheme:F,fragment:`ch${x.toString().padStart(7,"0")}${O.scheme!==k.Schemas.file?O.scheme:""}`})}r.generateCellUri=te;function K(O,x){if(O.scheme!==x)return;const F=D.exec(O.fragment);return F?{handle:Number(F[1]),notebook:O.with({scheme:O.fragment.substr(F[0].length)||k.Schemas.file,fragment:null})}:void 0}r.parseCellUri=K})(_=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function P(r){return b.get(r)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=P;function l(r){return b.get(r)?.supportedByCore??!1}e.mimeTypeSupportedByCore=l;function f(r){return b.get(r)?.mergeable??!1}e.mimeTypeIsMergeable=f;function p(r,D){return T.isWindows&&(r=r.replace(/\//g,"\\"),D=D.replace(/\//g,"\\")),g.match(r,D)}function t(r,D,L){let U=0;for(let j=0;j<D.length;j++){if(p(D[j],r))return U;U++}for(let j=0;j<L.length;j++){if(p(L[j],r))return U;U++}return U}function s(r,D,L){return r.sort((U,j)=>t(U,D,L)-t(j,D,L))}e.sortMimeTypes=s;function o(r,D,L,U=(j,te)=>j===te){const j=[];function te(x,F,z){if(F===0&&z.length===0)return;const M=j[j.length-1];M&&M.start+M.deleteCount===x?(M.deleteCount+=F,M.toInsert.push(...z)):j.push({start:x,deleteCount:F,toInsert:z})}let K=0,O=0;for(;;){if(K===r.length){te(K,0,D.slice(O));break}if(O===D.length){te(K,r.length-K,[]);break}const x=r[K],F=D[O];if(U(x,F)){K+=1,O+=1;continue}L(F)?(te(K,1,[]),K+=1):(te(K,0,[F]),O+=1)}return j}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(r){r.default="default",r.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(r){const D=r;return!!((typeof D.include=="string"||g.isRelativePattern(D.include))&&(typeof D.exclude=="string"||g.isRelativePattern(D.exclude)))}e.isDocumentExcludePattern=a;function d(r,D,L){if(Array.isArray(r.viewType)&&r.viewType.indexOf(D)>=0||r.viewType===D)return!0;if(r.filenamePattern){let U=a(r.filenamePattern)?r.filenamePattern.include:r.filenamePattern,j=a(r.filenamePattern)?r.filenamePattern.exclude:void 0;if(g.match(U,(0,C.basename)(L.fsPath).toLowerCase()))return!(j&&g.match(j,(0,C.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class u{constructor(D){this.textModel=D}getElements(){const D=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)D[L]=this.textModel.cells[L].getHashValue();return D}}e.CellSequence=u,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var w;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class E{static create(D){return`${E._prefix}${D}`}static parse(D){if(D.startsWith(E._prefix))return D.substr(E._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=E,E._prefix="notebook/"}),define(me[212],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var R;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState",k[k.Complete=4]="Complete"})(R=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(me[213],ge([0,1,176,4,61]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[214],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=g;function R(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=R}),define(me[126],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var R;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(R=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var C;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(I,c)=>{c.expand!==void 0&&(I.expand=c.expand),c.item!==void 0&&(I.item=I.item?Object.assign(I.item,c.item):c.item)};e.applyTestItemUpdate=T;var y;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(y=e.DetailType||(e.DetailType={}));var S;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(c){}update(c){}remove(c,m){}complete(){}}e.IncrementalChangeCollector=A;class i{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(c){const m=this.createChangeCollector();for(const h of c)switch(h[0]){case 0:{const v=h[1];if(v.parent){if(this.items.has(v.parent)){const _=this.items.get(v.parent);_.children.add(v.item.extId);const b=this.createItem(v,_);this.items.set(v.item.extId,b),m.add(b)}}else{const _=this.createItem(v);this.roots.add(_),this.items.set(v.item.extId,_),m.add(_)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=h[1],_=this.items.get(v.extId);if(!_)break;v.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,v),m.update(_);break}case 2:{const v=this.items.get(h[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const _=[[h[1]]];for(;_.length;)for(const b of _.pop()){const P=this.items.get(b);P&&(_.push(P.children),this.items.delete(b),m.remove(P,P!==v),P.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break}m.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=i}),define(me[89],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(C){C.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class k{constructor(T,y=T.length){if(this.path=T,this.viewEnd=y,T.length===0||y<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,y,S=T.parent){if(T.id===y)return new k([y]);let A=[T.id];for(let i=S;i&&i.id!==y;i=i.parent)A.push(i.id);return A.push(y),new k(A.reverse())}static isRoot(T){return!T.includes("\0")}static fromString(T){return new k(T.split("\0"))}static join(T,y){return new k([...T.path,y])}static joinToString(T,y){return T.toString()+"\0"+y}static compare(T,y){return T===y?0:y.startsWith(T+"\0")?2:T.startsWith(y+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new k(this.path,T)}compare(T){if(typeof T=="string")return k.compare(this.toString(),T);for(let y=0;y<T.viewEnd&&y<this.viewEnd;y++)if(T.path[y]!==this.path[y])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=k}),define(me[215],ge([0,1,8,38,14,22,11,78,177]),function(Y,e,g,R,k,C,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(I,c,m){this._contributedVariables=new Map,this._context=I,this._labelService=c,m&&(this._envVariablesPromise=m.then(h=>this.prepareEnv(h)))}prepareEnv(I){if(T.isWindows){const c=Object.create(null);return Object.keys(I).forEach(m=>{c[m.toLowerCase()]=I[m]}),c}return I}resolveWithEnvironment(I,c,m){return this.recursiveResolve(this.prepareEnv(I),c?c.uri:void 0,m)}async resolveAsync(I,c){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,c)}async resolveAnyBase(I,c,m,h){const v=C.deepClone(c);return T.isWindows&&v.windows?Object.keys(v.windows).forEach(_=>v[_]=v.windows[_]):T.isMacintosh&&v.osx?Object.keys(v.osx).forEach(_=>v[_]=v.osx[_]):T.isLinux&&v.linux&&Object.keys(v.linux).forEach(_=>v[_]=v.linux[_]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,v,m,h)}async resolveAnyAsync(I,c,m){return this.resolveAnyBase(I,c,m)}async resolveAnyMap(I,c,m){const h=new Map;return{newConfig:await this.resolveAnyBase(I,c,m,h),resolvedVariables:h}}resolveWithInteractionReplace(I,c,m,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,c,m,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,c){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,c)}recursiveResolve(I,c,m,h,v){if(k.isString(m))return this.resolveString(I,c,m,h,v);if(k.isArray(m))return m.map(_=>this.recursiveResolve(I,c,_,h,v));if(k.isObject(m)){let _=Object.create(null);return Object.keys(m).forEach(b=>{const P=this.resolveString(I,c,b,h,v);_[P]=this.recursiveResolve(I,c,m[b],h,v)}),_}return m}resolveString(I,c,m,h,v){return m.replace(A.VARIABLE_REGEXP,(b,P)=>{if(P.includes(A.VARIABLE_LHS))return b;let l=this.evaluateSingleVariable(I,b,P,c,h);return v&&v.set(P,l),l!==b&&k.isString(l)&&l.match(A.VARIABLE_REGEXP)&&(l=this.resolveString(I,c,l,h,v)),l})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,c,m,h,v){let _;const b=m.split(":");b.length>1&&(m=b[0],_=b[1]);const P=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,S.localize)(0,null,c))},l=()=>{const p=P();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,c,g.basename(p)))},f=()=>{if(_){const p=this._context.getFolderUri(_);if(p)return p;throw new Error((0,S.localize)(2,null,c,_))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,c)):new Error((0,S.localize)(4,null,c))};switch(m){case"env":if(_){if(I){const p=I[T.isWindows?_.toLowerCase():_];if(k.isString(p))return p}return""}throw new Error((0,S.localize)(5,null,c));case"config":if(_){const p=this._context.getConfigurationValue(h,_);if(k.isUndefinedOrNull(p))throw new Error((0,S.localize)(6,null,c,_));if(k.isObject(p))throw new Error((0,S.localize)(7,null,c,_));return p}throw new Error((0,S.localize)(8,null,c));case"command":return this.resolveFromMap(c,_,v,"command");case"input":return this.resolveFromMap(c,_,v,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,y.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return h||_?(0,y.normalizeDriveLetter)(this.fsPath(f())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(f()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,S.localize)(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,c));case"file":return P();case"fileWorkspaceFolder":return l();case"relativeFile":return h||_?g.relative(this.fsPath(f()),P()):P();case"relativeFileDirname":const s=g.dirname(P());if(h||_){const d=g.relative(this.fsPath(f()),s);return d.length===0?".":d}return s;case"fileDirname":return g.dirname(P());case"fileExtname":return g.extname(P());case"fileBasename":return g.basename(P());case"fileBasenameNoExtension":const o=g.basename(P());return o.slice(0,o.length-g.extname(o).length);case"fileDirnameBasename":return g.basename(g.dirname(P()));case"execPath":const n=this._context.getExecPath();return n||c;case"execInstallFolder":const a=this._context.getAppRoot();return a||c;case"pathSeparator":return g.sep;default:try{const d=_?`${m}:${_}`:m;return this.resolveFromMap(c,d,v,void 0)}catch(d){return c}}}}resolveFromMap(I,c,m,h){if(c&&m){const v=h===void 0?m[c]:m[h+":"+c];if(typeof v=="string")return v;throw new Error((0,S.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[127],ge([0,1,4,207]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var k;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var C;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function A(v){const _=v;return(0,R.isEditorInput)(_?.editor)&&(0,R.isEditorInput)(_?.replacement)}e.isEditorReplacement=A;var i;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.EDITOR_OPEN=2]="EDITOR_OPEN",v[v.EDITOR_CLOSE=3]="EDITOR_CLOSE",v[v.EDITOR_MOVE=4]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=6]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=8]="EDITOR_PIN",v[v.EDITOR_STICKY=9]="EDITOR_STICKY",v[v.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var c;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(c=e.OpenEditorContext||(e.OpenEditorContext={}));function m(v){const _=v;return!!_&&typeof _.id=="number"&&Array.isArray(_.editors)}e.isEditorGroup=m;function h(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=h}),define(me[216],ge([0,1,4,127]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(C){const T=C;return typeof C=="number"||(0,R.isEditorGroup)(T)}e.isPreferredGroup=k}),define(me[15],ge([0,1,20,98,291,59,22,14,2,41,82,178,116,87,125,89,216,7]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var P;(function(pe){function de(q){const{selectionStartLineNumber:_e,selectionStartColumn:Le,positionLineNumber:Qe,positionColumn:qe}=q,ft=new b.Position(_e-1,Le-1),ht=new b.Position(Qe-1,qe-1);return new b.Selection(ft,ht)}pe.to=de;function ce(q){const{anchor:_e,active:Le}=q;return{selectionStartLineNumber:_e.line+1,selectionStartColumn:_e.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}pe.from=ce})(P=e.Selection||(e.Selection={}));var l;(function(pe){function de(q){if(!q)return;const{start:_e,end:Le}=q;return{startLineNumber:_e.line+1,startColumn:_e.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}pe.from=de;function ce(q){if(!q)return;const{startLineNumber:_e,startColumn:Le,endLineNumber:Qe,endColumn:qe}=q;return new b.Range(_e-1,Le-1,Qe-1,qe-1)}pe.to=ce})(l=e.Range||(e.Range={}));var f;(function(pe){function de(ce){switch(ce){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}pe.to=de})(f=e.TokenType||(e.TokenType={}));var p;(function(pe){function de(q){return new b.Position(q.lineNumber-1,q.column-1)}pe.to=de;function ce(q){return{lineNumber:q.line+1,column:q.character+1}}pe.from=ce})(p=e.Position||(e.Position={}));var t;(function(pe){function de(q){switch(q){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}pe.from=de;function ce(q){switch(q){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}pe.to=ce})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(pe){function de(q){let _e;return q.code&&((0,y.isString)(q.code)||(0,y.isNumber)(q.code)?_e=String(q.code):_e={value:String(q.code.value),target:q.code.target}),{...l.from(q.range),message:q.message,source:q.source,code:_e,severity:n.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(o.from),tags:Array.isArray(q.tags)?(0,g.coalesce)(q.tags.map(t.from)):void 0}}pe.from=de;function ce(q){const _e=new b.Diagnostic(l.to(q),q.message,n.to(q.severity));return _e.source=q.source,_e.code=(0,y.isString)(q.code)?q.code:q.code?.value,_e.relatedInformation=q.relatedInformation&&q.relatedInformation.map(o.to),_e.tags=q.tags&&(0,g.coalesce)(q.tags.map(t.to)),_e}pe.to=ce})(s=e.Diagnostic||(e.Diagnostic={}));var o;(function(pe){function de(q){return{...l.from(q.location.range),message:q.message,resource:q.location.uri}}pe.from=de;function ce(q){return new b.DiagnosticRelatedInformation(new b.Location(q.resource,l.to(q)),q.message)}pe.to=ce})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(pe){function de(q){switch(q){case b.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}pe.from=de;function ce(q){switch(q){case c.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}pe.to=ce})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(pe){function de(q){return typeof q=="number"&&q>=b.ViewColumn.One?q-1:q===b.ViewColumn.Beside?_.SIDE_GROUP:_.ACTIVE_GROUP}pe.from=de;function ce(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=ce})(a=e.ViewColumn||(e.ViewColumn={}));function d(pe){return typeof pe.range!="undefined"}function u(pe){return pe.length===0?!0:!!d(pe[0])}e.isDecorationOptionsArr=u;var w;(function(pe){function de(qe){return qe.map(pe.from)}pe.fromMany=de;function ce(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function q(qe){let ft;if(ce(qe)){const{language:ct,value:ut}=qe;ft={value:"```"+ct+`
`+ut+"\n```\n"}}else b.MarkdownString.isMarkdownString(qe)?ft={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons}:typeof qe=="string"?ft={value:qe}:ft={value:""};const ht=Object.create(null);ft.uris=ht;const yt=ct=>{try{let ut=S.URI.parse(ct,!0);ut=ut.with({query:_e(ut.query,ht)}),ht[ct]=ut}catch(ut){}return""},gt=new k.Renderer;return gt.link=yt,gt.image=ct=>yt(R.parseHrefAndDimensions(ct).href),k(ft.value,{renderer:gt}),ft}pe.from=q;function _e(qe,ft){if(!qe)return qe;let ht;try{ht=(0,C.parse)(qe)}catch(gt){}if(!ht)return qe;let yt=!1;return ht=(0,T.cloneAndChange)(ht,gt=>{if(S.URI.isUri(gt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[ct]=gt,yt=!0,ct}else return}),yt?JSON.stringify(ht):qe}function Le(qe){const ft=new b.MarkdownString(qe.value,qe.supportThemeIcons);return ft.isTrusted=qe.isTrusted,ft}pe.to=Le;function Qe(qe){if(!!qe)return typeof qe=="string"?qe:pe.from(qe)}pe.fromStrict=Qe})(w=e.MarkdownString||(e.MarkdownString={}));function E(pe){return u(pe)?pe.map(de=>({range:l.from(de.range),hoverMessage:Array.isArray(de.hoverMessage)?w.fromMany(de.hoverMessage):de.hoverMessage?w.from(de.hoverMessage):void 0,renderOptions:de.renderOptions})):pe.map(de=>({range:l.from(de)}))}e.fromRangeOrRangeWithMessage=E;function r(pe){return typeof pe=="undefined"?pe:typeof pe=="string"?S.URI.file(pe):pe}e.pathOrURIToURI=r;var D;(function(pe){function de(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?r(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}pe.from=de})(D=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(pe){function de(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?r(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?D.from(ce.before):void 0,after:ce.after?D.from(ce.after):void 0}}pe.from=de})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var U;(function(pe){function de(ce){if(typeof ce=="undefined")return ce;switch(ce){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=de})(U=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var j;(function(pe){function de(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?U.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?L.from(ce.light):void 0,dark:ce.dark?L.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?r(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?D.from(ce.before):void 0,after:ce.after?D.from(ce.after):void 0}}pe.from=de})(j=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var te;(function(pe){function de(q){return{text:q.newText,eol:q.newEol&&ee.from(q.newEol),range:l.from(q.range)}}pe.from=de;function ce(q){const _e=new b.TextEdit(l.to(q.range),q.text);return _e.newEol=typeof q.eol=="undefined"?void 0:ee.to(q.eol),_e}pe.to=ce})(te=e.TextEdit||(e.TextEdit={}));var K;(function(pe){function de(q,_e,Le){const Qe={edits:[]};if(q instanceof b.WorkspaceEdit)for(let qe of q._allEntries())if(qe._type===1)Qe.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const ft=_e?.getDocument(qe.uri);Qe.edits.push({_type:2,resource:qe.uri,edit:te.from(qe.edit),modelVersionId:ft?.version,metadata:qe.metadata})}else qe._type===3?Qe.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&Qe.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Ne.from)}});return Qe}pe.from=de;function ce(q){const _e=new b.WorkspaceEdit;for(const Le of q.edits)Le.edit?_e.replace(S.URI.revive(Le.resource),l.to(Le.edit.range),Le.edit.text):_e.renameFile(S.URI.revive(Le.oldUri),S.URI.revive(Le.newUri),Le.options);return _e}pe.to=ce})(K=e.WorkspaceEdit||(e.WorkspaceEdit={}));var O;(function(pe){const de=Object.create(null);de[b.SymbolKind.File]=0,de[b.SymbolKind.Module]=1,de[b.SymbolKind.Namespace]=2,de[b.SymbolKind.Package]=3,de[b.SymbolKind.Class]=4,de[b.SymbolKind.Method]=5,de[b.SymbolKind.Property]=6,de[b.SymbolKind.Field]=7,de[b.SymbolKind.Constructor]=8,de[b.SymbolKind.Enum]=9,de[b.SymbolKind.Interface]=10,de[b.SymbolKind.Function]=11,de[b.SymbolKind.Variable]=12,de[b.SymbolKind.Constant]=13,de[b.SymbolKind.String]=14,de[b.SymbolKind.Number]=15,de[b.SymbolKind.Boolean]=16,de[b.SymbolKind.Array]=17,de[b.SymbolKind.Object]=18,de[b.SymbolKind.Key]=19,de[b.SymbolKind.Null]=20,de[b.SymbolKind.EnumMember]=21,de[b.SymbolKind.Struct]=22,de[b.SymbolKind.Event]=23,de[b.SymbolKind.Operator]=24,de[b.SymbolKind.TypeParameter]=25;function ce(_e){return typeof de[_e]=="number"?de[_e]:6}pe.from=ce;function q(_e){for(const Le in de)if(de[Le]===_e)return Number(Le);return b.SymbolKind.Property}pe.to=q})(O=e.SymbolKind||(e.SymbolKind={}));var x;(function(pe){function de(q){switch(q){case b.SymbolTag.Deprecated:return 1}}pe.from=de;function ce(q){switch(q){case 1:return b.SymbolTag.Deprecated}}pe.to=ce})(x=e.SymbolTag||(e.SymbolTag={}));var F;(function(pe){function de(q){return{name:q.name,kind:O.from(q.kind),tags:q.tags&&q.tags.map(x.from),containerName:q.containerName,location:$.from(q.location)}}pe.from=de;function ce(q){const _e=new b.SymbolInformation(q.name,O.to(q.kind),q.containerName,$.to(q.location));return _e.tags=q.tags&&q.tags.map(x.to),_e}pe.to=ce})(F=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var z;(function(pe){function de(q){const _e={name:q.name||"!!MISSING: name!!",detail:q.detail,range:l.from(q.range),selectionRange:l.from(q.selectionRange),kind:O.from(q.kind),tags:q.tags?.map(x.from)??[]};return q.children&&(_e.children=q.children.map(de)),_e}pe.from=de;function ce(q){const _e=new b.DocumentSymbol(q.name,q.detail,O.to(q.kind),l.to(q.range),l.to(q.selectionRange));return(0,g.isNonEmptyArray)(q.tags)&&(_e.tags=q.tags.map(x.to)),q.children&&(_e.children=q.children.map(ce)),_e}pe.to=ce})(z=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(pe){function de(q){const _e=new b.CallHierarchyItem(O.to(q.kind),q.name,q.detail||"",S.URI.revive(q.uri),l.to(q.range),l.to(q.selectionRange));return _e._sessionId=q._sessionId,_e._itemId=q._itemId,_e}pe.to=de;function ce(q,_e,Le){if(_e=_e??q._sessionId,Le=Le??q._itemId,_e===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:_e,_itemId:Le,name:q.name,detail:q.detail,kind:O.from(q.kind),uri:q.uri,range:l.from(q.range),selectionRange:l.from(q.selectionRange),tags:q.tags?.map(x.from)}}pe.from=ce})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(pe){function de(ce){return new b.CallHierarchyIncomingCall(M.to(ce.from),ce.fromRanges.map(q=>l.to(q)))}pe.to=de})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var V;(function(pe){function de(ce){return new b.CallHierarchyOutgoingCall(M.to(ce.to),ce.fromRanges.map(q=>l.to(q)))}pe.to=de})(V=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(pe){function de(q){return{range:q.range&&l.from(q.range),uri:q.uri}}pe.from=de;function ce(q){return new b.Location(S.URI.revive(q.uri),l.to(q.range))}pe.to=ce})($=e.location||(e.location={}));var G;(function(pe){function de(q){const _e=q,Le=q;return{originSelectionRange:_e.originSelectionRange?l.from(_e.originSelectionRange):void 0,uri:_e.targetUri?_e.targetUri:Le.uri,range:l.from(_e.targetRange?_e.targetRange:Le.range),targetSelectionRange:_e.targetSelectionRange?l.from(_e.targetSelectionRange):void 0}}pe.from=de;function ce(q){return{targetUri:S.URI.revive(q.uri),targetRange:l.to(q.range),targetSelectionRange:q.targetSelectionRange?l.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?l.to(q.originSelectionRange):void 0}}pe.to=ce})(G=e.DefinitionLink||(e.DefinitionLink={}));var J;(function(pe){function de(q){return{range:l.from(q.range),contents:w.fromMany(q.contents)}}pe.from=de;function ce(q){return new b.Hover(q.contents.map(w.to),l.to(q.range))}pe.to=ce})(J=e.Hover||(e.Hover={}));var fe;(function(pe){function de(q){return{range:l.from(q.range),expression:q.expression}}pe.from=de;function ce(q){return new b.EvaluatableExpression(l.to(q.range),q.expression)}pe.to=ce})(fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(pe){function de(q){if(q instanceof b.InlineValueText)return{type:"text",range:l.from(q.range),text:q.text};if(q instanceof b.InlineValueVariableLookup)return{type:"variable",range:l.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=de;function ce(q){switch(q.type){case"text":return{range:l.to(q.range),text:q.text};case"variable":return{range:l.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:l.to(q.range),expression:q.expression}}}pe.to=ce})(ye=e.InlineValue||(e.InlineValue={}));var ke;(function(pe){function de(q){return{frameId:q.frameId,stoppedLocation:l.from(q.stoppedLocation)}}pe.from=de;function ce(q){return new b.InlineValueContext(q.frameId,l.to(q.stoppedLocation))}pe.to=ce})(ke=e.InlineValueContext||(e.InlineValueContext={}));var Re;(function(pe){function de(q){return{range:l.from(q.range),kind:q.kind}}pe.from=de;function ce(q){return new b.DocumentHighlight(l.to(q.range),q.kind)}pe.to=ce})(Re=e.DocumentHighlight||(e.DocumentHighlight={}));var Ve;(function(pe){function de(ce){switch(ce){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}pe.to=de})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(pe){function de(ce){return{triggerKind:Ve.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}pe.to=de})(Be=e.CompletionContext||(e.CompletionContext={}));var Ke;(function(pe){function de(q){switch(q){case b.CompletionItemTag.Deprecated:return 1}}pe.from=de;function ce(q){switch(q){case 1:return b.CompletionItemTag.Deprecated}}pe.to=ce})(Ke=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(pe){const de=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function ce(Le){return de.get(Le)??9}pe.from=ce;const q=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function _e(Le){return q.get(Le)??b.CompletionItemKind.Property}pe.to=_e})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(pe){function de(ce,q){const _e=new b.CompletionItem(ce.label);return _e.insertText=ce.insertText,_e.kind=W.to(ce.kind),_e.tags=ce.tags?.map(Ke.to),_e.detail=ce.detail,_e.documentation=R.isMarkdownString(ce.documentation)?w.to(ce.documentation):ce.documentation,_e.sortText=ce.sortText,_e.filterText=ce.filterText,_e.preselect=ce.preselect,_e.commitCharacters=ce.commitCharacters,A.Range.isIRange(ce.range)?_e.range=l.to(ce.range):typeof ce.range=="object"&&(_e.range={inserting:l.to(ce.range.insert),replacing:l.to(ce.range.replace)}),_e.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?_e.insertText=new b.SnippetString(ce.insertText):(_e.insertText=ce.insertText,_e.textEdit=_e.range instanceof b.Range?new b.TextEdit(_e.range,_e.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(_e.additionalTextEdits=ce.additionalTextEdits.map(Le=>te.to(Le))),_e.command=q&&ce.command?q.fromInternal(ce.command):void 0,_e}pe.to=de})(Z=e.CompletionItem||(e.CompletionItem={}));var re;(function(pe){function de(q){return{label:q.label,documentation:q.documentation?w.fromStrict(q.documentation):void 0}}pe.from=de;function ce(q){return{label:q.label,documentation:R.isMarkdownString(q.documentation)?w.to(q.documentation):q.documentation}}pe.to=ce})(re=e.ParameterInformation||(e.ParameterInformation={}));var ae;(function(pe){function de(q){return{label:q.label,documentation:q.documentation?w.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(re.from):[],activeParameter:q.activeParameter}}pe.from=de;function ce(q){return{label:q.label,documentation:R.isMarkdownString(q.documentation)?w.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(re.to):[],activeParameter:q.activeParameter}}pe.to=ce})(ae=e.SignatureInformation||(e.SignatureInformation={}));var Q;(function(pe){function de(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(ae.from):[]}}pe.from=de;function ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(ae.to):[]}}pe.to=ce})(Q=e.SignatureHelp||(e.SignatureHelp={}));var oe;(function(pe){function de(q){return{text:q.text,position:p.from(q.position),kind:we.from(q.kind??b.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}pe.from=de;function ce(q){const _e=new b.InlayHint(q.text,p.to(q.position),we.to(q.kind));return _e.whitespaceAfter=q.whitespaceAfter,_e.whitespaceBefore=q.whitespaceBefore,_e}pe.to=ce})(oe=e.InlayHint||(e.InlayHint={}));var we;(function(pe){function de(q){return q}pe.from=de;function ce(q){return q}pe.to=ce})(we=e.InlayHintKind||(e.InlayHintKind={}));var Me;(function(pe){function de(q){return{range:l.from(q.range),url:q.target,tooltip:q.tooltip}}pe.from=de;function ce(q){let _e;if(q.url)try{_e=typeof q.url=="string"?S.URI.parse(q.url,!0):S.URI.revive(q.url)}catch(Le){}return new b.DocumentLink(l.to(q.range),_e)}pe.to=ce})(Me=e.DocumentLink||(e.DocumentLink={}));var je;(function(pe){function de(q){const _e=new b.ColorPresentation(q.label);return q.textEdit&&(_e.textEdit=te.to(q.textEdit)),q.additionalTextEdits&&(_e.additionalTextEdits=q.additionalTextEdits.map(Le=>te.to(Le))),_e}pe.to=de;function ce(q){return{label:q.label,textEdit:q.textEdit?te.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(_e=>te.from(_e)):void 0}}pe.from=ce})(je=e.ColorPresentation||(e.ColorPresentation={}));var Xe;(function(pe){function de(q){return new b.Color(q[0],q[1],q[2],q[3])}pe.to=de;function ce(q){return[q.red,q.green,q.blue,q.alpha]}pe.from=ce})(Xe=e.Color||(e.Color={}));var Se;(function(pe){function de(q){return{range:l.from(q.range)}}pe.from=de;function ce(q){return new b.SelectionRange(l.to(q.range))}pe.to=ce})(Se=e.SelectionRange||(e.SelectionRange={}));var tt;(function(pe){function de(ce){switch(ce){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}pe.to=de})(tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(pe){function de(q){switch(q){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=de;function ce(q){switch(q){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}pe.to=ce})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ee;(function(pe){function de(q){if(q===b.EndOfLine.CRLF)return 1;if(q===b.EndOfLine.LF)return 0}pe.from=de;function ce(q){if(q===1)return b.EndOfLine.CRLF;if(q===0)return b.EndOfLine.LF}pe.to=ce})(ee=e.EndOfLine||(e.EndOfLine={}));var ve;(function(pe){function de(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=de})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Ue;(function(pe){function de(ce){const q={start:ce.start+1,end:ce.end+1};return ce.kind&&(q.kind=Je.from(ce.kind)),q}pe.from=de})(Ue=e.FoldingRange||(e.FoldingRange={}));var Je;(function(pe){function de(ce){if(ce)switch(ce){case b.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}pe.from=de})(Je=e.FoldingRangeKind||(e.FoldingRangeKind={}));var nt;(function(pe){function de(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?l.from(ce.selection):void 0,override:typeof ce.override=="boolean"?I.EditorResolution.DISABLED:void 0}}pe.from=de})(nt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var at;(function(pe){function de(q){return q instanceof b.RelativePattern||typeof q=="string"?q:ce(q)?new b.RelativePattern(q.base,q.pattern):q}pe.from=de;function ce(q){const _e=q;return _e&&typeof _e.base=="string"&&typeof _e.pattern=="string"}})(at=e.GlobPattern||(e.GlobPattern={}));var pt;(function(pe){function de(ce){if(ce){if(Array.isArray(ce))return ce.map(de);if(typeof ce=="string")return ce;{const q=ce;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:at.from(q.pattern),exclusive:q.exclusive}}}else return}pe.from=de})(pt=e.LanguageSelector||(e.LanguageSelector={}));var _t;(function(pe){function de(q){return{start:q.start,end:q.end}}pe.from=de;function ce(q){return new b.NotebookRange(q.start,q.end)}pe.to=ce})(_t=e.NotebookRange||(e.NotebookRange={}));var St;(function(pe){function de(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}pe.to=de;function ce(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}pe.from=ce})(St=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var le;(function(pe){function de(q){switch(q){case b.NotebookCellKind.Markup:return h.CellKind.Markup;case b.NotebookCellKind.Code:default:return h.CellKind.Code}}pe.from=de;function ce(q){switch(q){case h.CellKind.Markup:return b.NotebookCellKind.Markup;case h.CellKind.Code:default:return b.NotebookCellKind.Code}}pe.to=ce})(le=e.NotebookCellKind||(e.NotebookCellKind={}));var Pe;(function(pe){function de(q){const _e={metadata:q.metadata??Object.create(null),cells:[]};for(let Le of q.cells)b.NotebookCellData.validate(Le),_e.cells.push(Ne.from(Le));return _e}pe.from=de;function ce(q){const _e=new b.NotebookData(q.cells.map(Ne.to));return(0,y.isEmptyObject)(q.metadata)||(_e.metadata=q.metadata),_e}pe.to=ce})(Pe=e.NotebookData||(e.NotebookData={}));var Ne;(function(pe){function de(q){return{cellKind:le.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:St.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(We.from):[]}}pe.from=de;function ce(q){return new b.NotebookCellData(le.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(We.to):void 0,q.metadata,q.internalMetadata?St.to(q.internalMetadata):void 0)}pe.to=ce})(Ne=e.NotebookCellData||(e.NotebookCellData={}));var Ye;(function(pe){function de(q){return{mime:q.mime,valueBytes:Array.from(q.data)}}pe.from=de;function ce(q){return new b.NotebookCellOutputItem(new Uint8Array(q.valueBytes),q.mime)}pe.to=ce})(Ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var We;(function(pe){function de(q){return{outputId:q.id,items:q.items.map(Ye.from),metadata:q.metadata}}pe.from=de;function ce(q){const _e=q.items.map(Ye.to);return new b.NotebookCellOutput(_e,q.outputId,q.metadata)}pe.to=ce})(We=e.NotebookCellOutput||(e.NotebookCellOutput={}));var st;(function(pe){function de(Le){if(Le!=null){if(Le instanceof b.RelativePattern||typeof Le=="string")return Le;if(_e(Le))return new b.RelativePattern(Le.base,Le.pattern);if(q(Le))return{include:at.from(Le.include)||void 0,exclude:at.from(Le.exclude)||void 0}}}pe.from=de;function ce(Le){return typeof Le=="string"?Le:_e(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}pe.to=ce;function q(Le){const Qe=Le,qe=at.from(Qe.include);if(!(qe&&qe instanceof b.RelativePattern||typeof qe=="string"))return!1;const ft=at.from(Qe.exclude);return!!(ft&&ft instanceof b.RelativePattern||typeof ft=="string")}function _e(Le){const Qe=Le;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(st=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Te;(function(pe){function de(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?D.from(ce.top):void 0}}pe.from=de})(Te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var De;(function(pe){function de(ce,q,_e){const Le=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Le,_e),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}pe.from=de})(De=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ie;(function(pe){function de(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}pe.from=de})(Ie=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ne;(function(pe){function de(q){return{uri:q.uri,provides:q.provides}}pe.from=de;function ce(q){return new b.NotebookRendererScript(S.URI.revive(q.uri),q.provides)}pe.to=ce})(ne=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ue;(function(pe){function de(q){return{message:w.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location?$.from(q.location):void 0}}pe.from=de;function ce(q){const _e=new b.TestMessage(typeof q.message=="string"?q.message:w.to(q.message));return _e.actualOutput=q.actual,_e.expectedOutput=q.expected,_e}pe.to=ce})(ue=e.TestMessage||(e.TestMessage={}));var Ee;(function(pe){let de;(function(q){q.Delimiter="\0"})(de||(de={})),pe.namespace=(q,_e)=>q+"\0"+_e;function ce(q,_e){return{displayId:_e.id,id:pe.namespace(q,_e.id),label:_e.label}}pe.display=ce,pe.denamespace=q=>{const _e=q.indexOf("\0");return{ctrlId:q.slice(0,_e),tagId:q.slice(_e+1)}}})(Ee=e.TestTag||(e.TestTag={}));var be;(function(pe){function de(Le){const Qe=(0,m.getPrivateApiFor)(Le).controllerId;return{extId:v.TestId.fromExtHostTestItem(Le,Qe).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(qe=>Ee.namespace(Qe,qe.id)),range:l.from(Le.range)||null,description:Le.description||null,error:Le.error&&w.fromStrict(Le.error)||null}}pe.from=de;function ce(Le){return{id:v.TestId.fromString(Le.extId).localId,label:Le.label,uri:S.URI.revive(Le.uri),tags:(Le.tags||[]).map(Qe=>{const{tagId:qe}=Ee.denamespace(Qe);return new b.TestTag(qe,qe)}),range:l.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}pe.toPlain=ce;function q(Le){const Qe=v.TestId.fromString(Le.extId),qe=new m.TestItemImpl(Qe.controllerId,Qe.localId,Le.label,S.URI.revive(Le.uri));return qe.range=l.to(Le.range||void 0),qe.description=Le.description||void 0,qe}function _e(Le){let Qe;for(const qe of Le.tests){const ft=q(qe.item);(0,m.getPrivateApiFor)(ft).parent=Qe,Qe=ft}return Qe}pe.toItemFromContext=_e})(be=e.TestItem||(e.TestItem={})),function(pe){function de(q){return{id:q.id,label:q.label}}pe.from=de;function ce(q){return new b.TestTag(q.id,q.label)}pe.to=ce}(Ee=e.TestTag||(e.TestTag={}));var Fe;(function(pe){const de=(q,_e)=>{const Le={...be.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(qe=>qe.type===0).map(ue.to)})),children:q.children.map(Qe=>_e.get(Qe)).filter(y.isDefined).map(Qe=>de(Qe,_e))};for(const Qe of Le.children)Qe.parent=Le;return Le};function ce(q){const _e=[],Le=new Map;for(const Qe of q.items)Le.set(Qe.item.extId,Qe),q.request.targets.some(qe=>qe.controllerId===Qe.controllerId&&qe.testIds.includes(Qe.item.extId))&&_e.push(Qe);return{completedAt:q.completedAt,results:_e.map(Qe=>de(Qe,Le))}}pe.to=ce})(Fe=e.TestResults||(e.TestResults={}));var Ge;(function(pe){function de(Le){return{covered:Le.covered,total:Le.covered}}function ce(Le){return"line"in Le?p.from(Le):l.from(Le)}function q(Le){return"branches"in Le?{count:Le.executionCount,location:ce(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&ce(Qe.location)})):void 0}:{type:0,count:Le.executionCount,location:ce(Le.location)}}pe.fromDetailed=q;function _e(Le){return{uri:Le.uri,statement:de(Le.statementCoverage),branch:Le.branchCoverage&&de(Le.branchCoverage),function:Le.functionCoverage&&de(Le.functionCoverage),details:Le.detailedCoverage?.map(q)}}pe.fromFile=_e})(Ge=e.TestCoverage||(e.TestCoverage={}));var $e;(function(pe){function de(ce){switch(ce){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}pe.to=de})($e=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ze;(function(pe){function de(q){const _e=new b.TypeHierarchyItem(O.to(q.kind),q.name,q.detail||"",S.URI.revive(q.uri),l.to(q.range),l.to(q.selectionRange));return _e._sessionId=q._sessionId,_e._itemId=q._itemId,_e}pe.to=de;function ce(q,_e,Le){if(_e=_e??q._sessionId,Le=Le??q._itemId,_e===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:_e,_itemId:Le,kind:O.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:l.from(q.range),selectionRange:l.from(q.selectionRange),tags:q.tags?.map(x.from)}}pe.from=ce})(Ze=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[217],ge([0,1,2,16,7,15,94]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class y{constructor(A,i,I,c={timeout:1500,errors:3}){this._logService=A,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=c,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(i,I,c)=>{const h={dispose:this._callbacks.push([i,I,A])};return Array.isArray(c)&&c.push(h),h}}async $participateInSave(A,i){const I=g.URI.revive(A);let c=!1;const m=setTimeout(()=>c=!0,this._thresholds.timeout),h=[];try{for(let v of[...this._callbacks]){if(c)break;const _=this._documents.getDocument(I),b=await this._deliverEventAsyncAndBlameBadListeners(v,{document:_,reason:C.TextDocumentSaveReason.to(i)});h.push(b)}}finally{clearTimeout(m)}return h}_deliverEventAsyncAndBlameBadListeners([A,i,I],c){const m=this._badListeners.get(A);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,A,i,c).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const v=this._badListeners.get(A);this._badListeners.set(A,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,i,I,c){const m=[],h=Date.now(),{document:v,reason:_}=c,{version:b}=v,P=Object.freeze({document:v,reason:_,waitUntil(l){if(Object.isFrozen(m))throw(0,R.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(l))}});try{i.apply(I,[P])}catch(l){return Promise.reject(l)}return Object.freeze(m),new Promise((l,f)=>{const p=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(p),l(t)}).catch(t=>{clearTimeout(p),f(t)})}).then(l=>{const f={edits:[]};for(const p of l)if(Array.isArray(p)&&p.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:s,range:o}of p)f.edits.push({_type:2,resource:v.uri,edit:{range:o&&C.Range.from(o),text:t,eol:s&&C.EndOfLine.from(s)}});if(f.edits.length!==0)return b===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=y}),define(me[218],ge([0,1,3,30,2,15,7]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(i,I,c,m,h){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,c&&(this._config+=1),m&&(this._config+=2),h&&(this._config+=4);const v=(0,R.parse)(I),_=i(b=>{if(!c)for(let P of b.created){const l=k.URI.revive(P);v(l.fsPath)&&this._onDidCreate.fire(l)}if(!m)for(let P of b.changed){const l=k.URI.revive(P);v(l.fsPath)&&this._onDidChange.fire(l)}if(!h)for(let P of b.deleted){const l=k.URI.revive(P);v(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,_)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(i,I,c){this._logService=I,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,I,c,m){return new y(this._onFileSystemEvent.event,i,I,c,m)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,I){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(c=>({oldUri:k.URI.revive(c.source),newUri:k.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(c=>k.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(c=>k.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,I){return(c,m,h)=>{const v=function(b){c.call(m,b)};return v.extension=i,I.event(v,void 0,h)}}async $onWillRunFileOperation(i,I,c,m){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(h=>({oldUri:k.URI.revive(h.source),newUri:k.URI.revive(h.target)}))},c,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(h=>k.URI.revive(h.target))},c,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(h=>k.URI.revive(h.target))},c,m)}}async _fireWillEvent(i,I,c,m){const h=new Set,v=[];if(await i.fireAsync(I,m,async(b,P)=>{const l=Date.now(),f=await Promise.resolve(b);f instanceof T.WorkspaceEdit&&(v.push(f),h.add(P.extension.displayName??P.extension.identifier.value)),Date.now()-l>c&&this._logService.warn("SLOW file-participant",P.extension.identifier)}),m.isCancellationRequested||v.length===0)return;const _={edits:[]};for(let b of v){let{edits:P}=C.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);_.edits=_.edits.concat(P)}return{edit:_,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=S}),define(me[219],ge([0,1,10,22,2,15,7,125]),function(Y,e,g,R,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(c,m,h,v){this.start=c,this.deletedCount=m,this.deletedItems=h,this.items=v}static asApiEvents(c){return c.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(h=>h.apiCell)}))}}class A{constructor(c,m,h){this.notebook=c,this._extHostDocument=m,this._cellData=h,this.handle=h.handle,this.uri=k.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(c,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return c._mime},set mime(h){c._mime=h},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(C.NotebookCellOutput.to)}setOutputItems(c,m,h){const v=h.map(C.NotebookCellOutputItem.to),_=this._outputs.find(b=>b.id===c);_&&(m||(_.items.length=0),_.items.push(...v))}setMetadata(c){this._metadata=Object.freeze(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(c))}setMime(c){}}e.ExtHostCell=A;class i{constructor(c,m,h,v,_,b){this._proxy=c,this._textDocumentsAndEditors=m,this._textDocuments=h,this._emitter=v,this.uri=_,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===g.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(m){return m=c._validateIndex(m),c._cells[m].apiCell},getCells(m){return(m?c._getCells(m):c._cells).map(v=>v.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=Object.freeze({...this._metadata,...c.metadata}))}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,m){this._versionId=c.versionId,this._isDirty=m;for(const h of c.rawEvents)h.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===y.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===y.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let m=c.start|0,h=c.end|0;return m<0&&(m=0),h>this._cells.length&&(h=this._cells.length),c.with({start:m,end:h})}_getCells(c){c=this._validateRange(c);const m=[];for(let h=c.start;h<c.end;h++)m.push(this._cells[h]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,m){if(this._disposed)return;const h=[],v=[],_=[];c.reverse().forEach(b=>{const l=b[2].map(t=>{const s=new A(this,this._textDocumentsAndEditors,t);return m||v.push(A.asModelAddData(this.apiNotebook,t)),s}),f=new S(b[0],b[1],[],l),p=this._cells.splice(b[0],b[1],...l);for(const t of p)_.push(t.uri),f.deletedItems.push(t.apiCell);h.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:_}),m||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(h)}))}_moveCell(c,m){const h=this._cells.splice(c,1);this._cells.splice(m,0,...h);const v=[new S(c,1,h.map(_=>_.apiCell),[]),new S(m,0,[],h)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(v)}))}_setCellOutputs(c,m){const h=this._cells[c];h.setOutputs(m),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(c,m,h,v){const _=this._cells[c];_.setOutputItems(m,h,v),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(c,m){const h=this._cells[c];h.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(h.uri,m)}_changeCellMime(c,m){const h=this._cells[c];h.apiCell.mime=m}_changeCellMetadata(c,m){const h=this._cells[c],v=h.apiCell.metadata;h.setMetadata(m);const _=h.apiCell.metadata;(0,R.equals)(v,_)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(c,m){const h=this._cells[c],v=h.internalMetadata;if(h.setInternalMetadata(m),v.runState!==m.runState){const _=m.runState??T.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:_}))}}getCellFromApiCell(c){return this._cells.find(m=>m.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(m=>m.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(me[128],ge([0,1,7,15,16]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:A})}replaceCells(S,A,i){this._throwIfFinalized(),!(S===A&&i.length===0)&&this._collectedEdits.push({editType:1,index:S,count:A-S,cells:i.map(R.NotebookCellData.from)})}}class T{constructor(S,A,i,I,c,m){this.id=S,this._proxy=A,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=I,this._viewColumn=m}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(A){if(!Array.isArray(A)||!A.every(g.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");S._selections=A,S._trySetSelections(A)},get visibleRanges(){return S._visibleRanges},revealRange(A,i){S._proxy.$tryRevealRange(S.id,R.NotebookRange.from(A),i??g.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(A){const i=new C(this.document.version);return A(i),S._applyEdit(i.finalize())},setDecorations(A,i){return S.setDecorations(A,i)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(R.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const A=[];let i=-1;for(let I=0;I<S.cellEdits.length;I++){if(i<0){A.push(S.cellEdits[I]),i++;continue}const m=A[i],h=S.cellEdits[I];if(m.editType===1&&h.editType===1&&m.index===h.index){m.cells.push(...S.cellEdits[I].cells),m.count+=S.cellEdits[I].count;continue}A.push(S.cellEdits[I]),i++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,A)}setDecorations(S,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return A.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(A),S.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(me[220],ge([0,1,15,117,165,21,56]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,c,m){const h=this._handles++,{title:v,location:_,cancellable:b}=c,P={label:(0,k.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(h,{location:g.ProgressLocation.from(_),title:v,source:P,cancellable:b},I),this._withProgress(h,m,!!b)}_withProgress(I,c,m){let h;m&&(h=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,h));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),h&&h.dispose()};let _;try{_=c(new A(this._proxy,I),m&&h?h.token:C.CancellationToken.None)}catch(b){throw v(I),b}return _.then(b=>v(I),b=>v(I)),_}$acceptProgressCanceled(I){const c=this._mapHandleToCancellationSource.get(I);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=y;function S(i,I){return i.message=I.message,typeof I.increment=="number"&&(typeof i.increment=="number"?i.increment+=I.increment:i.increment=I.increment),i}class A extends R.Progress{constructor(I,c){super(m=>this.throttledReport(m));this._proxy=I,this._handle=c}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}ze([(0,T.throttle)(100,(i,I)=>S(i,I),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(me[129],ge([0,1,54,16,74,15,7]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class y{constructor(c,m,h){const v=y._Keys.nextId();c.$registerTextEditorDecorationType(m.identifier,v,C.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:v,dispose(){c.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=y,y._Keys=new k.IdGenerator("TextEditorDecorationType");class S{constructor(c,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,m){this._throwIfFinalized();let h=null;if(c instanceof T.Position)h=new T.Range(c,c);else if(c instanceof T.Range)h=c;else throw new Error("Unrecognized location");this._pushEdit(h,m,!1)}insert(c,m){this._throwIfFinalized(),this._pushEdit(new T.Range(c,c),m,!0)}delete(c){this._throwIfFinalized();let m=null;if(c instanceof T.Range)m=c;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(c,m,h){const v=this._document.validateRange(c);this._collectedEdits.push({range:v,text:m,forceMoveMarkers:h})}setEndOfLine(c){if(this._throwIfFinalized(),c!==T.EndOfLine.LF&&c!==T.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=S;class A{constructor(c,m,h,v){this._proxy=c,this._id=m,this._accept(h),this._logService=v;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(b){_._setTabSize(b)},get insertSpaces(){return _._insertSpaces},set insertSpaces(b){_._setInsertSpaces(b)},get cursorStyle(){return _._cursorStyle},set cursorStyle(b){_._setCursorStyle(b)},get lineNumbers(){return _._lineNumbers},set lineNumbers(b){_._setLineNumbers(b)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const m=Math.floor(c);return m>0?m:null}if(typeof c=="string"){const m=parseInt(c,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(c){const m=this._validateTabSize(c);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const m=this._validateInsertSpaces(c);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(c)})))}assign(c){const m={};let h=!1;if(typeof c.tabSize!="undefined"){const v=this._validateTabSize(c.tabSize);v==="auto"?(h=!0,m.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,h=!0,m.tabSize=v)}if(typeof c.insertSpaces!="undefined"){const v=this._validateInsertSpaces(c.insertSpaces);v==="auto"?(h=!0,m.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,h=!0,m.insertSpaces=v)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,h=!0,m.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,h=!0,m.lineNumbers=C.TextEditorLineNumbersStyle.from(c.lineNumbers)),h&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(c){c.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=A;class i{constructor(c,m,h,v,_,b,P,l){this.id=c,this._proxy=m,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new A(this._proxy,this.id,b,h),this._visibleRanges=P,this._viewColumn=l;const f=this;this.value=Object.freeze({get document(){return v.getValue()},set document(p){throw(0,R.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(p){if(!(p instanceof T.Selection))throw(0,R.illegalArgument)("selection");f._selections=[p],f._trySetSelection()},get selections(){return f._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof T.Selection)))throw(0,R.illegalArgument)("selections");f._selections=p,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(p){throw(0,R.readonly)("visibleRanges")},get options(){return f._options.value},set options(p){f._disposed||f._options.assign(p)},get viewColumn(){return f._viewColumn},set viewColumn(p){throw(0,R.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new S(v.getValue(),t);return p(s),f._applyEdit(s)},insertSnippet(p,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=f._selections.map(n=>C.Range.from(n));else if(t instanceof T.Position){const{lineNumber:n,column:a}=C.Position.from(t);o=[{startLineNumber:n,startColumn:a,endLineNumber:n,endColumn:a}]}else if(t instanceof T.Range)o=[C.Range.from(t)];else{o=[];for(const n of t)if(n instanceof T.Range)o.push(C.Range.from(n));else{const{lineNumber:a,column:d}=C.Position.from(n);o.push({startLineNumber:a,startColumn:d,endLineNumber:a,endColumn:d})}}return m.$tryInsertSnippet(c,p.value,o,s)},setDecorations(p,t){const s=t.length===0;s&&!f._hasDecorationsForKey.has(p.key)||(s?f._hasDecorationsForKey.delete(p.key):f._hasDecorationsForKey.add(p.key),f._runOnProxy(()=>{if(C.isDecorationOptionsArr(t))return m.$trySetDecorations(c,p.key,C.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let n=0,a=t.length;n<a;n++){const d=t[n];o[4*n]=d.start.line+1,o[4*n+1]=d.start.character+1,o[4*n+2]=d.end.line+1,o[4*n+3]=d.end.character+1}return m.$trySetDecorationsFast(c,p.key,o)}}))},revealRange(p,t){f._runOnProxy(()=>m.$tryRevealRange(c,C.Range.from(p),t||T.TextEditorRevealType.Default))},show(p){m.$tryShowEditor(c,C.ViewColumn.from(p))},hide(){m.$tryHideEditor(c)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,g.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,g.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,g.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,g.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const m=c.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const h=m.edits.map(_=>_.range);h.sort((_,b)=>_.end.line===b.end.line?_.end.character===b.end.character?_.start.line===b.start.line?_.start.character-b.start.character:_.start.line-b.start.line:_.end.character-b.end.character:_.end.line-b.end.line);for(let _=0,b=h.length-1;_<b;_++){const P=h[_].end;if(h[_+1].start.isBefore(P))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=m.edits.map(_=>({range:C.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,v,{setEndOfLine:typeof m.setEndOfLine=="number"?C.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=i}),define(me[221],ge([0,1,168,24,2,3,6,208,17,7,14,20,15,21,205]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(P,l){if((0,i.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let f;return Array.isArray(P.highlights)&&(f=P.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),f=f.length?f:void 0),{label:P.label,highlights:f}}}class _{constructor(l,f,p){this._proxy=l,this.commands=f,this.logService=p,this.treeViews=new Map;function t(s){return s&&s.$treeViewId&&s.$treeItemHandle}f.registerArgumentProcessor({processArgument:s=>t(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(o=>t(o)?this.convertArgument(o):o):s})}registerTreeDataProvider(l,f,p){const t=this.createTreeView(l,{treeDataProvider:f},p);return{dispose:()=>t.dispose()}}createTreeView(l,f,p){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=f.dragAndDropController!==void 0,s=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,canDragAndDrop:t}),o=this.createExtHostTreeView(l,f,p);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(n){o.message=n},get title(){return o.title},set title(n){o.title=n},get description(){return o.description},set description(n){o.description=n},reveal:(n,a)=>o.reveal(n,a),dispose:async()=>{await s,this.treeViews.delete(l),o.dispose()}}}$getChildren(l,f){const p=this.treeViews.get(l);return p?p.getChildren(f):Promise.reject(new Error((0,g.localize)(0,null,l)))}async $onDrop(l,f,p){const t=this.treeViews.get(l);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,l)));const s=h.TreeDataTransferConverter.toITreeDataTransfer(f);if(s.items.has(y.TREE_ITEM_DATA_TRANSFER_TYPE)){const n=JSON.parse(await s.items.get(y.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(a=>t.getExtensionElement(a)).filter(a=>!!a);n.length>0?s.items.set(y.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(n)}):s.items.delete(y.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(s,p)}async $hasResolve(l){const f=this.treeViews.get(l);if(!f)throw new Error((0,g.localize)(2,null,l));return f.hasResolve}$resolve(l,f,p){const t=this.treeViews.get(l);if(!t)throw new Error((0,g.localize)(3,null,l));return t.resolveTreeItem(f,p)}$setExpanded(l,f,p){const t=this.treeViews.get(l);if(!t)throw new Error((0,g.localize)(4,null,l));t.setExpanded(f,p)}$setSelection(l,f){const p=this.treeViews.get(l);if(!p)throw new Error((0,g.localize)(5,null,l));p.setSelection(f)}$setVisible(l,f){const p=this.treeViews.get(l);if(!p)throw new Error((0,g.localize)(6,null,l));p.setVisible(f)}createExtHostTreeView(l,f,p){const t=new b(l,f,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(l,t),t}convertArgument(l){const f=this.treeViews.get(l.$treeViewId);return f?f.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=_;class b extends T.Disposable{constructor(l,f,p,t,s,o){super();if(this.viewId=l,this.proxy=p,this.commands=t,this.logService=s,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,o.contributes&&o.contributes.views)for(const d in o.contributes.views)for(const u of o.contributes.views[d])u.id===l&&(this._title=u.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(d=>this._onDidChangeData.fire({message:!1,element:d}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(d=>this._onDidChangeData.fire({message:!1,element:d})));let n,a;this._register(C.Event.debounce(this._onDidChangeData.event,(d,u)=>(d||(d={message:!1,elements:[]}),u.element!==!1&&(n||(n=new Promise(w=>a=w),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(u.element)?d.elements.push(...u.element):d.elements.push(u.element)),u.message&&(d.message=!0),d),200,!0)(({message:d,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=a;return n=null,this.refresh(u).then(()=>w())})),d&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,i.isUndefinedOrNull)(l))}async getChildren(l){const f=l?this.getExtensionElement(l):void 0;if(l&&!f)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let p=this.getChildrenNodes(l);return p||(p=await this.fetchChildrenNodes(f)),p?p.map(t=>t.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,f){f=f||{select:!0,focus:!1};const p=(0,i.isUndefinedOrNull)(f.select)?!0:f.select,t=(0,i.isUndefinedOrNull)(f.focus)?!1:f.focus,s=(0,i.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(o=>this.resolveTreeNode(l,o[o.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:o.map(a=>a.item)},{select:p,focus:t,expand:s})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:t,expand:s})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}setExpanded(l,f){const p=this.getExtensionElement(l);p&&(f?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(l){(0,I.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(l,f){const p=this.getExtensionElement(f);if(!!p)return(0,S.asPromise)(()=>this.dndController?.onDrop(l,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,f){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(l);if(p){const t=this.nodes.get(p);if(t){const s=await this.dataProvider.resolveTreeItem(t.extensionItem,p,f)??t.extensionItem;return t.item.tooltip=this.getTooltip(s.tooltip),t.item.command=this.getCommand(t.disposableStore,s.command),t.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(f=>f?this.resolveUnknownParentChain(f).then(p=>this.resolveTreeNode(f,p[p.length-1]).then(t=>(p.push(t),p))):Promise.resolve([]))}resolveParent(l){const f=this.nodes.get(l);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,f){const p=this.nodes.get(l);return p?Promise.resolve(p):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(t=>this.createHandle(l,t,f,!0)).then(t=>this.getChildren(f?f.item.handle:void 0).then(()=>{const s=this.getExtensionElement(t);if(s){const o=this.nodes.get(s);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(l){if(l){let f;if(typeof l=="string"){const p=this.getExtensionElement(l);f=p?this.nodes.get(p):void 0}else f=l;return f&&f.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const f=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=l?this.nodes.get(l):void 0,t=await this.dataProvider.getChildren(l);if(f.token.isCancellationRequested)return;const s=await Promise.all((0,I.coalesce)(t||[]).map(async o=>{const n=await this.dataProvider.getTreeItem(o);return n&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(o,n,p):null}));return f.token.isCancellationRequested?void 0:(0,I.coalesce)(s)}finally{f.dispose()}}refresh(l){if(l.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(l);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const f=new Set,p=l.map(s=>this.nodes.get(s));for(const s of p)if(s&&!f.has(s.item.handle)){let o=s;for(;o&&o.parent&&p.findIndex(n=>o&&o.parent&&n&&n.item.handle===o.parent.item.handle)===-1;){const n=this.elements.get(o.parent.item.handle);o=n?this.nodes.get(n):void 0}o&&!o.parent&&f.add(s.item.handle)}const t=[];return f.forEach(s=>{const o=this.elements.get(s);if(o){const n=this.nodes.get(o);n&&(!n.parent||!f.has(n.parent.item.handle))&&t.push(s)}}),t}refreshHandles(l){const f={};return Promise.all(l.map(p=>this.refreshNode(p).then(t=>{t&&(f[p]=t.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(l){const f=this.getExtensionElement(l);if(f){const p=this.nodes.get(f);if(p)return this.clearChildren(f),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(t=>{if(t){const s=this.createTreeNode(f,t,p.parent);return this.updateNodeCache(f,s,p,p.parent),p.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,f,p){const t=this.createTreeNode(l,f,p);if(f.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,f.id));return this.addNodeToCache(l,t),this.addNodeToParentCache(t,p),t}getTooltip(l){return A.MarkdownString.isMarkdownString(l)?c.MarkdownString.from(l):l}getCommand(l,f){return f?this.commands.toInternal(f,l):void 0}createTreeNode(l,f,p){const t=new T.DisposableStore,s=this.createHandle(l,f,p),o=this.getLightIconPath(f);return{item:{handle:s,parentHandle:p?p.item.handle:void 0,label:v(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(t,f.command),contextValue:f.contextValue,icon:o,iconDark:this.getDarkIconPath(f)||o,themeIcon:this.getThemeIcon(f),collapsibleState:(0,i.isUndefinedOrNull)(f.collapsibleState)?A.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:p,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(l){return l.iconPath instanceof A.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:f,label:p,resourceUri:t},s,o){if(f)return`${b.ID_HANDLE_PREFIX}/${f}`;const n=v(p,this.extension),a=s?s.item.handle:b.LABEL_HANDLE_PREFIX;let d=n?n.label:t?(0,R.basename)(t):"";d=d.indexOf("/")!==-1?d.replace("/","//"):d;const u=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,w=this.getChildrenNodes(s)||[];let E,r=0;do{if(E=`${a}/${r}:${d}`,o||!this.elements.has(E)||u===E)break;r++}while(r<=w.length);return E}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof A.ThemeIcon))return typeof l.iconPath=="string"||k.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof A.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return k.URI.isUri(l)?l:k.URI.file(l)}addNodeToCache(l,f){this.elements.set(f.item.handle,l),this.nodes.set(l,f)}updateNodeCache(l,f,p,t){this.elements.delete(f.item.handle),this.nodes.delete(l),f.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(l,f);const s=this.getChildrenNodes(t)||[],o=s.filter(n=>n.item.handle===p.item.handle)[0];o&&s.splice(s.indexOf(o),1,f)}addNodeToParentCache(l,f){f?(f.children||(f.children=[]),f.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const f=this.nodes.get(l);if(f){if(f.children)for(const p of f.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}f.children=void 0}}else this.clearAll()}clear(l){const f=this.nodes.get(l);if(f){if(f.children)for(const p of f.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}this.nodes.delete(l),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}b.LABEL_HANDLE_PREFIX="0",b.ID_HANDLE_PREFIX="1"}),define(me[222],ge([0,1,17,3,6,14,87,15,126,89]),function(Y,e,g,R,k,C,T,y,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class i extends k.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const c=this.diff;return this.diff=[],c}*tags(){const c=new Set;for(const m of this.tree.values())for(const h of m.actual.tags)c.has(h.id)||(c.add(h.id),yield h)}pushDiff(c){const m=this.diff[this.diff.length-1];if(m&&c[0]===1){if(m[0]===1&&m[1].extId===c[1].extId){(0,S.applyTestItemUpdate)(m[1],c[1]);return}if(m[0]===0&&m[1].item.extId===c[1].extId){(0,S.applyTestItemUpdate)(m[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,m){const h=this.tree.get(c);if(!!h){if((h.expandLevels===void 0||m>h.expandLevels)&&(h.expandLevels=m),h.expand===1){const v=this.resolveChildren(h);return v.isOpen()?this.expandChildren(h,m-1):v.wait().then(()=>this.expandChildren(h,m-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,m-1)):this.expandChildren(h,m-1)}}dispose(){for(const c of this.tree.values())(0,T.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,m){switch(m.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(A.TestId.joinToString(c.fullId,m.id));break;case 0:this.upsertItem(m.item,c);break;case 4:for(const b of m.ops)this.onTestItemEvent(c,b);break;case 3:const{key:h,value:v}=m,_=c.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.pushDiff([1,{extId:_,item:{tags:v.map(b=>b.id)}}]);break;case"range":this.pushDiff([1,{extId:_,item:{range:y.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:_,item:{error:y.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:_,item:{[h]:v??null}}]);break}break;default:(0,C.assertNever)(m)}}upsertItem(c,m){if(!(c instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const h=A.TestId.fromExtHostTestItem(c,this.root.id,m?.actual),v=(0,T.getPrivateApiFor)(c);v.parent&&v.parent!==m?.actual&&v.parent.children.delete(c.id);let _=this.tree.get(h.toString());if(!_){_={fullId:h,actual:c,parent:m?h.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},this.tree.set(_.fullId.toString(),_),this.setItemParent(c,m),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:y.TestItem.from(c)}]),this.connectItemAndChildren(c,_,m);return}if(_.actual===c){this.connectItem(c,_,m);return}const b=_.actual.children,P=_.actual,l=(0,T.diffTestItems)(P,c);(0,T.getPrivateApiFor)(P).listener=void 0,_.actual=c,_.expand=0;for(const[f,p]of l)this.onTestItemEvent(_,{op:3,key:f,value:p});this.connectItemAndChildren(c,_,m);for(const f of b)c.children.get(f.id)||this.removeItem(A.TestId.joinToString(h,f.id))}setItemParent(c,m){(0,T.getPrivateApiFor)(c).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(c,m,h){this.setItemParent(c,h);const v=(0,T.getPrivateApiFor)(c);v.parent=h?.actual,v.listener=_=>this.onTestItemEvent(m,_),this.updateExpandability(m)}connectItemAndChildren(c,m,h){this.connectItem(c,m,h);for(const v of c.children)this.upsertItem(v,m)}updateExpandability(c){let m;this._resolveHandler?c.resolveBarrier?m=c.resolveBarrier.isOpen()?3:2:m=c.actual.canResolveChildren?1:0:m=0,m!==c.expand&&(c.expand=m,this.pushDiff([1,{extId:c.fullId.toString(),expand:m}]),m===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,m){if(m<0)return;const h=[];for(const v of c.actual.children){const _=this.expand(A.TestId.joinToString(c.fullId,v.id),m);(0,g.isThenable)(_)&&h.push(_)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const _=new g.Barrier;return _.open(),_}c.expand=2,this.pushExpandStateUpdate(c);const m=c.resolveBarrier=new g.Barrier,h=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=_.stack||_.message||String(_))};let v;try{v=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(_){h(_)}return(0,g.isThenable)(v)?v.catch(h).then(()=>{m.open(),this.updateExpandability(c)}):(m.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const m=this.tree.get(c);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const h=[m];for(;h.length;){const v=h.pop();if(!!v){(0,T.getPrivateApiFor)(v.actual).listener=void 0,this.tree.delete(v.fullId.toString());for(const _ of v.actual.children)h.push(this.tree.get(A.TestId.joinToString(v.fullId,_.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=i}),define(me[223],ge([0,1,4,183]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(R.IEnvironmentService)}),define(me[224],ge([0,1,26,3,8]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=C;class T{constructor(i){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(c=>I.add(g.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>I.has(g.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const c=T._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(c.map(m=>m.identifier)),I.length>0){const m=new Set;I.forEach(h=>m.add(g.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!m.has(g.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(c)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,b){this.addNode(_),this.addNode(b),this._arcs.has(_)?this._arcs.get(_).push(b):this._arcs.set(_,[b])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,b){const P=I.getArcs(_);for(let l=0;l<P.length;l++)if(!b.has(P[l]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let _ of i){const b=g.ExtensionIdentifier.toKey(_.identifier);if(c.set(b,_),_.extensionDependencies)for(let P of _.extensionDependencies){const l=g.ExtensionIdentifier.toKey(P);I.addArc(b,l)}}let m=new Set;I.getNodes().filter(_=>I.getArcs(_).length===0).forEach(_=>m.add(_));let h=I.getNodes().filter(_=>!m.has(_)),v;do{v=!1;for(let _=0;_<h.length;_++){const b=h[_];I.hasOnlyGoodArcs(b,m)&&(h.splice(_,1),_--,m.add(b),v=!0)}}while(v);return h.map(_=>c.get(_))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=T;var y;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(y||(y={}));function S(A,i){const I=A.isBuiltin?0:A.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==c)return I-c;const m=k.posix.basename(A.extensionLocation.path),h=k.posix.basename(i.extensionLocation.path);return m<h?-1:m>h?1:0}}),define(me[225],ge([0,1,25]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function C(y){const S=g.VSBuffer.alloc(1);switch(y){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=C;function T(y,S){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=T}),define(me[35],ge([0,1,3,2,4,26,185]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class y{constructor(P){this.dependency=P}}e.MissingExtensionDependency=y;var S;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));class A{constructor(P,l,f,p){this.codeLoadingTime=P,this.activateCallTime=l,this.activateResolvedTime=f,this.activationReason=p}}e.ActivationTimes=A;class i{constructor(P,l){this.description=P,this.value=l}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var I;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function c(b){b.enableProposedApi||m(b)}e.checkProposedApiEnabled=c;function m(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=m;function h(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=h;function v(b,P){return{identifier:new C.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!P,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid}}e.toExtensionDescription=v;class _{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(P){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(P){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(P){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(P){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(P,l){return Promise.resolve()}_onWillActivateExtension(P){}_onDidActivateExtension(P,l,f,p,t){}_onDidActivateExtensionError(P,l){}_onExtensionRuntimeError(P,l){}_onExtensionHostExit(P){}}e.NullExtensionService=_}),define(me[226],ge([0,1,26,35,12]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class T{constructor(h,v,_,b){this.startup=h,this.codeLoadingTime=v,this.activateCallTime=_,this.activateResolvedTime=b}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class y{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,v){return h===-1||v===-1?-1:v-h}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class S{constructor(h,v,_,b,P,l){this.activationFailed=h,this.activationFailedError=v,this.activationTimes=_,this.module=b,this.exports=P,this.subscriptions=l}}e.ActivatedExtension=S;class A extends S{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class i extends S{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends S{constructor(h){super(!0,h,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let c=class{constructor(h,v,_,b,P){this._logService=P,this._registry=h,this._resolvedExtensionsSet=new Set,v.forEach(l=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,_.forEach(l=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(l),l)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const v=g.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(v)}getActivatedExtension(h){const v=g.ExtensionIdentifier.toKey(h),_=this._activatedExtensions.get(v);if(!_)throw new Error("Extension `"+h.value+"` is not known or not activated");return _}activateByEvent(h,v){if(this._alreadyActivatedEvents[h])return C;const _=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(_.map(b=>({id:b.identifier,reason:{startup:v,extensionId:b.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,v){const _=this._registry.getExtensionDescription(h);if(!_)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:_.identifier,reason:v}])}_handleActivateRequest(h,v,_){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(h.id))){v[g.ExtensionIdentifier.toKey(h.id)]=h;return}const b=this._registry.getExtensionDescription(h.id);if(!b){const f=new Error(`Cannot activate unknown extension '${h.id.value}'`);this._host.onExtensionActivationError(h.id,f,new R.MissingExtensionDependency(h.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(h.id),new I(f));return}const P=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let l=!0;for(let f=0,p=P.length;f<p;f++){const t=P[f];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const s=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const d=b.displayName||b.identifier.value,u=this._registry.getExtensionDescription(t),w=u&&u.displayName||t,E=new Error(`Cannot activate the '${d}' extension because its dependency '${w}' failed to activate`);E.detail=s.activationFailedError,this._host.onExtensionActivationError(b.identifier,E,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(b.identifier),new I(E));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){l=!1,v[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:h.reason};continue}const o=this._registry.getExtensionDescription(t);if(o){l=!1,v[g.ExtensionIdentifier.toKey(t)]={id:o.identifier,reason:h.reason};continue}const n=b.displayName||b.identifier.value,a=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(b.identifier,a,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(b.identifier),new I(a));return}l?v[g.ExtensionIdentifier.toKey(b.identifier)]=h:_.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(P=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(P.id))),h.length===0))return Promise.resolve(void 0);const v=Object.create(null),_=[];for(let P=0,l=h.length;P<l;P++)this._handleActivateRequest(h[P],v,_);for(let P=0,l=_.length;P<l;P++){const f=g.ExtensionIdentifier.toKey(_[P].id);v[f]&&delete v[f]}const b=Object.keys(v).map(P=>v[P]);return _.length===0?Promise.all(b.map(P=>this._activateExtension(P.id,P.reason))).then(P=>{}):this._activateExtensions(b).then(P=>this._activateExtensions(_))}_activateExtension(h,v){const _=g.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const b=this._activatingExtensions.get(_);if(b)return b;const P=this._host.actualActivateExtension(h,v).then(void 0,l=>{const f=new Error;return l&&l.name&&(f.name=l.name),l&&l.message?f.message=`Activating extension '${h.value}' failed: ${l.message}.`:f.message=`Activating extension '${h.value}' failed: ${l}.`,l&&l.stack&&(f.stack=l.stack),this._host.onExtensionActivationError(h,f,null),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(l),new I(l)}).then(l=>{this._activatedExtensions.set(_,l),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,P),P}};c=ze([xe(4,k.ILogService)],c),e.ExtensionsActivator=c}),define(me[227],ge([0,1,12,35,27,10,115]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends g.LogService{constructor(A){if(A.logFile.scheme!==C.Schemas.file)throw new Error("Only file-logging supported");super(new T.SpdLogLogger(R.ExtensionHostLogFileName,A.logFile.fsPath,!0,A.logLevel))}$setLevel(A){this.setLevel(A)}};y=ze([xe(0,k.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(me[228],ge([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,T)=>{this._actualOk=C,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,g.onUnexpectedError)(C))}then(C,T){return this._ensureActual().then(C,T)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=R}),define(me[130],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(S,A){this._proxyIdentifierBrand=void 0,this.isMain=S,this.sid=A,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const R=[];function k(y){const S=new g(!0,y);return R[S.nid]=S,S}e.createMainContextProxyIdentifier=k;function C(y){const S=new g(!1,y);return R[S.nid]=S,S}e.createExtHostContextProxyIdentifier=C;function T(y){return R[y].sid}e.getStringIdentifierForProxy=T}),define(me[5],ge([0,1,59,2,130]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var T;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(l){l.name="$ident";function f(t,s){return Object.defineProperty(t,l.name,{value:s,enumerable:!0}),t}l.mixin=f;function p(t){return t[l.name]}l.of=p})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(f){return f._id=m._n++,f}}e.IdObject=m,m._n=0;var h;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(l){if(l&&l.edits)for(const f of l.edits)typeof f.resource=="object"?f.resource=R.URI.revive(f.resource):(f.newUri=R.URI.revive(f.newUri),f.oldUri=R.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,g.revive)(f.metadata));return l}e.reviveWorkspaceEditDto=b;var P;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(P=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[90],ge([0,1,5,3,4]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(y){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=y.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(y){this._onDidChangePassword.fire(y)}get(y,S){return this._proxy.$getPassword(y,S)}store(y,S,A){return this._proxy.$setPassword(y,S,A)}delete(y,S){return this._proxy.$deletePassword(y,S)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(me[65],ge([0,1,4,12,5,13]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(S,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(k.MainContext.MainThreadTelemetry)}report(S,A,i){const I=this.getUsageKey(S,A);this._reportedUsages.has(I)||(this._reportedUsages.add(I),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:S}))}getUsageKey(S,A){return`${S}-${A.identifier.value}`}};T=ze([xe(0,C.IExtHostRpcService),xe(1,R.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(y,S,A){}})}),define(me[229],ge([0,1,3,5,7,26]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,A,i,I={}){const c=C.ExtensionIdentifier.toKey(S.identifier),m=this._inFlightRequests.get(c)||[],h=[...i].sort().join(" ");let v=m.find(_=>_.scopes===h);if(v)return v.result;{const _=this._getSession(S,c,A,i,I);v={scopes:h,result:_},m.push(v),this._inFlightRequests.set(c,m);try{await _}finally{const b=m.findIndex(P=>P.scopes===h);b>-1&&(m.splice(b),this._inFlightRequests.set(c,m))}return _}}async _getSession(S,A,i,I,c={}){await this._proxy.$ensureProvider(i);const m=S.displayName||S.name;return this._proxy.$getSession(i,I,A,m,c)}async removeSession(S,A){const i=this._authenticationProviders.get(S);return i?i.provider.removeSession(A):this._proxy.$removeSession(S,A)}registerAuthenticationProvider(S,A,i,I){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:A,provider:i,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===S)||this._providers.push({id:S,label:A});const c=i.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(S,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,A,I?.supportsMultipleAccounts??!1),new k.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(S);const m=this._providers.findIndex(h=>h.id===S);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,A){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,A){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,A){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,A){return this._onDidChangeSessions.fire({provider:{id:S,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(me[230],ge([0,1,5,13,15]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(y,S){this._extHostDocumentsAndEditors=S,this._proxy=y.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(y){const S=k.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};C=ze([xe(0,R.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(me[231],ge([0,1,5]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(C){const T=C.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(y){return T.$writeText(y)}})}}e.ExtHostClipboard=R}),define(me[44],ge([0,1,14,7,15,22,5,20,12,59,41,50,2,6,4,13]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(T.MainContext.MainThreadCommands),this._logService=s,this.converter=new b(this,o=>{const n=this._apiCommands.get(o);return n?.result===l.Void?n:void 0},s),this._argumentProcessors=[{processArgument(o){return(0,A.revive)(o)}},{processArgument(o){return(0,C.cloneAndChange)(o,function(n){if(i.Range.isIRange(n))return k.Range.to(n);if(I.Position.isIPosition(n))return k.Position.to(n);if(i.Range.isIRange(n.range)&&c.URI.isUri(n.uri))return k.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const s=this.registerCommand(!1,t.id,async(...o)=>{const n=t.args.map((d,u)=>{if(!d.validate(o[u]))throw new Error(`Invalid argument '${d.name}' when running '${t.id}', received: ${o[u]}`);return d.convert(o[u])}),a=await this.executeCommand(t.internalId,...n);return t.result.convert(a,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{s.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,s,o,n,a){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:o,thisArg:n,description:a}),t&&this._proxy.$registerCommand(s),new R.Disposable(()=>{this._commands.delete(s)&&t&&this._proxy.$unregisterCommand(s)})}executeCommand(t,...s){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,s,!0)}async _doExecuteCommand(t,s,o){if(this._commands.has(t))return this._executeContributedCommand(t,s);{const n=(0,C.cloneAndChange)(s,function(a){if(a instanceof R.Position)return k.Position.from(a);if(a instanceof R.Range)return k.Range.from(a);if(a instanceof R.Location)return k.location.from(a);if(R.NotebookRange.isNotebookRange(a))return k.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,n,o);return(0,A.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,s,!1);throw a}}}async _executeContributedCommand(t,s){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:n,thisArg:a,description:d}=o;if(d)for(let u=0;u<d.args.length;u++)try{(0,g.validateConstraint)(s[u],d.args[u].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${d.args[u].name}' - ${d.args[u].description}`)}try{return await n.apply(a,s)}catch(u){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...s);w&&(t=w.command)}throw this._logService.error(u,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(s=s.map(o=>this._argumentProcessors.reduce((n,a)=>a.processArgument(n),o)),this._executeContributedCommand(t,s)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(s=>(t&&(s=s.filter(o=>o[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[s,o]of this._commands){let{description:n}=o;n&&(t[s]=n)}return Promise.resolve(t)}};_=ze([xe(0,v.IExtHostRpcService),xe(1,S.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class b{constructor(t,s,o){this._commands=t,this._lookupApiCommand=s,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,s){if(!t)return;const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const n=this._lookupApiCommand(t.command);if(n)o.id=n.internalId,o.arguments=n.args.map((a,d)=>a.convert(t.arguments&&t.arguments[d]));else if((0,y.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),s.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),o.$ident=a,o.id=this.delegatingCommandId,o.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return o}fromInternal(t){const s=T.ObjectIdentifier.of(t);return typeof s=="number"?this._cache.get(s):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const s=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class P{constructor(t,s,o,n){this.name=t,this.description=s,this.validate=o,this.convert=n}optional(){return new P(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,s){return new P(t??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",p=>c.URI.isUri(p),p=>p),P.Position=new P("position","A position in a text document",p=>R.Position.isPosition(p),k.Position.from),P.Range=new P("range","A range in a text document",p=>R.Range.isRange(p),k.Range.from),P.Selection=new P("selection","A selection in a text document",p=>R.Selection.isSelection(p),k.Selection.from),P.Number=new P("number","",p=>typeof p=="number",p=>p),P.String=new P("string","",p=>typeof p=="string",p=>p),P.CallHierarchyItem=new P("item","A call hierarchy item",p=>p instanceof R.CallHierarchyItem,k.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",p=>p instanceof R.TypeHierarchyItem,k.TypeHierarchyItem.from);class l{constructor(t,s){this.description=t,this.convert=s}}e.ApiCommandResult=l,l.Void=new l("no result",p=>p);class f{constructor(t,s,o,n,a){this.id=t,this.internalId=s,this.description=o,this.args=n,this.result=a}}e.ApiCommand=f}),define(me[232],ge([0,1,15,7,82,44,20,110]),function(Y,e,g,R,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(g.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,m)=>{if((0,T.isFalsyOrEmpty)(c))return;class h extends R.SymbolInformation{static to(_){const b=new h(_.name,g.SymbolKind.to(_.kind),_.containerName||"",new R.Location(m[0],g.Range.to(_.range)));return b.detail=_.detail,b.range=b.location.range,b.selectionRange=g.Range.to(_.selectionRange),b.children=_.children?_.children.map(h.to):[],b}}return c.map(h.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(g.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(g.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(m=>R.Position.isPosition(m)),c=>c.map(g.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(m=>{let h;for(const v of m.reverse())h=new R.SelectionRange(g.Range.to(v),h);return h}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const m=[];if(Array.isArray(c))for(let h of c)m.push(...h[1].map(g.WorkspaceSymbol.to));return m})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return g.WorkspaceEdit.to(c)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(g.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new R.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,y.decodeSemanticTokensDto)(c);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new R.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,y.decodeSemanticTokensDto)(c);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,m,h)=>{if(!c)return new R.CompletionList([]);const v=c.suggestions.map(_=>g.CompletionItem.to(_,h));return new R.CompletionList(v,c.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return g.SignatureHelp.to(c)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,m,h)=>i(v=>new R.CodeLens(g.Range.to(v.range),v.command&&h.fromInternal(v.command)))(c))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>R.Range.isRange(c),c=>R.Selection.isSelection(c)?g.Selection.from(c):g.Range.from(c)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,m,h)=>i(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(v.command)}else{const _=new R.CodeAction(v.title,v.kind?new R.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=g.WorkspaceEdit.to(v.edit)),v.command&&(_.command=h.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(c))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(m=>new R.ColorInformation(g.Range.to(m.range),g.Color.to(m.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",c=>c instanceof R.Color,g.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:g.Range.from(c.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(g.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(g.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(m=>g.NotebookExclusiveDocumentPattern.to(m))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(g.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to)))];class A{static register(m){S.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=A;function i(c){return m=>{if(Array.isArray(m))return m.map(c)}}function I(c){if(!Array.isArray(c))return;const m=[];for(const h of c)k.isLocationLink(h)?m.push(g.DefinitionLink.to(h)):m.push(g.location.to(h));return m}}),define(me[233],ge([0,1,17,56,3,6,2,82,26,15,7,5]),function(Y,e,g,R,k,C,T,y,S,A,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(m,h,v){const _=m.getProxy(I.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const a=this._commentControllers.get(n.handle);return a||n}else if(n&&n.$mid===7){const a=this._commentControllers.get(n.commentControlHandle);if(!a)return n;const d=a.getCommentThread(n.commentThreadHandle);return d||n}else if(n&&n.$mid===8){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const d=a.getCommentThread(n.thread.commentThreadHandle);return d?{thread:d,text:n.text}:n}else if(n&&n.$mid===9){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const d=a.getCommentThread(n.thread.commentThreadHandle);if(!d)return n;let u=n.commentUniqueId,w=d.getCommentByUniqueId(u);return w||n}else if(n&&n.$mid===10){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const d=a.getCommentThread(n.thread.commentThreadHandle);if(!d)return n;let u=n.text,w=n.commentUniqueId,E=d.getCommentByUniqueId(w);return E?(E.body=u,E):n}return n}})}createCommentController(n,a,d){const u=b.handlePool++,w=new l(n,u,a,d);this._commentControllers.set(w.handle,w);const E=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(n.identifier))||[];return E.push(w),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(n.identifier),E),w.value}$createCommentThreadTemplate(n,a,d){const u=this._commentControllers.get(n);!u||u.$createCommentThreadTemplate(a,d)}async $updateCommentThreadTemplate(n,a,d){const u=this._commentControllers.get(n);!u||u.$updateCommentThreadTemplate(a,d)}$deleteCommentThread(n,a){const d=this._commentControllers.get(n);d&&d.$deleteCommentThread(a)}$provideCommentingRanges(n,a,d){const u=this._commentControllers.get(n);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const w=v.getDocument(T.URI.revive(a));return(0,g.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(w,d)).then(E=>E?E.map(r=>A.Range.from(r)):void 0)}$toggleReaction(n,a,d,u,w){const E=this._commentControllers.get(n);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const r=E.getCommentThread(a);if(r){const D=r.getCommentByUniqueId(u.uniqueIdInThread);if(E!==void 0&&D&&E.reactionHandler)return E.reactionHandler(D,t(w))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class P{constructor(n,a,d,u,w,E,r){this._commentControllerHandle=a,this._id=d,this._uri=u,this._range=w,this._comments=E,this.handle=P._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),_.$createCommentThread(a,this.handle,this._id,this._uri,A.Range.from(this._range),r),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(a,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(L){D.range=L},get comments(){return D.comments},set comments(L){D.comments=L},get collapsibleState(){return D.collapsibleState},set collapsibleState(L){D.collapsibleState=L},get canReply(){return D.canReply},set canReply(L){D.canReply=L},get contextValue(){return D.contextValue},set contextValue(L){D.contextValue=L},get label(){return D.label},set label(L){D.label=L},dispose:()=>{D.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const n=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),a={};n("range")&&(a.range=A.Range.from(this._range)),n("label")&&(a.label=this.label),n("contextValue")&&(a.contextValue=this.contextValue),n("comments")&&(a.comments=this._comments.map(d=>f(this,d,this._commentsMap))),n("collapsibleState")&&(a.collapseState=s(this._collapseState)),n("canReply")&&(a.canReply=this.canReply),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,a)}getCommentByUniqueId(n){for(let a of this._commentsMap){let d=a[0],u=a[1];if(n===u)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}P._handlePool=0,ze([(0,R.debounce)(100)],P.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(n,a,d,u){this._extension=n,this._handle=a,this._id=d,this._label=u,this._threads=new Map,_.$registerCommentController(this.handle,d,u);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(E){w.options=E},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(E){w.commentingRangeProvider=E},get reactionHandler(){return w.reactionHandler},set reactionHandler(E){w.reactionHandler=E},createCommentThread(E,r,D){return w.createCommentThread(E,r,D).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,a,d,u){if(typeof n=="string"){const w=new P(this.id,this.handle,n,a,d,u,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new P(this.id,this.handle,void 0,n,a,d,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(n,a){const d=new P(this.id,this.handle,void 0,T.URI.revive(n),A.Range.to(a),[],this._extension.identifier);return d.collapsibleState=y.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(n,a){let d=this._threads.get(n);d&&(d.range=A.Range.to(a))}$deleteCommentThread(n){let a=this._threads.get(n);a&&a.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function f(o,n,a){let d=a.get(n);d||(d=++o.commentHandle,a.set(n,d));const u=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:d,body:A.MarkdownString.from(n.body),userName:n.author.name,userIconPath:u,label:n.label,commentReactions:n.reactions?n.reactions.map(w=>p(w)):void 0}}function p(o){return{label:o.label,iconPath:o.iconPath?A.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function t(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?T.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function s(o){if(o!==void 0)switch(o){case i.CommentThreadCollapsibleState.Expanded:return y.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return y.CommentThreadCollapsibleState.Collapsed}return y.CommentThreadCollapsibleState.Collapsed}return new b}e.createExtHostComments=c}),define(me[131],ge([0,1,2,5,7,4,13,12,20,9,8]),function(Y,e,g,R,k,C,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class En{constructor(m,h){this._logService=h,this._provider=new Map,this._proxy=m.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,h){const v=En._handlePool++;this._provider.set(v,{provider:m,extensionId:h}),this._proxy.$registerDecorationProvider(v,h.value);const _=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(v,null);return}let P=(0,S.asArray)(b);if(P.length<=En._maxEventSize){this._proxy.$onDidChange(v,P);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,P.length);const l=P.map(t=>({uri:t,rank:(0,A.count)(t.path,"/")})),f=(0,S.groupBy)(l,(t,s)=>t.rank-s.rank||(0,A.compare)(t.uri.path,s.uri.path));let p=[];e:for(let t of f){let s;for(let o of t){let n=(0,i.dirname)(o.uri.path);if(s!==n&&(s=n,p.push(o.uri)>=En._maxEventSize))break e}}this._proxy.$onDidChange(v,p)});return new k.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(m,h,v){if(!this._provider.has(m))return Object.create(null);const _=Object.create(null),{provider:b,extensionId:P}=this._provider.get(m);return await Promise.all(h.map(async l=>{try{const{uri:f,id:p}=l,t=await Promise.resolve(b.provideFileDecoration(g.URI.revive(f),v));if(!t)return;try{k.FileDecoration.validate(t),_[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${P.value}': ${s}`)}}catch(f){this._logService.error(f)}})),_}};I._handlePool=0,I._maxEventSize=250,I=ze([xe(0,T.IExtHostRpcService),xe(1,y.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")}),define(me[234],ge([0,1,163,116,2,5,7,15,3,12,23]),function(Y,e,g,R,k,C,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(h,v,_,b,P){this._name=h,this._owner=v,this._maxDiagnosticsPerFile=_,this._proxy=b,this._onDidChangeDiagnostics=P,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(h,v){if(!h){this.clear();return}this._checkDisposed();let _=[];if(k.URI.isUri(h)){if(!v){this.delete(h);return}this._data.set(h,v.slice()),_=[h]}else if(Array.isArray(h)){_=[];let P;h=[...h].sort(I._compareIndexedTuplesByUri);for(const l of h){const[f,p]=l;if((!P||f.toString()!==P.toString())&&(P&&this._data.get(P).length===0&&this._data.delete(P),P=f,_.push(f),this._data.set(f,[])),p){const t=this._data.get(f);t&&t.push(...p)}else{const t=this._data.get(f);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const b=[];for(let P of _){let l=[];const f=this._data.get(P);if(f)if(f.length>this._maxDiagnosticsPerFile){l=[];const p=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let s of f)if(s.severity===p[t]&&l.push(y.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;l.push({severity:R.MarkerSeverity.Info,message:(0,g.localize)(0,null,f.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=f.map(p=>y.Diagnostic.from(p));b.push([P,l])}this._proxy.$changeMany(this._owner,b)}delete(h){this._checkDisposed(),this._onDidChangeDiagnostics.fire([h]),this._data.delete(h),this._proxy&&this._proxy.$changeMany(this._owner,[[h,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(h,v){this._checkDisposed();for(let _ of this._data.keys())h.apply(v,[_,this.get(_),this])}get(h){this._checkDisposed();const v=this._data.get(h);return Array.isArray(v)?Object.freeze(v.slice(0)):[]}has(h){return this._checkDisposed(),Array.isArray(this._data.get(h))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(h,v){return h[0].toString()<v[0].toString()?-1:h[0].toString()>v[0].toString()?1:0}}e.DiagnosticCollection=I;let c=class Xt{constructor(h,v){this._logService=v,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,Xt._mapper),this._proxy=h.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(h){const v=new i.ResourceMap;for(const _ of h)v.set(_,_);return{uris:Object.freeze(Array.from(v.values()))}}createDiagnosticCollection(h,v){const{_collections:_,_proxy:b,_onDidChangeDiagnostics:P,_logService:l}=this,f=new class{$changeMany(s,o){b.$changeMany(s,o),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",h.value,s,o.length===0?"CLEARING":o)}$clear(s){b.$clear(s),l.trace("[DiagnosticCollection] remove all (extension, owner)",h.value,s)}dispose(){b.dispose()}};let p;if(!v)v="_generated_diagnostic_collection_name_#"+Xt._idPool++,p=v;else if(!_.has(v))p=v;else{this._logService.warn(`DiagnosticCollection with name '${v}' does already exist.`);do p=v+Xt._idPool++;while(_.has(p))}return new class extends I{constructor(){super(v,p,Xt._maxDiagnosticsPerFile,f,P);_.set(p,this)}dispose(){super.dispose(),_.delete(p)}}}getDiagnostics(h){if(h)return this._getDiagnostics(h);{const v=new Map,_=[];for(const b of this._collections.values())b.forEach((P,l)=>{let f=v.get(P.toString());typeof f=="undefined"&&(f=_.length,v.set(P.toString(),f),_.push([P,[]])),_[f][1]=_[f][1].concat(...l)});return _}}_getDiagnostics(h){let v=[];for(let _ of this._collections.values())_.has(h)&&(v=v.concat(_.get(h)));return v}$acceptMarkersChange(h){if(!this._mirrorCollection){const v="_generated_mirror",_=new I(v,v,Xt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(v,_),this._mirrorCollection=_}for(const[v,_]of h)this._mirrorCollection.set(k.URI.revive(v),_.map(y.Diagnostic.to))}};c._idPool=0,c._maxDiagnosticsPerFile=1e3,c=ze([xe(1,A.ILogService)],c),e.ExtHostDiagnostics=c}),define(me[235],ge([0,1,2,5]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(T){this._proxy=T.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(y=>y?y.map(S=>g.URI.revive(S)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(y=>y?g.URI.revive(y):void 0)}}e.ExtHostDialogs=k}),define(me[236],ge([0,1,16,2,7,5,10,21,9]),function(Y,e,g,R,k,C,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(I,c,m){this._documentsAndEditors=c,this._logService=m,this._documentContentProviders=new Map,this._proxy=I.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,c){if(Object.keys(T.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const m=A._handlePool++;this._documentContentProviders.set(m,c),this._proxy.$registerTextContentProvider(m,I);let h;return typeof c.onDidChange=="function"&&(h=c.onDidChange(v=>{if(v.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(m,v).then(_=>{if(!_&&typeof _!="string")return;const b=this._documentsAndEditors.getDocument(v);if(!b)return;const P=(0,S.splitLines)(_);if(!b.equalLines(P))return this._proxy.$onVirtualDocumentChange(v,_)},g.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(I,c){const m=this._documentContentProviders.get(I);return m?Promise.resolve(m.provideTextDocumentContent(R.URI.revive(c),y.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(me[237],ge([0,1,3,6,2,5,122,15,14,22,7]),function(Y,e,g,R,k,C,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(m,h){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const _ of v)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const _ of v)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const h=this._documentsAndEditors.getDocument(m);if(h)return h}getDocument(m){const h=this.getDocumentData(m);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return h.document}ensureDocumentData(m){const h=this._documentsAndEditors.getDocument(m);if(h)return Promise.resolve(h);let v=this._documentLoader.get(m.toString());return v||(v=this._proxy.$tryOpenDocument(m).then(_=>{this._documentLoader.delete(m.toString());const b=k.URI.revive(_);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(b))},_=>(this._documentLoader.delete(m.toString()),Promise.reject(_))),this._documentLoader.set(m.toString(),v)),v}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(h=>k.URI.revive(h))}$acceptModelModeChanged(m,h){const v=k.URI.revive(m),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(h),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(m){const h=k.URI.revive(m),v=this._documentsAndEditors.getDocument(h);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(m,h){const v=k.URI.revive(m),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");_._acceptIsDirty(h),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,h,v){const _=k.URI.revive(m),b=this._documentsAndEditors.getDocument(_);if(!b)throw new Error("unknown document");b._acceptIsDirty(v),b.onEvents(h);let P;h.isUndoing?P=i.TextDocumentChangeReason.Undo:h.isRedoing&&(P=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:b.document,contentChanges:h.changes.map(l=>({range:y.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:P}))}setWordDefinitionFor(m,h){(0,T.setWordDefinitionFor)(m,h)}}e.ExtHostDocuments=I}),define(me[45],ge([0,1,54,3,6,2,4,5,122,13,129,15,12,23,10,75,139]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class b{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let P=class{constructor(f,p){this._extHostRpc=f,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const p=[],t=[],s=[];if(f.removedDocuments)for(const o of f.removedDocuments){const n=C.URI.revive(o),a=this._documents.get(n);a?.unref()&&(this._documents.delete(n),p.push(a.value))}if(f.addedDocuments)for(const o of f.addedDocuments){const n=C.URI.revive(o.uri);let a=this._documents.get(n);if(a&&n.scheme!==h.Schemas.vscodeNotebookCell&&n.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);a||(a=new b(new S.ExtHostDocumentData(this._extHostRpc.getProxy(y.MainContext.MainThreadDocuments),n,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(n,a),t.push(a.value)),a.ref()}if(f.removedEditors)for(const o of f.removedEditors){const n=this._editors.get(o);this._editors.delete(o),n&&s.push(n)}if(f.addedEditors)for(const o of f.addedEditors){const n=C.URI.revive(o.documentUri);g.ok(this._documents.has(n),`document '${n}' does not exist`),g.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const a=this._documents.get(n).value,d=new i.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(y.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>a.document),o.selections.map(I.Selection.to),o.options,o.visibleRanges.map(u=>I.Range.to(u)),typeof o.editorPosition=="number"?I.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,d)}f.newActiveEditor!==void 0&&(g.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,k.dispose)(p),(0,k.dispose)(s),f.removedDocuments&&this._onDidRemoveDocuments.fire(p),f.addedDocuments&&this._onDidAddDocuments.fire(t),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return f?p:p?.value}allEditors(){return[...this._editors.values()]}};P=ze([xe(0,A.IExtHostRpcService),xe(1,c.ILogService)],P),e.ExtHostDocumentsAndEditors=P,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[238],ge([0,1,2,5,6,7,15,147,9,25]),function(Y,e,g,R,k,C,T,y,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const h=this._schemes.indexOf(m);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),h=[];let v,_,b=14,P=14;for(const l of m){let f=v?(0,S.commonPrefixLength)(v,l):0;for(f===0?_=1:_=P;f<l.length;f++)f+1===l.length?(b=P,P=9):P+=1,h.push([_,l.toUpperCase().charCodeAt(f),P]),h.push([_,l.toLowerCase().charCodeAt(f),P]),_=P;v=l,P=b}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new y.StateMachine(h)}}provideDocumentLinks(m){this._initStateMachine();const h=[],v=y.LinkComputer.computeLinks({getLineContent(_){return m.lineAt(_-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const _ of v){const b=T.DocumentLink.to(_);b.target&&h.push(b)}return h}}class I{constructor(m,h){this._extHostLanguageFeatures=h,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=m.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,h,v,_={},b){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(P,v),this._enableProposedApi.set(P,b??!1);let l=2;_.isCaseSensitive&&(l+=1024),_.isReadonly&&(l+=2048),typeof v.copy=="function"&&(l+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&(l+=4),this._proxy.$registerFileSystemProvider(P,h,l).catch(p=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${h}`),console.error(p)});const f=v.onDidChangeFile(p=>{const t=[];for(const s of p){let{uri:o,type:n}=s;if(o.scheme!==h)continue;let a;switch(n){case C.FileChangeType.Changed:a=0;break;case C.FileChangeType.Created:a=1;break;case C.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:o,type:a})}this._proxy.$onFileSystemChange(P,t)});return(0,k.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(P),this._enableProposedApi.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(m,h){const{type:v,ctime:_,mtime:b,size:P,permissions:l}=m;return h?{type:v,ctime:_,mtime:b,size:P,permissions:l}:{type:v,ctime:_,mtime:b,size:P}}$stat(m,h){return Promise.resolve(this._getFsProvider(m).stat(g.URI.revive(h))).then(v=>I._asIStat(v,this._enableProposedApi.get(m)??!1))}$readdir(m,h){return Promise.resolve(this._getFsProvider(m).readDirectory(g.URI.revive(h)))}$readFile(m,h){return Promise.resolve(this._getFsProvider(m).readFile(g.URI.revive(h))).then(v=>A.VSBuffer.wrap(v))}$writeFile(m,h,v,_){return Promise.resolve(this._getFsProvider(m).writeFile(g.URI.revive(h),v.buffer,_))}$delete(m,h,v){return Promise.resolve(this._getFsProvider(m).delete(g.URI.revive(h),v))}$rename(m,h,v,_){return Promise.resolve(this._getFsProvider(m).rename(g.URI.revive(h),g.URI.revive(v),_))}$copy(m,h,v,_){const b=this._getFsProvider(m);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(g.URI.revive(h),g.URI.revive(v),_))}$mkdir(m,h){return Promise.resolve(this._getFsProvider(m).createDirectory(g.URI.revive(h)))}$watch(m,h,v,_){const b=this._getFsProvider(m).watch(g.URI.revive(v),_);this._watches.set(h,b)}$unwatch(m,h){const v=this._watches.get(h);v&&(v.dispose(),this._watches.delete(h))}$open(m,h,v){const _=this._getFsProvider(m);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(g.URI.revive(h),v))}$close(m,h){const v=this._getFsProvider(m);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(h))}$read(m,h,v,_){const b=this._getFsProvider(m);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const P=A.VSBuffer.alloc(_);return Promise.resolve(b.read(h,v,P.buffer,0,_)).then(l=>P.slice(0,l))}$write(m,h,v,_){const b=this._getFsProvider(m);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(h,v,_.buffer,0,_.byteLength))}_getFsProvider(m){const h=this._fsProvider.get(m);if(!h){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return h}}e.ExtHostFileSystem=I}),define(me[91],ge([0,1,5,42,7,25,4,13,63]),function(Y,e,g,R,k,C,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Ut{constructor(I,c){const m=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(h){return m.$stat(h).catch(Ut._handleError)},readDirectory(h){return m.$readdir(h).catch(Ut._handleError)},createDirectory(h){return m.$mkdir(h).catch(Ut._handleError)},async readFile(h){return m.$readFile(h).then(v=>v.buffer).catch(Ut._handleError)},writeFile(h,v){return m.$writeFile(h,C.VSBuffer.wrap(v)).catch(Ut._handleError)},delete(h,v){return m.$delete(h,{recursive:!1,useTrash:!1,...v}).catch(Ut._handleError)},rename(h,v,_){return m.$rename(h,v,{overwrite:!1,..._}).catch(Ut._handleError)},copy(h,v,_){return m.$copy(h,v,{overwrite:!1,..._}).catch(Ut._handleError)},isWritableFileSystem(h){const v=c.getCapabilities(h);if(typeof v=="number")return!(v&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new k.FileSystemError(String(I));if(I.name==="ENOPRO")throw k.FileSystemError.Unavailable(I.message);switch(I.name){case R.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(I.message);case R.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(I.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(I.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(I.message);case R.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(I.message);case R.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(I.message);default:throw new k.FileSystemError(I.message,I.name)}}};A=ze([xe(0,y.IExtHostRpcService),xe(1,S.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(me[239],ge([0,1,2,44]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(T,y,S,A){this._extHostNotebooks=y,this._textDocumentsAndEditors=S,this._commands=A;const i=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new R.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new R.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new R.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new R.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(i)}$willAddInteractiveDocument(T,y,S,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:y,lines:[""],modeId:S,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=k}),define(me[240],ge([0,1,6,5]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(T){this._handlePool=0,this._proxy=T.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const y=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(y,T),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(y)})}}e.ExtHostLabelService=k}),define(me[241],ge([0,1,2,22,15,7,5,9,41,20,14,144,6,110,74,86,46,16,3]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentSymbols(W,Z){const re=this._documents.getDocument(W),ae=await this._provider.provideDocumentSymbols(re,Z);if(!(0,A.isFalsyOrEmpty)(ae))return ae[0]instanceof C.DocumentSymbol?ae.map(k.DocumentSymbol.from):l._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(W){W=W.slice(0).sort((ae,Q)=>{let oe=ae.location.range.start.compareTo(Q.location.range.start);return oe===0&&(oe=Q.location.range.end.compareTo(ae.location.range.end)),oe});const Z=[],re=[];for(const ae of W){const Q={name:ae.name||"!!MISSING: name!!",kind:k.SymbolKind.from(ae.kind),tags:ae.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:k.Range.from(ae.location.range),selectionRange:k.Range.from(ae.location.range),children:[]};for(;;){if(re.length===0){re.push(Q),Z.push(Q);break}const oe=re[re.length-1];if(S.Range.containsRange(oe.range,Q.range)&&!S.Range.equalsRange(oe.range,Q.range)){oe.children&&oe.children.push(Q),re.push(Q);break}re.pop()}}return Z}}class f{constructor(W,Z,re){this._documents=W,this._commands=Z,this._provider=re,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,Z){const re=this._documents.getDocument(W),ae=await this._provider.provideCodeLenses(re,Z);if(!ae||Z.isCancellationRequested)return;const Q=this._cache.add(ae),oe=new c.DisposableStore;this._disposables.set(Q,oe);const we={cacheId:Q,lenses:[]};for(let Me=0;Me<ae.length;Me++)we.lenses.push({cacheId:[Q,Me],range:k.Range.from(ae[Me].range),command:this._commands.toInternal(ae[Me].command,oe)});return we}async resolveCodeLens(W,Z){const re=W.cacheId&&this._cache.get(...W.cacheId);if(!re)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?ae=re:ae=await this._provider.resolveCodeLens(re,Z),ae||(ae=re),Z.isCancellationRequested)return;const Q=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!Q)return W.command=this._commands.toInternal(ae.command??f._badCmd,Q),W}releaseCodeLenses(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(Ke){return Array.isArray(Ke)?Ke.map(k.DefinitionLink.from):Ke?[k.DefinitionLink.from(Ke)]:[]}class t{constructor(W,Z){this._documents=W,this._provider=Z}async provideDefinition(W,Z,re){const ae=this._documents.getDocument(W),Q=k.Position.to(Z),oe=await this._provider.provideDefinition(ae,Q,re);return p(oe)}}class s{constructor(W,Z){this._documents=W,this._provider=Z}async provideDeclaration(W,Z,re){const ae=this._documents.getDocument(W),Q=k.Position.to(Z),oe=await this._provider.provideDeclaration(ae,Q,re);return p(oe)}}class o{constructor(W,Z){this._documents=W,this._provider=Z}async provideImplementation(W,Z,re){const ae=this._documents.getDocument(W),Q=k.Position.to(Z),oe=await this._provider.provideImplementation(ae,Q,re);return p(oe)}}class n{constructor(W,Z){this._documents=W,this._provider=Z}async provideTypeDefinition(W,Z,re){const ae=this._documents.getDocument(W),Q=k.Position.to(Z),oe=await this._provider.provideTypeDefinition(ae,Q,re);return p(oe)}}class a{constructor(W,Z){this._documents=W,this._provider=Z}async provideHover(W,Z,re){const ae=this._documents.getDocument(W),Q=k.Position.to(Z),oe=await this._provider.provideHover(ae,Q,re);if(!(!oe||(0,A.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(Q)),oe.range||(oe.range=new C.Range(Q,Q)),k.Hover.from(oe)}}class d{constructor(W,Z){this._documents=W,this._provider=Z}async provideEvaluatableExpression(W,Z,re){const ae=this._documents.getDocument(W),Q=k.Position.to(Z),oe=await this._provider.provideEvaluatableExpression(ae,Q,re);if(oe)return k.EvaluatableExpression.from(oe)}}class u{constructor(W,Z){this._documents=W,this._provider=Z}async provideInlineValues(W,Z,re,ae){const Q=this._documents.getDocument(W),oe=await this._provider.provideInlineValues(Q,k.Range.to(Z),k.InlineValueContext.to(re),ae);if(Array.isArray(oe))return oe.map(we=>k.InlineValue.from(we))}}class w{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentHighlights(W,Z,re){const ae=this._documents.getDocument(W),Q=k.Position.to(Z),oe=await this._provider.provideDocumentHighlights(ae,Q,re);if(Array.isArray(oe))return oe.map(k.DocumentHighlight.from)}}class E{constructor(W,Z){this._documents=W,this._provider=Z}async provideLinkedEditingRanges(W,Z,re){const ae=this._documents.getDocument(W),Q=k.Position.to(Z),oe=await this._provider.provideLinkedEditingRanges(ae,Q,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,A.coalesce)(oe.ranges.map(k.Range.from)),wordPattern:oe.wordPattern}}}class r{constructor(W,Z){this._documents=W,this._provider=Z}async provideReferences(W,Z,re,ae){const Q=this._documents.getDocument(W),oe=k.Position.to(Z),we=await this._provider.provideReferences(Q,oe,re,ae);if(Array.isArray(we))return we.map(k.location.from)}}class D{constructor(W,Z,re,ae,Q,oe,we){this._documents=W,this._commands=Z,this._diagnostics=re,this._provider=ae,this._logService=Q,this._extension=oe,this._apiDeprecation=we,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(W,Z,re,ae){const Q=this._documents.getDocument(W),oe=I.Selection.isISelection(Z)?k.Selection.to(Z):k.Range.to(Z),we=[];for(const X of this._diagnostics.getDiagnostics(W))if(oe.intersection(X.range)&&we.push(X)>D._maxCodeActionsPerFile)break;const Me={diagnostics:we,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:k.CodeActionTriggerKind.to(re.trigger)},je=await this._provider.provideCodeActions(Q,oe,Me,ae);if(!(0,A.isNonEmptyArray)(je)||ae.isCancellationRequested)return;const Xe=this._cache.add(je),Se=new c.DisposableStore;this._disposables.set(Xe,Se);const tt=[];for(let X=0;X<je.length;X++){const ee=je[X];!ee||(D._isCommand(ee)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:ee.title,command:this._commands.toInternal(ee,Se)})):(Me.only&&(ee.kind?Me.only.contains(ee.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${ee.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Xe,X],title:ee.title,command:ee.command&&this._commands.toInternal(ee.command,Se),diagnostics:ee.diagnostics&&ee.diagnostics.map(k.Diagnostic.from),edit:ee.edit&&k.WorkspaceEdit.from(ee.edit),kind:ee.kind&&ee.kind.value,isPreferred:ee.isPreferred,disabled:ee.disabled?.reason})))}return{cacheId:Xe,actions:tt}}async resolveCodeAction(W,Z){const[re,ae]=W,Q=this._cache.get(re,ae);if(!Q||D._isCommand(Q)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(Q,Z)??Q;return oe?.edit?k.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}D._maxCodeActionsPerFile=1e3;class L{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentFormattingEdits(W,Z,re){const ae=this._documents.getDocument(W),Q=await this._provider.provideDocumentFormattingEdits(ae,Z,re);if(Array.isArray(Q))return Q.map(k.TextEdit.from)}}class U{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeFormattingEdits(W,Z,re,ae){const Q=this._documents.getDocument(W),oe=k.Range.to(Z),we=await this._provider.provideDocumentRangeFormattingEdits(Q,oe,re,ae);if(Array.isArray(we))return we.map(k.TextEdit.from)}}class j{constructor(W,Z){this._documents=W,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,Z,re,ae,Q){const oe=this._documents.getDocument(W),we=k.Position.to(Z),Me=await this._provider.provideOnTypeFormattingEdits(oe,we,re,ae,Q);if(Array.isArray(Me))return Me.map(k.TextEdit.from)}}class te{constructor(W,Z){this._provider=W,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(W,Z){const re=T.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(W,Z);if((0,A.isNonEmptyArray)(ae))for(const Q of ae){if(!Q)continue;if(!Q.name){this._logService.warn("INVALID SymbolInformation, lacks name",Q);continue}const oe=T.IdObject.mixin(k.WorkspaceSymbol.from(Q));this._symbolCache.set(oe._id,Q),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(W,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const re=this._symbolCache.get(W._id);if(re){const ae=await this._provider.resolveWorkspaceSymbol(re,Z);return ae&&(0,R.mixin)(W,k.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(W){const Z=this._resultCache.get(W);if(Z){for(let[re,ae]=Z;re<=ae;re++)this._symbolCache.delete(re);this._resultCache.delete(W)}}}class K{constructor(W,Z,re){this._documents=W,this._provider=Z,this._logService=re}static supportsResolving(W){return typeof W.prepareRename=="function"}async provideRenameEdits(W,Z,re,ae){const Q=this._documents.getDocument(W),oe=k.Position.to(Z);try{const we=await this._provider.provideRenameEdits(Q,oe,re,ae);return we?k.WorkspaceEdit.from(we):void 0}catch(we){const Me=K._asMessage(we);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(we)}}async resolveRenameLocation(W,Z,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(W),Q=k.Position.to(Z);try{const oe=await this._provider.prepareRename(ae,Q,re);let we,Me;if(C.Range.isRange(oe)?(we=oe,Me=ae.getText(oe)):(0,i.isObject)(oe)&&(we=oe.range,Me=oe.placeholder),!we||!Me)return;if(we.start.line>Q.line||we.end.line<Q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(we),text:Me}}catch(oe){const we=K._asMessage(oe);return we?{rejectReason:we,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class O{constructor(W,Z){this.resultId=W,this.tokens=Z}}class x{constructor(W,Z){this._documents=W,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(W,Z,re){const ae=this._documents.getDocument(W),Q=Z!==0?this._previousResults.get(Z):null;let oe=typeof Q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,Q.resultId,re):await this._provider.provideDocumentSemanticTokens(ae,re);return Q&&this._previousResults.delete(Z),oe?(oe=x._fixProvidedSemanticTokens(oe),this._send(x._convertToEdits(Q,oe),oe)):null}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return x._isSemanticTokens(W)?x._isCorrectSemanticTokens(W)?W:new C.SemanticTokens(new Uint32Array(W.data),W.resultId):x._isSemanticTokensEdits(W)?x._isCorrectSemanticTokensEdits(W)?W:new C.SemanticTokensEdits(W.edits.map(Z=>new C.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const Z of W.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,Z){if(!x._isSemanticTokens(Z)||!W||!W.tokens)return Z;const re=W.tokens,ae=re.length,Q=Z.data,oe=Q.length;let we=0;const Me=Math.min(ae,oe);for(;we<Me&&re[we]===Q[we];)we++;if(we===ae&&we===oe)return new C.SemanticTokensEdits([],Z.resultId);let je=0;const Xe=Me-we;for(;je<Xe&&re[ae-je-1]===Q[oe-je-1];)je++;return new C.SemanticTokensEdits([{start:we,deleteCount:ae-we-je,data:Q.subarray(we,oe-je)}],Z.resultId)}_send(W,Z){if(x._isSemanticTokens(W)){const re=this._nextResultId++;return this._previousResults.set(re,new O(W.resultId,W.data)),(0,m.encodeSemanticTokensDto)({id:re,type:"full",data:W.data})}if(x._isSemanticTokensEdits(W)){const re=this._nextResultId++;return x._isSemanticTokens(Z)?this._previousResults.set(re,new O(Z.resultId,Z.data)):this._previousResults.set(re,new O(W.resultId)),(0,m.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(W.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class F{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeSemanticTokens(W,Z,re){const ae=this._documents.getDocument(W),Q=await this._provider.provideDocumentRangeSemanticTokens(ae,k.Range.to(Z),re);return Q?this._send(Q):null}_send(W){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=F;class z{constructor(W,Z,re,ae,Q){this._documents=W,this._commands=Z,this._provider=re,this._apiDeprecation=ae,this._extension=Q,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,Z,re,ae){const Q=this._documents.getDocument(W),oe=k.Position.to(Z),we=Q.getWordRangeAtPosition(oe)||new C.Range(oe,oe),Me=we.with({end:oe}),je=new _.StopWatch(!0),Xe=await this._provider.provideCompletionItems(Q,oe,ae,k.CompletionContext.to(re));if(!Xe||ae.isCancellationRequested)return;const Se=Array.isArray(Xe)?new C.CompletionList(Xe):Xe,tt=z.supportsResolving(this._provider)?this._cache.add(Se.items):this._cache.add([]),X=new c.DisposableStore;this._disposables.set(tt,X);const ee=[],ve={x:tt,b:ee,a:{replace:k.Range.from(we),insert:k.Range.from(Me)},c:Se.isIncomplete||void 0,d:je.elapsed()};for(let Ue=0;Ue<Se.items.length;Ue++){const Je=Se.items[Ue],nt=this._convertCompletionItem(Je,[tt,Ue],Me,we);ee.push(nt)}return ve}async resolveCompletionItem(W,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...W);if(!re)return;const ae=await this._provider.resolveCompletionItem(re,Z);if(!!ae)return this._convertCompletionItem(ae,W)}releaseCompletionItems(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,Z,re,ae){const Q=this._disposables.get(Z[0]);if(!Q)throw Error("DisposableStore is missing...");const oe={x:Z,a:W.label,b:W.kind!==void 0?k.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(k.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(W.command,Q)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=W.textEdit.newText):typeof W.insertText=="string"?oe.h=W.insertText:W.insertText instanceof C.SnippetString&&(oe.h=W.insertText.value,oe.i|=4);let we;return W.textEdit?we=W.textEdit.range:W.range&&(we=W.range),C.Range.isRange(we)?oe.j=k.Range.from(we):we&&(!re?.isEqual(we.inserting)||!ae?.isEqual(we.replacing))&&(oe.j={insert:k.Range.from(we.inserting),replace:k.Range.from(we.replacing)}),oe}}class M{constructor(W,Z,re){this._documents=W,this._provider=Z,this._commands=re,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(W,Z,re,ae){const Q=this._documents.getDocument(W),oe=k.Position.to(Z),we=await this._provider.provideInlineCompletionItems(Q,oe,re,ae);if(!we||ae.isCancellationRequested)return;const Me=(0,i.isArray)(we)?{items:we}:we,je=this._cache.add(Me.items);let Xe;return{pid:je,items:Me.items.map((Se,tt)=>{let X;return Se.command&&(Xe||(Xe=new c.DisposableStore,this._disposables.set(je,Xe)),X=this._commands.toInternal(Se.command,Xe)),{text:Se.text,range:Se.range?k.Range.from(Se.range):void 0,command:X,idx:tt}})}}disposeCompletions(W){this._cache.delete(W);const Z=this._disposables.get(W);Z&&Z.clear(),this._disposables.delete(W)}handleDidShowCompletionItem(W,Z){const re=this._cache.get(W,Z);re&&N.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class N{constructor(){this._onDidShowCompletionItemEmitter=new P.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(W){let Z=N.map.get(W);return Z||(Z=new N,N.map.set(W,Z)),Z}fireOnDidShowCompletionItem(W){this._onDidShowCompletionItemEmitter.fire(W)}}e.InlineCompletionController=N,N.map=new WeakMap;class V{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(W,Z,re,ae){const Q=this._documents.getDocument(W),oe=k.Position.to(Z),we=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(Q,oe,ae,we);if(Me){const je=this._cache.add([Me]);return{...k.SignatureHelp.from(Me),id:je}}}reviveContext(W){let Z;if(W.activeSignatureHelp){const re=k.SignatureHelp.to(W.activeSignatureHelp),ae=this._cache.get(W.activeSignatureHelp.id,0);ae?(Z=ae,Z.activeSignature=re.activeSignature,Z.activeParameter=re.activeParameter):Z=re}return{...W,activeSignatureHelp:Z}}releaseSignatureHelp(W){this._cache.delete(W)}}class ${constructor(W,Z){this._documents=W,this._provider=Z}async provideInlayHints(W,Z,re){const ae=this._documents.getDocument(W),Q=await this._provider.provideInlayHints(ae,k.Range.to(Z),re);return Q?{hints:Q.map(k.InlayHint.from)}:void 0}}class G{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new v.Cache("DocumentLink")}async provideLinks(W,Z){const re=this._documents.getDocument(W),ae=await this._provider.provideDocumentLinks(re,Z);if(!(!Array.isArray(ae)||ae.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(G._validateLink).map(k.DocumentLink.from)};{const Q=this._cache.add(ae),oe={links:[],id:Q};for(let we=0;we<ae.length;we++){if(!G._validateLink(ae[we]))continue;const Me=k.DocumentLink.from(ae[we]);Me.cacheId=[Q,we],oe.links.push(Me)}return oe}}}static _validateLink(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...W);if(!re)return;const ae=await this._provider.resolveDocumentLink(re,Z);if(!(!ae||!G._validateLink(ae)))return k.DocumentLink.from(ae)}releaseLinks(W){this._cache.delete(W)}}class J{constructor(W,Z){this._documents=W,this._provider=Z}async provideColors(W,Z){const re=this._documents.getDocument(W),ae=await this._provider.provideDocumentColors(re,Z);return Array.isArray(ae)?ae.map(oe=>({color:k.Color.from(oe.color),range:k.Range.from(oe.range)})):[]}async provideColorPresentations(W,Z,re){const ae=this._documents.getDocument(W),Q=k.Range.to(Z.range),oe=k.Color.to(Z.color),we=await this._provider.provideColorPresentations(oe,{document:ae,range:Q},re);if(!!Array.isArray(we))return we.map(k.ColorPresentation.from)}}class fe{constructor(W,Z){this._documents=W,this._provider=Z}async provideFoldingRanges(W,Z,re){const ae=this._documents.getDocument(W),Q=await this._provider.provideFoldingRanges(ae,Z,re);if(!!Array.isArray(Q))return Q.map(k.FoldingRange.from)}}class ye{constructor(W,Z,re){this._documents=W,this._provider=Z,this._logService=re}async provideSelectionRanges(W,Z,re){const ae=this._documents.getDocument(W),Q=Z.map(k.Position.to),oe=await this._provider.provideSelectionRanges(ae,Q,re);if(!(0,A.isNonEmptyArray)(oe))return[];if(oe.length!==Q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const we=[];for(let Me=0;Me<Q.length;Me++){const je=[];we.push(je);let Xe=Q[Me],Se=oe[Me];for(;;){if(!Se.range.contains(Xe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(k.SelectionRange.from(Se)),!Se.parent)break;Xe=Se.range,Se=Se.parent}}return we}}class ke{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,re){const ae=this._documents.getDocument(W),Q=k.Position.to(Z),oe=await this._provider.prepareCallHierarchy(ae,Q,re);if(!oe)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(we,Me)):[this._cacheAndConvertItem(we,oe)]}async provideCallsTo(W,Z,re){const ae=this._itemFromCache(W,Z);if(!ae)throw new Error("missing call hierarchy item");const Q=await this._provider.provideCallHierarchyIncomingCalls(ae,re);if(!!Q)return Q.map(oe=>({from:this._cacheAndConvertItem(W,oe.from),fromRanges:oe.fromRanges.map(we=>k.Range.from(we))}))}async provideCallsFrom(W,Z,re){const ae=this._itemFromCache(W,Z);if(!ae)throw new Error("missing call hierarchy item");const Q=await this._provider.provideCallHierarchyOutgoingCalls(ae,re);if(!!Q)return Q.map(oe=>({to:this._cacheAndConvertItem(W,oe.to),fromRanges:oe.fromRanges.map(we=>k.Range.from(we))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const re=this._cache.get(W),ae=k.CallHierarchyItem.from(Z,W,re.size.toString(36));return re.set(ae._itemId,Z),ae}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class Re{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,re){const ae=this._documents.getDocument(W),Q=k.Position.to(Z),oe=await this._provider.prepareTypeHierarchy(ae,Q,re);if(!oe)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(we,Me)):[this._cacheAndConvertItem(we,oe)]}async provideSupertypes(W,Z,re){const ae=this._itemFromCache(W,Z);if(!ae)throw new Error("missing type hierarchy item");const Q=await this._provider.provideTypeHierarchySupertypes(ae,re);if(!!Q)return Q.map(oe=>this._cacheAndConvertItem(W,oe))}async provideSubtypes(W,Z,re){const ae=this._itemFromCache(W,Z);if(!ae)throw new Error("missing type hierarchy item");const Q=await this._provider.provideTypeHierarchySubtypes(ae,re);if(!!Q)return Q.map(oe=>this._cacheAndConvertItem(W,oe))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const re=this._cache.get(W),ae=k.TypeHierarchyItem.from(Z,W,re.size.toString(36));return re.set(ae._itemId,Z),ae}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class Ve{constructor(W,Z){this.adapter=W,this.extension=Z}}class Be{constructor(W,Z,re,ae,Q,oe,we){this._adapter=new Map,this._uriTransformer=Z,this._proxy=W.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ae,this._diagnostics=Q,this._logService=oe,this._apiDeprecation=we}_transformDocumentSelector(W){return(0,A.coalesce)((0,A.asArray)(W).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:k.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new C.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return Be._handlePool++}_withAdapter(W,Z,re,ae,Q=!1){const oe=this._adapter.get(W);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof Z){let we;oe.extension&&(we=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Me=re(oe.adapter,oe.extension),je=oe.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-we}ms`),Xe=>{Q&&Xe instanceof b.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Xe))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,Z){const re=this._nextHandle();return this._adapter.set(re,new Ve(W,Z)),re}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,Z,re,ae){const Q=this._addNewAdapter(new l(this._documents,re),W),oe=ae&&ae.label||Be._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(Q,this._transformDocumentSelector(Z),oe),this._createDisposable(Q)}$provideDocumentSymbols(W,Z,re){return this._withAdapter(W,l,ae=>ae.provideDocumentSymbols(g.URI.revive(Z),re),void 0)}registerCodeLensProvider(W,Z,re){const ae=this._nextHandle(),Q=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ve(new f(this._documents,this._commands.converter,re),W)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Z),Q);let oe=this._createDisposable(ae);if(Q!==void 0){const we=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Q));oe=C.Disposable.from(oe,we)}return oe}$provideCodeLenses(W,Z,re){return this._withAdapter(W,f,ae=>ae.provideCodeLenses(g.URI.revive(Z),re),void 0)}$resolveCodeLens(W,Z,re){return this._withAdapter(W,f,ae=>ae.resolveCodeLens(Z,re),void 0)}$releaseCodeLenses(W,Z){this._withAdapter(W,f,re=>Promise.resolve(re.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(W,Z,re){const ae=this._addNewAdapter(new t(this._documents,re),W);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDefinition(W,Z,re,ae){return this._withAdapter(W,t,Q=>Q.provideDefinition(g.URI.revive(Z),re,ae),[])}registerDeclarationProvider(W,Z,re){const ae=this._addNewAdapter(new s(this._documents,re),W);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDeclaration(W,Z,re,ae){return this._withAdapter(W,s,Q=>Q.provideDeclaration(g.URI.revive(Z),re,ae),[])}registerImplementationProvider(W,Z,re){const ae=this._addNewAdapter(new o(this._documents,re),W);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideImplementation(W,Z,re,ae){return this._withAdapter(W,o,Q=>Q.provideImplementation(g.URI.revive(Z),re,ae),[])}registerTypeDefinitionProvider(W,Z,re){const ae=this._addNewAdapter(new n(this._documents,re),W);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideTypeDefinition(W,Z,re,ae){return this._withAdapter(W,n,Q=>Q.provideTypeDefinition(g.URI.revive(Z),re,ae),[])}registerHoverProvider(W,Z,re,ae){const Q=this._addNewAdapter(new a(this._documents,re),W);return this._proxy.$registerHoverProvider(Q,this._transformDocumentSelector(Z)),this._createDisposable(Q)}$provideHover(W,Z,re,ae){return this._withAdapter(W,a,Q=>Q.provideHover(g.URI.revive(Z),re,ae),void 0)}registerEvaluatableExpressionProvider(W,Z,re,ae){const Q=this._addNewAdapter(new d(this._documents,re),W);return this._proxy.$registerEvaluatableExpressionProvider(Q,this._transformDocumentSelector(Z)),this._createDisposable(Q)}$provideEvaluatableExpression(W,Z,re,ae){return this._withAdapter(W,d,Q=>Q.provideEvaluatableExpression(g.URI.revive(Z),re,ae),void 0)}registerInlineValuesProvider(W,Z,re,ae){const Q=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new u(this._documents,re),W);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(Z),Q);let we=this._createDisposable(oe);if(Q!==void 0){const Me=re.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Q));we=C.Disposable.from(we,Me)}return we}$provideInlineValues(W,Z,re,ae,Q){return this._withAdapter(W,u,oe=>oe.provideInlineValues(g.URI.revive(Z),re,ae,Q),void 0)}registerDocumentHighlightProvider(W,Z,re){const ae=this._addNewAdapter(new w(this._documents,re),W);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDocumentHighlights(W,Z,re,ae){return this._withAdapter(W,w,Q=>Q.provideDocumentHighlights(g.URI.revive(Z),re,ae),void 0)}registerLinkedEditingRangeProvider(W,Z,re){const ae=this._addNewAdapter(new E(this._documents,re),W);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideLinkedEditingRanges(W,Z,re,ae){return this._withAdapter(W,E,async Q=>{const oe=await Q.provideLinkedEditingRanges(g.URI.revive(Z),re,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Be._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(W,Z,re){const ae=this._addNewAdapter(new r(this._documents,re),W);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideReferences(W,Z,re,ae,Q){return this._withAdapter(W,r,oe=>oe.provideReferences(g.URI.revive(Z),re,ae,Q),void 0)}registerCodeActionProvider(W,Z,re,ae){const Q=new c.DisposableStore,oe=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,re,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(Z),{providedKinds:ae?.providedCodeActionKinds?.map(we=>we.value),documentation:ae?.documentation?.map(we=>({kind:we.kind.value,command:this._commands.converter.toInternal(we.command,Q)}))},Be._extLabel(W),Boolean(re.resolveCodeAction)),Q.add(this._createDisposable(oe)),Q}$provideCodeActions(W,Z,re,ae,Q){return this._withAdapter(W,D,oe=>oe.provideCodeActions(g.URI.revive(Z),re,ae,Q),void 0)}$resolveCodeAction(W,Z,re){return this._withAdapter(W,D,ae=>ae.resolveCodeAction(Z,re),void 0)}$releaseCodeActions(W,Z){this._withAdapter(W,D,re=>Promise.resolve(re.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(W,Z,re){const ae=this._addNewAdapter(new L(this._documents,re),W);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(W,Z,re,ae){return this._withAdapter(W,L,Q=>Q.provideDocumentFormattingEdits(g.URI.revive(Z),re,ae),void 0)}registerDocumentRangeFormattingEditProvider(W,Z,re){const ae=this._addNewAdapter(new U(this._documents,re),W);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(W,Z,re,ae,Q){return this._withAdapter(W,U,oe=>oe.provideDocumentRangeFormattingEdits(g.URI.revive(Z),re,ae,Q),void 0)}registerOnTypeFormattingEditProvider(W,Z,re,ae){const Q=this._addNewAdapter(new j(this._documents,re),W);return this._proxy.$registerOnTypeFormattingSupport(Q,this._transformDocumentSelector(Z),ae,W.identifier),this._createDisposable(Q)}$provideOnTypeFormattingEdits(W,Z,re,ae,Q,oe){return this._withAdapter(W,j,we=>we.provideOnTypeFormattingEdits(g.URI.revive(Z),re,ae,Q,oe),void 0)}registerWorkspaceSymbolProvider(W,Z){const re=this._addNewAdapter(new te(Z,this._logService),W);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(W,Z,re){return this._withAdapter(W,te,ae=>ae.provideWorkspaceSymbols(Z,re),{symbols:[]})}$resolveWorkspaceSymbol(W,Z,re){return this._withAdapter(W,te,ae=>ae.resolveWorkspaceSymbol(Z,re),void 0)}$releaseWorkspaceSymbols(W,Z){this._withAdapter(W,te,re=>re.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(W,Z,re){const ae=this._addNewAdapter(new K(this._documents,re,this._logService),W);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Z),K.supportsResolving(re)),this._createDisposable(ae)}$provideRenameEdits(W,Z,re,ae,Q){return this._withAdapter(W,K,oe=>oe.provideRenameEdits(g.URI.revive(Z),re,ae,Q),void 0)}$resolveRenameLocation(W,Z,re,ae){return this._withAdapter(W,K,Q=>Q.resolveRenameLocation(g.URI.revive(Z),re,ae),void 0)}registerDocumentSemanticTokensProvider(W,Z,re,ae){const Q=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Q,new Ve(new x(this._documents,re),W)),this._proxy.$registerDocumentSemanticTokensProvider(Q,this._transformDocumentSelector(Z),ae,oe);let we=this._createDisposable(Q);if(oe){const Me=re.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(oe));we=C.Disposable.from(we,Me)}return we}$provideDocumentSemanticTokens(W,Z,re,ae){return this._withAdapter(W,x,Q=>Q.provideDocumentSemanticTokens(g.URI.revive(Z),re,ae),null,!0)}$releaseDocumentSemanticTokens(W,Z){this._withAdapter(W,x,re=>re.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(W,Z,re,ae){const Q=this._addNewAdapter(new F(this._documents,re),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Q,this._transformDocumentSelector(Z),ae),this._createDisposable(Q)}$provideDocumentRangeSemanticTokens(W,Z,re,ae){return this._withAdapter(W,F,Q=>Q.provideDocumentRangeSemanticTokens(g.URI.revive(Z),re,ae),null,!0)}registerCompletionItemProvider(W,Z,re,ae){const Q=this._addNewAdapter(new z(this._documents,this._commands.converter,re,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(Q,this._transformDocumentSelector(Z),ae,z.supportsResolving(re),`${W.identifier.value}(${ae.join("")})`),this._createDisposable(Q)}$provideCompletionItems(W,Z,re,ae,Q){return this._withAdapter(W,z,oe=>oe.provideCompletionItems(g.URI.revive(Z),re,ae,Q),void 0)}$resolveCompletionItem(W,Z,re){return this._withAdapter(W,z,ae=>ae.resolveCompletionItem(Z,re),void 0)}$releaseCompletionItems(W,Z){this._withAdapter(W,z,re=>re.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(W,Z,re){const ae=this._addNewAdapter(new M(this._documents,re,this._commands.converter),W);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideInlineCompletions(W,Z,re,ae,Q){return this._withAdapter(W,M,oe=>oe.provideInlineCompletions(g.URI.revive(Z),re,ae,Q),void 0)}$handleInlineCompletionDidShow(W,Z,re){this._withAdapter(W,M,async ae=>{ae.handleDidShowCompletionItem(Z,re)},void 0)}$freeInlineCompletionsList(W,Z){this._withAdapter(W,M,async re=>{re.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(W,Z,re,ae){const Q=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new V(this._documents,re),W);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(Z),Q),this._createDisposable(oe)}$provideSignatureHelp(W,Z,re,ae,Q){return this._withAdapter(W,V,oe=>oe.provideSignatureHelp(g.URI.revive(Z),re,ae,Q),void 0)}$releaseSignatureHelp(W,Z){this._withAdapter(W,V,re=>re.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(W,Z,re){const ae=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Q=this._addNewAdapter(new $(this._documents,re),W);this._proxy.$registerInlayHintsProvider(Q,this._transformDocumentSelector(Z),ae);let oe=this._createDisposable(Q);if(ae!==void 0){const we=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ae));oe=C.Disposable.from(oe,we)}return oe}$provideInlayHints(W,Z,re,ae){return this._withAdapter(W,$,Q=>Q.provideInlayHints(g.URI.revive(Z),re,ae),void 0)}registerDocumentLinkProvider(W,Z,re){const ae=this._addNewAdapter(new G(this._documents,re),W);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Z),typeof re.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(W,Z,re){return this._withAdapter(W,G,ae=>ae.provideLinks(g.URI.revive(Z),re),void 0)}$resolveDocumentLink(W,Z,re){return this._withAdapter(W,G,ae=>ae.resolveLink(Z,re),void 0)}$releaseDocumentLinks(W,Z){this._withAdapter(W,G,re=>re.releaseLinks(Z),void 0)}registerColorProvider(W,Z,re){const ae=this._addNewAdapter(new J(this._documents,re),W);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDocumentColors(W,Z,re){return this._withAdapter(W,J,ae=>ae.provideColors(g.URI.revive(Z),re),[])}$provideColorPresentations(W,Z,re,ae){return this._withAdapter(W,J,Q=>Q.provideColorPresentations(g.URI.revive(Z),re,ae),void 0)}registerFoldingRangeProvider(W,Z,re){const ae=this._nextHandle(),Q=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ve(new fe(this._documents,re),W)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Z),Q);let oe=this._createDisposable(ae);if(Q!==void 0){const we=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Q));oe=C.Disposable.from(oe,we)}return oe}$provideFoldingRanges(W,Z,re,ae){return this._withAdapter(W,fe,Q=>Q.provideFoldingRanges(g.URI.revive(Z),re,ae),void 0)}registerSelectionRangeProvider(W,Z,re){const ae=this._addNewAdapter(new ye(this._documents,re,this._logService),W);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideSelectionRanges(W,Z,re,ae){return this._withAdapter(W,ye,Q=>Q.provideSelectionRanges(g.URI.revive(Z),re,ae),[])}registerCallHierarchyProvider(W,Z,re){const ae=this._addNewAdapter(new ke(this._documents,re),W);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$prepareCallHierarchy(W,Z,re,ae){return this._withAdapter(W,ke,Q=>Promise.resolve(Q.prepareSession(g.URI.revive(Z),re,ae)),void 0)}$provideCallHierarchyIncomingCalls(W,Z,re,ae){return this._withAdapter(W,ke,Q=>Q.provideCallsTo(Z,re,ae),void 0)}$provideCallHierarchyOutgoingCalls(W,Z,re,ae){return this._withAdapter(W,ke,Q=>Q.provideCallsFrom(Z,re,ae),void 0)}$releaseCallHierarchy(W,Z){this._withAdapter(W,ke,re=>Promise.resolve(re.releaseSession(Z)),void 0)}registerTypeHierarchyProvider(W,Z,re){const ae=this._addNewAdapter(new Re(this._documents,re),W);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$prepareTypeHierarchy(W,Z,re,ae){return this._withAdapter(W,Re,Q=>Promise.resolve(Q.prepareSession(g.URI.revive(Z),re,ae)),void 0)}$provideTypeHierarchySupertypes(W,Z,re,ae){return this._withAdapter(W,Re,Q=>Q.provideSupertypes(Z,re,ae),void 0)}$provideTypeHierarchySubtypes(W,Z,re,ae){return this._withAdapter(W,Re,Q=>Q.provideSubtypes(Z,re,ae),void 0)}$releaseTypeHierarchy(W,Z){this._withAdapter(W,Re,re=>Promise.resolve(re.releaseSession(Z)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,y.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:Be._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:Be._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Be._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Be._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:Be._serializeRegExp(W.beforeText),afterText:W.afterText?Be._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?Be._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(Be._serializeOnEnterRule)}setLanguageConfiguration(W,Z,re){let{wordPattern:ae}=re;if(ae&&(0,y.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Z,ae):this._documents.setWordDefinitionFor(Z,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const Q=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Be._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Be._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Be._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Q,Z,oe),this._createDisposable(Q)}$setWordDefinitions(W){for(const Z of W)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=Be,Be._handlePool=0}),define(me[242],ge([0,1,5,15,7,48,17]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(A,i){this._handlePool=0,this._proxy=A.getProxy(g.MainContext.MainThreadLanguages),this._documents=i}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(A,i){await this._proxy.$changeLanguage(A,i);const I=this._documents.getDocumentData(A);if(!I)throw new Error(`document '${A.toString}' NOT found`);return I.document}async tokenAtPosition(A,i){const I=A.version,c=R.Position.from(i),m=await this._proxy.$tokensAtPosition(A.uri,c),h={type:k.StandardTokenType.Other,range:A.getWordRangeAtPosition(i)??new k.Range(i.line,i.character,i.line,i.character)};if(!m)return h;const v={range:R.Range.to(m.range),type:R.TokenType.to(m.type)};return!v.range.contains(i)||I!==A.version?h:v}createLanguageStatusItem(A){const i=this._handlePool++,I=this._proxy,c={selector:A,text:"",detail:"",severity:k.LanguageStatusSeverity.Information};let m;const h=()=>{m?.dispose(),m=(0,T.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(i,{selector:c.selector,text:c.text,message:typeof c.detail=="string"?c.detail:R.MarkdownString.from(c.detail),severity:c.severity===k.LanguageStatusSeverity.Error?C.default.Error:c.severity===k.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info})},0)},v={get selector(){return c.selector},set selector(_){c.selector=_,h()},get text(){return c.text},set text(_){c.text=_,h()},get detail(){return c.detail},set detail(_){c.detail=_,h()},get severity(){return c.severity},set severity(_){c.severity=_,h()},dispose(){m?.dispose(),I.$removeLanguageStatus(i)}};return h(),v}}e.ExtHostLanguages=y}),define(me[243],ge([0,1,5,12,35]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(y){return y&&y.title}let T=class{constructor(S,A){this._logService=A,this._proxy=S.getProxy(g.MainContext.MainThreadMessageService)}showMessage(S,A,i,I,c){const m={extension:S};let h;typeof I=="string"||C(I)?h=[I,...c]:(m.modal=I?.modal,m.useCustom=I?.useCustom,m.detail=I?.detail,h=c),m.useCustom&&(0,k.checkProposedApiEnabled)(S);const v=[];for(let _=0;_<h.length;_++){const b=h[_];if(typeof b=="string")v.push({title:b,handle:_,isCloseAffordance:!1});else if(typeof b=="object"){let{title:P,isCloseAffordance:l}=b;v.push({title:P,isCloseAffordance:!!l,handle:_})}else this._logService.warn("Invalid message item:",b)}return this._proxy.$showMessage(A,i,m,v).then(_=>{if(typeof _=="number")return h[_]})}};T=ze([xe(1,R.ILogService)],T),e.ExtHostMessageService=T}),define(me[244],ge([0,1,25,3,58,6,23,9,14,2,86,5,15,7,219,128]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class _{constructor(P,l,f,p,t){this._textDocumentsAndEditors=f,this._textDocuments=p,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=P.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=P.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=P.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const o=s.notebookEditor?.notebookUri,n=s.cell.handle,d=this._documents.get(o)?.getCell(n);if(d)return d.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(P=>P.apiEditor)}getEditorById(P){const l=this._editors.get(P);if(!l)throw new Error(`unknown text editor: ${P}. known editors: ${[...this._editors.keys()]} `);return l}getIdByEditor(P){for(const[l,f]of this._editors)if(f.apiEditor===P)return l}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(P,l){const f=this._documents.get(P);if(!f&&!l)throw new Error(`NO notebook document for '${P}'`);return f}_getProviderData(P){const l=this._notebookContentProviders.get(P);if(!l)throw new Error(`NO provider for '${P}'`);return l}registerNotebookContentProvider(P,l,f,p,t){if((0,y.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);this._notebookContentProviders.set(l,{extension:P,provider:f});let s;return f.onDidChangeNotebookContentOptions&&(s=f.onDidChangeNotebookContentOptions(()=>{const o=c.NotebookDocumentContentOptions.from(f.options);this._notebookProxy.$updateNotebookProviderOptions(l,o)})),this._notebookProxy.$registerNotebookProvider({id:P.identifier,location:P.extensionLocation},l,c.NotebookDocumentContentOptions.from(p),_._convertNotebookRegistrationData(P,t)),new m.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}static _convertNotebookRegistrationData(P,l){if(!l)return;const f=l.filenamePattern.map(p=>c.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(l.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:P.identifier,providerDisplayName:P.displayName||P.name,displayName:l.displayName,filenamePattern:f,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(P,l,f){const p=_._notebookStatusBarItemProviderHandlePool++,t=typeof f.onDidChangeCellStatusBarItems=="function"?_._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(p,f),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(p,t,l);let s;return t!==void 0&&(s=f.onDidChangeCellStatusBarItems(o=>this._notebookProxy.$emitCellStatusBarEvent(t))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(p),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(p,t),s&&s.dispose()})}async createNotebookDocument(P){const l=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:P.viewType,content:P.content&&c.NotebookData.from(P.content)});return A.URI.revive(l)}async openNotebookDocument(P){const l=this._documents.get(P);if(l)return l.apiNotebook;const f=await this._notebookDocumentsProxy.$tryOpenNotebook(P),p=this._documents.get(A.URI.revive(f));return(0,S.assertIsDefined)(p?.apiNotebook)}async showNotebookDocument(P,l){A.URI.isUri(P)&&(P=await this.openNotebookDocument(P));let f;typeof l=="object"?f={position:c.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(c.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:f={preserveFocus:!1};const p=await this._notebookEditorsProxy.$tryShowNotebookDocument(P.uri,P.notebookType,f),t=p&&this._editors.get(p)?.apiEditor;if(t)return t;throw p?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(P,l,f,p){const t=this._notebookStatusBarItemProviders.get(P),s=A.URI.revive(l),o=this._documents.get(s);if(!o||!t)return;const n=o.getCellFromIndex(f);if(!n)return;const a=await t.provideCellStatusBarItems(n.apiCell,p);if(!a)return;const d=new C.DisposableStore,u=this._statusBarCache.add([d]),E=(Array.isArray(a)?a:[a]).map(r=>c.NotebookStatusBarItem.from(r,this._commandsConverter,d));return{cacheId:u,items:E}}$releaseNotebookCellStatusBarItems(P){this._statusBarCache.delete(P)}registerNotebookSerializer(P,l,f,p,t){if((0,y.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,f),this._notebookProxy.$registerNotebookSerializer(s,{id:P.identifier,location:P.extensionLocation},l,c.NotebookDocumentContentOptions.from(p),_._convertNotebookRegistrationData(P,t)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(P,l,f){const p=this._notebookSerializer.get(P);if(!p)throw new Error("NO serializer found");const t=await p.deserializeNotebook(l.buffer,f);return c.NotebookData.from(t)}async $notebookToData(P,l,f){const p=this._notebookSerializer.get(P);if(!p)throw new Error("NO serializer found");const t=await p.serializeNotebook(c.NotebookData.to(l),f);return g.VSBuffer.wrap(t)}async $openNotebook(P,l,f,p,t){const{provider:s}=this._getProviderData(P),o=await s.openNotebook(A.URI.revive(l),{backupId:f,untitledDocumentData:p?.buffer},t);return{metadata:o.metadata??Object.create(null),cells:o.cells.map(c.NotebookCellData.from)}}async $saveNotebook(P,l,f){const p=this.getNotebookDocument(A.URI.revive(l)),{provider:t}=this._getProviderData(P);return await t.saveNotebook(p.apiNotebook,f),!0}async $saveNotebookAs(P,l,f,p){const t=this.getNotebookDocument(A.URI.revive(l)),{provider:s}=this._getProviderData(P);return await s.saveNotebookAs(A.URI.revive(f),t.apiNotebook,p),!0}async $backupNotebook(P,l,f){const p=this.getNotebookDocument(A.URI.revive(l)),t=this._getProviderData(P),s=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),o=String((0,k.hash)([p.uri.toString(),this._backupIdPool++])),n=A.URI.joinPath(s,o),a=await t.provider.backupNotebook(p.apiNotebook,{destination:n},f);return p.updateBackup(a),a.id}_createExtHostEditor(P,l,f){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const p=new v.ExtHostNotebookEditor(l,this._notebookEditorsProxy,P,f.visibleRanges.map(c.NotebookRange.to),f.selections.map(c.NotebookRange.to),typeof f.viewColumn=="number"?c.ViewColumn.to(f.viewColumn):void 0);this._editors.set(l,p)}$acceptDocumentAndEditorsDelta(P){if(P.removedDocuments)for(const f of P.removedDocuments){const p=A.URI.revive(f),t=this._documents.get(p);t&&(t.dispose(),this._documents.delete(p),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===p.toString()&&this._editors.delete(s.id)}if(P.addedDocuments){const f=[];for(const p of P.addedDocuments){const t=A.URI.revive(p.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const s=this,o=new h.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){s._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){s._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){s._onDidChangeCellMetadata.fire(n)},emitCellExecutionStateChange(n){s._onDidChangeCellExecutionState.fire(n)}},t,p);f.push(...p.cells.map(n=>h.ExtHostCell.asModelAddData(o.apiNotebook,n))),this._documents.get(t)?.dispose(),this._documents.set(t,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(P.addedEditors)for(const f of P.addedEditors){if(this._editors.has(f.id))return;const p=A.URI.revive(f.documentUri),t=this._documents.get(p);t&&this._createExtHostEditor(t,f.id,f)}const l=[];if(P.removedEditors)for(const f of P.removedEditors){const p=this._editors.get(f);p&&(this._editors.delete(f),this._activeNotebookEditor?.id===p.id&&(this._activeNotebookEditor=void 0),l.push(p))}if(P.visibleEditors){this._visibleNotebookEditors=P.visibleEditors.map(p=>this._editors.get(p)).filter(p=>!!p);const f=new Set;this._visibleNotebookEditors.forEach(p=>f.add(p.id));for(const p of this._editors.values()){const t=f.has(p.id);p._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(p=>p).filter(p=>p.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}P.newActiveEditor===null?this._activeNotebookEditor=void 0:P.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(P.newActiveEditor)),P.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=_,_._notebookStatusBarItemProviderHandlePool=0}),define(me[245],ge([0,1,3,74,12,5,13,15]),function(Y,e,g,R,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(I,c){const m=S._Keys.nextId();I.$registerNotebookEditorDecorationType(m,y.NotebookDecorationRenderOptions.from(c)),this.value={key:m,dispose(){I.$removeNotebookEditorDecorationType(m)}}}}S._Keys=new R.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(I,c,m){this._logService=I,this._extHostRpc=c,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new S(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,c);const m=this._notebooksAndEditors.getEditorById(I);c.visibleRanges&&m._acceptVisibleRanges(c.visibleRanges.ranges.map(y.NotebookRange.to)),c.selections&&m._acceptSelections(c.selections.selections.map(y.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const c in I)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(y.ViewColumn.to(I[c]))}};A=ze([xe(0,k.ILogService),xe(1,T.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(me[246],ge([0,1,20,17,21,3,6,23,2,26,12,5,15,7,88,212,35]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(t,s,o,n){this._initData=s,this._extHostNotebook=o,this._logService=n,this._activeExecutions=new y.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(I.MainContext.MainThreadNotebookKernels)}createNotebookController(t,s,o,n,a,d){for(let M of this._kernelData.values())if(M.controller.id===s&&A.ExtensionIdentifier.equals(t.identifier,M.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const u=this._handlePool++,w=this;this._logService.trace(`NotebookController[${u}], CREATED by ${t.identifier.value}, ${s}`);const E=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${t.identifier}'`);let r=!1;const D=new T.DisposableStore,L=new C.Emitter,U=new C.Emitter,j={id:`${t.identifier.value}/${s}`,notebookType:o,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:d?d.map(c.NotebookRendererScript.from):[]};let te=a??E,K;this._proxy.$addKernel(u,j).catch(M=>{console.log(M),r=!0});let O=0;const x=()=>{if(r)return;const M=++O;Promise.resolve().then(()=>{M===O&&this._proxy.$updateKernel(u,j)})},F=new y.ResourceMap,z={get id(){return s},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return j.label},set label(M){j.label=M??t.displayName??t.name,x()},get detail(){return j.detail??""},set detail(M){j.detail=M,x()},get description(){return j.description??""},set description(M){j.description=M,x()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(M){j.supportedLanguages=M,x()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(M){j.supportsExecutionOrder=M,x()},get rendererScripts(){return j.preloads?j.preloads.map(c.NotebookRendererScript.to):[]},get executeHandler(){return te},set executeHandler(M){te=M??E},get interruptHandler(){return K},set interruptHandler(M){K=M,j.supportsInterrupt=Boolean(M),x()},createNotebookCellExecution(M){if(r)throw new Error("notebook controller is DISPOSED");if(!F.has(M.notebook.uri))throw w._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(F.keys()).map(N=>N.toString())),new Error(`notebook controller is NOT associated to notebook: ${M.notebook.uri.toString()}`);return w._createNotebookCellExecution(M)},dispose:()=>{r||(this._logService.trace(`NotebookController[${u}], DISPOSED`),r=!0,this._kernelData.delete(u),D.dispose(),L.dispose(),U.dispose(),this._proxy.$removeKernel(u))},updateNotebookAffinity(M,N){w._proxy.$updateNotebookPriority(u,M.uri,N)},onDidReceiveMessage:U.event,postMessage(M,N){return(0,_.checkProposedApiEnabled)(t),w._proxy.$postMessage(u,N&&w._extHostNotebook.getIdByEditor(N),M)},asWebviewUri(M){return(0,_.checkProposedApiEnabled)(t),(0,h.asWebviewUri)(M,w._initData.remote)}};return this._kernelData.set(u,{extensionId:t.identifier,controller:z,onDidReceiveMessage:U,onDidChangeSelection:L,associatedNotebooks:F}),z}$acceptNotebookAssociation(t,s,o){const n=this._kernelData.get(t);if(n){const a=this._extHostNotebook.getNotebookDocument(S.URI.revive(s));o?n.associatedNotebooks.set(a.uri,!0):n.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,a.uri.toString(),o),n.onDidChangeSelection.fire({selected:o,notebook:a.apiNotebook})}}async $executeCells(t,s,o){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(S.URI.revive(s)),d=[];for(let u of o){const w=a.getCell(u);w&&d.push(w.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,a.uri.toString(),d.length),await n.controller.executeHandler.call(n.controller,d,a.apiNotebook,n.controller)}catch(u){this._logService.error(`NotebookController[${t}] execute cells FAILED`,u),console.error(u)}}async $cancelCells(t,s,o){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(S.URI.revive(s));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,a.apiNotebook);else for(let d of o){const u=a.getCell(d);u&&this._activeExecutions.get(u.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,s,o){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getEditorById(s);n.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:o}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const n=new l(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,n);const a=n.onDidChangeState(()=>{n.state===P.Resolved&&(n.dispose(),a.dispose(),this._activeExecutions.delete(o.uri))});return n.asApiObject()}};b=ze([xe(3,i.ILogService)],b),e.ExtHostNotebookKernels=b;var P;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(P||(P={}));class l extends T.Disposable{constructor(t,s,o){super();this._document=t,this._cell=s,this._proxy=o,this._handle=l.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=P.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new f(10,n=>this.update(n)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(t){await this._collector.addItem(t)}async update(t){const s=Array.isArray(t)?t:[t];return this._proxy.$updateExecutions(s)}verifyStateForOutput(){if(this._state===P.Init)throw new Error("Must call start before modifying cell output");if(this._state===P.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(t){let s=this._cell;if(t&&(s=this._document.getCellFromApiCell(t)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(t){return t.map(s=>{const o=m.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return o===s.items?c.NotebookCellOutput.from(s):c.NotebookCellOutput.from({items:o,id:s.id,metadata:s.metadata})})}async updateOutputs(t,s,o){const n=this.cellIndexToHandle(s),a=this.validateAndConvertOutputs((0,g.asArray)(t));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:n,append:o,outputs:a})}async updateOutputItems(t,s,o){return t=m.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(t),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:t.map(c.NotebookCellOutputItem.from),outputId:s.id,append:o})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(o){t._executionOrder=o,t.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:t._handle,executionOrder:t._executionOrder}])},start(o){if(t._state===P.Resolved||t._state===P.Started)throw new Error("Cannot call start again");t._state=P.Started,t._onDidChangeState.fire(),t.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:t._handle,runStartTime:o})},end(o,n){if(t._state===P.Resolved)throw new Error("Cannot call resolve twice");t._state=P.Resolved,t._onDidChangeState.fire(),t.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:t._handle,runEndTime:n,lastRunSuccess:o}),t._collector.flush(),t._proxy.$removeExecution(t._handle)},clearOutput(o){return t.verifyStateForOutput(),t.updateOutputs([],o,!1)},appendOutput(o,n){return t.verifyStateForOutput(),t.updateOutputs(o,n,!0)},replaceOutput(o,n){return t.verifyStateForOutput(),t.updateOutputs(o,n,!1)},appendOutputItems(o,n){return t.verifyStateForOutput(),t.updateOutputItems(o,n,!0)},replaceOutputItems(o,n){return t.verifyStateForOutput(),t.updateOutputItems(o,n,!1)}})}}l.HANDLE=0;class f{constructor(t,s){this.delay=t,this.callback=s,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,R.timeout)(this.delay).then(()=>this.flush())),this.waitPromise}flush(){this.waitPromise=void 0;const t=this.batch;return this.batch=[],this.callback(t)}}}),define(me[247],ge([0,1,3,5,128]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(y,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,S,A){const i=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(S)?.fire({editor:i.apiEditor,message:A})}createRendererMessaging(y,S){if(!y.contributes?.notebookRenderer?.some(c=>c.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const A=!!y.enableProposedApi,i=new WeakMap;return{onDidReceiveMessage:(c,m,h)=>{const v=A?c:_=>{const b={};i.set(b,_.editor),c({editor:b,message:_.message})};return this.getOrCreateEmitterFor(S).event(v,m,h)},postMessage:(c,m)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(c)&&([c,m]=[m,c]);const h=A?m:i.get(m),v=h&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(h);return this.proxy.$postMessage(v?.id,S,c)}}}getOrCreateEmitterFor(y){let S=this._rendererMessageEmitters.get(y);return S||(S=new g.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,S),S)}}e.ExtHostNotebookRenderers=C}),define(me[66],ge([0,1,5,3,6,25,4,13]),function(Y,e,g,R,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends k.Disposable{constructor(h,v,_,b,P){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=h,this._proxy=P,this._id=P.$register(this.name,v,_,b),this._disposed=!1,this._offset=0}get name(){return this._name}append(h){this.validate(),this._offset+=h?C.VSBuffer.fromString(h).byteLength:0}update(){this._id.then(h=>this._proxy.$update(h))}appendLine(h){this.validate(),this.append(h+`
`)}clear(){this.validate();const h=this._offset;this._id.then(v=>this._proxy.$clear(v,h))}show(h,v){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof h=="boolean"?h:v)))}hide(){this.validate(),this._id.then(h=>this._proxy.$close(h))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(h=>this._proxy.$dispose(h)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class A extends S{constructor(h,v,_){super(h,!1,void 0,v,_)}append(h){super.append(h),this._id.then(v=>this._proxy.$append(v,h)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=A;class i extends S{constructor(h,v,_){super(h,!0,v,void 0,_)}append(h){throw new Error("Not supported")}}class I{constructor(h,v){this.name=h,this._channel=v}append(h){this._channel.then(v=>v.append(h))}appendLine(h){this._channel.then(v=>v.appendLine(h))}clear(){this._channel.then(h=>h.clear())}show(h,v){this._channel.then(_=>_.show(h,v))}hide(){this._channel.then(h=>h.hide())}dispose(){this._channel.then(h=>h.dispose())}}e.LazyOutputChannel=I;let c=class{constructor(h){this._proxy=h.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(h){}createOutputChannel(h,v){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");return new A(h,v.identifier.value,this._proxy)}createOutputChannelFromLogFile(h,v){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");if(!v)throw new Error("illegal argument `file`. must not be falsy");return new i(h,v,this._proxy)}};c=ze([xe(0,y.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(me[248],ge([0,1,17,21,3,6,5,2,7,16,20,48,62]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(h,v,_){const b=h.getProxy(T.MainContext.MainThreadQuickOpen);class P{constructor(d,u){this._sessions=new Map,this._instances=0,this._workspace=d,this._commands=u}showQuickPick(d,u,w,E=R.CancellationToken.None){this._onDidSelectItem=void 0;const r=Promise.resolve(d),D=++this._instances,L=b.$show(D,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},E),U={},j=L.then(()=>U);return Promise.race([j,r]).then(te=>{if(te!==U)return r.then(K=>{const O=[];for(let x=0;x<K.length;x++){const F=K[x];let z,M,N,V,$;typeof F=="string"?z=F:(z=F.label,M=F.description,N=F.detail,V=F.picked,$=F.alwaysShow),O.push({label:z,description:M,handle:x,detail:N,picked:V,alwaysShow:$})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{w.onDidSelectItem(K[x])}),b.$setItems(D,O),L.then(x=>{if(typeof x=="number")return K[x];if(Array.isArray(x))return x.map(F=>K[F])})})}).then(void 0,te=>{if(!(0,A.isPromiseCanceledError)(te))return b.$setError(D,te),Promise.reject(te)})}$onItemSelected(d){this._onDidSelectItem&&this._onDidSelectItem(d)}showInput(d,u=R.CancellationToken.None){return this._validateInput=d?d.validateInput:void 0,b.$input(d,typeof this._validateInput=="function",u).then(void 0,w=>{if(!(0,A.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(d){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(d)):Promise.resolve(void 0)}async showWorkspaceFolderPick(d,u=R.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!w)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(r=>r.uri.toString()===w.uri.toString())}createQuickPick(d,u){const w=new o(d,u,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(d){const u=new n(d,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(d,u){const w=this._sessions.get(d);w&&w._fireDidChangeValue(u)}$onDidAccept(d){const u=this._sessions.get(d);u&&u._fireDidAccept()}$onDidChangeActive(d,u){const w=this._sessions.get(d);w instanceof o&&w._fireDidChangeActive(u)}$onDidChangeSelection(d,u){const w=this._sessions.get(d);w instanceof o&&w._fireDidChangeSelection(u)}$onDidTriggerButton(d,u){const w=this._sessions.get(d);w&&w._fireDidTriggerButton(u)}$onDidTriggerItemButton(d,u,w){const E=this._sessions.get(d);E instanceof o&&E._fireDidTriggerItemButton(u,w)}$onDidHide(d){const u=this._sessions.get(d);u&&u._fireDidHide()}}class l{constructor(d,u){this._extensionId=d,this._onDidDispose=u,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(d){this._title=d,this.update({title:d})}get step(){return this._steps}set step(d){this._steps=d,this.update({step:d})}get totalSteps(){return this._totalSteps}set totalSteps(d){this._totalSteps=d,this.update({totalSteps:d})}get enabled(){return this._enabled}set enabled(d){this._enabled=d,this.update({enabled:d})}get busy(){return this._busy}set busy(d){this._busy=d,this.update({busy:d})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(d){this._ignoreFocusOut=d,this.update({ignoreFocusOut:d})}get value(){return this._value}set value(d){this._value=d,this.update({value:d})}get placeholder(){return this._placeholder}set placeholder(d){this._placeholder=d,this.update({placeholder:d})}get buttons(){return this._buttons}set buttons(d){this._buttons=d.slice(),this._handlesToButtons.clear(),d.forEach((u,w)=>{const E=u===S.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(E,u)}),this.update({buttons:d.map((u,w)=>({...s(u),tooltip:u.tooltip,handle:u===S.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(d){this._value=d,this._onDidChangeValueEmitter.fire(d)}_fireDidTriggerButton(d){const u=this._handlesToButtons.get(d);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(d){if(!this._disposed){for(const u of Object.keys(d)){const w=d[u];this._pendingUpdate[u]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}l._nextId=1;function f(a){if(a instanceof S.ThemeIcon)return{id:a.id};const d=t(a),u=p(a);return{dark:typeof d=="string"?y.URI.file(d):d,light:typeof u=="string"?y.URI.file(u):u}}function p(a){return typeof a=="object"&&"light"in a?a.light:a}function t(a){return typeof a=="object"&&"dark"in a?a.dark:a}function s(a){const d=f(a.iconPath);let u,w;return"id"in d?w=c.ThemeIcon.asClassName(d):u=d,{iconPath:u,iconClass:w}}class o extends l{constructor(d,u,w){super(d,w);this.enableProposedApi=u,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(d){this._items=d.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),d.forEach((u,w)=>{this._handlesToItems.set(w,u),this._itemsToHandles.set(u,w)}),this.update({items:d.map((u,w)=>({label:u.label,description:u.description,handle:w,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons&&this.enableProposedApi?u.buttons.map((E,r)=>({...s(E),tooltip:E.tooltip,handle:r})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(d){this._canSelectMany=d,this.update({canSelectMany:d})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(d){this._matchOnDescription=d,this.update({matchOnDescription:d})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(d){this._matchOnDetail=d,this.update({matchOnDetail:d})}get sortByLabel(){return this._sortByLabel}set sortByLabel(d){this._sortByLabel=d,this.update({sortByLabel:d})}get activeItems(){return this._activeItems}set activeItems(d){this._activeItems=d.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(d){this._selectedItems=d.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(d){const u=(0,i.coalesce)(d.map(w=>this._handlesToItems.get(w)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(d){const u=(0,i.coalesce)(d.map(w=>this._handlesToItems.get(w)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}_fireDidTriggerItemButton(d,u){const w=this._handlesToItems.get(d);if(!w||!w.buttons||!w.buttons.length)return;const E=w.buttons[u];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:w})}}class n extends l{constructor(d,u){super(d,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(d){this._password=d,this.update({password:d})}get prompt(){return this._prompt}set prompt(d){this._prompt=d,this.update({prompt:d})}get validationMessage(){return this._validationMessage}set validationMessage(d){this._validationMessage=d,this.update({validationMessage:d,severity:d?I.default.Error:I.default.Ignore})}}return new P(v,_)}e.createExtHostQuickOpen=m}),define(me[249],ge([0,1,2,3,56,6,17,5,20,99,12,26,35,62,15]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function v(d){if(d)return typeof d.iconPath=="string"?g.URI.file(d.iconPath):g.URI.isUri(d.iconPath)||m.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function _(d,u){if(!d.iconPath&&!u.iconPath)return 0;if(d.iconPath){if(!u.iconPath)return 1}else return-1;const w=typeof d.iconPath=="string"?d.iconPath:g.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,E=typeof u.iconPath=="string"?u.iconPath:g.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,A.comparePaths)(w,E)}function b(d,u){let w=0;if(d.strikeThrough!==u.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==u.faded)return d.faded?1:-1;if(d.tooltip!==u.tooltip)return(d.tooltip||"").localeCompare(u.tooltip||"");if(w=_(d,u),w!==0)return w;if(d.light&&u.light)w=_(d.light,u.light);else{if(d.light)return 1;if(u.light)return-1}if(w!==0)return w;if(d.dark&&u.dark)w=_(d.dark,u.dark);else{if(d.dark)return 1;if(u.dark)return-1}return w}function P(d,u){if(d.command!==u.command)return d.command<u.command?-1:1;if(d.title!==u.title)return d.title<u.title?-1:1;if(d.tooltip!==u.tooltip){if(d.tooltip!==void 0&&u.tooltip!==void 0)return d.tooltip<u.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(d.arguments===u.arguments)return 0;if(d.arguments)if(u.arguments){if(d.arguments.length!==u.arguments.length)return d.arguments.length-u.arguments.length}else return 1;else return-1;for(let w=0;w<d.arguments.length;w++){const E=d.arguments[w],r=u.arguments[w];if(E!==r)return E<r?-1:1}return 0}function l(d,u){let w=(0,A.comparePaths)(d.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(w!==0)return w;if(d.command&&u.command)w=P(d.command,u.command);else{if(d.command)return 1;if(u.command)return-1}if(w!==0)return w;if(d.decorations&&u.decorations)w=b(d.decorations,u.decorations);else{if(d.decorations)return 1;if(u.decorations)return-1}return w}function f(d,u){for(let w=0;w<d.length;w++)if(d[w]!==u[w])return!1;return!0}function p(d,u){return d.command===u.command&&d.title===u.title&&d.tooltip===u.tooltip&&(d.arguments&&u.arguments?f(d.arguments,u.arguments):d.arguments===u.arguments)}function t(d,u){return(0,S.equals)(d,u,p)}class s{constructor(u,w,E){this._extension=u,this._proxy=w,this._sourceControlHandle=E,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,c.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(u){if((0,c.checkProposedApiEnabled)(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}focus(){(0,c.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(u,w){(0,c.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,u,w)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=s;class o{constructor(u,w,E,r,D){this._proxy=u,this._commands=w,this._sourceControlHandle=E,this._id=r,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,w){const E=this._resourceStatesCommandsMap.get(u);return E?(0,T.asPromise)(()=>this._commands.executeCommand(E.command,...E.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this._resourceStates].sort(l),E=(0,S.sortedDiff)(this._resourceSnapshot,u,l).map(L=>{const U=L.toInsert.map(j=>{const te=this._resourceHandlePool++;this._resourceStatesMap.set(te,j);const K=j.resourceUri;let O;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const fe=new C.DisposableStore;O=this._commands.converter.toInternal(j.command,fe),this._resourceStatesDisposablesMap.set(te,fe)}else this._resourceStatesCommandsMap.set(te,j.command);const x=v(j.decorations),F=j.decorations&&v(j.decorations.light)||x,z=j.decorations&&v(j.decorations.dark)||x,M=[F,z],N=j.decorations&&j.decorations.tooltip||"",V=j.decorations&&!!j.decorations.strikeThrough,$=j.decorations&&!!j.decorations.faded,G=j.contextValue||"";return{rawResource:[te,K,M,N,V,$,G,O],handle:te}});return{start:L.start,deleteCount:L.deleteCount,toInsert:U}}),r=E.map(({start:L,deleteCount:U,toInsert:j})=>[L,U,j.map(te=>te.rawResource)]),D=E.reverse();for(const{start:L,deleteCount:U,toInsert:j}of D){const te=j.map(O=>O.handle),K=this._handlesSnapshot.splice(L,U,...te);for(const O of K)this._resourceStatesMap.delete(O),this._resourceStatesCommandsMap.delete(O),this._resourceStatesDisposablesMap.get(O)?.dispose(),this._resourceStatesDisposablesMap.delete(O)}return this._resourceSnapshot=u,r}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class n{constructor(u,w,E,r,D,L){this._proxy=w,this._commands=E,this._id=r,this._label=D,this._rootUri=L,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new s(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,r,D,L)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=u;const w=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&t(this._statusBarCommands,u))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=u;const w=(u||[]).map(E=>this._commands.converter.toInternal(E,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(u,w){const E=new o(this._proxy,this._commands,this.handle,u,w),r=R.Event.once(E.onDidDispose)(()=>this.createdResourceGroups.delete(E));return this.createdResourceGroups.set(E,r),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const u=[],w=[];for(const[E,r]of this.createdResourceGroups){r.dispose();const D=E.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(E),this.eventuallyUpdateResourceStates()});R.Event.once(E.onDidDispose)(()=>{this.updatedResourceGroups.delete(E),D.dispose(),this._groups.delete(E.handle),this._proxy.$unregisterGroup(this.handle,E.handle)}),u.push([E.handle,E.id,E.label,E.features]);const L=E._takeResourceStateSnapshot();L.length>0&&w.push([E.handle,L]),this._groups.set(E.handle,E)}this._proxy.$registerGroups(this.handle,u,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(w=>{const E=w._takeResourceStateSnapshot();E.length!==0&&u.push([w.handle,E])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,ze([(0,k.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),ze([(0,k.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let a=class xn{constructor(u,w,E){this._commands=w,this.logService=E,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=u.getProxy(y.MainContext.MainThreadSCM),this._telemetry=u.getProxy(y.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===3){const D=this._sourceControls.get(r.sourceControlHandle);if(!D)return r;const L=D.getResourceGroup(r.groupHandle);return L?L.getResourceState(r.handle):r}else if(r&&r.$mid===4){const D=this._sourceControls.get(r.sourceControlHandle);return D?D.getResourceGroup(r.groupHandle):r}else if(r&&r.$mid===5){const D=this._sourceControls.get(r.handle);return D||r}return r}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,w,E,r){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,w,E,r),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const D=xn._handlePool++,L=new n(u,this._proxy,this._commands,w,E,r);this._sourceControls.set(D,L);const U=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier))||[];return U.push(L),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(u.identifier),U),L}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const w=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier)),E=w&&w[w.length-1];return E&&E.inputBox}$provideOriginalResource(u,w,E){const r=g.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,r.toString());const D=this._sourceControls.get(u);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>D.quickDiffProvider.provideOriginalResource(r,E)).then(L=>L||null)}$onInputBoxValueChange(u,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const E=this._sourceControls.get(u);return E&&E.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(u,w,E,r){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,w,E);const D=this._sourceControls.get(u);if(!D)return Promise.resolve(void 0);const L=D.getResourceGroup(w);return L?L.$executeResourceCommand(E,r):Promise.resolve(void 0)}$validateInput(u,w,E){this.logService.trace("ExtHostSCM#$validateInput",u);const r=this._sourceControls.get(u);return!r||!r.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>r.inputBox.validateInput(w,E)).then(D=>{if(!D)return Promise.resolve(void 0);const L=h.MarkdownString.fromStrict(D.message);return L?Promise.resolve([L,D.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this._sourceControls.get(u)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};a._handlePool=0,a=ze([xe(2,i.ILogService)],a),e.ExtHostSCM=a});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},He=this&&this.__classPrivateFieldGet||function(Y,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(Y):R?R.value:e.get(Y)};define(me[250],ge([0,1,7,5,166,6,15]),function(Y,e,g,R,k,C,T){"use strict";var y,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(m,h,v,_,b=g.StatusBarAlignment.Left,P){y.set(this,void 0),S.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,rt(this,y,m,"f"),rt(this,S,h,"f"),this._entryId=A.ID_GEN++,this._extension=v,this._id=_,this._alignment=b,this._priority=P}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!A.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:He(this,S,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:He(this,S,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,He(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let h;this._name?h=this._name:h=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const _=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;He(this,y,"f").$setEntry(this._entryId,m,h,this._text,_,this._command?.internal,v,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,y=new WeakMap,S=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class i{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const h={message:m};return this._messages.unshift(h),this._update(),new g.Disposable(()=>{const v=this._messages.indexOf(h);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(m,h){this._proxy=m.getProxy(R.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new i(this)}createStatusBarEntry(m,h,v,_){return new A(this._proxy,this._commands,m,h,v,_)}setStatusBarMessage(m,h){const v=this._statusMessage.setMessage(m);let _;return typeof h=="number"?_=setTimeout(()=>v.dispose(),h):typeof h!="undefined"&&h.then(()=>v.dispose(),()=>v.dispose()),new g.Disposable(()=>{v.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=I}),define(me[92],ge([0,1,5,3,4]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(y){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=y.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(y,S){this._proxy.$registerExtensionStorageKeysToSync(y,S)}getValue(y,S,A){return this._proxy.$getValue(y,S).then(i=>i||A)}setValue(y,S,A){return this._proxy.$setValue(y,S,A)}$acceptValue(y,S,A){this._onDidChangeStorage.fire({shared:y,key:S,value:A})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(me[67],ge([0,1,4,27,12,91,2]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let y=class{constructor(A,i,I){this._logService=i,this._extHostFileSystem=I,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(A){return T.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,i=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(A){if(this._value)return T.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return T.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};y=ze([xe(0,R.IExtHostInitDataService),xe(1,k.ILogService),xe(2,C.IExtHostConsumerFileSystem)],y),e.ExtensionStoragePaths=y}),define(me[33],ge([0,1,3,5,4,2,13,6,7,167,16,214,21,32,195,62,14]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class b{constructor(a,d,u,w){this._proxy=a,this._id=d,this._creationOptions=u,this._name=w,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(r=>this._pidPromiseComplete=r);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(r,D=!0){E._checkDisposed(),E._proxy.$sendText(E._id,r,D)},show(r){E._checkDisposed(),E._proxy.$show(E._id,r)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(a,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:a.name,shellPath:(0,_.withNullAsUndefined)(a.shellPath),shellArgs:(0,_.withNullAsUndefined)(a.shellArgs),cwd:(0,_.withNullAsUndefined)(a.cwd),env:(0,_.withNullAsUndefined)(a.env),icon:(0,_.withNullAsUndefined)(s(a.iconPath)),color:v.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,_.withNullAsUndefined)(a.message),strictEnv:(0,_.withNullAsUndefined)(a.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(a.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(d?.useShellEnvironment),isSplitTerminal:d?.isSplitTerminal,target:d?.target})}async createExtensionTerminal(a,d,u,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:u,color:v.ThemeColor.isThemeColor(w)?w.id:void 0,isSplitTerminal:a,target:d}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(a){this._name=a}setExitCode(a){this._exitStatus=Object.freeze({code:a})}setDimensions(a,d){return a===this._cols&&d===this._rows||a===0||d===0?!1:(this._cols=a,this._rows=d,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(a){this._pidPromiseComplete?(this._pidPromiseComplete(a),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==a&&(this._pidPromise=Promise.resolve(a))})}}e.ExtHostTerminal=b;class P{constructor(a){this._pty=a,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(a){this._pty.handleInput&&this._pty.handleInput(a)}resize(a,d){this._pty.setDimensions&&this._pty.setDimensions({columns:a,rows:d})}async processBinary(a){}acknowledgeDataEvent(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose&&this._pty.onDidClose((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d&&{cols:d.columns,rows:d.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(d=>this._onProcessTitleChanged.fire(d)),this._pty.open(a||void 0),this._pty.setDimensions&&a&&this._pty.setDimensions(a),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=P;let l=1,f=class extends y.Disposable{constructor(a,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=d.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(a),this._register({dispose:()=>{for(const[u,w]of this._terminalProcesses)w.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(a=>a.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(a,d){const u=new b(this._proxy,(0,m.generateUuid)(),a,a.name),w=new P(a.pty);return u.createExtensionTerminal(d?.isSplitTerminal,d?.target,s(a.iconPath),o(a.color)).then(E=>{const r=this._setupExtHostProcessListeners(E,w);this._terminalProcessDisposables[E]=r}),this._terminals.push(u),u.value}attachPtyToTerminal(a,d){if(!this._getTerminalById(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const w=new P(d),E=this._setupExtHostProcessListeners(a,w);this._terminalProcessDisposables[a]=E}async $acceptActiveTerminalChanged(a){const d=this._activeTerminal;if(a===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(a);u&&(this._activeTerminal=u,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(a,d){const u=this._getTerminalById(a);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:d})}async $acceptTerminalDimensions(a,d,u){const w=this._getTerminalById(a);w&&w.setDimensions(d,u)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(a,d,u){this._terminalProcesses.get(a)?.resize(d,u)}async $acceptTerminalTitleChange(a,d){const u=this._getTerminalById(a);u&&(u.name=d)}async $acceptTerminalClosed(a,d){const u=this._getTerminalObjectIndexById(this._terminals,a);if(u!==null){const w=this._terminals.splice(u,1)[0];w.setExitCode(d),this._onDidCloseTerminal.fire(w.value)}}$acceptTerminalOpened(a,d,u,w){if(d){const D=this._getTerminalObjectIndexById(this._terminals,d);if(D!==null){this._terminals[D]._id=a,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const E={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:C.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},r=new b(this._proxy,a,E,u);this._terminals.push(r),this._onDidOpenTerminal.fire(r.value),r.isOpen=!0}async $acceptTerminalProcessId(a,d){const u=this._getTerminalById(a);u&&u._setProcessId(d)}async $startExtensionTerminal(a,d){const u=this._getTerminalById(a);if(!u)return{message:(0,A.localize)(0,null,a)};u.isOpen||await new Promise(E=>{const r=this.onDidOpenTerminal(async D=>{D===u.value&&(r.dispose(),E())})});const w=this._terminalProcesses.get(a);w?w.startSendingEvents(d):this._extensionTerminalAwaitingStart[a]={initialDimensions:d}}_setupExtHostProcessListeners(a,d){const u=new y.DisposableStore;u.add(d.onProcessReady(E=>this._proxy.$sendProcessReady(a,E.pid,E.cwd))),u.add(d.onProcessTitleChanged(E=>this._proxy.$sendProcessTitle(a,E))),this._bufferer.startBuffering(a,d.onProcessData),u.add(d.onProcessExit(E=>this._onProcessExit(a,E))),d.onProcessOverrideDimensions&&u.add(d.onProcessOverrideDimensions(E=>this._proxy.$sendOverrideDimensions(a,E))),this._terminalProcesses.set(a,d);const w=this._extensionTerminalAwaitingStart[a];return w&&d instanceof P&&(d.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[a]),u}$acceptProcessAckDataEvent(a,d){this._terminalProcesses.get(a)?.acknowledgeDataEvent(d)}$acceptProcessInput(a,d){this._terminalProcesses.get(a)?.input(d)}$acceptTerminalInteraction(a){const d=this._getTerminalById(a);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire({terminal:d.value,state:d.value.state})}$acceptProcessResize(a,d,u){try{this._terminalProcesses.get(a)?.resize(d,u)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(a,d){this._terminalProcesses.get(a)?.shutdown(d)}$acceptProcessRequestInitialCwd(a){this._terminalProcesses.get(a)?.getInitialCwd().then(d=>this._proxy.$sendProcessInitialCwd(a,d))}$acceptProcessRequestCwd(a){this._terminalProcesses.get(a)?.getCwd().then(d=>this._proxy.$sendProcessCwd(a,d))}$acceptProcessRequestLatency(a){return a}registerLinkProvider(a){return this._linkProviders.add(a),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(a),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(a,d,u){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,u),this._proxy.$registerProfileProvider(d,a.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(a,d){const u=new c.CancellationTokenSource().token,w=await this._profileProviders.get(a)?.provideTerminalProfile(u);if(!u.isCancellationRequested){if(!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,d);return}this.createTerminalFromOptions(w.options,d)}}async $provideLinks(a,d){const u=this._getTerminalById(a);if(!u)return[];this._terminalLinkCache.delete(a);const w=this._terminalLinkCancellationSource.get(a);w&&w.dispose(!0);const E=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(a,E);const r=[],D={terminal:u.value,line:d},L=[];for(const te of this._linkProviders)L.push(new Promise(async K=>{E.token.onCancellationRequested(()=>K({provider:te,links:[]}));const O=await te.provideTerminalLinks(D,E.token)||[];E.token.isCancellationRequested||K({provider:te,links:O})}));const U=await Promise.all(L);if(E.token.isCancellationRequested)return[];const j=new Map;for(const te of U)te&&te.links.length>0&&r.push(...te.links.map(K=>{const O={id:l++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return j.set(O.id,{provider:te.provider,link:K}),O}));return this._terminalLinkCache.set(a,j),r}$activateLink(a,d){const u=this._terminalLinkCache.get(a)?.get(d);!u||u.provider.handleTerminalLink(u.link)}_onProcessExit(a,d){this._bufferer.stopBuffering(a),this._terminalProcesses.delete(a),delete this._extensionTerminalAwaitingStart[a];const u=this._terminalProcessDisposables[a];u&&(u.dispose(),delete this._terminalProcessDisposables[a]),this._proxy.$sendProcessExit(a,d)}_getTerminalById(a){return this._getTerminalObjectById(this._terminals,a)}_getTerminalObjectById(a,d){const u=this._getTerminalObjectIndexById(a,d);return u!==null?a[u]:null}_getTerminalObjectIndexById(a,d){let u=null;return a.some((w,E)=>w._id===d?(u=E,!0):!1),u}getEnvironmentVariableCollection(a){let d=this._environmentVariableCollections.get(a.identifier.value);return d||(d=new p,this._setEnvironmentVariableCollection(a.identifier.value,d)),d}_syncEnvironmentVariableCollection(a,d){const u=(0,I.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(a,d.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(a){a.forEach(d=>{const u=d[0],w=new p(d[1]);this._setEnvironmentVariableCollection(u,w)})}$acceptDefaultProfile(a,d){this._defaultProfile=a,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(a,d){this._environmentVariableCollections.set(a,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(a,d)})}};f=ze([xe(1,T.IExtHostRpcService)],f),e.BaseExtHostTerminalService=f;class p{constructor(a){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(a)}get persistent(){return this._persistent}set persistent(a){this._persistent=a,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(a,d){this._setIfDiffers(a,{value:d,type:S.EnvironmentVariableMutatorType.Replace})}append(a,d){this._setIfDiffers(a,{value:d,type:S.EnvironmentVariableMutatorType.Append})}prepend(a,d){this._setIfDiffers(a,{value:d,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(a,d){const u=this.map.get(a);(!u||u.value!==d.value||u.type!==d.type)&&(this.map.set(a,d),this._onDidChangeCollection.fire())}get(a){return this.map.get(a)}forEach(a,d){this.map.forEach((u,w)=>a.call(d,w,u,this))}delete(a){this.map.delete(a),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let t=class extends f{constructor(a){super(!1,a)}createTerminal(a,d,u){throw new i.NotSupportedError}createTerminalFromOptions(a,d){throw new i.NotSupportedError}};t=ze([xe(0,T.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function s(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function o(n){return v.ThemeColor.isThemeColor(n)?n:void 0}});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},He=this&&this.__classPrivateFieldGet||function(Y,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(Y):R?R.value:e.get(Y)};define(me[251],ge([0,1,25,21,3,73,58,75,6,22,14,32,5,13,87,15,7,222,126,89]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b,P,l){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(L,U){this.resultsChangedEmitter=new k.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(c.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new s(this.proxy),U.registerArgumentProcessor({processArgument:j=>j?.$mid===13?v.TestItem.toItemFromContext(j):j})}createTestController(L,U){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const j=new S.DisposableStore,te=j.add(new b.SingleUseTestCollection(L));te.root.label=U;const K=new Map,O=this.proxy,x={items:te.root.children,get label(){return U},set label(z){U=z,te.root.label=z,O.$updateControllerLabel(L,U)},get id(){return L},createRunProfile:(z,M,N,V,$)=>{let G=(0,T.hash)(z);for(;K.has(G);)G++;const J=new E(this.proxy,L,G,z,M,N,V,$);return K.set(G,J),J},createTestItem(z,M,N){return new h.TestItemImpl(L,z,M,N)},createTestRun:(z,M,N=!0)=>this.runTracker.createTestRun(L,te,z,M,N),set resolveHandler(z){te.resolveHandler=z},get resolveHandler(){return te.resolveHandler},dispose:()=>{j.dispose()}};x.createRunConfiguration=x.createRunProfile,O.$registerTestController(L,U),j.add((0,S.toDisposable)(()=>O.$unregisterTestController(L)));const F={controller:x,collection:te,profiles:K};return this.controllers.set(L,F),j.add((0,S.toDisposable)(()=>this.controllers.delete(L))),j.add(te.onDidGenerateDiff(z=>O.$publishDiff(L,z))),x}createTestObserver(){return this.observer.checkout()}async runTests(L,U=R.CancellationToken.None){const j=o(L);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const te=this.controllers.get(j.controllerId);if(!te)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:L.include?.map(K=>K.id)??[te.collection.root.id],profileGroup:r[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:L.exclude?.map(K=>K.id)},U)}$provideFileCoverage(L,U,j){return y.Iterable.find(this.runTracker.trackers,te=>te.id===L)?.getCoverage(U)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(L,U,j,te){return y.Iterable.find(this.runTracker.trackers,K=>K.id===L)?.getCoverage(U)?.resolveFileCoverage(j,te)??Promise.resolve([])}$configureRunProfile(L,U){this.controllers.get(L)?.profiles.get(U)?.configureHandler?.()}$getTestTags(L){const U=this.controllers.get(L);if(!U)return Promise.resolve([]);const j=new Map;for(const te of U.profiles.values())if(te.tag){const K=v.TestTag.display(L,te.tag);j.set(K.id,K)}for(const te of U.collection.tags()){const K=v.TestTag.display(L,te);j.set(K.id,K)}return Promise.resolve([...j.values()])}$publishTestResults(L){this.results=Object.freeze(L.map(U=>(0,A.deepFreeze)(v.TestResults.to(U))).concat(this.results).sort((U,j)=>j.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,U){const j=this.controllers.get(l.TestId.fromString(L).controllerId)?.collection;j&&(await j.expand(L,U<0?Infinity:U),j.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L)}async $runControllerTests(L,U){const j=this.controllers.get(L.controllerId);if(!j)return;const{collection:te,profiles:K}=j,O=K.get(L.profileId);if(!O)return;const x=L.testIds.map(N=>te.tree.get(N)).filter(i.isDefined),F=L.excludeExtIds.map(N=>j.collection.tree.get(N)).filter(i.isDefined).filter(N=>x.some(V=>V.fullId.compare(N.fullId)===2));if(!x.length)return;const z=new _.TestRunRequest(x.some(N=>N.actual instanceof h.TestItemRootImpl)?void 0:x.map(N=>N.actual),F.map(N=>N.actual),O),M=this.runTracker.prepareForMainThreadTestRun(z,n.fromInternal(L,j.collection),U);try{await O.runHandler(z,U)}finally{M.isRunning&&!U.isCancellationRequested&&await k.Event.toPromise(M.onEnd),this.runTracker.cancelRunById(L.runId)}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};p=ze([xe(0,m.IExtHostRpcService)],p),e.ExtHostTesting=p;class t extends S.Disposable{constructor(L,U,j){super();this.dto=L,this.proxy=U,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new R.CancellationTokenSource(j)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:te}of this.tasks.values())te.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const U=this.dto.id,j=this.dto.controllerId,te=(0,I.generateUuid)(),K=new a(this.proxy,U,te),O=z=>(M,...N)=>{if(x){console.warn(`Setting the state of test "${M.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(M)||(this.ensureTestIsKnown(M),z(M,...N))};let x=!1;const F={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return K.coverageProvider},set coverageProvider(z){K.coverageProvider=z},enqueued:O(z=>{this.proxy.$updateTestStateInRun(U,te,l.TestId.fromExtHostTestItem(z,j).toString(),1)}),skipped:O(z=>{this.proxy.$updateTestStateInRun(U,te,l.TestId.fromExtHostTestItem(z,j).toString(),5)}),started:O(z=>{this.proxy.$updateTestStateInRun(U,te,l.TestId.fromExtHostTestItem(z,j).toString(),2)}),errored:O((z,M,N)=>{this.proxy.$appendTestMessagesInRun(U,te,l.TestId.fromExtHostTestItem(z,j).toString(),M instanceof Array?M.map(v.TestMessage.from):[v.TestMessage.from(M)]),this.proxy.$updateTestStateInRun(U,te,l.TestId.fromExtHostTestItem(z,j).toString(),6,N)}),failed:O((z,M,N)=>{this.proxy.$appendTestMessagesInRun(U,te,l.TestId.fromExtHostTestItem(z,j).toString(),M instanceof Array?M.map(v.TestMessage.from):[v.TestMessage.from(M)]),this.proxy.$updateTestStateInRun(U,te,l.TestId.fromExtHostTestItem(z,j).toString(),4,N)}),passed:O((z,M)=>{this.proxy.$updateTestStateInRun(U,te,l.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,M)}),appendOutput:(z,M,N)=>{x||(N&&(this.dto.isIncluded(N)?this.ensureTestIsKnown(N):N=void 0),this.proxy.$appendOutputToRun(U,te,g.VSBuffer.fromString(z),M&&v.location.from(M),N&&l.TestId.fromExtHostTestItem(N,j).toString()))},end:()=>{x||(x=!0,this.proxy.$finishedTestRunTask(U,te),this.tasks.delete(te),this.isRunning||this.dispose())}};return this.tasks.set(te,{run:F,coverage:K}),this.proxy.$startedTestRunTask(U,{id:te,name:L,running:!0}),F}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof h.TestItemImpl))throw new h.InvalidTestItemError(L.id);if(this.sharedTestIds.has(L.id))return;const U=[];for(;U.unshift(v.TestItem.from(L)),!(this.sharedTestIds.has(L.id)||(this.sharedTestIds.add(L.id),!L.parent));)L=L.parent;const j=this.dto.colllection.root;this.sharedTestIds.has(j.id)||(this.sharedTestIds.add(j.id),U.unshift(v.TestItem.from(j))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class s{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,U,j){return this.getTracker(L,U,j)}cancelRunById(L){for(const U of this.tracked.values())if(U.id===L){U.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,U,j,te,K){const O=this.tracked.get(j);if(O)return O.createRun(te);const x=n.fromPublic(L,U,j,K),F=o(j);this.proxy.$startedExtensionTestRun({controllerId:L,profile:F&&{group:r[F.kind],id:F.profileId},exclude:j.exclude?.map(M=>M.id)??[],id:x.id,include:j.include?.map(M=>M.id)??[U.root.id],persist:K});const z=this.getTracker(j,x);return z.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),z.createRun(te)}getTracker(L,U,j){const te=new t(U,this.proxy,j);return this.tracked.set(L,te),te.onEnd(()=>this.tracked.delete(L)),te}}e.TestRunCoordinator=s;const o=D=>{if(!!D.profile){if(!(D.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return D.profile}};class n{constructor(L,U,j,te,K,O){this.controllerId=L,this.id=U,this.isPersisted=K,this.colllection=O,this.includePrefix=j.map(x=>x+"\0"),this.excludePrefix=te.map(x=>x+"\0")}static fromPublic(L,U,j,te){return new n(L,(0,I.generateUuid)(),j.include?.map(K=>l.TestId.fromExtHostTestItem(K,L).toString())??[L],j.exclude?.map(K=>l.TestId.fromExtHostTestItem(K,L).toString())??[],te,U)}static fromInternal(L,U){return new n(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,U)}isIncluded(L){const U=l.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const j of this.excludePrefix)if(U===j||U.startsWith(j))return!1;for(const j of this.includePrefix)if(U===j||U.startsWith(j))return!0;return!1}}e.TestRunDto=n;class a{constructor(L,U,j){this.proxy=L,this.runId=U,this.taskId=j}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(L,U){const j=await this.fileCoverage;let te=j?.[L];return!this._coverageProvider||!j||!te?[]:(te.detailedCoverage||(te=j[L]=await this._coverageProvider.resolveFileCoverage?.(te,U)??te),te.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class d extends P.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,v.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:U,removed:j}=this;return{get added(){return[...L].map(te=>te.revived)},get updated(){return[...U].map(te=>te.revived)},get removed(){return[...j].map(te=>te.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class u extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,U){return{...L,revived:v.TestItem.toPlain(L.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=u;class w{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(U=>U.revived)},dispose:(0,C.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new u;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class E{constructor(L,U,j,te,K,O,x=!1,F=void 0){this.controllerId=U,this.profileId=j,this._label=te,this.kind=K,this.runHandler=O,this._isDefault=x,this._tag=F,f.set(this,void 0),rt(this,f,L,"f");const z=r[K];if(typeof z!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);He(this,f,"f").$publishTestRunProfile({profileId:j,controllerId:U,tag:F?v.TestTag.namespace(this.controllerId,F.id):null,label:te,group:z,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,He(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,He(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,He(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?v.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,He(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){He(this,f,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=E,f=new WeakMap;const r={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(me[252],ge([0,1,3,20,5,129,15,7]),function(Y,e,g,R,k,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(c=>c.value)}async showTextDocument(i,I,c){let m;typeof I=="number"?m={position:T.ViewColumn.from(I),preserveFocus:c}:typeof I=="object"?m={position:T.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?T.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:m={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(i.uri,m),v=h&&this._extHostDocumentsAndEditors.getEditor(h);if(v)return v.value;throw h?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,I){return new C.TextEditorDecorationType(this._proxy,i,I).value}$acceptEditorPropertiesChanged(i,I){const c=this._extHostDocumentsAndEditors.getEditor(i);if(!c)throw new Error("unknown text editor");if(I.options&&c._acceptOptions(I.options),I.selections){const m=I.selections.selections.map(T.Selection.to);c._acceptSelections(m)}if(I.visibleRanges){const m=R.coalesce(I.visibleRanges.map(T.Range.to));c._acceptVisibleRanges(m)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...I.options,lineNumbers:T.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const m=y.TextEditorSelectionChangeKind.fromValue(I.selections.source),h=I.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:h,kind:m})}if(I.visibleRanges){const m=R.coalesce(I.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:m})}}$acceptEditorPositionData(i){for(const I in i){const c=this._extHostDocumentsAndEditors.getEditor(I);if(!c)throw new Error("Unknown text editor");const m=T.ViewColumn.to(i[I]);c.value.viewColumn!==m&&(c._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:m}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=S}),define(me[253],ge([0,1,2,4,5,6,7]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class y{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(k.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const m=c.uri===void 0?void 0:g.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(S(m))?.get(c.handle)}return c}})}async $getTimeline(i,I,c,m,h){return this._providers.get(i)?.provideTimeline(g.URI.revive(I),c,m,h)}registerTimelineProvider(i,I,c,m){const h=new C.DisposableStore,v=this.convertTimelineItem(I.id,m,h).bind(this);let _;I.onDidChange&&(_=I.onDidChange(P=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...P,id:I.id}),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:i,onDidChange:void 0,async provideTimeline(P,l,f,p){p?.resetCache&&(h.clear(),b.get(I.id)?.clear());const t=await I.provideTimeline(P,l,f);if(t==null)return;const s=v(P,p);return{...t,source:I.id,items:t.items.map(s)}},dispose(){for(const P of b.values())P.get(I.id)?.clear();_?.dispose(),h.dispose()}})}convertTimelineItem(i,I,c){return(m,h)=>{let v;if(h?.cacheResults){let _=this._itemsBySourceAndUriMap.get(i);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(i,_));const b=S(m);v=_.get(b),v===void 0&&(v=new Map,_.set(b,v))}return _=>{const{iconPath:b,...P}=_,l=`${i}|${_.id??_.timestamp}`;v?.set(l,_);let f,p,t;return _.iconPath&&(b instanceof T.ThemeIcon?t={id:b.id,color:b.color}:g.URI.isUri(b)?(f=b,p=b):{light:f,dark:p}=b),{...P,id:P.id??void 0,handle:l,source:i,command:_.command?I.toInternal(_.command,c):void 0,icon:f,iconDark:p,themeIcon:t,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,C.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=y;function S(A){return A?.toString()}}),define(me[254],ge([0,1,6,10,2,5]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(S){this._openers=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,A,i,I){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const c=I.schemes.find(m=>!T.supportedSchemes.has(m));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,i),this._proxy.$registerUriOpener(A,I.schemes,S,I.label),(0,g.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(S,A,i){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const c=k.URI.revive(A);return I.canOpenExternalUri(c,i)}async $openUri(S,A,i){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(k.URI.revive(A.resolvedUri),{sourceUri:k.URI.revive(A.sourceUri)},i)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(me[255],ge([0,1,5,2,6,16,26]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class y{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(A,i){if(this.handles.has(T.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const I=y.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(A)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,A),(0,k.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(A)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(A,i){const I=this.handlers.get(A);if(!I)return Promise.resolve(void 0);try{I.handleUri(R.URI.revive(i))}catch(c){(0,C.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(A){return R.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=y,y.HandlePool=0});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},He=this&&this.__classPrivateFieldGet||function(Y,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(Y):R?R.value:e.get(Y)};define(me[68],ge([0,1,3,2,179,204,88,5]),function(Y,e,g,R,k,C,T,y){"use strict";var S,A,i,I,c,m,h,v,_,b,P,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(u,w,E,r,D,L,U){S.set(this,void 0),A.set(this,void 0),i.set(this,void 0),I.set(this,void 0),c.set(this,void 0),m.set(this,void 0),h.set(this,""),v.set(this,void 0),_.set(this,!1),b.set(this,!1),P.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new g.Emitter),this._onDidDispose=He(this,l,"f").event,rt(this,S,u,"f"),rt(this,A,w,"f"),rt(this,v,E,"f"),rt(this,I,r,"f"),rt(this,c,D,"f"),rt(this,m,L,"f"),rt(this,P,p(L),"f"),rt(this,i,U,"f")}dispose(){rt(this,_,!0,"f"),He(this,l,"f").fire(),He(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return rt(this,b,!0,"f"),(0,T.asWebviewUri)(u,He(this,I,"f").remote)}get cspSource(){return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),He(this,h,"f")}set html(u){this.assertNotDisposed(),He(this,h,"f")!==u&&(rt(this,h,u,"f"),!He(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(rt(this,b,!0,"f"),He(this,i,"f").report("Webview vscode-resource: uris",He(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),He(this,A,"f").$setHtml(He(this,S,"f"),u))}get options(){return this.assertNotDisposed(),He(this,v,"f")}set options(u){this.assertNotDisposed(),He(this,A,"f").$setOptions(He(this,S,"f"),o(He(this,m,"f"),He(this,c,"f"),u)),rt(this,v,u,"f")}async postMessage(u){if(He(this,_,"f"))return!1;const w=(0,C.serializeWebviewMessage)(u,{serializeBuffersForPostMessage:He(this,P,"f")});return He(this,A,"f").$postMessage(He(this,S,"f"),w.message,...w.buffers)}assertNotDisposed(){if(He(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,S=new WeakMap,A=new WeakMap,i=new WeakMap,I=new WeakMap,c=new WeakMap,m=new WeakMap,h=new WeakMap,v=new WeakMap,_=new WeakMap,b=new WeakMap,P=new WeakMap,l=new WeakMap;function p(d){try{const u=(0,k.normalizeVersion)((0,k.parseVersion)(d.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=p;class t{constructor(u,w,E,r,D){this.initData=w,this.workspace=E,this._logService=r,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=u.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(u,w,...E){const r=this.getWebview(u);if(r){const{message:D}=(0,C.deserializeWebviewMessage)(w,E);r._onMessageEmitter.fire(D)}}$onMissingCsp(u,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,w,E){const r=new f(u,this._webviewProxy,n(w),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(u,r),r._onDidDispose(()=>{this._webviews.delete(u)}),r}deleteWebview(u){this._webviews.delete(u)}getWebview(u){return this._webviews.get(u)}}e.ExtHostWebviews=t;function s(d){return{id:d.identifier,location:d.extensionLocation}}e.toExtensionData=s;function o(d,u,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||a(d,u)}}e.serializeWebviewOptions=o;function n(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(u=>R.URI.from(u))}}e.reviveOptions=n;function a(d,u){return[...(u?.getWorkspaceFolders()||[]).map(w=>w.uri),d.extensionLocation]}}),define(me[256],ge([0,1,21,58,6,10,24,2,15,68,86,5,7]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,s){this.document=t,this._storagePath=s,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,s){await this.getEdit(t).undo(),s||this.disposeBackup()}async redo(t,s){await this.getEdit(t).redo(),s||this.disposeBackup()}disposeEdits(t){for(const s of t)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=f(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const s=this._edits.get(t,0);if(!s)throw new Error("No edit found");return s}}class h{constructor(){this._documents=new Map}get(t,s){return this._documents.get(this.key(t,s))}add(t,s,o){const n=this.key(t,s.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${s.uri}`);const a=new m(s,o);return this._documents.set(n,a),a}delete(t,s){const o=this.key(t,s.uri);this._documents.delete(o)}key(t,s){return`${t}@@@${s}`}}var v;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(v||(v={}));class _{constructor(){this._providers=new Map}addTextProvider(t,s,o){return this.add(0,t,s,o)}addCustomProvider(t,s,o){return this.add(1,t,s,o)}get(t){return this._providers.get(t)}add(t,s,o,n){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:t,extension:o,provider:n}),new c.Disposable(()=>this._providers.delete(s))}}class b{constructor(t,s,o,n,a){this._extHostDocuments=s,this._extensionStoragePaths=o,this._extHostWebview=n,this._extHostWebviewPanels=a,this._editorProviders=new _,this._documents=new h,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,s,o,n){const a=new k.DisposableStore;return P(o)?(a.add(this._editorProviders.addTextProvider(s,t,o)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(t),s,n.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(s,t,o)),this.supportEditing(o)&&a.add(o.onDidChangeCustomDocument(d=>{const u=this.getCustomDocumentEntry(s,d.document.uri);if(l(d)){const w=u.addEdit(d);this._proxy.$onDidEdit(d.document.uri,s,w,d.label)}else this._proxy.$onContentChange(d.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(t),s,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(t))),c.Disposable.from(a,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(t,s,o,n,a){const d=this._editorProviders.get(s);if(!d)throw new Error(`No provider found for '${s}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${s}'`);const u=y.URI.revive(t),w=await d.provider.openCustomDocument(u,{backupId:o,untitledDocumentData:n?.buffer},a);let E;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(E=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(s,w,E),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(t,s){const o=this._editorProviders.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const n=y.URI.revive(t),{document:a}=this.getCustomDocumentEntry(s,n);this._documents.delete(s,a),a.dispose()}async $resolveWebviewEditor(t,s,o,n,a,d){const u=this._editorProviders.get(o);if(!u)throw new Error(`No provider found for '${o}'`);const w=S.ViewColumn.to(a),E=this._extHostWebview.createNewWebview(s,n.webviewOptions,u.extension),r=this._extHostWebviewPanels.createNewWebviewPanel(s,o,n.title,w,n.panelOptions,E),D=y.URI.revive(t);switch(u.type){case 1:{const{document:L}=this.getCustomDocumentEntry(o,D);return u.provider.resolveCustomEditor(L,r,d)}case 0:{const L=this._extHostDocuments.getDocument(D);return u.provider.resolveCustomTextEditor(L,r,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,s,o){this.getCustomDocumentEntry(s,t).disposeEdits(o)}async $onMoveCustomEditor(t,s,o){const n=this._editorProviders.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const d=y.URI.revive(s),u=this._extHostDocuments.getDocument(d);await n.provider.moveCustomTextEditor(u,a,g.CancellationToken.None)}async $undo(t,s,o,n){return this.getCustomDocumentEntry(s,t).undo(o,n)}async $redo(t,s,o,n){return this.getCustomDocumentEntry(s,t).redo(o,n)}async $revert(t,s,o){const n=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).revertCustomDocument(n.document,o),n.disposeBackup()}async $onSave(t,s,o){const n=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).saveCustomDocument(n.document,o),n.disposeBackup()}async $onSaveAs(t,s,o,n){const a=this.getCustomDocumentEntry(s,t);return this.getCustomEditorProvider(s).saveCustomDocumentAs(a.document,y.URI.revive(o),n)}async $backup(t,s,o){const n=this.getCustomDocumentEntry(s,t),d=await this.getCustomEditorProvider(s).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},o);return n.updateBackup(d),d.id}getCustomDocumentEntry(t,s){const o=this._documents.get(t,y.URI.revive(s));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const o=this._editorProviders.get(t)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=b;function P(p){return typeof p.resolveCustomTextEditor=="function"}function l(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function f(p){const t=p.scheme===C.Schemas.file||p.scheme===C.Schemas.untitled?p.fsPath:p.toString();return(0,R.hash)(t)+""}});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},He=this&&this.__classPrivateFieldGet||function(Y,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(Y):R?R.value:e.get(Y)};define(me[257],ge([0,1,3,6,2,32,15,68,5,7]),function(Y,e,g,R,k,C,T,y,S,A){"use strict";var i,I,c,m,h,v,_,b,P,l,f,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends R.Disposable{constructor(d,u,w,E,r,D,L){super();i.set(this,void 0),I.set(this,void 0),c.set(this,void 0),m.set(this,void 0),h.set(this,void 0),v.set(this,void 0),_.set(this,void 0),b.set(this,void 0),P.set(this,!0),l.set(this,!0),f.set(this,!1),p.set(this,this._register(new g.Emitter)),this.onDidDispose=He(this,p,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=He(this,t,"f").event,rt(this,i,d,"f"),rt(this,I,u,"f"),rt(this,c,w,"f"),rt(this,h,D,"f"),rt(this,b,r,"f"),rt(this,v,E,"f"),rt(this,m,L,"f")}dispose(){He(this,f,"f")||(rt(this,f,!0,"f"),He(this,p,"f").fire(),He(this,I,"f").$disposeWebview(He(this,i,"f")),He(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),He(this,m,"f")}get viewType(){return this.assertNotDisposed(),He(this,c,"f")}get title(){return this.assertNotDisposed(),He(this,v,"f")}set title(d){this.assertNotDisposed(),He(this,v,"f")!==d&&(rt(this,v,d,"f"),He(this,I,"f").$setTitle(He(this,i,"f"),d))}get iconPath(){return this.assertNotDisposed(),He(this,_,"f")}set iconPath(d){this.assertNotDisposed(),He(this,_,"f")!==d&&(rt(this,_,d,"f"),He(this,I,"f").$setIconPath(He(this,i,"f"),k.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return He(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof He(this,b,"f")=="number"&&He(this,b,"f")<0))return He(this,b,"f")}get active(){return this.assertNotDisposed(),He(this,l,"f")}get visible(){return this.assertNotDisposed(),He(this,P,"f")}_updateViewState(d){He(this,f,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(rt(this,l,d.active,"f"),rt(this,P,d.visible,"f"),rt(this,b,d.viewColumn,"f"),He(this,t,"f").fire({webviewPanel:this}))}reveal(d,u){this.assertNotDisposed(),He(this,I,"f").$reveal(He(this,i,"f"),{viewColumn:d?T.ViewColumn.from(d):void 0,preserveFocus:!!u})}assertNotDisposed(){if(He(this,f,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,c=new WeakMap,m=new WeakMap,h=new WeakMap,v=new WeakMap,_=new WeakMap,b=new WeakMap,P=new WeakMap,l=new WeakMap,f=new WeakMap,p=new WeakMap,t=new WeakMap;class o{constructor(d,u,w){this.webviews=u,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(d,u,w,E,r={}){const D=typeof E=="object"?E.viewColumn:E,L={viewColumn:T.ViewColumn.from(D),preserveFocus:typeof E=="object"&&!!E.preserveFocus},U=(0,y.shouldSerializeBuffersForPostMessage)(d),j=o.newHandle();this._proxy.$createWebviewPanel((0,y.toExtensionData)(d),j,u,{title:w,panelOptions:n(r),webviewOptions:(0,y.serializeWebviewOptions)(d,this.workspace,r),serializeBuffersForPostMessage:U},L);const te=this.webviews.createNewWebview(j,r,d);return this.createNewWebviewPanel(j,u,w,D,r,te)}$onDidChangeWebviewPanelViewStates(d){const u=Object.keys(d);u.sort((w,E)=>{const r=d[w],D=d[E];return r.active?1:D.active?-1:+r.visible-+D.visible});for(const w of u){const E=this.getWebviewPanel(w);if(!E)continue;const r=d[w];E._updateViewState({active:r.active,visible:r.visible,viewColumn:T.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,u,w){if(this._serializers.has(u))throw new Error(`Serializer for '${u}' already registered`);return this._serializers.set(u,{serializer:w,extension:d}),this._proxy.$registerSerializer(u,{serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(d)}),new A.Disposable(()=>{this._serializers.delete(u),this._proxy.$unregisterSerializer(u)})}async $deserializeWebviewPanel(d,u,w,E){const r=this._serializers.get(u);if(!r)throw new Error(`No serializer found for '${u}'`);const{serializer:D,extension:L}=r,U=this.webviews.createNewWebview(d,w.webviewOptions,L),j=this.createNewWebviewPanel(d,u,w.title,E,w.panelOptions,U);await D.deserializeWebviewPanel(j,w.state)}createNewWebviewPanel(d,u,w,E,r,D){const L=new s(d,this._proxy,u,w,E,r,D);return this._webviewPanels.set(d,L),L}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=o;function n(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},He=this&&this.__classPrivateFieldGet||function(Y,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(Y):R?R.value:e.get(Y)};define(me[258],ge([0,1,3,6,68,5,7]),function(Y,e,g,R,k,C,T){"use strict";var y,S,A,i,I,c,m,h,v,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends R.Disposable{constructor(f,p,t,s,o,n){super();y.set(this,void 0),S.set(this,void 0),A.set(this,void 0),i.set(this,void 0),I.set(this,!1),c.set(this,void 0),m.set(this,void 0),h.set(this,void 0),v.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=He(this,v,"f").event,_.set(this,this._register(new g.Emitter)),this.onDidDispose=He(this,_,"f").event,rt(this,A,t,"f"),rt(this,m,s,"f"),rt(this,y,f,"f"),rt(this,S,p,"f"),rt(this,i,o,"f"),rt(this,c,n,"f")}dispose(){He(this,I,"f")||(rt(this,I,!0,"f"),He(this,_,"f").fire(),He(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),He(this,m,"f")}set title(f){this.assertNotDisposed(),He(this,m,"f")!==f&&(rt(this,m,f,"f"),He(this,S,"f").$setWebviewViewTitle(He(this,y,"f"),f))}get description(){return this.assertNotDisposed(),He(this,h,"f")}set description(f){this.assertNotDisposed(),He(this,h,"f")!==f&&(rt(this,h,f,"f"),He(this,S,"f").$setWebviewViewDescription(He(this,y,"f"),f))}get visible(){return He(this,c,"f")}get webview(){return He(this,i,"f")}get viewType(){return He(this,A,"f")}_setVisible(f){f===He(this,c,"f")||He(this,I,"f")||(rt(this,c,f,"f"),He(this,v,"f").fire())}show(f){this.assertNotDisposed(),He(this,S,"f").$show(He(this,y,"f"),!!f)}assertNotDisposed(){if(He(this,I,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,S=new WeakMap,A=new WeakMap,i=new WeakMap,I=new WeakMap,c=new WeakMap,m=new WeakMap,h=new WeakMap,v=new WeakMap,_=new WeakMap;class P{constructor(f,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,p,t,s){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:f}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(f),p,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(f,p,t,s,o){const n=this._viewProviders.get(p);if(!n)throw new Error(`No view provider found for '${p}'`);const{provider:a,extension:d}=n,u=this._extHostWebview.createNewWebview(f,{},d),w=new b(f,this._proxy,p,t,u,!0);this._webviewViews.set(f,w),await a.resolveWebviewView(w,{state:s},o)}async $onDidChangeWebviewViewVisibility(f,p){this.getWebviewView(f)._setVisible(p)}async $disposeWebviewView(f){const p=this.getWebviewView(f);this._webviewViews.delete(f),p.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const p=this._webviewViews.get(f);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=P}),define(me[132],ge([0,1,3,5,2,10,9,4,13]),function(Y,e,g,R,k,C,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class Bn{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bn.InitialState,this._proxy=I.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,c){let m;if(typeof I=="string"){m=I;try{I=k.URI.parse(I)}catch(h){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,T.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,m,c)}async asExternalUri(I,c){if((0,T.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(I,c);return k.URI.from(m)}};A.InitialState={focused:!0},A=ze([xe(0,S.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,y.createDecorator)("IExtHostWindow")}),define(me[259],ge([0,1,8,79,32,44,6,5,2,13]),function(Y,e,g,R,k,C,T,y,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends T.Disposable{constructor(c,m){super();const h=c.getProxy(y.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async v=>{const _=S.URI.file((0,g.join)((0,R.tmpdir)(),(0,k.generateUuid)()));return await h.$download(v,_),_})}};i=ze([xe(0,A.IExtHostRpcService),xe(1,C.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(me[260],ge([0,1,2,8,151,28,66,27,13,6,12,115,42]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class m{constructor(b,P,l){this.name=b,this.file=P,this.appender=l}static async create(b,P){const l=await(0,I.createRotatingLogger)(b,P,30*c.ByteSize.MB,1);return l.clearFormatters(),new m(b,P,l)}append(b){this.appender.critical(b)}flush(){this.appender.flush()}}class h extends T.AbstractExtHostOutputChannel{constructor(b,P,l,f){super(b,!1,g.URI.file(P.file),l,f);this._appender=P}append(b){super.append(b),this._appender.append(b),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(b,P){this._appender.flush(),super.show(b,P)}clear(){this._appender.flush(),super.clear()}}let v=class extends T.ExtHostOutputService{constructor(b,P,l){super(b);this.logService=P,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new A.MutableDisposable,this._logsLocation=l.logsLocation}$setVisibleChannel(b){if(b){const P=this._channels.get(b);P&&(this._visibleChannelDisposable.value=P.onDidAppend(()=>P.update()))}}createOutputChannel(b,P){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const l=this._doCreateOutChannel(b,P);return l.then(f=>f._id.then(p=>this._channels.set(p,f))),new T.LazyOutputChannel(b,l)}async _doCreateOutChannel(b,P){try{const l=(0,R.join)(this._logsLocation.fsPath,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await C.SymlinkSupport.existsDirectory(l)||await C.Promises.mkdir(l,{recursive:!0});const p=`${this._namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=g.URI.file((0,R.join)(l,`${p}.log`)),s=await m.create(p,t.fsPath);return new h(b,s,P.identifier.value,this._proxy)}catch(l){return this.logService.error(l),new T.ExtHostPushOutputChannel(b,P.identifier.value,this._proxy)}}};v=ze([xe(0,S.IExtHostRpcService),xe(1,i.ILogService),xe(2,y.IExtHostInitDataService)],v),e.ExtHostOutputService2=v}),define(me[261],ge([0,1,49,292,2,67,6,10,17]),function(Y,e,g,R,k,C,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(p){const t=await super._getWorkspaceStorageURI(p);if(t.scheme!==y.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const s=t.fsPath;let o=0;do{let n;o===0?n=s:n=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${o}`:`${s}-${o}`,await i(n);const a=R.join(n,"vscode.lock"),d=await h(this._logService,a,!1);if(d)return this._workspaceStorageLock=d,process.on("exit",()=>{d.dispose()}),k.URI.file(n);o++}while(o<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function i(f){try{await g.promises.stat(f);return}catch{}try{await g.promises.mkdir(f,{recursive:!0})}catch{}}const I=1e3,c=10*60*1e3;class m extends T.Disposable{constructor(p,t){super();this.logService=p,this.filename=t,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await v(p,t);(!s||s.pid!==process.pid)&&(p.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.promises.utimes(t,new Date,new Date)}catch(o){p.error(o),p.info(`Lock '${t}': Could not update mtime.`)}},I)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(p){}}async setWillRelease(p){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${p} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+p};await g.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function h(f,p,t){try{const o={pid:process.pid,willReleaseAt:0};await g.promises.writeFile(p,JSON.stringify(o),{flag:"wx"})}catch(o){f.error(o)}const s=await v(f,p);return!s||s.pid!==process.pid?t?(f.info(`Lock '${p}': Could not acquire lock, giving up.`),null):(f.info(`Lock '${p}': Could not acquire lock, checking if the file is stale.`),P(f,p)):(f.info(`Lock '${p}': Lock acquired.`),new m(f,p))}async function v(f,p){let t;try{t=await g.promises.readFile(p)}catch(s){return f.error(s),null}try{return JSON.parse(String(t))}catch(s){return f.error(s),null}}async function _(f,p){let t;try{t=await g.promises.stat(p)}catch(s){return f.error(s),0}return t.mtime.getTime()}function b(f){try{return process.kill(f,0),!0}catch(p){return!1}}async function P(f,p){const t=await v(f,p);if(!t)return f.info(`Lock '${p}': Could not read pid of lock holder.`),l(f,p);if(t.willReleaseAt){let d=t.willReleaseAt-Date.now();if(d<5e3){for(d>0?f.info(`Lock '${p}': The lockfile is scheduled to be released in ${d} ms.`):f.info(`Lock '${p}': The lockfile is scheduled to have been released.`);d>0;){if(await(0,S.timeout)(Math.min(100,d)),await _(f,p)===0)return l(f,p);d=t.willReleaseAt-Date.now()}return l(f,p)}}if(!b(t.pid))return f.info(`Lock '${p}': The pid ${t.pid} appears to be gone.`),l(f,p);const s=await _(f,p),o=Date.now()-s;if(o<=c)return f.info(`Lock '${p}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;f.info(`Lock '${p}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const n=await _(f,p),a=Date.now()-n;return a<=c?(f.info(`Lock '${p}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(f.info(`Lock '${p}': The lock looks stale even after waiting for 2s.`),l(f,p))}async function l(f,p){f.info(`Lock '${p}': Deleting a stale lock.`);try{await g.promises.unlink(p)}catch(t){}return h(f,p,!0)}}),define(me[262],ge([0,1,32,13,33]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends k.BaseExtHostTerminalService{constructor(y){super(!0,y)}createTerminal(y,S,A){return this.createTerminalFromOptions({name:y,shellPath:S,shellArgs:A})}createTerminalFromOptions(y,S){const A=new k.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),y,y.name);return this._terminals.push(A),A.create(y,S),A.value}};C=ze([xe(0,R.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(me[263],ge([0,1,5,13,6,27,2,39,24,28,7,11,52,3,193,76,12]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(u,w,E){this.remoteAddress=u,this.localAddress=w,this._dispose=E,this._onDispose=new m.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function P(d){const u=d.trim().split(`
`),w=[];return u.forEach(r=>{const D=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(r);D&&D.length>=3&&w.push({pid:parseInt(D[1],10),socket:parseInt(D[2],10)})}),w.reduce((r,D)=>(r[D.socket]=D,r),{})}e.getSockets=P;function l(...d){const u=[].concat(...d.map(p));return[...new Map(u.filter(w=>w.st==="0A").map(w=>{const E=w.local_address.split(":");return{socket:parseInt(w.inode,10),ip:f(E[0]),port:parseInt(E[1],16)}}).map(w=>[w.ip+":"+w.port,w])).values()]}e.loadListeningPorts=l;function f(d){let u="";if(d.length===8)for(let w=d.length-2;w>=0;w-=2)u+=parseInt(d.substr(w,2),16),w!==0&&(u+=".");else for(let w=d.length-4;w>=0;w-=4)u+=parseInt(d.substr(w,4),16).toString(16),w!==0&&(u+=":");return u}e.parseIpAddress=f;function p(d){const u=d.trim().split(`
`),w=u.shift().trim().split(/\s+/).filter(r=>r!=="rx_queue"&&r!=="tm->when");return u.map(r=>r.trim().split(/\s+/).reduce((D,L,U)=>(D[w[U]||U]=L,D),{}))}e.loadConnectionTable=p;function t(d){return!!d.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||d.indexOf("out/vs/server/main.js")!==-1||d.indexOf("_productName=VSCode")!==-1}function s(d){const u=d.trim().split(`
`),w=[];return u.forEach(E=>{const r=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);r&&r.length>=4&&w.push({pid:parseInt(r[1],10),ppid:parseInt(r[2]),cmd:r[3]})}),w}e.getRootProcesses=s;async function o(d,u,w){const E=w.reduce((D,L)=>(D[L.pid]=L,D),{}),r=[];return d.forEach(({socket:D,ip:L,port:U})=>{const j=u[D]?u[D].pid:void 0,te=j?E[j]?.cmd:void 0;j&&te&&!t(te)&&r.push({host:L,port:U,detail:te,pid:j})}),r}e.findPorts=o;function n(d,u,w){const E=new Map,r=s(u);for(const D of d){const L=w.get(D.port);if(L){E.set(D.port,L);continue}const U=r.find(j=>j.cmd.includes(`${D.port}`));if(U){let j=U,te;do te=r.find(K=>K.ppid===j.pid),te&&(j=te);while(te);E.set(D.port,{host:D.ip,port:D.port,pid:j.pid,detail:j.cmd,ppid:j.ppid})}else E.set(D.port,{host:D.ip,port:D.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=n;let a=class extends k.Disposable{constructor(u,w,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new m.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=u.getProxy(g.MainContext.MainThreadTunnelService),I.isLinux&&w.remote.isRemote&&w.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(u,w){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${u.identifier.value} called openTunnel API for ${w.remoteAddress.host}:${w.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(w,u.displayName);if(E){const r=new b(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(r),r}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(u){return Math.max(u*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(u,w){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:u,provider:w}),this._proxy.$registerPortsAttributesProvider(u,E),new i.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(u,w,E,r,D){const L=[];for(const j of u){const te=this._portAttributesProviders.get(j);if(!te)return[];L.push(...await Promise.all(w.map(async K=>te.provider.providePortAttributes(K,E,r,D))))}const U=L.filter(j=>!!j);return U.length>0?U.map(j=>({autoForwardAction:j.autoForwardAction,port:j.port})):[]}async $registerCandidateFinder(u){if(u&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=u;let w=new v.MovingAverage,E;for(;this._candidateFindingEnabled;){const r=new Date().getTime(),D=(await this.findCandidatePorts()).filter(U=>(0,h.isLocalhost)(U.host)||(0,h.isAllInterfaces)(U.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${D.map(U=>U.port).join(", ")}`);const L=new Date().getTime()-r;w.update(L),(!E||JSON.stringify(E)!==JSON.stringify(D))&&(E=D,await this._proxy.$onFoundNewCandidates(E)),await new Promise(U=>setTimeout(()=>U(),this.calculateDelay(w.value)))}}async setTunnelExtensionFunctions(u){return u?(u.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(u.candidatePortSource),u.showCandidatePort&&(this._showCandidatePort=u.showCandidatePort,this._proxy.$setCandidateFilter()),u.tunnelFactory&&(this._forwardPortProvider=u.tunnelFactory,this._proxy.$setTunnelProvider(u.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,k.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(u,w){if(this._extensionTunnels.has(u.host)){const E=this._extensionTunnels.get(u.host);E.has(u.port)&&(w&&E.get(u.port).disposeListener.dispose(),await E.get(u.port).tunnel.dispose(),E.delete(u.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(u,w){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(u,w);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const r=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(u.remoteAddress.host)||this._extensionTunnels.set(u.remoteAddress.host,new Map);const D=this._register(r.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(r.remoteAddress))));return this._extensionTunnels.get(u.remoteAddress.host).set(u.remoteAddress.port,{tunnel:r,disposeListener:D}),c.TunnelDto.fromApiTunnel(r)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(u){const w=await Promise.all(u.map(r=>this._showCandidatePort(r.host,r.port,r.detail??""))),E=u.filter((r,D)=>w[D]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${u.map(r=>r.port).join(", ")} to ${E.map(r=>r.port).join(", ")}`),E}async findCandidatePorts(){let u="",w="";try{u=await A.Promises.readFile("/proc/net/tcp","utf8"),w=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const E=l(u,w),r=await new Promise(x=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,z,M)=>{x(z)})}),D=P(r),L=await A.Promises.readdir("/proc"),U=[];for(let x of L)try{const F=Number(x),z=S.joinPath(T.URI.file("/proc"),x);if((await A.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(F)){const N=await A.Promises.readlink(S.joinPath(z,"cwd").fsPath),V=await A.Promises.readFile(S.joinPath(z,"cmdline").fsPath,"utf8");U.push({pid:F,cwd:N,cmd:V})}}catch(F){}const j=[],te=E.filter(x=>{const F=D[x.socket];return F||j.push(x),F}),K=o(te,D,U);let O;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${j.length}`),j.length>0){const x=await new Promise(F=>{(0,y.exec)("ps -F -A -l | grep root",(z,M,N)=>{F(M)})});this._foundRootPorts=n(j,x,this._foundRootPorts),O=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${O.join(", ")}`)}return K.then(x=>O?x.concat(O):x)}};a=ze([xe(0,R.IExtHostRpcService),xe(1,C.IExtHostInitDataService),xe(2,_.ILogService)],a),e.ExtHostTunnelService=a}),define(me[264],ge([0,1,17,21,16,3,6,102,228,130,25]),function(Y,e,g,R,k,C,T,y,S,A,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function c(n,a){try{return JSON.stringify(n,a)}catch(d){return"null"}}function m(n,a){return JSON.stringify(n,a)}function h(n){return n?(a,d)=>d&&d.$mid===1?n.transformOutgoing(d):d:null}var v;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const b=()=>{},P=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class f extends T.Disposable{constructor(a,d=null,u=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new C.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=d,this._uriTransformer=u,this._uriReplacer=h(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,E=A.ProxyIdentifier.count;w<E;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,y.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:d,sid:u}=a;return this._proxies[d]||(this._proxies[d]=this._createProxy(d,u)),this._proxies[d]}_createProxy(a,d){let u={get:(w,E)=>(typeof E=="string"&&!w[E]&&E.charCodeAt(0)===36&&(w[E]=(...r)=>this._remoteCall(a,E,r)),E===l?d:w[E])};return new Proxy(Object.create(null),u)}set(a,d){return this._locals[a.nid]=d,d}assertRegistered(a){for(let d=0,u=a.length;d<u;d++){const w=a[d];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(a){if(this._isDisposed)return;const d=a.byteLength,u=p.read(a,0),w=u.readUInt8(),E=u.readUInt32();switch(w){case 1:case 2:{let{rpcId:r,method:D,args:L}=t.deserializeRequestJSONArgs(u);this._uriTransformer&&(L=(0,y.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(d,E,r,D,L,w===2);break}case 3:case 4:{let{rpcId:r,method:D,args:L}=t.deserializeRequestMixedArgs(u);this._uriTransformer&&(L=(0,y.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(d,E,r,D,L,w===4);break}case 5:{this._logger&&this._logger.logIncoming(d,E,0,"ack"),this._onDidReceiveAcknowledge(E);break}case 6:{this._receiveCancel(d,E);break}case 7:{this._receiveReply(d,E,void 0);break}case 9:{let r=t.deserializeReplyOKJSON(u);this._uriTransformer&&(r=(0,y.transformIncomingURIs)(r,this._uriTransformer)),this._receiveReply(d,E,r);break}case 8:{let r=t.deserializeReplyOKVSBuffer(u);this._receiveReply(d,E,r);break}case 10:{let r=t.deserializeReplyErrError(u);this._uriTransformer&&(r=(0,y.transformIncomingURIs)(r,this._uriTransformer)),this._receiveReplyErr(d,E,r);break}case 11:{this._receiveReplyErr(d,E,void 0);break}default:console.error("received unexpected message"),console.error(a)}}_receiveRequest(a,d,u,w,E,r){this._logger&&this._logger.logIncoming(a,d,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(u)}.${w}(`,E);const D=String(d);let L,U;if(r){const te=new R.CancellationTokenSource;E.push(te.token),L=this._invokeHandler(u,w,E),U=()=>te.cancel()}else L=this._invokeHandler(u,w,E),U=b;this._cancelInvokedHandlers[D]=U;const j=t.serializeAcknowledged(d);this._logger&&this._logger.logOutgoing(j.byteLength,d,1,"ack"),this._protocol.send(j),L.then(te=>{delete this._cancelInvokedHandlers[D];const K=t.serializeReplyOK(d,te,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,d,1,"reply:",te),this._protocol.send(K)},te=>{delete this._cancelInvokedHandlers[D];const K=t.serializeReplyErr(d,te);this._logger&&this._logger.logOutgoing(K.byteLength,d,1,"replyErr:",te),this._protocol.send(K)})}_receiveCancel(a,d){this._logger&&this._logger.logIncoming(a,d,1,"receiveCancel");const u=String(d);this._cancelInvokedHandlers[u]&&this._cancelInvokedHandlers[u]()}_receiveReply(a,d,u){this._logger&&this._logger.logIncoming(a,d,0,"receiveReply:",u);const w=String(d);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const E=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],E.resolveOk(u)}_receiveReplyErr(a,d,u){this._logger&&this._logger.logIncoming(a,d,0,"receiveReplyErr:",u);const w=String(d);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const E=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let r;u&&(u.$isError?(r=new Error,r.name=u.name,r.message=u.message,r.stack=u.stack):r=u),E.resolveErr(r)}_invokeHandler(a,d,u){try{return Promise.resolve(this._doInvokeHandler(a,d,u))}catch(w){return Promise.reject(w)}}_doInvokeHandler(a,d,u){const w=this._locals[a];if(!w)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(a));let E=w[d];if(typeof E!="function")throw new Error("Unknown method "+d+" on actor "+(0,A.getStringIdentifierForProxy)(a));return E.apply(w,u)}_remoteCall(a,d,u){if(this._isDisposed)return Promise.reject(k.canceled());let w=null;if(u.length>0&&R.CancellationToken.isCancellationToken(u[u.length-1])&&(w=u.pop()),w&&w.isCancellationRequested)return Promise.reject(k.canceled());const E=t.serializeRequestArguments(u,this._uriReplacer),r=++this._lastMessageId,D=String(r),L=new S.LazyPromise;w&&w.onCancellationRequested(()=>{const j=t.serializeCancel(r);this._logger&&this._logger.logOutgoing(j.byteLength,r,0,"cancel"),this._protocol.send(t.serializeCancel(r))}),this._pendingRPCReplies[D]=L,this._onWillSendRequest(r);const U=t.serializeRequest(r,a,d,E,!!w);return this._logger&&this._logger.logOutgoing(U.byteLength,r,0,`request: ${(0,A.getStringIdentifierForProxy)(a)}.${d}(`,u),this._protocol.send(U),L}}e.RPCProtocol=f,I=P,f.UNRESPONSIVE_TIME=3*1e3;class p{constructor(a,d){this._buff=a,this._offset=d}static alloc(a,d,u){let w=new p(i.VSBuffer.alloc(u+1+4),0);return w.writeUInt8(a),w.writeUInt32(d),w}static read(a,d){return new p(a,d)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const u=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,u}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const u=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,u}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const d=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,d}static sizeMixedArray(a,d){let u=0;u+=1;for(let w=0,E=a.length;w<E;w++){const r=a[w],D=d[w];switch(u+=1,D){case 1:u+=this.sizeLongString(r);break;case 2:u+=this.sizeVSBuffer(r);break;case 3:break}}return u}writeMixedArray(a,d){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let u=0,w=a.length;u<w;u++){const E=a[u];switch(d[u]){case 1:this.writeUInt8(1),this.writeLongString(E);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let d=new Array(a);for(let u=0;u<a;u++)switch(this.readUInt8()){case 1:d[u]=this.readLongString();break;case 2:d[u]=this.readVSBuffer();break;case 3:d[u]=void 0;break}return d}}class t{static _arrayContainsBufferOrUndefined(a){for(let d=0,u=a.length;d<u;d++)if(a[d]instanceof i.VSBuffer||typeof a[d]=="undefined")return!0;return!1}static serializeRequestArguments(a,d){if(this._arrayContainsBufferOrUndefined(a)){let u=[],w=[];for(let E=0,r=a.length;E<r;E++){const D=a[E];D instanceof i.VSBuffer?(u[E]=D,w[E]=2):typeof D=="undefined"?(u[E]=i.VSBuffer.alloc(0),w[E]=3):(u[E]=i.VSBuffer.fromString(m(D,d)),w[E]=1)}return{type:"mixed",args:u,argsType:w}}return{type:"simple",args:m(a,d)}}static serializeRequest(a,d,u,w,E){return w.type==="mixed"?this._requestMixedArgs(a,d,u,w.args,w.argsType,E):this._requestJSONArgs(a,d,u,w.args,E)}static _requestJSONArgs(a,d,u,w,E){const r=i.VSBuffer.fromString(u),D=i.VSBuffer.fromString(w);let L=0;L+=p.sizeUInt8(),L+=p.sizeShortString(r),L+=p.sizeLongString(D);let U=p.alloc(E?2:1,a,L);return U.writeUInt8(d),U.writeShortString(r),U.writeLongString(D),U.buffer}static deserializeRequestJSONArgs(a){const d=a.readUInt8(),u=a.readShortString(),w=a.readLongString();return{rpcId:d,method:u,args:JSON.parse(w)}}static _requestMixedArgs(a,d,u,w,E,r){const D=i.VSBuffer.fromString(u);let L=0;L+=p.sizeUInt8(),L+=p.sizeShortString(D),L+=p.sizeMixedArray(w,E);let U=p.alloc(r?4:3,a,L);return U.writeUInt8(d),U.writeShortString(D),U.writeMixedArray(w,E),U.buffer}static deserializeRequestMixedArgs(a){const d=a.readUInt8(),u=a.readShortString(),w=a.readMixedArray(),E=new Array(w.length);for(let r=0,D=w.length;r<D;r++){const L=w[r];typeof L=="string"?E[r]=JSON.parse(L):E[r]=L}return{rpcId:d,method:u,args:E}}static serializeAcknowledged(a){return p.alloc(5,a,0).buffer}static serializeCancel(a){return p.alloc(6,a,0).buffer}static serializeReplyOK(a,d,u){return typeof d=="undefined"?this._serializeReplyOKEmpty(a):d instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(a,d):this._serializeReplyOKJSON(a,c(d,u))}static _serializeReplyOKEmpty(a){return p.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,d){let u=0;u+=p.sizeVSBuffer(d);let w=p.alloc(8,a,u);return w.writeVSBuffer(d),w.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,d){const u=i.VSBuffer.fromString(d);let w=0;w+=p.sizeLongString(u);let E=p.alloc(9,a,w);return E.writeLongString(u),E.buffer}static deserializeReplyOKJSON(a){const d=a.readLongString();return JSON.parse(d)}static serializeReplyErr(a,d){return d?this._serializeReplyErrEror(a,d):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,d){const u=i.VSBuffer.fromString(c(k.transformErrorForSerialization(d),null));let w=0;w+=p.sizeLongString(u);let E=p.alloc(10,a,w);return E.writeLongString(u),E.buffer}static deserializeReplyErrError(a){const d=a.readLongString();return JSON.parse(d)}static _serializeReplyErrEmpty(a){return p.alloc(11,a,0).buffer}}var s;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(s||(s={}));var o;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(o||(o={}))}),define(me[265],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(me[266],ge([0,1,10,8,11,2,4,85,43,223,265]),function(Y,e,g,R,k,C,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,T.createDecorator)("pathService");let I=class $n{constructor(m,h,v,_){this.localUserHome=m,this.remoteAgentService=h,this.environmentService=v,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||k.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome||m})()}get defaultUriScheme(){return $n.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,h){if(m.remoteAuthority)return g.Schemas.vscodeRemote;const v=(0,y.getVirtualWorkspaceScheme)(h.getWorkspace());if(v)return v;const _=h.getWorkspace().folders[0];if(_)return _.uri.scheme;const b=h.getWorkspace().configuration;return b?b.scheme:g.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?R.win32:R.posix)}async fileURI(m){let h="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const _=m.indexOf("/",2);_===-1?(h=m.substring(2),m="/"):(h=m.substring(2,_),m=m.substring(_)||"/")}return C.URI.from({scheme:g.Schemas.file,authority:h,path:m,query:"",fragment:""})}};I=ze([xe(1,i.IRemoteAgentService),xe(2,A.IWorkbenchEnvironmentService),xe(3,S.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(me[69],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(T,y){this.line=T,this.character=y}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,y){return new g(0,0)}with(T){return new g(0,0)}}e.Position=g;class R{constructor(T,y,S,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(T,y),this.end=new g(S,A)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new R(0,0,0,0)}with(T){return new R(0,0,0,0)}}e.Range=R;var k;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,20,30,22,29,9,4,8,16,69]),function(Y,e,g,R,k,C,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",c=" characters skipped \u27EB",m=(I.length+c.length+5)*2;e.ISearchService=(0,y.createDecorator)("searchService");var h;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function _(F){return!!F.preview}e.resultIsMatch=_;function b(F){return!!F.resource}e.isFileMatch=b;function P(F){return!!F.message}e.isProgressMessage=P;var l;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=f;class p{constructor(z,M,N){this.ranges=M;const V=Array.isArray(M)?M:[M];if(N&&N.matchLines===1&&t(V)){z=(0,T.getNLines)(z,N.matchLines);let $="",G=0,J=0;const fe=Math.floor(N.charsPerLine/5),ye=[];for(const ke of V){const Re=Math.max(ke.startColumn-fe,0),Ve=ke.startColumn+N.charsPerLine;if(Re>J+fe+m){const Be=I+(Re-J)+c;$+=Be+z.slice(Re,Ve),G+=Re-(J+Be.length)}else $+=z.slice(J,Ve);ye.push(new o(0,ke.startColumn-G,ke.endColumn-G)),J=Ve}this.preview={text:$,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const $=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:z,matches:(0,g.mapArrayOrNot)(M,G=>new s(G.startLineNumber-$,G.startColumn,G.endLineNumber-$,G.endColumn))}}}}e.TextSearchMatch=p;function t(F){const z=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==z||M.endLineNumber!==z)return!1;return!0}class s{constructor(z,M,N,V){this.startLineNumber=z,this.startColumn=M,this.endLineNumber=N,this.endColumn=V}}e.SearchRange=s;class o extends s{constructor(z,M,N){super(z,M,z,N)}}e.OneLineRange=o;var n;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function a(F,z=!0){const M=F&&F.files&&F.files.exclude,N=z&&F&&F.search&&F.search.exclude;if(!M&&!N)return;if(!M||!N)return M||N;let V=Object.create(null);return V=k.mixin(V,k.deepClone(M)),V=k.mixin(V,k.deepClone(N),!0),V}e.getExcludes=a;function d(F,z){return F.excludePattern&&R.match(F.excludePattern,z)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&R.match(F.includePattern,z)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const N=M.folder.fsPath;if(C.isEqualOrParent(z,N)){const V=S.relative(N,z);return!M.includePattern||!!R.match(M.includePattern,V)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var u;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(u=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(z,M){super(z);this.code=M}}e.SearchError=w;function E(F){const z=F.message;if((0,A.isPromiseCanceledError)(F))return new w(z,u.canceled);try{const M=JSON.parse(z);return new w(M.message,M.code)}catch(M){return new w(z,u.other)}}e.deserializeSearchError=E;function r(F){const z={message:F.message,code:F.code};return new Error(JSON.stringify(z))}e.serializeSearchError=r;function D(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=D;function L(F){return F.type==="success"}e.isSerializedSearchSuccess=L;function U(F){return!!F.path}e.isSerializedFileMatch=U;function j(F,z){const M=F.searchPath?F.searchPath:F.relativePath;return(0,T.fuzzyContains)(M,z)}e.isFilePatternMatch=j;class te{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=te;function K(F,z){const M={...F||{},...z||{}};return Object.keys(M).filter(N=>{const V=M[N];return typeof V=="boolean"&&V})}e.resolvePatternsForProvider=K;class O{constructor(z,M){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...M.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let N=z.includePattern;M.includePattern&&(N?N={...N,...M.includePattern}:N=M.includePattern),N&&(this._parsedIncludeExpression=R.parse(N))}includedInQuerySync(z,M,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,M,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,M,N))}includedInQuery(z,M,N){return Promise.resolve(this._parsedExcludeExpression(z,M,N)).then($=>!!$).then($=>$?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(z,M,N)).then(G=>!!G):Promise.resolve(!0)).then($=>$)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=O;function x(F){for(const z in F)if(typeof F[z]!="boolean")return!0;return!1}}),define(me[36],ge([0,1,20,17,21,3,23,10,76,24,9,14,2,169,4,12,189,43,63,27,13,7,31,5]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b,P,l,f,p,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(D,L,U){return new A.ExtUri(j=>u(j,U)).isEqual(D,L)}function n(D,L,U){return o(D.uri,L.uri,U)?0:(0,i.compare)(D.uri.toString(),L.uri.toString())}function a(D,L,U){return D.index!==L.index?D.index<L.index?-1:1:o(D.uri,L.uri,U)?(0,i.compare)(D.name,L.name):(0,i.compare)(D.uri.toString(),L.uri.toString())}function d(D,L,U,j){const te=D.slice(0).sort((O,x)=>U(O,x,j)),K=L.slice(0).sort((O,x)=>U(O,x,j));return(0,g.delta)(te,K,(O,x)=>U(O,x,j))}function u(D,L){const U=L.getCapabilities(D.scheme);return!(U&&U&1024)}class w extends b.Workspace{constructor(L,U,j,te,K,O){super(L,j.map(x=>new b.WorkspaceFolder(x)),te,O);this._name=U,this._isUntitled=K,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(O),j.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(L,U,j,te){if(!L)return{workspace:null,added:[],removed:[]};const{id:K,name:O,folders:x,configuration:F,isUntitled:z}=L,M=[],N=U;U?x.forEach((J,fe)=>{const ye=c.URI.revive(J.uri),ke=w._findFolder(j||U,ye,te);ke?(ke.name=J.name,ke.index=J.index,M.push(ke)):M.push({uri:ye,name:J.name,index:fe})}):M.push(...x.map(({uri:J,name:fe,index:ye})=>({uri:c.URI.revive(J),name:fe,index:ye}))),M.sort((J,fe)=>J.index<fe.index?-1:1);const V=new w(K,O,M,F?c.URI.revive(F):null,!!z,J=>u(J,te)),{added:$,removed:G}=d(N?N.workspaceFolders:[],V.workspaceFolders,n,te);return{workspace:V,added:$,removed:G}}static _findFolder(L,U,j){for(let te=0;te<L.folders.length;te++){const K=L.workspaceFolders[te];if(o(K.uri,U,j))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,U){return U&&this._structure.get(L)&&(L=(0,A.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let E=class{constructor(L,U,j,te){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=te,this._extHostFileSystemInfo=j,this._requestIdProvider=new S.Counter,this._barrier=new R.Barrier,this._proxy=L.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(s.MainContext.MainThreadMessageService);const K=U.workspace;this._confirmedWorkspace=K?new w(K.id,K.name,[],K.configuration?c.URI.revive(K.configuration):null,!!K.isUntitled,O=>u(O,j)):void 0}$initializeWorkspace(L,U){this._trusted=U,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:y.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,U,j,...te){const K=[];if(Array.isArray(te)&&te.forEach(M=>{c.URI.isUri(M.uri)&&!K.some(N=>o(N.uri,M.uri,this._extHostFileSystemInfo))&&K.push({uri:M.uri,name:M.name||(0,A.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[U,j].some(M=>typeof M!="number"||M<0)||j===0&&K.length===0)return!1;const O=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+j>O.length)return!1;const x=O.slice(0);x.splice(U,j,...K.map(M=>({uri:M.uri,name:M.name||(0,A.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<x.length;M++){const N=x[M];if(x.some((V,$)=>$!==M&&o(N.uri,V.uri,this._extHostFileSystemInfo)))return!1}x.forEach((M,N)=>M.index=N);const{added:F,removed:z}=d(O,x,a,this._extHostFileSystemInfo);if(F.length===0&&z.length===0)return!1;if(this._proxy){const M=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(M,U,j,K).then(void 0,N=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,m.localize)(0,null,M,N.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(L,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,U)}async getWorkspaceFolder2(L,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,U)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,U){let j,te="";if(typeof L=="string"?(j=c.URI.file(L),te=L):typeof L!="undefined"&&(j=L,te=L.fsPath),!j)return te;const K=this.getWorkspaceFolder(j,!0);if(!K)return te;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let O=(0,A.relativePath)(K.uri,j);return U&&K.name&&(O=`${K.name}/${O}`),O}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:U,added:j,removed:te}=w.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:j,removed:te}))}findFiles(L,U,j,te,K=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${te.value}, entryPoint: findFiles`);let O;if(U===null?O=!1:U&&(typeof U=="string"?O=U:O=U.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:F}=r(L);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(x),(0,I.withUndefinedAsNull)(F),(0,I.withUndefinedAsNull)(O),(0,I.withUndefinedAsNull)(j),K).then(z=>Array.isArray(z)?z.map(M=>c.URI.revive(M)):[])}async findTextInFiles(L,U,j,te,K=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${te.value}, entryPoint: findTextInFiles`);const O=this._requestIdProvider.getNext(),x=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:F,folder:z}=r(U.include),M=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,N={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:x,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:F,excludePattern:M},V=!1;if(this._activeSearchCallbacks[O]=$=>{if(V)return;const G=c.URI.revive($.resource);$.results.forEach(J=>{(0,t.resultIsMatch)(J)?j({uri:G,preview:{text:J.preview.text,matches:(0,g.mapArrayOrNot)(J.preview.matches,fe=>new p.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))},ranges:(0,g.mapArrayOrNot)(J.ranges,fe=>new p.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))}):j({uri:G,text:J.text,lineNumber:J.lineNumber})})},K.isCancellationRequested)return{};try{const $=await this._proxy.$startTextSearch(L,(0,I.withUndefinedAsNull)(z),N,O,K);return delete this._activeSearchCallbacks[O],$||{}}catch($){throw delete this._activeSearchCallbacks[O],$}}$handleTextSearchResult(L,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=ze([xe(0,f.IExtHostRpcService),xe(1,l.IExtHostInitDataService),xe(2,P.IExtHostFileSystemInfo),xe(3,v.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function r(D){let L,U;return D&&(typeof D=="string"?L=D:(L=D.pattern,U=D.baseFolder||c.URI.file(D.base))),{includePattern:L,folder:U}}}),define(me[37],ge([0,1,22,3,36,5,7,192,84,14,17,4,13,12,2]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(s,o){if(o){const n=o.split(".");let a=s;for(let d=0;a&&d<n.length;d++)a=a[n[d]];return a}}function _(s){return s instanceof h.URI}function b(s){return s&&s.uri instanceof h.URI&&s.languageId&&typeof s.languageId=="string"}function P(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function l(s){return s&&s.uri instanceof h.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function f(s){if(_(s))return{resource:s};if(b(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(P(s))return{overrideIdentifier:s.languageId};if(l(s))return{resource:s.uri};if(s===null)return{resource:null}}let p=class{constructor(o,n,a){this._proxy=o.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=a,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,n){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(o,n))}};p=ze([xe(0,c.IExtHostRpcService),xe(1,k.IExtHostWorkspace),xe(2,m.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(o,n,a,d){this._onDidChangeConfiguration=new R.Emitter,this._proxy=o,this._logService=d,this._extHostWorkspace=n,this._configuration=y.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,n){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=y.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,a))}getConfiguration(o,n,a){const d=f(n)||{},u=this._toReadonlyValue(o?v(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,d,a?.identifier);function w(r){if(r==null)return null;if(typeof r=="boolean")return r?1:4;switch(r){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const E={has(r){return typeof v(u,r)!="undefined"},get:(r,D)=>{this._validateConfigurationAccess(o?`${o}.${r}`:r,d,a?.identifier);let L=v(u,r);if(typeof L=="undefined")L=D;else{let U;const j=(te,K)=>{let O;const x=()=>{U=U||(0,g.deepClone)(u),O=O||v(U,K)};return(0,A.isObject)(te)?new Proxy(te,{get:(F,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return x(),()=>O;if(U)return O=O||v(U,K),O[z];const M=F[z];return typeof z=="string"?j(M,`${K}.${z}`):M},set:(F,z,M)=>(x(),O&&(O[z]=M),!0),deleteProperty:(F,z)=>(x(),O&&delete O[z],!0),defineProperty:(F,z,M)=>(x(),O&&Object.defineProperty(O,z,M),!0)}):te};L=j(L,r)}return L},update:(r,D,L,U)=>{r=o?`${o}.${r}`:r;const j=w(L);return D!==void 0?this._proxy.$updateConfigurationOption(j,r,D,d,U):this._proxy.$removeConfigurationOption(j,r,d,U)},inspect:r=>{r=o?`${o}.${r}`:r;const D=(0,g.deepClone)(this._configuration.inspect(r,d,this._extHostWorkspace.workspace));if(D)return{key:r,defaultValue:D.default?.value,globalValue:D.user?.value,workspaceValue:D.workspace?.value,workspaceFolderValue:D.workspaceFolder?.value,defaultLanguageValue:D.default?.override,globalLanguageValue:D.user?.override,workspaceLanguageValue:D.workspace?.override,workspaceFolderLanguageValue:D.workspaceFolder?.override,languageIds:D.overrideIdentifiers}}};return typeof u=="object"&&(0,g.mixin)(E,u,!1),Object.freeze(E)}_toReadonlyValue(o){const n=a=>(0,A.isObject)(a)?new Proxy(a,{get:(d,u)=>n(d[u]),set:(d,u,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(d,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(d,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return n(o)}_validateConfigurationAccess(o,n,a){const d=S.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),u=a?`[${a.value}] `:"";if(d===4){typeof n?.resource=="undefined"&&this._logService.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){n?.resource&&this._logService.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,n){const a=new y.ConfigurationChangeEvent(o,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,u)=>a.affectsConfiguration(d,f(u))})}_toMap(o){return o.reduce((n,a)=>(n.set(a[0],a[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},He=this&&this.__classPrivateFieldGet||function(Y,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(Y):R?R.value:e.get(Y)};define(me[70],ge([0,1,2,17,3,5,22,7,36,45,37,21,33,13,27,4,10,11,12,65,213,16]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b,P,l,f,p){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function(O){function x(z){if(z!=null)return z}O.from=x;function F(z){if(z!=null)return z}O.to=F})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var o;(function(O){function x(z){if(z!=null)return z}O.from=x;function F(z){if(z!=null)return z}O.to=F})(o=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(O){function x(z){if(z!=null)return z}O.from=x;function F(z){if(z!=null)return z}O.to=F})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(O){function x(M){if(M){const N=M;return N&&!!N.process}else return!1}O.is=x;function F(M){if(M==null)return;const N={process:M.process,args:M.args};return M.options&&(N.options=n.from(M.options)),N}O.from=F;function z(M){if(M!=null)return new y.ProcessExecution(M.process,M.args,M.options)}O.to=z})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var d;(function(O){function x(z){if(z!=null)return z}O.from=x;function F(z){if(z!=null)return z}O.to=F})(d=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(O){function x(M){if(M){const N=M;return N&&(!!N.commandLine||!!N.command)}else return!1}O.is=x;function F(M){if(M==null)return;const N={};return M.commandLine!==void 0?N.commandLine=M.commandLine:(N.command=M.command,N.args=M.args),M.options&&(N.options=d.from(M.options)),N}O.from=F;function z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new y.ShellExecution(M.commandLine,M.options):new y.ShellExecution(M.command,M.args?M.args:[],M.options)}O.to=z})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var w;(function(O){function x(M){if(M){let N=M;return N&&N.customExecution==="customExecution"}else return!1}O.is=x;function F(M){return{customExecution:"customExecution"}}O.from=F;function z(M,N){return N.get(M)}O.to=z})(w=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(O){function x(F,z){let M;return F.scope!==void 0&&typeof F.scope!="number"?M=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===y.TaskScope.Workspace&&z&&z.workspaceFile?M=z.workspaceFile:M=f.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:M}}O.from=x})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var r;(function(O){function x(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}O.from=x})(r=e.TaskGroupDTO||(e.TaskGroupDTO={}));var D;(function(O){function x(M,N){if(M==null)return[];const V=[];for(let $ of M){const G=F($,N);G&&V.push(G)}return V}O.fromMany=x;function F(M,N){if(M==null)return;let V;M.execution instanceof y.ProcessExecution?V=a.from(M.execution):M.execution instanceof y.ShellExecution?V=u.from(M.execution):M.execution&&M.execution instanceof y.CustomExecution&&(V=w.from(M.execution));const $=s.from(M.definition);let G;return M.scope?typeof M.scope=="number"?G=M.scope:G=M.scope.uri:G=y.TaskScope.Workspace,!$||!G?void 0:{_id:M._id,definition:$,name:M.name,source:{extensionId:N.identifier.value,label:M.source,scope:G},execution:V,isBackground:M.isBackground,group:r.from(M.group),presentationOptions:o.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}O.from=F;async function z(M,N,V){if(M==null)return;let $;a.is(M.execution)?$=a.to(M.execution):u.is(M.execution)?$=u.to(M.execution):w.is(M.execution)&&($=w.to(M._id,V));const G=s.to(M.definition);let J;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?J=M.source.scope:J=await N.resolveWorkspaceFolder(g.URI.revive(M.source.scope)):J=y.TaskScope.Workspace),!G||!J)return;const fe=new y.Task(G,J,M.name,M.source.label,$,M.problemMatchers);return M.isBackground!==void 0&&(fe.isBackground=M.isBackground),M.group!==void 0&&(fe.group=y.TaskGroup.from(M.group._id),fe.group&&(fe.group=T.deepClone(fe.group),M.group.isDefault&&(fe.group.isDefault=M.group.isDefault))),M.presentationOptions&&(fe.presentationOptions=o.to(M.presentationOptions)),M._id&&(fe._id=M._id),M.detail&&(fe.detail=M.detail),fe}O.to=z})(D=e.TaskDTO||(e.TaskDTO={}));var L;(function(O){function x(z){return z}O.from=x;function F(z){if(!!z)return Object.assign(Object.create(null),z)}O.to=F})(L=e.TaskFilterDTO||(e.TaskFilterDTO={}));class U{constructor(x,F,z){this._id=F,this._task=z,t.set(this,void 0),rt(this,t,x,"f")}get task(){return this._task}terminate(){He(this,t,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}t=new WeakMap;var j;(function(O){function x(F){return{id:F._id,task:void 0}}O.from=x})(j=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let te=class{constructor(x,F,z,M,N,V,$,G){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=x.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=M,this._configurationService=N,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,F,z){if(!z)return new y.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:F,provider:z,extension:x}),this._proxy.$registerTaskProvider(M,F),new y.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(x,F){this._proxy.$registerTaskSystem(x,F)}fetchTasks(x){return this._proxy.$fetchTasks(L.from(x)).then(async F=>{const z=[];for(let M of F){const N=await D.to(M,this._workspaceProvider,this._providedCustomExecutions2);N&&z.push(N)}return z})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(F=>x.push(F)),x}terminateTask(x){if(!(x instanceof U))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,F,z){const M=this._providedCustomExecutions2.get(x.id);if(M){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,M),this._terminalService.attachPtyToTerminal(F,await M.callback(z))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const F=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:F})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const F=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:F,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const F=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:F,exitCode:x.exitCode})}$provideTasks(x,F){const z=this._handlers.get(x);if(!z)return Promise.reject(new Error("no handler found"));const M=[],N=(0,R.asPromise)(()=>z.provider.provideTasks(I.CancellationToken.None)).then(V=>this.provideTasksInternal(F,M,z,V));return new Promise(V=>{N.then($=>{Promise.all(M).then(()=>{V($)})})})}async $resolveTask(x,F){const z=this._handlers.get(x);if(!z)return Promise.reject(new Error("no handler found"));if(F.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${z.type}].`);const M=await D.to(F,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const N=await z.provider.resolveTask(M,I.CancellationToken.None);if(!N)return;this.checkDeprecation(N,z);const V=D.from(N,z.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(V.execution)&&await this.addCustomExecution(V,N,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,F,z){const M=await this._proxy.$createTaskId(x);!z&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,F.execution)}async getTaskExecution(x,F){if(typeof x=="string"){const N=this._taskExecutionPromises.get(x);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let z=this._taskExecutionPromises.get(x.id);if(z)return z;const M=new Promise(async(N,V)=>{const $=F||await D.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);$?N(new U(this,x.id,$)):V("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,M),M.then(N=>(this._taskExecutions.set(x.id,N),N),N=>Promise.reject(N))}checkDeprecation(x,F){x._deprecated&&this._deprecationService.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let z=this._notProvidedCustomExecutions.values(),M=z.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=z.next()}};te=ze([xe(0,m.IExtHostRpcService),xe(1,h.IExtHostInitDataService),xe(2,S.IExtHostWorkspace),xe(3,A.IExtHostDocumentsAndEditors),xe(4,i.IExtHostConfiguration),xe(5,c.IExtHostTerminalService),xe(6,P.ILogService),xe(7,l.IExtHostApiDeprecationService)],te),e.ExtHostTaskBase=te;let K=class extends te{constructor(x,F,z,M,N,V,$,G){super(x,F,z,M,N,V,$,G);this.registerTaskSystem(_.Schemas.vscodeRemote,{scheme:_.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(x,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const z=D.from(F,x);if(z===void 0)throw new Error("Task is not valid");if(w.is(z.execution))await this.addCustomExecution(z,F,!1);else throw new p.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),F);return this._proxy.$executeTask(z).catch(N=>{throw new Error(N)}),M}provideTasksInternal(x,F,z,M){const N=[];if(M)for(let V of M){this.checkDeprecation(V,z),(!V.definition||!x[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const $=D.from(V,z.extension);$&&w.is($.execution)?(N.push($),F.push(this.addCustomExecution($,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:z.extension}}async resolveTaskInternal(x){if(w.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,F,z){}};K=ze([xe(0,m.IExtHostRpcService),xe(1,h.IExtHostInitDataService),xe(2,S.IExtHostWorkspace),xe(3,A.IExtHostDocumentsAndEditors),xe(4,i.IExtHostConfiguration),xe(5,c.IExtHostTerminalService),xe(6,P.ILogService),xe(7,l.IExtHostApiDeprecationService)],K),e.WorkerExtHostTask=K,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(me[267],ge([0,1,20,55,30,78,23,10,8,24,9,14,2,145,175,119,43,127,266,31]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(w,E,r,D){this.configurationService=w,this.workspaceContextService=E,this.editorGroupsService=r,this.pathService=D}text(w,E,r={}){w=this.getContentPattern(w,r);const D=this.configurationService.getValue(),L=E&&E.some(j=>!this.configurationService.getValue({resource:j}).search.useRipgrep);return{...this.commonQuery(E?.map(_.toWorkspaceFolder),r),type:2,contentPattern:w,previewOptions:r.previewOptions,maxFileSize:r.maxFileSize,usePCRE2:D.search.usePCRE2||L||!1,beforeContext:r.beforeContext,afterContext:r.afterContext,userDisabledExcludesAndIgnoreFiles:r.disregardExcludeSettings&&r.disregardIgnoreFiles}}getContentPattern(w,E){const r=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const D={...w,wordSeparators:r.editor.wordSeparators};return this.isCaseSensitive(w,E)&&(D.isCaseSensitive=!0),this.isMultiline(w)&&(D.isMultiline=!0),D}file(w,E={}){return{...this.commonQuery(w,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(w,E){return w?(w=Array.isArray(w)?w.map(n):n(w),E?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],E={}){const r=this.handleIncludeExclude(E.includePattern,E.expandPatterns),D=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),L=w.length>1,U=(r.searchPaths&&r.searchPaths.length?r.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,E,D)):w.map(K=>this.getFolderQueryForRoot(K,E,D,L))).filter(K=>!!K),j={_reason:E._reason,folderQueries:U,usingSearchPaths:!!(r.searchPaths&&r.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:D.pattern,includePattern:r.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const O=g.coalesce(g.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(z=>z.resource)))).filter(F=>(0,l.pathIncludedInQuery)(j,F.fsPath)),x=this.commonQueryFromFileList(O);return{...j,...x}}const te=E.extraFileResources&&E.extraFileResources.filter(K=>(0,l.pathIncludedInQuery)(j,K.fsPath));return j.extraFileResources=te&&te.length?te:void 0,j}commonQueryFromFileList(w){const E=[],r=new T.ResourceMap,D={};let L=!1;return w.forEach(U=>{if(U.scheme===y.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(U)){const te=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:S.dirname(U.fsPath)});let K=r.get(te);K||(L=!0,K={folder:te,includePattern:{}},E.push(K),r.set(te,K));const O=S.relative(te.fsPath,U.fsPath);(0,I.assertIsDefined)(K.includePattern)[O.replace(/\\/g,"/")]=!0}else U.fsPath&&(L=!0,D[U.fsPath]=!0)}),{folderQueries:E,includePattern:D,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(w,E){if(E.isSmartCase){if(w.isRegExp){if(i.containsUppercaseCharacter(w.pattern,!0))return!0}else if(i.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,m.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const E=x=>S.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),D=(Array.isArray(w)?w:s(w)).map(x=>{const F=this.pathService.resolvedUserHome;return F?(0,C.untildify)(x,F.scheme===y.Schemas.file?F.fsPath:F.path):x}),L=R.groupBy(D,x=>E(x)?"searchPaths":"exprSegments"),U=(L.exprSegments||[]).map(x=>i.rtrim(x,"/")).map(x=>i.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),o(x))),j={},te=this.expandSearchPathPatterns(L.searchPaths||[]);te&&te.length&&(j.searchPaths=te);const K=g.flatten(U),O=t(...K);return O&&(j.pattern=O),j}getExcludesForFolder(w,E){return E.disregardExcludeSettings?void 0:(0,l.getExcludes)(w,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const E=g.flatten(w.map(D=>{let{pathPortion:L,globPortion:U}=p(D);U&&(U=a(U));const j=this.expandOneSearchPath(L);return g.flatten(j.map(te=>this.resolveOneSearchPathPattern(te,U)))})),r=new Map;return E.forEach(D=>{const L=D.searchPath.toString(),U=r.get(L);U?D.pattern&&(U.pattern=U.pattern||{},U.pattern[D.pattern]=!0):r.set(L,{searchPath:D.searchPath,pattern:D.pattern?t(D.pattern):void 0})}),Array.from(r.values())}expandOneSearchPath(w){if(S.isAbsolute(w)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==y.Schemas.file?[{searchPath:E[0].uri.with({path:w})}]:[{searchPath:c.URI.file(S.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=n(w),w.startsWith("../")||w===".."){const D=S.posix.resolve(E.path,w);return[{searchPath:E.with({path:D})}]}const r=a(w);return[{searchPath:E,pattern:r}]}else{if(w==="./"||w===".\\")return[];{const E=w.replace(/^\.[\/\\]/,""),D=this.workspaceContextService.getWorkspace().folders.map(L=>{const U=E.match(new RegExp(`^${i.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return U?{match:U,folder:L}:null}).filter(I.isDefined);if(D.length)return D.map(L=>{const U=L.match[1];return{searchPath:L.folder.uri,pattern:U&&a(U)}});{const L=w.match(/\.[\/\\](.+)[\/\\]?/),U=L?L[1]:w,j=h.localize(0,null,U);throw new Error(j)}}}}resolveOneSearchPathPattern(w,E){const r=w.pattern&&E?`${w.pattern}/${E}`:w.pattern||E,D=[{searchPath:w.searchPath,pattern:r}];return r&&!r.endsWith("**")&&D.push({searchPath:w.searchPath,pattern:r+"/**"}),D}getFolderQueryForSearchPath(w,E,r){const D=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(w.searchPath),E,r,!1);return D?{...D,includePattern:w.pattern}:null}getFolderQueryForRoot(w,E,r,D){let L;const U=c.URI.isUri(w)?w:w.uri;if(r.searchPaths){const x=r.searchPaths.filter(F=>(0,A.isEqual)(F.searchPath,U))[0];if(x&&!x.pattern)return null;x&&(L=x.pattern)}const j=this.configurationService.getValue({resource:U}),K={...this.getExcludesForFolder(j,E)||{},...L||{}},O=c.URI.isUri(w)?(0,A.basename)(w):w.name;return{folder:U,folderName:D?O:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!j.search.followSymlinks}}};f=ze([xe(0,v.IConfigurationService),xe(1,_.IWorkspaceContextService),xe(2,b.IEditorGroupsService),xe(3,P.IPathService)],f),e.QueryBuilder=f;function p(u){const w=u.match(/[\*\{\}\(\)\[\]\?]/);if(w){const E=w.index,r=u.substr(0,E).match(/[/|\\][^/\\]*$/);if(r){let D=u.substr(0,r.index);return D.match(/[/\\]/)||(D+="/"),{pathPortion:D,globPortion:u.substr((r.index||0)+1)}}}return{pathPortion:u}}function t(...u){return u.length?u.reduce((w,E)=>(w[E]=!0,w),Object.create(null)):void 0}function s(u){return k.splitGlobAware(u,",").map(w=>w.trim()).filter(w=>!!w.length)}function o(u){return[`**/${u}/**`,`**/${u}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function n(u){return u.replace(/\\/g,"/")}function a(u){return n(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(u,w){u=g.distinct(u,D=>D.toString());const E=[],r=w.getWorkspace();return u&&u.forEach(D=>{let L;if(w.getWorkbenchState()===2)L=(0,A.relativePath)(r.folders[0].uri,D),L&&L!=="."&&(L="./"+L);else{const U=w.getWorkspaceFolder(D);if(U){const j=U.name;if(r.folders.filter(K=>K.name===j).length===1){const K=(0,A.relativePath)(U.uri,D);K===""?L=`./${U.name}`:L=`./${U.name}/${K}`}else L=D.fsPath}}L&&E.push(L)}),E}e.resolveResourcesForSearchIncludes=d}),define(me[268],ge([0,1,24,2,21,16,4,267,31,43]),function(Y,e,g,R,k,C,T,y,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(v,_){const b=_.activationEvents;if(!b)return Promise.resolve(void 0);const P=[],l=[];for(const n of b)if(/^workspaceContains:/.test(n)){const a=n.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||v.forceUsingSearch?l.push(a):P.push(a)}if(P.length===0&&l.length===0)return Promise.resolve(void 0);let f;const p=new Promise((n,a)=>{f=n}),t=n=>f({activationEvent:n}),s=Promise.all(P.map(n=>c(v,n,t))).then(()=>{}),o=m(v,_.identifier,l,t);return Promise.all([s,o]).then(()=>{f(void 0)}),p}e.checkActivateWorkspaceContainsExtension=I;async function c(v,_,b){for(const P of v.folders)if(await v.exists(g.joinPath(R.URI.revive(P),_))){b(`workspaceContains:${_}`);return}}async function m(v,_,b,P){if(b.length===0)return Promise.resolve(void 0);const l=new k.CancellationTokenSource,f=v.checkExists(v.folders,b,l.token),p=setTimeout(async()=>{l.cancel(),P(`workspaceContainsTimeout:${b.join(",")}`)},i);let t=!1;try{t=await f}catch(s){C.isPromiseCanceledError(s)||C.onUnexpectedError(s)}l.dispose(),clearTimeout(p),t&&P(`workspaceContains:${b.join(",")}`)}function h(v,_,b,P){const l=v.get(T.IInstantiationService),f=v.get(S.ISearchService),t=l.createInstance(y.QueryBuilder).file(_.map(s=>(0,A.toWorkspaceFolder)(R.URI.revive(s))),{_reason:"checkExists",includePattern:b,exists:!0});return f.fileSearch(t,P).then(s=>!!s.limitHit,s=>C.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=h});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Y,g):k?k.value=g:e.set(Y,g),g},He=this&&this.__classPrivateFieldGet||function(Y,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(Y):R?R.value:e.get(Y)};define(me[40],ge([0,1,164,8,71,24,17,6,23,2,12,5,37,226,92,36,35,224,16,26,25,199,7,120,4,27,67,13,83,52,33,3,268,90,201]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b,P,l,f,p,t,s,o,n,a,d,u,w,E,r,D,L,U){"use strict";var j,te,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let O=class Wn extends y.Disposable{constructor(M,N,V,$,G,J,fe,ye,ke,Re){super();this._onDidChangeRemoteConnectionData=this._register(new r.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=N,this._extHostContext=V,this._initData=fe,this._extHostWorkspace=$,this._extHostConfiguration=G,this._logService=J,this._extHostTunnelService=ke,this._extHostTerminalService=Re,this._disposables=new y.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new b.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=ye,this._instaService=M.createChild(new u.ServiceCollection([h.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Ve=new Set;this._initData.hostExtensions.forEach(Be=>Ve.add(l.ExtensionIdentifier.toKey(Be))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Be,Ke,W)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Be,P.transformErrorForSerialization(Ke),W)},actualActivateExtension:async(Be,Ke)=>{if(Ve.has(l.ExtensionIdentifier.toKey(Be)))return await this._mainThreadExtensionsProxy.$activateExtension(Be,Ke),new m.HostExtension;const W=this._registry.getExtensionDescription(Be);return this._activateExtension(W,Ke)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){P.onUnexpectedError(M)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let M=[];try{M=this._registry.getAllExtensionDescriptions().map(G=>G.identifier).filter(G=>this.isActivated(G)).map(G=>this._deactivate(G))}catch(N){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,N){return this._activator.activateByEvent(M,N)}_activateById(M,N){return this._activator.activateById(M,N)}activateByIdWithErrors(M,N){return this._activateById(M,N).then(()=>{const V=this._activator.getActivatedExtension(M);if(V.activationFailed)return Promise.reject(V.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=S.TernarySearchTree.forPaths(),N=this._registry.getAllExtensionDescriptions().map(V=>{if(!!this._getEntryPoint(V))return this._hostUtils.realpath(V.extensionLocation.fsPath).then($=>M.set(A.URI.file($).fsPath,V))});this._extensionPathIndex=Promise.all(N).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let N=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return N;const V=this._activator.getActivatedExtension(M);if(!V)return N;try{typeof V.module.deactivate=="function"&&(N=Promise.resolve(V.module.deactivate()).then(void 0,$=>(this._logService.error($),Promise.resolve(void 0))))}catch($){this._logService.error($)}try{(0,y.dispose)(V.subscriptions)}catch($){this._logService.error($)}return N}async _activateExtension(M,N){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,N).then(V=>{const $=V.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,$.codeLoadingTime,$.activateCallTime,$.activateResolvedTime,N),this._logExtensionActivationTimes(M,N,"success",$),V},V=>{throw this._logExtensionActivationTimes(M,N,"failure"),V})}_logExtensionActivationTimes(M,N,V,$){const G=x(M,N);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...G,...$||{},outcome:V})}_doActivateExtension(M,N){const V=x(M,N);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",V);const $=this._getEntryPoint(M);if(!$)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(N)}`),this._logService.flush();const G=new m.ExtensionActivationTimesBuilder(N.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,C.joinPath)(M.extensionLocation,$),G),this._loadExtensionContext(M)]).then(J=>(k.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Wn._callActivate(this._logService,M.identifier,J[0],J[1],G))).then(J=>(k.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),J))}_loadExtensionContext(M){const N=new p.ExtensionGlobalMemento(M,this._storage),V=new p.ExtensionMemento(M.identifier.value,!1,this._storage),$=new U.ExtensionSecrets(M,this._secretState),G=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,J=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([N.whenReady,V.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let ye;return Object.freeze({globalState:N,workspaceState:V,secrets:$,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(ke){return R.join(M.extensionLocation.fsPath,ke)},get storagePath(){return fe._storagePath.workspaceValue(M)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(M).fsPath},get logPath(){return R.join(fe._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return A.URI.joinPath(fe._initData.logsLocation,M.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(M)},get globalStorageUri(){return fe._storagePath.globalValue(M)},get extensionMode(){return G},get extension(){return ye===void 0&&(ye=new F(fe,M.identifier,M,J)),ye},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(M),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,N,V,$,G){return V=V||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,N,V,$,G).then(J=>new m.ActivatedExtension(!1,null,G.build(),V,J,$.subscriptions))}static _callActivateOptional(M,N,V,$,G){if(typeof V.activate=="function")try{G.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${N.value}`);const J=typeof global=="object"?global:self,fe=V.activate.apply(J,[$]);return G.activateCallStop(),G.activateResolveStart(),Promise.resolve(fe).then(ye=>(G.activateResolveStop(),ye))}catch(J){return Promise.reject(J)}else return Promise.resolve(V)}_activateOneStartupFinished(M,N){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:N}).then(void 0,V=>{this._logService.error(V)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const N of M.activationEvents)N==="onStartupFinished"&&this._activateOneStartupFinished(M,N)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,G=>{this._logService.error(G)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(G=>this._handleWorkspaceContainsEagerExtensions(G.added)));const N=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],V=this._handleWorkspaceContainsEagerExtensions(N),$=Promise.all([M,V]).then(()=>{});return Promise.race([$,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),$}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(N=>this._handleWorkspaceContainsEagerExtension(M,N))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,N){if(this.isActivated(N.identifier))return;const V=!this._initData.remote.isRemote&&!!this._initData.remote.authority,$={folders:M.map(J=>J.uri),forceUsingSearch:V,exists:J=>this._hostUtils.exists(J.fsPath),checkExists:(J,fe,ye)=>this._mainThreadWorkspaceProxy.$checkExists(J,fe,ye)},G=await(0,D.checkActivateWorkspaceContainsExtension)($,N);if(!!G)return this._activateById(N.identifier,{startup:!0,extensionId:N.identifier,activationEvent:G.activationEvent}).then(void 0,J=>this._logService.error(J))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:N}=this._initData.environment;if(!M||!N)throw new Error(g.localize(0,null));const V=await this._loadCommonJSModule(null,N,new m.ExtensionActivationTimesBuilder(!1));if(!V||typeof V.run!="function")throw new Error(g.localize(1,null,N.toString()));return new Promise(($,G)=>{const J=(ke,Re)=>{ke?G(ke):$(typeof Re=="number"&&Re>0?1:0)},fe=(0,C.originalFSPath)(N),ye=V.run(fe,J);ye&&ye.then&&ye.then(()=>{$(0)}).catch(ke=>{G(ke.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,N){return this._resolvers[M]=N,(0,y.toDisposable)(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const N=M.indexOf("+");if(N===-1)throw new Error("Not an authority that can be resolved!");const V=M.substr(0,N);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${V}`,!1),{authorityPrefix:V,resolver:this._resolvers[V]}}async $resolveAuthority(M,N){const{authorityPrefix:V,resolver:$}=await this._activateAndGetResolver(M);if(!$)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${V}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions($)),k.mark(`code/extHost/willResolveAuthority/${V}`);const G=await $.resolve(M,{resolveAttempt:N});k.mark(`code/extHost/didResolveAuthorityOK/${V}`);const J={authority:M,host:G.host,port:G.port,connectionToken:G.connectionToken},fe={extensionHostEnv:G.extensionHostEnv,isTrusted:G.isTrusted};return{type:"ok",value:{authority:J,options:fe,tunnelInformation:{environmentTunnels:G.environmentTunnels}}}}catch(G){if(k.mark(`code/extHost/didResolveAuthorityError/${V}`),G instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G}}async $getCanonicalURI(M,N){const{authorityPrefix:V,resolver:$}=await this._activateAndGetResolver(M);if(!$)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${V}`);const G=A.URI.revive(N);if(typeof $.getCanonicalURI=="undefined")return G;const J=await(0,T.asPromise)(()=>$.getCanonicalURI(G));return J||G}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,N){return N===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(V=>this._activateByEvent(M,!1))}async $activate(M,N){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,N),!0):!1}async $deltaExtensions(M,N){M.forEach($=>$.extensionLocation=A.URI.revive($.extensionLocation));const V=await this.getExtensionPathIndex();return await Promise.all(N.map(async $=>{const G=this._registry.getExtensionDescription($);if(!G)return;const J=await this._hostUtils.realpath(G.extensionLocation.fsPath);V.delete(A.URI.file(J).fsPath)})),await Promise.all(M.map(async $=>{const G=await this._hostUtils.realpath($.extensionLocation.fsPath);V.set(A.URI.file(G).fsPath,$)})),this._registry.deltaExtensions(M,N),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let N=f.VSBuffer.alloc(M),V=Math.random()%256;for(let $=0;$<M;$++)N.writeUInt8(V,$);return N}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};O=ze([xe(0,o.IInstantiationService),xe(1,e.IHostUtils),xe(2,d.IExtHostRpcService),xe(3,v.IExtHostWorkspace),xe(4,c.IExtHostConfiguration),xe(5,i.ILogService),xe(6,n.IExtHostInitDataService),xe(7,a.IExtensionStoragePaths),xe(8,w.IExtHostTunnelService),xe(9,E.IExtHostTerminalService)],O),e.AbstractExtHostExtensionService=O;function x(z,M){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class F{constructor(M,N,V,$){j.set(this,void 0),te.set(this,void 0),K.set(this,void 0),rt(this,j,M,"f"),rt(this,te,N,"f"),rt(this,K,V.identifier,"f"),this.id=V.identifier.value,this.extensionUri=V.extensionLocation,this.extensionPath=R.normalize((0,C.originalFSPath)(V.extensionLocation)),this.packageJSON=V,this.extensionKind=$}get isActive(){return He(this,j,"f").isActivated(He(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return He(this,j,"f").getExtensionExports(He(this,K,"f"))}activate(){return He(this,j,"f").activateByIdWithErrors(He(this,K,"f"),{startup:!1,extensionId:He(this,te,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,j=new WeakMap,te=new WeakMap,K=new WeakMap}),define(me[53],ge([0,1,8,2,3,17,5,7,123,36,40,45,215,37,209,13,4,14,38,51]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let f=class{constructor(u,w,E,r,D,L){this._workspaceService=w,this._extensionService=E,this._editorsService=r,this._configurationService=D,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=u.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(j=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(u,w){const E=u;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let r=`debug:${encodeURIComponent(E.path||"")}`,D="?";return w&&(r+=`${D}session=${encodeURIComponent(w.id)}`,D="&"),r+=`${D}ref=${E.sourceReference}`,R.URI.parse(r)}else{if(E.path)return R.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(u){const w=[];for(const E of u.getAllExtensionDescriptions())if(E.contributes){const r=E.contributes.debuggers;if(r&&r.length>0)for(const D of r)(0,h.isDebuggerMainContribution)(D)&&w.push(D.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const u=[];return this._breakpoints.forEach(w=>u.push(w)),u}addBreakpoints(u){this.startBreakpoints();const w=u.filter(D=>{const L=D.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,D),!0)});this.fireBreakpointChanges(w,[],[]);const E=[],r=new Map;for(const D of w)if(D instanceof y.SourceBreakpoint){let L=r.get(D.location.uri.toString());L||(L={type:"sourceMulti",uri:D.location.uri,lines:[]},r.set(D.location.uri.toString(),L),E.push(L)),L.lines.push({id:D.id,enabled:D.enabled,condition:D.condition,hitCondition:D.hitCondition,logMessage:D.logMessage,line:D.location.range.start.line,character:D.location.range.start.character})}else D instanceof y.FunctionBreakpoint&&E.push({type:"function",id:D.id,enabled:D.enabled,hitCondition:D.hitCondition,logMessage:D.logMessage,condition:D.condition,functionName:D.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(u){this.startBreakpoints();const w=u.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],w,[]);const E=w.filter(L=>L instanceof y.SourceBreakpoint).map(L=>L.id),r=w.filter(L=>L instanceof y.FunctionBreakpoint).map(L=>L.id),D=w.filter(L=>L instanceof y.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(E,r,D)}startDebugging(u,w,E){return this._debugServiceProxy.$startDebugging(u?u.uri:void 0,w,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,debugUI:E.debugUI})}stopDebugging(u){return this._debugServiceProxy.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,w,E){if(!w)return new y.Disposable(()=>{});const r=this._configProviderHandleCounter++;return this._configProviders.push({type:u,handle:r,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(u,E,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,r),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(D=>D.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(r)})}registerDebugAdapterDescriptorFactory(u,w,E){if(!E)return new y.Disposable(()=>{});if(!this.definesDebugType(u,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const r=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:r,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,r),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(D=>D.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(r)})}registerDebugAdapterTrackerFactory(u,w){if(!w)return new y.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:u,handle:E,factory:w}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(r=>r.factory!==w)})}async $runInTerminal(u,w){return Promise.resolve(void 0)}async $substituteVariables(u,w){if(!this._variableResolver){const[D,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(D||[],this._editorsService,L)}let E;const r=await this.getFolder(u);return r&&(E={uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(E,w)}createDebugAdapter(u,w){if(u.type==="implementation")return new n(u.implementation)}createSignService(){}async $startDASession(u,w){const E=this,r=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(r.type),r).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}' (extension might have failed to activate)`);const L=this.convertToDto(D),U=this.createDebugAdapter(L,r);if(!U)throw new Error(`Couldn't create a debug adapter for type '${r.type}'.`);const j=U;return this._debugAdapters.set(u,j),this.getDebugAdapterTrackers(r).then(te=>(te&&this._debugAdaptersTrackers.set(u,te),j.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const O=K,x={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(O.arguments.value);x.body={signature:F},j.sendResponse(x)}else throw new Error("no signer")}catch(F){x.success=!1,x.message=F.message,j.sendResponse(x)}}else te&&te.onDidSendMessage&&te.onDidSendMessage(K),K=(0,h.convertToVSCPaths)(K,!0),E._debugServiceProxy.$acceptDAMessage(u,K)}),j.onError(K=>{te&&te.onError&&te.onError(K),this._debugServiceProxy.$acceptDAError(u,K.name,K.message,K.stack)}),j.onExit(K=>{te&&te.onExit&&te.onExit((0,b.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(u,(0,b.withNullAsUndefined)(K),void 0)}),te&&te.onWillStartSession&&te.onWillStartSession(),j.startSession()))})}$sendDAMessage(u,w){w=(0,h.convertToDAPaths)(w,!1);const E=this._debugAdaptersTrackers.get(u);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(w);const r=this._debugAdapters.get(u);r&&r.sendMessage(w)}$stopDASession(u){const w=this._debugAdaptersTrackers.get(u);this._debugAdaptersTrackers.delete(u),w&&w.onWillStopSession&&w.onWillStopSession();const E=this._debugAdapters.get(u);return this._debugAdapters.delete(u),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const w=[],E=[],r=[];if(u.added)for(const D of u.added){const L=D.id;if(L&&!this._breakpoints.has(L)){let U;if(D.type==="function")U=new y.FunctionBreakpoint(D.functionName,D.enabled,D.condition,D.hitCondition,D.logMessage);else if(D.type==="data")U=new y.DataBreakpoint(D.label,D.dataId,D.canPersist,D.enabled,D.hitCondition,D.condition,D.logMessage);else{const j=R.URI.revive(D.uri);U=new y.SourceBreakpoint(new y.Location(j,new y.Position(D.line,D.character)),D.enabled,D.condition,D.hitCondition,D.logMessage)}U._id=L,this._breakpoints.set(L,U),w.push(U)}}if(u.removed)for(const D of u.removed){const L=this._breakpoints.get(D);L&&(this._breakpoints.delete(D),E.push(L))}if(u.changed){for(const D of u.changed)if(D.id){const L=this._breakpoints.get(D.id);if(L){if(L instanceof y.FunctionBreakpoint&&D.type==="function"){const U=L;U.enabled=D.enabled,U.condition=D.condition,U.hitCondition=D.hitCondition,U.logMessage=D.logMessage,U.functionName=D.functionName}else if(L instanceof y.SourceBreakpoint&&D.type==="source"){const U=L;U.enabled=D.enabled,U.condition=D.condition,U.hitCondition=D.hitCondition,U.logMessage=D.logMessage,U.location=new y.Location(R.URI.revive(D.uri),new y.Position(D.line,D.character))}r.push(L)}}}this.fireBreakpointChanges(w,E,r)}$provideDebugConfigurations(u,w,E){return(0,C.asPromise)(async()=>{const r=this.getConfigProviderByHandle(u);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const D=await this.getFolder(w);return r.provideDebugConfigurations(D,E)}).then(r=>{if(!r)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return r})}$resolveDebugConfiguration(u,w,E,r){return(0,C.asPromise)(async()=>{const D=this.getConfigProviderByHandle(u);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(w);return D.resolveDebugConfiguration(L,E,r)})}$resolveDebugConfigurationWithSubstitutedVariables(u,w,E,r){return(0,C.asPromise)(async()=>{const D=this.getConfigProviderByHandle(u);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(w);return D.resolveDebugConfigurationWithSubstitutedVariables(L,E,r)})}async $provideDebugAdapter(u,w){const E=this.getAdapterDescriptorFactoryByHandle(u);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const r=await this.getSession(w);return this.getAdapterDescriptor(E,r).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}'`);return this.convertToDto(D)})}async $acceptDebugSessionStarted(u){const w=await this.getSession(u);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(u){const w=await this.getSession(u);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(u){this._activeDebugSession=u?await this.getSession(u):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(u,w){const E=await this.getSession(u);E&&E._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(u,w){const r={session:await this.getSession(u),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(r)}convertToDto(u){if(u instanceof y.DebugAdapterExecutable)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof y.DebugAdapterServer)return{type:"server",port:u.port,host:u.host};if(u instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:u.path};if(u instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(u){const w=this._adapterFactories.filter(E=>E.type===u);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(u){const w=this._adapterFactories.filter(E=>E.handle===u);if(w.length>0)return w[0].factory}getConfigProviderByHandle(u){const w=this._configProviders.filter(E=>E.handle===u);if(w.length>0)return w[0].provider}definesDebugType(u,w){if(u.contributes){const E=u.contributes.debuggers;if(E&&E.length>0){for(const r of E)if(r.label&&r.type&&r.type===w)return!0}}return!1}getDebugAdapterTrackers(u){const E=u.configuration.type,r=this._trackerFactories.filter(D=>D.type===E||D.type==="*").map(D=>(0,C.asPromise)(()=>D.factory.createDebugAdapterTracker(u)).then(L=>L,L=>null));return Promise.race([Promise.all(r).then(D=>{const L=D.filter(U=>!!U);if(L.length>0)return new o(L)}),new Promise((D,L)=>{const U=setTimeout(()=>{clearTimeout(U),L(new Error("timeout"))},1e3)})]).catch(D=>{})}async getAdapterDescriptor(u,w){const E=w.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new y.DebugAdapterServer(E));if(u){const D=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>u.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,D))).then(L=>{if(L)return L})}const r=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,r))}daExecutableFromPackage(u,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(u,w,E){(u.length>0||w.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:u,removed:w,changed:E}))}async getSession(u){if(u)if(typeof u=="string"){const w=this._debugSessions.get(u);if(w)return w}else{let w=this._debugSessions.get(u.id);if(!w){const E=await this.getFolder(u.folderUri),r=u.parent?this._debugSessions.get(u.parent):void 0;w=new p(this._debugServiceProxy,u.id,u.type,u.name,E,u.configuration,r),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(u){if(u){const w=R.URI.revive(u);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};f=ze([xe(0,v.IExtHostRpcService),xe(1,A.IExtHostWorkspace),xe(2,i.IExtHostExtensionService),xe(3,I.IExtHostDocumentsAndEditors),xe(4,m.IExtHostConfiguration),xe(5,l.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class p{constructor(u,w,E,r,D,L,U){this._debugServiceProxy=u,this._id=w,this._type=E,this._name=r,this._workspaceFolder=D,this._configuration=L,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(u){this._name=u,this._debugServiceProxy.$setDebugSessionName(this._id,u)}get parentSession(){return this._parentSession}_acceptNameChanged(u){this._name=u}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(u,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,u,w)}getDebugProtocolBreakpoint(u){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,u.id)}}e.ExtHostDebugSession=p;class t{constructor(u){this.value=Object.freeze({append(w){u.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class s extends c.AbstractVariableResolverService{constructor(u,w,E,r,D){function L(){if(w){const U=w.activeEditor();if(U)return U.document.uri;const j=r.tabs.filter(te=>te.isActive);if(j.length>0)return j[0].resource}}super({getFolderUri:U=>{const j=u.filter(te=>te.name===U);if(j&&j.length>0)return j[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(U,j)=>E.getConfiguration(void 0,U).get(j),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=L();if(U)return g.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(D){const U=L();if(U){const j=D.getWorkspaceFolder(U);if(j)return g.normalize(j.uri.fsPath)}}},getSelectedText:()=>{if(w){const U=w.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(w){const U=w.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(P.env))}}e.ExtHostVariableResolverService=s;class o{constructor(u){this.trackers=u}onWillStartSession(){this.trackers.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(u):void 0)}onWillStopSession(){this.trackers.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.trackers.forEach(w=>w.onError?w.onError(u):void 0)}onExit(u,w){this.trackers.forEach(E=>E.onExit?E.onExit(u,w):void 0)}}class n extends S.AbstractDebugAdapter{constructor(u){super();this.implementation=u,u.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.implementation.handleMessage(u)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends f{constructor(u,w,E,r,D,L){super(u,w,E,r,D,L)}createVariableResolver(u,w,E){return new s(u,w,E,this._editorTabs)}};a=ze([xe(0,v.IExtHostRpcService),xe(1,A.IExtHostWorkspace),xe(2,i.IExtHostExtensionService),xe(3,I.IExtHostDocumentsAndEditors),xe(4,m.IExtHostConfiguration),xe(5,l.IExtHostEditorTabs)],a),e.WorkerExtHostDebugService=a}),define(me[269],ge([0,1,71,2,5,37,35,26,13,27,4,40,38,12]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(l,f,p,t,s,o,n){this._apiFactory=l,this._extensionRegistry=f,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=s,this._initData=o,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,f,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,f,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let f of l.nodeModuleName)this._factories.set(f,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(f=>l.alternativeModuleName(f))}};h=ze([xe(2,i.IInstantiationService),xe(3,C.IExtHostConfiguration),xe(4,I.IExtHostExtensionService),xe(5,A.IExtHostInitDataService),xe(6,m.ILogService)],h),e.RequireInterceptor=h;class v{constructor(l,f,p,t,s){this._apiFactory=l,this._extensionPaths=f,this._extensionRegistry=p,this._configProvider=t,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,f){const p=this._extensionPaths.findSubstr(f.fsPath);if(p){let t=this._extApiImpl.get(y.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(y.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((s,o)=>t+=`	${o} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(l,f){this.nodeModuleName="keytar";const{environment:p}=f,t=l.getProxy(k.MainContext.MainThreadKeytar);if(p.appRoot){let s=p.appRoot.fsPath;c.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,o)=>t.$getPassword(s,o),setPassword:(s,o,n)=>t.$setPassword(s,o,n),deletePassword:(s,o)=>t.$deletePassword(s,o),findPassword:s=>t.$findPassword(s),findCredentials(s){return t.$findCredentials(s)}}}load(l,f){return this._impl}alternativeModuleName(l){const f=l.length;if(f<=7||!this.alternativeNames)return;const p=f-7;if((l.charAt(p)==="/"||l.charAt(p)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};_=ze([xe(0,S.IExtHostRpcService),xe(1,A.IExtHostInitDataService)],_);let b=class{constructor(l,f,p){this._extensionPaths=l,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(k.MainContext.MainThreadTelemetry);const t=p.getProxy(k.MainContext.MainThreadWindow);this._impl=(s,o)=>{const n=R.URI.parse(s);return o?this.callOriginal(s,o):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,s,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,s,{}):this.callOriginal(s,o)}}load(l,f,p){const t=this._extensionPaths.findSubstr(f.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(l),this._impl}callOriginal(l,f){return this.sendNoForwardTelemetry(),this._original(l,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=ze([xe(2,S.IExtHostRpcService)],b)}),define(me[270],ge([0,1,170,11,7,210,36,40,45,37,33,13,53,194,17,211,51]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends c.ExtHostDebugServiceBase{constructor(f,p,t,s,o,n,a){super(f,p,t,s,o,a);this._terminalService=n,this._integratedTerminalInstances=new P}createDebugAdapter(f,p){switch(f.type){case"server":return new C.SocketDebugAdapter(f);case"pipeServer":return new C.NamedPipeDebugAdapter(f);case"executable":return new C.ExecutableDebugAdapter(f,p.type)}return super.createDebugAdapter(f,p)}daExecutableFromPackage(f,p){const t=C.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),f.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new m.SignService}async $runInTerminal(f,p){if(f.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),s=this._terminalService.getDefaultShell(!0),o=this._terminalService.getDefaultShellArgs(!0),n=f.title||g.localize(0,null),a=JSON.stringify({shell:s,shellArgs:o});let d=await this._integratedTerminalInstances.checkout(a,n),u,w=!1;if(d)u=f.cwd;else{const L={shellPath:s,shellArgs:o,cwd:f.cwd,name:n,iconPath:new k.ThemeIcon("debug")};w=!0,d=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,a)}d.show(!0);const E=await d.processId;w?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?d.sendText("cls"):s.indexOf("bash")>=0?d.sendText("clear"):R.isWindows?d.sendText("cls"):d.sendText("clear"));const r=(0,v.prepareCommand)(s,f.args,u,f.env);d.sendText(r);const D=this.onDidTerminateDebugSession(L=>{L.id===p&&(this._integratedTerminalInstances.free(d),D.dispose())});return E}else if(f.kind==="external")return(0,v.runInExternalTerminal)(f,await this._configurationService.getConfigProvider());return super.$runInTerminal(f,p)}createVariableResolver(f,p,t){return new c.ExtHostVariableResolverService(f,p,t,this._editorTabs,this._workspaceService)}};b=ze([xe(0,I.IExtHostRpcService),xe(1,T.IExtHostWorkspace),xe(2,y.IExtHostExtensionService),xe(3,S.IExtHostDocumentsAndEditors),xe(4,A.IExtHostConfiguration),xe(5,i.IExtHostTerminalService),xe(6,_.IExtHostEditorTabs)],b),e.ExtHostDebugService=b;class P{constructor(){this._terminalInstances=new Map}async checkout(f,p){const s=[...this._terminalInstances.entries()].map(([o,n])=>(0,h.createCancelablePromise)(async a=>{if(o.name!==p||n.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await o.processId))return null;const d=Date.now();return n.lastUsedAt+P.minUseDelay>d||a.isCancellationRequested||n.config!==f?null:(n.lastUsedAt=d,o)}));return await(0,h.firstParallel)(s,o=>!!o)}insert(f,p){this._terminalInstances.set(f,{lastUsedAt:Date.now(),config:p})}free(f){const p=this._terminalInstances.get(f);p&&(p.lastUsedAt=-1)}onTerminalClosed(f){this._terminalInstances.delete(f)}}P.minUseDelay=1e3}),define(me[271],ge([0,1,8,2,112,36,53,45,37,43,33,13,27,70,10,12,65,51,24,79]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends m.ExtHostTaskBase{constructor(t,s,o,n,a,d,u,w,E){super(t,s,o,n,a,d,u,w);this.workspaceService=o,this.editorTabs=E,s.remote.isRemote&&s.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,s){const o=s;if(!s.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const n=m.TaskHandleDTO.from(o,this.workspaceService),a=await this._proxy.$getTaskExecution(n);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const d=await this.getTaskExecution(a,s);return this._proxy.$executeTask(n).catch(()=>{}),d}else{const n=m.TaskDTO.from(s,t);if(n===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(n.execution)&&await this.addCustomExecution(n,s,!1);const a=await this.getTaskExecution(await this._proxy.$getTaskExecution(n),s);return this._proxy.$executeTask(n).catch(()=>{}),a}}provideTasksInternal(t,s,o,n){const a=[];if(n)for(let d of n){this.checkDeprecation(d,o),(!d.definition||!t[d.definition.type])&&this._logService.warn(`The task [${d.source}, ${d.name}] uses an undefined task type. The task will be ignored in the future.`);const u=m.TaskDTO.from(d,o.extension);u&&(a.push(u),m.CustomExecutionDTO.is(u.execution)&&s.push(this.addCustomExecution(u,d,!0)))}return{tasks:a,extension:o.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const s=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(t,this._editorService,s,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let s=t&&t.length>0?t[0]:void 0;if(!s){const o=R.URI.file((0,l.homedir)());s=new A.WorkspaceFolder({uri:o,name:P.basename(o),index:0})}return{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,s){const o=R.URI.revive(t),n={process:void 0,variables:Object.create(null)},a=await this._workspaceProvider.resolveWorkspaceFolder(o),d=await this._workspaceProvider.getWorkspaceFolders2()??[],u=await this.getVariableResolver(d),w=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(d);for(let E of s.variables)n.variables[E]=await u.resolveAsync(w,E);if(s.process!==void 0){let E;if(s.process.path!==void 0){E=s.process.path.split(g.delimiter);for(let r=0;r<E.length;r++)E[r]=await u.resolveAsync(w,E[r])}n.process=await k.win32.findExecutable(await u.resolveAsync(w,s.process.name),s.process.cwd!==void 0?await u.resolveAsync(w,s.process.cwd):void 0,E)}return n}async $jsonTasksSupported(){return!0}async $findExecutable(t,s,o){return k.win32.findExecutable(t,s,o)}};f=ze([xe(0,I.IExtHostRpcService),xe(1,c.IExtHostInitDataService),xe(2,C.IExtHostWorkspace),xe(3,y.IExtHostDocumentsAndEditors),xe(4,S.IExtHostConfiguration),xe(5,i.IExtHostTerminalService),xe(6,v.ILogService),xe(7,_.IExtHostApiDeprecationService),xe(8,b.IExtHostEditorTabs)],f),e.ExtHostTask=f}),define(me[272],ge([0,1,17,16,71,6,2,5,264,12,81,83,27,188,13,64,40,33]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class P{constructor(f,p,t,s){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new S.RPCProtocol(f,null,s),p=P._transform(p,this._rpcProtocol);const o=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());o.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...p}),o.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),o.set(v.IURITransformerService,new v.URITransformerService(s)),o.set(_.IHostUtils,t);const n=new m.InstantiationService(o,!0),a=n.invokeFunction(E=>E.get(b.IExtHostTerminalService));this._disposables.add(a),this._logService=n.invokeFunction(E=>E.get(A.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=n.invokeFunction(E=>E.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const d=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(r,D)=>{let L="",U,j;for(const te of D)L+=`
	at ${te.toString()}`,j=te.getFileName(),!U&&j&&(U=E.findSubstr(j));return d.set(r,U),`${r.name||"Error"}: ${r.message||""}${L}`}});const u=this._rpcProtocol.getProxy(y.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(y.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(E=>{const r=R.transformErrorForSerialization(E),D=d.get(E);D?u.$onExtensionRuntimeError(D.identifier,r):w.$onUnexpectedError(r)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,p){f.extensions.forEach(s=>s.extensionLocation=T.URI.revive(p.transformIncomingURIs(s.extensionLocation))),f.environment.appRoot=T.URI.revive(p.transformIncomingURIs(f.environment.appRoot));const t=f.environment.extensionDevelopmentLocationURI;return t&&(f.environment.extensionDevelopmentLocationURI=t.map(s=>T.URI.revive(p.transformIncomingURIs(s)))),f.environment.extensionTestsLocationURI=T.URI.revive(p.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=T.URI.revive(p.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=T.URI.revive(p.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=T.URI.revive(p.transformIncomingURIs(f.logsLocation)),f.logFile=T.URI.revive(p.transformIncomingURIs(f.logFile)),f.workspace=p.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=P}),define(me[273],ge([0,1,8,21,60,30,24,46,31]),function(Y,e,g,R,k,C,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(c,m,h){this.config=c,this.provider=m,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&C.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&C.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const m=this.config.folderQueries||[];return new Promise((h,v)=>{const _=b=>{this.resultCount++,c(b)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const P=b.toString(),l=g.basename(P);this.globalExcludePattern&&this.globalExcludePattern(P,l)||this.matchFile(_,{base:b,basename:l})}),Promise.all(m.map(b=>this.searchInFolder(b,_))).then(b=>{h({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{v(new Error((0,k.toErrorMessage)(b)))})})}async searchInFolder(c,m){const h=new R.CancellationTokenSource,v=this.getSearchOptionsForFolder(c),_=this.initDirectoryTree(),b=new S.QueryGlobTester(this.config,c),P=!b.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(h),l=y.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,h.token),p=l.elapsed(),t=y.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(s=>{const o=g.posix.relative(c.folder.path,s.path);if(P){const n=g.basename(s.path);this.matchFile(m,{base:c.folder,relativePath:o,basename:n});return}this.addDirectoryEntries(_,c.folder,o,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,b,m),{providerTime:p,postProcessTime:t.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(c){const m=(0,S.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),h=(0,S.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:h,includes:m,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},m,h,v){if(h===this.filePattern){const b=g.basename(this.filePattern);this.matchFile(v,{base:m,relativePath:this.filePattern,basename:b})}function _(b){const P=g.basename(b),l=g.dirname(b);let f=c[l];f||(f=c[l]=[],_(l)),f.push({base:m,relativePath:b,basename:P})}_(h)}matchDirectoryTree({rootEntries:c,pathToEntries:m},h,v){const _=this,b=this.filePattern;function P(l){const f=C.hasSiblingFn(()=>l.map(p=>p.basename));for(let p=0,t=l.length;p<t;p++){const s=l[p],{relativePath:o,basename:n}=s;if(!h.includedInQuerySync(o,n,b!==n?f:void 0))continue;const a=m[o];if(a)P(a);else{if(o===b)continue;_.matchFile(v,s)}if(_.isLimitHit)break}}P(c)}matchFile(c,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(m))}}class i{constructor(){this.sessions=new Map}fileSearch(c,m,h,v){const _=this.getSessionTokenSource(c.cacheKey),b=new A(c,m,_&&_.token);let P=0;const l=f=>{P+=f.length,h(f.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(b,i.BATCH_SIZE,l,v).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:P,detailStats:f.stats}}))}clearCache(c){const m=this.getSessionTokenSource(c);m&&m.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new R.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:T.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,m,h,v){v.onCancellationRequested(()=>{c.cancel()});const _=P=>{P&&(b.push(P),m>0&&b.length>=m&&(h(b),b=[]))};let b=[];return c.search(_).then(P=>(b.length&&h(b),P),P=>(b.length&&h(b),Promise.reject(P)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(me[133],ge([0,1,8,20,21,60,24,30,2,31,10,14]),function(Y,e,g,R,k,C,T,y,S,A,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(l,f,p){this.query=l,this.provider=f,this.fileUtils=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,f){const p=this.query.folderQueries||[],t=new k.CancellationTokenSource;return f.onCancellationRequested(()=>t.cancel()),new Promise((s,o)=>{this.collector=new h(l);let n=!1;const a=(d,u)=>{if(!n&&!this.isLimitHit){const w=this.resultSize(d);_(d)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const E=this.resultSize(d);this.resultCount+=E,(E>0||!_(d))&&this.collector.add(d,u)}};Promise.all(p.map((d,u)=>this.searchInFolder(d,w=>a(w,u),t.token))).then(d=>{t.dispose(),this.collector.flush();const u=d.some(w=>!!w&&!!w.limitHit);s({limitHit:this.isLimitHit||u,messages:(0,R.flatten)(d.map(w=>w?.message?(0,I.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:"textSearchProvider"}})},d=>{t.dispose();const u=(0,C.toErrorMessage)(d);o(new Error(u))})})}resultSize(l){return _(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,f){const p=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:p.slice(0,f),preview:{matches:t.slice(0,f),text:l.preview.text},uri:l.uri}}async searchInFolder(l,f,p){const t=new A.QueryGlobTester(this.query,l),s=[],o={report:d=>{if(!this.validateProviderResult(d))return;const u=l.folder.scheme===i.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(d.uri))):void 0,w=T.relativePath(l.folder,d.uri);w&&s.push(t.includedInQuery(w,g.basename(w),u).then(E=>{E&&f(d)}))}},n=this.getSearchOptionsForFolder(l),a=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,o,p);return await Promise.all(s),a}validateProviderResult(l){if(_(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const f=(0,A.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),p=(0,A.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),t={folder:S.URI.from(l.folder),excludes:p,includes:f,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=c;function m(P){return{isCaseSensitive:P.isCaseSensitive||!1,isRegExp:P.isRegExp||!1,isWordMatch:P.isWordMatch||!1,isMultiline:P.isMultiline||!1,pattern:P.pattern}}class h{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,f=>this.sendItems(f))}add(l,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!T.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(v(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=h;function v(P){return _(P)?{preview:{matches:(0,R.mapArrayOrNot)(P.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:P.preview.text},ranges:(0,R.mapArrayOrNot)(P.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:P.text,lineNumber:P.lineNumber}}function _(P){return!!P.preview}e.extensionResultIsMatch=_;class b{constructor(l,f){this.maxBatchSize=l,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,f){!l||this.addItemToBatch(l,f)}addItems(l,f){!l||this.addItemsToBatch(l,f)}addItemToBatch(l,f){this.batch.push(l),this.batchSize+=f,this.onUpdate()}addItemsToBatch(l,f){this.batch=this.batch.concat(l),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(me[72],ge([0,1,6,5,4,273,13,64,12,2,133]),function(Y,e,g,R,k,C,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let I=class{constructor(v,_,b){this.extHostRpc=v,this._uriTransformer=_,this._logService=b,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,_){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const b=this._handlePool++;return this._textSearchProvider.set(b,_),this._proxy.$registerTextSearchProvider(b,this._transformScheme(v)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}registerFileSearchProvider(v,_){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const b=this._handlePool++;return this._fileSearchProvider.set(b,_),this._proxy.$registerFileSearchProvider(b,this._transformScheme(v)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(v,_,b,P){const l=c(b),f=this._fileSearchProvider.get(v);if(f)return this._fileSearchManager.fileSearch(l,f,p=>{this._proxy.$handleFileMatch(v,_,p.map(t=>t.resource))},P);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,_,b,P){const l=this._textSearchProvider.get(v);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const f=c(b);return this.createTextSearchManager(f,l).search(t=>this._proxy.$handleTextMatch(v,_,t),P)}createTextSearchManager(v,_){return new i.TextSearchManager(v,_,{readdir:b=>Promise.resolve([]),toCanonicalName:b=>b})}};I=ze([xe(0,T.IExtHostRpcService),xe(1,y.IURITransformerService),xe(2,S.ILogService)],I),e.ExtHostSearch=I;function c(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(m),extraFileResources:h.extraFileResources&&h.extraFileResources.map(v=>A.URI.revive(v))}}e.reviveQuery=c;function m(h){return{...h,folder:A.URI.revive(h.folder)}}}),define(me[274],ge([0,1,21,16,3,48,2,113,108,146,80,42,5,232,231,44,233,37,234,235,236,217,237,45,40,238,218,241,242,243,66,220,248,249,250,92,33,252,221,15,7,255,68,132,36,35,55,206,240,85,131,70,53,72,12,64,13,27,244,203,52,65,229,253,202,67,91,258,256,257,230,63,251,254,90,51,121,246,69,247,10,190,245,200,239]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b,P,l,f,p,t,s,o,n,a,d,u,w,E,r,D,L,U,j,te,K,O,x,F,z,M,N,V,$,G,J,fe,ye,ke,Re,Ve,Be,Ke,W,Z,re,ae,Q,oe,we,Me,je,Xe,Se,tt,X,ee,ve,Ue,Je,nt,at,pt,_t,St,le,Pe,Ne,Ye,We,st,Te,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ie(ne){const ue=ne.get(re.IExtHostInitDataService),Ee=ne.get(Je.IExtHostFileSystemInfo),be=ne.get(tt.IExtHostConsumerFileSystem),Fe=ne.get(o.IExtHostExtensionService),Ge=ne.get(V.IExtHostWorkspace),$e=ne.get(St.IExtHostTelemetry),Ze=ne.get(b.IExtHostConfiguration),pe=ne.get(W.IURITransformerService),de=ne.get(Z.IExtHostRpcService),ce=ne.get(j.IExtHostStorage),q=ne.get(Se.IExtensionStoragePaths),_e=ne.get(Ke.ILogService),Le=ne.get(oe.IExtHostTunnelService),Qe=ne.get(we.IExtHostApiDeprecationService),qe=ne.get(N.IExtHostWindow),ft=ne.get(pt.IExtHostSecretState),ht=ne.get(_t.IExtHostEditorTabs);de.set(c.ExtHostContext.ExtHostFileSystemInfo,Ee),de.set(c.ExtHostContext.ExtHostLogService,_e),de.set(c.ExtHostContext.ExtHostWorkspace,Ge),de.set(c.ExtHostContext.ExtHostConfiguration,Ze),de.set(c.ExtHostContext.ExtHostExtensionService,Fe),de.set(c.ExtHostContext.ExtHostStorage,ce),de.set(c.ExtHostContext.ExtHostTunnelService,Le),de.set(c.ExtHostContext.ExtHostWindow,qe),de.set(c.ExtHostContext.ExtHostSecretState,ft),de.set(c.ExtHostContext.ExtHostTelemetry,$e),de.set(c.ExtHostContext.ExtHostEditorTabs,ht);const yt=de.set(c.ExtHostContext.ExtHostDecorations,ne.get(ke.IExtHostDecorations)),gt=de.set(c.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(s.IExtHostDocumentsAndEditors)),ct=de.set(c.ExtHostContext.ExtHostCommands,ne.get(v.IExtHostCommands)),ut=de.set(c.ExtHostContext.ExtHostTerminalService,ne.get(te.IExtHostTerminalService)),vt=de.set(c.ExtHostContext.ExtHostDebugService,ne.get(Ve.IExtHostDebugService)),It=de.set(c.ExtHostContext.ExtHostSearch,ne.get(Be.IExtHostSearch)),At=de.set(c.ExtHostContext.ExtHostTask,ne.get(Re.IExtHostTask)),Wt=de.set(c.ExtHostContext.ExtHostOutputService,ne.get(E.IExtHostOutputService)),jt=de.set(c.ExtHostContext.ExtHostUrls,new z.ExtHostUrls(de)),Dt=de.set(c.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(de,gt)),Yt=de.set(c.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(de,gt,_e)),Jt=de.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(_e,Dt,de.getProxy(c.MainContext.MainThreadBulkEdits))),wt=de.set(c.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(de,ct,gt,Dt,q)),qt=de.set(c.ExtHostContext.ExtHostNotebookDocuments,new Te.ExtHostNotebookDocuments(_e,wt)),Ht=de.set(c.ExtHostContext.ExtHostNotebookEditors,new st.ExtHostNotebookEditors(_e,de,wt)),Zt=de.set(c.ExtHostContext.ExtHostNotebookKernels,new le.ExtHostNotebookKernels(de,ue,wt,_e)),en=de.set(c.ExtHostContext.ExtHostNotebookRenderers,new Ne.ExtHostNotebookRenderers(de,wt)),Pt=de.set(c.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(de,gt)),fn=de.set(c.ExtHostContext.ExtHostTreeViews,new O.ExtHostTreeViews(de.getProxy(c.MainContext.MainThreadTreeViews),ct,_e)),tn=de.set(c.ExtHostContext.ExtHostEditorInsets,new J.ExtHostEditorInsets(de.getProxy(c.MainContext.MainThreadEditorInsets),Pt,ue)),xt=de.set(c.ExtHostContext.ExtHostDiagnostics,new P.ExtHostDiagnostics(de,_e)),mt=de.set(c.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(de,pe,Dt,ct,xt,_e,Qe)),nn=de.set(c.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(de,mt)),Mt=de.set(c.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(de,_e,gt)),Ot=de.set(c.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(de,Ge,ct)),Gt=de.set(c.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(de,ct,_e)),_n=de.set(c.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(de,ct,Dt)),mn=de.set(c.ExtHostContext.ExtHostProgress,new r.ExtHostProgress(de.getProxy(c.MainContext.MainThreadProgress))),Sn=de.set(c.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(de)),gn=de.set(c.ExtHostContext.ExtHostTheming,new Q.ExtHostTheming(de)),rn=de.set(c.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(de)),sn=de.set(c.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(de,ct)),zt=de.set(c.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(de,{remote:ue.remote},Ge,_e,Qe)),on=de.set(c.ExtHostContext.ExtHostWebviewPanels,new ve.ExtHostWebviewPanels(de,zt,Ge)),yn=de.set(c.ExtHostContext.ExtHostCustomEditors,new ee.ExtHostCustomEditors(de,Dt,q,zt,on)),Dn=de.set(c.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(de,zt)),Vt=de.set(c.ExtHostContext.ExtHostTesting,new nt.ExtHostTesting(de,ct)),Kt=de.set(c.ExtHostContext.ExtHostUriOpeners,new at.ExtHostUriOpeners(de));de.set(c.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(de,wt,gt,ct));const Cn=(0,G.values)(c.ExtHostContext);de.assertRegistered(Cn);const kn=new Ue.ExtHostBulkEdits(de,gt),an=new h.ExtHostClipboard(de),ln=new w.ExtHostMessageService(de,_e),Bt=new l.ExtHostDialogs(de),Lt=new U.ExtHostStatusBar(de,ct.converter),Qt=new u.ExtHostLanguages(de,Dt);return m.ExtHostApiCommands.register(ct),function(Oe,$t,pn){const bt=function(){let ie=!Oe.isUnderDevelopment;function he(Ae){ie||(_e.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Ae(lt){if(Array.isArray(lt))lt.forEach(Ae);else if(typeof lt=="string")he(lt);else{const Et=lt;typeof Et.scheme=="undefined"&&he(lt),!Oe.enableProposedApi&&typeof Et.exclusive=="boolean"&&(0,$.throwProposedApiError)(Oe)}return lt}}(),In={getSession(ie,he,Ae){return Ae?.forceNewSession&&(0,$.checkProposedApiEnabled)(Oe),rn.getSession(Oe,ie,he,Ae)},get onDidChangeSessions(){return rn.onDidChangeSessions},registerAuthenticationProvider(ie,he,Ae,lt){return rn.registerAuthenticationProvider(ie,he,Ae,lt)}},Pn={registerCommand(ie,he,Ae){return ct.registerCommand(!0,ie,he,Ae)},registerTextEditorCommand(ie,he,Ae){return ct.registerCommand(!0,ie,(...lt)=>{const Et=Pt.getActiveTextEditor();if(!Et){_e.warn("Cannot execute "+ie+" because there is no active text editor.");return}return Et.edit(kt=>{he.apply(Ae,[Et,kt,...lt])}).then(kt=>{kt||_e.warn("Edits from command "+ie+" were not applied.")},kt=>{_e.warn("An error occurred while running command "+ie,kt)})})},registerDiffInformationCommand:(ie,he,Ae)=>((0,$.checkProposedApiEnabled)(Oe),ct.registerCommand(!0,ie,async(...lt)=>{const Et=gt.activeEditor(!0);if(!Et){_e.warn("Cannot execute "+ie+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(Et.id);he.apply(Ae,[kt,...lt])})),executeCommand(ie,...he){return ct.executeCommand(ie,...he)},getCommands(ie=!1){return ct.getCommands(ie)}},vn={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get embedderIdentifier(){return ue.environment.embedderIdentifier},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return an.value},get shell(){return ut.getDefaultShell(!1)},get isTelemetryEnabled(){return $e.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return $e.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,he){return qe.openUri(ie,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===ue.environment.appUriScheme)return jt.createAppUri(ie);try{return await qe.asExternalUri(ie,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,We.matchesScheme)(ie,Ye.Schemas.http)||(0,We.matchesScheme)(ie,Ye.Schemas.https))return ie;throw he}},get remoteName(){return(0,ye.getRemoteName)(ue.remote.authority)},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(vn);const wn=ue.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,An={createTestController(ie,he){return Vt.createTestController(ie,he)},createTestObserver(){return(0,$.checkProposedApiEnabled)(Oe),Vt.createTestObserver()},runTests(ie){return(0,$.checkProposedApiEnabled)(Oe),Vt.runTests(ie)},get onDidChangeTestResults(){return(0,$.checkProposedApiEnabled)(Oe),Vt.onResultsChanged},get testResults(){return(0,$.checkProposedApiEnabled)(Oe),Vt.results}},cn={getExtension(ie){const he=$t.getExtensionDescription(ie);if(he)return new o.Extension(Fe,Oe.identifier,he,wn)},get all(){return $t.getAllExtensionDescriptions().map(ie=>new o.Extension(Fe,Oe.identifier,ie,wn))},get onDidChange(){return $t.onDidChange}},Tn={createDiagnosticCollection(ie){return xt.createDiagnosticCollection(Oe.identifier,ie)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:ie=>xt.getDiagnostics(ie),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(ie,he){return Qt.changeLanguage(ie.uri,he)},match(ie,he){return(0,i.score)(x.LanguageSelector.from(ie),he.uri,he.languageId,!0)},registerCodeActionsProvider(ie,he,Ae){return mt.registerCodeActionProvider(Oe,bt(ie),he,Ae)},registerCodeLensProvider(ie,he){return mt.registerCodeLensProvider(Oe,bt(ie),he)},registerDefinitionProvider(ie,he){return mt.registerDefinitionProvider(Oe,bt(ie),he)},registerDeclarationProvider(ie,he){return mt.registerDeclarationProvider(Oe,bt(ie),he)},registerImplementationProvider(ie,he){return mt.registerImplementationProvider(Oe,bt(ie),he)},registerTypeDefinitionProvider(ie,he){return mt.registerTypeDefinitionProvider(Oe,bt(ie),he)},registerHoverProvider(ie,he){return mt.registerHoverProvider(Oe,bt(ie),he,Oe.identifier)},registerEvaluatableExpressionProvider(ie,he){return mt.registerEvaluatableExpressionProvider(Oe,bt(ie),he,Oe.identifier)},registerInlineValuesProvider(ie,he){return mt.registerInlineValuesProvider(Oe,bt(ie),he,Oe.identifier)},registerDocumentHighlightProvider(ie,he){return mt.registerDocumentHighlightProvider(Oe,bt(ie),he)},registerLinkedEditingRangeProvider(ie,he){return mt.registerLinkedEditingRangeProvider(Oe,bt(ie),he)},registerReferenceProvider(ie,he){return mt.registerReferenceProvider(Oe,bt(ie),he)},registerRenameProvider(ie,he){return mt.registerRenameProvider(Oe,bt(ie),he)},registerDocumentSymbolProvider(ie,he,Ae){return mt.registerDocumentSymbolProvider(Oe,bt(ie),he,Ae)},registerWorkspaceSymbolProvider(ie){return mt.registerWorkspaceSymbolProvider(Oe,ie)},registerDocumentFormattingEditProvider(ie,he){return mt.registerDocumentFormattingEditProvider(Oe,bt(ie),he)},registerDocumentRangeFormattingEditProvider(ie,he){return mt.registerDocumentRangeFormattingEditProvider(Oe,bt(ie),he)},registerOnTypeFormattingEditProvider(ie,he,Ae,...lt){return mt.registerOnTypeFormattingEditProvider(Oe,bt(ie),he,[Ae].concat(lt))},registerDocumentSemanticTokensProvider(ie,he,Ae){return mt.registerDocumentSemanticTokensProvider(Oe,bt(ie),he,Ae)},registerDocumentRangeSemanticTokensProvider(ie,he,Ae){return mt.registerDocumentRangeSemanticTokensProvider(Oe,bt(ie),he,Ae)},registerSignatureHelpProvider(ie,he,Ae,...lt){return typeof Ae=="object"?mt.registerSignatureHelpProvider(Oe,bt(ie),he,Ae):mt.registerSignatureHelpProvider(Oe,bt(ie),he,typeof Ae=="undefined"?[]:[Ae,...lt])},registerCompletionItemProvider(ie,he,...Ae){return mt.registerCompletionItemProvider(Oe,bt(ie),he,Ae)},registerInlineCompletionItemProvider(ie,he){return(0,$.checkProposedApiEnabled)(Oe),mt.registerInlineCompletionsProvider(Oe,bt(ie),he)},registerDocumentLinkProvider(ie,he){return mt.registerDocumentLinkProvider(Oe,bt(ie),he)},registerColorProvider(ie,he){return mt.registerColorProvider(Oe,bt(ie),he)},registerFoldingRangeProvider(ie,he){return mt.registerFoldingRangeProvider(Oe,bt(ie),he)},registerSelectionRangeProvider(ie,he){return mt.registerSelectionRangeProvider(Oe,ie,he)},registerCallHierarchyProvider(ie,he){return mt.registerCallHierarchyProvider(Oe,ie,he)},setLanguageConfiguration:(ie,he)=>mt.setLanguageConfiguration(Oe,ie,he),getTokenInformationAtPosition(ie,he){return(0,$.checkProposedApiEnabled)(Oe),Qt.tokenAtPosition(ie,he)},registerInlayHintsProvider(ie,he){return(0,$.checkProposedApiEnabled)(Oe),mt.registerInlayHintsProvider(Oe,ie,he)},registerTypeHierarchyProvider(ie,he){return(0,$.checkProposedApiEnabled)(Oe),mt.registerTypeHierarchyProvider(Oe,ie,he)},createLanguageStatusItem(ie){return(0,$.checkProposedApiEnabled)(Oe),Qt.createLanguageStatusItem(ie)}},Rn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(ie,he,Ae){const lt=await(T.URI.isUri(ie)?Promise.resolve(bn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(lt,he,Ae)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Oe,ie)},onDidChangeActiveTextEditor(ie,he,Ae){return Pt.onDidChangeActiveTextEditor(ie,he,Ae)},onDidChangeVisibleTextEditors(ie,he,Ae){return Pt.onDidChangeVisibleTextEditors(ie,he,Ae)},onDidChangeTextEditorSelection(ie,he,Ae){return Pt.onDidChangeTextEditorSelection(ie,he,Ae)},onDidChangeTextEditorOptions(ie,he,Ae){return Pt.onDidChangeTextEditorOptions(ie,he,Ae)},onDidChangeTextEditorVisibleRanges(ie,he,Ae){return Pt.onDidChangeTextEditorVisibleRanges(ie,he,Ae)},onDidChangeTextEditorViewColumn(ie,he,Ae){return Pt.onDidChangeTextEditorViewColumn(ie,he,Ae)},onDidCloseTerminal(ie,he,Ae){return ut.onDidCloseTerminal(ie,he,Ae)},onDidOpenTerminal(ie,he,Ae){return ut.onDidOpenTerminal(ie,he,Ae)},onDidChangeActiveTerminal(ie,he,Ae){return ut.onDidChangeActiveTerminal(ie,he,Ae)},onDidChangeTerminalDimensions(ie,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),ut.onDidChangeTerminalDimensions(ie,he,Ae)},onDidChangeTerminalState(ie,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),ut.onDidChangeTerminalState(ie,he,Ae)},onDidWriteTerminalData(ie,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),ut.onDidWriteTerminalData(ie,he,Ae)},get state(){return qe.state},onDidChangeWindowState(ie,he,Ae){return qe.onDidChangeWindowState(ie,he,Ae)},showInformationMessage(ie,...he){return ln.showMessage(Oe,C.default.Info,ie,he[0],he.slice(1))},showWarningMessage(ie,...he){return ln.showMessage(Oe,C.default.Warning,ie,he[0],he.slice(1))},showErrorMessage(ie,...he){return ln.showMessage(Oe,C.default.Error,ie,he[0],he.slice(1))},showQuickPick(ie,he,Ae){return Ot.showQuickPick(ie,!!Oe.enableProposedApi,he,Ae)},showWorkspaceFolderPick(ie){return Ot.showWorkspaceFolderPick(ie)},showInputBox(ie,he){return Ot.showInput(ie,he)},showOpenDialog(ie){return Bt.showOpenDialog(ie)},showSaveDialog(ie){return Bt.showSaveDialog(ie)},createStatusBarItem(ie,he,Ae){let lt,Et,kt;return typeof ie=="string"?(lt=ie,Et=he,kt=Ae):(Et=ie,kt=he),Lt.createStatusBarEntry(Oe,lt,Et,kt)},setStatusBarMessage(ie,he){return Lt.setStatusBarMessage(ie,he)},withScmProgress(ie){return Qe.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),mn.withProgress(Oe,{location:F.ProgressLocation.SourceControl},(he,Ae)=>ie({report(lt){}}))},withProgress(ie,he){return mn.withProgress(Oe,ie,he)},createOutputChannel(ie){return Wt.createOutputChannel(ie,Oe)},createWebviewPanel(ie,he,Ae,lt){return on.createWebviewPanel(Oe,ie,he,Ae,lt)},createWebviewTextEditorInset(ie,he,Ae,lt){return(0,$.checkProposedApiEnabled)(Oe),tn.createWebviewEditorInset(ie,he,Ae,lt,Oe)},createTerminal(ie,he,Ae){return typeof ie=="object"?"pty"in ie?ut.createExtensionTerminal(ie):ut.createTerminalFromOptions(ie):ut.createTerminal(ie,he,Ae)},registerTerminalLinkProvider(ie){return ut.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,he){return ut.registerProfileProvider(Oe,ie,he)},registerTreeDataProvider(ie,he){return fn.registerTreeDataProvider(ie,he,Oe)},createTreeView(ie,he){return fn.createTreeView(ie,he,Oe)},registerWebviewPanelSerializer:(ie,he)=>on.registerWebviewPanelSerializer(Oe,ie,he),registerCustomEditorProvider:(ie,he,Ae={})=>yn.registerCustomEditorProvider(Oe,ie,he,Ae),registerFileDecorationProvider(ie){return yt.registerFileDecorationProvider(ie,Oe.identifier)},registerUriHandler(ie){return jt.registerUriHandler(Oe.identifier,ie)},createQuickPick(){return Ot.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return Ot.createInputBox(Oe.identifier)},get activeColorTheme(){return gn.activeColorTheme},onDidChangeActiveColorTheme(ie,he,Ae){return gn.onDidChangeActiveColorTheme(ie,he,Ae)},registerWebviewViewProvider(ie,he,Ae){return Dn.registerWebviewViewProvider(Oe,ie,he,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,$.checkProposedApiEnabled)(Oe),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),wt.onDidChangeActiveNotebookEditor(ie,he,Ae)},get visibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Oe),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Oe),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),Ht.onDidChangeNotebookEditorSelection(ie,he,Ae)},onDidChangeNotebookEditorVisibleRanges(ie,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),Ht.onDidChangeNotebookEditorVisibleRanges(ie,he,Ae)},showNotebookDocument(ie,he){return(0,$.checkProposedApiEnabled)(Oe),wt.showNotebookDocument(ie,he)},registerExternalUriOpener(ie,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),Kt.registerExternalUriOpener(Oe.identifier,ie,he,Ae)},get openEditors(){return(0,$.checkProposedApiEnabled)(Oe),ht.tabs},get onDidChangeOpenEditors(){return(0,$.checkProposedApiEnabled)(Oe),ht.onDidChangeTabs},getInlineCompletionItemController(ie){return(0,$.checkProposedApiEnabled)(Oe),d.InlineCompletionController.get(ie)}},bn={get rootPath(){return Qe.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ge.getPath()},set rootPath(ie){throw R.readonly()},getWorkspaceFolder(ie){return Ge.getWorkspaceFolder(ie)},get workspaceFolders(){return Ge.getWorkspaceFolders()},get name(){return Ge.name},set name(ie){throw R.readonly()},get workspaceFile(){return Ge.workspaceFile},set workspaceFile(ie){throw R.readonly()},updateWorkspaceFolders:(ie,he,...Ae)=>Ge.updateWorkspaceFolders(Oe,ie,he||0,...Ae),onDidChangeWorkspaceFolders:function(ie,he,Ae){return Ge.onDidChangeWorkspace(ie,he,Ae)},asRelativePath:(ie,he)=>Ge.getRelativePath(ie,he),findFiles:(ie,he,Ae,lt)=>Ge.findFiles(x.GlobPattern.from(ie),x.GlobPattern.from(he),Ae,Oe.identifier,lt),findTextInFiles:(ie,he,Ae,lt)=>{let Et,kt;return typeof he=="object"?(Et=he,kt=Ae):(Et={},kt=he,lt=Ae),Ge.findTextInFiles(ie,Et||{},kt,Oe.identifier,lt)},saveAll:ie=>Ge.saveAll(ie),applyEdit(ie){return kn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,he,Ae,lt)=>Mt.createFileSystemWatcher(x.GlobPattern.from(ie),he,Ae,lt),get textDocuments(){return Dt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw R.readonly()},openTextDocument(ie){let he;const Ae=ie;if(typeof ie=="string")he=Promise.resolve(T.URI.file(ie));else if(T.URI.isUri(ie))he=Promise.resolve(ie);else if(!Ae||typeof Ae=="object")he=Dt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(lt=>Dt.ensureDocumentData(lt).then(Et=>Et.document))},onDidOpenTextDocument:(ie,he,Ae)=>Dt.onDidAddDocument(ie,he,Ae),onDidCloseTextDocument:(ie,he,Ae)=>Dt.onDidRemoveDocument(ie,he,Ae),onDidChangeTextDocument:(ie,he,Ae)=>Dt.onDidChangeDocument(ie,he,Ae),onDidSaveTextDocument:(ie,he,Ae)=>Dt.onDidSaveDocument(ie,he,Ae),onWillSaveTextDocument:(ie,he,Ae)=>Jt.getOnWillSaveTextDocumentEvent(Oe)(ie,he,Ae),get notebookDocuments(){return wt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,he){let Ae;if(T.URI.isUri(ie))Ae=ie,await wt.openNotebookDocument(ie);else if(typeof ie=="string")Ae=T.URI.revive(await wt.createNotebookDocument({viewType:ie,content:he}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,he,Ae,lt){return wt.registerNotebookSerializer(Oe,ie,he,Ae,Oe.enableProposedApi?lt:void 0)},registerNotebookContentProvider:(ie,he,Ae,lt)=>((0,$.checkProposedApiEnabled)(Oe),wt.registerNotebookContentProvider(Oe,ie,he,Ae,Oe.enableProposedApi?lt:void 0)),onDidChangeConfiguration:(ie,he,Ae)=>pn.onDidChangeConfiguration(ie,he,Ae),getConfiguration(ie,he){return he=arguments.length===1?void 0:he,pn.getConfiguration(ie,he,Oe)},registerTextDocumentContentProvider(ie,he){return Yt.registerTextDocumentContentProvider(ie,he)},registerTaskProvider:(ie,he)=>(Qe.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),At.registerTaskProvider(Oe,ie,he)),registerFileSystemProvider(ie,he,Ae){return nn.registerFileSystemProvider(Oe.identifier,ie,he,Ae,Oe.enableProposedApi)},get fs(){return be.value},registerFileSearchProvider:(ie,he)=>((0,$.checkProposedApiEnabled)(Oe),It.registerFileSearchProvider(ie,he)),registerTextSearchProvider:(ie,he)=>((0,$.checkProposedApiEnabled)(Oe),It.registerTextSearchProvider(ie,he)),registerRemoteAuthorityResolver:(ie,he)=>((0,$.checkProposedApiEnabled)(Oe),Fe.registerRemoteAuthorityResolver(ie,he)),registerResourceLabelFormatter:ie=>((0,$.checkProposedApiEnabled)(Oe),Sn.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,he,Ae)=>Mt.onDidCreateFile(ie,he,Ae),onDidDeleteFiles:(ie,he,Ae)=>Mt.onDidDeleteFile(ie,he,Ae),onDidRenameFiles:(ie,he,Ae)=>Mt.onDidRenameFile(ie,he,Ae),onWillCreateFiles:(ie,he,Ae)=>Mt.getOnWillCreateFileEvent(Oe)(ie,he,Ae),onWillDeleteFiles:(ie,he,Ae)=>Mt.getOnWillDeleteFileEvent(Oe)(ie,he,Ae),onWillRenameFiles:(ie,he,Ae)=>Mt.getOnWillRenameFileEvent(Oe)(ie,he,Ae),openTunnel:ie=>((0,$.checkProposedApiEnabled)(Oe),Le.openTunnel(Oe,ie).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,$.checkProposedApiEnabled)(Oe),Le.getTunnels()},onDidChangeTunnels:(ie,he,Ae)=>((0,$.checkProposedApiEnabled)(Oe),Le.onDidChangeTunnels(ie,he,Ae)),registerPortAttributesProvider:(ie,he)=>((0,$.checkProposedApiEnabled)(Oe),Le.registerPortsAttributesProvider(ie,he)),registerTimelineProvider:(ie,he)=>((0,$.checkProposedApiEnabled)(Oe),sn.registerTimelineProvider(ie,he,Oe.identifier,ct.converter)),get isTrusted(){return Ge.trusted},requestWorkspaceTrust:ie=>((0,$.checkProposedApiEnabled)(Oe),Ge.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,he,Ae)=>Ge.onDidGrantWorkspaceTrust(ie,he,Ae)},Ln={get inputBox(){return Qe.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),Gt.getLastInputBox(Oe)},createSourceControl(ie,he,Ae){return Gt.createSourceControl(Oe,ie,he,Ae)}},Fn={createCommentController(ie,he){return _n.createCommentController(Oe,ie,he)}},Mn={get activeDebugSession(){return vt.activeDebugSession},get activeDebugConsole(){return vt.activeDebugConsole},get breakpoints(){return vt.breakpoints},onDidStartDebugSession(ie,he,Ae){return vt.onDidStartDebugSession(ie,he,Ae)},onDidTerminateDebugSession(ie,he,Ae){return vt.onDidTerminateDebugSession(ie,he,Ae)},onDidChangeActiveDebugSession(ie,he,Ae){return vt.onDidChangeActiveDebugSession(ie,he,Ae)},onDidReceiveDebugSessionCustomEvent(ie,he,Ae){return vt.onDidReceiveDebugSessionCustomEvent(ie,he,Ae)},onDidChangeBreakpoints(ie,he,Ae){return vt.onDidChangeBreakpoints(ie,he,Ae)},registerDebugConfigurationProvider(ie,he,Ae){return vt.registerDebugConfigurationProvider(ie,he,Ae||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,he){return vt.registerDebugAdapterDescriptorFactory(Oe,ie,he)},registerDebugAdapterTrackerFactory(ie,he){return vt.registerDebugAdapterTrackerFactory(ie,he)},startDebugging(ie,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?vt.startDebugging(ie,he,{parentSession:Ae}):vt.startDebugging(ie,he,Ae||{})},stopDebugging(ie){return vt.stopDebugging(ie)},addBreakpoints(ie){return vt.addBreakpoints(ie)},removeBreakpoints(ie){return vt.removeBreakpoints(ie)},asDebugSourceUri(ie,he){return vt.asDebugSourceUri(ie,he)}},On={registerTaskProvider:(ie,he)=>At.registerTaskProvider(Oe,ie,he),fetchTasks:ie=>At.fetchTasks(ie),executeTask:ie=>At.executeTask(Oe,ie),get taskExecutions(){return At.taskExecutions},onDidStartTask:(ie,he,Ae)=>At.onDidStartTask(ie,he,Ae),onDidEndTask:(ie,he,Ae)=>At.onDidEndTask(ie,he,Ae),onDidStartTaskProcess:(ie,he,Ae)=>At.onDidStartTaskProcess(ie,he,Ae),onDidEndTaskProcess:(ie,he,Ae)=>At.onDidEndTaskProcess(ie,he,Ae)},un={createNotebookController(ie,he,Ae,lt,Et){return Zt.createNotebookController(Oe,ie,he,Ae,lt,Oe.enableProposedApi?Et:void 0)},registerNotebookCellStatusBarItemProvider:(ie,he)=>wt.registerNotebookCellStatusBarItemProvider(Oe,ie,he),get onDidSaveNotebookDocument(){return(0,$.checkProposedApiEnabled)(Oe),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,$.checkProposedApiEnabled)(Oe),Ht.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return en.createRendererMessaging(Oe,ie)},onDidChangeNotebookDocumentMetadata(ie,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),qt.onDidChangeNotebookDocumentMetadata(ie,he,Ae)},onDidChangeNotebookCells(ie,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),wt.onDidChangeNotebookCells(ie,he,Ae)},onDidChangeNotebookCellExecutionState(ie,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),wt.onDidChangeNotebookCellExecutionState(ie,he,Ae)},onDidChangeCellOutputs(ie,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),wt.onDidChangeCellOutputs(ie,he,Ae)},onDidChangeCellMetadata(ie,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),wt.onDidChangeCellMetadata(ie,he,Ae)},createConcatTextDocument(ie,he){return(0,$.checkProposedApiEnabled)(Oe),new Xe.ExtHostNotebookConcatDocument(wt,Dt,ie,he)}};return{version:ue.version,authentication:In,commands:Pn,comments:Fn,debug:Mn,env:vn,extensions:cn,languages:Tn,notebooks:un,scm:Ln,tasks:On,tests:An,window:Rn,workspace:bn,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionList:F.InlineSuggestions,Hover:F.Hover,IndentAction:A.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:c.UIKind,Uri:T.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:Pe.TextSearchCompleteMessageType,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ie}),define(me[275],ge([0,1,81,66,36,131,37,44,45,33,70,53,72,92,52,65,132,91,63,90,121,51]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b,P,l,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,g.registerSingleton)(y.IExtHostCommands,y.ExtHostCommands),(0,g.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,g.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,g.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(P.IExtHostFileSystemInfo,P.ExtHostFileSystemInfo),(0,g.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,g.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,g.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,g.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,g.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,g.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,g.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,g.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,g.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,g.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,g.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(me[93],ge([0,1,20,12,31,69]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=T;function y(I,c,m,h){const v=(0,g.mapArrayOrNot)(m,S),_=new k.TextSearchMatch(c,v,h),b=_.preview.matches;return{ranges:(0,g.mapArrayOrNot)(v,A),uri:I,preview:{text:_.preview.text,matches:(0,g.mapArrayOrNot)(b,A)}}}e.createTextSearchResult=y;function S(I){return new k.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function A(I){return new C.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let i=class{constructor(c,m){this.prefix=c,this.logService=m}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};i=ze([xe(1,R.ILogService)],i),e.OutputChannel=i}),define(me[276],ge([0,1,95,25]),function(Y,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,T=512,y=512*8,S=512*128;class A{constructor(s){this.iconvLiteDecoder=s}static async create(s){let o;if(s!==e.UTF8)o=(await new Promise((a,d)=>{Y(["iconv-lite-umd"],a,d)})).getDecoder(m(s));else{const n=new TextDecoder;o={write(a){return n.decode(a,{stream:!0})},end(){return n.decode()}}}return new A(o)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function i(t,s){const o=s.minBytesRequiredForDetection??s.guessEncoding?y:T;return new Promise((n,a)=>{const d=(0,g.newWriteableStream)(D=>D.join("")),u=[];let w=0,E;const r=async()=>{try{const D=await p({buffer:R.VSBuffer.concat(u),bytesRead:w},s.guessEncoding);D.encoding=await s.overwriteEncoding(D.encoding),E=await A.create(D.encoding);const L=E.write(R.VSBuffer.concat(u).buffer);d.write(L),u.length=0,w=0,n({stream:d,detected:D})}catch(D){a(D)}};(0,g.listenStream)(t,{onData:async D=>{E?d.write(E.write(D.buffer)):(u.push(D),w+=D.byteLength,w>=o&&(t.pause(),await r(),setTimeout(()=>t.resume())))},onError:D=>d.error(D),onEnd:async()=>{E||await r(),d.end(E?.end())}})})}e.toDecodeStream=i;async function I(t,s,o){const a=(await new Promise((w,E)=>{Y(["iconv-lite-umd"],w,E)})).getEncoder(m(s),o);let d=!1,u=!1;return{read(){if(u)return null;const w=t.read();if(typeof w!="string"){if(u=!0,!d&&o?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const E=a.end();return E&&E.length>0?(d=!0,R.VSBuffer.wrap(E)):null}return d=!0,R.VSBuffer.wrap(a.write(w))}}}e.toEncodeReadable=I;async function c(t){return(await new Promise((o,n)=>{Y(["iconv-lite-umd"],o,n)})).encodingExists(m(t))}e.encodingExists=c;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function h(t,s){if(!t||s<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),n=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return o===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=h;const v=["ascii","utf-16","utf-32"];async function _(t){const s=await new Promise((u,w)=>{Y(["jschardet"],u,w)}),o=t.slice(0,S),n=l(o.buffer),a=s.detect(n);if(!a||!a.encoding)return null;const d=a.encoding.toLowerCase();return 0<=v.indexOf(d)?null:P(a.encoding)}const b={ibm866:"cp866",big5:"cp950"};function P(t){const s=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[s]||s}function l(t){let s="";for(let o=0;o<t.length;o++)s+=String.fromCharCode(t[o]);return s}function f(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const s=t.match(/windows(\d+)/);return s?"windows-"+s[1]:t}}e.toCanonicalName=f;function p({buffer:t,bytesRead:s},o){let n=h(t,s),a=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let d=!0,u=!0,w=!1;for(let E=0;E<s&&E<C;E++){const r=E%2==1,D=t.readUInt8(E)===0;if(D&&(w=!0),d&&(r&&!D||!r&&D)&&(d=!1),u&&(r&&D||!r&&!D)&&(u=!1),D&&!d&&!u)break}w&&(d?n=e.UTF16le:u?n=e.UTF16be:a=!0)}return o&&!a&&!n&&t?_(t.slice(0,s)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:a,encoding:n}}e.detectEncodingFromBuffer=p,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[134],ge([0,1,276,28,133]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends k.TextSearchManager{constructor(y,S,A=R){super(y,S,{readdir:i=>A.Promises.readdir(i.fsPath),toCanonicalName:i=>(0,g.toCanonicalName)(i)})}}e.NativeTextSearchManager=C}),define(me[277],ge([0,1,278,293,294,2,295]),function(Y,e,g,R,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function y(I,c,m,h,v,_){const b=_.environment.useHostProxy,P=typeof b=="boolean"?b:!_.remote.isRemote,l=(0,T.createProxyResolver)({resolveProxy:p=>I.resolveProxy(p),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(p,t,...s)=>{switch(p){case T.LogLevel.Trace:h.trace(t,...s);break;case T.LogLevel.Debug:h.debug(t,...s);break;case T.LogLevel.Info:h.info(t,...s);break;case T.LogLevel.Warning:h.warn(t,...s);break;case T.LogLevel.Error:h.error(t,...s);break;case T.LogLevel.Critical:h.critical(t,...s);break;case T.LogLevel.Off:break;default:o(p,t,s);break}function o(n,a,...d){h.error("Unknown log level",n),h.error(a,...d)}},getLogLevel:()=>h.getLevel(),proxyResolveTelemetry:p=>{v.$publicLog2("resolveProxy",p)},useHostProxy:P,env:process.env}),f=S(c,l);return i(m,f)}e.connectProxyResolver=y;function S(I,c){const m={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(v=>{m.config=I.getConfiguration("http").get("proxySupport")||"off"});const h={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(v=>{h.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,T.createHttpPatch)(g,c,{config:"off"},h,!0)),on:Object.assign({},g,(0,T.createHttpPatch)(g,c,{config:"on"},h,!0)),override:Object.assign({},g,(0,T.createHttpPatch)(g,c,{config:"override"},h,!0)),onRequest:Object.assign({},g,(0,T.createHttpPatch)(g,c,m,h,!0)),default:Object.assign(g,(0,T.createHttpPatch)(g,c,m,h,!1))},https:{off:Object.assign({},R,(0,T.createHttpPatch)(R,c,{config:"off"},h,!0)),on:Object.assign({},R,(0,T.createHttpPatch)(R,c,{config:"on"},h,!0)),override:Object.assign({},R,(0,T.createHttpPatch)(R,c,{config:"override"},h,!0)),onRequest:Object.assign({},R,(0,T.createHttpPatch)(R,c,m,h,!0)),default:Object.assign(R,(0,T.createHttpPatch)(R,c,m,h,!1))},tls:Object.assign(k,(0,T.createTlsPatch)(k))}}const A=new Map;function i(I,c){return I.getExtensionPathIndex().then(m=>{const h=Y.__$__nodeRequire("module"),v=h._load;h._load=function(b,P,l){if(b==="tls")return c.tls;if(b!=="http"&&b!=="https")return v.apply(this,arguments);const f=c[b],p=m.findSubstr(C.URI.file(P.filename).fsPath);let t=A.get(p);if(t||A.set(p,t={}),!t[b]){let s=f.default;p&&p.enableProposedApi&&(s=f[p.proxySupport]||f.onRequest),t[b]={...s}}return t[b]}})}}),define(me[279],ge([0,1,39,8,77,29,11,9,93,280]),function(Y,e,g,R,k,C,T,y,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=A.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(l,f,p,t){const s=c(l,f,p,t),o=f.folder.fsPath;return{cmd:g.spawn(i,s.args,{cwd:o}),rgDiskPath:i,siblingClauses:s.siblingClauses,rgArgs:s,cwd:o}}e.spawnRipgrepCmd=I;function c(l,f,p,t){const s=["--files","--hidden","--case-sensitive"];h([f],p,!1).forEach(n=>{const a=(0,S.anchorGlob)(n);if(s.push("-g",a),T.isMacintosh){const d=(0,k.normalizeNFD)(a);d!==a&&s.push("-g",d)}});const o=m([f],t,void 0,!1);return o.globArgs.forEach(n=>{const a=`!${(0,S.anchorGlob)(n)}`;if(s.push("-g",a),T.isMacintosh){const d=(0,k.normalizeNFD)(a);d!==a&&s.push("-g",d)}}),f.disregardIgnoreFiles!==!1?s.push("--no-ignore"):s.push("--no-ignore-parent"),f.ignoreSymlinks||s.push("--follow"),l.exists&&s.push("--quiet"),s.push("--no-config"),f.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:o.siblingClauses}}function m(l,f,p,t=!0){const s=[];let o={};return l.forEach(n=>{const a=Object.assign({},n.excludePattern||{},f||{}),d=v(a,t?n.folder.fsPath:void 0,p);s.push(...d.globArgs),d.siblingClauses&&(o=Object.assign(o,d.siblingClauses))}),{globArgs:s,siblingClauses:o}}e.foldersToRgExcludeGlobs=m;function h(l,f,p=!0){const t=[];return l.forEach(s=>{const o=Object.assign({},f||{},s.includePattern||{}),n=v(o,p?s.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=h;function v(l,f,p){const t=[],s={};return Object.keys(l).forEach(o=>{if(p&&p.has(o)||!o)return;const n=l[o];o=b(f?_(f,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof n=="boolean"&&n?(o.startsWith("\\\\")&&(o+="**"),t.push(P(o))):n&&n.when&&(s[o]=n)}),{globArgs:t,siblingClauses:s}}function _(l,f){return R.isAbsolute(f)?f:R.join(l,f)}e.getAbsoluteGlob=_;function b(l){return l=y.rtrim(l,"\\"),y.rtrim(l,"/")}function P(l){return C.getRoot(l).toLowerCase()==="c:/"?l.replace(/^c:[/\\]/i,"/"):l}e.fixDriveC=P}),define(me[281],ge([0,1,39,49,8,103,20,60,30,77,29,11,46,9,14,28,31,279,100]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const l=new Set;process.on("exit",()=>{l.forEach(o=>o())});class f{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&S.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,P.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&S.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(a=>{const d=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),u=a.folder.fsPath;n.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==u).forEach(w=>{(0,i.isEqualOrParent)(w,u)&&(d[k.relative(u,w)]=!0)}),this.folderExcludePatterns.set(u,new t(d,u))})}cancel(){this.isCanceled=!0}walk(n,a,d,u,w){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);a.forEach(E=>{const r=k.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,r)||this.matchFile(d,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(n,(E,r)=>{this.call(this.cmdTraversal,this,E,d,u,D=>{if(D){const L=(0,y.toErrorMessage)(D);console.error(L),this.errors.push(L),r(D,void 0)}else r(null,void 0)})},(E,r)=>{this.fileWalkSW.stop();const D=E?T.coalesce(E)[0]:null;w(D,this.isLimitHit)})}parallel(n,a,d){const u=new Array(n.length),w=new Array(n.length);let E=!1,r=0;if(n.length===0)return d(null,[]);n.forEach((D,L)=>{a(D,(U,j)=>{if(U?(E=!0,u[L]=null,w[L]=U):(u[L]=j,w[L]=null),++r===n.length)return d(E?w:null,u)})})}call(n,a,...d){try{n.apply(a,d)}catch(u){d[d.length-1](u)}}cmdTraversal(n,a,d,u){const w=n.folder.fsPath,E=I.isMacintosh;let r;const D=()=>r&&r.kill();l.add(D);let L=F=>{l.delete(D),L=()=>{},u(F)},U="";const j=this.initDirectoryTree();let te;const K=(0,b.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);r=K.cmd,te=!Object.keys(K.siblingClauses).length;const O=K.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let x=`${K.rgDiskPath} ${O}
 - cwd: ${K.cwd}`;K.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(K.rgArgs.siblingClauses)}`),d({message:x}),this.cmdResultCount=0,this.collectStdout(r,"utf8",d,(F,z,M)=>{if(F){L(F);return}if(this.isLimitHit){L();return}const V=(U+(E?A.normalizeNFC(z||""):z)).split(`
`);if(M){const $=V.length;V[$-1]=V[$-1].trim(),V[$-1]||V.pop()}else U=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,te){for(const $ of V)if(this.matchFile(a,{base:w,relativePath:$,searchPath:this.getSearchPath(n,$)}),this.isLimitHit){D();break}(M||this.isLimitHit)&&L();return}this.addDirectoryEntries(n,j,w,V,a),M&&(this.matchDirectoryTree(j,w,a),L())})}spawnFindCmd(n){const a=this.folderExcludePatterns.get(n.folder.fsPath),d=a.getBasenameTerms(),u=a.getPathTerms(),w=["-L","."];if(d.length||u.length){w.push("-not","(","(");for(const E of d)w.push("-name",E),w.push("-o");for(const E of u)w.push("-path",E),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),g.spawn("find",w,{cwd:n.folder.fsPath})}readStdout(n,a,d){let u="";this.collectStdout(n,a,()=>{},(w,E,r)=>{if(w){d(w);return}u+=E,r&&d(null,u)})}collectStdout(n,a,d,u){let w=(D,L,U)=>{(D||U)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),u(D,L,U)},E=!1;n.stdout?(this.forwardData(n.stdout,a,w),n.stdout.once("data",()=>E=!0)):d({message:"stdout is null"});let r;n.stderr?r=this.collectData(n.stderr):d({message:"stderr is null"}),n.on("error",D=>{w(D)}),n.on("close",D=>{let L;!E&&(L=this.decodeData(r,a))&&s(L)?w(new Error(`command failed with error code ${D}: ${this.decodeData(r,a)}`)):(this.exists&&D===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(n,a,d){const u=new C.StringDecoder(a);return n.on("data",w=>{d(null,u.write(w))}),u}collectData(n){const a=[];return n.on("data",d=>{a.push(d)}),a}decodeData(n,a){const d=new C.StringDecoder(a);return n.map(u=>d.write(u)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:a},d,u,w){u.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const E=r=>{const D=k.basename(r),L=k.dirname(r);let U=a[L];U||(U=a[L]=[],E(L)),U.push({base:d,relativePath:r,basename:D,searchPath:this.getSearchPath(n,r)})};u.forEach(E)}matchDirectoryTree({rootEntries:n,pathToEntries:a},d,u){const w=this,E=this.folderExcludePatterns.get(d),r=this.filePattern;function D(L){w.directoriesWalked++;const U=S.hasSiblingFn(()=>L.map(j=>j.basename));for(let j=0,te=L.length;j<te;j++){const K=L[j],{relativePath:O,basename:x}=K;if(E.test(O,x,r!==x?U:void 0))continue;const F=a[O];if(F)D(F);else{if(w.filesWalked++,O===r)continue;w.matchFile(u,K)}if(w.isLimitHit)break}}D(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,a,d,u,w){const E=n.folder,r=S.hasSiblingFn(()=>d);this.parallel(d,(D,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const U=a?[a,D].join(k.sep):D;if(this.folderExcludePatterns.get(n.folder.fsPath).test(U,D,this.config.filePattern!==D?r:void 0))return L(null);const j=[E.fsPath,U].join(k.sep);R.lstat(j,(te,K)=>{if(te||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(j,K,(O,x)=>O||this.isCanceled||this.isLimitHit?L(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(j,K,(F,z)=>F||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?L(null):(this.walkedPaths[z]=!0,v.Promises.readdir(j).then(M=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(n,U,M,u,N=>L(N||null))},M=>{L(null)})))):(this.filesWalked++,U===this.filePattern||this.maxFilesize&&h.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(u,{base:E.fsPath,relativePath:U,searchPath:this.getSearchPath(n,U)}),L(null,void 0)))})},D=>{const L=D&&T.coalesce(D);return w(L&&L.length>0?L[0]:void 0)})}matchFile(n,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,k.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(a))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,a,d){return a.isSymbolicLink()?R.stat(n,d):d(null,a)}realPathIfNeeded(n,a,d){return a.isSymbolicLink()?R.realpath(n,(u,w)=>u?d(u):d(null,w)):d(null,n)}getSearchPath(n,a){return n.folderName?k.join(n.folderName,a):a}}e.FileWalker=f;class p{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new f(n)}search(n,a,d){this.walker.walk(this.folderQueries,this.extraFiles,n,a,(u,w)=>{d(u,{limitHit:w,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(n,a){this.expression=n,this.root=a,this.init(n)}init(n){let a,d;Object.keys(n).filter(u=>n[u]).forEach(u=>{k.isAbsolute(u)?(a=a||S.getEmptyExpression(),a[u]=n[u]):(d=d||S.getEmptyExpression(),d[u]=n[u])}),this.absoluteParsedExpr=a&&S.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=d&&S.parse(d,{trimForExclusions:!0})}test(n,a,d){return this.relativeParsedExpr&&this.relativeParsedExpr(n,a,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,n),a,d)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getPathTerms(this.relativeParsedExpr)),n}}function s(o){const n=o.trim().split(`
`),a=n[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return m.uppercaseFirstLetter(n[n.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=s}),define(me[135],ge([0,1,39,296,103,20,55,30,8,9,2,31,69,297,280,93]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class b{constructor(E){this.outputChannel=E}provideTextSearchResults(E,r,D,L){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...r,folder:r.folder.toString()})}`),new Promise((U,j)=>{L.onCancellationRequested(()=>N());const te=s(E,r),K=r.folder.fsPath,O=te.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.outputChannel.appendLine(`${_} ${O}
 - cwd: ${K}`);let x=g.spawn(_,te,{cwd:K});x.on("error",fe=>{console.error(fe),this.outputChannel.appendLine("Error: "+(fe&&fe.message)),j((0,I.serializeSearchError)(new I.SearchError(fe&&fe.message,I.SearchErrorCode.rgProcessError)))});let F=!1;const z=new f(r.maxResults,K,r.previewOptions);z.on("result",fe=>{F=!0,$="",D.report(fe)});let M=!1;const N=()=>{M=!0,x&&x.kill(),z&&z.cancel()};let V=!1;z.on("hitLimit",()=>{V=!0,N()});let $="";x.stdout.on("data",fe=>{z.handleData(fe),F||($+=fe)});let G=!1;x.stdout.once("data",()=>G=!0);let J="";x.stderr.on("data",fe=>{const ye=fe.toString();this.outputChannel.appendLine(ye),J+=ye}),x.on("close",()=>{if(this.outputChannel.appendLine(G?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(F?"Got result from parser":"No result from parser"),$&&this.outputChannel.appendLine(`Got data without result: ${$}`),this.outputChannel.appendLine(""),M)U({limitHit:V});else{z.flush(),x=null;let fe;J&&!G&&(fe=P(J))?j((0,I.serializeSearchError)(new I.SearchError(fe.message,fe.code))):U({limitHit:V})}})})}}e.RipgrepTextSearchEngine=b;function P(w){const E=w.split(`
`),r=E[0].trim();if(E.some(L=>L.startsWith("regex parse error")))return new I.SearchError(l(E),I.SearchErrorCode.regexParseError);const D=r.match(/grep config error: unknown encoding: (.*)/);if(D)return new I.SearchError(`Unknown encoding: ${D[1]}`,I.SearchErrorCode.unknownEncoding);if(r.startsWith("error parsing glob"))return new I.SearchError(r.charAt(0).toUpperCase()+r.substr(1),I.SearchErrorCode.globParseError);if(r.startsWith("the literal"))return new I.SearchError(r.charAt(0).toUpperCase()+r.substr(1),I.SearchErrorCode.invalidLiteral);if(r.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(r,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=P;function l(w){const E=["Regex parse error"],r=w.filter(D=>D.startsWith("PCRE2:"));if(r.length>=1){const D=r[0].replace("PCRE2:","");if(D.indexOf(":")!==-1&&D.split(":").length>=2){const L=D.split(":")[1];E.push(":"+L)}}return E.join("")}e.buildRegexParseError=l;class f extends R.EventEmitter{constructor(E,r,D){super();this.maxResults=E,this.rootFolder=r,this.previewOptions=D,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,r){return super.on(E,r),this}handleData(E){if(this.isDone)return;const r=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(r)}handleDecodedData(E){let r=E.indexOf(`
`);const D=this.remainder+E;if(r>=0)r+=this.remainder.length;else{this.remainder=D;return}let L=0;for(;r>=0;)this.handleLine(D.substring(L,r).trim()),L=r+1,r=D.indexOf(`
`,L);this.remainder=D.substring(L)}handleLine(E){if(this.isDone||!E)return;let r;try{r=JSON.parse(E)}catch(D){throw new Error(`malformed line from rg: ${E}`)}if(r.type==="match"){const D=p(r.data.path),L=i.URI.file(S.join(this.rootFolder,D)),U=this.createTextSearchMatch(r.data,L);this.onResult(U),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(r.type==="context"){const D=p(r.data.path),L=i.URI.file(S.join(this.rootFolder,D));this.createTextSearchContext(r.data,L).forEach(j=>this.onResult(j))}}createTextSearchMatch(E,r){const D=E.line_number-1,L=p(E.lines),U=Buffer.from(L);let j=0,te=0,K=D;E.submatches.length===0&&E.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const O=(0,C.coalesce)(E.submatches.map((x,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const z=p(x.match),M=U.slice(j,x.start).toString().length,N=te+M,V=t(z),$=K,G=V.numLines+$,J=V.numLines>0?V.lastLineLength:V.lastLineLength+N;return j=x.end,te=J,K=G,new c.Range($,N,G,J)}));return(0,v.createTextSearchResult)(r,L,O,this.previewOptions)}createTextSearchContext(E,r){const D=p(E.lines),L=E.line_number;return D.replace(/\r?\n$/,"").split(`
`).map((U,j)=>({text:U,uri:r,lineNumber:L+j}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=f;function p(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const E=/\n/g;let r=0,D=-1,L;for(;L=E.exec(w);)r++,D=L.index;const U=D>=0?w.length-D-1:w.length;return{numLines:r,lastLineLength:U}}function s(w,E){const r=["--hidden"];r.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:D,otherIncludes:L}=(0,T.groupBy)(E.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const j=new Set;L.forEach(te=>{j.add(te)}),r.push("-g","!*"),j.forEach(te=>{o(te).map(v.anchorGlob).forEach(K=>{r.push("-g",K)})})}D&&D.length&&D.forEach(j=>{r.push("-g",j)}),E.excludes.map(v.anchorGlob).forEach(j=>r.push("-g",`!${j}`)),E.maxFileSize&&r.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?r.push("--no-ignore-parent"):r.push("--no-ignore"),E.followSymlinks&&r.push("--follow"),E.encoding&&E.encoding!=="utf8"&&r.push("--encoding",E.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,A.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),E.usePCRE2&&r.push("--pcre2"),r.push("--crlf"),w.isRegExp&&(w.pattern=n(w.pattern),r.push("--auto-hybrid-regex"));let U;if(w.isWordMatch){const te=(0,A.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");r.push("--regexp",te)}else if(w.isRegExp){let j=d(w.pattern);j=u(j),r.push("--regexp",j)}else U=w.pattern,r.push("--fixed-strings");return r.push("--no-config"),E.useGlobalIgnoreFiles||r.push("--no-ignore-global"),r.push("--json"),w.isMultiline&&r.push("--multiline"),E.beforeContext&&r.push("--before-context",E.beforeContext+""),E.afterContext&&r.push("--after-context",E.afterContext+""),r.push("--"),U&&r.push(U),r.push("."),r}function o(w){const E=(0,y.splitGlobAware)(w,"/");return E.map((r,D)=>E.slice(0,D+1).join("/"))}e.spreadGlobComponents=o;function n(w){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(E);)w=w.replace(E,"$1\\x{$2}");const r=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(r);)w=w.replace(r,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=n;const a=w=>w.type==="Assertion"&&w.kind==="lookbehind";function d(w){let E;try{E=new m.RegExpParser().parsePattern(w)}catch{return w}let r="",D=0;const L=(te,K,O)=>{r+=w.slice(D,te)+O,D=K},U=[];return new m.RegExpVisitor({onCharacterEnter(te){if(te.raw!=="\\n")return;const K=U[0];if(!K)L(te.start,te.end,"\\r?\\n");else if(!U.some(a))if(K.type==="CharacterClass")if(K.negate){const O=w.slice(K.start+2,te.start)+w.slice(te.end,K.end-1);L(K.start,K.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=w.slice(K.start+1,te.start)+w.slice(te.end,K.end-1);L(K.start,K.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else K.type==="Quantifier"&&L(te.start,te.end,"(?:\\r?\\n)")},onQuantifierEnter(te){U.unshift(te)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(te){U.unshift(te)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(te){U.unshift(te)},onCharacterClassLeave(){U.shift()},onAssertionEnter(te){a(te)&&U.push(te)},onAssertionLeave(te){U[0]===te&&U.shift()}}).visit(E),r+=w.slice(D),r}e.fixRegexNewline=d;function u(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=u}),define(me[282],ge([0,1,21,135,117,10]),function(Y,e,g,R,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(A){this.outputChannel=A,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(A,i,I,c){const m=new R.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===C.Schemas.userData){const h={...i,folder:i.folder.with({scheme:C.Schemas.file})},v=new k.Progress(_=>I.report({..._,uri:_.uri.with({scheme:i.folder.scheme})}));return this.withToken(c,_=>m.provideTextSearchResults(A,h,v,_))}else return this.withToken(c,h=>m.provideTextSearchResults(A,i,I,h))}async withToken(A,i){const I=y(A);this.inProgress.add(I);const c=await i(I.token);return this.inProgress.delete(I),c}dispose(){this.inProgress.forEach(A=>A.cancel())}}e.RipgrepSearchProvider=T;function y(S){const A=new g.CancellationTokenSource;return S.onCancellationRequested(()=>A.cancel()),A}}),define(me[283],ge([0,1,28,135,134]),function(Y,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(S){this.query=S}search(S,A,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(m){i({message:m})}},c=new k.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(I),g);return new Promise((m,h)=>c.search(v=>{A(v.map(T))},S).then(v=>m({limitHit:v.limitHit,type:"success"}),h))}}e.TextSearchEngineAdapter=C;function T(y){return{path:y.resource&&y.resource.fsPath,results:y.results,numMatches:(y.results||[]).reduce((S,A)=>{if(A.ranges){const i=A;return S+(Array.isArray(i.ranges)?i.ranges.length:1)}else return S+1},0)}}}),define(me[284],ge([0,1,49,298,20,17,16,3,100,8,46,2,42,31,281,283]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(g);class _{constructor(){this.caches=Object.create(null)}fileSearch(t){let s;const o=l(t),n=new y.Emitter({onFirstListenerDidAdd:()=>{s=(0,C.createCancelablePromise)(a=>this.doFileSearchWithEngine(h.Engine,o,d=>n.fire(d),a)),s.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return n.event}textSearch(t){let s;const o=l(t),n=new y.Emitter({onFirstListenerDidAdd:()=>{s=(0,C.createCancelablePromise)(a=>this.ripgrepTextSearch(o,d=>n.fire(d),a)),s.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return n.event}ripgrepTextSearch(t,s,o){return t.maxFileSize=(0,c.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new v.TextSearchEngineAdapter(t).search(o,s,s)}doFileSearch(t,s,o){return this.doFileSearchWithEngine(h.Engine,t,s,o)}doFileSearchWithEngine(t,s,o,n,a=_.BATCH_SIZE){let d=0;const u=E=>{Array.isArray(E)?(d+=E.length,o(E.map(r=>this.rawMatchToSearchItem(r)))):E.relativePath?(d++,o(this.rawMatchToSearchItem(E))):o(E)};if(s.sortByScore){let E=this.trySortedSearchFromCache(s,u,n);if(!E){const r=s.maxResults?Object.assign({},s,{maxResults:null}):s,D=new t(r);E=this.doSortedSearch(D,s,o,u,n)}return new Promise((r,D)=>{E.then(([L,U])=>{const j=U.map(te=>this.rawMatchToSearchItem(te));this.sendProgress(j,o,a),r(L)},D)})}const w=new t(s);return this.doSearch(w,u,a,n).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:"searchProcess",fromCache:!1,resultCount:d,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,A.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,s,o,n,a){const d=new y.Emitter;let u=(0,C.createCancelablePromise)(E=>{let r=[];const D=L=>{Array.isArray(L)?r=L:(n(L),d.fire(L))};return this.doSearch(t,D,-1,E).then(L=>[L,r])}),w;if(s.cacheKey){w=this.getOrCreateCache(s.cacheKey);const E={promise:u,event:d.event,resolved:!1};w.resultsToSearchCache[s.filePattern||""]=E,u.then(()=>{E.resolved=!0},r=>{delete w.resultsToSearchCache[s.filePattern||""]}),u=this.preventCancellation(u)}return u.then(([E,r])=>{const D=w?w.scorerCache:Object.create(null),L=(typeof s.maxResults!="number"||s.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(s,r,D,a).then(U=>{const j=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:j,fromCache:!1,type:"searchProcess",workspaceFolderCount:s.folderQueries.length,resultCount:U.length},messages:E.messages,limitHit:E.limitHit||typeof s.maxResults=="number"&&r.length>s.maxResults},U]})})}getOrCreateCache(t){const s=this.caches[t];return s||(this.caches[t]=new b)}trySortedSearchFromCache(t,s,o){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const a=this.getResultsFromCache(n,t.filePattern||"",s,o);if(a)return a.then(([d,u,w])=>{const E=i.StopWatch.create(!1);return this.sortResults(t,u,n.scorerCache,o).then(r=>{const D=E.elapsed(),L={fromCache:!0,detailStats:w,type:"searchProcess",resultCount:u.length,sortingTime:D};return[{type:"success",limitHit:d.limitHit||typeof t.maxResults=="number"&&u.length>t.maxResults,stats:L},r]})})}sortResults(t,s,o,n){const a=(0,S.prepareQuery)(t.filePattern||""),d=(w,E)=>(0,S.compareItemsByFuzzyScore)(w,E,a,!0,P,o),u=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(s,d,u,1e4,n)}sendProgress(t,s,o){if(o&&o>0)for(let n=0;n<t.length;n+=o)s(t.slice(n,n+o));else s(t)}getResultsFromCache(t,s,o,n){const a=i.StopWatch.create(!1),d=s.indexOf(A.sep)>=0;let u;for(const D in t.resultsToSearchCache)if(s.startsWith(D)){if(d&&D.indexOf(A.sep)<0&&D!=="")continue;const L=t.resultsToSearchCache[D];u={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!u)return null;const w=a.elapsed(),E=i.StopWatch.create(!1),r=u.event(o);return n&&n.onCancellationRequested(()=>{r.dispose()}),u.promise.then(([D,L])=>{if(n&&n.isCancellationRequested)throw(0,T.canceled)();const U=[],j=(0,S.prepareQuery)(s).normalizedLowercase;for(const te of L)!(0,m.isFilePatternMatch)(te,j)||U.push(te);return[D,U,{cacheWasResolved:u.resolved,cacheLookupTime:w,cacheFilterTime:E.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,s,o,n){return new Promise((a,d)=>{let u=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(o?(u.push(w),o>0&&u.length>=o&&(s(u),u=[])):s(w))},w=>{s(w)},(w,E)=>{u.length&&s(u),w?d(w):a(E)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,o){return t.then(s,o)}catch(s){return this.then(void 0,s)}finally(s){return t.finally(s)}}}}e.SearchService=_,_.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const P=new class{getItemLabel(p){return(0,A.basename)(p.relativePath)}getItemDescription(p){return(0,A.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(f),extraFileResources:p.extraFileResources&&p.extraFileResources.map(t=>I.URI.revive(t))}}function f(p){return{...p,folder:I.URI.revive(p.folder)}}}),define(me[285],ge([0,1,6,2,28,12,31,284,282,93,13,64,27,72,10,134]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends m.ExtHostSearch{constructor(P,l,f,p){super(P,f,p);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new A.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(h.Schemas.userData,new S.RipgrepSearchProvider(t)),l.remote.isRemote&&l.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const P=new A.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(h.Schemas.file,new S.RipgrepSearchProvider(P)),this.registerInternalFileSearchProvider(h.Schemas.file,new y.SearchService)}registerInternalFileSearchProvider(P,l){const f=this._handlePool++;return this._internalFileSearchProvider=l,this._internalFileSearchHandle=f,this._proxy.$registerFileSearchProvider(f,this._transformScheme(P)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(P,l,f,p){const t=(0,m.reviveQuery)(f);return P===this._internalFileSearchHandle?this.doInternalFileSearch(P,l,t,p):super.$provideFileSearchResults(P,l,f,p)}doInternalFileSearch(P,l,f,p){const t=s=>{if((0,T.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this._proxy.$handleFileMatch(P,l,s.map(o=>R.URI.file(o.path)));return}s.message&&this._logService.debug("ExtHostSearch",s.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(f,t,p)}$clearCache(P){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(P),super.$clearCache(P)}createTextSearchManager(P,l){return new v.NativeTextSearchManager(P,l)}};_=ze([xe(0,i.IExtHostRpcService),xe(1,c.IExtHostInitDataService),xe(2,I.IURITransformerService),xe(3,C.ILogService)],_),e.NativeExtHostSearch=_}),define(me[136],ge([0,1,299,124,79,25,16,3,6,8,11,32,105,106,300]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(u){this.socket=u,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const w=E=>u(C.VSBuffer.wrap(E));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(u){const w=E=>{u({type:0,hadError:E,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((u,w)=>{if(this.socket.bufferSize===0){u();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),u()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=v;var _;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var b;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(b||(b={}));class P extends S.Disposable{constructor(u,w,E,r){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=r,w?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",D=>{console.error(D),(0,T.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})}),this._zlibInflate.on("data",D=>{this._pendingInflateData.push(D)}),E&&(this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",D=>{console.error(D),(0,T.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})}),this._zlibDeflate.on("data",D=>{this._pendingDeflateData.push(D)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new m.ChunkStream,this._register(this.socket.onData(D=>this._acceptChunk(D))),this._register(this.socket.onClose(D=>this._onClose.fire(D)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(C.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,w){let E=2;u.byteLength<126?E+=0:u.byteLength<2**16?E+=2:E+=8;const r=C.VSBuffer.alloc(E);if(w?r.writeUInt8(194,0):r.writeUInt8(130,0),u.byteLength<126)r.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){r.writeUInt8(126,1);let D=1;r.writeUInt8(u.byteLength>>>8&255,++D),r.writeUInt8(u.byteLength>>>0&255,++D)}else{r.writeUInt8(127,1);let D=1;r.writeUInt8(0,++D),r.writeUInt8(0,++D),r.writeUInt8(0,++D),r.writeUInt8(0,++D),r.writeUInt8(u.byteLength>>>24&255,++D),r.writeUInt8(u.byteLength>>>16&255,++D),r.writeUInt8(u.byteLength>>>8&255,++D),r.writeUInt8(u.byteLength>>>0&255,++D)}this._totalOutgoingWireBytes+=r.byteLength+u.byteLength,this.socket.write(C.VSBuffer.concat([r,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),r=(w.readUInt8(0)&128)>>>7,D=w.readUInt8(1),L=(D&128)>>>7,U=D&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(U===126?2:0)+(U===127?8:0),this._state.fin=r,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),E=w.readUInt8(1),r=(E&128)>>>7;let D=E&127,L=1;D===126?D=w.readUInt8(++L)*2**8+w.readUInt8(++L):D===127&&(D=w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L));let U=0;r&&(U=w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L)),this._state.state=3,this._state.readLen=D,this._state.mask=U}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);l(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const E=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=E.length,this._onData.fire(C.VSBuffer.wrap(E))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=P;function l(d,u){if(u===0)return;let w=d.byteLength>>>2;for(let j=0;j<w;j++){const te=d.readUInt32BE(j*4);d.writeUInt32BE(te^u,j*4)}let E=w*4,r=d.byteLength-E;const D=u>>>24&255,L=u>>>16&255,U=u>>>8&255;r>=1&&d.writeUInt8(d.readUInt8(E)^D,E),r>=2&&d.writeUInt8(d.readUInt8(E+1)^L,E+1),r>=3&&d.writeUInt8(d.readUInt8(E+2)^U,E+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const f={[2]:107,[1]:103};function p(){const d=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):u=(0,A.join)((0,k.tmpdir)(),`vscode-ipc-${d}.sock`),s(u),u}e.createRandomIPCHandle=p;function t(d,u,w){const E=(0,g.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${w}-${u}-sock`;let r;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?r=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${w}-${u}.sock`):r=(0,A.join)(d,`${w}-${u}.sock`),s(r),r}e.createStaticIPCHandle=t;function s(d){const u=f[i.platform];typeof u=="number"&&d.length>=u&&console.warn(`WARNING: IPC handle "${d}" is longer than ${u} chars, try a shorter --user-data-dir`)}class o extends c.IPCServer{constructor(u){super(o.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const w=y.Event.fromNodeEventEmitter(u,"connection");return y.Event.map(w,E=>({protocol:new m.Protocol(new v(E)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(E,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function n(d){return new Promise((u,w)=>{const E=(0,R.createServer)();E.on("error",w),E.listen(d,()=>{E.removeListener("error",w),u(new o(E))})})}e.serve=n;function a(d,u){return new Promise((w,E)=>{const r=(0,R.createConnection)(d,()=>{r.removeListener("error",E),w(m.Client.fromSocket(new v(r),u))});r.once("error",E)})}e.connect=a}),define(me[286],ge([0,1,136,278,49,44,2,198,12]),function(Y,e,g,R,k,C,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class A{constructor(c,m,h){this._commands=c,this.logService=m,this._ipcHandlePath=h,this._server=R.createServer((v,_)=>this.onRequest(v,_)),this.setup().catch(v=>(m.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch(c){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,m){const h=[];c.setEncoding("utf8"),c.on("data",v=>h.push(v)),c.on("end",()=>{const v=JSON.parse(h.join(""));switch(v.type){case"open":this.open(v,m);break;case"openExternal":this.openExternal(v,m);break;case"status":this.getStatus(v,m);break;case"extensionManagement":this.manageExtensions(v,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${v.type}`,_=>{_&&this.logService.error(_)}),m.end();break}})}open(c,m){let{fileURIs:h,folderURIs:v,forceNewWindow:_,diffMode:b,addMode:P,forceReuseWindow:l,gotoLineMode:f,waitMarkerFilePath:p}=c;const t=[];if(Array.isArray(v))for(const s of v)try{t.push({folderUri:T.URI.parse(s)})}catch(o){}if(Array.isArray(h))for(const s of h)try{(0,y.hasWorkspaceFileExtension)(s)?t.push({workspaceUri:T.URI.parse(s)}):t.push({fileUri:T.URI.parse(s)})}catch(o){}if(t.length){const s=p?T.URI.file(p):void 0,n={forceNewWindow:_,diffMode:b,addMode:P,gotoLineMode:f,forceReuseWindow:l,preferNewWindow:!l&&!s&&!P,waitMarkerFileURI:s};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}m.writeHead(200),m.end()}async openExternal(c,m){for(const h of c.uris){const v=T.URI.parse(h),_=v.scheme==="file"?v:h;await this._commands.executeCommand("_remoteCLI.openExternal",_)}m.writeHead(200),m.end()}async manageExtensions(c,m){try{const h=b=>b?.map(P=>/\.vsix$/i.test(P)?T.URI.parse(P):P),v={list:c.list,install:h(c.install),uninstall:h(c.uninstall),force:c.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);m.writeHead(200),m.write(_)}catch(h){m.writeHead(500),m.write(String(h),v=>{v&&this.logService.error(v)})}m.end()}async getStatus(c,m){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(h),m.end()}catch(h){m.writeHead(500),m.write(String(h),v=>{v&&this.logService.error(v)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=A;let i=class extends A{constructor(c,m){super(c,m,(0,g.createRandomIPCHandle)())}};i=ze([xe(0,C.IExtHostCommands),xe(1,S.ILogService)],i),e.CLIServer=i}),define(me[287],ge([0,1,71,274,269,5,277,40,259,2,10,7,286,104]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends k.RequireInterceptor{_installInterceptor(){const b=this,P=Y.__$__nodeRequire("module"),l=P._load;P._load=function(p,t,s){for(let o of b._alternatives){let n=o(p);if(n){p=n;break}}return b._factories.has(p)?b._factories.get(p).load(p,A.URI.file((0,m.realpathSync)(t.filename)),o=>l.apply(this,[o,t,s])):l.apply(this,arguments)}}}class v extends y.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const b=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(h,b,this._registry).install(),g.mark("code/extHost/didInitAPI");const l=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,l,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const f=process.send,p=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?f.apply(process,t):(p.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(b){return b.main}_loadCommonJSModule(b,P,l){if(P.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${P}', must be of file-scheme`);let f=null;l.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${P.toString(!0)}`),this._logService.flush();try{b&&g.mark(`code/extHost/willLoadExtensionCode/${b.value}`),f=Y.__$__nodeRequire(P.fsPath)}catch(p){return Promise.reject(p)}finally{b&&g.mark(`code/extHost/didLoadExtensionCode/${b.value}`),l.codeLoadingStop()}return Promise.resolve(f)}async $setRemoteEnvironment(b){if(!!this._initData.remote.isRemote)for(const P in b){const l=b[P];l===null?delete process.env[P]:process.env[P]=l}}}e.ExtHostExtensionService=v}),define(me[288],ge([0,1,81,260,262,271,270,285,287,227,263,53,40,66,72,70,33,52,12,67,261]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_,b,P,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(c.IExtHostExtensionService,S.ExtHostExtensionService),(0,g.registerSingleton)(P.ILogService,A.ExtHostLogService),(0,g.registerSingleton)(l.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,g.registerSingleton)(I.IExtHostDebugService,T.ExtHostDebugService),(0,g.registerSingleton)(m.IExtHostOutputService,R.ExtHostOutputService2),(0,g.registerSingleton)(h.IExtHostSearch,y.NativeExtHostSearch),(0,g.registerSingleton)(v.IExtHostTask,C.ExtHostTask),(0,g.registerSingleton)(_.IExtHostTerminalService,k.ExtHostTerminalService),(0,g.registerSingleton)(b.IExtHostTunnelService,i.ExtHostTunnelService)}),define(me[289],ge([0,1,124,301,71,16,106,136,191,225,272,25,102,28,104,17,113,275,288]),function(Y,e,g,R,k,C,T,y,S,A,i,I,c,m,h,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let a=0;a<process.execArgv.length;a++)process.execArgv[a]==="--inspect-port=0"&&(process.execArgv.splice(a,1),a--)}();const b=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const n=Y.__$__nodeRequire("module"),a=n._load;n._load=function(d){if(d==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return a.apply(this,arguments)}})();const P=process.exit.bind(process);function l(n){process.exit=function(a){if(n)P(a);else{const d=new Error("An extension called process.exit() and this was prevented.");console.warn(d.stack)}},process.crash=function(){const a=new Error("An extension called process.crash() and this was prevented.");console.warn(a.stack)}}let f=function(n){P()};function p(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,a)=>{let d=null,u=setTimeout(()=>{f("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const w=108e5,E=3e5,r=new v.RunOnceScheduler(()=>f("renderer disconnected for too long (1)"),w),D=new v.RunOnceScheduler(()=>f("renderer disconnected for too long (2)"),E);process.on("message",(U,j)=>{if(U&&U.type==="VSCODE_EXTHOST_IPC_SOCKET"){const te=I.VSBuffer.wrap(Buffer.from(U.initialDataChunk,"base64"));let K;if(U.skipWebSocketFrames)K=new y.NodeSocket(j);else{const O=I.VSBuffer.wrap(Buffer.from(U.inflateBytes,"base64"));K=new y.WebSocketNodeSocket(new y.NodeSocket(j),U.permessageDeflate,O,!1)}d?(r.cancel(),D.cancel(),d.beginAcceptReconnection(K,te),d.endAcceptReconnection()):(clearTimeout(u),d=new T.PersistentProtocol(K,te),d.onDidDispose(()=>f("renderer disconnected")),n(d),d.onSocketClose(()=>{r.schedule()}))}if(U&&U.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(D.isScheduled())return;r.isScheduled()&&D.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((a,d)=>{const u=g.createConnection(n,()=>{u.removeListener("error",d),a(new T.PersistentProtocol(new y.NodeSocket(u)))});u.once("error",d),u.on("close",()=>{f("renderer closed the socket")})})}}async function t(){const n=await p();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(a=>{(0,A.isMessageOfType)(a,2)?(this._terminating=!0,f("received terminate message from renderer")):this._onMessage.fire(a)})}send(a){this._terminating||n.send(a)}drain(){return n.drain()}}}function s(n){return new Promise(a=>{const d=n.onMessage(u=>{d.dispose();const w=JSON.parse(u.toString()),E=w.commit,r=S.default.commit;E&&r&&E!==r&&P(55);const D=[];process.on("unhandledRejection",(j,te)=>{D.push(te),setTimeout(()=>{const K=D.indexOf(te);K>=0&&te.catch(O=>{D.splice(K,1),(0,C.isPromiseCanceledError)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),(0,C.onUnexpectedError)(j))})},1e3)}),process.on("rejectionHandled",j=>{const te=D.indexOf(j);te>=0&&D.splice(te,1)}),process.on("uncaughtException",function(j){(0,C.onUnexpectedError)(j)});let L=0;setInterval(function(){try{process.kill(w.parentPid,0),L=0}catch(j){j&&j.code==="EPERM"?(L++,L>=3&&f(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):f(`parent process ${w.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let U;try{U=Y.__$__nodeRequire("native-watchdog"),U.start(w.parentPid)}catch(j){(0,C.onUnexpectedError)(j)}n.send((0,A.createMessageOfType)(0)),a({protocol:n,initData:w})});n.send((0,A.createMessageOfType)(1))})}async function o(){k.mark("code/extHost/willConnectToRenderer");const n=await t();k.mark("code/extHost/didConnectToRenderer");const a=await s(n);k.mark("code/extHost/didWaitForInitData");const{initData:d}=a;l(!!d.environment.extensionTestsLocationURI),d.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,d.environment.skipWorkspaceStorageLock=(0,_.boolean)(b.skipWorkspaceStorageLock,!1);const u=new class{exit(D){P(D)}exists(D){return m.Promises.exists(D)}realpath(D){return(0,h.realpath)(D)}};let w=null;if(d.remote.authority&&b.uriTransformerPath)try{const D=Y.__$__nodeRequire(b.uriTransformerPath)(d.remote.authority);w=new c.URITransformer(D)}catch(r){console.error(r)}const E=new i.ExtensionHostMain(a.protocol,d,u,w);f=r=>E.terminate(r)}e.startExtensionHostProcess=o}),define(me[302],ge([0,1,289]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f0913d7718bbc4a805cd3a051335b4df60ca5d77/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
