/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/iterator","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(te){for(var e=[],h=0,F=te.length;h<F;h++)e[h]=Ee[te[h]];return e};define(Ee[39],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(F,E){if(!F)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=h}),define(Ee[49],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const h=Object.prototype.hasOwnProperty;function F(t){const S=[];for(let r in t)h.call(t,r)&&S.push(t[r]);return S}e.values=F;function E(t,S){for(let r in t)if(h.call(t,r)&&S({key:r,value:t[r]},function(){delete t[r]})===!1)return}e.forEach=E;function T(t,S){const r=Object.create(null);for(const d of t){const a=S(d);let l=r[a];l||(l=r[a]=[]),l.push(d)}return r}e.groupBy=T;function A(t){const S=Object.create(null);return t&&t.forEach((r,d)=>{S[d]=r}),S}e.fromMap=A;function I(t,S){const r=[],d=[];for(let a of t)S.has(a)||r.push(a);for(let a of S)t.has(a)||d.push(a);return{removed:r,added:d}}e.diffSets=I;function D(t,S){const r=[],d=[];for(let[a,l]of t)S.has(a)||r.push(l);for(let[a,l]of S)t.has(a)||d.push(l);return{removed:r,added:d}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(S,r){let d=this.map.get(S);d||(d=new Set,this.map.set(S,d)),d.add(r)}delete(S,r){const d=this.map.get(S);!d||(d.delete(r),d.size===0&&this.map.delete(S))}forEach(S,r){const d=this.map.get(S);!d||d.forEach(r)}}e.SetMap=P}),define(Ee[50],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function h(A){return(I,D,P)=>{let t=null,S=null;if(typeof P.value=="function"?(t="value",S=P.value):typeof P.get=="function"&&(t="get",S=P.get),!S)throw new Error("not supported");P[t]=A(S,D)}}e.createDecorator=h;function F(A,I,D){let P=null,t=null;if(typeof D.value=="function"?(P="value",t=D.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(P="get",t=D.get),!t)throw new Error("not supported");const S=`$memoize$${I}`;D[P]=function(...r){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,r)}),this[S]}}e.memoize=F;function E(A,I,D){return h((P,t)=>{const S=`$debounce$${t}`,r=`$debounce$result$${t}`;return function(...d){this[r]||(this[r]=D?D():void 0),clearTimeout(this[S]),I&&(this[r]=I(this[r],...d),d=[this[r]]),this[S]=setTimeout(()=>{P.apply(this,d),this[r]=D?D():void 0},A)}})}e.debounce=E;function T(A,I,D){return h((P,t)=>{const S=`$throttle$timer$${t}`,r=`$throttle$result$${t}`,d=`$throttle$lastRun$${t}`,a=`$throttle$pending$${t}`;return function(...l){if(this[r]||(this[r]=D?D():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),I&&(this[r]=I(this[r],...l)),this[a])return;const p=this[d]+A;p<=Date.now()?(this[d]=Date.now(),P.apply(this,[this[r]]),this[r]=D?D():void 0):(this[a]=!0,this[S]=setTimeout(()=>{this[a]=!1,this[d]=Date.now(),P.apply(this,[this[r]]),this[r]=D?D():void 0},p-Date.now()))}})}e.throttle=T}),define(Ee[16],_e([0,1,15]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F(z,se=0){return z[z.length-(1+se)]}e.tail=F;function E(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=E;function T(z,se,re=(we,Re)=>we===Re){if(z===se)return!0;if(!z||!se||z.length!==se.length)return!1;for(let we=0,Re=z.length;we<Re;we++)if(!re(z[we],se[we]))return!1;return!0}e.equals=T;function A(z,se,re){let we=0,Re=z.length-1;for(;we<=Re;){const Fe=(we+Re)/2|0,Ne=re(z[Fe],se);if(Ne<0)we=Fe+1;else if(Ne>0)Re=Fe-1;else return Fe}return-(we+1)}e.binarySearch=A;function I(z,se){let re=0,we=z.length;if(we===0)return 0;for(;re<we;){const Re=Math.floor((re+we)/2);se(z[Re])?we=Re:re=Re+1}return re}e.findFirstInSorted=I;function D(z,se,re){if(z=z|0,z>=se.length)throw new TypeError("invalid index");let we=se[Math.floor(se.length*Math.random())],Re=[],Fe=[],Ne=[];for(let Qe of se){const qe=re(Qe,we);qe<0?Re.push(Qe):qe>0?Fe.push(Qe):Ne.push(Qe)}return z<Re.length?D(z,Re,re):z<Re.length+Ne.length?Ne[0]:D(z-(Re.length+Ne.length),Fe,re)}e.quickSelect=D;function P(z,se){const re=[];let we;for(const Re of z.slice(0).sort(se))!we||se(we[0],Re)!==0?(we=[Re],re.push(we)):we.push(Re);return re}e.groupBy=P;function t(z,se,re){const we=[];function Re(Qe,qe,Ke){if(qe===0&&Ke.length===0)return;const N=we[we.length-1];N&&N.start+N.deleteCount===Qe?(N.deleteCount+=qe,N.toInsert.push(...Ke)):we.push({start:Qe,deleteCount:qe,toInsert:Ke})}let Fe=0,Ne=0;for(;;){if(Fe===z.length){Re(Fe,0,se.slice(Ne));break}if(Ne===se.length){Re(Fe,z.length-Fe,[]);break}const Qe=z[Fe],qe=se[Ne],Ke=re(Qe,qe);Ke===0?(Fe+=1,Ne+=1):Ke<0?(Re(Fe,1,[]),Fe+=1):Ke>0&&(Re(Fe,0,[qe]),Ne+=1)}return we}e.sortedDiff=t;function S(z,se,re){const we=t(z,se,re),Re=[],Fe=[];for(const Ne of we)Re.push(...z.slice(Ne.start,Ne.start+Ne.deleteCount)),Fe.push(...Ne.toInsert);return{removed:Re,added:Fe}}e.delta=S;function r(z,se,re){if(re===0)return[];const we=z.slice(0,re).sort(se);return a(z,se,we,re,z.length),we}e.top=r;function d(z,se,re,we,Re){return re===0?Promise.resolve([]):new Promise((Fe,Ne)=>{(async()=>{const Qe=z.length,qe=z.slice(0,re).sort(se);for(let Ke=re,N=Math.min(re+we,Qe);Ke<Qe;Ke=N,N=Math.min(N+we,Qe)){if(Ke>re&&await new Promise(q=>setTimeout(q)),Re&&Re.isCancellationRequested)throw(0,h.canceled)();a(z,se,qe,Ke,N)}return qe})().then(Fe,Ne)})}e.topAsync=d;function a(z,se,re,we,Re){for(const Fe=re.length;we<Re;we++){const Ne=z[we];if(se(Ne,re[Fe-1])<0){re.pop();const Qe=I(re,qe=>se(Ne,qe)<0);re.splice(Qe,0,Ne)}}}function l(z){return z.filter(se=>!!se)}e.coalesce=l;function p(z){let se=0;for(let re=0;re<z.length;re++)z[re]&&(z[se]=z[re],se+=1);z.length=se}e.coalesceInPlace=p;function v(z,se,re){z.splice(re,0,z.splice(se,1)[0])}e.move=v;function k(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=k;function c(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=c;function w(z,se){if(!se)return z.filter((we,Re)=>z.indexOf(we)===Re);const re=Object.create(null);return z.filter(we=>{const Re=se(we);return re[Re]?!1:(re[Re]=!0,!0)})}e.distinct=w;function y(z){const se=new Set;return z.filter(re=>se.has(re)?!1:(se.add(re),!0))}e.distinctES6=y;function i(z){const se=Object.create(null);return re=>{const we=z(re);return se[we]?!1:(se[we]=!0,!0)}}e.uniqueFilter=i;function o(z,se){for(let re=z.length-1;re>=0;re--){const we=z[re];if(se(we))return re}return-1}e.lastIndex=o;function u(z,se){return z.length>0?z[0]:se}e.firstOrDefault=u;function s(z,se,re=(we,Re)=>we===Re){let we=0;for(let Re=0,Fe=Math.min(z.length,se.length);Re<Fe&&re(z[Re],se[Re]);Re++)we++;return we}e.commonPrefixLength=s;function f(z){return[].concat(...z)}e.flatten=f;function m(z,se){let re=typeof se=="number"?z:0;typeof se=="number"?re=z:(re=0,se=z);const we=[];if(re<=se)for(let Re=re;Re<se;Re++)we.push(Re);else for(let Re=re;Re>se;Re--)we.push(Re);return we}e.range=m;function g(z,se,re){return z.reduce((we,Re)=>(we[se(Re)]=re?re(Re):Re,we),Object.create(null))}e.index=g;function b(z,se){return z.push(se),()=>C(z,se)}e.insert=b;function C(z,se){const re=z.indexOf(se);if(re>-1)return z.splice(re,1),se}e.remove=C;function n(z,se,re){const we=z.slice(0,se),Re=z.slice(se);return we.concat(re,Re)}e.arrayInsert=n;function _(z,se){let re;if(typeof se=="number"){let we=se;re=()=>{const Re=Math.sin(we++)*179426549;return Re-Math.floor(Re)}}else re=Math.random;for(let we=z.length-1;we>0;we-=1){const Re=Math.floor(re()*(we+1)),Fe=z[we];z[we]=z[Re],z[Re]=Fe}}e.shuffle=_;function R(z,se){const re=z.indexOf(se);re>-1&&(z.splice(re,1),z.unshift(se))}e.pushToStart=R;function U(z,se){const re=z.indexOf(se);re>-1&&(z.splice(re,1),z.push(se))}e.pushToEnd=U;function V(z,se){return Array.isArray(z)?z.map(se):se(z)}e.mapArrayOrNot=V;function le(z){return Array.isArray(z)?z:[z]}e.asArray=le;function he(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=he;function j(z,se){for(const re of z){const we=se(re);if(we!==void 0)return we}}e.mapFind=j;function H(z,se,re){const we=K(z,se),Re=z.length,Fe=re.length;z.length=Re+Fe;for(let Ne=Re-1;Ne>=we;Ne--)z[Ne+Fe]=z[Ne];for(let Ne=0;Ne<Fe;Ne++)z[Ne+we]=re[Ne]}e.insertInto=H;function L(z,se,re,we){const Re=K(z,se),Fe=z.splice(Re,re);return H(z,Re,we),Fe}e.splice=L;function K(z,se){return se<0?Math.max(se+z.length,0):Math.min(se,z.length)}function x(z,se){let re=Number.MAX_SAFE_INTEGER,we=0;return z.forEach((Re,Fe)=>{const Ne=se(Re);Ne<re&&(re=Ne,we=Fe)}),we}e.minIndex=x;function Y(z,se){let re=Number.MIN_SAFE_INTEGER,we=0;return z.forEach((Re,Fe)=>{const Ne=se(Re);Ne>re&&(re=Ne,we=Fe)}),we}e.maxIndex=Y;class ce{constructor(se){this.items=se,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(se){let re=this.firstIdx;for(;re<this.items.length&&se(this.items[re]);)re++;const we=re===this.firstIdx?null:this.items.slice(this.firstIdx,re);return this.firstIdx=re,we}takeFromEndWhile(se){let re=this.lastIdx;for(;re>=0&&se(this.items[re]);)re--;const we=re===this.lastIdx?null:this.items.slice(re+1,this.lastIdx+1);return this.lastIdx=re,we}}e.ArrayQueue=ce}),define(Ee[51],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class h{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=h,e.defaultGenerator=new h("id#")}),define(Ee[102],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var F;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(i,o=!1){let u=0,s=i.length,f="",m=0,g=16,b=0;function C(he){let j=0,H=0;for(;j<he;){const L=i.charCodeAt(u);if(L>=48&&L<=57)H=H*16+L-48;else if(L>=65&&L<=70)H=H*16+L-65+10;else if(L>=97&&L<=102)H=H*16+L-97+10;else break;u++,j++}return j<he&&(H=-1),H}function n(he){u=he,f="",m=0,g=16,b=0}function _(){const he=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&P(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&P(i.charCodeAt(u)))for(u++;u<i.length&&P(i.charCodeAt(u));)u++;else return b=3,i.substring(he,u);let j=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&P(i.charCodeAt(u))){for(u++;u<i.length&&P(i.charCodeAt(u));)u++;j=u}else b=3;return i.substring(he,j)}function R(){let he="",j=u;for(;;){if(u>=s){he+=i.substring(j,u),b=2;break}const H=i.charCodeAt(u);if(H===34){he+=i.substring(j,u),u++;break}if(H===92){if(he+=i.substring(j,u),u++,u>=s){b=2;break}switch(i.charCodeAt(u++)){case 34:he+='"';break;case 92:he+="\\";break;case 47:he+="/";break;case 98:he+="\b";break;case 102:he+="\f";break;case 110:he+=`
`;break;case 114:he+="\r";break;case 116:he+="	";break;case 117:const K=C(4);K>=0?he+=String.fromCharCode(K):b=4;break;default:b=5}j=u;continue}if(H>=0&&H<=31)if(D(H)){he+=i.substring(j,u),b=2;break}else b=6;u++}return he}function U(){if(f="",b=0,m=u,u>=s)return m=s,g=17;let he=i.charCodeAt(u);if(I(he)){do u++,f+=String.fromCharCode(he),he=i.charCodeAt(u);while(I(he));return g=15}if(D(he))return u++,f+=String.fromCharCode(he),he===13&&i.charCodeAt(u)===10&&(u++,f+=`
`),g=14;switch(he){case 123:return u++,g=1;case 125:return u++,g=2;case 91:return u++,g=3;case 93:return u++,g=4;case 58:return u++,g=6;case 44:return u++,g=5;case 34:return u++,f=R(),g=10;case 47:const j=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<s&&!D(i.charCodeAt(u));)u++;return f=i.substring(j,u),g=12}if(i.charCodeAt(u+1)===42){u+=2;const H=s-1;let L=!1;for(;u<H;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,L=!0;break}u++}return L||(u++,b=1),f=i.substring(j,u),g=13}return f+=String.fromCharCode(he),u++,g=16;case 45:if(f+=String.fromCharCode(he),u++,u===s||!P(i.charCodeAt(u)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=_(),g=11;default:for(;u<s&&V(he);)u++,he=i.charCodeAt(u);if(m!==u){switch(f=i.substring(m,u),f){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return f+=String.fromCharCode(he),u++,g=16}}function V(he){if(I(he)||D(he))return!1;switch(he){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let he;do he=U();while(he>=12&&he<=15);return he}return{setPosition:n,getPosition:()=>u,scan:o?le:U,getToken:()=>g,getTokenValue:()=>f,getTokenOffset:()=>m,getTokenLength:()=>u-m,getTokenError:()=>b}}e.createScanner=A;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function D(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function S(i,o){const u=[],s=new Object;let f;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function b(C,n,_,R){m.value=C,m.offset=n,m.length=_,m.type=R,m.colonOffset=void 0,f=m}try{c(i,{onObjectBegin:(C,n)=>{if(o<=C)throw s;f=void 0,g=o>C,u.push("")},onObjectProperty:(C,n,_)=>{if(o<n||(b(C,n,_,"property"),u[u.length-1]=C,o<=n+_))throw s},onObjectEnd:(C,n)=>{if(o<=C)throw s;f=void 0,u.pop()},onArrayBegin:(C,n)=>{if(o<=C)throw s;f=void 0,u.push(0)},onArrayEnd:(C,n)=>{if(o<=C)throw s;f=void 0,u.pop()},onLiteralValue:(C,n,_)=>{if(o<n||(b(C,n,_,y(C)),o<=n+_))throw s},onSeparator:(C,n,_)=>{if(o<=n)throw s;if(C===":"&&f&&f.type==="property")f.colonOffset=n,g=!1,f=void 0;else if(C===","){const R=u[u.length-1];typeof R=="number"?u[u.length-1]=R+1:(g=!0,u[u.length-1]=""),f=void 0}}})}catch(C){if(C!==s)throw C}return{path:u,previousNode:f,isAtPropertyKey:g,matches:C=>{let n=0;for(let _=0;n<C.length&&_<u.length;_++)if(C[n]===u[_]||C[n]==="*")n++;else if(C[n]!=="**")return!1;return n===C.length}}}e.getLocation=S;function r(i,o=[],u=T.DEFAULT){let s=null,f=[];const m=[];function g(C){Array.isArray(f)?f.push(C):s!==null&&(f[s]=C)}return c(i,{onObjectBegin:()=>{const C={};g(C),m.push(f),f=C,s=null},onObjectProperty:C=>{s=C},onObjectEnd:()=>{f=m.pop()},onArrayBegin:()=>{const C=[];g(C),m.push(f),f=C,s=null},onArrayEnd:()=>{f=m.pop()},onLiteralValue:g,onError:(C,n,_)=>{o.push({error:C,offset:n,length:_})}},u),f[0]}e.parse=r;function d(i,o=[],u=T.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(C){s.type==="property"&&(s.length=C-s.offset,s=s.parent)}function m(C){return s.children.push(C),C}c(i,{onObjectBegin:C=>{s=m({type:"object",offset:C,length:-1,parent:s,children:[]})},onObjectProperty:(C,n,_)=>{s=m({type:"property",offset:n,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:C,offset:n,length:_,parent:s})},onObjectEnd:(C,n)=>{s.length=C+n-s.offset,s=s.parent,f(C+n)},onArrayBegin:(C,n)=>{s=m({type:"array",offset:C,length:-1,parent:s,children:[]})},onArrayEnd:(C,n)=>{s.length=C+n-s.offset,s=s.parent,f(C+n)},onLiteralValue:(C,n,_)=>{m({type:y(C),offset:n,length:_,parent:s,value:C}),f(n+_)},onSeparator:(C,n,_)=>{s.type==="property"&&(C===":"?s.colonOffset=n:C===","&&f(n))},onError:(C,n,_)=>{o.push({error:C,offset:n,length:_})}},u);const b=s.children[0];return b&&delete b.parent,b}e.parseTree=d;function a(i,o){if(!i)return;let u=i;for(let s of o)if(typeof s=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let f=!1;for(const m of u.children)if(Array.isArray(m.children)&&m.children[0].value===s){u=m.children[1],f=!0;break}if(!f)return}else{const f=s;if(u.type!=="array"||f<0||!Array.isArray(u.children)||f>=u.children.length)return;u=u.children[f]}return u}e.findNodeAtLocation=a;function l(i){if(!i.parent||!i.parent.children)return[];const o=l(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;o.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&o.push(u)}return o}e.getNodePath=l;function p(i){switch(i.type){case"array":return i.children.map(p);case"object":const o=Object.create(null);for(let u of i.children){const s=u.children[1];s&&(o[u.children[0].value]=p(s))}return o;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=p;function v(i,o,u=!1){return o>=i.offset&&o<i.offset+i.length||u&&o===i.offset+i.length}e.contains=v;function k(i,o,u=!1){if(v(i,o,u)){const s=i.children;if(Array.isArray(s))for(let f=0;f<s.length&&s[f].offset<=o;f++){const m=k(s[f],o,u);if(m)return m}return i}}e.findNodeAtOffset=k;function c(i,o,u=T.DEFAULT){const s=A(i,!1);function f(re){return re?()=>re(s.getTokenOffset(),s.getTokenLength()):()=>!0}function m(re){return re?we=>re(we,s.getTokenOffset(),s.getTokenLength()):()=>!0}const g=f(o.onObjectBegin),b=m(o.onObjectProperty),C=f(o.onObjectEnd),n=f(o.onArrayBegin),_=f(o.onArrayEnd),R=m(o.onLiteralValue),U=m(o.onSeparator),V=f(o.onComment),le=m(o.onError),he=u&&u.disallowComments,j=u&&u.allowTrailingComma;function H(){for(;;){const re=s.scan();switch(s.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:he||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(re){case 12:case 13:he?L(10):V();break;case 16:L(1);break;case 15:case 14:break;default:return re}}}function L(re,we=[],Re=[]){if(le(re),we.length+Re.length>0){let Fe=s.getToken();for(;Fe!==17;){if(we.indexOf(Fe)!==-1){H();break}else if(Re.indexOf(Fe)!==-1)break;Fe=H()}}}function K(re){const we=s.getTokenValue();return re?R(we):b(we),H(),!0}function x(){switch(s.getToken()){case 11:let re=0;try{re=JSON.parse(s.getTokenValue()),typeof re!="number"&&(L(2),re=0)}catch(we){L(2)}R(re);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return H(),!0}function Y(){return s.getToken()!==10?(L(3,[],[2,5]),!1):(K(!1),s.getToken()===6?(U(":"),H(),se()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function ce(){g(),H();let re=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(re||L(4,[],[]),U(","),H(),s.getToken()===2&&j)break}else re&&L(6,[],[]);Y()||L(4,[],[2,5]),re=!0}return C(),s.getToken()!==2?L(7,[2],[]):H(),!0}function z(){n(),H();let re=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(re||L(4,[],[]),U(","),H(),s.getToken()===4&&j)break}else re&&L(6,[],[]);se()||L(4,[],[4,5]),re=!0}return _(),s.getToken()!==4?L(8,[4],[]):H(),!0}function se(){switch(s.getToken()){case 3:return z();case 1:return ce();case 10:return K(!0);default:return x()}}return H(),s.getToken()===17?u.allowEmptyContent?!0:(L(4,[],[]),!1):se()?(s.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=c;function w(i,o){let u=A(i),s=[],f,m=0,g;do switch(g=u.getPosition(),f=u.scan(),f){case 12:case 13:case 17:m!==g&&s.push(i.substring(m,g)),o!==void 0&&s.push(u.getTokenValue().replace(/[^\r\n]/g,o)),m=u.getPosition();break}while(f!==17);return s.join("")}e.stripComments=w;function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),define(Ee[103],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class h{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new h(()=>E(this.getValue()))}}e.Lazy=h}),function(te,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(te=typeof globalThis!="undefined"?globalThis:te||self,te.marked=e())}(this,function(){"use strict";function te(Pe,Se){for(var Ce=0;Ce<Se.length;Ce++){var J=Se[Ce];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(Pe,J.key,J)}}function e(Pe,Se,Ce){return Se&&te(Pe.prototype,Se),Ce&&te(Pe,Ce),Pe}function h(Pe,Se){if(!!Pe){if(typeof Pe=="string")return F(Pe,Se);var Ce=Object.prototype.toString.call(Pe).slice(8,-1);if(Ce==="Object"&&Pe.constructor&&(Ce=Pe.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Pe);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return F(Pe,Se)}}function F(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var Ce=0,J=new Array(Se);Ce<Se;Ce++)J[Ce]=Pe[Ce];return J}function E(Pe,Se){var Ce=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(Ce)return(Ce=Ce.call(Pe)).next.bind(Ce);if(Array.isArray(Pe)||(Ce=h(Pe))||Se&&Pe&&typeof Pe.length=="number"){Ce&&(Pe=Ce);var J=0;return function(){return J>=Pe.length?{done:!0}:{done:!1,value:Pe[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function A(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Pe){T.exports.defaults=Pe}T.exports={defaults:A(),getDefaults:A,changeDefaults:I};var D=/[&<>"']/,P=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(Se){return r[Se]};function a(Pe,Se){if(Se){if(D.test(Pe))return Pe.replace(P,d)}else if(t.test(Pe))return Pe.replace(S,d);return Pe}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(Pe){return Pe.replace(l,function(Se,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var v=/(^|[^\[])\^/g;function k(Pe,Se){Pe=Pe.source||Pe,Se=Se||"";var Ce={replace:function(oe,pe){return pe=pe.source||pe,pe=pe.replace(v,"$1"),Pe=Pe.replace(oe,pe),Ce},getRegex:function(){return new RegExp(Pe,Se)}};return Ce}var c=/[^\w:]/g,w=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function y(Pe,Se,Ce){if(Pe){var J;try{J=decodeURIComponent(p(Ce)).replace(c,"").toLowerCase()}catch(oe){return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}Se&&!w.test(Ce)&&(Ce=f(Se,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(oe){return null}return Ce}var i={},o=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(Pe,Se){i[" "+Pe]||(o.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=C(Pe,"/",!0)),Pe=i[" "+Pe];var Ce=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?Ce?Se:Pe.replace(u,"$1")+Se:Se.charAt(0)==="/"?Ce?Se:Pe.replace(s,"$1")+Se:Pe+Se}var m={exec:function(){}};function g(Pe){for(var Se=1,Ce,J;Se<arguments.length;Se++){Ce=arguments[Se];for(J in Ce)Object.prototype.hasOwnProperty.call(Ce,J)&&(Pe[J]=Ce[J])}return Pe}function b(Pe,Se){var Ce=Pe.replace(/\|/g,function(pe,ge,Ie){for(var Be=!1,Me=ge;--Me>=0&&Ie[Me]==="\\";)Be=!Be;return Be?"|":" |"}),J=Ce.split(/ \|/),oe=0;if(J[0].trim()||J.shift(),J[J.length-1].trim()||J.pop(),J.length>Se)J.splice(Se);else for(;J.length<Se;)J.push("");for(;oe<J.length;oe++)J[oe]=J[oe].trim().replace(/\\\|/g,"|");return J}function C(Pe,Se,Ce){var J=Pe.length;if(J===0)return"";for(var oe=0;oe<J;){var pe=Pe.charAt(J-oe-1);if(pe===Se&&!Ce)oe++;else if(pe!==Se&&Ce)oe++;else break}return Pe.substr(0,J-oe)}function n(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var Ce=Pe.length,J=0,oe=0;oe<Ce;oe++)if(Pe[oe]==="\\")oe++;else if(Pe[oe]===Se[0])J++;else if(Pe[oe]===Se[1]&&(J--,J<0))return oe;return-1}function _(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Pe,Se){if(Se<1)return"";for(var Ce="";Se>1;)Se&1&&(Ce+=Pe),Se>>=1,Pe+=Pe;return Ce+Pe}var U={escape:a,unescape:p,edit:k,cleanUrl:y,resolveUrl:f,noopTest:m,merge:g,splitCells:b,rtrim:C,findClosingBracket:n,checkSanitizeDeprecation:_,repeatString:R},V=T.exports.defaults,le=U.rtrim,he=U.splitCells,j=U.escape,H=U.findClosingBracket;function L(Pe,Se,Ce,J){var oe=Se.href,pe=Se.title?j(Se.title):null,ge=Pe[1].replace(/\\([\[\]])/g,"$1");return Pe[0].charAt(0)!=="!"?(J.state.inLink=!0,{type:"link",raw:Ce,href:oe,title:pe,text:ge,tokens:J.inlineTokens(ge,[])}):{type:"image",raw:Ce,href:oe,title:pe,text:j(ge)}}function K(Pe,Se){var Ce=Pe.match(/^(\s+)(?:```)/);if(Ce===null)return Se;var J=Ce[1];return Se.split(`
`).map(function(oe){var pe=oe.match(/^\s+/);if(pe===null)return oe;var ge=pe[0];return ge.length>=J.length?oe.slice(J.length):oe}).join(`
`)}var x=function(){function Pe(Ce){this.options=Ce||V}var Se=Pe.prototype;return Se.space=function(J){var oe=this.rules.block.newline.exec(J);if(oe)return oe[0].length>1?{type:"space",raw:oe[0]}:{raw:`
`}},Se.code=function(J){var oe=this.rules.block.code.exec(J);if(oe){var pe=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:le(pe,`
`)}}},Se.fences=function(J){var oe=this.rules.block.fences.exec(J);if(oe){var pe=oe[0],ge=K(pe,oe[3]||"");return{type:"code",raw:pe,lang:oe[2]?oe[2].trim():oe[2],text:ge}}},Se.heading=function(J){var oe=this.rules.block.heading.exec(J);if(oe){var pe=oe[2].trim();if(/#$/.test(pe)){var ge=le(pe,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(pe=ge.trim())}var Ie={type:"heading",raw:oe[0],depth:oe[1].length,text:pe,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},Se.hr=function(J){var oe=this.rules.block.hr.exec(J);if(oe)return{type:"hr",raw:oe[0]}},Se.blockquote=function(J){var oe=this.rules.block.blockquote.exec(J);if(oe){var pe=oe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},Se.list=function(J){var oe=this.rules.block.list.exec(J);if(oe){var pe,ge,Ie,Be,Me,je,de,ae,ne,B,ve=oe[1].trim(),ke=ve.length>1,$e={type:"list",raw:"",ordered:ke,start:ke?+ve.slice(0,-1):"",loose:!1,items:[]};ve=ke?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=ke?ve:"[*+-]");for(var xe=new RegExp("^( {0,3}"+ve+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");J&&!(this.rules.block.hr.test(J)||!(oe=xe.exec(J)));){ne=oe[2].split(`
`),this.options.pedantic?(Be=2,B=ne[0].trimLeft()):(Be=oe[2].search(/[^ ]/),Be=oe[1].length+(Be>4?1:Be),B=ne[0].slice(Be-oe[1].length)),je=!1,pe=oe[0],!ne[0]&&/^ *$/.test(ne[1])&&(pe=oe[1]+ne.slice(0,2).join(`
`)+`
`,$e.loose=!0,ne=[]);var lt=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Me=1;Me<ne.length;Me++){if(ae=ne[Me],this.options.pedantic&&(ae=ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),lt.test(ae)){pe=oe[1]+ne.slice(0,Me).join(`
`)+`
`;break}if(!je){ae.trim()||(je=!0),ae.search(/[^ ]/)>=Be?B+=`
`+ae.slice(Be):B+=`
`+ae;continue}if(ae.search(/[^ ]/)>=Be||!ae.trim()){B+=`
`+ae.slice(Be);continue}else{pe=oe[1]+ne.slice(0,Me).join(`
`)+`
`;break}}$e.loose||(de?$e.loose=!0:/\n *\n *$/.test(pe)&&(de=!0)),this.options.gfm&&(ge=/^\[[ xX]\] /.exec(B),ge&&(Ie=ge[0]!=="[ ] ",B=B.replace(/^\[[ xX]\] +/,""))),$e.items.push({type:"list_item",raw:pe,task:!!ge,checked:Ie,loose:!1,text:B}),$e.raw+=pe,J=J.slice(pe.length)}$e.items[$e.items.length-1].raw=pe.trimRight(),$e.items[$e.items.length-1].text=B.trimRight(),$e.raw=$e.raw.trimRight();var at=$e.items.length;for(Me=0;Me<at;Me++)this.lexer.state.top=!1,$e.items[Me].tokens=this.lexer.blockTokens($e.items[Me].text,[]),$e.items[Me].tokens.some(function(bt){return bt.type==="space"})&&($e.loose=!0,$e.items[Me].loose=!0);return $e}},Se.html=function(J){var oe=this.rules.block.html.exec(J);if(oe){var pe={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};return this.options.sanitize&&(pe.type="paragraph",pe.text=this.options.sanitizer?this.options.sanitizer(oe[0]):j(oe[0]),pe.tokens=[],this.lexer.inline(pe.text,pe.tokens)),pe}},Se.def=function(J){var oe=this.rules.block.def.exec(J);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var pe=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:oe[0],href:oe[2],title:oe[3]}}},Se.table=function(J){var oe=this.rules.block.table.exec(J);if(oe){var pe={type:"table",header:he(oe[1]).map(function(de){return{text:de}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]?oe[3].replace(/\n$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=oe[0];var ge=pe.align.length,Ie,Be,Me,je;for(Ie=0;Ie<ge;Ie++)/^ *-+: *$/.test(pe.align[Ie])?pe.align[Ie]="right":/^ *:-+: *$/.test(pe.align[Ie])?pe.align[Ie]="center":/^ *:-+ *$/.test(pe.align[Ie])?pe.align[Ie]="left":pe.align[Ie]=null;for(ge=pe.rows.length,Ie=0;Ie<ge;Ie++)pe.rows[Ie]=he(pe.rows[Ie],pe.header.length).map(function(de){return{text:de}});for(ge=pe.header.length,Be=0;Be<ge;Be++)pe.header[Be].tokens=[],this.lexer.inlineTokens(pe.header[Be].text,pe.header[Be].tokens);for(ge=pe.rows.length,Be=0;Be<ge;Be++)for(je=pe.rows[Be],Me=0;Me<je.length;Me++)je[Me].tokens=[],this.lexer.inlineTokens(je[Me].text,je[Me].tokens);return pe}}},Se.lheading=function(J){var oe=this.rules.block.lheading.exec(J);if(oe){var pe={type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:[]};return this.lexer.inline(pe.text,pe.tokens),pe}},Se.paragraph=function(J){var oe=this.rules.block.paragraph.exec(J);if(oe){var pe={type:"paragraph",raw:oe[0],text:oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1],tokens:[]};return this.lexer.inline(pe.text,pe.tokens),pe}},Se.text=function(J){var oe=this.rules.block.text.exec(J);if(oe){var pe={type:"text",raw:oe[0],text:oe[0],tokens:[]};return this.lexer.inline(pe.text,pe.tokens),pe}},Se.escape=function(J){var oe=this.rules.inline.escape.exec(J);if(oe)return{type:"escape",raw:oe[0],text:j(oe[1])}},Se.tag=function(J){var oe=this.rules.inline.tag.exec(J);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):j(oe[0]):oe[0]}},Se.link=function(J){var oe=this.rules.inline.link.exec(J);if(oe){var pe=oe[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var ge=le(pe.slice(0,-1),"\\");if((pe.length-ge.length)%2==0)return}else{var Ie=H(oe[2],"()");if(Ie>-1){var Be=oe[0].indexOf("!")===0?5:4,Me=Be+oe[1].length+Ie;oe[2]=oe[2].substring(0,Ie),oe[0]=oe[0].substring(0,Me).trim(),oe[3]=""}}var je=oe[2],de="";if(this.options.pedantic){var ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);ae&&(je=ae[1],de=ae[3])}else de=oe[3]?oe[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(pe)?je=je.slice(1):je=je.slice(1,-1)),L(oe,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:de&&de.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},Se.reflink=function(J,oe){var pe;if((pe=this.rules.inline.reflink.exec(J))||(pe=this.rules.inline.nolink.exec(J))){var ge=(pe[2]||pe[1]).replace(/\s+/g," ");if(ge=oe[ge.toLowerCase()],!ge||!ge.href){var Ie=pe[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return L(pe,ge,pe[0],this.lexer)}},Se.emStrong=function(J,oe,pe){pe===void 0&&(pe="");var ge=this.rules.inline.emStrong.lDelim.exec(J);if(!!ge&&!(ge[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=ge[1]||ge[2]||"";if(!Ie||Ie&&(pe===""||this.rules.inline.punctuation.exec(pe))){var Be=ge[0].length-1,Me,je,de=Be,ae=0,ne=ge[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ne.lastIndex=0,oe=oe.slice(-1*J.length+Be);(ge=ne.exec(oe))!=null;)if(Me=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!!Me){if(je=Me.length,ge[3]||ge[4]){de+=je;continue}else if((ge[5]||ge[6])&&Be%3&&!((Be+je)%3)){ae+=je;continue}if(de-=je,!(de>0)){if(je=Math.min(je,je+de+ae),Math.min(Be,je)%2){var B=J.slice(1,Be+ge.index+je);return{type:"em",raw:J.slice(0,Be+ge.index+je+1),text:B,tokens:this.lexer.inlineTokens(B,[])}}var ve=J.slice(2,Be+ge.index+je-1);return{type:"strong",raw:J.slice(0,Be+ge.index+je+1),text:ve,tokens:this.lexer.inlineTokens(ve,[])}}}}}},Se.codespan=function(J){var oe=this.rules.inline.code.exec(J);if(oe){var pe=oe[2].replace(/\n/g," "),ge=/[^ ]/.test(pe),Ie=/^ /.test(pe)&&/ $/.test(pe);return ge&&Ie&&(pe=pe.substring(1,pe.length-1)),pe=j(pe,!0),{type:"codespan",raw:oe[0],text:pe}}},Se.br=function(J){var oe=this.rules.inline.br.exec(J);if(oe)return{type:"br",raw:oe[0]}},Se.del=function(J){var oe=this.rules.inline.del.exec(J);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2],[])}},Se.autolink=function(J,oe){var pe=this.rules.inline.autolink.exec(J);if(pe){var ge,Ie;return pe[2]==="@"?(ge=j(this.options.mangle?oe(pe[1]):pe[1]),Ie="mailto:"+ge):(ge=j(pe[1]),Ie=ge),{type:"link",raw:pe[0],text:ge,href:Ie,tokens:[{type:"text",raw:ge,text:ge}]}}},Se.url=function(J,oe){var pe;if(pe=this.rules.inline.url.exec(J)){var ge,Ie;if(pe[2]==="@")ge=j(this.options.mangle?oe(pe[0]):pe[0]),Ie="mailto:"+ge;else{var Be;do Be=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(Be!==pe[0]);ge=j(pe[0]),pe[1]==="www."?Ie="http://"+ge:Ie=ge}return{type:"link",raw:pe[0],text:ge,href:Ie,tokens:[{type:"text",raw:ge,text:ge}]}}},Se.inlineText=function(J,oe){var pe=this.rules.inline.text.exec(J);if(pe){var ge;return this.lexer.state.inRawBlock?ge=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):j(pe[0]):pe[0]:ge=j(this.options.smartypants?oe(pe[0]):pe[0]),{type:"text",raw:pe[0],text:ge}}},Pe}(),Y=U.noopTest,ce=U.edit,z=U.merge,se={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:Y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};se._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,se._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,se.def=ce(se.def).replace("label",se._label).replace("title",se._title).getRegex(),se.bullet=/(?:[*+-]|\d{1,9}[.)])/,se.listItemStart=ce(/^( *)(bull) */).replace("bull",se.bullet).getRegex(),se.list=ce(se.list).replace(/bull/g,se.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+se.def.source+")").getRegex(),se._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",se._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,se.html=ce(se.html,"i").replace("comment",se._comment).replace("tag",se._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),se.paragraph=ce(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.blockquote=ce(se.blockquote).replace("paragraph",se.paragraph).getRegex(),se.normal=z({},se),se.gfm=z({},se.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),se.gfm.table=ce(se.gfm.table).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.pedantic=z({},se.normal,{html:ce(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",se._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Y,paragraph:ce(se.normal._paragraph).replace("hr",se.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",se.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=ce(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=ce(se._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=ce(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=ce(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=ce(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=ce(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=ce(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=ce(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=ce(re.reflink).replace("label",re._label).getRegex(),re.reflinkSearch=ce(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=z({},re),re.pedantic=z({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ce(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:ce(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=z({},re.normal,{escape:ce(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),re.gfm.url=ce(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=z({},re.gfm,{br:ce(re.br).replace("{2,}","*").getRegex(),text:ce(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var we={block:se,inline:re},Re=x,Fe=T.exports.defaults,Ne=we.block,Qe=we.inline,qe=U.repeatString;function Ke(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function N(Pe){var Se="",Ce,J,oe=Pe.length;for(Ce=0;Ce<oe;Ce++)J=Pe.charCodeAt(Ce),Math.random()>.5&&(J="x"+J.toString(16)),Se+="&#"+J+";";return Se}var q=function(){function Pe(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Fe,this.options.tokenizer=this.options.tokenizer||new Re,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:Ne.normal,inline:Qe.normal};this.options.pedantic?(J.block=Ne.pedantic,J.inline=Qe.pedantic):this.options.gfm&&(J.block=Ne.gfm,this.options.breaks?J.inline=Qe.breaks:J.inline=Qe.gfm),this.tokenizer.rules=J}Pe.lex=function(J,oe){var pe=new Pe(oe);return pe.lex(J)},Pe.lexInline=function(J,oe){var pe=new Pe(oe);return pe.inlineTokens(J)};var Se=Pe.prototype;return Se.lex=function(J){J=J.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(J,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},Se.blockTokens=function(J,oe){var pe=this;oe===void 0&&(oe=[]),this.options.pedantic&&(J=J.replace(/^ +$/gm,""));for(var ge,Ie,Be,Me;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(de){return(ge=de.call({lexer:pe},J,oe))?(J=J.substring(ge.raw.length),oe.push(ge),!0):!1}))){if(ge=this.tokenizer.space(J)){J=J.substring(ge.raw.length),ge.type&&oe.push(ge);continue}if(ge=this.tokenizer.code(J)){J=J.substring(ge.raw.length),Ie=oe[oe.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+ge.raw,Ie.text+=`
`+ge.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):oe.push(ge);continue}if(ge=this.tokenizer.fences(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.heading(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.hr(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.blockquote(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.list(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.html(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.def(J)){J=J.substring(ge.raw.length),Ie=oe[oe.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+ge.raw,Ie.text+=`
`+ge.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.lheading(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(Be=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var de=Infinity,ae=J.slice(1),ne=void 0;pe.options.extensions.startBlock.forEach(function(B){ne=B.call({lexer:this},ae),typeof ne=="number"&&ne>=0&&(de=Math.min(de,ne))}),de<Infinity&&de>=0&&(Be=J.substring(0,de+1))}(),this.state.top&&(ge=this.tokenizer.paragraph(Be))){Ie=oe[oe.length-1],Me&&Ie.type==="paragraph"?(Ie.raw+=`
`+ge.raw,Ie.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):oe.push(ge),Me=Be.length!==J.length,J=J.substring(ge.raw.length);continue}if(ge=this.tokenizer.text(J)){J=J.substring(ge.raw.length),Ie=oe[oe.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+ge.raw,Ie.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):oe.push(ge);continue}if(J){var je="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return this.state.top=!0,oe},Se.inline=function(J,oe){this.inlineQueue.push({src:J,tokens:oe})},Se.inlineTokens=function(J,oe){var pe=this;oe===void 0&&(oe=[]);var ge,Ie,Be,Me=J,je,de,ae;if(this.tokens.links){var ne=Object.keys(this.tokens.links);if(ne.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)ne.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,je.index)+"["+qe("a",je[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,je.index)+"["+qe("a",je[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,je.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(de||(ae=""),de=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(ge=ve.call({lexer:pe},J,oe))?(J=J.substring(ge.raw.length),oe.push(ge),!0):!1}))){if(ge=this.tokenizer.escape(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.tag(J)){J=J.substring(ge.raw.length),Ie=oe[oe.length-1],Ie&&ge.type==="text"&&Ie.type==="text"?(Ie.raw+=ge.raw,Ie.text+=ge.text):oe.push(ge);continue}if(ge=this.tokenizer.link(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(ge.raw.length),Ie=oe[oe.length-1],Ie&&ge.type==="text"&&Ie.type==="text"?(Ie.raw+=ge.raw,Ie.text+=ge.text):oe.push(ge);continue}if(ge=this.tokenizer.emStrong(J,Me,ae)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.codespan(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.br(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.del(J)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.autolink(J,N)){J=J.substring(ge.raw.length),oe.push(ge);continue}if(!this.state.inLink&&(ge=this.tokenizer.url(J,N))){J=J.substring(ge.raw.length),oe.push(ge);continue}if(Be=J,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=Infinity,ke=J.slice(1),$e=void 0;pe.options.extensions.startInline.forEach(function(xe){$e=xe.call({lexer:this},ke),typeof $e=="number"&&$e>=0&&(ve=Math.min(ve,$e))}),ve<Infinity&&ve>=0&&(Be=J.substring(0,ve+1))}(),ge=this.tokenizer.inlineText(Be,Ke)){J=J.substring(ge.raw.length),ge.raw.slice(-1)!=="_"&&(ae=ge.raw.slice(-1)),de=!0,Ie=oe[oe.length-1],Ie&&Ie.type==="text"?(Ie.raw+=ge.raw,Ie.text+=ge.text):oe.push(ge);continue}if(J){var B="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return oe},e(Pe,null,[{key:"rules",get:function(){return{block:Ne,inline:Qe}}}]),Pe}(),X=T.exports.defaults,ie=U.cleanUrl,W=U.escape,ee=function(){function Pe(Ce){this.options=Ce||X}var Se=Pe.prototype;return Se.code=function(J,oe,pe){var ge=(oe||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(J,ge);Ie!=null&&Ie!==J&&(pe=!0,J=Ie)}return J=J.replace(/\n$/,"")+`
`,ge?'<pre><code class="'+this.options.langPrefix+W(ge,!0)+'">'+(pe?J:W(J,!0))+`</code></pre>
`:"<pre><code>"+(pe?J:W(J,!0))+`</code></pre>
`},Se.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},Se.html=function(J){return J},Se.heading=function(J,oe,pe,ge){return this.options.headerIds?"<h"+oe+' id="'+this.options.headerPrefix+ge.slug(pe)+'">'+J+"</h"+oe+`>
`:"<h"+oe+">"+J+"</h"+oe+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(J,oe,pe){var ge=oe?"ol":"ul",Ie=oe&&pe!==1?' start="'+pe+'"':"";return"<"+ge+Ie+`>
`+J+"</"+ge+`>
`},Se.listitem=function(J){return"<li>"+J+`</li>
`},Se.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(J){return"<p>"+J+`</p>
`},Se.table=function(J,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+oe+`</table>
`},Se.tablerow=function(J){return`<tr>
`+J+`</tr>
`},Se.tablecell=function(J,oe){var pe=oe.header?"th":"td",ge=oe.align?"<"+pe+' align="'+oe.align+'">':"<"+pe+">";return ge+J+"</"+pe+`>
`},Se.strong=function(J){return"<strong>"+J+"</strong>"},Se.em=function(J){return"<em>"+J+"</em>"},Se.codespan=function(J){return"<code>"+J+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(J){return"<del>"+J+"</del>"},Se.link=function(J,oe,pe){if(J=ie(this.options.sanitize,this.options.baseUrl,J),J===null)return pe;var ge='<a href="'+W(J)+'"';return oe&&(ge+=' title="'+oe+'"'),ge+=">"+pe+"</a>",ge},Se.image=function(J,oe,pe){if(J=ie(this.options.sanitize,this.options.baseUrl,J),J===null)return pe;var ge='<img src="'+J+'" alt="'+pe+'"';return oe&&(ge+=' title="'+oe+'"'),ge+=this.options.xhtml?"/>":">",ge},Se.text=function(J){return J},Pe}(),me=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(J){return J},Se.em=function(J){return J},Se.codespan=function(J){return J},Se.del=function(J){return J},Se.html=function(J){return J},Se.text=function(J){return J},Se.link=function(J,oe,pe){return""+pe},Se.image=function(J,oe,pe){return""+pe},Se.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(J,oe){var pe=J,ge=0;if(this.seen.hasOwnProperty(pe)){ge=this.seen[J];do ge++,pe=J+"-"+ge;while(this.seen.hasOwnProperty(pe))}return oe||(this.seen[J]=ge,this.seen[pe]=0),pe},Se.slug=function(J,oe){oe===void 0&&(oe={});var pe=this.serialize(J);return this.getNextSafeSlug(pe,oe.dryrun)},Pe}(),Ue=ee,He=me,be=Te,Je=T.exports.defaults,$=U.unescape,G=function(){function Pe(Ce){this.options=Ce||Je,this.options.renderer=this.options.renderer||new Ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new be}Pe.parse=function(J,oe){var pe=new Pe(oe);return pe.parse(J)},Pe.parseInline=function(J,oe){var pe=new Pe(oe);return pe.parseInline(J)};var Se=Pe.prototype;return Se.parse=function(J,oe){oe===void 0&&(oe=!0);var pe="",ge,Ie,Be,Me,je,de,ae,ne,B,ve,ke,$e,xe,lt,at,bt,dt,nt,st,ft=J.length;for(ge=0;ge<ft;ge++){if(ve=J[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(st=this.options.extensions.renderers[ve.type].call({parser:this},ve),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){pe+=st||"";continue}switch(ve.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,$(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(ne="",ae="",Me=ve.header.length,Ie=0;Ie<Me;Ie++)ae+=this.renderer.tablecell(this.parseInline(ve.header[Ie].tokens),{header:!0,align:ve.align[Ie]});for(ne+=this.renderer.tablerow(ae),B="",Me=ve.rows.length,Ie=0;Ie<Me;Ie++){for(de=ve.rows[Ie],ae="",je=de.length,Be=0;Be<je;Be++)ae+=this.renderer.tablecell(this.parseInline(de[Be].tokens),{header:!1,align:ve.align[Be]});B+=this.renderer.tablerow(ae)}pe+=this.renderer.table(ne,B);continue}case"blockquote":{B=this.parse(ve.tokens),pe+=this.renderer.blockquote(B);continue}case"list":{for(ke=ve.ordered,$e=ve.start,xe=ve.loose,Me=ve.items.length,B="",Ie=0;Ie<Me;Ie++)at=ve.items[Ie],bt=at.checked,dt=at.task,lt="",at.task&&(nt=this.renderer.checkbox(bt),xe?at.tokens.length>0&&at.tokens[0].type==="paragraph"?(at.tokens[0].text=nt+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=nt+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:nt}):lt+=nt),lt+=this.parse(at.tokens,xe),B+=this.renderer.listitem(lt,dt,bt);pe+=this.renderer.list(B,ke,$e);continue}case"html":{pe+=this.renderer.html(ve.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(B=ve.tokens?this.parseInline(ve.tokens):ve.text;ge+1<ft&&J[ge+1].type==="text";)ve=J[++ge],B+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);pe+=oe?this.renderer.paragraph(B):B;continue}default:{var kt='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(kt);return}else throw new Error(kt)}}}return pe},Se.parseInline=function(J,oe){oe=oe||this.renderer;var pe="",ge,Ie,Be,Me=J.length;for(ge=0;ge<Me;ge++){if(Ie=J[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Be=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){pe+=Be||"";continue}switch(Ie.type){case"escape":{pe+=oe.text(Ie.text);break}case"html":{pe+=oe.html(Ie.text);break}case"link":{pe+=oe.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,oe));break}case"image":{pe+=oe.image(Ie.href,Ie.title,Ie.text);break}case"strong":{pe+=oe.strong(this.parseInline(Ie.tokens,oe));break}case"em":{pe+=oe.em(this.parseInline(Ie.tokens,oe));break}case"codespan":{pe+=oe.codespan(Ie.text);break}case"br":{pe+=oe.br();break}case"del":{pe+=oe.del(this.parseInline(Ie.tokens,oe));break}case"text":{pe+=oe.text(Ie.text);break}default:{var je='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return pe},Pe}(),fe=q,Le=G,Ve=x,et=ee,rt=me,pt=Te,St=U.merge,Ct=U.checkSanitizeDeprecation,ct=U.escape,_t=T.exports.getDefaults,ht=T.exports.changeDefaults,wt=T.exports.defaults;function Ye(Pe,Se,Ce){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(Ce=Se,Se=null),Se=St({},Ye.defaults,Se||{}),Ct(Se),Ce){var J=Se.highlight,oe;try{oe=fe.lex(Pe,Se)}catch(Be){return Ce(Be)}var pe=function(Me){var je;if(!Me)try{Se.walkTokens&&Ye.walkTokens(oe,Se.walkTokens),je=Le.parse(oe,Se)}catch(de){Me=de}return Se.highlight=J,Me?Ce(Me):Ce(null,je)};if(!J||J.length<3||(delete Se.highlight,!oe.length))return pe();var ge=0;Ye.walkTokens(oe,function(Be){Be.type==="code"&&(ge++,setTimeout(function(){J(Be.text,Be.lang,function(Me,je){if(Me)return pe(Me);je!=null&&je!==Be.text&&(Be.text=je,Be.escaped=!0),ge--,ge===0&&pe()})},0))}),ge===0&&pe();return}try{var Ie=fe.lex(Pe,Se);return Se.walkTokens&&Ye.walkTokens(Ie,Se.walkTokens),Le.parse(Ie,Se)}catch(Be){if(Be.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ct(Be.message+"",!0)+"</pre>";throw Be}}Ye.options=Ye.setOptions=function(Pe){return St(Ye.defaults,Pe),ht(Ye.defaults),Ye},Ye.getDefaults=_t,Ye.defaults=wt,Ye.use=function(){for(var Pe=this,Se=arguments.length,Ce=new Array(Se),J=0;J<Se;J++)Ce[J]=arguments[J];var oe=St.apply(void 0,[{}].concat(Ce)),pe=Ye.defaults.extensions||{renderers:{},childTokens:{}},ge;Ce.forEach(function(Ie){if(Ie.extensions&&(ge=!0,Ie.extensions.forEach(function(Me){if(!Me.name)throw new Error("extension name required");if(Me.renderer){var je=pe.renderers?pe.renderers[Me.name]:null;je?pe.renderers[Me.name]=function(){for(var de=arguments.length,ae=new Array(de),ne=0;ne<de;ne++)ae[ne]=arguments[ne];var B=Me.renderer.apply(this,ae);return B===!1&&(B=je.apply(this,ae)),B}:pe.renderers[Me.name]=Me.renderer}if(Me.tokenizer){if(!Me.level||Me.level!=="block"&&Me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");pe[Me.level]?pe[Me.level].unshift(Me.tokenizer):pe[Me.level]=[Me.tokenizer],Me.start&&(Me.level==="block"?pe.startBlock?pe.startBlock.push(Me.start):pe.startBlock=[Me.start]:Me.level==="inline"&&(pe.startInline?pe.startInline.push(Me.start):pe.startInline=[Me.start]))}Me.childTokens&&(pe.childTokens[Me.name]=Me.childTokens)})),Ie.renderer&&function(){var Me=Ye.defaults.renderer||new et,je=function(ne){var B=Me[ne];Me[ne]=function(){for(var ve=arguments.length,ke=new Array(ve),$e=0;$e<ve;$e++)ke[$e]=arguments[$e];var xe=Ie.renderer[ne].apply(Me,ke);return xe===!1&&(xe=B.apply(Me,ke)),xe}};for(var de in Ie.renderer)je(de);oe.renderer=Me}(),Ie.tokenizer&&function(){var Me=Ye.defaults.tokenizer||new Ve,je=function(ne){var B=Me[ne];Me[ne]=function(){for(var ve=arguments.length,ke=new Array(ve),$e=0;$e<ve;$e++)ke[$e]=arguments[$e];var xe=Ie.tokenizer[ne].apply(Me,ke);return xe===!1&&(xe=B.apply(Me,ke)),xe}};for(var de in Ie.tokenizer)je(de);oe.tokenizer=Me}(),Ie.walkTokens){var Be=Ye.defaults.walkTokens;oe.walkTokens=function(Me){Ie.walkTokens.call(Pe,Me),Be&&Be(Me)}}ge&&(oe.extensions=pe),Ye.setOptions(oe)})},Ye.walkTokens=function(Pe,Se){for(var Ce=function(){var ge=oe.value;switch(Se(ge),ge.type){case"table":{for(var Ie=E(ge.header),Be;!(Be=Ie()).done;){var Me=Be.value;Ye.walkTokens(Me.tokens,Se)}for(var je=E(ge.rows),de;!(de=je()).done;)for(var ae=de.value,ne=E(ae),B;!(B=ne()).done;){var ve=B.value;Ye.walkTokens(ve.tokens,Se)}break}case"list":{Ye.walkTokens(ge.items,Se);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[ge.type]?Ye.defaults.extensions.childTokens[ge.type].forEach(function(ke){Ye.walkTokens(ge[ke],Se)}):ge.tokens&&Ye.walkTokens(ge.tokens,Se)}},J=E(Pe),oe;!(oe=J()).done;)Ce()},Ye.parseInline=function(Pe,Se){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=St({},Ye.defaults,Se||{}),Ct(Se);try{var Ce=fe.lexInline(Pe,Se);return Se.walkTokens&&Ye.walkTokens(Ce,Se.walkTokens),Le.parseInline(Ce,Se)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ct(J.message+"",!0)+"</pre>";throw J}},Ye.Parser=Le,Ye.parser=Le.parse,Ye.Renderer=et,Ye.TextRenderer=rt,Ye.Lexer=fe,Ye.lexer=fe.lex,Ye.Tokenizer=Ve,Ye.Slugger=pt,Ye.parse=Ye;var Pt=Ye;return Pt}),define(Ee[74],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function h(A,I,D){return Math.min(Math.max(A,I),D)}e.clamp=h;function F(A,I){return(I+A%I)%I}e.rot=F;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class T{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function te(E){const T=[];typeof E=="number"&&T.push("code/timeOrigin",E);function A(D){T.push(D,Date.now())}function I(){const D=[];for(let P=0;P<T.length;P+=2)D.push({name:T[P],startTime:T[P+1]});return D}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(E+A.startTime)});return T}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function h(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=h(F))}(),define(Ee[34],_e([0,1,3]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new h.Emitter}add(S){const r=this._icons.get(S.id);r?S.description?r.description=S.description:console.error(`Duplicate registration of codicon ${S.id}`):(this._icons.set(S.id,S),this._onDidRegister.fire(S))}get(S){return this._icons.get(S)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new F;e.iconRegistry=E;function T(t,S){return new I(t,S)}e.registerCodicon=T;function A(t){return t?t.replace(/\$\((.*?)\)/g,(S,r)=>` ${r} `).trim():""}e.getCodiconAriaLabel=A;class I{constructor(S,r,d){this.id=S,this.definition=r,this.description=d,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=I;function D(t,S){const r=["codicon","codicon-"+t];return S&&r.push("codicon-modifier-"+S),r}e.getClassNamesArray=D;var P;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const S=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function r(l){if(l instanceof I)return["codicon","codicon-"+l.id];const p=S.exec(l.id);if(!p)return r(I.error);let[,v,k]=p;const c=["codicon","codicon-"+v];return k&&c.push("codicon-modifier-"+k.substr(1)),c}t.asClassNameArray=r;function d(l){return r(l).join(" ")}t.asClassName=d;function a(l){return"."+r(l).join(".")}t.asCSSSelector=a})(P=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(I=e.Codicon||(e.Codicon={}))}),define(Ee[104],_e([0,1,15,7]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(c){const w=c;return w?[w.on,w.pause,w.resume,w.destroy].every(y=>typeof y=="function"):!1}e.isReadableStream=E;function T(c){const w=c;return w?E(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=T;function A(c,w){return new I(c,w)}e.newWriteableStream=A;class I{constructor(w,y){this.reducer=w,this.options=y,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(y=>this.pendingWritePromises.push(y))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w!="undefined"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(y=>y(w))}emitError(w){this.listeners.error.length===0?(0,h.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(y=>y(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,y){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(y),this.resume();break;case"end":this.listeners.end.push(y),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(y),this.state.flowing&&this.flowErrors();break}}removeListener(w,y){if(this.state.destroyed)return;let i;switch(w){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const o=i.indexOf(y);o>=0&&i.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const y=[...this.pendingWritePromises];this.pendingWritePromises.length=0,y.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(c,w){const y=[];let i;for(;(i=c.read())!==null;)y.push(i);return w(y)}e.consumeReadable=D;function P(c,w,y){const i=[];let o;for(;(o=c.read())!==null&&i.length<y;)i.push(o);return o===null&&i.length>0?w(i):{read:()=>{if(i.length>0)return i.shift();if(typeof o!="undefined"){const u=o;return o=void 0,u}return c.read()}}}e.peekReadable=P;function t(c,w){return new Promise((y,i)=>{const o=[];S(c,{onData:u=>{w&&o.push(u)},onError:u=>{w?i(u):y(void 0)},onEnd:()=>{y(w?w(o):void 0)}})})}e.consumeStream=t;function S(c,w){c.on("error",y=>w.onError(y)),c.on("end",()=>w.onEnd()),c.on("data",y=>w.onData(y))}e.listenStream=S;function r(c,w){return new Promise((y,i)=>{const o=new F.DisposableStore,u=[],s=g=>{if(u.push(g),u.length>w)return o.dispose(),c.pause(),y({stream:c,buffer:u,ended:!1})},f=g=>i(g),m=()=>y({stream:c,buffer:u,ended:!0});o.add((0,F.toDisposable)(()=>c.removeListener("error",f))),c.on("error",f),o.add((0,F.toDisposable)(()=>c.removeListener("end",m))),c.on("end",m),o.add((0,F.toDisposable)(()=>c.removeListener("data",s))),c.on("data",s)})}e.peekStream=r;function d(c,w){const y=A(w);return y.end(c),y}e.toStream=d;function a(){const c=A(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=a;function l(c){let w=!1;return{read:()=>w?null:(w=!0,c)}}e.toReadable=l;function p(c,w,y){const i=A(y);return S(c,{onData:o=>i.write(w.data(o)),onError:o=>i.error(w.error?w.error(o):o),onEnd:()=>i.end()}),i}e.transform=p;function v(c,w,y){let i=!1;return{read:()=>{const o=w.read();return i?o:(i=!0,o!==null?y([c,o]):c)}}}e.prefixedReadable=v;function k(c,w,y){let i=!1;const o=A(y);return S(w,{onData:u=>i?o.write(u):(i=!0,o.write(y([c,u]))),onError:u=>o.error(u),onEnd:()=>{i||(i=!0,o.write(c)),o.end()}}),o}e.prefixedStream=k}),define(Ee[23],_e([0,1,104]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let E,T;class A{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return F?new A(Buffer.allocUnsafe(s)):new A(new Uint8Array(s))}static wrap(s){return F&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new A(s)}static fromString(s,f){return!(f?.dontUseNodeBuffer||!1)&&F?new A(Buffer.from(s)):(E||(E=new TextEncoder),new A(E.encode(s)))}static concat(s,f){if(typeof f=="undefined"){f=0;for(let b=0,C=s.length;b<C;b++)f+=s[b].byteLength}const m=A.alloc(f);let g=0;for(let b=0,C=s.length;b<C;b++){const n=s[b];m.set(n,g),g+=n.byteLength}return m}toString(){return F?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(s,f){return new A(this.buffer.subarray(s,f))}set(s,f){s instanceof A?this.buffer.set(s.buffer,f):this.buffer.set(s,f)}readUInt32BE(s){return P(this.buffer,s)}writeUInt32BE(s,f){t(this.buffer,s,f)}readUInt32LE(s){return S(this.buffer,s)}writeUInt32LE(s,f){r(this.buffer,s,f)}readUInt8(s){return d(this.buffer,s)}writeUInt8(s,f){a(this.buffer,s,f)}}e.VSBuffer=A;function I(u,s){return u[s+0]<<0>>>0|u[s+1]<<8>>>0}e.readUInt16LE=I;function D(u,s,f){u[f+0]=s&255,s=s>>>8,u[f+1]=s&255}e.writeUInt16LE=D;function P(u,s){return u[s]*2**24+u[s+1]*2**16+u[s+2]*2**8+u[s+3]}e.readUInt32BE=P;function t(u,s,f){u[f+3]=s,s=s>>>8,u[f+2]=s,s=s>>>8,u[f+1]=s,s=s>>>8,u[f]=s}e.writeUInt32BE=t;function S(u,s){return u[s+0]<<0>>>0|u[s+1]<<8>>>0|u[s+2]<<16>>>0|u[s+3]<<24>>>0}e.readUInt32LE=S;function r(u,s,f){u[f+0]=s&255,s=s>>>8,u[f+1]=s&255,s=s>>>8,u[f+2]=s&255,s=s>>>8,u[f+3]=s&255}e.writeUInt32LE=r;function d(u,s){return u[s]}e.readUInt8=d;function a(u,s,f){u[f]=s}e.writeUInt8=a;function l(u){return h.consumeReadable(u,s=>A.concat(s))}e.readableToBuffer=l;function p(u){return h.toReadable(u)}e.bufferToReadable=p;function v(u){return h.consumeStream(u,s=>A.concat(s))}e.streamToBuffer=v;async function k(u){return u.ended?A.concat(u.buffer):A.concat([...u.buffer,await v(u.stream)])}e.bufferedStreamToBuffer=k;function c(u){return h.toStream(u,s=>A.concat(s))}e.bufferToStream=c;function w(u){return h.transform(u,{data:s=>typeof s=="string"?A.fromString(s):A.wrap(s)},s=>A.concat(s))}e.streamToBufferReadableStream=w;function y(u){return h.newWriteableStream(s=>A.concat(s),u)}e.newWriteableBufferStream=y;function i(u,s){return h.prefixedReadable(u,s,f=>A.concat(f))}e.prefixedBufferReadable=i;function o(u,s){return h.prefixedStream(u,s,f=>A.concat(f))}e.prefixedBufferStream=o}),define(Ee[35],_e([0,1,9]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(F||(F={})),function(E){const T="error",A="warning",I="warn",D="info",P="ignore";function t(r){return r?h.equalsIgnoreCase(T,r)?E.Error:h.equalsIgnoreCase(A,r)||h.equalsIgnoreCase(I,r)?E.Warning:h.equalsIgnoreCase(D,r)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function S(r){switch(r){case E.Error:return T;case E.Warning:return A;case E.Info:return D;default:return P}}E.toString=S}(F||(F={})),e.default=F}),define(Ee[40],_e([0,1,17,26,9,10]),function(te,e,h,F,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(u){return u===47||u===92}e.isPathSeparator=A;function I(u){return u.replace(/[\\/]/g,h.posix.sep)}e.toSlashes=I;function D(u){return u.indexOf("/")===-1&&(u=I(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.toPosixPath=D;function P(u,s=h.posix.sep){if(!u)return"";const f=u.length,m=u.charCodeAt(0);if(A(m)){if(A(u.charCodeAt(1))&&!A(u.charCodeAt(2))){let b=3;const C=b;for(;b<f&&!A(u.charCodeAt(b));b++);if(C!==b&&!A(u.charCodeAt(b+1))){for(b+=1;b<f;b++)if(A(u.charCodeAt(b)))return u.slice(0,b+1).replace(/[\\/]/g,s)}}return s}else if(v(m)&&u.charCodeAt(1)===58)return A(u.charCodeAt(2))?u.slice(0,2)+s:u.slice(0,2);let g=u.indexOf("://");if(g!==-1){for(g+=3;g<f;g++)if(A(u.charCodeAt(g)))return u.slice(0,g+1)}return""}e.getRoot=P;function t(u){if(!F.isWindows||!u||u.length<5)return!1;let s=u.charCodeAt(0);if(s!==92||(s=u.charCodeAt(1),s!==92))return!1;let f=2;const m=f;for(;f<u.length&&(s=u.charCodeAt(f),s!==92);f++);return!(m===f||(s=u.charCodeAt(f+1),isNaN(s)||s===92))}e.isUNC=t;const S=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(u,s=F.isWindows){const f=s?S:r;return!(!u||u.length===0||/^\s+$/.test(u)||(f.lastIndex=0,f.test(u))||s&&d.test(u)||u==="."||u===".."||s&&u[u.length-1]==="."||s&&u.length!==u.trim().length||u.length>255)}e.isValidBasename=a;function l(u,s,f){const m=u===s;return!f||m?m:!u||!s?!1:(0,E.equalsIgnoreCase)(u,s)}e.isEqual=l;function p(u,s,f,m=h.sep){if(u===s)return!0;if(!u||!s||s.length>u.length)return!1;if(f){if(!(0,E.startsWithIgnoreCase)(u,s))return!1;if(s.length===u.length)return!0;let b=s.length;return s.charAt(s.length-1)===m&&b--,u.charAt(b)===m}return s.charAt(s.length-1)!==m&&(s+=m),u.indexOf(s)===0}e.isEqualOrParent=p;function v(u){return u>=65&&u<=90||u>=97&&u<=122}e.isWindowsDriveLetter=v;function k(u,s){return F.isWindows&&u.endsWith(":")&&(u+=h.sep),(0,h.isAbsolute)(u)||(u=(0,h.join)(s,u)),u=(0,h.normalize)(u),F.isWindows?(u=(0,E.rtrim)(u,h.sep),u.endsWith(":")&&(u+=h.sep)):(u=(0,E.rtrim)(u,h.sep),u||(u=h.sep)),u}e.sanitizeFilePath=k;function c(u){const s=(0,h.normalize)(u);return F.isWindows?u.length>3?!1:w(s)&&(u.length===2||s.charCodeAt(2)===92):s===h.posix.sep}e.isRootOrDriveLetter=c;function w(u){return F.isWindows?v(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.hasDriveLetter=w;function y(u){return w(u)?u[0]:void 0}e.getDriveLetter=y;function i(u,s,f){return s.length>u.length?-1:u===s?0:(f&&(u=u.toLowerCase(),s=s.toLowerCase()),u.indexOf(s))}e.indexOfPath=i;function o(u){const s=u.split(":");let f,m,g;if(s.forEach(b=>{const C=Number(b);(0,T.isNumber)(C)?m===void 0?m=C:g===void 0&&(g=C):f=f?[f,b].join(":"):b}),!f)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:f,line:m!==void 0?m:void 0,column:g!==void 0?g:m!==void 0?1:void 0}}e.parseLineAndColumnAware=o}),define(Ee[22],_e([0,1,10]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const p=Array.isArray(l)?[]:{};return Object.keys(l).forEach(v=>{l[v]&&typeof l[v]=="object"?p[v]=F(l[v]):p[v]=l[v]}),p}e.deepClone=F;function E(l){if(!l||typeof l!="object")return l;const p=[l];for(;p.length>0;){const v=p.shift();Object.freeze(v);for(const k in v)if(T.call(v,k)){const c=v[k];typeof c=="object"&&!Object.isFrozen(c)&&p.push(c)}}return l}e.deepFreeze=E;const T=Object.prototype.hasOwnProperty;function A(l,p){return I(l,p,new Set)}e.cloneAndChange=A;function I(l,p,v){if((0,h.isUndefinedOrNull)(l))return l;const k=p(l);if(typeof k!="undefined")return k;if((0,h.isArray)(l)){const c=[];for(const w of l)c.push(I(w,p,v));return c}if((0,h.isObject)(l)){if(v.has(l))throw new Error("Cannot clone recursive data-structure");v.add(l);const c={};for(let w in l)T.call(l,w)&&(c[w]=I(l[w],p,v));return v.delete(l),c}return l}function D(l,p,v=!0){return(0,h.isObject)(l)?((0,h.isObject)(p)&&Object.keys(p).forEach(k=>{k in l?v&&((0,h.isObject)(l[k])&&(0,h.isObject)(p[k])?D(l[k],p[k],v):l[k]=p[k]):l[k]=p[k]}),l):p}e.mixin=D;function P(l,p){if(l===p)return!0;if(l==null||p===null||p===void 0||typeof l!=typeof p||typeof l!="object"||Array.isArray(l)!==Array.isArray(p))return!1;let v,k;if(Array.isArray(l)){if(l.length!==p.length)return!1;for(v=0;v<l.length;v++)if(!P(l[v],p[v]))return!1}else{const c=[];for(k in l)c.push(k);c.sort();const w=[];for(k in p)w.push(k);if(w.sort(),!P(c,w))return!1;for(v=0;v<c.length;v++)if(!P(l[c[v]],p[c[v]]))return!1}return!0}e.equals=P;function t(l){const p=new Set;return JSON.stringify(l,(v,k)=>{if((0,h.isObject)(k)||Array.isArray(k)){if(p.has(k))return"[Circular]";p.add(k)}return k})}e.safeStringify=t;function S(l,p,v){const k=p(l);return typeof k=="undefined"?v:k}e.getOrDefault=S;function r(l,p){const v=Object.create(null);return!l||!p||Object.keys(p).forEach(c=>{const w=l[c],y=p[c];P(w,y)||(v[c]=y)}),v}e.distinct=r;function d(l,p){const v=p.toLowerCase(),k=Object.keys(l).find(c=>c.toLowerCase()===v);return k?l[k]:l[p]}e.getCaseInsensitive=d;function a(l,p){const v=Object.create(null);for(const k of Object.keys(l))p(k,l[k])&&(v[k]=l[k]);return v}e.filter=a});var Ze=this&&this.__classPrivateFieldSet||function(te,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!E:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(te,h):E?E.value=h:e.set(te,h),h},Oe=this&&this.__classPrivateFieldGet||function(te,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!F:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(te):F?F.value:e.get(te)};define(Ee[20],_e([0,1,9,2]),function(te,e,h,F){"use strict";var E,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(i,o,u){let s=i.get(o);return s===void 0&&(s=u,i.set(o,s)),s}e.getOrSet=I;function D(i){const o=[];return i.forEach((u,s)=>{o.push(`${s} => ${u}`)}),`Map(${i.size}) {${o.join(", ")}}`}e.mapToString=D;function P(i){const o=[];return i.forEach(u=>{o.push(u)}),`Set(${i.size}) {${o.join(", ")}}`}e.setToString=P;class t{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const u=o.charCodeAt(0),s=this._value.charCodeAt(this._pos);return u-s}value(){return this._value[this._pos]}}e.StringIterator=t;class S{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,h.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,h.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class r{constructor(o=!0,u=!0){this._splitOnBackslash=o,this._caseSensitive=u}reset(o){return this._value=o.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,h.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,h.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=r;var d;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(d||(d={}));class a{constructor(o){this._ignorePathCasing=o,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new r(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,h.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,h.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,h.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,h.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class l{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(o){this._iter=o}static forUris(o=()=>!1){return new p(new a(o))}static forPaths(){return new p(new r)}static forStrings(){return new p(new t)}static forConfigKeys(){return new p(new S)}clear(){this._root=void 0}set(o,u){const s=this._iter.reset(o);let f;for(this._root||(this._root=new l,this._root.segment=s.value()),f=this._root;;){const g=s.cmp(f.segment);if(g>0)f.left||(f.left=new l,f.left.segment=s.value()),f=f.left;else if(g<0)f.right||(f.right=new l,f.right.segment=s.value()),f=f.right;else if(s.hasNext())s.next(),f.mid||(f.mid=new l,f.mid.segment=s.value()),f=f.mid;else break}const m=f.value;return f.value=u,f.key=o,m}get(o){return this._getNode(o)?.value}_getNode(o){const u=this._iter.reset(o);let s=this._root;for(;s;){const f=u.cmp(s.segment);if(f>0)s=s.left;else if(f<0)s=s.right;else if(u.hasNext())u.next(),s=s.mid;else break}return s}has(o){const u=this._getNode(o);return!(u?.value===void 0&&u?.mid===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,u){const s=this._iter.reset(o),f=[];let m=this._root;for(;m;){const g=s.cmp(m.segment);if(g>0)f.push([1,m]),m=m.left;else if(g<0)f.push([-1,m]),m=m.right;else if(s.hasNext())s.next(),f.push([0,m]),m=m.mid;else{for(u?(m.left=void 0,m.mid=void 0,m.right=void 0):m.value=void 0;f.length>0&&m.isEmpty();){let[b,C]=f.pop();switch(b){case 1:C.left=void 0;break;case 0:C.mid=void 0;break;case-1:C.right=void 0;break}m=C}break}}}findSubstr(o){const u=this._iter.reset(o);let s=this._root,f;for(;s;){const m=u.cmp(s.segment);if(m>0)s=s.left;else if(m<0)s=s.right;else if(u.hasNext())u.next(),f=s.value||f,s=s.mid;else break}return s&&s.value||f}findSuperstr(o){const u=this._iter.reset(o);let s=this._root;for(;s;){const f=u.cmp(s.segment);if(f>0)s=s.left;else if(f<0)s=s.right;else if(u.hasNext())u.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(o){for(const[u,s]of this)o(s,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(o){if(!o)return;const u=[o];for(;u.length>0;){const s=u.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&u.push(s.left),s.mid&&u.push(s.mid),s.right&&u.push(s.right))}}}e.TernarySearchTree=p;class v{constructor(o,u){this[E]="ResourceMap",o instanceof v?(this.map=new Map(o.map),this.toKey=u??v.defaultToKey):(this.map=new Map,this.toKey=o??v.defaultToKey)}set(o,u){return this.map.set(this.toKey(o),u),this}get(o){return this.map.get(this.toKey(o))}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,u){typeof u!="undefined"&&(o=o.bind(u));for(let[s,f]of this.map)o(f,F.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let o of this.map.keys())yield F.URI.parse(o)}*entries(){for(let o of this.map.entries())yield[F.URI.parse(o[0]),o[1]]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(let o of this.map)yield[F.URI.parse(o[0]),o[1]]}}e.ResourceMap=v,v.defaultToKey=i=>i.toString();var k;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(k=e.Touch||(e.Touch={}));class c{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(o){return this._map.has(o)}get(o,u=0){const s=this._map.get(o);if(!!s)return u!==0&&this.touch(s,u),s.value}set(o,u,s=0){let f=this._map.get(o);if(f)f.value=u,s!==0&&this.touch(f,s);else{switch(f={key:o,value:u,next:void 0,previous:void 0},s){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(o,f),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const u=this._map.get(o);if(!!u)return this._map.delete(o),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}forEach(o,u){const s=this._state;let f=this._head;for(;f;){if(u?o.bind(u)(f.value,f.key,this):o(f.value,f.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const o=this,u=this._state;let s=this._head;const f={[Symbol.iterator](){return f},next(){if(o._state!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const m={value:s.key,done:!1};return s=s.next,m}else return{value:void 0,done:!0}}};return f}values(){const o=this,u=this._state;let s=this._head;const f={[Symbol.iterator](){return f},next(){if(o._state!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const m={value:s.value,done:!1};return s=s.next,m}else return{value:void 0,done:!0}}};return f}entries(){const o=this,u=this._state;let s=this._head;const f={[Symbol.iterator](){return f},next(){if(o._state!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const m={value:[s.key,s.value],done:!1};return s=s.next,m}else return{value:void 0,done:!0}}};return f}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(o>=this.size)return;if(o===0){this.clear();return}let u=this._head,s=this.size;for(;u&&s>o;)this._map.delete(u.key),u=u.next,s--;this._head=u,this._size=s,u&&(u.previous=void 0),this._state++}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const u=o.next,s=o.previous;if(!u||!s)throw new Error("Invalid list");u.previous=s,s.next=u}o.next=void 0,o.previous=void 0,this._state++}touch(o,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(o===this._head)return;const s=o.next,f=o.previous;o===this._tail?(f.next=void 0,this._tail=f):(s.previous=f,f.next=s),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(u===2){if(o===this._tail)return;const s=o.next,f=o.previous;o===this._head?(s.previous=void 0,this._head=s):(s.previous=f,f.next=s),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((u,s)=>{o.push([s,u])}),o}fromJSON(o){this.clear();for(const[u,s]of o)this.set(u,s)}}e.LinkedMap=c;class w extends c{constructor(o,u=1){super();this._limit=o,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,u=2){return super.get(o,u)}peek(o){return super.get(o,0)}set(o,u){return super.set(o,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=w;class y{constructor(o){A.set(this,void 0),Ze(this,A,o,"f")}get size(){return Oe(this,A,"f").size}forEach(o,u){Oe(this,A,"f").forEach(o,u)}get(o){return Oe(this,A,"f").get(o)}has(o){return Oe(this,A,"f").has(o)}entries(){return Oe(this,A,"f").entries()}keys(){return Oe(this,A,"f").keys()}values(){return Oe(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Oe(this,A,"f").entries()}}e.ReadonlyMapView=y}),define(Ee[105],_e([0,1,20,9]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...W){return function(ee,me){for(let Te=0,Ue=W.length;Te<Ue;Te++){const He=W[Te](ee,me);if(He)return He}return null}}e.or=E,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(W,ee,me){if(!me||me.length<ee.length)return null;let Te;return W?Te=F.startsWithIgnoreCase(me,ee):Te=me.indexOf(ee)===0,Te?ee.length>0?[{start:0,end:ee.length}]:[]:null}function A(W,ee){const me=ee.toLowerCase().indexOf(W.toLowerCase());return me===-1?null:[{start:me,end:me+W.length}]}e.matchesContiguousSubString=A;function I(W,ee){return D(W.toLowerCase(),ee.toLowerCase(),0,0)}e.matchesSubString=I;function D(W,ee,me,Te){if(me===W.length)return[];if(Te===ee.length)return null;if(W[me]===ee[Te]){let Ue=null;return(Ue=D(W,ee,me+1,Te+1))?v({start:Te,end:Te+1},Ue):null}return D(W,ee,me,Te+1)}function P(W){return 97<=W&&W<=122}function t(W){return 65<=W&&W<=90}e.isUpper=t;function S(W){return 48<=W&&W<=57}function r(W){return W===32||W===9||W===10||W===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(W=>d.add(W.charCodeAt(0)));function a(W){return r(W)||d.has(W)}function l(W,ee){return W===ee||a(W)&&a(ee)}function p(W){return P(W)||t(W)||S(W)}function v(W,ee){return ee.length===0?ee=[W]:W.end===ee[0].start?ee[0].start=W.start:ee.unshift(W),ee}function k(W,ee){for(let me=ee;me<W.length;me++){const Te=W.charCodeAt(me);if(t(Te)||S(Te)||me>0&&!p(W.charCodeAt(me-1)))return me}return W.length}function c(W,ee,me,Te){if(me===W.length)return[];if(Te===ee.length)return null;if(W[me]!==ee[Te].toLowerCase())return null;{let Ue=null,He=Te+1;for(Ue=c(W,ee,me+1,Te+1);!Ue&&(He=k(ee,He))<ee.length;)Ue=c(W,ee,me+1,He),He++;return Ue===null?null:v({start:Te,end:Te+1},Ue)}}function w(W){let ee=0,me=0,Te=0,Ue=0,He=0;for(let fe=0;fe<W.length;fe++)He=W.charCodeAt(fe),t(He)&&ee++,P(He)&&me++,p(He)&&Te++,S(He)&&Ue++;const be=ee/W.length,Je=me/W.length,$=Te/W.length,G=Ue/W.length;return{upperPercent:be,lowerPercent:Je,alphaPercent:$,numericPercent:G}}function y(W){const{upperPercent:ee,lowerPercent:me}=W;return me===0&&ee>.6}function i(W){const{upperPercent:ee,lowerPercent:me,alphaPercent:Te,numericPercent:Ue}=W;return me>.2&&ee<.8&&Te>.6&&Ue<.2}function o(W){let ee=0,me=0,Te=0,Ue=0;for(let He=0;He<W.length;He++)Te=W.charCodeAt(He),t(Te)&&ee++,P(Te)&&me++,r(Te)&&Ue++;return(ee===0||me===0)&&Ue===0?W.length<=30:ee<=5}function u(W,ee){if(!ee||(ee=ee.trim(),ee.length===0)||!o(W)||ee.length>60)return null;const me=w(ee);if(!i(me)){if(!y(me))return null;ee=ee.toLowerCase()}let Te=null,Ue=0;for(W=W.toLowerCase();Ue<ee.length&&(Te=c(W,ee,0,Ue))===null;)Ue=k(ee,Ue+1);return Te}e.matchesCamelCase=u;function s(W,ee,me=!1){if(!ee||ee.length===0)return null;let Te=null,Ue=0;for(W=W.toLowerCase(),ee=ee.toLowerCase();Ue<ee.length&&(Te=f(W,ee,0,Ue,me))===null;)Ue=m(ee,Ue+1);return Te}e.matchesWords=s;function f(W,ee,me,Te,Ue){if(me===W.length)return[];if(Te===ee.length)return null;if(l(W.charCodeAt(me),ee.charCodeAt(Te))){let He=null,be=Te+1;if(He=f(W,ee,me+1,Te+1,Ue),!Ue)for(;!He&&(be=m(ee,be))<ee.length;)He=f(W,ee,me+1,be,Ue),be++;return He===null?null:v({start:Te,end:Te+1},He)}else return null}function m(W,ee){for(let me=ee;me<W.length;me++)if(a(W.charCodeAt(me))||me>0&&a(W.charCodeAt(me-1)))return me;return W.length}const g=E(e.matchesPrefix,u,A),b=E(e.matchesPrefix,u,I),C=new h.LRUCache(1e4);function n(W,ee,me=!1){if(typeof W!="string"||typeof ee!="string")return null;let Te=C.get(W);Te||(Te=new RegExp(F.convertSimple2RegExpPattern(W),"i"),C.set(W,Te));const Ue=Te.exec(ee);return Ue?[{start:Ue.index,end:Ue.index+Ue[0].length}]:me?b(W,ee):g(W,ee)}e.matchesFuzzy=n;function _(W,ee){const me=Qe(W,W.toLowerCase(),0,ee,ee.toLowerCase(),0,!0);return me?U(me):null}e.matchesFuzzy2=_;function R(W,ee,me,Te,Ue,He){const be=Math.min(13,W.length);for(;me<be;me++){const Je=Qe(W,ee,me,Te,Ue,He,!1);if(Je)return Je}return[0,He]}e.anyScore=R;function U(W){if(typeof W=="undefined")return[];const ee=[],me=W[1];for(let Te=W.length-1;Te>1;Te--){const Ue=W[Te]+me,He=ee[ee.length-1];He&&He.end===Ue?He.end=Ue+1:ee.push({start:Ue,end:Ue+1})}return ee}e.createMatches=U;const V=128;function le(){const W=[],ee=[];for(let me=0;me<=V;me++)ee[me]=0;for(let me=0;me<=V;me++)W.push(ee.slice(0));return W}function he(W){const ee=[];for(let me=0;me<=W;me++)ee[me]=0;return ee}const j=he(2*V),H=he(2*V),L=le(),K=le(),x=le(),Y=!1;function ce(W,ee,me,Te,Ue){function He(Je,$,G=" "){for(;Je.length<$;)Je=G+Je;return Je}let be=` |   |${Te.split("").map(Je=>He(Je,3)).join("|")}
`;for(let Je=0;Je<=me;Je++)Je===0?be+=" |":be+=`${ee[Je-1]}|`,be+=W[Je].slice(0,Ue+1).map($=>He($.toString(),3)).join("|")+`
`;return be}function z(W,ee,me,Te){W=W.substr(ee),me=me.substr(Te),console.log(ce(K,W,W.length,me,me.length)),console.log(ce(x,W,W.length,me,me.length)),console.log(ce(L,W,W.length,me,me.length))}function se(W,ee){if(ee<0||ee>=W.length)return!1;const me=W.codePointAt(ee);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(me)}}function re(W,ee){if(ee<0||ee>=W.length)return!1;switch(W.charCodeAt(ee)){case 32:case 9:return!0;default:return!1}}function we(W,ee,me){return ee[W]!==me[W]}function Re(W,ee,me,Te,Ue,He,be=!1){for(;ee<me&&Ue<He;)W[ee]===Te[Ue]&&(be&&(j[ee]=Ue),ee+=1),Ue+=1;return ee===me}e.isPatternInWord=Re;var Fe;(function(W){W[W.Diag=1]="Diag",W[W.Left=2]="Left",W[W.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var Ne;(function(W){W.Default=[-100,0];function ee(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}W.isDefault=ee})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function Qe(W,ee,me,Te,Ue,He,be){const Je=W.length>V?V:W.length,$=Te.length>V?V:Te.length;if(me>=Je||He>=$||Je-me>$-He||!Re(ee,me,Je,Ue,He,$,!0))return;qe(Je,$,me,He,ee,Ue);let G=1,fe=1,Le=me,Ve=He;const et=[!1];for(G=1,Le=me;Le<Je;G++,Le++){const ct=j[Le],_t=H[Le],ht=Le+1<Je?H[Le+1]:$;for(fe=ct-He+1,Ve=ct;Ve<ht;fe++,Ve++){let wt=Number.MIN_SAFE_INTEGER,Ye=!1;Ve<=_t&&(wt=Ke(W,ee,Le,me,Te,Ue,Ve,$,He,L[G-1][fe-1]===0,et));let Pt=0;wt!==Number.MAX_SAFE_INTEGER&&(Ye=!0,Pt=wt+K[G-1][fe-1]);const Pe=Ve>ct,Se=Pe?K[G][fe-1]+(L[G][fe-1]>0?-5:0):0,Ce=Ve>ct+1&&L[G][fe-1]>0,J=Ce?K[G][fe-2]+(L[G][fe-2]>0?-5:0):0;if(Ce&&(!Pe||J>=Se)&&(!Ye||J>=Pt))K[G][fe]=J,x[G][fe]=3,L[G][fe]=0;else if(Pe&&(!Ye||Se>=Pt))K[G][fe]=Se,x[G][fe]=2,L[G][fe]=0;else if(Ye)K[G][fe]=Pt,x[G][fe]=1,L[G][fe]=L[G-1][fe-1]+1;else throw new Error("not possible")}}if(Y&&z(W,me,Te,He),!et[0]&&!be)return;G--,fe--;const rt=[K[G][fe],He];let pt=0,St=0;for(;G>=1;){let ct=fe;do{const _t=x[G][ct];if(_t===3)ct=ct-2;else if(_t===2)ct=ct-1;else break}while(ct>=1);pt>1&&ee[me+G-1]===Ue[He+fe-1]&&!we(ct+He-1,Te,Ue)&&pt+1>L[G][ct]&&(ct=fe),ct===fe?pt++:pt=1,St||(St=ct),G--,fe=ct-1,rt.push(fe)}$===Je&&(rt[0]+=2);const Ct=St-Je;return rt[0]-=Ct,rt}e.fuzzyScore=Qe;function qe(W,ee,me,Te,Ue,He){let be=W-1,Je=ee-1;for(;be>=me&&Je>=Te;)Ue[be]===He[Je]&&(H[be]=Je,be--),Je--}function Ke(W,ee,me,Te,Ue,He,be,Je,$,G,fe){if(ee[me]!==He[be])return Number.MIN_SAFE_INTEGER;let Le=1,Ve=!1;return be===me-Te?Le=W[me]===Ue[be]?7:5:we(be,Ue,He)&&(be===0||!we(be-1,Ue,He))?(Le=W[me]===Ue[be]?7:5,Ve=!0):se(He,be)&&(be===0||!se(He,be-1))?Le=5:(se(He,be-1)||re(He,be-1))&&(Le=5,Ve=!0),Le>1&&me===Te&&(fe[0]=!0),Ve||(Ve=we(be,Ue,He)||se(He,be-1)||re(He,be-1)),me===Te?be>$&&(Le-=Ve?3:5):G?Le+=Ve?2:0:Le+=Ve?0:1,be+1===Je&&(Le-=Ve?3:5),Le}function N(W,ee,me,Te,Ue,He,be){return X(W,ee,me,Te,Ue,He,!0,be)}e.fuzzyScoreGracefulAggressive=N;function q(W,ee,me,Te,Ue,He,be){return X(W,ee,me,Te,Ue,He,!1,be)}e.fuzzyScoreGraceful=q;function X(W,ee,me,Te,Ue,He,be,Je){let $=Qe(W,ee,me,Te,Ue,He,Je);if($&&!be)return $;if(W.length>=3){const G=Math.min(7,W.length-1);for(let fe=me+1;fe<G;fe++){const Le=ie(W,fe);if(Le){const Ve=Qe(Le,Le.toLowerCase(),me,Te,Ue,He,Je);Ve&&(Ve[0]-=3,(!$||Ve[0]>$[0])&&($=Ve))}}}return $}function ie(W,ee){if(ee+1>=W.length)return;const me=W[ee],Te=W[ee+1];if(me!==Te)return W.slice(0,ee)+Te+me+W.slice(ee+2)}}),define(Ee[106],_e([0,1,34,105,9]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${T.source}`,"g");function I(l){return l.replace(A,(p,v)=>v?p:`\\${p}`)}e.escapeIcons=I;const D=new RegExp(`\\\\${T.source}`,"g");function P(l){return l.replace(D,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=P;const t=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function S(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(t,(p,v,k,c)=>k?p:v||c||"")}e.stripIcons=S;function r(l){const p=l.indexOf(e.iconStartMarker);return p===-1?{text:l}:d(l,p)}e.parseLabelWithIcons=r;function d(l,p){const v=[];let k="";function c(m){if(m){k+=m;for(const g of m)v.push(i)}}let w=-1,y="",i=0,o,u,s=p;const f=l.length;for(c(l.substr(0,p));s<f;)o=l[s],u=l[s+1],o===e.iconStartMarker[0]&&u===e.iconStartMarker[1]?(w=s,c(y),y=e.iconStartMarker,s++):o===")"&&w!==-1?(i+=s-w+1,w=-1,y=""):w!==-1?/^[a-z0-9\-]$/i.test(o)?y+=o:(c(y),w=-1,y=""):c(o),s++;return c(y),{text:k,iconOffsets:v}}function a(l,p,v=!1){const{text:k,iconOffsets:c}=p;if(!c||c.length===0)return(0,F.matchesFuzzy)(l,k,v);const w=(0,E.ltrim)(k," "),y=k.length-w.length,i=(0,F.matchesFuzzy)(l,w,v);if(i)for(const o of i){const u=c[o.start+y]+y;o.start+=u,o.end+=u}return i}e.matchesFuzzyIconAware=a}),define(Ee[75],_e([0,1,15,106]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(d="",a=!1){if(this.value=d,typeof this.value!="string")throw(0,h.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1)}appendText(d,a=0){return this.value+=P(this.supportThemeIcons?(0,F.escapeIcons)(d):d).replace(/([ \t]+)/g,(l,p)=>"&nbsp;".repeat(p.length)).replace(/^>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,a){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=T;function A(r){return I(r)?!r.value:Array.isArray(r)?r.every(A):!0}e.isEmptyMarkdownString=A;function I(r){return r instanceof T?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function D(r,d){return r===d?!0:!r||!d?!1:r.value===d.value&&r.isTrusted===d.isTrusted&&r.supportThemeIcons===d.supportThemeIcons}e.markdownStringEqual=D;function P(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function t(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function S(r){const d=[],a=r.split("|").map(p=>p.trim());r=a[0];const l=a[1];if(l){const p=/height=(\d+)/.exec(l),v=/width=(\d+)/.exec(l),k=p?p[1]:"",c=v?v[1]:"",w=isFinite(parseInt(c)),y=isFinite(parseInt(k));w&&d.push(`width="${c}"`),y&&d.push(`height="${k}"`)}return{href:r,dimensions:d}}e.parseHrefAndDimensions=S}),define(Ee[52],_e([0,1,23,9,2]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(t){return JSON.stringify(t,D)}e.stringify=T;function A(t){let S=JSON.parse(t);return S=P(S),S}e.parse=A;var I;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function D(t,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:(0,F.regExpFlags)(S)}:S}function P(t,S=0){if(!t||S>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof h.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let r=0;r<t.length;++r)t[r]=P(t[r],S+1);else for(const r in t)Object.hasOwnProperty.call(t,r)&&(t[r]=P(t[r],S+1))}return t}e.revive=P}),define(Ee[11],_e([0,1,26,2]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp"})(E=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,t){this._hosts[D]=P,this._ports[D]=t}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let t=this._hosts[P];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const S=this._ports[P],r=this._connectionTokens[P];let d=`path=${encodeURIComponent(D.path)}`;return typeof r=="string"&&(d+=`&tkn=${encodeURIComponent(r)}`),F.URI.from({scheme:h.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${S}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new T;class A{asBrowserUri(D,P){const t=this.toUri(D,P);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(h.isNative||typeof h.globals.importScripts=="function"&&h.globals.origin===`${E.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(D,P){const t=this.toUri(D,P);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==A.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(D,P){return F.URI.isUri(D)?D:F.URI.parse(P.toUrl(D))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(Ee[24],_e([0,1,40,11,17,26,9,2]),function(te,e,h,F,E,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(d){return(0,I.uriToFsPath)(d,!0)}e.originalFSPath=D;class P{constructor(a){this._ignorePathCasing=a}compare(a,l,p=!1){return a===l?0:(0,A.compare)(this.getComparisonKey(a,p),this.getComparisonKey(l,p))}isEqual(a,l,p=!1){return a===l?!0:!a||!l?!1:this.getComparisonKey(a,p)===this.getComparisonKey(l,p)}getComparisonKey(a,l=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,l,p=!1){if(a.scheme===l.scheme){if(a.scheme===F.Schemas.file)return h.isEqualOrParent(D(a),D(l),this._ignorePathCasing(a))&&a.query===l.query&&(p||a.fragment===l.fragment);if((0,e.isEqualAuthority)(a.authority,l.authority))return h.isEqualOrParent(a.path,l.path,this._ignorePathCasing(a),"/")&&a.query===l.query&&(p||a.fragment===l.fragment)}return!1}joinPath(a,...l){return I.URI.joinPath(a,...l)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return E.posix.basename(a.path)}extname(a){const l=E.posix.extname(a.path),p=l.indexOf("?");return p!==-1?l.substr(0,p):l}dirname(a){if(a.path.length===0)return a;let l;return a.scheme===F.Schemas.file?l=I.URI.file(E.dirname(D(a))).path:(l=E.posix.dirname(a.path),a.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),l="/")),a.with({path:l})}normalizePath(a){if(!a.path.length)return a;let l;return a.scheme===F.Schemas.file?l=I.URI.file(E.normalize(D(a))).path:l=E.posix.normalize(a.path),a.with({path:l})}relativePath(a,l){if(a.scheme!==l.scheme||!(0,e.isEqualAuthority)(a.authority,l.authority))return;if(a.scheme===F.Schemas.file){const k=E.relative(D(a),D(l));return T.isWindows?h.toSlashes(k):k}let p=a.path||"/",v=l.path||"/";if(this._ignorePathCasing(a)){let k=0;for(const c=Math.min(p.length,v.length);k<c&&!(p.charCodeAt(k)!==v.charCodeAt(k)&&p.charAt(k).toLowerCase()!==v.charAt(k).toLowerCase());k++);p=v.substr(0,k)+p.substr(k)}return E.posix.relative(p,v)}resolvePath(a,l){if(a.scheme===F.Schemas.file){const p=I.URI.file(E.resolve(D(a),l));return a.with({authority:p.authority,path:p.path})}return l=h.toPosixPath(l),a.with({path:E.posix.resolve(a.path,l)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,l){return a===l||(0,A.equalsIgnoreCase)(a,l)}hasTrailingPathSeparator(a,l=E.sep){if(a.scheme===F.Schemas.file){const p=D(a);return p.length>h.getRoot(p).length&&p[p.length-1]===l}else{const p=a.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,l=E.sep){return(0,e.hasTrailingPathSeparator)(a,l)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,l=E.sep){let p=!1;if(a.scheme===F.Schemas.file){const v=D(a);p=v!==void 0&&v.length===h.getRoot(v).length&&v[v.length-1]===l}else{l="/";const v=a.path;p=v.length===1&&v.charCodeAt(v.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(a,l)?a.with({path:a.path+"/"}):a}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(d=>d.scheme===F.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new P(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(d,a){const l=[];for(let p=0;p<d.length;p++){const v=a(d[p]);d.some((k,c)=>c===p?!1:(0,e.isEqualOrParent)(v,a(k)))||l.push(d[p])}return l}e.distinctParents=t;var S;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function a(l){const p=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(c=>{const[w,y]=c.split(":");w&&y&&p.set(w,y)});const k=l.path.substring(0,l.path.indexOf(";"));return k&&p.set(d.META_DATA_MIME,k),p}d.parseMetaData=a})(S=e.DataUri||(e.DataUri={}));function r(d,a,l){if(a){let p=d.path;return p&&p[0]!==E.posix.sep&&(p=E.posix.sep+p),d.with({scheme:l,authority:a,path:p})}return d.with({scheme:l})}e.toLocalResource=r}),define(Ee[13],_e([0,1,21,15,3,7,24]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(H){return!!H&&typeof H.then=="function"}e.isThenable=I;function D(H){const L=new h.CancellationTokenSource,K=H(L.token),x=new Promise((Y,ce)=>{const z=L.token.onCancellationRequested(()=>{z.dispose(),L.dispose(),ce((0,F.canceled)())});Promise.resolve(K).then(se=>{z.dispose(),L.dispose(),Y(se)},se=>{z.dispose(),L.dispose(),ce(se)})});return new class{cancel(){L.cancel()}then(Y,ce){return x.then(Y,ce)}catch(Y){return this.then(void 0,Y)}finally(Y){return x.finally(Y)}}}e.createCancelablePromise=D;function P(H,L,K){return Promise.race([H,new Promise(x=>L.onCancellationRequested(()=>x(K)))])}e.raceCancellation=P;async function t(H){let L=-1;const K=H.map((Y,ce)=>Y.then(z=>(L=ce,z))),x=await Promise.race(K);return H.forEach((Y,ce)=>{ce!==L&&Y.cancel()}),x}e.raceCancellablePromises=t;function S(H,L,K){let x;const Y=setTimeout(()=>{x?.(void 0),K?.()},L);return Promise.race([H.finally(()=>clearTimeout(Y)),new Promise(ce=>x=ce)])}e.raceTimeout=S;function r(H){return new Promise((L,K)=>{const x=H();I(x)?x.then(L,K):L(x)})}e.asPromise=r;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const K=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(K,K).then(x)})}return new Promise((K,x)=>{this.queuedPromise.then(K,x)})}return this.activePromise=L(),new Promise((K,x)=>{this.activePromise.then(Y=>{this.activePromise=null,K(Y)},Y=>{this.activePromise=null,x(Y)})})}}e.Throttler=d;class a{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=a;class l{constructor(){this.promiseMap=new Map}queue(L,K){const Y=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.promiseMap.get(L)===Y&&this.promiseMap.delete(L)});return this.promiseMap.set(L,Y),Y}}e.SequencerByKey=l;class p{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,K=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,Y)=>{this.doResolve=x,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},K),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class v{constructor(L){this.delayer=new p(L),this.throttler=new d}trigger(L,K){return this.delayer.trigger(()=>this.throttler.queue(L),K)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class k{constructor(){this._isOpen=!1,this._promise=new Promise((L,K)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=k;class c extends k{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function w(H,L){return L?new Promise((K,x)=>{const Y=setTimeout(()=>{ce.dispose(),K()},H),ce=L.onCancellationRequested(()=>{clearTimeout(Y),ce.dispose(),x((0,F.canceled)())})}):D(K=>w(H,K))}e.timeout=w;function y(H,L=0){const K=setTimeout(H,L);return(0,T.toDisposable)(()=>clearTimeout(K))}e.disposableTimeout=y;function i(H){const L=[];let K=0;const x=H.length;function Y(){return K<x?H[K++]():null}function ce(z){z!=null&&L.push(z);const se=Y();return se?se.then(ce):Promise.resolve(L)}return Promise.resolve(null).then(ce)}e.sequence=i;function o(H,L=x=>!!x,K=null){let x=0;const Y=H.length,ce=()=>{if(x>=Y)return Promise.resolve(K);const z=H[x++];return Promise.resolve(z()).then(re=>L(re)?Promise.resolve(re):ce())};return ce()}e.first=o;function u(H,L=x=>!!x,K=null){if(H.length===0)return Promise.resolve(K);let x=H.length;const Y=()=>{x=-1;for(const ce of H)ce.cancel?.()};return new Promise((ce,z)=>{for(const se of H)se.then(re=>{--x>=0&&L(re)?(Y(),ce(re)):x===0&&ce(K)}).catch(re=>{--x>=0&&(Y(),z(re))})})}e.firstParallel=u;class s{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((K,x)=>{this.outstandingPromises.push({factory:L,c:K,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const K=L.factory();K.then(L.c,L.e),K.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class f extends s{constructor(){super(1)}}e.Queue=f;class m{constructor(){this.queues=new Map}queueFor(L,K=A.extUri){const x=K.getComparisonKey(L);let Y=this.queues.get(x);return Y||(Y=new f,E.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(x)}),this.queues.set(x,Y)),Y}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=m;class g{constructor(L,K){this._token=-1,typeof L=="function"&&typeof K=="number"&&this.setIfNotSet(L,K)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,K){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},K)}setIfNotSet(L,K){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},K))}}e.TimeoutTimer=g;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,K){this.cancel(),this._token=setInterval(()=>{L()},K)}}e.IntervalTimer=b;class C{constructor(L,K){this.timeoutToken=-1,this.runner=L,this.timeout=K,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=C;class n extends C{constructor(L,K){super(L,K);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=n;class _ extends T.Disposable{constructor(L,K,x,Y){super();this.maxWorkChunkSize=L,this.maxPendingWork=K,this.throttleDelay=x,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.maxPendingWork)return!1}else if(this.pending+L.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new C(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const H=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const K=setTimeout(()=>L(H));let x=!1;return{dispose(){x||(x=!0,clearTimeout(K))}}}}else e.runWhenIdle=(H,L)=>{const K=requestIdleCallback(H,typeof L=="number"?{timeout:L}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(K))}}}}();class R{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(K){this._error=K}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function U(H,L,K){let x;for(let Y=0;Y<K;Y++)try{return await H()}catch(ce){x=ce,await w(L)}throw x}e.retry=U;class V{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,K,x){return this._pending={taskId:L,cancel:()=>x?.(),promise:K},K.then(()=>this.donePending(L),()=>this.donePending(L)),K}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let K,x;const Y=new Promise((ce,z)=>{K=ce,x=z});this._next={run:L,promise:Y,promiseResolve:K,promiseReject:x}}return this._next.promise}}e.TaskSequentializer=V;class le{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=le;class he{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,K)=>{this.completeCallback=L,this.errorCallback=K})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(K=>{this.completeCallback(L),this.resolved=!0,K()})}error(L){return new Promise(K=>{this.errorCallback(L),this.rejected=!0,K()})}cancel(){new Promise(L=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=he;var j;(function(H){async function L(K){let x;const Y=await Promise.all(K.map(ce=>ce.then(z=>z,z=>{x||(x=z)})));if(typeof x!="undefined")throw x;return Y}H.settled=L})(j=e.Promises||(e.Promises={}))}),define(Ee[107],_e([0,1,13,17]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new h.IdleValue(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),T=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(C,n,_=!1){const R=C||"",U=n||"",V=E.value.collator.compare(R,U);return E.value.collatorIsNumeric&&V===0&&R!==U?R<U?-1:1:V}e.compareFileNames=I;function D(C,n){const _=T.value.collator;return C=C||"",n=n||"",y(_,C,n)}e.compareFileNamesDefault=D;function P(C,n){const _=T.value.collator;return C=C||"",n=n||"",s(C,n)||y(_,C,n)}e.compareFileNamesUpper=P;function t(C,n){const _=T.value.collator;return C=C||"",n=n||"",u(C,n)||y(_,C,n)}e.compareFileNamesLower=t;function S(C,n){return C=C||"",n=n||"",C===n?0:C<n?-1:1}e.compareFileNamesUnicode=S;function r(C,n,_=!1){_||(C=C&&C.toLowerCase(),n=n&&n.toLowerCase());const[R,U]=c(C),[V,le]=c(n);return R!==V?R<V?-1:1:U===le?0:U<le?-1:1}e.noIntlCompareFileNames=r;function d(C,n){const[_,R]=c(C),[U,V]=c(n);let le=E.value.collator.compare(R,V);if(le===0){if(E.value.collatorIsNumeric&&R!==V)return R<V?-1:1;if(le=E.value.collator.compare(_,U),E.value.collatorIsNumeric&&le===0&&_!==U)return _<U?-1:1}return le}e.compareFileExtensions=d;function a(C,n){C=C||"",n=n||"";const _=w(C),R=w(n),U=T.value.collator,V=A.value.collator;return y(V,_,R)||y(U,C,n)}e.compareFileExtensionsDefault=a;function l(C,n){C=C||"",n=n||"";const _=w(C),R=w(n),U=T.value.collator,V=A.value.collator;return y(V,_,R)||s(C,n)||y(U,C,n)}e.compareFileExtensionsUpper=l;function p(C,n){C=C||"",n=n||"";const _=w(C),R=w(n),U=T.value.collator,V=A.value.collator;return y(V,_,R)||u(C,n)||y(U,C,n)}e.compareFileExtensionsLower=p;function v(C,n){C=C||"",n=n||"";const _=w(C).toLowerCase(),R=w(n).toLowerCase();return _!==R?_<R?-1:1:C!==n?C<n?-1:1:0}e.compareFileExtensionsUnicode=v;const k=/^(.*?)(\.([^.]*))?$/;function c(C,n=!1){const _=C?k.exec(C):[];let R=[_&&_[1]||"",_&&_[3]||""];return n&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function w(C){const n=C?k.exec(C):[];return n&&n[1]&&n[1].charAt(0)!=="."&&n[3]||""}function y(C,n,_){let R=C.compare(n,_);return R!==0?R:n.length!==_.length?n.length<_.length?-1:1:0}function i(C){const n=C.charAt(0);return n.toLocaleUpperCase()!==n}function o(C){const n=C.charAt(0);return n.toLocaleLowerCase()!==n}function u(C,n){return i(C)&&o(n)?-1:o(C)&&i(n)?1:0}function s(C,n){return o(C)&&i(n)?-1:i(C)&&o(n)?1:0}function f(C,n,_=!1){return _||(C=C&&C.toLowerCase(),n=n&&n.toLowerCase()),C===n?0:C<n?-1:1}function m(C,n,_=!1){const R=C.split(F.sep),U=n.split(F.sep),V=R.length-1,le=U.length-1;let he,j;for(let H=0;;H++){if(he=V===H,j=le===H,he&&j)return I(R[H],U[H],_);if(he)return-1;if(j)return 1;const L=f(R[H],U[H],_);if(L!==0)return L}}e.comparePaths=m;function g(C,n,_){const R=C.toLowerCase(),U=n.toLowerCase(),V=b(C,n,_);if(V)return V;const le=R.endsWith(_),he=U.endsWith(_);if(le!==he)return le?-1:1;const j=I(R,U);return j!==0?j:R.localeCompare(U)}e.compareAnything=g;function b(C,n,_){const R=C.toLowerCase(),U=n.toLowerCase(),V=R.startsWith(_),le=U.startsWith(_);if(V!==le)return V?-1:1;if(V&&le){if(R.length<U.length)return-1;if(R.length>U.length)return 1}return 0}e.compareByPrefix=b}),define(Ee[27],_e([0,1,13,40,20,17,9]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const D="**",P="/",t="[/\\\\]",S="[^/\\\\]",r=/\//g;function d(Y){switch(Y){case 0:return"";case 1:return`${S}*?`;default:return`(?:${t}|${S}+${t}|${t}${S}+)*?`}}function a(Y,ce){if(!Y)return[];const z=[];let se=!1,re=!1,we="";for(const Re of Y){switch(Re){case ce:if(!se&&!re){z.push(we),we="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":re=!0;break;case"]":re=!1;break}we+=Re}return we&&z.push(we),z}e.splitGlobAware=a;function l(Y){if(!Y)return"";let ce="";const z=a(Y,P);if(z.every(se=>se===D))ce=".*";else{let se=!1;z.forEach((re,we)=>{if(re===D){se||(ce+=d(2),se=!0);return}let Re=!1,Fe="",Ne=!1,Qe="";for(const qe of re){if(qe!=="}"&&Re){Fe+=qe;continue}if(Ne&&(qe!=="]"||!Qe)){let Ke;qe==="-"?Ke=qe:(qe==="^"||qe==="!")&&!Qe?Ke="^":qe===P?Ke="":Ke=A.escapeRegExpCharacters(qe),Qe+=Ke;continue}switch(qe){case"{":Re=!0;continue;case"[":Ne=!0;continue;case"}":ce+=`(?:${a(Fe,",").map(q=>l(q)).join("|")})`,Re=!1,Fe="";break;case"]":ce+="["+Qe+"]",Ne=!1,Qe="";break;case"?":ce+=S;continue;case"*":ce+=d(1);continue;default:ce+=A.escapeRegExpCharacters(qe)}}we<z.length-1&&(z[we+1]!==D||we+2<z.length)&&(ce+=t),se=!1})}return ce}const p=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,k=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new E.LRUCache(1e4),o=function(){return!1},u=function(){return null};function s(Y,ce){if(!Y)return u;let z;typeof Y!="string"?z=Y.pattern:z=Y,z=z.trim();const se=`${z}_${!!ce.trimForExclusions}`;let re=i.get(se);if(re)return f(re,Y);let we;if(p.test(z)){const Re=z.substr(4);re=function(Fe,Ne){return typeof Fe=="string"&&Fe.endsWith(Re)?z:null}}else(we=v.exec(m(z,ce)))?re=g(we[1],z):(ce.trimForExclusions?c:k).test(z)?re=b(z,ce):(we=w.exec(m(z,ce)))?re=C(we[1].substr(1),z,!0):(we=y.exec(m(z,ce)))?re=C(we[1],z,!1):re=n(z);return i.set(se,re),f(re,Y)}function f(Y,ce){return typeof ce=="string"?Y:function(z,se){return F.isEqualOrParent(z,ce.base)?Y(T.relative(ce.base,z),se):null}}function m(Y,ce){return ce.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function g(Y,ce){const z=`/${Y}`,se=`\\${Y}`,re=function(Re,Fe){return typeof Re!="string"?null:Fe?Fe===Y?ce:null:Re===Y||Re.endsWith(z)||Re.endsWith(se)?ce:null},we=[Y];return re.basenames=we,re.patterns=[ce],re.allBasenames=we,re}function b(Y,ce){const z=x(Y.slice(1,-1).split(",").map(Fe=>s(Fe,ce)).filter(Fe=>Fe!==u),Y),se=z.length;if(!se)return u;if(se===1)return z[0];const re=function(Fe,Ne){for(let Qe=0,qe=z.length;Qe<qe;Qe++)if(z[Qe](Fe,Ne))return Y;return null},we=z.find(Fe=>!!Fe.allBasenames);we&&(re.allBasenames=we.allBasenames);const Re=z.reduce((Fe,Ne)=>Ne.allPaths?Fe.concat(Ne.allPaths):Fe,[]);return Re.length&&(re.allPaths=Re),re}function C(Y,ce,z){const se=T.sep===T.posix.sep,re=se?Y:Y.replace(r,T.sep),we=T.sep+re,Re=T.posix.sep+Y,Fe=z?function(Ne,Qe){return typeof Ne=="string"&&(Ne===re||Ne.endsWith(we)||!se&&(Ne===Y||Ne.endsWith(Re)))?ce:null}:function(Ne,Qe){return typeof Ne=="string"&&(Ne===re||!se&&Ne===Y)?ce:null};return Fe.allPaths=[(z?"*/":"./")+Y],Fe}function n(Y){try{const ce=new RegExp(`^${l(Y)}$`);return function(z){return ce.lastIndex=0,typeof z=="string"&&ce.test(z)?Y:null}}catch(ce){return u}}function _(Y,ce,z){return!Y||typeof ce!="string"?!1:R(Y)(ce,void 0,z)}e.match=_;function R(Y,ce={}){if(!Y)return o;if(typeof Y=="string"||he(Y)){const z=s(Y,ce);if(z===u)return o;const se=function(re,we){return!!z(re,we)};return z.allBasenames&&(se.allBasenames=z.allBasenames),z.allPaths&&(se.allPaths=z.allPaths),se}return L(Y,ce)}e.parse=R;function U(Y){if(!Y)return;let ce;return z=>(ce||(ce=(Y()||Promise.resolve([])).then(se=>se?le(se):{})),ce.then(se=>!!se[z]))}e.hasSiblingPromiseFn=U;function V(Y){if(!Y)return;let ce;return z=>{if(!ce){const se=Y();ce=se?le(se):{}}return!!ce[z]}}e.hasSiblingFn=V;function le(Y){const ce={};for(const z of Y)ce[z]=!0;return ce}function he(Y){const ce=Y;return ce&&typeof ce.base=="string"&&typeof ce.pattern=="string"}e.isRelativePattern=he;function j(Y){return Y.allBasenames||[]}e.getBasenameTerms=j;function H(Y){return Y.allPaths||[]}e.getPathTerms=H;function L(Y,ce){const z=x(Object.getOwnPropertyNames(Y).map(Fe=>K(Fe,Y[Fe],ce)).filter(Fe=>Fe!==u)),se=z.length;if(!se)return u;if(!z.some(Fe=>!!Fe.requiresSiblings)){if(se===1)return z[0];const Fe=function(qe,Ke){for(let N=0,q=z.length;N<q;N++){const X=z[N](qe,Ke);if(X)return X}return null},Ne=z.find(qe=>!!qe.allBasenames);Ne&&(Fe.allBasenames=Ne.allBasenames);const Qe=z.reduce((qe,Ke)=>Ke.allPaths?qe.concat(Ke.allPaths):qe,[]);return Qe.length&&(Fe.allPaths=Qe),Fe}const re=function(Fe,Ne,Qe){let qe;for(let Ke=0,N=z.length;Ke<N;Ke++){const q=z[Ke];q.requiresSiblings&&Qe&&(Ne||(Ne=T.basename(Fe)),qe||(qe=Ne.substr(0,Ne.length-T.extname(Fe).length)));const X=q(Fe,Ne,qe,Qe);if(X)return X}return null},we=z.find(Fe=>!!Fe.allBasenames);we&&(re.allBasenames=we.allBasenames);const Re=z.reduce((Fe,Ne)=>Ne.allPaths?Fe.concat(Ne.allPaths):Fe,[]);return Re.length&&(re.allPaths=Re),re}function K(Y,ce,z){if(ce===!1)return u;const se=s(Y,z);if(se===u)return u;if(typeof ce=="boolean")return se;if(ce){const re=ce.when;if(typeof re=="string"){const we=(Re,Fe,Ne,Qe)=>{if(!Qe||!se(Re,Fe))return null;const qe=re.replace("$(basename)",Ne),Ke=Qe(qe);return(0,h.isThenable)(Ke)?Ke.then(N=>N?Y:null):Ke?Y:null};return we.requiresSiblings=!0,we}}return se}function x(Y,ce){const z=Y.filter(Fe=>!!Fe.basenames);if(z.length<2)return Y;const se=z.reduce((Fe,Ne)=>{const Qe=Ne.basenames;return Qe?Fe.concat(Qe):Fe},[]);let re;if(ce){re=[];for(let Fe=0,Ne=se.length;Fe<Ne;Fe++)re.push(ce)}else re=z.reduce((Fe,Ne)=>{const Qe=Ne.patterns;return Qe?Fe.concat(Qe):Fe},[]);const we=function(Fe,Ne){if(typeof Fe!="string")return null;if(!Ne){let qe;for(qe=Fe.length;qe>0;qe--){const Ke=Fe.charCodeAt(qe-1);if(Ke===47||Ke===92)break}Ne=Fe.substr(qe)}const Qe=se.indexOf(Ne);return Qe!==-1?re[Qe]:null};we.basenames=se,we.patterns=re,we.allBasenames=se;const Re=Y.filter(Fe=>!Fe.basenames);return Re.push(we),Re}}),define(Ee[76],_e([0,1,40,11,17,26,24,9,2]),function(te,e,h,F,E,T,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(s,f,m){if(typeof s=="string"&&(s=D.URI.file(s)),m){const b=m.getWorkspaceFolder(s);if(b){const C=m.getWorkspace().folders.length>1;let n;if((0,A.isEqual)(b.uri,s)?n="":n=(0,A.relativePath)(b.uri,s),C){const _=b.name?b.name:(0,A.basename)(b.uri);n=n?_+" \u2022 "+n:_}return n}}if(s.scheme!==F.Schemas.file&&s.scheme!==F.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(s.fsPath))return(0,E.normalize)(S(s.fsPath));let g=(0,E.normalize)(s.fsPath);return!T.isWindows&&f?.userHome&&(g=d(g,f.userHome.fsPath)),g}e.getPathLabel=P;function t(s){if(!s)return;typeof s=="string"&&(s=D.URI.file(s));const f=(0,A.basename)(s)||(s.scheme===F.Schemas.file?s.fsPath:s.path);return T.isWindows&&(0,h.isRootOrDriveLetter)(f)?S(f):f}e.getBaseLabel=t;function S(s){return(0,h.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=S;let r=Object.create(null);function d(s,f){if(T.isWindows||!s||!f)return s;let m=r.original===f?r.normalized:void 0;return m||(m=`${(0,I.rtrim)(f,E.posix.sep)}${E.posix.sep}`,r={original:f,normalized:m}),(T.isLinux?s.startsWith(m):(0,I.startsWithIgnoreCase)(s,m))&&(s=`~/${s.substr(m.length)}`),s}e.tildify=d;function a(s,f){return s.replace(/^~($|\/|\\)/,`${f}$1`)}e.untildify=a;const l="\u2026",p="\\\\",v="~";function k(s,f=E.sep){const m=new Array(s.length);let g=!1;for(let b=0;b<s.length;b++){let C=s[b];if(C===""){m[b]=`.${f}`;continue}if(!C){m[b]=C;continue}g=!0;let n="";C.indexOf(p)===0?(n=C.substr(0,C.indexOf(p)+p.length),C=C.substr(C.indexOf(p)+p.length)):C.indexOf(f)===0?(n=C.substr(0,C.indexOf(f)+f.length),C=C.substr(C.indexOf(f)+f.length)):C.indexOf(v)===0&&(n=C.substr(0,C.indexOf(v)+v.length),C=C.substr(C.indexOf(v)+v.length));const _=C.split(f);for(let R=1;g&&R<=_.length;R++)for(let U=_.length-R;g&&U>=0;U--){g=!1;let V=_.slice(U,U+R).join(f);for(let le=0;!g&&le<s.length;le++)if(le!==b&&s[le]&&s[le].indexOf(V)>-1){const he=U+R===_.length,j=U>0&&s[le].indexOf(f)>-1?f+V:V,H=s[le].endsWith(j);g=!he||H}if(!g){let le="";(_[0].endsWith(":")||n!=="")&&(U===1&&(U=0,R++,V=_[0]+f+V),U>0&&(le=_[0]+f),le=n+le),U>0&&(le=le+l+f),le=le+V,U+R<_.length&&(le=le+f+l),m[b]=le}}g&&(m[b]=C)}return m}e.shorten=k;var c;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function w(s,f=Object.create(null)){const m=[];let g=!1,b="";for(const C of s)if(C==="$"||g&&C==="{")b&&m.push({value:b,type:c.TEXT}),b="",g=!0;else if(C==="}"&&g){const n=f[b];if(typeof n=="string")n.length&&m.push({value:n,type:c.VARIABLE});else if(n){const _=m[m.length-1];(!_||_.type!==c.SEPARATOR)&&m.push({value:n.label,type:c.SEPARATOR})}b="",g=!1}else b+=C;return b&&!g&&m.push({value:b,type:c.TEXT}),m.filter((C,n)=>{if(C.type===c.SEPARATOR){const _=m[n-1],R=m[n+1];return[_,R].every(U=>U&&(U.type===c.VARIABLE||U.type===c.TEXT)&&U.value.length>0)}return!0}).map(C=>C.value).join("")}e.template=w;function y(s,f){return T.isMacintosh||f?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):s.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function i(s,f){return T.isMacintosh||f?s.replace(/\(&&\w\)|&&/g,""):T.isWindows?s.replace(/&&|&/g,m=>m==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function o(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=o;function u(s){const f=s.indexOf("/")!==-1?E.posix:E.win32,m=f.basename(s),g=f.dirname(s);return m.length?{name:m,parentPath:g}:{name:g,parentPath:""}}e.splitName=u}),define(Ee[77],_e([0,1,27,11,17,24,9]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var I;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(I=e.Mimes||(e.Mimes={}));let D=[],P=[],t=[];function S(s,f=!1){const m=r(s);D.push(m),m.userConfigured?t.push(m):P.push(m),f&&!m.userConfigured&&D.forEach(g=>{g.mime===m.mime||g.userConfigured||(m.extension&&g.extension===m.extension&&console.warn(`Overwriting extension <<${m.extension}>> to now point to mime <<${m.mime}>>`),m.filename&&g.filename===m.filename&&console.warn(`Overwriting filename <<${m.filename}>> to now point to mime <<${m.mime}>>`),m.filepattern&&g.filepattern===m.filepattern&&console.warn(`Overwriting filepattern <<${m.filepattern}>> to now point to mime <<${m.mime}>>`),m.firstline&&g.firstline===m.firstline&&console.warn(`Overwriting firstline <<${m.firstline}>> to now point to mime <<${m.mime}>>`))})}e.registerTextMime=S;function r(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?s.filepattern.toLowerCase():void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(E.posix.sep)>=0:!1}}function d(s){s?(D=D.filter(f=>!f.userConfigured),t=[]):(D=[],P=[],t=[])}e.clearTextMimes=d;function a(s,f){let m;if(s)switch(s.scheme){case F.Schemas.file:m=s.fsPath;break;case F.Schemas.data:m=T.DataUri.parseMetaData(s).get(T.DataUri.META_DATA_LABEL);break;default:m=s.path}if(!m)return[I.unknown];m=m.toLowerCase();const g=(0,E.basename)(m),b=l(m,g,t);if(b)return[b,I.text];const C=l(m,g,P);if(C)return[C,I.text];if(f){const n=p(f);if(n)return[n,I.text]}return[I.unknown]}e.guessMimeTypes=a;function l(s,f,m){let g=null,b=null,C=null;for(let n=m.length-1;n>=0;n--){const _=m[n];if(f===_.filenameLowercase){g=_;break}if(_.filepattern&&(!b||_.filepattern.length>b.filepattern.length)){const R=_.filepatternOnPath?s:f;(0,h.match)(_.filepatternLowercase,R)&&(b=_)}_.extension&&(!C||_.extension.length>C.extension.length)&&f.endsWith(_.extensionLowercase)&&(C=_)}return g?g.mime:b?b.mime:C?C.mime:null}function p(s){if((0,A.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let f=D.length-1;f>=0;f--){const m=D[f];if(!m.firstline)continue;const g=s.match(m.firstline);if(g&&g.length>0)return m.mime}return null}function v(s){return s?typeof s=="string"?s===I.binary||s===I.text||s===I.unknown:s.length===1&&v(s[0]):!0}e.isUnspecific=v;const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},c={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function w(s){const f=(0,E.extname)(s),m=k[f.toLowerCase()];return m!==void 0?m:y(s)}e.getMediaOrTextMime=w;function y(s){const f=(0,E.extname)(s);return c[f.toLowerCase()]}e.getMediaMime=y;function i(s){for(const f in c)if(c[f]===s)return f}e.getExtensionForMimeType=i;const o=/^(.+)\/(.+?)(;.+)?$/;function u(s,f){const m=o.exec(s);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:f?void 0:s}e.normalizeMimeType=u}),define(Ee[108],_e([0,1,2]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(t){return t.toJSON()}class E{constructor(S){this._uriTransformer=S}transformIncoming(S){const r=this._uriTransformer.transformIncoming(S);return r===S?S:F(h.URI.from(r))}transformOutgoing(S){const r=this._uriTransformer.transformOutgoing(S);return r===S?S:F(h.URI.from(r))}transformOutgoingURI(S){const r=this._uriTransformer.transformOutgoing(S);return r===S?S:h.URI.from(r)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function T(t,S,r){if(!t||r>200)return null;if(typeof t=="object"){if(t instanceof h.URI)return S.transformOutgoing(t);for(let d in t)if(Object.hasOwnProperty.call(t,d)){const a=T(t[d],S,r+1);a!==null&&(t[d]=a)}}return null}function A(t,S){const r=T(t,S,0);return r===null?t:r}e.transformOutgoingURIs=A;function I(t,S,r,d){if(!t||d>200)return null;if(typeof t=="object"){if(t.$mid===1)return r?h.URI.revive(S.transformIncoming(t)):S.transformIncoming(t);for(let a in t)if(Object.hasOwnProperty.call(t,a)){const l=I(t[a],S,r,d+1);l!==null&&(t[a]=l)}}return null}function D(t,S){const r=I(t,S,!1,0);return r===null?t:r}e.transformIncomingURIs=D;function P(t,S){const r=I(t,S,!0,0);return r===null?t:r}e.transformAndReviveIncomingURIs=P}),define(Ee[36],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(D){return h.test(D)}e.isUUID=F;const E=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function I(){A(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let D=0,P="";return P+=T[E[D++]],P+=T[E[D++]],P+=T[E[D++]],P+=T[E[D++]],P+="-",P+=T[E[D++]],P+=T[E[D++]],P+="-",P+=T[E[D++]],P+=T[E[D++]],P+="-",P+=T[E[D++]],P+=T[E[D++]],P+="-",P+=T[E[D++]],P+=T[E[D++]],P+=T[E[D++]],P+=T[E[D++]],P+=T[E[D++]],P+=T[E[D++]],P}e.generateUuid=I}),define(Ee[109],_e([0,1,226]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends h.CharacterClassifier{constructor(I){super(0);for(let D=0,P=I.length;D<P;D++)this.set(I.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function T(A){let I={};return D=>(I.hasOwnProperty(D)||(I[D]=A(D)),I[D])}e.getMapForWordSeparators=T(A=>new E(A))}),define(Ee[78],_e([0,1,22]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var F;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(F=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var I;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(I=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(p){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,p.tabSize|0),this.indentSize=p.tabSize|0,this.insertSpaces=Boolean(p.insertSpaces),this.defaultEOL=p.defaultEOL|0,this.trimAutoWhitespace=Boolean(p.trimAutoWhitespace),this.bracketPairColorizationOptions=p.bracketPairColorizationOptions}equals(p){return this.tabSize===p.tabSize&&this.indentSize===p.indentSize&&this.insertSpaces===p.insertSpaces&&this.defaultEOL===p.defaultEOL&&this.trimAutoWhitespace===p.trimAutoWhitespace&&(0,h.equals)(this.bracketPairColorizationOptions,p.bracketPairColorizationOptions)}createChangeEvent(p){return{tabSize:this.tabSize!==p.tabSize,indentSize:this.indentSize!==p.indentSize,insertSpaces:this.insertSpaces!==p.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==p.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class P{constructor(p,v){this._findMatchBrand=void 0,this.range=p,this.matches=v}}e.FindMatch=P;var t;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var S;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None"})(S=e.PositionAffinity||(e.PositionAffinity={}));var r;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(r=e.ModelConstants||(e.ModelConstants={}));class d{constructor(p,v,k,c,w,y){this.identifier=p,this.range=v,this.text=k,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=w,this._isTracked=y}}e.ValidAnnotatedEditOperation=d;class a{constructor(p,v,k){this.reverseEdits=p,this.changes=v,this.trimAutoWhitespaceLineNumbers=k}}e.ApplyEditsResult=a}),define(Ee[110],_e([0,1,9,109,111,41,78]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class D{constructor(c,w,y,i){this.searchString=c,this.isRegex=w,this.matchCase=y,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=P(this.searchString):c=this.searchString.indexOf(`
`)>=0;let w=null;try{w=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(i){return null}if(!w)return null;let y=!this.isRegex&&!c;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new t(w,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=D;function P(k){if(!k||k.length===0)return!1;for(let c=0,w=k.length;c<w;c++)if(k.charCodeAt(c)===92){if(c++,c>=w)break;const i=k.charCodeAt(c);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=P;class t{constructor(c,w,y){this.regex=c,this.wordSeparators=w,this.simpleSearch=y}}e.SearchData=t;function S(k,c,w){if(!w)return new A.FindMatch(k,null);let y=[];for(let i=0,o=c.length;i<o;i++)y[i]=c[i];return new A.FindMatch(k,y)}e.createFindMatch=S;class r{constructor(c){let w=[],y=0;for(let i=0,o=c.length;i<o;i++)c.charCodeAt(i)===10&&(w[y++]=i);this._lineFeedsOffsets=w}findLineFeedCountBeforeOffset(c){const w=this._lineFeedsOffsets;let y=0,i=w.length-1;if(i===-1||c<=w[0])return 0;for(;y<i;){const o=y+((i-y)/2>>0);w[o]>=c?i=o-1:w[o+1]>=c?(y=o,i=o):y=o+1}return y+1}}class d{static findMatches(c,w,y,i,o){const u=w.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(c,y,new v(u.wordSeparators,u.regex),i,o):this._doFindMatchesLineByLine(c,y,u,i,o):[]}static _getMultilineMatchRange(c,w,y,i,o,u){let s,f=0;i?(f=i.findLineFeedCountBeforeOffset(o),s=w+o+f):s=w+o;let m;if(i){let n=i.findLineFeedCountBeforeOffset(o+u.length)-f;m=s+u.length+n}else m=s+u.length;const g=c.getPositionAt(s),b=c.getPositionAt(m);return new T.Range(g.lineNumber,g.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(c,w,y,i,o){const u=c.getOffsetAt(w.getStartPosition()),s=c.getValueInRange(w,1),f=c.getEOL()===`\r
`?new r(s):null,m=[];let g=0,b;for(y.reset(0);b=y.next(s);)if(m[g++]=S(this._getMultilineMatchRange(c,u,s,f,b.index,b[0]),b,i),g>=o)return m;return m}static _doFindMatchesLineByLine(c,w,y,i,o){const u=[];let s=0;if(w.startLineNumber===w.endLineNumber){const m=c.getLineContent(w.startLineNumber).substring(w.startColumn-1,w.endColumn-1);return s=this._findMatchesInLine(y,m,w.startLineNumber,w.startColumn-1,s,u,i,o),u}const f=c.getLineContent(w.startLineNumber).substring(w.startColumn-1);s=this._findMatchesInLine(y,f,w.startLineNumber,w.startColumn-1,s,u,i,o);for(let m=w.startLineNumber+1;m<w.endLineNumber&&s<o;m++)s=this._findMatchesInLine(y,c.getLineContent(m),m,0,s,u,i,o);if(s<o){const m=c.getLineContent(w.endLineNumber).substring(0,w.endColumn-1);s=this._findMatchesInLine(y,m,w.endLineNumber,0,s,u,i,o)}return u}static _findMatchesInLine(c,w,y,i,o,u,s,f){const m=c.wordSeparators;if(!s&&c.simpleSearch){const C=c.simpleSearch,n=C.length,_=w.length;let R=-n;for(;(R=w.indexOf(C,R+n))!==-1;)if((!m||p(m,w,_,R,n))&&(u[o++]=new A.FindMatch(new T.Range(y,R+1+i,y,R+1+n+i),null),o>=f))return o;return o}const g=new v(c.wordSeparators,c.regex);let b;g.reset(0);do if(b=g.next(w),b&&(u[o++]=S(new T.Range(y,b.index+1+i,y,b.index+1+b[0].length+i),b,s),o>=f))return o;while(b);return o}static findNextMatch(c,w,y,i){const o=w.parseSearchRequest();if(!o)return null;const u=new v(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindNextMatchMultiline(c,y,u,i):this._doFindNextMatchLineByLine(c,y,u,i)}static _doFindNextMatchMultiline(c,w,y,i){const o=new E.Position(w.lineNumber,1),u=c.getOffsetAt(o),s=c.getLineCount(),f=c.getValueInRange(new T.Range(o.lineNumber,o.column,s,c.getLineMaxColumn(s)),1),m=c.getEOL()===`\r
`?new r(f):null;y.reset(w.column-1);let g=y.next(f);return g?S(this._getMultilineMatchRange(c,u,f,m,g.index,g[0]),g,i):w.lineNumber!==1||w.column!==1?this._doFindNextMatchMultiline(c,new E.Position(1,1),y,i):null}static _doFindNextMatchLineByLine(c,w,y,i){const o=c.getLineCount(),u=w.lineNumber,s=c.getLineContent(u),f=this._findFirstMatchInLine(y,s,u,w.column,i);if(f)return f;for(let m=1;m<=o;m++){const g=(u+m-1)%o,b=c.getLineContent(g+1),C=this._findFirstMatchInLine(y,b,g+1,1,i);if(C)return C}return null}static _findFirstMatchInLine(c,w,y,i,o){c.reset(i-1);const u=c.next(w);return u?S(new T.Range(y,u.index+1,y,u.index+1+u[0].length),u,o):null}static findPreviousMatch(c,w,y,i){const o=w.parseSearchRequest();if(!o)return null;const u=new v(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindPreviousMatchMultiline(c,y,u,i):this._doFindPreviousMatchLineByLine(c,y,u,i)}static _doFindPreviousMatchMultiline(c,w,y,i){const o=this._doFindMatchesMultiline(c,new T.Range(1,1,w.lineNumber,w.column),y,i,10*I);if(o.length>0)return o[o.length-1];const u=c.getLineCount();return w.lineNumber!==u||w.column!==c.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(c,new E.Position(u,c.getLineMaxColumn(u)),y,i):null}static _doFindPreviousMatchLineByLine(c,w,y,i){const o=c.getLineCount(),u=w.lineNumber,s=c.getLineContent(u).substring(0,w.column-1),f=this._findLastMatchInLine(y,s,u,i);if(f)return f;for(let m=1;m<=o;m++){const g=(o+u-m-1)%o,b=c.getLineContent(g+1),C=this._findLastMatchInLine(y,b,g+1,i);if(C)return C}return null}static _findLastMatchInLine(c,w,y,i){let o=null,u;for(c.reset(0);u=c.next(w);)o=S(new T.Range(y,u.index+1,y,u.index+1+u[0].length),u,i);return o}}e.TextModelSearch=d;function a(k,c,w,y,i){if(y===0)return!0;const o=c.charCodeAt(y-1);if(k.get(o)!==0||o===13||o===10)return!0;if(i>0){const u=c.charCodeAt(y);if(k.get(u)!==0)return!0}return!1}function l(k,c,w,y,i){if(y+i===w)return!0;const o=c.charCodeAt(y+i);if(k.get(o)!==0||o===13||o===10)return!0;if(i>0){const u=c.charCodeAt(y+i-1);if(k.get(u)!==0)return!0}return!1}function p(k,c,w,y,i){return a(k,c,w,y,i)&&l(k,c,w,y,i)}e.isValidMatch=p;class v{constructor(c,w){this._wordSeparators=c,this._searchRegex=w,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const w=c.length;let y;do{if(this._prevMatchStartIndex+this._prevMatchLength===w||(y=this._searchRegex.exec(c),!y))return null;const i=y.index,o=y[0].length;if(i===this._prevMatchStartIndex&&o===this._prevMatchLength){if(o===0){h.getNextCodePoint(c,w,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=o,!this._wordSeparators||p(this._wordSeparators,c,w,i,o))return y}while(y);return null}}e.Searcher=v}),define(Ee[112],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var h;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(h=e.IndentAction||(e.IndentAction={}));class F{constructor(I){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let D=0,P=I.notIn.length;D<P;D++)switch(I.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=F;class E{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of I)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=E;function T(A,I,D){A.has(I)?A.get(I).push(D):A.set(I,[D])}}),define(Ee[53],_e([0,1,27,17]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(T,A,I,D){if(Array.isArray(T)){let P=0;for(const t of T){const S=E(t,A,I,D);if(S===10)return S;S>P&&(P=S)}return P}else{if(typeof T=="string")return D?T==="*"?5:T===I?10:0:0;if(T){const{language:P,pattern:t,scheme:S,hasAccessToAllModels:r}=T;if(!D&&!r)return 0;let d=0;if(S)if(S===A.scheme)d=10;else if(S==="*")d=5;else return 0;if(P)if(P===I)d=10;else if(P==="*")d=Math.max(d,5);else return 0;if(t){let a;if(typeof t=="string"?a=t:a={...t,base:(0,F.normalize)(t.base)},a===A.fsPath||(0,h.match)(a,A.fsPath))d=10;else return 0}return d}else return 0}}e.score=E}),define(Ee[113],_e([0,1,3,7]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,I){return this._map.set(A,I),this.fire([A]),(0,F.toDisposable)(()=>{this._map.get(A)===I&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,I){let D=null,P=!1;return this._promises.set(A,I.then(t=>{this._promises.delete(A),!(P||!t)&&(D=this.register(A,t))})),(0,F.toDisposable)(()=>{P=!0,D&&D.dispose()})}getPromise(A){const I=this.get(A);if(I)return Promise.resolve(I);const D=this._promises.get(A);return D?D.then(P=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(Ee[79],_e([0,1,23,26]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(E||(E={}));function T(S){for(let r=0,d=S.length;r<d;r+=4){const a=S[r+0],l=S[r+1],p=S[r+2],v=S[r+3];S[r+0]=v,S[r+1]=p,S[r+2]=l,S[r+3]=a}}function A(S){const r=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return F.isLittleEndian()||T(r),h.VSBuffer.wrap(r)}function I(S){const r=S.buffer;if(F.isLittleEndian()||T(r),r.byteOffset%4==0)return new Uint32Array(r.buffer,r.byteOffset,r.length/4);{const d=new Uint8Array(r.byteLength);return d.set(r),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function D(S){const r=new Uint32Array(P(S));let d=0;if(r[d++]=S.id,S.type==="full")r[d++]=1,r[d++]=S.data.length,r.set(S.data,d),d+=S.data.length;else{r[d++]=2,r[d++]=S.deltas.length;for(const a of S.deltas)r[d++]=a.start,r[d++]=a.deleteCount,a.data?(r[d++]=a.data.length,r.set(a.data,d),d+=a.data.length):r[d++]=0}return A(r)}e.encodeSemanticTokensDto=D;function P(S){let r=0;if(r+=1+1,S.type==="full")r+=1+S.data.length;else{r+=1,r+=(1+1+1)*S.deltas.length;for(const d of S.deltas)d.data&&(r+=d.data.length)}return r}function t(S){const r=I(S);let d=0;const a=r[d++];if(r[d++]===1){const k=r[d++],c=r.subarray(d,d+k);return d+=k,{id:a,type:"full",data:c}}const p=r[d++];let v=[];for(let k=0;k<p;k++){const c=r[d++],w=r[d++],y=r[d++];let i;y>0&&(i=r.subarray(d,d+y),d+=y),v[k]={start:c,deleteCount:w,data:i}}return{id:a,type:"delta",deltas:v}}e.decodeSemanticTokensDto=t}),define(Ee[114],_e([18,19]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ee[54],_e([0,1,16,10,114]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(P,t){return t&&(P.stack||P.stacktrace)?E.localize(0,null,I(P),A(P.stack)||A(P.stacktrace)):I(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function I(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?E.localize(1,null,P.message):P.message||E.localize(2,null)}function D(P=null,t=!1){if(!P)return E.localize(3,null);if(Array.isArray(P)){const S=h.coalesce(P),r=D(S[0],t);return S.length>1?E.localize(4,null,r,S.length):r}if(F.isString(P))return P;if(P.detail){const S=P.detail;if(S.error)return T(S.error,t);if(S.exception)return T(S.exception,t)}return P.stack?T(P,t):P.message?P.message:E.localize(5,null)}e.toErrorMessage=D}),define(Ee[115],_e([18,19]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ee[116],_e([0,1,115,26,117]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function($){$[$.None=0]="None",$[$.Keep=1]="Keep",$[$.Brackets=2]="Brackets",$[$.Advanced=3]="Advanced",$[$.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(G){this._values=G}hasChanged(G){return this._values[G]}}e.ConfigurationChangedEvent=A;class I{constructor(){this._values=[]}_read(G){return this._values[G]}get(G){return this._values[G]}_write(G,fe){this._values[G]=fe}}e.ValidatedEditorOptions=I;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class P{constructor(G,fe,Le,Ve){this.id=G,this.name=fe,this.defaultValue=Le,this.schema=Ve}compute(G,fe,Le){return Le}}class t{constructor(G,fe=null){this.schema=void 0,this.id=G,this.name="_never_",this.defaultValue=void 0,this.deps=fe}validate(G){return this.defaultValue}}class S{constructor(G,fe,Le,Ve){this.id=G,this.name=fe,this.defaultValue=Le,this.schema=Ve}validate(G){return typeof G=="undefined"?this.defaultValue:G}compute(G,fe,Le){return Le}}function r($,G){return typeof $=="undefined"?G:$==="false"?!1:Boolean($)}e.boolean=r;class d extends S{constructor(G,fe,Le,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Le),super(G,fe,Le,Ve)}validate(G){return r(G,this.defaultValue)}}class a extends S{constructor(G,fe,Le,Ve,et,rt=void 0){typeof rt!="undefined"&&(rt.type="integer",rt.default=Le,rt.minimum=Ve,rt.maximum=et),super(G,fe,Le,rt),this.minimum=Ve,this.maximum=et}static clampedInt(G,fe,Le,Ve){if(typeof G=="undefined")return fe;let et=parseInt(G,10);return isNaN(et)?fe:(et=Math.max(Le,et),et=Math.min(Ve,et),et|0)}validate(G){return a.clampedInt(G,this.defaultValue,this.minimum,this.maximum)}}class l extends S{constructor(G,fe,Le,Ve,et){typeof et!="undefined"&&(et.type="number",et.default=Le),super(G,fe,Le,et),this.validationFn=Ve}static clamp(G,fe,Le){return G<fe?fe:G>Le?Le:G}static float(G,fe){if(typeof G=="number")return G;if(typeof G=="undefined")return fe;const Le=parseFloat(G);return isNaN(Le)?fe:Le}validate(G){return this.validationFn(l.float(G,this.defaultValue))}}class p extends S{static string(G,fe){return typeof G!="string"?fe:G}constructor(G,fe,Le,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Le),super(G,fe,Le,Ve)}validate(G){return p.string(G,this.defaultValue)}}function v($,G,fe){return typeof $!="string"||fe.indexOf($)===-1?G:$}e.stringSet=v;class k extends S{constructor(G,fe,Le,Ve,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=Ve,et.default=Le),super(G,fe,Le,et),this._allowedValues=Ve}validate(G){return v(G,this.defaultValue,this._allowedValues)}}class c extends P{constructor(G,fe,Le,Ve,et,rt,pt=void 0){typeof pt!="undefined"&&(pt.type="string",pt.enum=et,pt.default=Ve),super(G,fe,Le,pt),this._allowedValues=et,this._convert=rt}validate(G){return typeof G!="string"?this.defaultValue:this._allowedValues.indexOf(G)===-1?this.defaultValue:this._convert(G)}}function w($){switch($){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class y extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",description:h.localize(3,null)})}validate(G){switch(G){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(G,fe,Le){return Le===0?G.accessibilitySupport:Le}}class i extends P{constructor(){const G={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",G,{"editor.comments.insertSpace":{type:"boolean",default:G.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:G.ignoreEmptyLines,description:h.localize(5,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const fe=G;return{insertSpace:r(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function($){$[$.Hidden=0]="Hidden",$[$.Blink=1]="Blink",$[$.Smooth=2]="Smooth",$[$.Phase=3]="Phase",$[$.Expand=4]="Expand",$[$.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u($){switch($){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function($){$[$.Line=1]="Line",$[$.Block=2]="Block",$[$.Underline=3]="Underline",$[$.LineThin=4]="LineThin",$[$.BlockOutline=5]="BlockOutline",$[$.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function f($){switch($){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function m($){switch($){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class g extends t{constructor(){super(127,[65,32])}compute(G,fe,Le){const Ve=["monaco-editor"];return fe.get(32)&&Ve.push(fe.get(32)),G.extraEditorClassName&&Ve.push(G.extraEditorClassName),fe.get(65)==="default"?Ve.push("mouse-default"):fe.get(65)==="copy"&&Ve.push("mouse-copy"),fe.get(100)&&Ve.push("showUnused"),fe.get(125)&&Ve.push("showDeprecated"),Ve.join(" ")}}class b extends d{constructor(){super(31,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(G,fe,Le){return Le&&G.emptySelectionClipboard}}class C extends P{constructor(){const G={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",G,{"editor.find.cursorMoveOnType":{type:"boolean",default:G.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:G.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:G.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:G.globalFindClipboard,description:h.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:G.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:G.loop,description:h.localize(18,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const fe=G;return{cursorMoveOnType:r(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof G.seedSearchStringFromSelection=="boolean"?G.seedSearchStringFromSelection?"always":"never":v(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof G.autoFindInSelection=="boolean"?G.autoFindInSelection?"always":"never":v(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(fe.loop,this.defaultValue.loop)}}}class n extends P{constructor(){super(43,"fontLigatures",n.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(G){return typeof G=="undefined"?this.defaultValue:typeof G=="string"?G==="false"?n.OFF:G==="true"?n.ON:G:Boolean(G)?n.ON:n.OFF}}e.EditorFontLigatures=n,n.OFF='"liga" off, "calt" off',n.ON='"liga" on, "calt" on';class _ extends t{constructor(){super(42)}compute(G,fe,Le){return G.fontInfo}}class R extends S{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(22,null)})}validate(G){let fe=l.float(G,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(fe,6,100)}compute(G,fe,Le){return G.fontInfo.fontSize}}class U extends P{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:h.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(24,null)})}validate(G){return G==="normal"||G==="bold"?G:String(a.clampedInt(G,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class V extends P{constructor(){const G={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:G.multiple,enumDescriptions:[h.localize(25,null),h.localize(26,null),h.localize(27,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",G,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:h.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:h.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:h.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:G.alternativeDefinitionCommand,enum:Le,description:h.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:G.alternativeTypeDefinitionCommand,enum:Le,description:h.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:G.alternativeDeclarationCommand,enum:Le,description:h.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:G.alternativeImplementationCommand,enum:Le,description:h.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:G.alternativeReferenceCommand,enum:Le,description:h.localize(38,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const fe=G;return{multiple:v(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??v(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??v(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??v(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??v(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??v(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends P{constructor(){const G={enabled:!0,delay:300,sticky:!0};super(52,"hover",G,{"editor.hover.enabled":{type:"boolean",default:G.enabled,description:h.localize(39,null)},"editor.hover.delay":{type:"number",default:G.delay,description:h.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:G.sticky,description:h.localize(41,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const fe=G;return{enabled:r(fe.enabled,this.defaultValue.enabled),delay:a.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:r(fe.sticky,this.defaultValue.sticky)}}}var he;(function($){$[$.None=0]="None",$[$.Text=1]="Text",$[$.Blocks=2]="Blocks"})(he=e.RenderMinimap||(e.RenderMinimap={}));class j extends t{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(G,fe,Le){return j.computeLayout(fe,{memory:G.memory,outerWidth:G.outerWidth,outerHeight:G.outerHeight,isDominatedByLongLines:G.isDominatedByLongLines,lineHeight:G.fontInfo.lineHeight,viewLineCount:G.viewLineCount,lineNumbersDigitCount:G.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:G.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:G.fontInfo.maxDigitWidth,pixelRatio:G.pixelRatio})}static computeContainedMinimapLineCount(G){const fe=G.height/G.lineHeight,Le=G.scrollBeyondLastLine?fe-1:0,Ve=(G.viewLineCount+Le)/(G.pixelRatio*G.height),et=Math.floor(G.viewLineCount/Ve);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Le,desiredRatio:Ve,minimapLineCount:et}}static _computeMinimapLayout(G,fe){const Le=G.outerWidth,Ve=G.outerHeight,et=G.pixelRatio;if(!G.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const rt=fe.stableMinimapLayoutInput,pt=rt&&G.outerHeight===rt.outerHeight&&G.lineHeight===rt.lineHeight&&G.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&G.pixelRatio===rt.pixelRatio&&G.scrollBeyondLastLine===rt.scrollBeyondLastLine&&G.minimap.enabled===rt.minimap.enabled&&G.minimap.side===rt.minimap.side&&G.minimap.size===rt.minimap.size&&G.minimap.showSlider===rt.minimap.showSlider&&G.minimap.renderCharacters===rt.minimap.renderCharacters&&G.minimap.maxColumn===rt.minimap.maxColumn&&G.minimap.scale===rt.minimap.scale&&G.verticalScrollbarWidth===rt.verticalScrollbarWidth&&G.isViewportWrapping===rt.isViewportWrapping,St=G.lineHeight,Ct=G.typicalHalfwidthCharacterWidth,ct=G.scrollBeyondLastLine,_t=G.minimap.renderCharacters;let ht=et>=2?Math.round(G.minimap.scale*2):G.minimap.scale;const wt=G.minimap.maxColumn,Ye=G.minimap.size,Pt=G.minimap.side,Pe=G.verticalScrollbarWidth,Se=G.viewLineCount,Ce=G.remainingWidth,J=G.isViewportWrapping,oe=_t?2:3;let pe=Math.floor(et*Ve);const ge=pe/et;let Ie=!1,Be=!1,Me=oe*ht,je=ht/et,de=1;if(Ye==="fill"||Ye==="fit"){const{typicalViewportLineCount:xe,extraLinesBeyondLastLine:lt,desiredRatio:at,minimapLineCount:bt}=j.computeContainedMinimapLineCount({viewLineCount:Se,scrollBeyondLastLine:ct,height:Ve,lineHeight:St,pixelRatio:et});if(Se/bt>1)Ie=!0,Be=!0,ht=1,Me=1,je=ht/et;else{let nt=!1,st=ht+1;if(Ye==="fit"){const ft=Math.ceil((Se+lt)*Me);J&&pt&&Ce<=fe.stableFitRemainingWidth?(nt=!0,st=fe.stableFitMaxMinimapScale):nt=ft>pe}if(Ye==="fill"||nt){Ie=!0;const ft=ht;Me=Math.min(St*et,Math.max(1,Math.floor(1/at))),J&&pt&&Ce<=fe.stableFitRemainingWidth&&(st=fe.stableFitMaxMinimapScale),ht=Math.min(st,Math.max(1,Math.floor(Me/oe))),ht>ft&&(de=Math.min(2,ht/ft)),je=ht/et/de,pe=Math.ceil(Math.max(xe,Se+lt)*Me),J?(fe.stableMinimapLayoutInput=G,fe.stableFitRemainingWidth=Ce,fe.stableFitMaxMinimapScale=ht):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const ae=Math.floor(wt*je),ne=Math.min(ae,Math.max(0,Math.floor((Ce-Pe-2)*je/(Ct+je)))+e.MINIMAP_GUTTER_WIDTH);let B=Math.floor(et*ne);const ve=B/et;B=Math.floor(B*de);const ke=_t?1:2,$e=Pt==="left"?0:Le-ne-Pe;return{renderMinimap:ke,minimapLeft:$e,minimapWidth:ne,minimapHeightIsEditorHeight:Ie,minimapIsSampling:Be,minimapScale:ht,minimapLineHeight:Me,minimapCanvasInnerWidth:B,minimapCanvasInnerHeight:pe,minimapCanvasOuterWidth:ve,minimapCanvasOuterHeight:ge}}static computeLayout(G,fe){const Le=fe.outerWidth|0,Ve=fe.outerHeight|0,et=fe.lineHeight|0,rt=fe.lineNumbersDigitCount|0,pt=fe.typicalHalfwidthCharacterWidth,St=fe.maxDigitWidth,Ct=fe.pixelRatio,ct=fe.viewLineCount,_t=G.get(122),ht=_t==="inherit"?G.get(121):_t,wt=ht==="inherit"?G.get(117):ht,Ye=G.get(120),Pt=G.get(2),Pe=fe.isDominatedByLongLines,Se=G.get(48),Ce=G.get(59).renderType!==0,J=G.get(60),oe=G.get(94),pe=G.get(64),ge=G.get(92),Ie=ge.verticalScrollbarSize,Be=ge.verticalHasArrows,Me=ge.arrowSize,je=ge.horizontalScrollbarSize,de=G.get(57),ae=G.get(36);let ne;if(typeof de=="string"&&/^\d+(\.\d+)?ch$/.test(de)){const Wt=parseFloat(de.substr(0,de.length-2));ne=a.clampedInt(Wt*pt,0,0,1e3)}else ne=a.clampedInt(de,0,0,1e3);ae&&(ne+=16);let B=0;if(Ce){const Wt=Math.max(rt,J);B=Math.round(Wt*St)}let ve=0;Se&&(ve=et);let ke=0,$e=ke+ve,xe=$e+B,lt=xe+ne;const at=Le-ve-B-ne;let bt=!1,dt=!1,nt=-1;Pt!==2&&(ht==="inherit"&&Pe?(bt=!0,dt=!0):wt==="on"||wt==="bounded"?dt=!0:wt==="wordWrapColumn"&&(nt=Ye));const st=j._computeMinimapLayout({outerWidth:Le,outerHeight:Ve,lineHeight:et,typicalHalfwidthCharacterWidth:pt,pixelRatio:Ct,scrollBeyondLastLine:oe,minimap:pe,verticalScrollbarWidth:Ie,viewLineCount:ct,remainingWidth:at,isViewportWrapping:dt},fe.memory||new D);st.renderMinimap!==0&&st.minimapLeft===0&&(ke+=st.minimapWidth,$e+=st.minimapWidth,xe+=st.minimapWidth,lt+=st.minimapWidth);const ft=at-st.minimapWidth,kt=Math.max(1,Math.floor((ft-Ie-2)/pt)),Tt=Be?Me:0;return dt&&(nt=Math.max(1,kt),wt==="bounded"&&(nt=Math.min(nt,Ye))),{width:Le,height:Ve,glyphMarginLeft:ke,glyphMarginWidth:ve,lineNumbersLeft:$e,lineNumbersWidth:B,decorationsLeft:xe,decorationsWidth:ne,contentLeft:lt,contentWidth:ft,minimap:st,viewportColumn:kt,isWordWrapMinified:bt,isViewportWrapping:dt,wrappingColumn:nt,verticalScrollbarWidth:Ie,horizontalScrollbarHeight:je,overviewRuler:{top:Tt,width:Ie,height:Ve-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=j;class H extends P{constructor(){const G={enabled:!0};super(56,"lightbulb",G,{"editor.lightbulb.enabled":{type:"boolean",default:G.enabled,description:h.localize(42,null)}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{enabled:r(G.enabled,this.defaultValue.enabled)}}}class L extends P{constructor(){const G={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",G,{"editor.inlayHints.enabled":{type:"boolean",default:G.enabled,description:h.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:G.fontSize,markdownDescription:h.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:G.fontFamily,description:h.localize(45,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const fe=G;return{enabled:r(fe.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(fe.fontFamily,this.defaultValue.fontFamily)}}}class K extends l{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,G=>l.clamp(G,0,150),{markdownDescription:h.localize(46,null)})}compute(G,fe,Le){return G.fontInfo.lineHeight}}class x extends P{constructor(){const G={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",G,{"editor.minimap.enabled":{type:"boolean",default:G.enabled,description:h.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(48,null),h.localize(49,null),h.localize(50,null)],default:G.size,description:h.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:G.side,description:h.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:G.showSlider,description:h.localize(53,null)},"editor.minimap.scale":{type:"number",default:G.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:G.renderCharacters,description:h.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:G.maxColumn,description:h.localize(56,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const fe=G;return{enabled:r(fe.enabled,this.defaultValue.enabled),size:v(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(fe.side,this.defaultValue.side,["right","left"]),showSlider:v(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(fe.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(fe.scale,1,1,3),maxColumn:a.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y($){return $==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ce extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(58,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const fe=G;return{top:a.clampedInt(fe.top,0,0,1e3),bottom:a.clampedInt(fe.bottom,0,0,1e3)}}}class z extends P{constructor(){const G={enabled:!0,cycle:!1};super(75,"parameterHints",G,{"editor.parameterHints.enabled":{type:"boolean",default:G.enabled,description:h.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:G.cycle,description:h.localize(60,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const fe=G;return{enabled:r(fe.enabled,this.defaultValue.enabled),cycle:r(fe.cycle,this.defaultValue.cycle)}}}class se extends t{constructor(){super(128)}compute(G,fe,Le){return G.pixelRatio}}class re extends P{constructor(){const G={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",G,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:G.strings,description:h.localize(61,null)},comments:{type:"boolean",default:G.comments,description:h.localize(62,null)},other:{type:"boolean",default:G.other,description:h.localize(63,null)}}}],default:G,description:h.localize(64,null)});this.defaultValue=G}validate(G){if(typeof G=="boolean")return G;if(G&&typeof G=="object"){const fe=G,Le={other:r(fe.other,this.defaultValue.other),comments:r(fe.comments,this.defaultValue.comments),strings:r(fe.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var we;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative",$[$.Interval=3]="Interval",$[$.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(65,null),h.localize(66,null),h.localize(67,null),h.localize(68,null)],default:"on",description:h.localize(69,null)})}validate(G){let fe=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof G!="undefined"&&(typeof G=="function"?(fe=4,Le=G):G==="interval"?fe=3:G==="relative"?fe=2:G==="on"?fe=1:fe=0),{renderType:fe,renderFn:Le}}}function Fe($){const G=$.get(87);return G==="editable"?$.get(80):G!=="on"}e.filterValidationDecorations=Fe;class Ne extends P{constructor(){const G=[],fe={type:"number",description:h.localize(70,null)};super(91,"rulers",G,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:h.localize(71,null),format:"color-hex"}}}]},default:G,description:h.localize(72,null)})}validate(G){if(Array.isArray(G)){let fe=[];for(let Le of G)if(typeof Le=="number")fe.push({column:a.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Ve=Le;fe.push({column:a.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return fe.sort((Le,Ve)=>Le.column-Ve.column),fe}return this.defaultValue}}function Qe($,G){if(typeof $!="string")return G;switch($){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends P{constructor(){const G={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",G,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(73,null),h.localize(74,null),h.localize(75,null)],default:"auto",description:h.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(77,null),h.localize(78,null),h.localize(79,null)],default:"auto",description:h.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:G.verticalScrollbarSize,description:h.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:G.horizontalScrollbarSize,description:h.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:G.scrollByPage,description:h.localize(83,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const fe=G,Le=a.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=a.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(fe.vertical,this.defaultValue.vertical),horizontal:Qe(fe.horizontal,this.defaultValue.horizontal),useShadows:r(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:a.clampedInt(fe.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:a.clampedInt(fe.verticalSliderSize,Ve,0,1e3),scrollByPage:r(fe.scrollByPage,this.defaultValue.scrollByPage)}}}class Ke extends P{constructor(){const G={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",G,{"editor.inlineSuggest.enabled":{type:"boolean",default:G.enabled,description:h.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[h.localize(85,null),h.localize(86,null),h.localize(87,null)],default:G.mode,description:h.localize(88,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const fe=G;return{enabled:r(fe.enabled,this.defaultValue.enabled),mode:v(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class N extends P{constructor(){const G={enabled:!1};super(12,"bracketPairColorization",G,{"editor.bracketPairColorization.enabled":{type:"boolean",default:G.enabled,description:h.localize(89,null)}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{enabled:r(G.enabled,this.defaultValue.enabled)}}}class q extends P{constructor(){const G={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",G,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(90,null),h.localize(91,null)],default:G.insertMode,description:h.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:G.filterGraceful,description:h.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:G.localityBonus,description:h.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:G.shareSuggestSelections,markdownDescription:h.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:G.snippetsPreventQuickSuggestions,description:h.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:G.showIcons,description:h.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:G.showStatusBar,description:h.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:G.preview,description:h.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[h.localize(100,null),h.localize(101,null),h.localize(102,null)],default:G.previewMode,description:h.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:G.showInlineDetails,description:h.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(135,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const fe=G;return{insertMode:v(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:r(fe.showIcons,this.defaultValue.showIcons),showStatusBar:r(fe.showStatusBar,this.defaultValue.showStatusBar),preview:r(fe.preview,this.defaultValue.preview),previewMode:v(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(fe.showMethods,this.defaultValue.showMethods),showFunctions:r(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:r(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:r(fe.showFields,this.defaultValue.showFields),showVariables:r(fe.showVariables,this.defaultValue.showVariables),showClasses:r(fe.showClasses,this.defaultValue.showClasses),showStructs:r(fe.showStructs,this.defaultValue.showStructs),showInterfaces:r(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:r(fe.showModules,this.defaultValue.showModules),showProperties:r(fe.showProperties,this.defaultValue.showProperties),showEvents:r(fe.showEvents,this.defaultValue.showEvents),showOperators:r(fe.showOperators,this.defaultValue.showOperators),showUnits:r(fe.showUnits,this.defaultValue.showUnits),showValues:r(fe.showValues,this.defaultValue.showValues),showConstants:r(fe.showConstants,this.defaultValue.showConstants),showEnums:r(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:r(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(fe.showKeywords,this.defaultValue.showKeywords),showWords:r(fe.showWords,this.defaultValue.showWords),showColors:r(fe.showColors,this.defaultValue.showColors),showFiles:r(fe.showFiles,this.defaultValue.showFiles),showReferences:r(fe.showReferences,this.defaultValue.showReferences),showFolders:r(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:r(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(fe.showSnippets,this.defaultValue.showSnippets),showUsers:r(fe.showUsers,this.defaultValue.showUsers),showIssues:r(fe.showIssues,this.defaultValue.showIssues)}}}class X extends P{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(136,null),default:!0,type:"boolean"}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(G.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ie extends t{constructor(){super(129,[80])}compute(G,fe,Le){return fe.get(80)?!0:G.tabFocusMode}}var W;(function($){$[$.None=0]="None",$[$.Same=1]="Same",$[$.Indent=2]="Indent",$[$.DeepIndent=3]="DeepIndent"})(W=e.WrappingIndent||(e.WrappingIndent={}));function ee($){switch($){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class me extends t{constructor(){super(131,[130])}compute(G,fe,Le){const Ve=fe.get(130);return{isDominatedByLongLines:G.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const Te="Consolas, 'Courier New', monospace",Ue="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?Ue:F.isLinux?He:Te,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function be($){return e.editorOptionsRegistry[$.id]=$,$}var Je;(function($){$[$.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",$[$.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",$[$.accessibilitySupport=2]="accessibilitySupport",$[$.accessibilityPageSize=3]="accessibilityPageSize",$[$.ariaLabel=4]="ariaLabel",$[$.autoClosingBrackets=5]="autoClosingBrackets",$[$.autoClosingDelete=6]="autoClosingDelete",$[$.autoClosingOvertype=7]="autoClosingOvertype",$[$.autoClosingQuotes=8]="autoClosingQuotes",$[$.autoIndent=9]="autoIndent",$[$.automaticLayout=10]="automaticLayout",$[$.autoSurround=11]="autoSurround",$[$.bracketPairColorization=12]="bracketPairColorization",$[$.codeLens=13]="codeLens",$[$.codeLensFontFamily=14]="codeLensFontFamily",$[$.codeLensFontSize=15]="codeLensFontSize",$[$.colorDecorators=16]="colorDecorators",$[$.columnSelection=17]="columnSelection",$[$.comments=18]="comments",$[$.contextmenu=19]="contextmenu",$[$.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",$[$.cursorBlinking=21]="cursorBlinking",$[$.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",$[$.cursorStyle=23]="cursorStyle",$[$.cursorSurroundingLines=24]="cursorSurroundingLines",$[$.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",$[$.cursorWidth=26]="cursorWidth",$[$.disableLayerHinting=27]="disableLayerHinting",$[$.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",$[$.domReadOnly=29]="domReadOnly",$[$.dragAndDrop=30]="dragAndDrop",$[$.emptySelectionClipboard=31]="emptySelectionClipboard",$[$.extraEditorClassName=32]="extraEditorClassName",$[$.fastScrollSensitivity=33]="fastScrollSensitivity",$[$.find=34]="find",$[$.fixedOverflowWidgets=35]="fixedOverflowWidgets",$[$.folding=36]="folding",$[$.foldingStrategy=37]="foldingStrategy",$[$.foldingHighlight=38]="foldingHighlight",$[$.foldingImportsByDefault=39]="foldingImportsByDefault",$[$.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",$[$.fontFamily=41]="fontFamily",$[$.fontInfo=42]="fontInfo",$[$.fontLigatures=43]="fontLigatures",$[$.fontSize=44]="fontSize",$[$.fontWeight=45]="fontWeight",$[$.formatOnPaste=46]="formatOnPaste",$[$.formatOnType=47]="formatOnType",$[$.glyphMargin=48]="glyphMargin",$[$.gotoLocation=49]="gotoLocation",$[$.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",$[$.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",$[$.hover=52]="hover",$[$.inDiffEditor=53]="inDiffEditor",$[$.inlineSuggest=54]="inlineSuggest",$[$.letterSpacing=55]="letterSpacing",$[$.lightbulb=56]="lightbulb",$[$.lineDecorationsWidth=57]="lineDecorationsWidth",$[$.lineHeight=58]="lineHeight",$[$.lineNumbers=59]="lineNumbers",$[$.lineNumbersMinChars=60]="lineNumbersMinChars",$[$.linkedEditing=61]="linkedEditing",$[$.links=62]="links",$[$.matchBrackets=63]="matchBrackets",$[$.minimap=64]="minimap",$[$.mouseStyle=65]="mouseStyle",$[$.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",$[$.mouseWheelZoom=67]="mouseWheelZoom",$[$.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",$[$.multiCursorModifier=69]="multiCursorModifier",$[$.multiCursorPaste=70]="multiCursorPaste",$[$.occurrencesHighlight=71]="occurrencesHighlight",$[$.overviewRulerBorder=72]="overviewRulerBorder",$[$.overviewRulerLanes=73]="overviewRulerLanes",$[$.padding=74]="padding",$[$.parameterHints=75]="parameterHints",$[$.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",$[$.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",$[$.quickSuggestions=78]="quickSuggestions",$[$.quickSuggestionsDelay=79]="quickSuggestionsDelay",$[$.readOnly=80]="readOnly",$[$.renameOnType=81]="renameOnType",$[$.renderControlCharacters=82]="renderControlCharacters",$[$.renderIndentGuides=83]="renderIndentGuides",$[$.renderFinalNewline=84]="renderFinalNewline",$[$.renderLineHighlight=85]="renderLineHighlight",$[$.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",$[$.renderValidationDecorations=87]="renderValidationDecorations",$[$.renderWhitespace=88]="renderWhitespace",$[$.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",$[$.roundedSelection=90]="roundedSelection",$[$.rulers=91]="rulers",$[$.scrollbar=92]="scrollbar",$[$.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",$[$.scrollBeyondLastLine=94]="scrollBeyondLastLine",$[$.scrollPredominantAxis=95]="scrollPredominantAxis",$[$.selectionClipboard=96]="selectionClipboard",$[$.selectionHighlight=97]="selectionHighlight",$[$.selectOnLineNumbers=98]="selectOnLineNumbers",$[$.showFoldingControls=99]="showFoldingControls",$[$.showUnused=100]="showUnused",$[$.snippetSuggestions=101]="snippetSuggestions",$[$.smartSelect=102]="smartSelect",$[$.smoothScrolling=103]="smoothScrolling",$[$.stickyTabStops=104]="stickyTabStops",$[$.stopRenderingLineAfter=105]="stopRenderingLineAfter",$[$.suggest=106]="suggest",$[$.suggestFontSize=107]="suggestFontSize",$[$.suggestLineHeight=108]="suggestLineHeight",$[$.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",$[$.suggestSelection=110]="suggestSelection",$[$.tabCompletion=111]="tabCompletion",$[$.tabIndex=112]="tabIndex",$[$.unusualLineTerminators=113]="unusualLineTerminators",$[$.useShadowDOM=114]="useShadowDOM",$[$.useTabStops=115]="useTabStops",$[$.wordSeparators=116]="wordSeparators",$[$.wordWrap=117]="wordWrap",$[$.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",$[$.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",$[$.wordWrapColumn=120]="wordWrapColumn",$[$.wordWrapOverride1=121]="wordWrapOverride1",$[$.wordWrapOverride2=122]="wordWrapOverride2",$[$.wrappingIndent=123]="wrappingIndent",$[$.wrappingStrategy=124]="wrappingStrategy",$[$.showDeprecated=125]="showDeprecated",$[$.inlayHints=126]="inlayHints",$[$.editorClassName=127]="editorClassName",$[$.pixelRatio=128]="pixelRatio",$[$.tabFocusMode=129]="tabFocusMode",$[$.layoutInfo=130]="layoutInfo",$[$.wrappingInfo=131]="wrappingInfo"})(Je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(137,null)})),acceptSuggestionOnEnter:be(new k(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(138,null),""],markdownDescription:h.localize(139,null)})),accessibilitySupport:be(new y),accessibilityPageSize:be(new a(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(140,null)})),ariaLabel:be(new p(4,"ariaLabel",h.localize(141,null))),autoClosingBrackets:be(new k(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(142,null),h.localize(143,null),""],description:h.localize(144,null)})),autoClosingDelete:be(new k(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(145,null),""],description:h.localize(146,null)})),autoClosingOvertype:be(new k(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(147,null),""],description:h.localize(148,null)})),autoClosingQuotes:be(new k(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(149,null),h.localize(150,null),""],description:h.localize(151,null)})),autoIndent:be(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[h.localize(152,null),h.localize(153,null),h.localize(154,null),h.localize(155,null),h.localize(156,null)],description:h.localize(157,null)})),automaticLayout:be(new d(10,"automaticLayout",!1)),autoSurround:be(new k(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(158,null),h.localize(159,null),h.localize(160,null),""],description:h.localize(161,null)})),bracketPairColorization:be(new N),stickyTabStops:be(new d(104,"stickyTabStops",!1,{description:h.localize(162,null)})),codeLens:be(new d(13,"codeLens",!0,{description:h.localize(163,null)})),codeLensFontFamily:be(new p(14,"codeLensFontFamily","",{description:h.localize(164,null)})),codeLensFontSize:be(new a(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(165,null)})),colorDecorators:be(new d(16,"colorDecorators",!0,{description:h.localize(166,null)})),columnSelection:be(new d(17,"columnSelection",!1,{description:h.localize(167,null)})),comments:be(new i),contextmenu:be(new d(19,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new d(20,"copyWithSyntaxHighlighting",!0,{description:h.localize(168,null)})),cursorBlinking:be(new c(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:h.localize(169,null)})),cursorSmoothCaretAnimation:be(new d(22,"cursorSmoothCaretAnimation",!1,{description:h.localize(170,null)})),cursorStyle:be(new c(23,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],m,{description:h.localize(171,null)})),cursorSurroundingLines:be(new a(24,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(172,null)})),cursorSurroundingLinesStyle:be(new k(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(173,null),h.localize(174,null)],description:h.localize(175,null)})),cursorWidth:be(new a(26,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(176,null)})),disableLayerHinting:be(new d(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new d(28,"disableMonospaceOptimizations",!1)),domReadOnly:be(new d(29,"domReadOnly",!1)),dragAndDrop:be(new d(30,"dragAndDrop",!0,{description:h.localize(177,null)})),emptySelectionClipboard:be(new b),extraEditorClassName:be(new p(32,"extraEditorClassName","")),fastScrollSensitivity:be(new l(33,"fastScrollSensitivity",5,$=>$<=0?5:$,{markdownDescription:h.localize(178,null)})),find:be(new C),fixedOverflowWidgets:be(new d(35,"fixedOverflowWidgets",!1)),folding:be(new d(36,"folding",!0,{description:h.localize(179,null)})),foldingStrategy:be(new k(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(180,null),h.localize(181,null)],description:h.localize(182,null)})),foldingHighlight:be(new d(38,"foldingHighlight",!0,{description:h.localize(183,null)})),foldingImportsByDefault:be(new d(39,"foldingImportsByDefault",!1,{description:h.localize(184,null)})),unfoldOnClickAfterEndOfLine:be(new d(40,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(185,null)})),fontFamily:be(new p(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(186,null)})),fontInfo:be(new _),fontLigatures2:be(new n),fontSize:be(new R),fontWeight:be(new U),formatOnPaste:be(new d(46,"formatOnPaste",!1,{description:h.localize(187,null)})),formatOnType:be(new d(47,"formatOnType",!1,{description:h.localize(188,null)})),glyphMargin:be(new d(48,"glyphMargin",!0,{description:h.localize(189,null)})),gotoLocation:be(new V),hideCursorInOverviewRuler:be(new d(50,"hideCursorInOverviewRuler",!1,{description:h.localize(190,null)})),highlightActiveIndentGuide:be(new d(51,"highlightActiveIndentGuide",!0,{description:h.localize(191,null)})),hover:be(new le),inDiffEditor:be(new d(53,"inDiffEditor",!1)),letterSpacing:be(new l(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,$=>l.clamp($,-5,20),{description:h.localize(192,null)})),lightbulb:be(new H),lineDecorationsWidth:be(new S(57,"lineDecorationsWidth",10)),lineHeight:be(new K),lineNumbers:be(new Re),lineNumbersMinChars:be(new a(60,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new d(61,"linkedEditing",!1,{description:h.localize(193,null)})),links:be(new d(62,"links",!0,{description:h.localize(194,null)})),matchBrackets:be(new k(63,"matchBrackets","always",["always","near","never"],{description:h.localize(195,null)})),minimap:be(new x),mouseStyle:be(new k(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new l(66,"mouseWheelScrollSensitivity",1,$=>$===0?1:$,{markdownDescription:h.localize(196,null)})),mouseWheelZoom:be(new d(67,"mouseWheelZoom",!1,{markdownDescription:h.localize(197,null)})),multiCursorMergeOverlapping:be(new d(68,"multiCursorMergeOverlapping",!0,{description:h.localize(198,null)})),multiCursorModifier:be(new c(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[h.localize(199,null),h.localize(200,null)],markdownDescription:h.localize(201,null)})),multiCursorPaste:be(new k(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(202,null),h.localize(203,null)],markdownDescription:h.localize(204,null)})),occurrencesHighlight:be(new d(71,"occurrencesHighlight",!0,{description:h.localize(205,null)})),overviewRulerBorder:be(new d(72,"overviewRulerBorder",!0,{description:h.localize(206,null)})),overviewRulerLanes:be(new a(73,"overviewRulerLanes",3,0,3)),padding:be(new ce),parameterHints:be(new z),peekWidgetDefaultFocus:be(new k(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(207,null),h.localize(208,null)],description:h.localize(209,null)})),definitionLinkOpensInPeek:be(new d(77,"definitionLinkOpensInPeek",!1,{description:h.localize(210,null)})),quickSuggestions:be(new re),quickSuggestionsDelay:be(new a(79,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(211,null)})),readOnly:be(new d(80,"readOnly",!1)),renameOnType:be(new d(81,"renameOnType",!1,{description:h.localize(212,null),markdownDeprecationMessage:h.localize(213,null)})),renderControlCharacters:be(new d(82,"renderControlCharacters",!1,{description:h.localize(214,null)})),renderIndentGuides:be(new d(83,"renderIndentGuides",!0,{description:h.localize(215,null)})),renderFinalNewline:be(new d(84,"renderFinalNewline",!0,{description:h.localize(216,null)})),renderLineHighlight:be(new k(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(217,null)],description:h.localize(218,null)})),renderLineHighlightOnlyWhenFocus:be(new d(86,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(219,null)})),renderValidationDecorations:be(new k(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new k(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(220,null),h.localize(221,null),h.localize(222,null),""],description:h.localize(223,null)})),revealHorizontalRightPadding:be(new a(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new d(90,"roundedSelection",!0,{description:h.localize(224,null)})),rulers:be(new Ne),scrollbar:be(new qe),scrollBeyondLastColumn:be(new a(93,"scrollBeyondLastColumn",5,0,1073741824,{description:h.localize(225,null)})),scrollBeyondLastLine:be(new d(94,"scrollBeyondLastLine",!0,{description:h.localize(226,null)})),scrollPredominantAxis:be(new d(95,"scrollPredominantAxis",!0,{description:h.localize(227,null)})),selectionClipboard:be(new d(96,"selectionClipboard",!0,{description:h.localize(228,null),included:F.isLinux})),selectionHighlight:be(new d(97,"selectionHighlight",!0,{description:h.localize(229,null)})),selectOnLineNumbers:be(new d(98,"selectOnLineNumbers",!0)),showFoldingControls:be(new k(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[h.localize(230,null),h.localize(231,null)],description:h.localize(232,null)})),showUnused:be(new d(100,"showUnused",!0,{description:h.localize(233,null)})),showDeprecated:be(new d(125,"showDeprecated",!0,{description:h.localize(234,null)})),inlayHints:be(new L),snippetSuggestions:be(new k(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(235,null),h.localize(236,null),h.localize(237,null),h.localize(238,null)],description:h.localize(239,null)})),smartSelect:be(new X),smoothScrolling:be(new d(103,"smoothScrolling",!1,{description:h.localize(240,null)})),stopRenderingLineAfter:be(new a(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new q),inlineSuggest:be(new Ke),suggestFontSize:be(new a(107,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(241,null)})),suggestLineHeight:be(new a(108,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(242,null)})),suggestOnTriggerCharacters:be(new d(109,"suggestOnTriggerCharacters",!0,{description:h.localize(243,null)})),suggestSelection:be(new k(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(244,null),h.localize(245,null),h.localize(246,null)],description:h.localize(247,null)})),tabCompletion:be(new k(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(248,null),h.localize(249,null),h.localize(250,null)],description:h.localize(251,null)})),tabIndex:be(new a(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new k(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(252,null),h.localize(253,null),h.localize(254,null)],description:h.localize(255,null)})),useShadowDOM:be(new d(114,"useShadowDOM",!0)),useTabStops:be(new d(115,"useTabStops",!0,{description:h.localize(256,null)})),wordSeparators:be(new p(116,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:h.localize(257,null)})),wordWrap:be(new k(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(258,null),h.localize(259,null),h.localize(260,null),h.localize(261,null)],description:h.localize(262,null)})),wordWrapBreakAfterCharacters:be(new p(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new p(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new a(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(263,null)})),wordWrapOverride1:be(new k(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new k(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new c(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ee,{enumDescriptions:[h.localize(264,null),h.localize(265,null),h.localize(266,null),h.localize(267,null)],description:h.localize(268,null)})),wrappingStrategy:be(new k(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[h.localize(269,null),h.localize(270,null)],description:h.localize(271,null)})),editorClassName:be(new g),pixelRatio:be(new se),tabFocusMode:be(new ie),layoutInfo:be(new j),wrappingInfo:be(new me)}}),define(Ee[118],_e([18,19]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[119],_e([18,19]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[120],_e([18,19]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ee[121],_e([18,19]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ee[122],_e([18,19]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[123],_e([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[124],_e([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[125],_e([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[126],_e([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[127],_e([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[128],_e([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[129],_e([18,19]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[130],_e([18,19]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ee[131],_e([18,19]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Ee[132],_e([18,19]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[133],_e([18,19]),function(te,e){return te.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[134],_e([18,19]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[135],_e([18,19]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[136],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var h;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(h=e.EditorActivation||(e.EditorActivation={}));var F;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var E;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[137],_e([0,1,119]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function T(r){return r=r.trim(),r==="*"||F.test(r)}e.isValidVersionStr=T;function A(r){if(!T(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=r.match(F);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=A;function I(r){if(!r)return null;let d=r.majorBase,a=r.majorMustEqual,l=r.minorBase,p=r.minorMustEqual,v=r.patchBase,k=r.patchMustEqual;r.hasCaret&&(d===0||(p=!1),k=!1);let c=0;if(r.preRelease){const w=E.exec(r.preRelease);if(w){const[,y,i,o]=w;c=Date.UTC(Number(y),Number(i)-1,Number(o))}}return{majorBase:d,majorMustEqual:a,minorBase:l,minorMustEqual:p,patchBase:v,patchMustEqual:k,isMinimum:r.hasGreaterEquals,notBefore:c}}e.normalizeVersion=I;function D(r,d,a){let l;typeof r=="string"?l=I(A(r)):l=r;let p;d instanceof Date?p=d.getTime():typeof d=="string"&&(p=new Date(d).getTime());let v;if(typeof a=="string"?v=I(A(a)):v=a,!l||!v)return!1;let k=l.majorBase,c=l.minorBase,w=l.patchBase,y=v.majorBase,i=v.minorBase,o=v.patchBase,u=v.notBefore,s=v.majorMustEqual,f=v.minorMustEqual,m=v.patchMustEqual;return v.isMinimum?k>y?!0:k<y?!1:c>i?!0:c<i||p&&p<u?!1:w>=o:(k===1&&y===0&&(!s||!f||!m)&&(y=1,i=0,o=0,s=!0,f=!1,m=!1),k<y?!1:k>y?!s:c<i?!1:c>i?!f:w<o?!1:w>o?!m:!(p&&p<u))}e.isValidVersion=D;function P(r,d,a,l){return a.isBuiltin||typeof a.main=="undefined"?!0:S(r,d,a.engines.vscode,l)}e.isValidExtensionVersion=P;function t(r,d,a){return r==="*"||S(d,a,r)}e.isEngineValid=t;function S(r,d,a,l=[]){let p=I(A(a));if(!p)return l.push(h.localize(0,null,a)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return l.push(h.localize(1,null,a)),!1}else if(!p.majorMustEqual)return l.push(h.localize(2,null,a)),!1;return D(r,d,p)?!0:(l.push(h.localize(3,null,r,a)),!1)}}),define(Ee[80],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class h{constructor(E,T=[],A=!1){this.ctor=E,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=h}),define(Ee[55],_e([0,1,80]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function E(A,I,D){I instanceof h.SyncDescriptor||(I=new h.SyncDescriptor(I,[],D)),F.push([A,I])}e.registerSingleton=E;function T(){return F}e.getSingletonServiceDescriptors=T}),define(Ee[138],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=h;class F{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const I=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(A);I.outgoing.set(this._hashFn(A),D),D.incoming.set(this._hashFn(T),I)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let I of this._nodes.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let I=this._nodes.get(A);return I||(I=new h(T),this._nodes.set(A,I)),I}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,I]of this._nodes)T.push(`${A}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const I=new Set([T]),D=this._findCycle(A,I);if(D)return D}}_findCycle(T,A){for(let[I,D]of T.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const P=this._findCycle(D,A);if(P)return P;A.delete(I)}}}e.Graph=F}),define(Ee[4],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function D(P){return P[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=D})(h=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function F(I,D,P,t){D[h.DI_TARGET]===D?D[h.DI_DEPENDENCIES].push({id:I,index:P,optional:t}):(D[h.DI_DEPENDENCIES]=[{id:I,index:P,optional:t}],D[h.DI_TARGET]=D)}function E(I){if(h.serviceIds.has(I))return h.serviceIds.get(I);const D=function(P,t,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(D,P,S,!1)};return D.toString=()=>I,h.serviceIds.set(I,D),D}e.createDecorator=E;function T(I){return I}e.refineServiceDecorator=T;function A(I){return function(D,P,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(I,D,t,!0)}}e.optional=A}),define(Ee[139],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,h.createDecorator)("modelService");function F(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(Ee[140],_e([0,1,3,56,7,20,74,53,139]),function(te,e,h,F,E,T,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(r){return typeof r=="string"?!1:Array.isArray(r)?r.every(P):!!r.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new h.Emitter}get onDidChange(){return this._onDidChange.event}register(d,a){let l={selector:d,provider:a,_score:-1,_time:this._clock++};return this._entries.push(l),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(l){let p=this._entries.indexOf(l);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),l=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const a=[];for(let l of this._entries)l._score>0&&a.push(l.provider);return a}ordered(d){const a=[];return this._orderedForEach(d,l=>a.push(l.provider)),a}orderedGroups(d){const a=[];let l,p;return this._orderedForEach(d,v=>{l&&p===v._score?l.push(v.provider):(p=v._score,l=[v.provider],a.push(l))}),a}_orderedForEach(d,a){if(!!d){this._updateScores(d);for(const l of this._entries)l._score>0&&a(l)}}_updateScores(d){let a={uri:d.uri.toString(),language:d.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let l of this._entries)if(l._score=(0,I.score)(l.selector,d.uri,d.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(d)),P(l.selector)&&l._score>0){for(let p of this._entries)p._score=0;l._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(d,a){return d._score<a._score?1:d._score>a._score?-1:d._time<a._time?1:d._time>a._time?-1:0}}e.LanguageFeatureRegistry=t;class S{constructor(d,a,l=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=a,this.max=l,this._cache=new T.LRUCache(50,.7)}_key(d){return d.id+(0,F.hash)(this._registry.all(d))}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const a=this._key(d),l=this._cache.get(a);return this._clamp(l?.value)}update(d,a){const l=this._key(d);let p=this._cache.get(l);return p||(p=new A.MovingAverage,this._cache.set(l,p)),p.update(a),this.get(d)}}e.LanguageFeatureRequestDelays=S}),define(Ee[57],_e([0,1,2,41,140,113,34]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(n){n[n.Null=0]="Null",n[n.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class D{constructor(_,R){this.language=_,this.id=R}}e.LanguageIdentifier=D;var P;(function(n){n[n.NotSet=-1]="NotSet",n[n.None=0]="None",n[n.Italic=1]="Italic",n[n.Bold=2]="Bold",n[n.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var t;(function(n){n[n.None=0]="None",n[n.DefaultForeground=1]="DefaultForeground",n[n.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var S;(function(n){n[n.Other=0]="Other",n[n.Comment=1]="Comment",n[n.String=2]="String",n[n.RegEx=4]="RegEx"})(S=e.StandardTokenType||(e.StandardTokenType={}));var r;(function(n){n[n.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",n[n.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",n[n.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",n[n.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",n[n.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",n[n.ITALIC_MASK=2048]="ITALIC_MASK",n[n.BOLD_MASK=4096]="BOLD_MASK",n[n.UNDERLINE_MASK=8192]="UNDERLINE_MASK",n[n.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",n[n.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",n[n.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",n[n.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",n[n.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",n[n.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",n[n.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",n[n.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",n[n.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",n[n.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(r=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&1792)>>>8}static getFontStyle(_){return(_&14336)>>>11}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let R=this.getForeground(_),U="mtk"+R,V=this.getFontStyle(_);return V&1&&(U+=" mtki"),V&2&&(U+=" mtkb"),V&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(_,R){const U=this.getForeground(_),V=this.getFontStyle(_);let le=`color: ${R[U]};`;return V&1&&(le+="font-style: italic;"),V&2&&(le+="font-weight: bold;"),V&4&&(le+="text-decoration: underline;"),le}}e.TokenMetadata=d;var a;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let n=Object.create(null);return n[0]="symbol-method",n[1]="symbol-function",n[2]="symbol-constructor",n[3]="symbol-field",n[4]="symbol-variable",n[5]="symbol-class",n[6]="symbol-struct",n[7]="symbol-interface",n[8]="symbol-module",n[9]="symbol-property",n[10]="symbol-event",n[11]="symbol-operator",n[12]="symbol-unit",n[13]="symbol-value",n[14]="symbol-constant",n[15]="symbol-enum",n[16]="symbol-enum-member",n[17]="symbol-keyword",n[27]="symbol-snippet",n[18]="symbol-text",n[19]="symbol-color",n[20]="symbol-file",n[21]="symbol-reference",n[22]="symbol-customcolor",n[23]="symbol-folder",n[24]="symbol-type-parameter",n[25]="account",n[26]="issues",function(_){const R=n[_];let U=R&&A.iconRegistry.get(R);return U||(console.info("No codicon found for CompletionItemKind "+_),U=A.Codicon.symbolProperty),U.classNames}}(),e.completionKindFromString=function(){let n=Object.create(null);return n.method=0,n.function=1,n.constructor=2,n.field=3,n.variable=4,n.class=5,n.struct=6,n.interface=7,n.module=8,n.property=9,n.event=10,n.operator=11,n.unit=12,n.value=13,n.constant=14,n.enum=15,n["enum-member"]=16,n.enumMember=16,n.keyword=17,n.snippet=27,n.text=18,n.color=19,n.file=20,n.reference=21,n.customcolor=22,n.folder=23,n["type-parameter"]=24,n.typeParameter=24,n.account=25,n.issue=26,function(_,R){let U=n[_];return typeof U=="undefined"&&!R&&(U=9),U}}();var l;(function(n){n[n.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(n){n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var k;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(k=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var w;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(w=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var y;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(y=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(n){return n&&h.URI.isUri(n.uri)&&F.Range.isIRange(n.range)&&(F.Range.isIRange(n.originSelectionRange)||F.Range.isIRange(n.targetSelectionRange))}e.isLocationLink=i;var o;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(o=e.SymbolKind||(e.SymbolKind={}));var u;(function(n){n[n.Deprecated=1]="Deprecated"})(u=e.SymbolTag||(e.SymbolTag={}));var s;(function(n){const _=new Map;_.set("file",0),_.set("module",1),_.set("namespace",2),_.set("package",3),_.set("class",4),_.set("method",5),_.set("property",6),_.set("field",7),_.set("constructor",8),_.set("enum",9),_.set("interface",10),_.set("function",11),_.set("variable",12),_.set("constant",13),_.set("string",14),_.set("number",15),_.set("boolean",16),_.set("array",17),_.set("object",18),_.set("key",19),_.set("null",20),_.set("enum-member",21),_.set("struct",22),_.set("event",23),_.set("operator",24),_.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function U(he){return _.get(he)}n.fromString=U;function V(he){return R.get(he)}n.toString=V;function le(he,j){const H=R.get(he);let L=H&&A.iconRegistry.get("symbol-"+H);return L||(console.info("No codicon found for SymbolKind "+he),L=A.Codicon.symbolProperty),`${j?"inline":"block"} ${L.classNames}`}n.toCssClassName=le})(s=e.SymbolKinds||(e.SymbolKinds={}));class f{constructor(_){this.value=_}}e.FoldingRangeKind=f,f.Comment=new f("comment"),f.Imports=new f("imports"),f.Region=new f("region");var m;(function(n){n[n.Collapsed=0]="Collapsed",n[n.Expanded=1]="Expanded"})(m=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var g;(function(n){n[n.Editing=0]="Editing",n[n.Preview=1]="Preview"})(g=e.CommentMode||(e.CommentMode={}));var b;(function(n){n[n.Other=0]="Other",n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var C;(function(n){n[n.None=0]="None",n[n.Option=1]="Option",n[n.Default=2]="Default",n[n.Preferred=3]="Preferred"})(C=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[42],_e([0,1,26,9,4]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=h.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",h.isMacintosh),A.set("isLinux",h.isLinux),A.set("isWindows",h.isWindows),A.set("isWeb",h.isWeb),A.set("isMacNative",h.isMacintosh&&!h.isWeb),A.set("isEdge",T.indexOf("Edg/")>=0),A.set("isFirefox",T.indexOf("Firefox")>=0),A.set("isChrome",T.indexOf("Chrome")>=0),A.set("isSafari",T.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var D;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return S.INSTANCE}static true(){return r.INSTANCE}static has(n){return d.create(n)}static equals(n,_){return a.create(n,_)}static notEquals(n,_){return v.create(n,_)}static regex(n,_){return o.create(n,_)}static in(n,_){return l.create(n,_)}static not(n){return k.create(n)}static and(...n){return s.create(n)}static or(...n){return f.create(n)}static greater(n,_){return c.create(n,_)}static less(n,_){return y.create(n,_)}static deserialize(n,_=!1){if(!!n)return this._deserializeOrExpression(n,_)}static _deserializeOrExpression(n,_){let R=n.split("||");return f.create(R.map(U=>this._deserializeAndExpression(U,_)))}static _deserializeAndExpression(n,_){let R=n.split("&&");return s.create(R.map(U=>this._deserializeOne(U,_)))}static _deserializeOne(n,_){if(n=n.trim(),n.indexOf("!=")>=0){let R=n.split("!=");return v.create(R[0].trim(),this._deserializeValue(R[1],_))}if(n.indexOf("==")>=0){let R=n.split("==");return a.create(R[0].trim(),this._deserializeValue(R[1],_))}if(n.indexOf("=~")>=0){let R=n.split("=~");return o.create(R[0].trim(),this._deserializeRegexValue(R[1],_))}if(n.indexOf(" in ")>=0){let R=n.split(" in ");return l.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(n)){const R=n.split(">=");return w.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(n)){const R=n.split(">");return c.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(n)){const R=n.split("<=");return i.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(n)){const R=n.split("<");return y.create(R[0].trim(),R[1].trim())}return/^\!\s*/.test(n)?k.create(n.substr(1).trim()):d.create(n)}static _deserializeValue(n,_){if(n=n.trim(),n==="true")return!0;if(n==="false")return!1;let R=/^'([^']*)'$/.exec(n);return R?R[1].trim():n}static _deserializeRegexValue(n,_){if((0,F.isFalsyOrWhitespace)(n)){if(_)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let R=n.indexOf("/"),U=n.lastIndexOf("/");if(R===U||R<0){if(_)throw new Error(`bad regexp-value '${n}', missing /-enclosure`);return console.warn(`bad regexp-value '${n}', missing /-enclosure`),null}let V=n.slice(R+1,U),le=n[U+1]==="i"?"i":"";try{return new RegExp(V,le)}catch(he){if(_)throw new Error(`bad regexp-value '${n}', parse error: ${he}`);return console.warn(`bad regexp-value '${n}', parse error: ${he}`),null}}}e.ContextKeyExpr=P;function t(C,n){return C.cmp(n)}class S{constructor(){this.type=0}cmp(n){return this.type-n.type}equals(n){return n.type===this.type}evaluate(n){return!1}serialize(){return"false"}keys(){return[]}map(n){return this}negate(){return r.INSTANCE}}e.ContextKeyFalseExpr=S,S.INSTANCE=new S;class r{constructor(){this.type=1}cmp(n){return this.type-n.type}equals(n){return n.type===this.type}evaluate(n){return!0}serialize(){return"true"}keys(){return[]}map(n){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=r,r.INSTANCE=new r;class d{constructor(n){this.key=n,this.type=2}static create(n){const _=A.get(n);return typeof _=="boolean"?_?r.INSTANCE:S.INSTANCE:new d(n)}cmp(n){return n.type!==this.type?this.type-n.type:g(this.key,n.key)}equals(n){return n.type===this.type?this.key===n.key:!1}evaluate(n){return!!n.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(n){return n.mapDefined(this.key)}negate(){return k.create(this.key)}}e.ContextKeyDefinedExpr=d;class a{constructor(n,_){this.key=n,this.value=_,this.type=4}static create(n,_){if(typeof _=="boolean")return _?d.create(n):k.create(n);const R=A.get(n);return typeof R=="boolean"?_===(R?"true":"false")?r.INSTANCE:S.INSTANCE:new a(n,_)}cmp(n){return n.type!==this.type?this.type-n.type:b(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return n.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(n){return n.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class l{constructor(n,_){this.key=n,this.valueKey=_,this.type=10}static create(n,_){return new l(n,_)}cmp(n){return n.type!==this.type?this.type-n.type:b(this.key,this.valueKey,n.key,n.valueKey)}equals(n){return n.type===this.type?this.key===n.key&&this.valueKey===n.valueKey:!1}evaluate(n){const _=n.getValue(this.valueKey),R=n.getValue(this.key);return Array.isArray(_)?_.indexOf(R)>=0:typeof R=="string"&&typeof _=="object"&&_!==null?I.call(_,R):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(n){return n.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=l;class p{constructor(n){this._actual=n,this.type=11}static create(n){return new p(n)}cmp(n){return n.type!==this.type?this.type-n.type:this._actual.cmp(n._actual)}equals(n){return n.type===this.type?this._actual.equals(n._actual):!1}evaluate(n){return!this._actual.evaluate(n)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(n){return new p(this._actual.map(n))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class v{constructor(n,_){this.key=n,this.value=_,this.type=5}static create(n,_){if(typeof _=="boolean")return _?k.create(n):d.create(n);const R=A.get(n);return typeof R=="boolean"?_===(R?"true":"false")?S.INSTANCE:r.INSTANCE:new v(n,_)}cmp(n){return n.type!==this.type?this.type-n.type:b(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return n.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(n){return n.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class k{constructor(n){this.key=n,this.type=3}static create(n){const _=A.get(n);return typeof _=="boolean"?_?S.INSTANCE:r.INSTANCE:new k(n)}cmp(n){return n.type!==this.type?this.type-n.type:g(this.key,n.key)}equals(n){return n.type===this.type?this.key===n.key:!1}evaluate(n){return!n.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(n){return n.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=k;class c{constructor(n,_){this.key=n,this.value=_,this.type=12}static create(n,_){return new c(n,_)}cmp(n){return n.type!==this.type?this.type-n.type:b(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return parseFloat(n.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(n){return n.mapGreater(this.key,this.value)}negate(){return i.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class w{constructor(n,_){this.key=n,this.value=_,this.type=13}static create(n,_){return new w(n,_)}cmp(n){return n.type!==this.type?this.type-n.type:b(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return parseFloat(n.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(n){return n.mapGreaterEquals(this.key,this.value)}negate(){return y.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=w;class y{constructor(n,_){this.key=n,this.value=_,this.type=14}static create(n,_){return new y(n,_)}cmp(n){return n.type!==this.type?this.type-n.type:b(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return parseFloat(n.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(n){return n.mapSmaller(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeySmallerExpr=y;class i{constructor(n,_){this.key=n,this.value=_,this.type=15}static create(n,_){return new i(n,_)}cmp(n){return n.type!==this.type?this.type-n.type:b(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return parseFloat(n.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(n){return n.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=i;class o{constructor(n,_){this.key=n,this.regexp=_,this.type=7}static create(n,_){return new o(n,_)}cmp(n){if(n.type!==this.type)return this.type-n.type;if(this.key<n.key)return-1;if(this.key>n.key)return 1;const _=this.regexp?this.regexp.source:"",R=n.regexp?n.regexp.source:"";return _<R?-1:_>R?1:0}equals(n){if(n.type===this.type){const _=this.regexp?this.regexp.source:"",R=n.regexp?n.regexp.source:"";return this.key===n.key&&_===R}return!1}evaluate(n){let _=n.getValue(this.key);return this.regexp?this.regexp.test(_):!1}serialize(){const n=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${n}`}keys(){return[this.key]}map(n){return n.mapRegex(this.key,this.regexp)}negate(){return u.create(this)}}e.ContextKeyRegexExpr=o;class u{constructor(n){this._actual=n,this.type=8}static create(n){return new u(n)}cmp(n){return n.type!==this.type?this.type-n.type:this._actual.cmp(n._actual)}equals(n){return n.type===this.type?this._actual.equals(n._actual):!1}evaluate(n){return!this._actual.evaluate(n)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(n){return new u(this._actual.map(n))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;class s{constructor(n){this.expr=n,this.type=6}static create(n){return s._normalizeArr(n)}cmp(n){if(n.type!==this.type)return this.type-n.type;if(this.expr.length<n.expr.length)return-1;if(this.expr.length>n.expr.length)return 1;for(let _=0,R=this.expr.length;_<R;_++){const U=t(this.expr[_],n.expr[_]);if(U!==0)return U}return 0}equals(n){if(n.type===this.type){if(this.expr.length!==n.expr.length)return!1;for(let _=0,R=this.expr.length;_<R;_++)if(!this.expr[_].equals(n.expr[_]))return!1;return!0}return!1}evaluate(n){for(let _=0,R=this.expr.length;_<R;_++)if(!this.expr[_].evaluate(n))return!1;return!0}static _normalizeArr(n){const _=[];let R=!1;for(const U of n)if(!!U){if(U.type===1){R=!0;continue}if(U.type===0)return S.INSTANCE;if(U.type===6){_.push(...U.expr);continue}_.push(U)}if(_.length===0&&R)return r.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];for(_.sort(t);_.length>1;){const U=_[_.length-1];if(U.type!==9)break;_.pop();const V=_.pop(),le=f.create(U.expr.map(he=>s.create([he,V])));le&&(_.push(le),_.sort(t))}return _.length===1?_[0]:new s(_)}}serialize(){return this.expr.map(n=>n.serialize()).join(" && ")}keys(){const n=[];for(let _ of this.expr)n.push(..._.keys());return n}map(n){return new s(this.expr.map(_=>_.map(n)))}negate(){let n=[];for(let _ of this.expr)n.push(_.negate());return f.create(n)}}e.ContextKeyAndExpr=s;class f{constructor(n){this.expr=n,this.type=9}static create(n){const _=f._normalizeArr(n);if(_.length!==0)return _.length===1?_[0]:new f(_)}cmp(n){if(n.type!==this.type)return this.type-n.type;if(this.expr.length<n.expr.length)return-1;if(this.expr.length>n.expr.length)return 1;for(let _=0,R=this.expr.length;_<R;_++){const U=t(this.expr[_],n.expr[_]);if(U!==0)return U}return 0}equals(n){if(n.type===this.type){if(this.expr.length!==n.expr.length)return!1;for(let _=0,R=this.expr.length;_<R;_++)if(!this.expr[_].equals(n.expr[_]))return!1;return!0}return!1}evaluate(n){for(let _=0,R=this.expr.length;_<R;_++)if(this.expr[_].evaluate(n))return!0;return!1}static _normalizeArr(n){let _=[],R=!1;if(n){for(let U=0,V=n.length;U<V;U++){const le=n[U];if(!!le){if(le.type===0){R=!0;continue}if(le.type===1)return[r.INSTANCE];if(le.type===9){_=_.concat(le.expr);continue}_.push(le)}}if(_.length===0&&R)return[S.INSTANCE];_.sort(t)}return _}serialize(){return this.expr.map(n=>n.serialize()).join(" || ")}keys(){const n=[];for(let _ of this.expr)n.push(..._.keys());return n}map(n){return new f(this.expr.map(_=>_.map(n)))}negate(){let n=[];for(let R of this.expr)n.push(R.negate());const _=R=>R.type===9?R.expr:[R];for(;n.length>1;){const R=n.shift(),U=n.shift(),V=[];for(const le of _(R))for(const he of _(U))V.push(P.and(le,he));n.unshift(P.or(...V))}return n[0]}}e.ContextKeyOrExpr=f;class m extends d{constructor(n,_,R){super(n);this._defaultValue=_,typeof R=="object"?m._info.push({...R,key:n}):R!==!0&&m._info.push({key:n,description:R,type:_!=null?typeof _:void 0})}static all(){return m._info.values()}bindTo(n){return n.createKey(this.key,this._defaultValue)}getValue(n){return n.getContextKeyValue(this.key)}toNegated(){return P.not(this.key)}isEqualTo(n){return P.equals(this.key,n)}notEqualsTo(n){return P.notEquals(this.key,n)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(C,n){return C<n?-1:C>n?1:0}function b(C,n,_,R){return C<_?-1:C>_?1:n<R?-1:n>R?1:0}}),define(Ee[141],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,h.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,h.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[25],_e([0,1,9,4]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function E(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=E;function T(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class I{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,r){if(typeof S=="undefined"||S===null)return typeof r=="undefined"||r===null;if(typeof r=="undefined"||r===null)return!1;if(typeof S=="string"||typeof r=="string"){let d=typeof S=="string"?S:S.value,a=typeof r=="string"?r:r.value;return h.equalsIgnoreCase(d,a)}return S._lower===r._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=I;function D(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function P(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[142],_e([0,1,9,25]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(a,l){return a.uuid&&l.uuid?a.uuid===l.uuid:a.id===l.id?!0:(0,h.compareIgnoreCase)(a.id,l.id)===0}e.areSameExtensions=E;class T{constructor(l,p){this.version=p,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof T?E(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=T;function A(a,l){return`${a}.${l}`}e.getExtensionId=A;function I(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function D(a,l){return I(A(a,l))}e.getGalleryExtensionId=D;function P(a,l){const p=[],v=k=>{for(const c of p)if(c.some(w=>E(l(w),l(k))))return c;return null};for(const k of a){const c=v(k);c?c.push(k):p.push([k])}return p}e.groupByExtension=P;function t(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function S(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function r(a){const l=new Set;for(const p of a)p.malicious&&l.add(p.id.id);return l}e.getMaliciousExtensionsSet=r;function d(a,l){const p=[],v=l.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const k=v.shift();if(k&&p.every(c=>!E(c.identifier,{id:k}))){const c=a.filter(w=>E(w.identifier,{id:k}));c.length===1&&(p.push(c[0]),v.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=d}),define(Ee[58],_e([0,1,20,17,9,10,2,120,4]),function(te,e,h,F,E,T,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function P(j){return j.create===!0}e.isFileOpenForWriteOptions=P;var t;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var S;(function(j){j[j.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var r;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(r=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=d;function a(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=a;function l(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function p(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=p;var v;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class k extends Error{constructor(H,L){super(H);this.code=L}}e.FileSystemProviderError=k;function c(j,H){const L=new k(j.toString(),H);return y(L,H),L}e.createFileSystemProviderError=c;function w(j){return j||c((0,I.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=w;function y(j,H){return j.name=H?`${H} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=y;function i(j){if(!j)return v.Unknown;if(j instanceof k)return j.code;const H=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!H)return v.Unknown;switch(H[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=i;function o(j){if(j instanceof b)return j.fileOperationResult;switch(i(j)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var u;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(u=e.FileOperation||(e.FileOperation={}));class s{constructor(H,L,K){this.resource=H,this.operation=L,this.target=K}isOperation(H){return this.operation===H}}e.FileOperationEvent=s;var f;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class m{constructor(H,L){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const K of H)switch(K.type){case 1:this.added||(this.added=h.TernarySearchTree.forUris(()=>L)),this.added.set(K.resource,K);break;case 0:this.updated||(this.updated=h.TernarySearchTree.forUris(()=>L)),this.updated.set(K.resource,K);break;case 2:this.deleted||(this.deleted=h.TernarySearchTree.forUris(()=>L)),this.deleted.set(K.resource,K);break}}contains(H,...L){return this.doContains(H,{includeChildren:!1},...L)}affects(H,...L){return this.doContains(H,{includeChildren:!0},...L)}doContains(H,L,...K){if(!H)return!1;const x=K.length>0;return!!((!x||K.includes(1))&&(this.added?.get(H)||L.includeChildren&&this.added?.findSuperstr(H))||(!x||K.includes(0))&&(this.updated?.get(H)||L.includeChildren&&this.updated?.findSuperstr(H))||(!x||K.includes(2))&&(this.deleted?.findSubstr(H)||L.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function g(j,H,L){return!j||!H||j===H||H.length>j.length?!1:(H.charAt(H.length-1)!==F.sep&&(H+=F.sep),L?(0,E.startsWithIgnoreCase)(j,H):j.indexOf(H)===0)}e.isParent=g;class b extends Error{constructor(H,L,K){super(H);this.fileOperationResult=L,this.options=K}}e.FileOperationError=b;class C extends b{constructor(H,L,K){super(H,2,K);this.stat=L}}e.NotModifiedSinceFileOperationError=C;var n;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(n=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=R;async function U(j,H){if(!H.canHandleResource(A.URI.from({scheme:j.scheme})))return new Promise(L=>{const K=H.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===j.scheme&&x.added&&(K.dispose(),L())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class V{static formatSize(H){return(0,T.isNumber)(H)||(H=0),H<V.KB?(0,I.localize)(1,null,H.toFixed(0)):H<V.MB?(0,I.localize)(2,null,(H/V.KB).toFixed(2)):H<V.GB?(0,I.localize)(3,null,(H/V.MB).toFixed(2)):H<V.TB?(0,I.localize)(4,null,(H/V.GB).toFixed(2)):(0,I.localize)(5,null,(H/V.TB).toFixed(2))}}e.ByteSize=V,V.KB=1024,V.MB=V.KB*V.KB,V.GB=V.MB*V.KB,V.TB=V.GB*V.KB;var le;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(le=e.Arch||(e.Arch={}));function he(j){return{maxFileSize:j===0?300*V.MB:16*V.GB,maxHeapSize:j===0?700*V.MB:2*700*V.MB}}e.getPlatformLimits=he}),define(Ee[59],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...E){this._entries=new Map;for(let[T,A]of E)this.set(T,A)}set(E,T){const A=this._entries.get(E);return this._entries.set(E,T),A}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=h}),define(Ee[143],_e([0,1,13,15,80,138,4,59]),function(te,e,h,F,E,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class t{constructor(a=new I.ServiceCollection,l=!1,p){this._activeInstantiations=new Set,this._services=a,this._strict=l,this._parent=p,this._services.set(A.IInstantiationService,this)}createChild(a){return new t(a,this._strict,this)}invokeFunction(a,...l){let p=r.traceInvocation(a),v=!1;try{return a({get:(c,w)=>{if(v)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const y=this._getOrCreateServiceInstance(c,p);if(!y&&w!==A.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return y}},...l)}finally{v=!0,p.stop()}}createInstance(a,...l){let p,v;return a instanceof E.SyncDescriptor?(p=r.traceCreation(a.ctor),v=this._createInstance(a.ctor,a.staticArguments.concat(l),p)):(p=r.traceCreation(a),v=this._createInstance(a,l,p)),p.stop(),v}_createInstance(a,l=[],p){let v=A._util.getServiceDependencies(a).sort((w,y)=>w.index-y.index),k=[];for(const w of v){let y=this._getOrCreateServiceInstance(w.id,p);if(!y&&this._strict&&!w.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${w.id}.`);k.push(y)}let c=v.length>0?v[0].index:l.length;if(l.length!==c){console.warn(`[createInstance] First service dependency of ${a.name} at position ${c+1} conflicts with ${l.length} static arguments`);let w=c-l.length;w>0?l=l.concat(new Array(w)):l=l.slice(0,c)}return new a(...[...l,...k])}_setServiceInstance(a,l){if(this._services.get(a)instanceof E.SyncDescriptor)this._services.set(a,l);else if(this._parent)this._parent._setServiceInstance(a,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let l=this._services.get(a);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):l}_getOrCreateServiceInstance(a,l){let p=this._getServiceInstanceOrDescriptor(a);return p instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,p,l.branch(a,!0)):(l.branch(a,!1),p)}_safeCreateAndCacheServiceInstance(a,l,p){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,l,p)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,l,p){const v=new T.Graph(w=>w.id.toString());let k=0;const c=[{id:a,desc:l,_trace:p}];for(;c.length;){const w=c.pop();if(v.lookupOrInsertNode(w),k++>1e3)throw new P(v);for(let y of A._util.getServiceDependencies(w.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(y.id);if(!i&&!y.optional&&console.warn(`[createInstance] ${a} depends on ${y.id} which is NOT registered.`),i instanceof E.SyncDescriptor){const o={id:y.id,desc:i,_trace:w._trace.branch(y.id,!0)};v.insertEdge(w,o),c.push(o)}}}for(;;){const w=v.roots();if(w.length===0){if(!v.isEmpty())throw new P(v);break}for(const{data:y}of w){if(this._getServiceInstanceOrDescriptor(y.id)instanceof E.SyncDescriptor){const o=this._createServiceInstanceWithOwner(y.id,y.desc.ctor,y.desc.staticArguments,y.desc.supportsDelayedInstantiation,y._trace);this._setServiceInstance(y.id,o)}v.removeNode(y)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,l,p=[],v,k){if(this._services.get(a)instanceof E.SyncDescriptor)return this._createServiceInstance(l,p,v,k);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,l,p,v,k);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(a,l=[],p,v){if(p){const k=new h.IdleValue(()=>this._createInstance(a,l,v));return new Proxy(Object.create(null),{get(c,w){if(w in c)return c[w];let y=k.value,i=y[w];return typeof i!="function"||(i=i.bind(y),c[w]=i),i},set(c,w,y){return k.value[w]=y,!0}})}else return this._createInstance(a,l,v)}}e.InstantiationService=t;var S;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(S||(S={}));class r{constructor(a,l){this.type=a,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new r(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):r._None}static traceCreation(a){return D?new r(0,a.name):r._None}branch(a,l){let p=new r(2,a.toString());return this._dep.push([a,l,p]),p}stop(){let a=Date.now()-this._start;r._totals+=a;let l=!1;function p(k,c){let w=[],y=new Array(k+1).join("	");for(const[i,o,u]of c._dep)if(o&&u){l=!0,w.push(`${y}CREATES -> ${i}`);let s=p(k+1,u);s&&w.push(s)}else w.push(`${y}uses -> ${i}`);return w.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${r._totals.toFixed(2)}ms)`];(a>2||l)&&console.log(v.join(`
`))}}r._None=new class extends r{constructor(){super(-1,null)}stop(){}branch(){return this}},r._totals=0}),define(Ee[14],_e([0,1,54,3,7,26,4]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function I(){return new Date().toISOString()}var D;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class P extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class t extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...o){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([i,...o]))}debug(i,...o){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([i,...o]))}info(i,...o){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([i,...o]))}warn(i,...o){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([i,...o]))}error(i,...o){if(this.checkLogLevel(D.Error))if(i instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=i.stack,this.log(D.Error,this.format(u))}else this.log(D.Error,this.format([i,...o]))}critical(i,...o){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([i,...o]))}flush(){}format(i){let o="";for(let u=0;u<i.length;u++){let s=i[u];if(typeof s=="object")try{s=JSON.stringify(s)}catch(f){}o+=(u>0?" ":"")+s}return o}}e.AbstractMessageLogger=t;class S extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...o){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...o):console.log(`[main ${I()}]`,i,...o))}debug(i,...o){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...o):console.log(`[main ${I()}]`,i,...o))}info(i,...o){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...o):console.log(`[main ${I()}]`,i,...o))}warn(i,...o){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,i,...o):console.warn(`[main ${I()}]`,i,...o))}error(i,...o){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,i,...o):console.error(`[main ${I()}]`,i,...o))}critical(i,...o){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,i,...o):console.error(`[main ${I()}]`,i,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class r extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...o){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",i,...o)}debug(i,...o){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...o)}info(i,...o){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",i,...o)}warn(i,...o){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",i,...o)}error(i,...o){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",i,...o)}critical(i,...o){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...o)}dispose(){}flush(){}}e.ConsoleLogger=r;class d extends P{constructor(i,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(o)}trace(i,...o){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(i),...o])}debug(i,...o){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(i),...o])}info(i,...o){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(i),...o])}warn(i,...o){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(i),...o])}error(i,...o){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(i),...o])}critical(i,...o){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(i),...o])}extractMessage(i){return typeof i=="string"?i:(0,h.toErrorMessage)(i,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class a extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const o of this.logServices)o.setLevel(i);super.setLevel(i)}trace(i,...o){for(const u of this.logServices)u.trace(i,...o)}debug(i,...o){for(const u of this.logServices)u.debug(i,...o)}info(i,...o){for(const u of this.logServices)u.info(i,...o)}warn(i,...o){for(const u of this.logServices)u.warn(i,...o)}error(i,...o){for(const u of this.logServices)u.error(i,...o)}critical(i,...o){for(const u of this.logServices)u.critical(i,...o)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=a;class l extends E.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...o){this.logger.trace(i,...o)}debug(i,...o){this.logger.debug(i,...o)}info(i,...o){this.logger.info(i,...o)}warn(i,...o){this.logger.warn(i,...o)}error(i,...o){this.logger.error(i,...o)}critical(i,...o){this.logger.critical(i,...o)}flush(){this.logger.flush()}}e.LogService=l;class p extends E.Disposable{constructor(i,o){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(u=>{this.logLevel=u,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(u))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,o){let u=this.loggers.get(i.toString());return u||(u=this.doCreateLogger(i,o?.always?D.Trace:this.logLevel,o),this.loggers.set(i.toString(),u),o?.always||this.logLevelChangeableLoggers.push(u)),u}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class v{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(i){}getLevel(){return D.Info}trace(i,...o){}debug(i,...o){}info(i,...o){}warn(i,...o){}error(i,...o){}critical(i,...o){}dispose(){}flush(){}}e.NullLogService=v;function k(y){if(y.verbose)return D.Trace;if(typeof y.logLevel=="string"){const i=c(y.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=k;function c(y){switch(y){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=c;function w(y){switch(y){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=w}),define(Ee[81],_e([0,1,35,121,4]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(a,l){return l-a}D.compare=P;const t=Object.create(null);t[D.Error]=(0,F.localize)(0,null),t[D.Warning]=(0,F.localize)(1,null),t[D.Info]=(0,F.localize)(2,null);function S(a){return t[a]||""}D.toString=S;function r(a){switch(a){case h.default.Error:return D.Error;case h.default.Warning:return D.Warning;case h.default.Info:return D.Info;case h.default.Ignore:return D.Hint}}D.fromSeverity=r;function d(a){switch(a){case D.Error:return h.default.Error;case D.Warning:return h.default.Warning;case D.Info:return h.default.Info;case D.Hint:return h.default.Ignore}}D.toSeverity=d}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(D){const P="";function t(r){return S(r,!0)}D.makeKey=t;function S(r,d){let a=[P];return r.source?a.push(r.source.replace("\xA6","\\\xA6")):a.push(P),r.code?typeof r.code=="string"?a.push(r.code.replace("\xA6","\\\xA6")):a.push(r.code.value.replace("\xA6","\\\xA6")):a.push(P),r.severity!==void 0&&r.severity!==null?a.push(A.toString(r.severity)):a.push(P),r.message&&d?a.push(r.message.replace("\xA6","\\\xA6")):a.push(P),r.startLineNumber!==void 0&&r.startLineNumber!==null?a.push(r.startLineNumber.toString()):a.push(P),r.startColumn!==void 0&&r.startColumn!==null?a.push(r.startColumn.toString()):a.push(P),r.endLineNumber!==void 0&&r.endLineNumber!==null?a.push(r.endLineNumber.toString()):a.push(P),r.endColumn!==void 0&&r.endColumn!==null?a.push(r.endColumn.toString()):a.push(P),a.push(P),a.join("\xA6")}D.makeKeyOptionalMessage=S})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(Ee[144],_e([0,1,3,35,4]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,E.createDecorator)("notificationService");var T;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new D,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=I;class D{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=D}),define(Ee[145],_e([0,1,7,9,2,4]),function(te,e,h,F,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return h.Disposable.None},registerValidator(){return h.Disposable.None},registerExternalUriResolver(){return h.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return h.Disposable.None},async open(){return!1},async resolveExternalUri(I){return{resolved:I,dispose(){}}}});function A(I,D){return E.URI.isUri(I)?(0,F.equalsIgnoreCase)(I.scheme,D):(0,F.startsWithIgnoreCase)(I,D+":")}e.matchesScheme=A});var We=this&&this.__decorate||function(te,e,h,F){var E=arguments.length,T=E<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,h):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(te,e,h,F);else for(var I=te.length-1;I>=0;I--)(A=te[I])&&(T=(E<3?A(T):E>3?A(e,h,T):A(e,h))||T);return E>3&&T&&Object.defineProperty(e,h,T),T},ze=this&&this.__param||function(te,e){return function(h,F){e(h,F,te)}};define(Ee[146],_e([0,1,13,21,7,4]),function(te,e,h,F,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var A;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(S){this.callback=S}get value(){return this._value}report(S){this._value=S,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let D=class extends E.Disposable{constructor(S,r){super();this.deferred=new h.DeferredPromise,r.withProgress(S,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(S){this.reporter?this.reporter.report(S):this.lastStep=S}};D=We([ze(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends E.Disposable{constructor(S){super();this.progressIndicator=S,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(S){this.stop();const r=++this.currentOperationId,d=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{r===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},S),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:r,token:d.token,stop:()=>this.doStop(r),isCurrent:()=>this.currentOperationId===r}}stop(){this.doStop(this.currentOperationId)}doStop(S){this.currentOperationId===S&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(Ee[28],_e([0,1,39,10]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(A,I){h.ok(F.isString(A)),h.ok(F.isObject(I)),h.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,I)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new E}),define(Ee[82],_e([0,1,3,28]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class T{constructor(){this._onDidChangeSchema=new h.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[E(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;F.Registry.add(e.Extensions.JSONContribution,A)}),define(Ee[60],_e([0,1,3,10,118,82,28]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=A.Registry.as(T.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new h.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new h.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(k,c=!0){this.registerConfigurations([k],c)}registerConfigurations(k,c=!0){const w=[];k.forEach(y=>{w.push(...this.validateAndRegisterProperties(y,c,y.extensionInfo)),this.configurationContributors.push(y),this.registerJSONConfiguration(y)}),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}deregisterConfigurations(k){const c=[],w=y=>{if(y.properties)for(const i in y.properties)c.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,y.properties[i]);y.allOf&&y.allOf.forEach(i=>w(i))};for(const y of k){w(y);const i=this.configurationContributors.indexOf(y);i!==-1&&this.configurationContributors.splice(i,1)}P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}registerDefaultConfigurations(k){const c=[],w=[];for(const y of k)for(const i in y)if(c.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...y[i]};const o={type:"object",default:this.defaultValues[i],description:E.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};w.push(r(i)),this.configurationProperties[i]=o,this.defaultLanguageConfigurationOverridesNode.properties[i]=o}else{this.defaultValues[i]=y[i];const o=this.configurationProperties[i];o&&(this.updatePropertyDefaultValue(i,o),this.updateSchema(i,o))}this.registerOverrideIdentifiers(w),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(k){const c=[];for(const w of k)for(const y in w)if(c.push(y),delete this.defaultValues[y],e.OVERRIDE_PROPERTY_PATTERN.test(y))delete this.configurationProperties[y],delete this.defaultLanguageConfigurationOverridesNode.properties[y];else{const i=this.configurationProperties[y];i&&(this.updatePropertyDefaultValue(y,i),this.updateSchema(y,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...k){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(k){for(const c of k)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(k,c=!0,w,y=3){y=F.isUndefinedOrNull(k.scope)?y:k.scope;let i=[],o=k.properties;if(o)for(let s in o){if(c&&l(s)){delete o[s];continue}const f=o[s];if(this.updatePropertyDefaultValue(s,f),e.OVERRIDE_PROPERTY_PATTERN.test(s)?f.scope=void 0:(f.scope=F.isUndefinedOrNull(f.scope)?y:f.scope,f.restricted=F.isUndefinedOrNull(f.restricted)?!!w?.restrictedConfigurations?.includes(s):f.restricted),o[s].hasOwnProperty("included")&&!o[s].included){this.excludedConfigurationProperties[s]=o[s],delete o[s];continue}else this.configurationProperties[s]=o[s];!o[s].deprecationMessage&&o[s].markdownDeprecationMessage&&(o[s].deprecationMessage=o[s].markdownDeprecationMessage),i.push(s)}let u=k.allOf;if(u)for(let s of u)i.push(...this.validateAndRegisterProperties(s,c,w,y));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(k){const c=w=>{let y=w.properties;if(y)for(const o in y)this.updateSchema(o,y[o]);let i=w.allOf;i&&i.forEach(c)};c(k)}updateSchema(k,c){switch(e.allSettings.properties[k]=c,c.scope){case 1:e.applicationSettings.properties[k]=c;break;case 2:e.machineSettings.properties[k]=c;break;case 6:e.machineOverridableSettings.properties[k]=c;break;case 3:e.windowSettings.properties[k]=c;break;case 4:e.resourceSettings.properties[k]=c;break;case 5:e.resourceSettings.properties[k]=c,this.resourceLanguageSettingsSchema.properties[k]=c;break}}removeFromSchema(k,c){switch(delete e.allSettings.properties[k],c.scope){case 1:delete e.applicationSettings.properties[k];break;case 2:delete e.machineSettings.properties[k];break;case 6:delete e.machineOverridableSettings.properties[k];break;case 3:delete e.windowSettings.properties[k];break;case 4:case 5:delete e.resourceSettings.properties[k];break}}updateOverridePropertyPatternKey(){for(const k of this.overrideIdentifiers.values()){const c=`[${k}]`,w={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,w),e.allSettings.properties[c]=w,e.applicationSettings.properties[c]=w,e.machineSettings.properties[c]=w,e.machineOverridableSettings.properties[c]=w,e.windowSettings.properties[c]=w,e.resourceSettings.properties[c]=w}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(k,c){let w=this.defaultValues[k];F.isUndefined(w)&&(w=c.default),F.isUndefined(w)&&(w=d(c.type)),c.default=w}}const S="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(S);function r(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=r;function d(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const a=new t;A.Registry.add(e.Extensions.Configuration,a);function l(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?E.localize(5,null,v):a.getConfigurationProperties()[v]!==void 0?E.localize(6,null,v):null:E.localize(4,null)}e.validateProperty=l;function p(){const v=[],k=a.getConfigurationProperties();for(const c of Object.keys(k))v.push([c,k[c].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=p}),define(Ee[83],_e([0,1,22,10,2,60,4,28]),function(te,e,h,F,E,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function D(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof E.URI)}e.isConfigurationOverrides=D;var P;(function(o){o[o.USER=1]="USER",o[o.USER_LOCAL=2]="USER_LOCAL",o[o.USER_REMOTE=3]="USER_REMOTE",o[o.WORKSPACE=4]="WORKSPACE",o[o.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",o[o.DEFAULT=6]="DEFAULT",o[o.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(o){switch(o){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function S(o,u){const s=u?o?u.keys.filter(_=>o.keys.indexOf(_)===-1):[...u.keys]:[],f=o?u?o.keys.filter(_=>u.keys.indexOf(_)===-1):[...o.keys]:[],m=[];if(u&&o){for(const _ of o.keys)if(u.keys.indexOf(_)!==-1){const R=v(o.contents,_),U=v(u.contents,_);h.equals(R,U)||m.push(_)}}const g=[],b=_=>{const R={};for(const U of _)for(const V of U.identifiers)R[y(V)]=U;return R},C=u?b(u.overrides):{},n=o?b(o.overrides):{};if(Object.keys(C).length)for(const _ of s){const R=C[_];R&&g.push([(0,T.overrideIdentifierFromKey)(_),R.keys])}if(Object.keys(n).length)for(const _ of f){const R=n[_];R&&g.push([(0,T.overrideIdentifierFromKey)(_),R.keys])}if(Object.keys(C).length&&Object.keys(n).length)for(const _ of m){const R=n[_],U=C[_];if(R&&U){const V=S({contents:R.contents,keys:R.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});g.push([(0,T.overrideIdentifierFromKey)(_),[...V.added,...V.removed,...V.updated]])}}return{added:s,removed:f,updated:m,overrides:g}}e.compare=S;function r(o,u){const s=[];for(const f of Object.keys(o))if(T.OVERRIDE_PROPERTY_PATTERN.test(f)){const m={};for(const g in o[f])m[g]=o[f][g];s.push({identifiers:[(0,T.overrideIdentifierFromKey)(f).trim()],keys:Object.keys(m),contents:d(m,u)})}return s}e.toOverrides=r;function d(o,u){const s=Object.create(null);for(let f in o)a(s,f,o[f],u);return s}e.toValuesTree=d;function a(o,u,s,f){const m=u.split("."),g=m.pop();let b=o;for(let C=0;C<m.length;C++){let n=m[C],_=b[n];switch(typeof _){case"undefined":_=b[n]=Object.create(null);break;case"object":break;default:f(`Ignoring ${u} as ${m.slice(0,C+1).join(".")} is ${JSON.stringify(_)}`);return}b=_}if(typeof b=="object"&&b!==null)try{b[g]=s}catch(C){f(`Ignoring ${u} as ${m.join(".")} is ${JSON.stringify(b)}`)}else f(`Ignoring ${u} as ${m.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=a;function l(o,u){const s=u.split(".");p(o,s)}e.removeFromValueTree=l;function p(o,u){const s=u.shift();if(u.length===0){delete o[s];return}if(Object.keys(o).indexOf(s)!==-1){const f=o[s];typeof f=="object"&&!Array.isArray(f)&&(p(f,u),Object.keys(f).length===0&&delete o[s])}}function v(o,u,s){function f(b,C){let n=b;for(const _ of C){if(typeof n!="object"||n===null)return;n=n[_]}return n}const m=u.split("."),g=f(o,m);return typeof g=="undefined"?s:g}e.getConfigurationValue=v;function k(o,u,s){Object.keys(u).forEach(f=>{f!=="__proto__"&&(f in o?F.isObject(o[f])&&F.isObject(u[f])?k(o[f],u[f],s):s&&(o[f]=u[f]):o[f]=u[f])})}e.merge=k;function c(){const o=I.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(o)}e.getConfigurationKeys=c;function w(){const o=Object.create(null),u=I.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let s in u){let f=u[s].default;a(o,s,f,m=>console.error(`Conflict in default settings: ${m}`))}return o}e.getDefaultValues=w;function y(o){return`[${o}]`}e.keyFromOverrideIdentifier=y;function i(o,u,s){const f=o.inspect(u),m=o.inspect(s);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:f.defaultValue}e.getMigratedSettingValue=i}),define(Ee[147],_e([0,1,16,3,102,7,20,22,10,2,83,60,28]),function(te,e,h,F,E,T,A,I,D,P,t,S,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(i={},o=[],u=[]){this._contents=i,this._keys=o,this._overrides=u,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,o){const u=this.getContentsForOverrideIdentifer(o);return u?i?(0,t.getConfigurationValue)(u,i):u:void 0}getKeysForOverrideIdentifier(i){for(const o of this.overrides)if(o.identifiers.indexOf(i)!==-1)return o.keys;return[]}override(i){const o=this.getContentsForOverrideIdentifer(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;let u={};for(const s of h.distinct([...Object.keys(this.contents),...Object.keys(o)])){let f=this.contents[s],m=o[s];m&&(typeof f=="object"&&typeof m=="object"?(f=I.deepClone(f),this.mergeContents(f,m)):f=m),u[s]=f}return new d(u,this.keys,this.overrides)}merge(...i){const o=I.deepClone(this.contents),u=I.deepClone(this.overrides),s=[...this.keys];for(const f of i){this.mergeContents(o,f.contents);for(const m of f.overrides){const[g]=u.filter(b=>h.equals(b.identifiers,m.identifiers));g?this.mergeContents(g.contents,m.contents):u.push(I.deepClone(m))}for(const m of f.keys)s.indexOf(m)===-1&&s.push(m)}return new d(o,s,u)}freeze(){return this.isFrozen=!0,this}mergeContents(i,o){for(const u of Object.keys(o)){if(u in i&&D.isObject(i[u])&&D.isObject(o[u])){this.mergeContents(i[u],o[u]);continue}i[u]=I.deepClone(o[u])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const o of this.overrides)if(o.identifiers.indexOf(i)!==-1)return o.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,o){this.addKey(i),(0,t.addToValueTree)(this.contents,i,o,u=>{throw new Error(u)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let o=this.keys.length;for(let u=0;u<o;u++)i.indexOf(this.keys[u])===0&&(o=u);this.keys.splice(o,1,i)}removeKey(i){let o=this.keys.indexOf(i);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=d;class a extends d{constructor(){const i=(0,t.getDefaultValues)(),o=(0,t.getConfigurationKeys)(),u=[];for(const s of Object.keys(i))S.OVERRIDE_PROPERTY_PATTERN.test(s)&&u.push({identifiers:[(0,S.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],f=>console.error(`Conflict in default settings file: ${f}`))});super(i,o,u)}}e.DefaultConfigurationModel=a;class l{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,o){if(!D.isUndefinedOrNull(i)){const u=this.doParseContent(i);this.parseRaw(u,o)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,o){this._raw=i;const{contents:u,keys:s,overrides:f,restricted:m}=this.doParseRaw(i,o);this._configurationModel=new d(u,s,f),this._restrictedConfigurations=m||[]}doParseContent(i){let o={},u=null,s=[],f=[],m=[];function g(C){Array.isArray(s)?s.push(C):u!==null&&(s[u]=C)}let b={onObjectBegin:()=>{let C={};g(C),f.push(s),s=C,u=null},onObjectProperty:C=>{u=C},onObjectEnd:()=>{s=f.pop()},onArrayBegin:()=>{let C=[];g(C),f.push(s),s=C,u=null},onArrayEnd:()=>{s=f.pop()},onLiteralValue:g,onError:(C,n,_)=>{m.push({error:C,offset:n,length:_})}};if(i)try{E.visit(i,b),o=s[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return o}doParseRaw(i,o){const u=r.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,u,!0,o);i=s.raw;const f=(0,t.toValuesTree)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),m=Object.keys(i),g=(0,t.toOverrides)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:f,keys:m,overrides:g,restricted:s.restricted}}filter(i,o,u,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const f={},m=[];for(let g in i)if(S.OVERRIDE_PROPERTY_PATTERN.test(g)&&u){const b=this.filter(i[g],o,!1,s);f[g]=b.raw,m.push(...b.restricted)}else{const b=o[g],C=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&m.push(g),(C===void 0||s.scopes===void 0||s.scopes.includes(C))&&(s.skipRestricted&&b?.restricted||(f[g]=i[g]))}return{raw:f,restricted:m}}}e.ConfigurationModelParser=l;class p extends T.Disposable{constructor(i,o,u,s){super();this.userSettingsResource=i,this.scopes=o,this.fileService=s,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class v{constructor(i,o,u=new d,s=new d,f=new A.ResourceMap,m=new d,g=new A.ResourceMap,b=!0){this._defaultConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=u,this._workspaceConfiguration=s,this._folderConfigurations=f,this._memoryConfiguration=m,this._memoryConfigurationByResource=g,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(i,o,u){return this.getConsolidateConfigurationModel(o,u).getValue(i)}updateValue(i,o,u={}){let s;u.resource?(s=this._memoryConfigurationByResource.get(u.resource),s||(s=new d,this._memoryConfigurationByResource.set(u.resource,s))):s=this._memoryConfiguration,o===void 0?s.removeValue(i):s.setValue(i,o),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,o,u){const s=this.getConsolidateConfigurationModel(o,u),f=this.getFolderConfigurationModelForResource(o.resource,u),m=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,g=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),b=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),C=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),n=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),_=u?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,R=f?o.overrideIdentifier?f.freeze().override(o.overrideIdentifier).getValue(i):f.freeze().getValue(i):void 0,U=o.overrideIdentifier?m.override(o.overrideIdentifier).getValue(i):m.getValue(i),V=s.getValue(i),le=h.distinct(h.flatten(s.overrides.map(he=>he.identifiers))).filter(he=>s.getOverrideValue(i,he)!==void 0);return{defaultValue:g,userValue:b,userLocalValue:C,userRemoteValue:n,workspaceValue:_,workspaceFolderValue:R,memoryValue:U,value:V,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userLocal:C!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userRemote:n!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:f?.freeze().getValue(i),override:o.overrideIdentifier?f?.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:m.getValue(i),override:o.overrideIdentifier?m.getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:le.length?le:void 0}}keys(i){const o=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,o){this._folderConfigurations.set(i,o),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const u=o.filter(s=>S.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const f=(0,S.overrideIdentifierFromKey)(s),m=this._defaultConfiguration.getKeysForOverrideIdentifier(f),g=i.getKeysForOverrideIdentifier(f),b=[...g.filter(C=>m.indexOf(C)===-1),...m.filter(C=>g.indexOf(C)===-1),...m.filter(C=>!I.equals(this._defaultConfiguration.override(f).getValue(C),i.override(f).getValue(C)))];return[f,b]});return this.updateDefaultConfiguration(i),{keys:o,overrides:u}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:u,removed:s,overrides:f}=(0,t.compare)(this.localUserConfiguration,i),m=[...o,...u,...s];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:f}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:u,removed:s,overrides:f}=(0,t.compare)(this.remoteUserConfiguration,i);let m=[...o,...u,...s];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:f}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:u,removed:s,overrides:f}=(0,t.compare)(this.workspaceConfiguration,i);let m=[...o,...u,...s];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:f}}compareAndUpdateFolderConfiguration(i,o){const u=this.folderConfigurations.get(i),{added:s,updated:f,removed:m,overrides:g}=(0,t.compare)(u,o);let b=[...s,...f,...m];return(b.length||!u)&&this.updateFolderConfiguration(i,o),{keys:b,overrides:g}}compareAndDeleteFolderConfiguration(i){const o=this.folderConfigurations.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:u,updated:s,removed:f,overrides:m}=(0,t.compare)(o,void 0);return{keys:[...u,...s,...f],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,o){let u=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier?u.override(i.overrideIdentifier):u}getConsolidatedConfigurationModelForResource({resource:i},o){let u=this.getWorkspaceConsolidatedConfiguration();if(o&&i){const s=o.getFolder(i);s&&(u=this.getFolderConsolidatedConfiguration(s.uri)||u);const f=this._memoryConfigurationByResource.get(i);f&&(u=u.merge(f))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let o=this._foldersConsolidatedConfigurations.get(i);if(!o){const u=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(o=u.merge(s),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(i,o)):o=u}return o}getFolderConfigurationModelForResource(i,o){if(o&&i){const u=o.getFolder(i);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,o)=>{const{contents:u,overrides:s,keys:f}=this._folderConfigurations.get(o);return i.push([o,{contents:u,overrides:s,keys:f}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>i.add(o)),this.userConfiguration.freeze().keys.forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(u=>i.add(u))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>o.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>o.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>o.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(i).forEach(s=>o.add(s))),[...o.values()]}static parse(i){const o=this.parseConfigurationModel(i.defaults),u=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),f=i.folders.reduce((m,g)=>(m.set(P.URI.revive(g[0]),this.parseConfigurationModel(g[1])),m),new A.ResourceMap);return new v(o,u,new d,s,f,new d,new A.ResourceMap,!1)}static parseConfigurationModel(i){return new d(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=v;function k(...y){if(y.length===0)return{keys:[],overrides:[]};if(y.length===1)return y[0];const i=new Set,o=new Map;for(const s of y)s.keys.forEach(f=>i.add(f)),s.overrides.forEach(([f,m])=>{const g=(0,A.getOrSet)(o,f,new Set);m.forEach(b=>g.add(b))});const u=[];return o.forEach((s,f)=>u.push([f,[...s.values()]])),{keys:[...i.values()],overrides:u}}e.mergeChanges=k;class c{constructor(i,o,u,s){this.change=i,this.previous=o,this.currentConfiguraiton=u,this.currentWorkspace=s,this._previousConfiguration=void 0;const f=new Set;i.keys.forEach(g=>f.add(g)),i.overrides.forEach(([,g])=>g.forEach(b=>f.add(b))),this.affectedKeys=[...f.values()];const m=new d;this.affectedKeys.forEach(g=>m.setValue(g,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(o){const u=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,o,this.currentWorkspace);return!I.equals(u,s)}return!0}return!1}doesAffectedKeysTreeContains(i,o){let u=(0,t.toValuesTree)({[o]:!0},()=>{}),s;for(;typeof u=="object"&&(s=Object.keys(u)[0]);){if(i=i[s],!i)return!1;u=u[s]}return!0}}e.ConfigurationChangeEvent=c;class w extends c{constructor(i,o,u,s){super({keys:i.allKeys(),overrides:[]},void 0,i,o);this.source=u,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=w}),define(Ee[84],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,h.createDecorator)("remoteAuthorityResolverService");var F;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(A,I=F.Unknown,D){super(A);this._message=A,this._code=I,this._detail=D,this.isHandled=I===F.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(A){return A instanceof E&&A._code===F.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof E&&A._code===F.NoResolverFound}static isHandled(A){return A instanceof E&&A.isHandled}}e.RemoteAuthorityResolverError=E}),define(Ee[85],_e([0,1,11]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(P){return P.scheme===h.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=F;function E(P){if(!P)return;const t=P.indexOf("+");return t<0?P:P.substr(0,t)}e.getRemoteName=E;function T(P){return P.scheme!==h.Schemas.file&&P.scheme!==h.Schemas.vscodeRemote}e.isVirtualResource=T;function A(P){if(P.folders.length)return P.folders.every(t=>T(t.uri))?P.folders[0].uri:void 0;if(P.configuration&&T(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=A;function I(P){return A(P)?.scheme}e.getVirtualWorkspaceScheme=I;function D(P){return A(P)!==void 0}e.isVirtualWorkspace=D}),define(Ee[148],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,T,A=5){let I;return I=T(D=>{const P=typeof D=="string"?D:D.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(P);return}const S=setTimeout(()=>this.flushBuffer(E),A);t={data:[P],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(E),I.dispose()}},this._terminalBufferMap.set(E,t)}),I}stopBuffering(E){const T=this._terminalBufferMap.get(E);T&&T.dispose()}flushBuffer(E){const T=this._terminalBufferMap.get(E);T&&(this._terminalBufferMap.delete(E),this._callback(E,T.data.join("")))}}e.TerminalDataBufferer=h}),define(Ee[149],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var h;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(h=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[43],_e([0,1,34,3,7,4,28,149]),function(te,e,h,F,E,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var D;(function(p){function v(k){return k&&typeof k=="object"&&typeof k.id=="string"}p.isThemeColor=v})(D=e.ThemeColor||(e.ThemeColor={}));function P(p){return{id:p}}e.themeColorFromId=P;var t;(function(p){function v(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||D.isThemeColor(o.color))}p.isThemeIcon=v;const k=new RegExp(`^\\$\\((${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?)\\)$`);function c(o){const u=k.exec(o);if(!u)return;let[,s]=u;return{id:s}}p.fromString=c;function w(o,u){let s=o.id;const f=s.lastIndexOf("~");return f!==-1&&(s=s.substring(0,f)),u&&(s=`${s}~${u}`),{id:s}}p.modify=w;function y(o,u){return o.id===u.id&&o.color?.id===u.color?.id}p.isEqual=y;function i(o,u){return{id:o.id,color:u?P(u):void 0}}p.asThemeIcon=i,p.asClassNameArray=h.CSSIcon.asClassNameArray,p.asClassName=h.CSSIcon.asClassName,p.asCSSSelector=h.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=h.Codicon.file,e.FolderThemeIcon=h.Codicon.folder;function S(p){switch(p){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class r{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,E.toDisposable)(()=>{const k=this.themingParticipants.indexOf(v);this.themingParticipants.splice(k,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new r;A.Registry.add(e.Extensions.ThemingContribution,d);function a(p){return d.onColorThemeChange(p)}e.registerThemingParticipant=a;class l extends E.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(k=>this.onThemeChange(k)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,k){let c=this.theme.getColor(v);return c&&k&&(c=k(c,this.theme)),c?c.toString():null}}e.Themable=l}),define(Ee[150],_e([0,1,13,34,3,122,82,28,43]),function(te,e,h,F,E,T,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${F.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,k,c,w){const y=this.iconsById[v];if(y){if(c&&!y.description){y.description=c,this.iconSchema.properties[v].markdownDescription=`${c} $(${v})`;const u=this.iconReferenceSchema.enum.indexOf(v);u!==-1&&(this.iconReferenceSchema.enumDescriptions[u]=c),this._onDidChange.fire()}return y}let i={id:v,description:c,defaults:k,deprecationMessage:w};this.iconsById[v]=i;let o={$ref:"#/definitions/icons"};return w&&(o.deprecationMessage=w),c&&(o.markdownDescription=`${c}: $(${v})`),this.iconSchema.properties[v]=o,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const k=this.iconReferenceSchema.enum.indexOf(v);k!==-1&&(this.iconReferenceSchema.enum.splice(k,1),this.iconReferenceSchema.enumDescriptions.splice(k,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,k){const c=this.iconFontsById[v];if(c)return c;let w={id:v,definition:k};return this.iconFontsById[v]=w,this._onDidChange.fire(),w}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFonts(){return Object.keys(this.iconFontsById).map(v=>this.iconFontsById[v])}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(y,i)=>y.id.localeCompare(i.id),k=y=>{for(;D.ThemeIcon.isThemeIcon(y.defaults);)y=this.iconsById[y.defaults.id];return`codicon codicon-${y?y.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const w=Object.keys(this.iconsById).map(y=>this.iconsById[y]);for(const y of w.filter(i=>!!i.description).sort(v))c.push(`|<i class="${k(y)}"></i>|${y.id}|${D.ThemeIcon.isThemeIcon(y.defaults)?y.defaults.id:y.id}|${y.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const y of w.filter(i=>!D.ThemeIcon.isThemeIcon(i.defaults)).sort(v))c.push(`|<i class="${k(y)}"></i>|${y.id}|`);return c.join(`
`)}}const t=new P;I.Registry.add(e.Extensions.IconContribution,t);function S(p,v,k,c){return t.registerIcon(p,v,k,c)}e.registerIcon=S;function r(){return t}e.getIconRegistry=r;function d(){for(const p of F.iconRegistry.all)t.registerIcon(p.id,p.definition,p.description);F.iconRegistry.onDidRegister(p=>t.registerIcon(p.id,p.definition,p.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let a=I.Registry.as(A.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,t.getIconSchema());const l=new h.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.widgetClose=S("widget-close",F.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=S("goto-previous-location",F.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=S("goto-next-location",F.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=D.ThemeIcon.modify(F.Codicon.sync,"spin")}),define(Ee[44],_e([0,1,20,24,2,4]),function(te,e,h,F,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var A;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function I(r){const d=r;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=I;function D(r){const d=r;return!!(d&&typeof d=="object"&&E.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(d,a,l,p){this._id=d,this._configuration=l,this._ignorePathCasing=p,this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class t{constructor(d,a){this.raw=a,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,F.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function S(r){return new t({uri:r,index:0,name:(0,F.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=S}),define(Ee[61],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class h{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const T=this._idPool++;return this._data.set(T,E),this.logDebugInfo(),T}get(E,T){return this._data.has(E)?this._data.get(E)[T]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!h.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=h,h.enableDebugLogging=!1}),define(Ee[62],_e([0,1,2,3,4]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,E.createDecorator)("IExtHostEditorTabs");class T{constructor(){this._onDidChangeTabs=new F.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(I){this._tabs=I.map(D=>({name:D.name,group:D.group,resource:h.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(Ee[45],_e([0,1,11,4]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class E{constructor(){this._systemSchemes=new Set(Object.keys(h.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,I){I===null?this._providerInfo.delete(A):this._providerInfo.set(A,I)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=E,e.IExtHostFileSystemInfo=(0,F.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[29],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,h.createDecorator)("IExtHostInitDataService")}),define(Ee[151],_e([0,1,13]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(A,I,D){this._deferredPromises=new Map,this._id=A,this._shared=I,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new h.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of P.values())t.complete()}catch(t){for(const S of P.values())S.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,I){let D=this._value[A];return typeof D=="undefined"&&(D=I),D}update(A,I){this._value[A]=I;let D=this._deferredPromises.get(A);if(D!==void 0)return D.p;const P=new h.DeferredPromise;return this._deferredPromises.set(A,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class E extends F{constructor(A,I){super(A.identifier.value,!0,I);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=E}),define(Ee[152],_e([0,1,3,2,14]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(I,D){this._logService=I,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new h.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new h.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,D,P){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I)).acceptModelChanged(D,P)}$acceptDirtyStateChanged(I,D){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I)).acceptDirty(D)}$acceptModelSaved(I){const D=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(I,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,D);const P=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I));P.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};T=We([ze(0,E.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(Ee[12],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,h.createDecorator)("IExtHostRpcService");class F{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=F});var Ze=this&&this.__classPrivateFieldSet||function(te,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!E:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(te,h):E?E.value=h:e.set(te,h),h},Oe=this&&this.__classPrivateFieldGet||function(te,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!F:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(te):F?F.value:e.get(te)};define(Ee[153],_e([0,1,25,3]),function(te,e,h,F){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(I,D){E.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=h.ExtensionIdentifier.toKey(I.identifier),Ze(this,E,D,"f"),Oe(this,E,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(I){return Oe(this,E,"f").get(this._id,I)}store(I,D){return Oe(this,E,"f").store(this._id,I,D)}delete(I){return Oe(this,E,"f").delete(this._id,I)}}e.ExtensionSecrets=T,E=new WeakMap}),define(Ee[86],_e([0,1,4,3]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,h.createDecorator)("IExtHostTelemetry")}),define(Ee[63],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var h;(function(k){k[k.Upsert=0]="Upsert",k[k.RemoveChild=1]="RemoveChild",k[k.Invalidated=2]="Invalidated",k[k.SetProp=3]="SetProp",k[k.Bulk=4]="Bulk"})(h=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,E=(k,c)=>{const w={controllerId:c};return F.set(k,w),w};e.createPrivateApiFor=E;const T=k=>F.get(k);e.getPrivateApiFor=T;const A=(k,c,w,y)=>{let i=w;return{enumerable:!0,configurable:!1,get(){return i},set(o){y(i,o)||(i=o,k.listener?.({op:3,key:c,value:o}))}}},I=(k,c)=>k===c,D={range:(k,c)=>k===c?!0:!k||!c?!1:k.isEqual(c),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(k,c)=>!(k.length!==c.length||k.some(w=>!c.find(y=>w.id===y.id)))},P=Object.keys(D),t=(k,c)=>({range:A(k,"range",void 0,D.range),label:A(k,"label",c,D.label),description:A(k,"description",void 0,D.description),canResolveChildren:A(k,"canResolveChildren",!1,D.canResolveChildren),busy:A(k,"busy",!1,D.busy),error:A(k,"error",void 0,D.error),tags:A(k,"tags",[],D.tags)}),S=(k,c)=>{const w=new Map;for(const y of P)D[y](k[y],c[y])||w.set(y,c[y]);return w};e.diffTestItems=S;class r extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=r;class d extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class a extends Error{constructor(c,w,y){super(`TestItem with ID "${c}" is from controller "${w}" and cannot be added as a child of an item from controller "${y}".`)}}e.MixedTestItemController=a;const l=k=>{const c=(0,e.getPrivateApiFor)(k);let w=new Map;return{get size(){return w.size},forEach(y,i){for(const o of w.values())y.call(i,o,this)},replace(y){const i=new Map,o=new Set(w.keys()),u={op:4,ops:[]};for(const s of y){if(!(s instanceof p))throw new d(s.id);const f=(0,e.getPrivateApiFor)(s).controllerId;if(f!==c.controllerId)throw new a(s.id,f,c.controllerId);if(i.has(s.id))throw new r(s.id);i.set(s.id,s),o.delete(s.id),u.ops.push({op:0,item:s})}for(const s of o.keys())u.ops.push({op:1,id:s});c.listener?.(u),w=i},add(y){if(!(y instanceof p))throw new d(y.id);w.set(y.id,y),c.listener?.({op:0,item:y})},delete(y){w.delete(y)&&c.listener?.({op:1,id:y})},get(y){return w.get(y)},toJSON(){return Array.from(w.values())},[Symbol.iterator](){return w.values()}}};class p{constructor(c,w,y,i){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const o=(0,e.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof v?void 0:o.parent}},children:{value:l(this),enumerable:!0,writable:!1},...t(o,y)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class v extends p{constructor(c,w){super(c,c,w,void 0)}}e.TestItemRootImpl=v}),define(Ee[64],_e([0,1,4,3,12]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(I){function D(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}I.fromApiTunnel=D;function P(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}I.fromServiceTunnel=P})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,h.createDecorator)("IExtHostTunnelService");let A=class{constructor(D){this.onDidChangeTunnels=new F.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,P){return{dispose:()=>{}}}async $providePortAttributes(D,P,t,S,r){return[]}async $forwardPort(D,P){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=We([ze(0,E.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var Ze=this&&this.__classPrivateFieldSet||function(te,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!E:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(te,h):E?E.value=h:e.set(te,h),h},Oe=this&&this.__classPrivateFieldGet||function(te,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!F:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(te):F?F.value:e.get(te)};define(Ee[6],_e([0,1,16,15,75,20,77,10,2,36,58,84]),function(te,e,h,F,E,T,A,I,D,P,t,S){"use strict";var r,d,a,l,p,v,k,c,w,y,i,o,u,s,f,m,g,b,C,n;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(O){function M(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(M,O),Object.setPrototypeOf(M.prototype,O.prototype),M}let R=p=class{constructor(M){r.set(this,void 0),Ze(this,r,M,"f")}static from(...M){let Z=M;return new p(function(){if(Z){for(const ye of Z)ye&&typeof ye.dispose=="function"&&ye.dispose();Z=void 0}})}dispose(){typeof Oe(this,r,"f")=="function"&&(Oe(this,r,"f").call(this),Ze(this,r,void 0,"f"))}};r=new WeakMap,R=p=We([_],R),e.Disposable=R;let U=v=class{constructor(M,Z){if(M<0)throw(0,F.illegalArgument)("line must be non-negative");if(Z<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=M,this._character=Z}static Min(...M){if(M.length===0)throw new TypeError;let Z=M[0];for(let ye=1;ye<M.length;ye++){const Ge=M[ye];Ge.isBefore(Z)&&(Z=Ge)}return Z}static Max(...M){if(M.length===0)throw new TypeError;let Z=M[0];for(let ye=1;ye<M.length;ye++){const Ge=M[ye];Ge.isAfter(Z)&&(Z=Ge)}return Z}static isPosition(M){if(!M)return!1;if(M instanceof v)return!0;let{line:Z,character:ye}=M;return typeof Z=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,Z=0){if(M===null||Z===null)throw(0,F.illegalArgument)();let ye;return typeof M=="undefined"?ye=0:typeof M=="number"?ye=M:(ye=typeof M.lineDelta=="number"?M.lineDelta:0,Z=typeof M.characterDelta=="number"?M.characterDelta:0),ye===0&&Z===0?this:new v(this.line+ye,this.character+Z)}with(M,Z=this.character){if(M===null||Z===null)throw(0,F.illegalArgument)();let ye;return typeof M=="undefined"?ye=this.line:typeof M=="number"?ye=M:(ye=typeof M.line=="number"?M.line:this.line,Z=typeof M.character=="number"?M.character:this.character),ye===this.line&&Z===this.character?this:new v(ye,Z)}toJSON(){return{line:this.line,character:this.character}}};U=v=We([_],U),e.Position=U;let V=k=class{constructor(M,Z,ye,Ge){let Xe,tt;if(typeof M=="number"&&typeof Z=="number"&&typeof ye=="number"&&typeof Ge=="number"?(Xe=new U(M,Z),tt=new U(ye,Ge)):M instanceof U&&Z instanceof U&&(Xe=M,tt=Z),!Xe||!tt)throw new Error("Invalid arguments");Xe.isBefore(tt)?(this._start=Xe,this._end=tt):(this._start=tt,this._end=Xe)}static isRange(M){return M instanceof k?!0:M?U.isPosition(M.start)&&U.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof k?this.contains(M._start)&&this.contains(M._end):M instanceof U?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const Z=U.Max(M.start,this._start),ye=U.Min(M.end,this._end);if(!Z.isAfter(ye))return new k(Z,ye)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const Z=U.Min(M.start,this._start),ye=U.Max(M.end,this.end);return new k(Z,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,Z=this.end){if(M===null||Z===null)throw(0,F.illegalArgument)();let ye;return M?U.isPosition(M)?ye=M:(ye=M.start||this.start,Z=M.end||this.end):ye=this.start,ye.isEqual(this._start)&&Z.isEqual(this.end)?this:new k(ye,Z)}toJSON(){return[this.start,this.end]}};V=k=We([_],V),e.Range=V;let le=c=class extends V{constructor(M,Z,ye,Ge){let Xe,tt;if(typeof M=="number"&&typeof Z=="number"&&typeof ye=="number"&&typeof Ge=="number"?(Xe=new U(M,Z),tt=new U(ye,Ge)):M instanceof U&&Z instanceof U&&(Xe=M,tt=Z),!Xe||!tt)throw new Error("Invalid arguments");super(Xe,tt);this._anchor=Xe,this._active=tt}static isSelection(M){return M instanceof c?!0:M?V.isRange(M)&&U.isPosition(M.anchor)&&U.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};le=c=We([_],le),e.Selection=le;class he{constructor(M,Z,ye){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,F.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,F.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(Z),this.connectionToken=ye}}e.ResolvedAuthority=he;class j extends Error{constructor(M,Z=S.RemoteAuthorityResolverErrorCode.Unknown,ye){super(M);this._message=M,this._code=Z,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,j.prototype)}static NotAvailable(M,Z){return new j(M,S.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(M){return new j(M,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=j;var H;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var L;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=w=class{constructor(M,Z){this._range=M,this._newText=Z}static isTextEdit(M){return M instanceof w?!0:M?V.isRange(M)&&typeof M.newText=="string":!1}static replace(M,Z){return new w(M,Z)}static insert(M,Z){return w.replace(new V(M,M),Z)}static delete(M){return w.replace(M,"")}static setEndOfLine(M){const Z=new w(new V(new U(0,0),new U(0,0)),"");return Z.newEol=M,Z}get range(){return this._range}set range(M){if(M&&!V.isRange(M))throw(0,F.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,F.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,F.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};K=w=We([_],K),e.TextEdit=K;var x;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellReplace=5]="CellReplace"})(x=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,Z,ye,Ge){this._edits.push({_type:1,from:M,to:Z,options:ye,metadata:Ge})}createFile(M,Z,ye){this._edits.push({_type:1,from:void 0,to:M,options:Z,metadata:ye})}deleteFile(M,Z,ye){this._edits.push({_type:1,from:M,to:void 0,options:Z,metadata:ye})}replaceNotebookMetadata(M,Z,ye){this._edits.push({_type:3,metadata:ye,uri:M,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(M,Z,ye,Ge,Xe){let tt,ot,yt=[],At;if(Bt.isNotebookRange(Z)&&Ft.isNotebookCellDataArray(ye)&&!Ft.isNotebookCellDataArray(Ge)?(tt=Z.start,ot=Z.end,yt=ye,At=Ge):typeof Z=="number"&&typeof ye=="number"&&Ft.isNotebookCellDataArray(Ge)&&(tt=Z,ot=ye,yt=Ge,At=Xe),tt===void 0||ot===void 0)throw new Error("Invalid arguments");(tt!==ot||yt.length>0)&&this._edits.push({_type:5,uri:M,index:tt,count:ot-tt,cells:yt,metadata:At})}replaceNotebookCellMetadata(M,Z,ye,Ge){this._edits.push({_type:3,metadata:Ge,uri:M,edit:{editType:8,index:Z,metadata:ye}})}replace(M,Z,ye,Ge){this._edits.push({_type:2,uri:M,edit:new K(Z,ye),metadata:Ge})}insert(M,Z,ye,Ge){this.replace(M,new V(Z,Z),ye,Ge)}delete(M,Z,ye){this.replace(M,Z,"",ye)}has(M){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===M.toString())}set(M,Z){if(Z)for(const ye of Z)ye&&this._edits.push({_type:2,uri:M,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const Ge=this._edits[ye];Ge._type===2&&Ge.uri.toString()===M.toString()&&(this._edits[ye]=void 0)}(0,h.coalesceInPlace)(this._edits)}}get(M){const Z=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===M.toString()&&Z.push(ye.edit);return Z}entries(){const M=new T.ResourceMap;for(let Z of this._edits)if(Z._type===2){let ye=M.get(Z.uri);ye||(ye=[Z.uri,[]],M.set(Z.uri,ye)),ye[1].push(Z.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=We([_],Y),e.WorkspaceEdit=Y;let ce=y=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof y?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=y._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,Z=this._tabstop++){if(typeof M=="function"){const ye=new y;ye._tabstop=this._tabstop,M(ye),this._tabstop=ye._tabstop,M=ye.value}else M=y._escape(M);return this.value+="${",this.value+=Z,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,Z=this._tabstop++){const ye=M.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(M,Z){if(typeof Z=="function"){const ye=new y;ye._tabstop=this._tabstop,Z(ye),this._tabstop=ye._tabstop,Z=ye.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};ce=y=We([_],ce),e.SnippetString=ce;var z;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})(z=e.DiagnosticTag||(e.DiagnosticTag={}));var se;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})(se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let re=i=class{constructor(M,Z){if(this.uri=M,Z)if(Z instanceof V)this.range=Z;else if(Z instanceof U)this.range=new V(Z,Z);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof i?!0:M?V.isRange(M.range)&&D.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};re=i=We([_],re),e.Location=re;let we=class{constructor(M,Z){this.location=M,this.message=Z}static is(M){return M?typeof M.message=="string"&&M.location&&V.isRange(M.location.range)&&D.URI.isUri(M.location.uri):!1}static isEqual(M,Z){return M===Z?!0:!M||!Z?!1:M.message===Z.message&&M.location.range.isEqual(Z.location.range)&&M.location.uri.toString()===Z.location.uri.toString()}};we=We([_],we),e.DiagnosticRelatedInformation=we;let Re=class{constructor(M,Z,ye=se.Error){if(!V.isRange(M))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=M,this.message=Z,this.severity=ye}toJSON(){return{severity:se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,Z){return M===Z?!0:!M||!Z?!1:M.message===Z.message&&M.severity===Z.severity&&M.code===Z.code&&M.severity===Z.severity&&M.source===Z.source&&M.range.isEqual(Z.range)&&(0,h.equals)(M.tags,Z.tags)&&(0,h.equals)(M.relatedInformation,Z.relatedInformation,we.isEqual)}};Re=We([_],Re),e.Diagnostic=Re;let Fe=class{constructor(M,Z){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=Z}};Fe=We([_],Fe),e.Hover=Fe;var Ne;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(Ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Qe=class{constructor(M,Z=Ne.Text){this.range=M,this.kind=Z}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};Qe=We([_],Qe),e.DocumentHighlight=Qe;var qe;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(qe=e.SymbolKind||(e.SymbolKind={}));var Ke;(function(O){O[O.Deprecated=1]="Deprecated"})(Ke=e.SymbolTag||(e.SymbolTag={}));let N=o=class{constructor(M,Z,ye,Ge,Xe){this.name=M,this.kind=Z,this.containerName=Xe,typeof ye=="string"&&(this.containerName=ye),Ge instanceof re?this.location=Ge:ye instanceof V&&(this.location=new re(Ge,ye)),o.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:qe[this.kind],location:this.location,containerName:this.containerName}}};N=o=We([_],N),e.SymbolInformation=N;let q=u=class{constructor(M,Z,ye,Ge,Xe){this.name=M,this.detail=Z,this.kind=ye,this.range=Ge,this.selectionRange=Xe,this.children=[],u.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(u.validate)}};q=u=We([_],q),e.DocumentSymbol=q;var X;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ie=class{constructor(M,Z){this.title=M,this.kind=Z}};ie=We([_],ie),e.CodeAction=ie;let W=s=class{constructor(M){this.value=M}append(M){return new s(this.value?this.value+s.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+s.sep)}};W.sep=".",W=s=We([_],W),e.CodeActionKind=W,W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll");let ee=class{constructor(M,Z){if(this.range=M,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ee=We([_],ee),e.SelectionRange=ee;class me{constructor(M,Z,ye,Ge,Xe,tt){this.kind=M,this.name=Z,this.detail=ye,this.uri=Ge,this.range=Xe,this.selectionRange=tt}}e.CallHierarchyItem=me;class Te{constructor(M,Z){this.fromRanges=Z,this.from=M}}e.CallHierarchyIncomingCall=Te;class Ue{constructor(M,Z){this.fromRanges=Z,this.to=M}}e.CallHierarchyOutgoingCall=Ue;var He;(function(O){O[O.Information=0]="Information",O[O.Warning=1]="Warning",O[O.Error=2]="Error"})(He=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let be=class{constructor(M,Z){this.range=M,this.command=Z}get isResolved(){return!!this.command}};be=We([_],be),e.CodeLens=be;let Je=f=class{constructor(M,Z=!1){d.set(this,void 0),Ze(this,d,new E.MarkdownString(M,{supportThemeIcons:Z}),"f")}static isMarkdownString(M){return M instanceof f?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Oe(this,d,"f").value}set value(M){Oe(this,d,"f").value=M}get isTrusted(){return Oe(this,d,"f").isTrusted}set isTrusted(M){Oe(this,d,"f").isTrusted=M}get supportThemeIcons(){return Oe(this,d,"f").supportThemeIcons}set supportThemeIcons(M){Oe(this,d,"f").supportThemeIcons=M}appendText(M){return Oe(this,d,"f").appendText(M),this}appendMarkdown(M){return Oe(this,d,"f").appendMarkdown(M),this}appendCodeblock(M,Z){return Oe(this,d,"f").appendCodeblock(Z??"",M),this}};d=new WeakMap,Je=f=We([_],Je),e.MarkdownString=Je;let $=class{constructor(M,Z){this.label=M,this.documentation=Z}};$=We([_],$),e.ParameterInformation=$;let G=class{constructor(M,Z){this.label=M,this.documentation=Z,this.parameters=[]}};G=We([_],G),e.SignatureInformation=G;let fe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};fe=We([_],fe),e.SignatureHelp=fe;var Le;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(Le=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ve;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(Ve=e.InlayHintKind||(e.InlayHintKind={}));let et=class{constructor(M,Z,ye){this.text=M,this.position=Z,this.kind=ye}};et=We([_],et),e.InlayHint=et;var rt;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(rt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var pt;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(pt=e.CompletionItemKind||(e.CompletionItemKind={}));var St;(function(O){O[O.Deprecated=1]="Deprecated"})(St=e.CompletionItemTag||(e.CompletionItemTag={}));let Ct=class{constructor(M,Z){this.label=M,this.kind=Z}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ct=We([_],Ct),e.CompletionItem=Ct;let ct=class{constructor(M=[],Z=!1){this.items=M,this.isIncomplete=Z}};ct=We([_],ct),e.CompletionList=ct;let _t=class{constructor(M,Z,ye){this.text=M,this.range=Z,this.command=ye}};_t=We([_],_t),e.InlineSuggestion=_t;let ht=class{constructor(M){this.items=M}};ht=We([_],ht),e.InlineSuggestions=ht;var wt;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(wt=e.ViewColumn||(e.ViewColumn={}));var Ye;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(Ye=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pt;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(Pt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Se;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(Se=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ce;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var J;(function(O){O[O.Undo=1]="Undo",O[O.Redo=2]="Redo"})(J=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var oe;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(oe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function M(Z){switch(Z){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=M}(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let pe=class{constructor(M,Z){if(Z&&!D.URI.isUri(Z))throw(0,F.illegalArgument)("target");if(!V.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.target=Z}};pe=We([_],pe),e.DocumentLink=pe;let ge=class{constructor(M,Z,ye,Ge){this.red=M,this.green=Z,this.blue=ye,this.alpha=Ge}};ge=We([_],ge),e.Color=ge;let Ie=class{constructor(M,Z){if(Z&&!(Z instanceof ge))throw(0,F.illegalArgument)("color");if(!V.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.color=Z}};Ie=We([_],Ie),e.ColorInformation=Ie;let Be=class{constructor(M){if(!M||typeof M!="string")throw(0,F.illegalArgument)("label");this.label=M}};Be=We([_],Be),e.ColorPresentation=Be;var Me;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(Me=e.ColorFormat||(e.ColorFormat={}));var je;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class de{constructor(M,Z,ye){if(this.startIndex=M,this.length=Z,this.tooltip=ye,typeof M!="number"||M<0)throw(0,F.illegalArgument)("startIndex");if(typeof Z!="number"||Z<1)throw(0,F.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=de;class ae{constructor(M){this.options=M,typeof M!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=ae;var ne;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(ne=e.TaskRevealKind||(e.TaskRevealKind={}));var B;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(B=e.TaskPanelKind||(e.TaskPanelKind={}));let ve=m=class{constructor(M,Z){if(typeof M!="string"||typeof Z!="string")throw(0,F.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};ve.Clean=new m("clean","Clean"),ve.Build=new m("build","Build"),ve.Rebuild=new m("rebuild","Rebuild"),ve.Test=new m("test","Test"),ve=m=We([_],ve),e.TaskGroup=ve;function ke(O){let M="";for(let Z=0;Z<O.length;Z++)M+=O[Z].replace(/,/g,",,")+",";return M}let $e=class{constructor(M,Z,ye){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=M,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=ye):this._options=Z)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)M.push(Z);return ke(M)}};$e=We([_],$e),e.ProcessExecution=$e;let xe=class{constructor(M,Z,ye){if(this._args=[],Array.isArray(Z)){if(!M)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M,this._args=Z,this._options=ye}else{if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)M.push(typeof Z=="string"?Z:Z.value);return ke(M)}};xe=We([_],xe),e.ShellExecution=xe;var lt;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(lt=e.ShellQuoting||(e.ShellQuoting={}));var at;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(at=e.TaskScope||(e.TaskScope={}));class bt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=bt;let dt=g=class{constructor(M,Z,ye,Ge,Xe,tt){this.__deprecated=!1,this._definition=this.definition=M;let ot;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=ye,this.execution=Ge,ot=Xe,this.__deprecated=!0):Z===at.Global||Z===at.Workspace?(this.target=Z,this._name=this.name=ye,this._source=this.source=Ge,this.execution=Xe,ot=tt):(this.target=Z,this._name=this.name=ye,this._source=this.source=Ge,this.execution=Xe,ot=tt),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof $e?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof bt?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const Z=this._definition.type;(g.EmptyType===Z||g.ProcessType===Z||g.ShellType===Z||g.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};dt.ExtensionCallbackType="customExecution",dt.ProcessType="process",dt.ShellType="shell",dt.EmptyType="$empty",dt=g=We([_],dt),e.Task=dt;var nt;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(nt=e.ProgressLocation||(e.ProgressLocation={}));let st=class{constructor(M,Z=ft.None){this.collapsibleState=Z,D.URI.isUri(M)?this.resourceUri=M:this.label=M}};st=We([_],st),e.TreeItem=st;var ft;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(ft=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let kt=class{constructor(M,Z){this.id=M,this.color=Z}};kt=We([_],kt),e.ThemeIcon=kt,kt.File=new kt("file"),kt.Folder=new kt("folder");let Tt=class{constructor(M){this.id=M}};Tt=We([_],Tt),e.ThemeColor=Tt;var Wt;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(Wt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let qt=class{constructor(M,Z){if(typeof M!="string"&&(!M||!D.URI.isUri(M)&&!D.URI.isUri(M.uri)))throw(0,F.illegalArgument)("base");if(typeof Z!="string")throw(0,F.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=D.URI.file(M),this.base=M):D.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=Z}};qt=We([_],qt),e.RelativePattern=qt;let Et=class{constructor(M,Z,ye,Ge){this.enabled=typeof M=="boolean"?M:!0,typeof Z=="string"&&(this.condition=Z),typeof ye=="string"&&(this.hitCondition=ye),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};Et=We([_],Et),e.Breakpoint=Et;let Jt=class extends Et{constructor(M,Z,ye,Ge,Xe){super(Z,ye,Ge,Xe);if(M===null)throw(0,F.illegalArgument)("location");this.location=M}};Jt=We([_],Jt),e.SourceBreakpoint=Jt;let Xt=class extends Et{constructor(M,Z,ye,Ge,Xe){super(Z,ye,Ge,Xe);this.functionName=M}};Xt=We([_],Xt),e.FunctionBreakpoint=Xt;let mt=class extends Et{constructor(M,Z,ye,Ge,Xe,tt,ot){super(Ge,Xe,tt,ot);if(!Z)throw(0,F.illegalArgument)("dataId");this.label=M,this.dataId=Z,this.canPersist=ye}};mt=We([_],mt),e.DataBreakpoint=mt;let jt=class{constructor(M,Z,ye){this.command=M,this.args=Z||[],this.options=ye}};jt=We([_],jt),e.DebugAdapterExecutable=jt;let Ht=class{constructor(M,Z){this.port=M,this.host=Z}};Ht=We([_],Ht),e.DebugAdapterServer=Ht;let Zt=class{constructor(M){this.path=M}};Zt=We([_],Zt),e.DebugAdapterNamedPipeServer=Zt;let ei=class{constructor(M){this.implementation=M}};ei=We([_],ei),e.DebugAdapterInlineImplementation=ei;let It=class{constructor(M,Z){this.range=M,this.expression=Z}};It=We([_],It),e.EvaluatableExpression=It;var hi;(function(O){O[O.Automatic=0]="Automatic",O[O.Explicit=1]="Explicit"})(hi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ti=class{constructor(M,Z){this.range=M,this.text=Z}};ti=We([_],ti),e.InlineValueText=ti;let Ut=class{constructor(M,Z,ye=!0){this.range=M,this.variableName=Z,this.caseSensitiveLookup=ye}};Ut=We([_],Ut),e.InlineValueVariableLookup=Ut;let ut=class{constructor(M,Z){this.range=M,this.expression=Z}};ut=We([_],ut),e.InlineValueEvaluatableExpression=ut;let ii=class{constructor(M,Z){this.frameId=M,this.stoppedLocation=Z}};ii=We([_],ii),e.InlineValueContext=ii;var Lt;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(Lt=e.FileChangeType||(e.FileChangeType={}));let Ot=b=class extends Error{constructor(M,Z=t.FileSystemProviderErrorCode.Unknown,ye){super(D.URI.isUri(M)?M.toString(!0):M);this.code=ye?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(M){return new b(M,t.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(M){return new b(M,t.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(M){return new b(M,t.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(M){return new b(M,t.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(M){return new b(M,t.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(M){return new b(M,t.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Ot=b=We([_],Ot),e.FileSystemError=Ot;let Gt=class{constructor(M,Z,ye){this.start=M,this.end=Z,this.kind=ye}};Gt=We([_],Gt),e.FoldingRange=Gt;var Ei;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(Ei=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _i;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(_i=e.CommentMode||(e.CommentMode={}));class mi{constructor(M,Z=[]){this.tokenTypes=M,this.tokenModifiers=Z}}e.SemanticTokensLegend=mi;function ni(O){return typeof O=="undefined"||(0,I.isStringArray)(O)}class ri{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let Z=0,ye=M.tokenTypes.length;Z<ye;Z++)this._tokenTypeStrToInt.set(M.tokenTypes[Z],Z);for(let Z=0,ye=M.tokenModifiers.length;Z<ye;Z++)this._tokenModifierStrToInt.set(M.tokenModifiers[Z],Z)}}push(M,Z,ye,Ge,Xe){if(typeof M=="number"&&typeof Z=="number"&&typeof ye=="number"&&typeof Ge=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded(M,Z,ye,Ge,Xe);if(V.isRange(M)&&typeof Z=="string"&&ni(ye))return this._push(M,Z,ye);throw(0,F.illegalArgument)()}_push(M,Z,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const Ge=M.start.line,Xe=M.start.character,tt=M.end.character-M.start.character,ot=this._tokenTypeStrToInt.get(Z);let yt=0;if(ye)for(const At of ye){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(At);yt|=1<<Rt>>>0}this._pushEncoded(Ge,Xe,tt,ot,yt)}_pushEncoded(M,Z,ye,Ge,Xe){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Rt=0;for(let Mt=0;Mt<yt;Mt++){let Nt=this._data[5*Mt],ci=this._data[5*Mt+1];Nt===0?(Nt=At,ci+=Rt):Nt+=At,this._data[5*Mt]=Nt,this._data[5*Mt+1]=ci,At=Nt,Rt=ci}}let tt=M,ot=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(tt-=this._prevLine,tt===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=tt,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Xe,this._prevLine=M,this._prevChar=Z}static _sortAndDeltaEncode(M){let Z=[];const ye=M.length/5|0;for(let ot=0;ot<ye;ot++)Z[ot]=ot;Z.sort((ot,yt)=>{const At=M[5*ot],Rt=M[5*yt];if(At===Rt){const Mt=M[5*ot+1],Nt=M[5*yt+1];return Mt-Nt}return At-Rt});const Ge=new Uint32Array(M.length);let Xe=0,tt=0;for(let ot=0;ot<ye;ot++){const yt=5*Z[ot],At=M[yt+0],Rt=M[yt+1],Mt=M[yt+2],Nt=M[yt+3],ci=M[yt+4],Ni=At-Xe,qi=Ni===0?Rt-tt:Rt,di=5*ot;Ge[di+0]=Ni,Ge[di+1]=qi,Ge[di+2]=Mt,Ge[di+3]=Nt,Ge[di+4]=ci,Xe=At,tt=Rt}return Ge}build(M){return this._dataIsSortedAndDeltaEncoded?new zt(new Uint32Array(this._data),M):new zt(ri._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=ri;class zt{constructor(M,Z){this.resultId=Z,this.data=M}}e.SemanticTokens=zt;class si{constructor(M,Z,ye){this.start=M,this.deleteCount=Z,this.data=ye}}e.SemanticTokensEdit=si;class yi{constructor(M,Z){this.resultId=Z,this.edits=M}}e.SemanticTokensEdits=yi;var Si;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(Si=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Vt;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(Vt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new kt("arrow-left")},Kt=We([_],Kt),e.QuickInputButtons=Kt;var Di;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(Di=e.ExtensionKind||(e.ExtensionKind={}));class Ci{constructor(M,Z,ye){this.badge=M,this.tooltip=Z,this.color=ye}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Ci;let oi=class{constructor(M){this.kind=M}};oi=We([_],oi),e.ColorTheme=oi;var ai;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(ai=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(M,Z){if(M<0)throw(0,F.illegalArgument)("start must be positive");if(Z<0)throw(0,F.illegalArgument)("end must be positive");M<=Z?(this._start=M,this._end=Z):(this._start=Z,this._end=M)}static isNotebookRange(M){return M instanceof Bt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let Z=this._start,ye=this._end;return M.start!==void 0&&(Z=M.start),M.end!==void 0&&(ye=M.end),Z===this._start&&ye===this._end?this:new Bt(Z,ye)}}e.NotebookRange=Bt;class Ft{constructor(M,Z,ye,Ge,Xe,tt,ot){this.kind=M,this.value=Z,this.languageId=ye,this.mime=Ge,this.outputs=Xe??[],this.metadata=tt,this.executionSummary=ot,Ft.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(Z=>Ft.isNotebookCellData(Z))}static isNotebookCellData(M){return!0}}e.NotebookCellData=Ft;class Qt{constructor(M){this.cells=M}}e.NotebookData=Qt;class Ae{constructor(M,Z){this.data=M,this.mime=Z;const ye=(0,A.normalizeMimeType)(Z,!0);if(!ye)throw new Error(`INVALID mime type: ${Z}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}static isNotebookCellOutputItem(M){return M instanceof Ae?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const Z={name:M.name,message:M.message,stack:M.stack};return Ae.json(Z,"application/vnd.code.notebook.error")}static stdout(M){return Ae.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Ae.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,Z="application/octet-stream"){return new Ae(M,Z)}static text(M,Z=A.Mimes.text){const ye=Oe(Ae,a,"f",l).encode(String(M));return new Ae(ye,Z)}static json(M,Z="application/json"){const ye=JSON.stringify(M,void 0,"	");return Ae.text(ye,Z)}}e.NotebookCellOutputItem=Ae,a=Ae,l={value:new TextEncoder};class $t{constructor(M,Z,ye){this.items=$t.ensureUniqueMimeTypes(M,!0),typeof Z=="string"?(this.id=Z,this.metadata=ye):(this.id=(0,P.generateUuid)(),this.metadata=Z??ye)}static isNotebookCellOutput(M){return M instanceof $t?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&(0,I.isArray)(M.items)}static ensureUniqueMimeTypes(M,Z=!1){const ye=new Set,Ge=new Set;for(let Xe=0;Xe<M.length;Xe++){const tt=M[Xe],ot=(0,A.normalizeMimeType)(tt.mime);if(!ye.has(ot)){ye.add(ot);continue}Ge.add(Xe),Z&&console.warn(`DUPLICATED mime type '${tt.mime}' will be dropped`)}return Ge.size===0?M:M.filter((Xe,tt)=>!Ge.has(tt))}}e.NotebookCellOutput=$t;var gi;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(gi=e.NotebookCellKind||(e.NotebookCellKind={}));var gt;(function(O){O[O.Idle=1]="Idle",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(gt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ii;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(Ii=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pi{constructor(M,Z){this.text=M,this.alignment=Z}}e.NotebookCellStatusBarItem=pi;var vi;(function(O){O[O.Default=1]="Default",O[O.Preferred=2]="Preferred"})(vi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(M,Z=[]){this.uri=M,this.provides=(0,h.asArray)(Z)}}e.NotebookRendererScript=Pi;let li=class{constructor(M,Z){this.label=M,this.timestamp=Z}};li=We([_],li),e.TimelineItem=li;var Ti;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var Ai;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(Ai=e.ExtensionRuntime||(e.ExtensionRuntime={}));var wi;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(wi=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(M,Z){this.ranges=M,this.wordPattern=Z}}e.LinkedEditingRanges=Ri;class Fi{constructor(M,Z){this._port=M,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(O){O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ui=class{constructor(M,Z,ye){this.include=M,this.exclude=Z,this.profile=ye}};ui=We([_],ui),e.TestRunRequest=ui;let Q=C=class{constructor(M){this.message=M}static diff(M,Z,ye){const Ge=new C(M);return Ge.expectedOutput=Z,Ge.actualOutput=ye,Ge}};Q=C=We([_],Q),e.TestMessage=Q;let ue=class{constructor(M,Z){this.id=M,this.label=Z}};ue=We([_],ue),e.TestTag=ue;let De=class{constructor(M,Z){this.covered=M,this.total=Z}};De=We([_],De),e.CoveredCount=De;let it=n=class{constructor(M,Z,ye,Ge){this.uri=M,this.statementCoverage=Z,this.branchCoverage=ye,this.functionCoverage=Ge}static fromDetails(M,Z){const ye=new De(0,0),Ge=new De(0,0),Xe=new De(0,0);for(const ot of Z)if("branches"in ot){ye.total+=1,ye.covered+=ot.executionCount>0?1:0;for(const yt of ot.branches)Ge.total+=1,Ge.covered+=yt.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=ot.executionCount>0?1:0;const tt=new n(M,ye,Ge.total>0?Ge:void 0,Xe.total>0?Xe:void 0);return tt.detailedCoverage=Z,tt}};it=n=We([_],it),e.FileCoverage=it;let vt=class{constructor(M,Z,ye=[]){this.executionCount=M,this.location=Z,this.branches=ye}};vt=We([_],vt),e.StatementCoverage=vt;let Dt=class{constructor(M,Z){this.executionCount=M,this.location=Z}};Dt=We([_],Dt),e.BranchCoverage=Dt;let Oi=class{constructor(M,Z){this.executionCount=M,this.location=Z}};Oi=We([_],Oi),e.FunctionCoverage=Oi;var Wi;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(Wi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Hi;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unspecified=2]="Unspecified"})(Hi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var zi;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore",O[O.OpenBrowserOnce=6]="OpenBrowserOnce"})(zi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Vi{constructor(M,Z,ye,Ge,Xe,tt){this.kind=M,this.name=Z,this.detail=ye,this.uri=Ge,this.range=Xe,this.selectionRange=tt}}e.TypeHierarchyItem=Vi}),define(Ee[87],_e([0,1,39,11,9,227,117,6,16]),function(te,e,h,F,E,T,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function t(a,l){l?P.set(a,l):P.delete(a)}e.setWordDefinitionFor=t;function S(a){return P.get(a)}e.getWordDefinitionFor=S;class r extends T.MirrorTextModel{constructor(l,p,v,k,c,w,y,i){super(p,v,k,c);this._proxy=l,this._languageId=w,this._isDirty=y,this._notebook=i,this._isDisposed=!1}dispose(){(0,h.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,D.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===F.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},get notebook(){return l._notebook},save(){return l._save()},getText(p){return p?l._getTextInRange(p):l.getText()},get eol(){return l._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(p){return l._lineAt(p)},offsetAt(p){return l._offsetAt(p)},positionAt(p){return l._positionAt(p)},validateRange(p){return l._validateRange(p)},validatePosition(p){return l._validatePosition(p)},getWordRangeAtPosition(p,v){return l._getWordRangeAtPosition(p,v)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,h.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,h.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const p=this._validateRange(l);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const v=this._eol,k=p.start.line,c=p.end.line,w=[];w.push(this._lines[k].substring(p.start.character));for(let y=k+1;y<c;y++)w.push(this._lines[y]);return w.push(this._lines[c].substring(0,p.end.character)),w.join(v)}_lineAt(l){let p;if(l instanceof I.Position?p=l.line:typeof l=="number"&&(p=l),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new d(p,this._lines[p],p===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(l),v=this._lines[p.index].length;return new I.Position(p.index,Math.min(p.remainder,v))}_validateRange(l){if(!(l instanceof I.Range))throw new Error("Invalid argument");const p=this._validatePosition(l.start),v=this._validatePosition(l.end);return p===l.start&&v===l.end?l:new I.Range(p.line,p.character,v.line,v.character)}_validatePosition(l){if(!(l instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:p,character:v}=l,k=!1;if(p<0)p=0,v=0,k=!0;else if(p>=this._lines.length)p=this._lines.length-1,v=this._lines[p].length,k=!0;else{const c=this._lines[p].length;v<0?(v=0,k=!0):v>c&&(v=c,k=!0)}return k?new I.Position(p,v):l}_getWordRangeAtPosition(l,p){const v=this._validatePosition(l);if(!p)p=S(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const k=(0,A.getWordAtText)(v.character+1,(0,A.ensureValidWordDefinition)(p),this._lines[v.line],0);if(k)return new I.Range(v.line,k.startColumn-1,v.line,k.endColumn-1)}}e.ExtHostDocumentData=r;class d{constructor(l,p,v){this._line=l,this._text=p,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(Ee[154],_e([0,1,6,3,228,7,53,20,2,36]),function(te,e,h,F,E,T,A,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(r,d,a,l){this._notebook=a,this._selector=l,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(v=>{const k=this._cellUris.get(v.document.uri);k!==void 0&&(this._cellLengths.changeValue(k,this._cells[k].document.getText().length+1),this._cellLines.changeValue(k,this._cells[k].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(r.onDidChangeNotebookCells(v=>p(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const r=[],d=[];for(const a of this._notebook.getCells())a.kind===h.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),r.push(a.document.getText().length+1),d.push(a.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(r)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(r){if(!r){let k="";for(const c of this._cells)k+=c.document.getText()+`
`;return k=k.slice(0,-1),k}if(r.isEmpty)return"";const d=this.locationAt(r.start),a=this.locationAt(r.end),l=this._cellUris.get(d.uri),p=this._cellUris.get(a.uri);if(l===void 0||p===void 0)return"";if(l===p)return this._cells[l].document.getText(new h.Range(d.range.start,a.range.end));const v=[this._cells[l].document.getText(new h.Range(d.range.start,new h.Position(this._cells[l].document.lineCount,0)))];for(let k=l+1;k<p;k++)v.push(this._cells[k].document.getText());return v.push(this._cells[p].document.getText(new h.Range(new h.Position(0,0),a.range.end))),v.join(`
`)}offsetAt(r){const d=this._cellLines.getIndexOf(r.line),a=this._cellLengths.getPrefixSum(d.index-1),l=this._cells[d.index].document.offsetAt(r.with(d.remainder));return a+l}positionAt(r){if(typeof r=="number"){const a=this._cellLengths.getIndexOf(r),l=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(l)}const d=this._cellUris.get(r.uri);if(d!==void 0){const a=this._cellLines.getPrefixSum(d-1);return new h.Position(a+r.range.start.line,r.range.start.character)}return new h.Position(0,0)}locationAt(r){h.Range.isRange(r)||(r=new h.Range(r,r));const d=this._cellLines.getIndexOf(r.start.line);let a=d;r.isEmpty||(a=this._cellLines.getIndexOf(r.end.line));const l=new h.Position(d.remainder,r.start.character),p=new h.Position(a.remainder,r.end.character),v=new h.Range(l,p),k=this._cells[d.index];return new h.Location(k.document.uri,k.document.validateRange(v))}contains(r){return this._cellUris.has(r)}validateRange(r){const d=this.validatePosition(r.start),a=this.validatePosition(r.end);return r.with(d,a)}validatePosition(r){const d=this._cellLines.getIndexOf(r.line),a=new h.Position(d.remainder,r.character),l=this._cells[d.index].document.validatePosition(a),p=this._cellLines.getPrefixSum(d.index-1);return new h.Position(p+l.line,l.character)}}e.ExtHostNotebookConcatDocument=t}),define(Ee[155],_e([0,1,6,12,3]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(I){this._actual=new h.ColorTheme(h.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let D=I==="light"?h.ColorThemeKind.Light:I==="dark"?h.ColorThemeKind.Dark:h.ColorThemeKind.HighContrast;this._actual=new h.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=We([ze(0,F.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(Ee[65],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,h.createDecorator)("IURITransformerService");class F{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=F}),define(Ee[156],_e([0,1,23]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function E(I,D){if(D.serializeBuffersForPostMessage){const P=new F,t=(d,a)=>{if(a instanceof ArrayBuffer){const l=P.add(a);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(a)){const l=T(a);if(l){const p=P.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:l,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},S=JSON.stringify(I,t),r=P.buffers.map(d=>{const a=new Uint8Array(d);return h.VSBuffer.wrap(a)});return{message:S,buffers:r}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=E;function T(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(I,D){const P=D.map(r=>{const d=new ArrayBuffer(r.byteLength);return new Uint8Array(d).set(r.buffer),d}),t=D.length?(r,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const a=d,{index:l}=a,p=P[l];if(a.view)switch(a.view.type){case 1:return new Int8Array(p,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return d}:void 0;return{message:JSON.parse(I,t),arrayBuffers:P}}e.deserializeWebviewMessage=A}),define(Ee[157],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var h;(function(F){function E(A){const I={items:new Map};return A.types.forEach((D,P)=>{I.items.set(D,{asString:async()=>A.items[P].asString})}),I}F.toITreeDataTransfer=E;async function T(A){const I={types:[],items:[]},D=Array.from(A.items.entries());for(const P of D)I.types.push(P[0]),I.items.push({asString:await P[1].asString()});return I}F.toTreeDataTransferDTO=T})(h=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[66],_e([0,1,11,2]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(I,D){return I.scheme===h.Schemas.http||I.scheme===h.Schemas.https?I:(D&&D.authority&&D.isRemote&&I.scheme===h.Schemas.file&&(I=F.URI.from({scheme:h.Schemas.vscodeRemote,authority:D.authority,path:I.path})),F.URI.from({scheme:h.Schemas.https,authority:`${I.scheme}+${T(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=E;function T(I){return I.replace(/./g,D=>{const P=D.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?D:"-"+P.toString(16).padStart(4,"0")})}function A(I){return I.replace(/-([0-9a-f]{4})/g,(D,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=A}),define(Ee[158],_e([0,1,3,7,66]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(I,D,P){this._proxy=I,this._editors=D,this._initData=P,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const t=D.getVisibleTextEditors();for(const S of this._insets.values())t.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,D,P,t,S){let r;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===I){r=c;break}if(!r)throw new Error("not a visible editor");const d=this,a=this._handlePool++,l=new h.Emitter,p=new h.Emitter,v=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,E.asWebviewUri)(c,d._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(c){this._options=c,d._proxy.$setOptions(a,c)}get options(){return this._options}set html(c){this._html=c,d._proxy.$setHtml(a,c)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(c){return d._proxy.$postMessage(a,c)}},k=new class{constructor(){this.editor=I,this.line=D,this.height=P,this.webview=v,this.onDidDispose=p.event}dispose(){d._insets.has(a)&&(d._insets.delete(a),d._proxy.$disposeEditorInset(a),p.fire(),p.dispose(),l.dispose())}};return this._proxy.$createEditorInset(a,r.id,r.value.document.uri,D+1,P,t||{},S.identifier,S.extensionLocation),this._insets.set(a,{editor:I,inset:k,onDidReceiveMessage:l}),k}$onDidDispose(I){const D=this._insets.get(I);D&&D.inset.dispose()}$onDidReceiveMessage(I,D){const P=this._insets.get(I);P&&P.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=T}),define(Ee[159],_e([0,1,130,10,2,7,4,42,28,16,11]),function(te,e,h,F,E,T,A,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,h.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,h.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,h.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,h.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,h.localize)(6,null)),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,h.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,h.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,h.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,h.localize)(10,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,h.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,h.localize)(12,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,h.localize)(13,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,h.localize)(14,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,h.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,h.localize)(16,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,h.localize)(17,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,h.localize)(18,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,h.localize)(19,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,h.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function S(n){return typeof n?.getViewState=="function"}e.isTextEditorPane=S;function r(n){if(c(n))return!1;const _=n;return E.URI.isUri(_?.resource)}e.isResourceEditorInput=r;function d(n){if(c(n))return!1;const _=n;return _?.original!==void 0&&_.modified!==void 0}e.isResourceDiffEditorInput=d;function a(n){if(c(n))return!1;const _=n;return _?_.resource===void 0||_.resource.scheme===t.Schemas.untitled||_.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;var l;(function(n){n[n.SHORT=0]="SHORT",n[n.MEDIUM=1]="MEDIUM",n[n.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var p;(function(n){n[n.EXPLICIT=1]="EXPLICIT",n[n.AUTO=2]="AUTO",n[n.FOCUS_CHANGE=3]="FOCUS_CHANGE",n[n.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p=e.SaveReason||(e.SaveReason={}));var v;(function(n){n[n.None=0]="None",n[n.Readonly=2]="Readonly",n[n.Untitled=4]="Untitled",n[n.Singleton=8]="Singleton",n[n.RequiresTrust=16]="RequiresTrust"})(v=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class k extends T.Disposable{}e.AbstractEditorInput=k;function c(n){return n instanceof k}e.isEditorInput=c;function w(n){const _=n;return E.URI.isUri(_?.preferredResource)}function y(n){const _=n;return c(_?.primary)&&c(_?.secondary)}e.isSideBySideEditorInput=y;function i(n){return c(n?.editor)}e.isEditorInputWithOptions=i;function o(n){const _=n;return i(n)&&_?.group!==void 0}e.isEditorInputWithOptionsAndGroup=o;function u(n){const _=n;return typeof _?.groupId=="number"&&c(_.editor)}e.isEditorIdentifier=u;var s;(function(n){n[n.PRIMARY=1]="PRIMARY",n[n.SECONDARY=2]="SECONDARY",n[n.BOTH=3]="BOTH"})(s=e.SideBySideEditor||(e.SideBySideEditor={}));class f{getOriginalUri(_,R){if(!_)return;const U=y(_)?_.primary:d(_)?_.modified:void 0,V=y(_)?_.secondary:d(_)?_.original:void 0;if(R?.supportSideBySide&&U&&V){if(R?.supportSideBySide===s.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:R.filterByScheme}),secondary:this.getOriginalUri(V,{filterByScheme:R.filterByScheme})};_=R.supportSideBySide===s.PRIMARY?U:V}if(d(_))return;const le=w(_)?_.preferredResource:_.resource;return!le||!R||!R.filterByScheme?le:this.filterUri(le,R.filterByScheme)}getCanonicalUri(_,R){if(!_)return;const U=y(_)?_.primary:d(_)?_.modified:void 0,V=y(_)?_.secondary:d(_)?_.original:void 0;if(R?.supportSideBySide&&U&&V){if(R?.supportSideBySide===s.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:R.filterByScheme}),secondary:this.getCanonicalUri(V,{filterByScheme:R.filterByScheme})};_=R.supportSideBySide===s.PRIMARY?U:V}if(d(_))return;const le=_.resource;return!le||!R||!R.filterByScheme?le:this.filterUri(le,R.filterByScheme)}filterUri(_,R){if(Array.isArray(R)){if(R.some(U=>_.scheme===U))return _}else if(R===_.scheme)return _}}e.EditorResourceAccessor=new f;var m;(function(n){n[n.LEFT=0]="LEFT",n[n.RIGHT=1]="RIGHT"})(m=e.CloseDirection||(e.CloseDirection={}));class g{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(_){const R=this.instantiationService=_.get(A.IInstantiationService);for(const[U,V]of this.editorSerializerConstructors)this.createEditorSerializer(U,V,R);this.editorSerializerConstructors.clear()}createEditorSerializer(_,R,U){const V=U.createInstance(R);this.editorSerializerInstances.set(_,V)}registerFileEditorFactory(_){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=_}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(_,R){if(this.editorSerializerConstructors.has(_)||this.editorSerializerInstances.has(_))throw new Error(`A editor serializer with type ID '${_}' was already registered.`);return this.instantiationService?this.createEditorSerializer(_,R,this.instantiationService):this.editorSerializerConstructors.set(_,R),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(_),this.editorSerializerInstances.delete(_)})}getEditorSerializer(_){return this.editorSerializerInstances.get(typeof _=="string"?_:_.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new g);async function b(n,_){if(!n||!n.length)return[];const R=await Promise.all(n.map(async U=>{const V=E.URI.revive(U.fileUri);if(!V||(await _.activateProvider(V.scheme),!_.canHandleResource(V)))return;const le=typeof U.exists=="boolean"?U.exists:await _.exists(V);if(!le&&U.openOnlyIfExists)return;const he=le&&!(0,F.isUndefined)(U.selection)?{selection:U.selection,pinned:!0,override:U.editorOverrideId}:{pinned:!0,override:U.editorOverrideId};let j;return le?j={resource:V,options:he,forceFile:!0}:j={resource:V,options:he,forceUntitled:!0},j}));return(0,P.coalesce)(R)}e.pathsToEditors=b;var C;(function(n){n[n.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",n[n.SEQUENTIAL=1]="SEQUENTIAL"})(C=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[160],_e([0,1,3,42,131,4,7,20,28,16,49,22,34,150]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",r.Codicon.window,(0,E.localize)(0,null));var a;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var l;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel"})(l=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(f){switch(f){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function v(f){return`viewContainer.${f}.enabled`}e.getEnabledViewContainerContextKey=v;class k extends A.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new h.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new h.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(m,g,b){const C=this.get(m.id);if(C)return C;const n=m;return n.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:n.openCommandActionDescriptor??{id:n.id},(0,I.getOrSet)(this.viewContainers,g,[]).push(n),b?.isDefault&&this.defaultViewContainers.push(n),this._onDidRegister.fire({viewContainer:n,viewContainerLocation:g}),n}deregisterViewContainer(m){for(const g of this.viewContainers.keys()){const b=this.viewContainers.get(g),C=b?.indexOf(m);if(C!==-1){b?.splice(C,1),b.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:m,viewContainerLocation:g});return}}}get(m){return this.all.filter(g=>g.id===m)[0]}getViewContainers(m){return[...this.viewContainers.get(m)||[]]}getViewContainerLocation(m){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(b=>b?.id===m.id).length>0)[0]}getDefaultViewContainer(m){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===m)}}D.Registry.add(a.ViewContainersRegistry,new k);var c;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function w(f,m){const g=f.group??c.More,b=m.group??c.More;return g!==b?g.localeCompare(b):(f.order??5)-(m.order??5)}class y extends A.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new h.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new h.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new h.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new h.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(m,g){this.registerViews2([{views:m,viewContainer:g}])}registerViews2(m){m.forEach(({views:g,viewContainer:b})=>this.addViews(g,b)),this._onViewsRegistered.fire(m)}deregisterViews(m,g){const b=this.removeViews(m,g);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:g})}moveViews(m,g){for(const b of this._views.keys())if(b!==g){const C=this.removeViews(m,b);C.length&&(this.addViews(C,g),this._onDidChangeContainer.fire({views:C,from:b,to:g}))}}getViews(m){return this._views.get(m)||[]}getView(m){for(const g of this._viewContainers){const b=(this._views.get(g)||[]).filter(C=>C.id===m)[0];if(b)return b}return null}getViewContainer(m){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(C=>C.id===m)[0])return g;return null}registerViewWelcomeContent(m,g){return this._viewWelcomeContents.add(m,g),this._onDidChangeViewWelcomeContent.fire(m),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(m,g),this._onDidChangeViewWelcomeContent.fire(m)})}registerViewWelcomeContent2(m,g){const b=new Map;for(const[C,n]of g)this._viewWelcomeContents.add(m,n),b.set(C,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(m,n),this._onDidChangeViewWelcomeContent.fire(m)}));return this._onDidChangeViewWelcomeContent.fire(m),b}getViewWelcomeContent(m){const g=[];return this._viewWelcomeContents.forEach(m,b=>g.push(b)),g.sort(w)}addViews(m,g){let b=this._views.get(g);b||(b=[],this._views.set(g,b),this._viewContainers.push(g));for(const C of m){if(this.getView(C.id)!==null)throw new Error((0,E.localize)(1,null,C.id));b.push(C)}}removeViews(m,g){const b=this._views.get(g);if(!b)return[];const C=[],n=[];for(const _ of b)m.includes(_)?C.push(_):n.push(_);return C.length&&(n.length?this._views.set(g,n):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),C}}D.Registry.add(a.ViewsRegistry,new y),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new F.RawContextKey("focusedView","",(0,E.localize)(2,null));function i(f){return`view.${f}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var o;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(o=e.ViewVisibilityState||(e.ViewVisibilityState={}));var u;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(u=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(m,g){this.resolved=!1,this._hasResolve=!1,(0,S.mixin)(this,m),this._hasResolve=!!g,this.resolve=async b=>{if(g&&!this.resolved){const C=await g(b);C&&(this.tooltip=this.tooltip??C.tooltip,this.command=this.command??C.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(Ee[161],_e([0,1,3,13,132]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new h.Emitter,this._onExit=new h.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,D,P,t){const S={command:I};if(D&&Object.keys(D).length>0&&(S.arguments=D),this.internalSend("request",S),typeof t=="number"){const r=setTimeout(()=>{clearTimeout(r);const d=this.pendingRequests.get(S.seq);if(d){this.pendingRequests.delete(S.seq);const a={type:"response",seq:0,request_seq:S.seq,success:!1,command:I,message:(0,E.localize)(0,null,t,I)};d(a)}},t)}return P&&this.pendingRequests.set(S.seq,P),S.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,D){return I.type!=="event"||D.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,F.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const D=I,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}internalSend(I,D){D.type=I,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((D,P)=>I.set(P,D)),await(0,F.timeout)(500),I.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(Ee[162],_e([0,1,9,2,17,22,11]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function D(u,s,f){return u.replace(I,function(m,g){return s&&g.length>0&&g[0]!=="_"?m:f&&f.hasOwnProperty(g)?f[g]:m})}e.formatPII=D;function P(u){const s={};for(const f of Object.keys(u))f.startsWith("!")||(s[f]=u[f]);return s}e.filterExceptionsFromTelemetry=P;function t(u){return u.configuration.request==="attach"&&!S(u)&&(!u.parentSession||t(u.parentSession))}e.isSessionAttach=t;function S(u){let s=u.configuration.type;if(!!s)return s==="vslsShare"&&(s=u.configuration.adapterProxy.configuration.type),(0,h.equalsIgnoreCase)(s,"extensionhost")||(0,h.equalsIgnoreCase)(s,"pwa-extensionhost")?u:u.parentSession?S(u.parentSession):void 0}e.getExtensionHostDebugSession=S;function r(u){return u.type&&(u.label||u.program||u.runtime)}e.isDebuggerMainContribution=r;function d(u,s,f){let m,g=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,C=null;for(;C=b.exec(u);){let n=C.index+1,_=n+C[0].length;if(n<=s&&_>=f){m=C[0],g=n;break}}if(m){let n=/\w+/g,_=null;for(;(_=n.exec(m))&&!(_.index+1+g+_[0].length>=f););_&&(m=m.substring(0,n.lastIndex))}return m?{start:g,end:g+m.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(u){return!!(u&&u.match(a))}e.isUri=l;function p(u){if(typeof u.path=="string"&&!(typeof u.sourceReference=="number"&&u.sourceReference>0)){if(l(u.path))return F.URI.parse(u.path);if((0,E.isAbsolute)(u.path))return F.URI.file(u.path)}return u.path}function v(u){if(typeof u.path=="object"){const s=F.URI.revive(u.path);if(s)return s.scheme===A.Schemas.file?s.fsPath:s.toString()}return u.path}function k(u,s){const f=s?p:v,m=(0,T.deepClone)(u);return w(m,(g,b)=>{g&&b&&(b.path=f(b))}),m}e.convertToDAPaths=k;function c(u,s){const f=s?p:v,m=(0,T.deepClone)(u);return w(m,(g,b)=>{!g&&b&&(b.path=f(b))}),m}e.convertToVSCPaths=c;function w(u,s){switch(u.type){case"event":const f=u;switch(f.event){case"output":s(!1,f.body.source);break;case"loadedSource":s(!1,f.body.source);break;case"breakpoint":s(!1,f.body.breakpoint.source);break;default:break}break;case"request":const m=u;switch(m.command){case"setBreakpoints":s(!0,m.arguments.source);break;case"breakpointLocations":s(!0,m.arguments.source);break;case"source":s(!0,m.arguments.source);break;case"gotoTargets":s(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(b=>s(!1,b));break;default:break}break;case"response":const g=u;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(b=>s(!1,b.source));break;case"loadedSources":g.body.sources.forEach(b=>s(!1,b));break;case"scopes":g.body.scopes.forEach(b=>s(!1,b.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(b=>s(!1,b.source));break;case"setBreakpoints":g.body.breakpoints.forEach(b=>s(!1,b.source));break;default:break}break}}function y(u){return u.filter(s=>!s.presentation?.hidden).sort((s,f)=>s.presentation?f.presentation?s.presentation.group?f.presentation.group?s.presentation.group!==f.presentation.group?s.presentation.group.localeCompare(f.presentation.group):i(s.presentation.order,f.presentation.order):-1:f.presentation.group?1:i(s.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=y;function i(u,s){return typeof u!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:u-s}async function o(u,s){const f=u.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorMode});if(f!=="none"&&(await s.saveAll(),f==="allEditorsInActiveGroup")){const m=s.activeEditorPane;m&&await s.save({editor:m.input,groupId:m.group.id})}await u.reloadConfiguration()}e.saveAllBeforeDebugStart=o}),define(Ee[88],_e([0,1,27,77,11,17,26,42]),function(te,e,h,F,E,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(n){n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var S;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(S=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var r;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(r=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeLanguage=5]="ChangeLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var p;(function(n){n.scheme=E.Schemas.vscodeNotebookCell;const _=/^ch(\d{7,})/;function R(j,H){return j.with({scheme:n.scheme,fragment:`ch${H.toString().padStart(7,"0")}${j.scheme!==E.Schemas.file?j.scheme:""}`})}n.generate=R;function U(j){if(j.scheme!==n.scheme)return;const H=_.exec(j.fragment);return H?{handle:Number(H[1]),notebook:j.with({scheme:j.fragment.substr(H[0].length)||E.Schemas.file,fragment:null})}:void 0}n.parse=U;function V(j){if(j.scheme!==E.Schemas.vscodeNotebookCellMetadata)return;const H=_.exec(j.fragment);return H?{handle:Number(H[1]),notebook:j.with({scheme:j.fragment.substr(H[0].length)||E.Schemas.file,fragment:null})}:void 0}n.parseCellMetadataUri=V;function le(j,H,L){return j.with({scheme:L,fragment:`ch${H.toString().padStart(7,"0")}${j.scheme!==E.Schemas.file?j.scheme:""}`})}n.generateCellUri=le;function he(j,H){if(j.scheme!==H)return;const L=_.exec(j.fragment);return L?{handle:Number(L[1]),notebook:j.with({scheme:j.fragment.substr(L[0].length)||E.Schemas.file,fragment:null})}:void 0}n.parseCellUri=he})(p=e.CellUri||(e.CellUri={}));const v=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function k(n){return v.get(n)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=k;function c(n){return v.get(n)?.supportedByCore??!1}e.mimeTypeSupportedByCore=c;function w(n){return v.get(n)?.mergeable??!1}e.mimeTypeIsMergeable=w;function y(n,_){return A.isWindows&&(n=n.replace(/\//g,"\\"),_=_.replace(/\//g,"\\")),h.match(n,_)}function i(n,_,R){let U=0;for(let V=0;V<_.length;V++){if(y(_[V],n))return U;U++}for(let V=0;V<R.length;V++){if(y(R[V],n))return U;U++}return U}function o(n,_,R){return n.sort((U,V)=>i(U,_,R)-i(V,_,R))}e.sortMimeTypes=o;function u(n,_,R,U=(V,le)=>V===le){const V=[];function le(H,L,K){if(L===0&&K.length===0)return;const x=V[V.length-1];x&&x.start+x.deleteCount===H?(x.deleteCount+=L,x.toInsert.push(...K)):V.push({start:H,deleteCount:L,toInsert:K})}let he=0,j=0;for(;;){if(he===n.length){le(he,0,_.slice(j));break}if(j===_.length){le(he,n.length-he,[]);break}const H=n[he],L=_[j];if(U(H,L)){he+=1,j+=1;continue}R(L)?(le(he,1,[]),he+=1):(le(he,0,[L]),j+=1)}return V}e.diff=u,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(n){n.default="default",n.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function f(n){const _=n;return!!((typeof _.include=="string"||h.isRelativePattern(_.include))&&(typeof _.exclude=="string"||h.isRelativePattern(_.exclude)))}e.isDocumentExcludePattern=f;function m(n,_,R){if(Array.isArray(n.viewType)&&n.viewType.indexOf(_)>=0||n.viewType===_)return!0;if(n.filenamePattern){let U=f(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,V=f(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(h.match(U,(0,T.basename)(R.fsPath).toLowerCase()))return!(V&&h.match(V,(0,T.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=m;class g{constructor(_){this.textModel=_}getElements(){const _=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)_[R]=this.textModel.cells[R].getHashValue();return _}}e.CellSequence=g,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var b;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class C{static create(_){return`${C._prefix}${_}`}static parse(_){if(_.startsWith(C._prefix))return _.substr(C._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=C,C._prefix="notebook/"}),define(Ee[163],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,h.createDecorator)("INotebookExecutionService")}),define(Ee[164],_e([0,1,134,4,42]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,h.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,h.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,h.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[165],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=h;function F(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=F}),define(Ee[89],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var h;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(h=e.TestResultState||(e.TestResultState={}));var F;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(S){S[S.Error=0]="Error",S[S.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var T;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(S,r)=>{r.expand!==void 0&&(S.expand=r.expand),r.item!==void 0&&(S.item=S.item?Object.assign(S.item,r.item):r.item)};e.applyTestItemUpdate=A;var I;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var D;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.Remove=2]="Remove",S[S.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",S[S.Retire=4]="Retire"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(r){}update(r){}remove(r,d){}complete(){}}e.IncrementalChangeCollector=P;class t{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(r){const d=this.createChangeCollector();for(const a of r)switch(a[0]){case 0:{const l=a[1];if(l.parent){if(this.items.has(l.parent)){const p=this.items.get(l.parent);p.children.add(l.item.extId);const v=this.createItem(l,p);this.items.set(l.item.extId,v),d.add(v)}}else{const p=this.createItem(l);this.roots.add(p),this.items.set(l.item.extId,p),d.add(p)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=a[1],p=this.items.get(l.extId);if(!p)break;l.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,l),d.update(p);break}case 2:{const l=this.items.get(a[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l);const p=[[a[1]]];for(;p.length;)for(const v of p.pop()){const k=this.items.get(v);k&&(p.push(k.children),this.items.delete(v),d.remove(k,k!==l),k.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break}d.complete()}retireTest(r){}updatePendingRoots(r){this.pendingRootCount+=r}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=t}),define(Ee[67],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(T){T.Delimiter="\0"})(h=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class E{constructor(A,I=A.length){if(this.path=A,this.viewEnd=I,A.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,I,D=A.parent){if(A.id===I)return new E([I]);let P=[A.id];for(let t=D;t&&t.id!==I;t=t.parent)P.push(t.id);return P.push(I),new E(P.reverse())}static isRoot(A){return!A.includes("\0")}static fromString(A){return new E(A.split("\0"))}static join(A,I){return new E([...A.path,I])}static joinToString(A,I){return A.toString()+"\0"+I}static compare(A,I){return A===I?0:I.startsWith(A+"\0")?2:A.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new E(this.path,A)}compare(A){if(typeof A=="string")return E.compare(this.toString(),A);for(let I=0;I<A.viewEnd&&I<this.viewEnd;I++)if(A.path[I]!==this.path[I])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=E}),define(Ee[166],_e([0,1,17,90,10,22,26,76,135]),function(te,e,h,F,E,T,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(S,r,d){this._contributedVariables=new Map,this._context=S,this._labelService=r,d&&(this._envVariablesPromise=d.then(a=>this.prepareEnv(a)))}prepareEnv(S){if(A.isWindows){const r=Object.create(null);return Object.keys(S).forEach(d=>{r[d.toLowerCase()]=S[d]}),r}return S}resolveWithEnvironment(S,r,d){return this.recursiveResolve(this.prepareEnv(S),r?r.uri:void 0,d)}async resolveAsync(S,r){return this.recursiveResolve(await this._envVariablesPromise,S?S.uri:void 0,r)}async resolveAnyBase(S,r,d,a){const l=T.deepClone(r);return A.isWindows&&l.windows?Object.keys(l.windows).forEach(p=>l[p]=l.windows[p]):A.isMacintosh&&l.osx?Object.keys(l.osx).forEach(p=>l[p]=l.osx[p]):A.isLinux&&l.linux&&Object.keys(l.linux).forEach(p=>l[p]=l.linux[p]),delete l.windows,delete l.osx,delete l.linux,this.recursiveResolve(await this._envVariablesPromise,S?S.uri:void 0,l,d,a)}async resolveAnyAsync(S,r,d){return this.resolveAnyBase(S,r,d)}async resolveAnyMap(S,r,d){const a=new Map;return{newConfig:await this.resolveAnyBase(S,r,d,a),resolvedVariables:a}}resolveWithInteractionReplace(S,r,d,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,r,d,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,r){if(this._contributedVariables.has(S))throw new Error("Variable "+S+" is contributed twice.");this._contributedVariables.set(S,r)}recursiveResolve(S,r,d,a,l){if(E.isString(d))return this.resolveString(S,r,d,a,l);if(E.isArray(d))return d.map(p=>this.recursiveResolve(S,r,p,a,l));if(E.isObject(d)){let p=Object.create(null);return Object.keys(d).forEach(v=>{const k=this.resolveString(S,r,v,a,l);p[k]=this.recursiveResolve(S,r,d[v],a,l)}),p}return d}resolveString(S,r,d,a,l){return d.replace(P.VARIABLE_REGEXP,(v,k)=>{if(k.includes(P.VARIABLE_LHS))return v;let c=this.evaluateSingleVariable(S,v,k,r,a);return l&&l.set(k,c),c!==v&&E.isString(c)&&c.match(P.VARIABLE_REGEXP)&&(c=this.resolveString(S,r,c,a,l)),c})}fsPath(S){return this._labelService?this._labelService.getUriLabel(S,{noPrefix:!0}):S.fsPath}evaluateSingleVariable(S,r,d,a,l){let p;const v=d.split(":");v.length>1&&(d=v[0],p=v[1]);const k=()=>{const y=this._context.getFilePath();if(y)return y;throw new Error((0,D.localize)(0,null,r))},c=()=>{const y=k();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,D.localize)(1,null,r,h.basename(y)))},w=()=>{if(p){const y=this._context.getFolderUri(p);if(y)return y;throw new Error((0,D.localize)(2,null,r,p))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,r)):new Error((0,D.localize)(4,null,r))};switch(d){case"env":if(p){if(S){const y=S[A.isWindows?p.toLowerCase():p];if(E.isString(y))return y}return""}throw new Error((0,D.localize)(5,null,r));case"config":if(p){const y=this._context.getConfigurationValue(a,p);if(E.isUndefinedOrNull(y))throw new Error((0,D.localize)(6,null,r,p));if(E.isObject(y))throw new Error((0,D.localize)(7,null,r,p));return y}throw new Error((0,D.localize)(8,null,r));case"command":return this.resolveFromMap(r,p,l,"command");case"input":return this.resolveFromMap(r,p,l,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(w()));case"cwd":return a||p?(0,I.normalizeDriveLetter)(this.fsPath(w())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(w()));case"lineNumber":const y=this._context.getLineNumber();if(y)return y;throw new Error((0,D.localize)(9,null,r));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,D.localize)(10,null,r));case"file":return k();case"fileWorkspaceFolder":return c();case"relativeFile":return a||p?h.relative(this.fsPath(w()),k()):k();case"relativeFileDirname":const o=h.dirname(k());if(a||p){const m=h.relative(this.fsPath(w()),o);return m.length===0?".":m}return o;case"fileDirname":return h.dirname(k());case"fileExtname":return h.extname(k());case"fileBasename":return h.basename(k());case"fileBasenameNoExtension":const u=h.basename(k());return u.slice(0,u.length-h.extname(u).length);case"fileDirnameBasename":return h.basename(h.dirname(k()));case"execPath":const s=this._context.getExecPath();return s||r;case"execInstallFolder":const f=this._context.getAppRoot();return f||r;case"pathSeparator":return h.sep;default:try{const m=p?`${d}:${p}`:d;return this.resolveFromMap(r,m,l,void 0)}catch(m){return r}}}}resolveFromMap(S,r,d,a){if(r&&d){const l=a===void 0?d[r]:d[a+":"+r];if(typeof l=="string")return l;throw new Error((0,D.localize)(11,null,S))}return S}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[91],_e([0,1,4,159]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,h.createDecorator)("editorGroupsService");var E;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var T;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var I;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function P(l){const p=l;return(0,F.isEditorInput)(p?.editor)&&(0,F.isEditorInput)(p?.replacement)}e.isEditorReplacement=P;var t;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var S;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.EDITOR_OPEN=2]="EDITOR_OPEN",l[l.EDITOR_CLOSE=3]="EDITOR_CLOSE",l[l.EDITOR_MOVE=4]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=6]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=8]="EDITOR_PIN",l[l.EDITOR_STICKY=9]="EDITOR_STICKY",l[l.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(S=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function d(l){const p=l;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=d;function a(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=a}),define(Ee[167],_e([0,1,4,91]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,h.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(T){const A=T;return typeof T=="number"||(0,F.isEditorGroup)(A)}e.isPreferredGroup=E}),define(Ee[8],_e([0,1,16,75,229,52,22,10,2,41,57,136,81,63,88,67,167,6]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var k;(function(de){function ae(B){const{selectionStartLineNumber:ve,selectionStartColumn:ke,positionLineNumber:$e,positionColumn:xe}=B,lt=new v.Position(ve-1,ke-1),at=new v.Position($e-1,xe-1);return new v.Selection(lt,at)}de.to=ae;function ne(B){const{anchor:ve,active:ke}=B;return{selectionStartLineNumber:ve.line+1,selectionStartColumn:ve.character+1,positionLineNumber:ke.line+1,positionColumn:ke.character+1}}de.from=ne})(k=e.Selection||(e.Selection={}));var c;(function(de){function ae(B){if(!B)return;const{start:ve,end:ke}=B;return{startLineNumber:ve.line+1,startColumn:ve.character+1,endLineNumber:ke.line+1,endColumn:ke.character+1}}de.from=ae;function ne(B){if(!B)return;const{startLineNumber:ve,startColumn:ke,endLineNumber:$e,endColumn:xe}=B;return new v.Range(ve-1,ke-1,$e-1,xe-1)}de.to=ne})(c=e.Range||(e.Range={}));var w;(function(de){function ae(ne){switch(ne){case 1:return v.StandardTokenType.Comment;case 0:return v.StandardTokenType.Other;case 4:return v.StandardTokenType.RegEx;case 2:return v.StandardTokenType.String}}de.to=ae})(w=e.TokenType||(e.TokenType={}));var y;(function(de){function ae(B){return new v.Position(B.lineNumber-1,B.column-1)}de.to=ae;function ne(B){return{lineNumber:B.line+1,column:B.character+1}}de.from=ne})(y=e.Position||(e.Position={}));var i;(function(de){function ae(B){switch(B){case v.DiagnosticTag.Unnecessary:return 1;case v.DiagnosticTag.Deprecated:return 2}}de.from=ae;function ne(B){switch(B){case 1:return v.DiagnosticTag.Unnecessary;case 2:return v.DiagnosticTag.Deprecated;default:return}}de.to=ne})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(de){function ae(B){let ve;return B.code&&((0,I.isString)(B.code)||(0,I.isNumber)(B.code)?ve=String(B.code):ve={value:String(B.code.value),target:B.code.target}),{...c.from(B.range),message:B.message,source:B.source,code:ve,severity:s.from(B.severity),relatedInformation:B.relatedInformation&&B.relatedInformation.map(u.from),tags:Array.isArray(B.tags)?(0,h.coalesce)(B.tags.map(i.from)):void 0}}de.from=ae;function ne(B){const ve=new v.Diagnostic(c.to(B),B.message,s.to(B.severity));return ve.source=B.source,ve.code=(0,I.isString)(B.code)?B.code:B.code?.value,ve.relatedInformation=B.relatedInformation&&B.relatedInformation.map(u.to),ve.tags=B.tags&&(0,h.coalesce)(B.tags.map(i.to)),ve}de.to=ne})(o=e.Diagnostic||(e.Diagnostic={}));var u;(function(de){function ae(B){return{...c.from(B.location.range),message:B.message,resource:B.location.uri}}de.from=ae;function ne(B){return new v.DiagnosticRelatedInformation(new v.Location(B.resource,c.to(B)),B.message)}de.to=ne})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var s;(function(de){function ae(B){switch(B){case v.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}de.from=ae;function ne(B){switch(B){case r.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}de.to=ne})(s=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var f;(function(de){function ae(B){return typeof B=="number"&&B>=v.ViewColumn.One?B-1:B===v.ViewColumn.Beside?p.SIDE_GROUP:p.ACTIVE_GROUP}de.from=ae;function ne(B){if(typeof B=="number"&&B>=0)return B+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=ne})(f=e.ViewColumn||(e.ViewColumn={}));function m(de){return typeof de.range!="undefined"}function g(de){return de.length===0?!0:!!m(de[0])}e.isDecorationOptionsArr=g;var b;(function(de){function ae(xe){return xe.map(de.from)}de.fromMany=ae;function ne(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function B(xe){let lt;if(ne(xe)){const{language:nt,value:st}=xe;lt={value:"```"+nt+`
`+st+"\n```\n"}}else v.MarkdownString.isMarkdownString(xe)?lt={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons}:typeof xe=="string"?lt={value:xe}:lt={value:""};const at=Object.create(null);lt.uris=at;const bt=nt=>{try{let st=D.URI.parse(nt,!0);st=st.with({query:ve(st.query,at)}),at[nt]=st}catch(st){}return""},dt=new E.Renderer;return dt.link=bt,dt.image=nt=>bt(F.parseHrefAndDimensions(nt).href),E(lt.value,{renderer:dt}),lt}de.from=B;function ve(xe,lt){if(!xe)return xe;let at;try{at=(0,T.parse)(xe)}catch(dt){}if(!at)return xe;let bt=!1;return at=(0,A.cloneAndChange)(at,dt=>{if(D.URI.isUri(dt)){const nt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[nt]=dt,bt=!0,nt}else return}),bt?JSON.stringify(at):xe}function ke(xe){const lt=new v.MarkdownString(xe.value,xe.supportThemeIcons);return lt.isTrusted=xe.isTrusted,lt}de.to=ke;function $e(xe){if(!!xe)return typeof xe=="string"?xe:de.from(xe)}de.fromStrict=$e})(b=e.MarkdownString||(e.MarkdownString={}));function C(de){return g(de)?de.map(ae=>({range:c.from(ae.range),hoverMessage:Array.isArray(ae.hoverMessage)?b.fromMany(ae.hoverMessage):ae.hoverMessage?b.from(ae.hoverMessage):void 0,renderOptions:ae.renderOptions})):de.map(ae=>({range:c.from(ae)}))}e.fromRangeOrRangeWithMessage=C;function n(de){return typeof de=="undefined"?de:typeof de=="string"?D.URI.file(de):de}e.pathOrURIToURI=n;var _;(function(de){function ae(ne){return typeof ne=="undefined"?ne:{contentText:ne.contentText,contentIconPath:ne.contentIconPath?n(ne.contentIconPath):void 0,border:ne.border,borderColor:ne.borderColor,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,color:ne.color,backgroundColor:ne.backgroundColor,margin:ne.margin,width:ne.width,height:ne.height}}de.from=ae})(_=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(de){function ae(ne){return typeof ne=="undefined"?ne:{backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?n(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?_.from(ne.before):void 0,after:ne.after?_.from(ne.after):void 0}}de.from=ae})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var U;(function(de){function ae(ne){if(typeof ne=="undefined")return ne;switch(ne){case v.DecorationRangeBehavior.OpenOpen:return 0;case v.DecorationRangeBehavior.ClosedClosed:return 1;case v.DecorationRangeBehavior.OpenClosed:return 2;case v.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=ae})(U=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(de){function ae(ne){return{isWholeLine:ne.isWholeLine,rangeBehavior:ne.rangeBehavior?U.from(ne.rangeBehavior):void 0,overviewRulerLane:ne.overviewRulerLane,light:ne.light?R.from(ne.light):void 0,dark:ne.dark?R.from(ne.dark):void 0,backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?n(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?_.from(ne.before):void 0,after:ne.after?_.from(ne.after):void 0}}de.from=ae})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var le;(function(de){function ae(B){return{text:B.newText,eol:B.newEol&&G.from(B.newEol),range:c.from(B.range)}}de.from=ae;function ne(B){const ve=new v.TextEdit(c.to(B.range),B.text);return ve.newEol=typeof B.eol=="undefined"?void 0:G.to(B.eol),ve}de.to=ne})(le=e.TextEdit||(e.TextEdit={}));var he;(function(de){function ae(B,ve,ke){const $e={edits:[]};if(B instanceof v.WorkspaceEdit)for(let xe of B._allEntries())if(xe._type===1)$e.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const lt=ve?.getDocument(xe.uri);$e.edits.push({_type:2,resource:xe.uri,edit:le.from(xe.edit),modelVersionId:lt?.version,metadata:xe.metadata})}else xe._type===3?$e.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:ke?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&$e.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:ke?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(ht.from)}});return $e}de.from=ae;function ne(B){const ve=new v.WorkspaceEdit;for(const ke of B.edits)ke.edit?ve.replace(D.URI.revive(ke.resource),c.to(ke.edit.range),ke.edit.text):ve.renameFile(D.URI.revive(ke.oldUri),D.URI.revive(ke.newUri),ke.options);return ve}de.to=ne})(he=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(de){const ae=Object.create(null);ae[v.SymbolKind.File]=0,ae[v.SymbolKind.Module]=1,ae[v.SymbolKind.Namespace]=2,ae[v.SymbolKind.Package]=3,ae[v.SymbolKind.Class]=4,ae[v.SymbolKind.Method]=5,ae[v.SymbolKind.Property]=6,ae[v.SymbolKind.Field]=7,ae[v.SymbolKind.Constructor]=8,ae[v.SymbolKind.Enum]=9,ae[v.SymbolKind.Interface]=10,ae[v.SymbolKind.Function]=11,ae[v.SymbolKind.Variable]=12,ae[v.SymbolKind.Constant]=13,ae[v.SymbolKind.String]=14,ae[v.SymbolKind.Number]=15,ae[v.SymbolKind.Boolean]=16,ae[v.SymbolKind.Array]=17,ae[v.SymbolKind.Object]=18,ae[v.SymbolKind.Key]=19,ae[v.SymbolKind.Null]=20,ae[v.SymbolKind.EnumMember]=21,ae[v.SymbolKind.Struct]=22,ae[v.SymbolKind.Event]=23,ae[v.SymbolKind.Operator]=24,ae[v.SymbolKind.TypeParameter]=25;function ne(ve){return typeof ae[ve]=="number"?ae[ve]:6}de.from=ne;function B(ve){for(const ke in ae)if(ae[ke]===ve)return Number(ke);return v.SymbolKind.Property}de.to=B})(j=e.SymbolKind||(e.SymbolKind={}));var H;(function(de){function ae(B){switch(B){case v.SymbolTag.Deprecated:return 1}}de.from=ae;function ne(B){switch(B){case 1:return v.SymbolTag.Deprecated}}de.to=ne})(H=e.SymbolTag||(e.SymbolTag={}));var L;(function(de){function ae(B){return{name:B.name,kind:j.from(B.kind),tags:B.tags&&B.tags.map(H.from),containerName:B.containerName,location:z.from(B.location)}}de.from=ae;function ne(B){const ve=new v.SymbolInformation(B.name,j.to(B.kind),B.containerName,z.to(B.location));return ve.tags=B.tags&&B.tags.map(H.to),ve}de.to=ne})(L=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(de){function ae(B){const ve={name:B.name||"!!MISSING: name!!",detail:B.detail,range:c.from(B.range),selectionRange:c.from(B.selectionRange),kind:j.from(B.kind),tags:B.tags?.map(H.from)??[]};return B.children&&(ve.children=B.children.map(ae)),ve}de.from=ae;function ne(B){const ve=new v.DocumentSymbol(B.name,B.detail,j.to(B.kind),c.to(B.range),c.to(B.selectionRange));return(0,h.isNonEmptyArray)(B.tags)&&(ve.tags=B.tags.map(H.to)),B.children&&(ve.children=B.children.map(ne)),ve}de.to=ne})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var x;(function(de){function ae(B){const ve=new v.CallHierarchyItem(j.to(B.kind),B.name,B.detail||"",D.URI.revive(B.uri),c.to(B.range),c.to(B.selectionRange));return ve._sessionId=B._sessionId,ve._itemId=B._itemId,ve}de.to=ae;function ne(B,ve,ke){if(ve=ve??B._sessionId,ke=ke??B._itemId,ve===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:ke,name:B.name,detail:B.detail,kind:j.from(B.kind),uri:B.uri,range:c.from(B.range),selectionRange:c.from(B.selectionRange),tags:B.tags?.map(H.from)}}de.from=ne})(x=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Y;(function(de){function ae(ne){return new v.CallHierarchyIncomingCall(x.to(ne.from),ne.fromRanges.map(B=>c.to(B)))}de.to=ae})(Y=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ce;(function(de){function ae(ne){return new v.CallHierarchyOutgoingCall(x.to(ne.to),ne.fromRanges.map(B=>c.to(B)))}de.to=ae})(ce=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var z;(function(de){function ae(B){return{range:B.range&&c.from(B.range),uri:B.uri}}de.from=ae;function ne(B){return new v.Location(D.URI.revive(B.uri),c.to(B.range))}de.to=ne})(z=e.location||(e.location={}));var se;(function(de){function ae(B){const ve=B,ke=B;return{originSelectionRange:ve.originSelectionRange?c.from(ve.originSelectionRange):void 0,uri:ve.targetUri?ve.targetUri:ke.uri,range:c.from(ve.targetRange?ve.targetRange:ke.range),targetSelectionRange:ve.targetSelectionRange?c.from(ve.targetSelectionRange):void 0}}de.from=ae;function ne(B){return{targetUri:D.URI.revive(B.uri),targetRange:c.to(B.range),targetSelectionRange:B.targetSelectionRange?c.to(B.targetSelectionRange):void 0,originSelectionRange:B.originSelectionRange?c.to(B.originSelectionRange):void 0}}de.to=ne})(se=e.DefinitionLink||(e.DefinitionLink={}));var re;(function(de){function ae(B){return{range:c.from(B.range),contents:b.fromMany(B.contents)}}de.from=ae;function ne(B){return new v.Hover(B.contents.map(b.to),c.to(B.range))}de.to=ne})(re=e.Hover||(e.Hover={}));var we;(function(de){function ae(B){return{range:c.from(B.range),expression:B.expression}}de.from=ae;function ne(B){return new v.EvaluatableExpression(c.to(B.range),B.expression)}de.to=ne})(we=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Re;(function(de){function ae(B){if(B instanceof v.InlineValueText)return{type:"text",range:c.from(B.range),text:B.text};if(B instanceof v.InlineValueVariableLookup)return{type:"variable",range:c.from(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};if(B instanceof v.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(B.range),expression:B.expression};throw new Error("Unknown 'InlineValue' type")}de.from=ae;function ne(B){switch(B.type){case"text":return{range:c.to(B.range),text:B.text};case"variable":return{range:c.to(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};case"expression":return{range:c.to(B.range),expression:B.expression}}}de.to=ne})(Re=e.InlineValue||(e.InlineValue={}));var Fe;(function(de){function ae(B){return{frameId:B.frameId,stoppedLocation:c.from(B.stoppedLocation)}}de.from=ae;function ne(B){return new v.InlineValueContext(B.frameId,c.to(B.stoppedLocation))}de.to=ne})(Fe=e.InlineValueContext||(e.InlineValueContext={}));var Ne;(function(de){function ae(B){return{range:c.from(B.range),kind:B.kind}}de.from=ae;function ne(B){return new v.DocumentHighlight(c.to(B.range),B.kind)}de.to=ne})(Ne=e.DocumentHighlight||(e.DocumentHighlight={}));var Qe;(function(de){function ae(ne){switch(ne){case 1:return v.CompletionTriggerKind.TriggerCharacter;case 2:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return v.CompletionTriggerKind.Invoke}}de.to=ae})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(de){function ae(ne){return{triggerKind:Qe.to(ne.triggerKind),triggerCharacter:ne.triggerCharacter}}de.to=ae})(qe=e.CompletionContext||(e.CompletionContext={}));var Ke;(function(de){function ae(B){switch(B){case v.CompletionItemTag.Deprecated:return 1}}de.from=ae;function ne(B){switch(B){case 1:return v.CompletionItemTag.Deprecated}}de.to=ne})(Ke=e.CompletionItemTag||(e.CompletionItemTag={}));var N;(function(de){const ae=new Map([[v.CompletionItemKind.Method,0],[v.CompletionItemKind.Function,1],[v.CompletionItemKind.Constructor,2],[v.CompletionItemKind.Field,3],[v.CompletionItemKind.Variable,4],[v.CompletionItemKind.Class,5],[v.CompletionItemKind.Interface,7],[v.CompletionItemKind.Struct,6],[v.CompletionItemKind.Module,8],[v.CompletionItemKind.Property,9],[v.CompletionItemKind.Unit,12],[v.CompletionItemKind.Value,13],[v.CompletionItemKind.Constant,14],[v.CompletionItemKind.Enum,15],[v.CompletionItemKind.EnumMember,16],[v.CompletionItemKind.Keyword,17],[v.CompletionItemKind.Snippet,27],[v.CompletionItemKind.Text,18],[v.CompletionItemKind.Color,19],[v.CompletionItemKind.File,20],[v.CompletionItemKind.Reference,21],[v.CompletionItemKind.Folder,23],[v.CompletionItemKind.Event,10],[v.CompletionItemKind.Operator,11],[v.CompletionItemKind.TypeParameter,24],[v.CompletionItemKind.Issue,26],[v.CompletionItemKind.User,25]]);function ne(ke){return ae.get(ke)??9}de.from=ne;const B=new Map([[0,v.CompletionItemKind.Method],[1,v.CompletionItemKind.Function],[2,v.CompletionItemKind.Constructor],[3,v.CompletionItemKind.Field],[4,v.CompletionItemKind.Variable],[5,v.CompletionItemKind.Class],[7,v.CompletionItemKind.Interface],[6,v.CompletionItemKind.Struct],[8,v.CompletionItemKind.Module],[9,v.CompletionItemKind.Property],[12,v.CompletionItemKind.Unit],[13,v.CompletionItemKind.Value],[14,v.CompletionItemKind.Constant],[15,v.CompletionItemKind.Enum],[16,v.CompletionItemKind.EnumMember],[17,v.CompletionItemKind.Keyword],[27,v.CompletionItemKind.Snippet],[18,v.CompletionItemKind.Text],[19,v.CompletionItemKind.Color],[20,v.CompletionItemKind.File],[21,v.CompletionItemKind.Reference],[23,v.CompletionItemKind.Folder],[10,v.CompletionItemKind.Event],[11,v.CompletionItemKind.Operator],[24,v.CompletionItemKind.TypeParameter],[25,v.CompletionItemKind.User],[26,v.CompletionItemKind.Issue]]);function ve(ke){return B.get(ke)??v.CompletionItemKind.Property}de.to=ve})(N=e.CompletionItemKind||(e.CompletionItemKind={}));var q;(function(de){function ae(ne,B){const ve=new v.CompletionItem(ne.label);return ve.insertText=ne.insertText,ve.kind=N.to(ne.kind),ve.tags=ne.tags?.map(Ke.to),ve.detail=ne.detail,ve.documentation=F.isMarkdownString(ne.documentation)?b.to(ne.documentation):ne.documentation,ve.sortText=ne.sortText,ve.filterText=ne.filterText,ve.preselect=ne.preselect,ve.commitCharacters=ne.commitCharacters,P.Range.isIRange(ne.range)?ve.range=c.to(ne.range):typeof ne.range=="object"&&(ve.range={inserting:c.to(ne.range.insert),replacing:c.to(ne.range.replace)}),ve.keepWhitespace=typeof ne.insertTextRules=="undefined"?!1:Boolean(ne.insertTextRules&1),typeof ne.insertTextRules!="undefined"&&ne.insertTextRules&4?ve.insertText=new v.SnippetString(ne.insertText):(ve.insertText=ne.insertText,ve.textEdit=ve.range instanceof v.Range?new v.TextEdit(ve.range,ve.insertText):void 0),ne.additionalTextEdits&&ne.additionalTextEdits.length>0&&(ve.additionalTextEdits=ne.additionalTextEdits.map(ke=>le.to(ke))),ve.command=B&&ne.command?B.fromInternal(ne.command):void 0,ve}de.to=ae})(q=e.CompletionItem||(e.CompletionItem={}));var X;(function(de){function ae(B){return{label:B.label,documentation:B.documentation?b.fromStrict(B.documentation):void 0}}de.from=ae;function ne(B){return{label:B.label,documentation:F.isMarkdownString(B.documentation)?b.to(B.documentation):B.documentation}}de.to=ne})(X=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(de){function ae(B){return{label:B.label,documentation:B.documentation?b.fromStrict(B.documentation):void 0,parameters:Array.isArray(B.parameters)?B.parameters.map(X.from):[],activeParameter:B.activeParameter}}de.from=ae;function ne(B){return{label:B.label,documentation:F.isMarkdownString(B.documentation)?b.to(B.documentation):B.documentation,parameters:Array.isArray(B.parameters)?B.parameters.map(X.to):[],activeParameter:B.activeParameter}}de.to=ne})(ie=e.SignatureInformation||(e.SignatureInformation={}));var W;(function(de){function ae(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(ie.from):[]}}de.from=ae;function ne(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(ie.to):[]}}de.to=ne})(W=e.SignatureHelp||(e.SignatureHelp={}));var ee;(function(de){function ae(B){return{text:B.text,position:y.from(B.position),kind:me.from(B.kind??v.InlayHintKind.Other),whitespaceBefore:B.whitespaceBefore,whitespaceAfter:B.whitespaceAfter}}de.from=ae;function ne(B){const ve=new v.InlayHint(B.text,y.to(B.position),me.to(B.kind));return ve.whitespaceAfter=B.whitespaceAfter,ve.whitespaceBefore=B.whitespaceBefore,ve}de.to=ne})(ee=e.InlayHint||(e.InlayHint={}));var me;(function(de){function ae(B){return B}de.from=ae;function ne(B){return B}de.to=ne})(me=e.InlayHintKind||(e.InlayHintKind={}));var Te;(function(de){function ae(B){return{range:c.from(B.range),url:B.target,tooltip:B.tooltip}}de.from=ae;function ne(B){let ve;if(B.url)try{ve=typeof B.url=="string"?D.URI.parse(B.url,!0):D.URI.revive(B.url)}catch(ke){}return new v.DocumentLink(c.to(B.range),ve)}de.to=ne})(Te=e.DocumentLink||(e.DocumentLink={}));var Ue;(function(de){function ae(B){const ve=new v.ColorPresentation(B.label);return B.textEdit&&(ve.textEdit=le.to(B.textEdit)),B.additionalTextEdits&&(ve.additionalTextEdits=B.additionalTextEdits.map(ke=>le.to(ke))),ve}de.to=ae;function ne(B){return{label:B.label,textEdit:B.textEdit?le.from(B.textEdit):void 0,additionalTextEdits:B.additionalTextEdits?B.additionalTextEdits.map(ve=>le.from(ve)):void 0}}de.from=ne})(Ue=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(de){function ae(B){return new v.Color(B[0],B[1],B[2],B[3])}de.to=ae;function ne(B){return[B.red,B.green,B.blue,B.alpha]}de.from=ne})(He=e.Color||(e.Color={}));var be;(function(de){function ae(B){return{range:c.from(B.range)}}de.from=ae;function ne(B){return new v.SelectionRange(c.to(B.range))}de.to=ne})(be=e.SelectionRange||(e.SelectionRange={}));var Je;(function(de){function ae(ne){switch(ne){case 2:return v.TextDocumentSaveReason.AfterDelay;case 1:return v.TextDocumentSaveReason.Manual;case 3:case 4:return v.TextDocumentSaveReason.FocusOut}}de.to=ae})(Je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var $;(function(de){function ae(B){switch(B){case v.TextEditorLineNumbersStyle.Off:return 0;case v.TextEditorLineNumbersStyle.Relative:return 2;case v.TextEditorLineNumbersStyle.On:default:return 1}}de.from=ae;function ne(B){switch(B){case 0:return v.TextEditorLineNumbersStyle.Off;case 2:return v.TextEditorLineNumbersStyle.Relative;case 1:default:return v.TextEditorLineNumbersStyle.On}}de.to=ne})($=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var G;(function(de){function ae(B){if(B===v.EndOfLine.CRLF)return 1;if(B===v.EndOfLine.LF)return 0}de.from=ae;function ne(B){if(B===1)return v.EndOfLine.CRLF;if(B===0)return v.EndOfLine.LF}de.to=ne})(G=e.EndOfLine||(e.EndOfLine={}));var fe;(function(de){function ae(ne){if(typeof ne=="object")return ne.viewId;switch(ne){case v.ProgressLocation.SourceControl:return 3;case v.ProgressLocation.Window:return 10;case v.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=ae})(fe=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(de){function ae(ne){const B={start:ne.start+1,end:ne.end+1};return ne.kind&&(B.kind=Ve.from(ne.kind)),B}de.from=ae})(Le=e.FoldingRange||(e.FoldingRange={}));var Ve;(function(de){function ae(ne){if(ne)switch(ne){case v.FoldingRangeKind.Comment:return t.FoldingRangeKind.Comment;case v.FoldingRangeKind.Imports:return t.FoldingRangeKind.Imports;case v.FoldingRangeKind.Region:return t.FoldingRangeKind.Region}}de.from=ae})(Ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var et;(function(de){function ae(ne){if(ne)return{pinned:typeof ne.preview=="boolean"?!ne.preview:void 0,inactive:ne.background,preserveFocus:ne.preserveFocus,selection:typeof ne.selection=="object"?c.from(ne.selection):void 0,override:typeof ne.override=="boolean"?S.EditorResolution.DISABLED:void 0}}de.from=ae})(et=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var rt;(function(de){function ae(B){return B instanceof v.RelativePattern||typeof B=="string"?B:ne(B)?new v.RelativePattern(B.base,B.pattern):B}de.from=ae;function ne(B){const ve=B;return ve&&typeof ve.base=="string"&&typeof ve.pattern=="string"}})(rt=e.GlobPattern||(e.GlobPattern={}));var pt;(function(de){function ae(ne){if(ne){if(Array.isArray(ne))return ne.map(ae);if(typeof ne=="string")return ne;{const B=ne;return{language:B.language,scheme:B.scheme,pattern:typeof B.pattern=="undefined"?void 0:rt.from(B.pattern),exclusive:B.exclusive}}}else return}de.from=ae})(pt=e.LanguageSelector||(e.LanguageSelector={}));var St;(function(de){function ae(B){return{start:B.start,end:B.end}}de.from=ae;function ne(B){return new v.NotebookRange(B.start,B.end)}de.to=ne})(St=e.NotebookRange||(e.NotebookRange={}));var Ct;(function(de){function ae(B){return{timing:typeof B.runStartTime=="number"&&typeof B.runEndTime=="number"?{startTime:B.runStartTime,endTime:B.runEndTime}:void 0,executionOrder:B.executionOrder,success:B.lastRunSuccess}}de.to=ae;function ne(B){return{lastRunSuccess:B.success,runStartTime:B.timing?.startTime,runEndTime:B.timing?.endTime,executionOrder:B.executionOrder}}de.from=ne})(Ct=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ct;(function(de){function ae(B){switch(B){case v.NotebookCellKind.Markup:return a.CellKind.Markup;case v.NotebookCellKind.Code:default:return a.CellKind.Code}}de.from=ae;function ne(B){switch(B){case a.CellKind.Markup:return v.NotebookCellKind.Markup;case a.CellKind.Code:default:return v.NotebookCellKind.Code}}de.to=ne})(ct=e.NotebookCellKind||(e.NotebookCellKind={}));var _t;(function(de){function ae(B){const ve={metadata:B.metadata??Object.create(null),cells:[]};for(let ke of B.cells)v.NotebookCellData.validate(ke),ve.cells.push(ht.from(ke));return ve}de.from=ae;function ne(B){const ve=new v.NotebookData(B.cells.map(ht.to));return(0,I.isEmptyObject)(B.metadata)||(ve.metadata=B.metadata),ve}de.to=ne})(_t=e.NotebookData||(e.NotebookData={}));var ht;(function(de){function ae(B){return{cellKind:ct.from(B.kind),language:B.languageId,mime:B.mime,source:B.value,metadata:B.metadata,internalMetadata:Ct.from(B.executionSummary??{}),outputs:B.outputs?B.outputs.map(Ye.from):[]}}de.from=ae;function ne(B){return new v.NotebookCellData(ct.to(B.cellKind),B.source,B.language,B.mime,B.outputs?B.outputs.map(Ye.to):void 0,B.metadata,B.internalMetadata?Ct.to(B.internalMetadata):void 0)}de.to=ne})(ht=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(de){function ae(B){return{mime:B.mime,valueBytes:Array.from(B.data)}}de.from=ae;function ne(B){return new v.NotebookCellOutputItem(new Uint8Array(B.valueBytes),B.mime)}de.to=ne})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ye;(function(de){function ae(B){return{outputId:B.id,items:B.items.map(wt.from),metadata:B.metadata}}de.from=ae;function ne(B){const ve=B.items.map(wt.to);return new v.NotebookCellOutput(ve,B.outputId,B.metadata)}de.to=ne})(Ye=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pt;(function(de){function ae(ke){if(ke!=null){if(ke instanceof v.RelativePattern||typeof ke=="string")return ke;if(ve(ke))return new v.RelativePattern(ke.base,ke.pattern);if(B(ke))return{include:rt.from(ke.include)||void 0,exclude:rt.from(ke.exclude)||void 0}}}de.from=ae;function ne(ke){return typeof ke=="string"?ke:ve(ke)?{base:ke.base,pattern:ke.pattern}:{include:ke.include,exclude:ke.exclude}}de.to=ne;function B(ke){const $e=ke,xe=rt.from($e.include);if(!(xe&&xe instanceof v.RelativePattern||typeof xe=="string"))return!1;const lt=rt.from($e.exclude);return!!(lt&&lt instanceof v.RelativePattern||typeof lt=="string")}function ve(ke){const $e=ke;return $e&&typeof $e.base=="string"&&typeof $e.pattern=="string"}})(Pt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pe;(function(de){function ae(ne){return{backgroundColor:ne.backgroundColor,borderColor:ne.borderColor,top:ne.top?_.from(ne.top):void 0}}de.from=ae})(Pe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Se;(function(de){function ae(ne,B,ve){const ke=typeof ne.command=="string"?{title:"",command:ne.command}:ne.command;return{alignment:ne.alignment===v.NotebookCellStatusBarAlignment.Left?1:2,command:B.toInternal(ke,ve),text:ne.text,tooltip:ne.tooltip,accessibilityInformation:ne.accessibilityInformation,priority:ne.priority}}de.from=ae})(Se=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ce;(function(de){function ae(ne){return{transientOutputs:ne?.transientOutputs??!1,transientCellMetadata:ne?.transientCellMetadata??{},transientDocumentMetadata:ne?.transientDocumentMetadata??{}}}de.from=ae})(Ce=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var J;(function(de){function ae(B){return{uri:B.uri,provides:B.provides}}de.from=ae;function ne(B){return new v.NotebookRendererScript(D.URI.revive(B.uri),B.provides)}de.to=ne})(J=e.NotebookRendererScript||(e.NotebookRendererScript={}));var oe;(function(de){function ae(B){return{message:b.fromStrict(B.message)||"",type:0,expected:B.expectedOutput,actual:B.actualOutput,location:B.location?z.from(B.location):void 0}}de.from=ae;function ne(B){const ve=new v.TestMessage(typeof B.message=="string"?B.message:b.to(B.message));return ve.actualOutput=B.actual,ve.expectedOutput=B.expected,ve}de.to=ne})(oe=e.TestMessage||(e.TestMessage={}));var pe;(function(de){let ae;(function(B){B.Delimiter="\0"})(ae||(ae={})),de.namespace=(B,ve)=>B+"\0"+ve;function ne(B,ve){return{displayId:ve.id,id:de.namespace(B,ve.id),label:ve.label}}de.display=ne,de.denamespace=B=>{const ve=B.indexOf("\0");return{ctrlId:B.slice(0,ve),tagId:B.slice(ve+1)}}})(pe=e.TestTag||(e.TestTag={}));var ge;(function(de){function ae(ke){const $e=(0,d.getPrivateApiFor)(ke).controllerId;return{extId:l.TestId.fromExtHostTestItem(ke,$e).toString(),label:ke.label,uri:ke.uri,tags:ke.tags.map(xe=>pe.namespace($e,xe.id)),range:c.from(ke.range)||null,description:ke.description||null,error:ke.error&&b.fromStrict(ke.error)||null}}de.from=ae;function ne(ke){return{id:l.TestId.fromString(ke.extId).localId,label:ke.label,uri:D.URI.revive(ke.uri),tags:(ke.tags||[]).map($e=>{const{tagId:xe}=pe.denamespace($e);return new v.TestTag(xe,xe)}),range:c.to(ke.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:ke.description||void 0}}de.toPlain=ne;function B(ke){const $e=l.TestId.fromString(ke.extId),xe=new d.TestItemImpl($e.controllerId,$e.localId,ke.label,D.URI.revive(ke.uri));return xe.range=c.to(ke.range||void 0),xe.description=ke.description||void 0,xe}function ve(ke){let $e;for(const xe of ke.tests){const lt=B(xe.item);(0,d.getPrivateApiFor)(lt).parent=$e,$e=lt}return $e}de.toItemFromContext=ve})(ge=e.TestItem||(e.TestItem={})),function(de){function ae(B){return{id:B.id,label:B.label}}de.from=ae;function ne(B){return new v.TestTag(B.id,B.label)}de.to=ne}(pe=e.TestTag||(e.TestTag={}));var Ie;(function(de){const ae=(B,ve)=>{const ke={...ge.toPlain(B.item),parent:void 0,taskStates:B.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(xe=>xe.type===0).map(oe.to)})),children:B.children.map($e=>ve.get($e)).filter(I.isDefined).map($e=>ae($e,ve))};for(const $e of ke.children)$e.parent=ke;return ke};function ne(B){const ve=[],ke=new Map;for(const $e of B.items)ke.set($e.item.extId,$e),B.request.targets.some(xe=>xe.controllerId===$e.controllerId&&xe.testIds.includes($e.item.extId))&&ve.push($e);return{completedAt:B.completedAt,results:ve.map($e=>ae($e,ke))}}de.to=ne})(Ie=e.TestResults||(e.TestResults={}));var Be;(function(de){function ae(ke){return{covered:ke.covered,total:ke.covered}}function ne(ke){return"line"in ke?y.from(ke):c.from(ke)}function B(ke){return"branches"in ke?{count:ke.executionCount,location:ne(ke.location),type:1,branches:ke.branches.length?ke.branches.map($e=>({count:$e.executionCount,location:$e.location&&ne($e.location)})):void 0}:{type:0,count:ke.executionCount,location:ne(ke.location)}}de.fromDetailed=B;function ve(ke){return{uri:ke.uri,statement:ae(ke.statementCoverage),branch:ke.branchCoverage&&ae(ke.branchCoverage),function:ke.functionCoverage&&ae(ke.functionCoverage),details:ke.detailedCoverage?.map(B)}}de.fromFile=ve})(Be=e.TestCoverage||(e.TestCoverage={}));var Me;(function(de){function ae(ne){switch(ne){case 1:return v.CodeActionTriggerKind.Invoke;case 2:return v.CodeActionTriggerKind.Automatic}}de.to=ae})(Me=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var je;(function(de){function ae(B){const ve=new v.TypeHierarchyItem(j.to(B.kind),B.name,B.detail||"",D.URI.revive(B.uri),c.to(B.range),c.to(B.selectionRange));return ve._sessionId=B._sessionId,ve._itemId=B._itemId,ve}de.to=ae;function ne(B,ve,ke){if(ve=ve??B._sessionId,ke=ke??B._itemId,ve===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:ke,kind:j.from(B.kind),name:B.name,detail:B.detail??"",uri:B.uri,range:c.from(B.range),selectionRange:c.from(B.selectionRange),tags:B.tags?.map(H.from)}}de.from=ne})(je=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[168],_e([0,1,2,15,6,8,230]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(P,t,S,r={timeout:1500,errors:3}){this._logService=P,this._documents=t,this._mainThreadBulkEdits=S,this._thresholds=r,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(t,S,r)=>{const a={dispose:this._callbacks.push([t,S,P])};return Array.isArray(r)&&r.push(a),a}}async $participateInSave(P,t){const S=h.URI.revive(P);let r=!1;const d=setTimeout(()=>r=!0,this._thresholds.timeout),a=[];try{for(let l of[...this._callbacks]){if(r)break;const p=this._documents.getDocument(S),v=await this._deliverEventAsyncAndBlameBadListeners(l,{document:p,reason:T.TextDocumentSaveReason.to(t)});a.push(v)}}finally{clearTimeout(d)}return a}_deliverEventAsyncAndBlameBadListeners([P,t,S],r){const d=this._badListeners.get(P);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(S,P,t,r).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const l=this._badListeners.get(P);this._badListeners.set(P,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,t,S,r){const d=[],a=Date.now(),{document:l,reason:p}=r,{version:v}=l,k=Object.freeze({document:l,reason:p,waitUntil(c){if(Object.isFrozen(d))throw(0,F.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(c))}});try{t.apply(S,[k])}catch(c){return Promise.reject(c)}return Object.freeze(d),new Promise((c,w)=>{const y=setTimeout(()=>w(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(y),c(i)}).catch(i=>{clearTimeout(y),w(i)})}).then(c=>{const w={edits:[]};for(const y of c)if(Array.isArray(y)&&y.every(i=>i instanceof E.TextEdit))for(const{newText:i,newEol:o,range:u}of y)w.edits.push({_type:2,resource:l.uri,edit:{range:u&&T.Range.from(u),text:i,eol:o&&T.EndOfLine.from(o)}});if(w.edits.length!==0)return v===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(w):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(Ee[169],_e([0,1,3,27,2,8,6]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(t,S,r,d,a){this._onDidCreate=new h.Emitter,this._onDidChange=new h.Emitter,this._onDidDelete=new h.Emitter,this._config=0,r&&(this._config+=1),d&&(this._config+=2),a&&(this._config+=4);const l=(0,F.parse)(S),p=t(v=>{if(!r)for(let k of v.created){const c=E.URI.revive(k);l(c.fsPath)&&this._onDidCreate.fire(c)}if(!d)for(let k of v.changed){const c=E.URI.revive(k);l(c.fsPath)&&this._onDidChange.fire(c)}if(!a)for(let k of v.deleted){const c=E.URI.revive(k);l(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(t,S,r){this._logService=S,this._extHostDocumentsAndEditors=r,this._onFileSystemEvent=new h.Emitter,this._onDidRenameFile=new h.Emitter,this._onDidCreateFile=new h.Emitter,this._onDidDeleteFile=new h.Emitter,this._onWillRenameFile=new h.AsyncEmitter,this._onWillCreateFile=new h.AsyncEmitter,this._onWillDeleteFile=new h.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,S,r,d){return new I(this._onFileSystemEvent.event,t,S,r,d)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,S){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:S.map(r=>({oldUri:E.URI.revive(r.source),newUri:E.URI.revive(r.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:S.map(r=>E.URI.revive(r.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:S.map(r=>E.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,S){return(r,d,a)=>{const l=function(v){r.call(d,v)};return l.extension=t,S.event(l,void 0,a)}}async $onWillRunFileOperation(t,S,r,d){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:S.map(a=>({oldUri:E.URI.revive(a.source),newUri:E.URI.revive(a.target)}))},r,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:S.map(a=>E.URI.revive(a.target))},r,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:S.map(a=>E.URI.revive(a.target))},r,d)}}async _fireWillEvent(t,S,r,d){const a=new Set,l=[];if(await t.fireAsync(S,d,async(v,k)=>{const c=Date.now(),w=await Promise.resolve(v);w instanceof A.WorkspaceEdit&&(l.push(w),a.add(k.extension.displayName??k.extension.identifier.value)),Date.now()-c>r&&this._logService.warn("SLOW file-participant",k.extension.identifier)}),d.isCancellationRequested||l.length===0)return;const p={edits:[]};for(let v of l){let{edits:k}=T.WorkspaceEdit.from(v,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(k)}return{edit:p,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=D}),define(Ee[170],_e([0,1,11,22,2,8,6,88]),function(te,e,h,F,E,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(r,d,a,l){this.start=r,this.deletedCount=d,this.deletedItems=a,this.items=l}static asApiEvents(r){return r.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(a=>a.apiCell)}))}}class P{constructor(r,d,a){this.notebook=r,this._extHostDocument=d,this._cellData=a,this.handle=a.handle,this.uri=E.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=a.internalMetadata??{},this._metadata=Object.freeze(a.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(a.internalMetadata??{}))}static asModelAddData(r,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:r}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const r=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return r.notebook.getCellIndex(r)},notebook:r.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return r._mime},set mime(a){r._mime=a},get outputs(){return r._outputs.slice(0)},get metadata(){return r._metadata},get executionSummary(){return r._previousResult}})}return this._apiCell}setOutputs(r){this._outputs=r.map(T.NotebookCellOutput.to)}setOutputItems(r,d,a){const l=a.map(T.NotebookCellOutputItem.to),p=this._outputs.find(v=>v.id===r);p&&(d||(p.items.length=0),p.items.push(...l))}setMetadata(r){this._metadata=Object.freeze(r)}setInternalMetadata(r){this._internalMetadata=r,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(r))}setMime(r){}}e.ExtHostCell=P;class t{constructor(r,d,a,l,p,v){this._proxy=r,this._textDocumentsAndEditors=d,this._textDocuments=a,this._emitter=l,this.uri=p,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=v.viewType,this._metadata=Object.freeze(v.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,v.cells]],!0),this._versionId=v.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const r=this;this._notebook={get uri(){return r.uri},get version(){return r._versionId},get notebookType(){return r._notebookType},get isDirty(){return r._isDirty},get isUntitled(){return r.uri.scheme===h.Schemas.untitled},get isClosed(){return r._disposed},get metadata(){return r._metadata},get cellCount(){return r._cells.length},cellAt(d){return d=r._validateIndex(d),r._cells[d].apiCell},getCells(d){return(d?r._getCells(d):r._cells).map(l=>l.apiCell)},save(){return r._save()}}}return this._notebook}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(r){r.metadata&&(this._metadata=Object.freeze({...this._metadata,...r.metadata}))}acceptDirty(r){this._isDirty=r}acceptModelChanged(r,d){this._versionId=r.versionId,this._isDirty=d;for(const a of r.rawEvents)a.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===I.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(r){return r=r|0,r<0?0:r>=this._cells.length?this._cells.length-1:r}_validateRange(r){let d=r.start|0,a=r.end|0;return d<0&&(d=0),a>this._cells.length&&(a=this._cells.length),r.with({start:d,end:a})}_getCells(r){r=this._validateRange(r);const d=[];for(let a=r.start;a<r.end;a++)d.push(this._cells[a]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(r,d){if(this._disposed)return;const a=[],l=[],p=[];r.reverse().forEach(v=>{const c=v[2].map(i=>{const o=new P(this,this._textDocumentsAndEditors,i);return d||l.push(P.asModelAddData(this.apiNotebook,i)),o}),w=new D(v[0],v[1],[],c),y=this._cells.splice(v[0],v[1],...c);for(const i of y)p.push(i.uri),w.deletedItems.push(i.apiCell);a.push(w)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:p}),d||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}_moveCell(r,d){const a=this._cells.splice(r,1);this._cells.splice(d,0,...a);const l=[new D(r,1,a.map(p=>p.apiCell),[]),new D(d,0,[],a)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(l)}))}_setCellOutputs(r,d){const a=this._cells[r];a.setOutputs(d),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(r,d,a,l){const p=this._cells[r];p.setOutputItems(d,a,l),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(r,d){const a=this._cells[r];a.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(a.uri,d)}_changeCellMime(r,d){const a=this._cells[r];a.apiCell.mime=d}_changeCellMetadata(r,d){const a=this._cells[r],l=a.apiCell.metadata;a.setMetadata(d);const p=a.apiCell.metadata;(0,F.equals)(l,p)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(r,d){const a=this._cells[r],l=a.internalMetadata;if(a.setInternalMetadata(d),l.runState!==d.runState){const p=d.runState??A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,state:p}))}}getCellFromApiCell(r){return this._cells.find(d=>d.apiCell===r)}getCellFromIndex(r){return this._cells[r]}getCell(r){return this._cells.find(d=>d.handle===r)}getCellIndex(r){return this._cells.indexOf(r)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(Ee[92],_e([0,1,6,8,15]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:P})}replaceCells(D,P,t){this._throwIfFinalized(),!(D===P&&t.length===0)&&this._collectedEdits.push({editType:1,index:D,count:P-D,cells:t.map(F.NotebookCellData.from)})}}class A{constructor(D,P,t,S,r,d){this.id=D,this._proxy=P,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=r,this._visibleRanges=S,this._viewColumn=d}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(P){if(!Array.isArray(P)||!P.every(h.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");D._selections=P,D._trySetSelections(P)},get visibleRanges(){return D._visibleRanges},revealRange(P,t){D._proxy.$tryRevealRange(D.id,F.NotebookRange.from(P),t??h.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(P){const t=new T(this.document.version);return P(t),D._applyEdit(t.finalize())},setDecorations(P,t){return D.setDecorations(P,t)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(F.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const P=[];let t=-1;for(let S=0;S<D.cellEdits.length;S++){if(t<0){P.push(D.cellEdits[S]),t++;continue}const d=P[t],a=D.cellEdits[S];if(d.editType===1&&a.editType===1&&d.index===a.index){d.cells.push(...D.cellEdits[S].cells),d.count+=D.cellEdits[S].count;continue}P.push(D.cellEdits[S]),t++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,P)}setDecorations(D,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return P.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(P),D.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(Ee[171],_e([0,1,8,146,125,21,50]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(S){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=S}withProgress(S,r,d){const a=this._handles++,{title:l,location:p,cancellable:v}=r,k={label:(0,E.localize)(0,null,S.displayName||S.name),id:S.identifier.value};return this._proxy.$startProgress(a,{location:h.ProgressLocation.from(p),title:l,source:k,cancellable:v},S),this._withProgress(a,d,!!v)}_withProgress(S,r,d){let a;d&&(a=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(S,a));const l=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),a&&a.dispose()};let p;try{p=r(new P(this._proxy,S),d&&a?a.token:T.CancellationToken.None)}catch(v){throw l(S),v}return p.then(v=>l(S),v=>l(S)),p}$acceptProgressCanceled(S){const r=this._mapHandleToCancellationSource.get(S);r&&(r.cancel(),this._mapHandleToCancellationSource.delete(S))}}e.ExtHostProgress=I;function D(t,S){return t.message=S.message,typeof S.increment=="number"&&(typeof t.increment=="number"?t.increment+=S.increment:t.increment=S.increment),t}class P extends F.Progress{constructor(S,r){super(d=>this.throttledReport(d));this._proxy=S,this._handle=r}throttledReport(S){this._proxy.$progressReport(this._handle,S)}}We([(0,A.throttle)(100,(t,S)=>D(t,S),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Ee[93],_e([0,1,39,15,51,8,6]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(r,d,a){const l=I._Keys.nextId();r.$registerTextEditorDecorationType(d.identifier,l,T.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:l,dispose(){r.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=I,I._Keys=new E.IdGenerator("TextEditorDecorationType");class D{constructor(r,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=r,this._documentVersionId=r.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(r,d){this._throwIfFinalized();let a=null;if(r instanceof A.Position)a=new A.Range(r,r);else if(r instanceof A.Range)a=r;else throw new Error("Unrecognized location");this._pushEdit(a,d,!1)}insert(r,d){this._throwIfFinalized(),this._pushEdit(new A.Range(r,r),d,!0)}delete(r){this._throwIfFinalized();let d=null;if(r instanceof A.Range)d=r;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(r,d,a){const l=this._document.validateRange(r);this._collectedEdits.push({range:l,text:d,forceMoveMarkers:a})}setEndOfLine(r){if(this._throwIfFinalized(),r!==A.EndOfLine.LF&&r!==A.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=r}}e.TextEditorEdit=D;class P{constructor(r,d,a,l){this._proxy=r,this._id=d,this._accept(a),this._logService=l;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(v){p._setTabSize(v)},get insertSpaces(){return p._insertSpaces},set insertSpaces(v){p._setInsertSpaces(v)},get cursorStyle(){return p._cursorStyle},set cursorStyle(v){p._setCursorStyle(v)},get lineNumbers(){return p._lineNumbers},set lineNumbers(v){p._setLineNumbers(v)}}}_accept(r){this._tabSize=r.tabSize,this._insertSpaces=r.insertSpaces,this._cursorStyle=r.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(r.lineNumbers)}_validateTabSize(r){if(r==="auto")return"auto";if(typeof r=="number"){const d=Math.floor(r);return d>0?d:null}if(typeof r=="string"){const d=parseInt(r,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(r){const d=this._validateTabSize(r);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(r){return r==="auto"?"auto":r==="false"?!1:Boolean(r)}_setInsertSpaces(r){const d=this._validateInsertSpaces(r);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(r){this._cursorStyle!==r&&(this._cursorStyle=r,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:r})))}_setLineNumbers(r){this._lineNumbers!==r&&(this._lineNumbers=r,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(r)})))}assign(r){const d={};let a=!1;if(typeof r.tabSize!="undefined"){const l=this._validateTabSize(r.tabSize);l==="auto"?(a=!0,d.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,a=!0,d.tabSize=l)}if(typeof r.insertSpaces!="undefined"){const l=this._validateInsertSpaces(r.insertSpaces);l==="auto"?(a=!0,d.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,a=!0,d.insertSpaces=l)}typeof r.cursorStyle!="undefined"&&this._cursorStyle!==r.cursorStyle&&(this._cursorStyle=r.cursorStyle,a=!0,d.cursorStyle=r.cursorStyle),typeof r.lineNumbers!="undefined"&&this._lineNumbers!==r.lineNumbers&&(this._lineNumbers=r.lineNumbers,a=!0,d.lineNumbers=T.TextEditorLineNumbersStyle.from(r.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(r){r.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=P;class t{constructor(r,d,a,l,p,v,k,c){this.id=r,this._proxy=d,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new P(this._proxy,this.id,v,a),this._visibleRanges=k,this._viewColumn=c;const w=this;this.value=Object.freeze({get document(){return l.getValue()},set document(y){throw(0,F.readonly)("document")},get selection(){return w._selections&&w._selections[0]},set selection(y){if(!(y instanceof A.Selection))throw(0,F.illegalArgument)("selection");w._selections=[y],w._trySetSelection()},get selections(){return w._selections},set selections(y){if(!Array.isArray(y)||y.some(i=>!(i instanceof A.Selection)))throw(0,F.illegalArgument)("selections");w._selections=y,w._trySetSelection()},get visibleRanges(){return w._visibleRanges},set visibleRanges(y){throw(0,F.readonly)("visibleRanges")},get options(){return w._options.value},set options(y){w._disposed||w._options.assign(y)},get viewColumn(){return w._viewColumn},set viewColumn(y){throw(0,F.readonly)("viewColumn")},edit(y,i={undoStopBefore:!0,undoStopAfter:!0}){if(w._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new D(l.getValue(),i);return y(o),w._applyEdit(o)},insertSnippet(y,i,o={undoStopBefore:!0,undoStopAfter:!0}){if(w._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=w._selections.map(s=>T.Range.from(s));else if(i instanceof A.Position){const{lineNumber:s,column:f}=T.Position.from(i);u=[{startLineNumber:s,startColumn:f,endLineNumber:s,endColumn:f}]}else if(i instanceof A.Range)u=[T.Range.from(i)];else{u=[];for(const s of i)if(s instanceof A.Range)u.push(T.Range.from(s));else{const{lineNumber:f,column:m}=T.Position.from(s);u.push({startLineNumber:f,startColumn:m,endLineNumber:f,endColumn:m})}}return d.$tryInsertSnippet(r,y.value,u,o)},setDecorations(y,i){const o=i.length===0;o&&!w._hasDecorationsForKey.has(y.key)||(o?w._hasDecorationsForKey.delete(y.key):w._hasDecorationsForKey.add(y.key),w._runOnProxy(()=>{if(T.isDecorationOptionsArr(i))return d.$trySetDecorations(r,y.key,T.fromRangeOrRangeWithMessage(i));{const u=new Array(4*i.length);for(let s=0,f=i.length;s<f;s++){const m=i[s];u[4*s]=m.start.line+1,u[4*s+1]=m.start.character+1,u[4*s+2]=m.end.line+1,u[4*s+3]=m.end.character+1}return d.$trySetDecorationsFast(r,y.key,u)}}))},revealRange(y,i){w._runOnProxy(()=>d.$tryRevealRange(r,T.Range.from(y),i||A.TextEditorRevealType.Default))},show(y){d.$tryShowEditor(r,T.ViewColumn.from(y))},hide(){d.$tryHideEditor(r)}})}dispose(){(0,h.ok)(!this._disposed),this._disposed=!0}_acceptOptions(r){(0,h.ok)(!this._disposed),this._options._accept(r)}_acceptVisibleRanges(r){(0,h.ok)(!this._disposed),this._visibleRanges=r}_acceptViewColumn(r){(0,h.ok)(!this._disposed),this._viewColumn=r}_acceptSelections(r){(0,h.ok)(!this._disposed),this._selections=r}async _trySetSelection(){const r=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,r)),this.value}_applyEdit(r){const d=r.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const a=d.edits.map(p=>p.range);a.sort((p,v)=>p.end.line===v.end.line?p.end.character===v.end.character?p.start.line===v.start.line?p.start.character-v.start.character:p.start.line-v.start.line:p.end.character-v.end.character:p.end.line-v.end.line);for(let p=0,v=a.length-1;p<v;p++){const k=a[p].end;if(a[p+1].start.isBefore(k))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=d.edits.map(p=>({range:T.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,l,{setEndOfLine:typeof d.setEndOfLine=="number"?T.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(r){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):r().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=t}),define(Ee[172],_e([0,1,128,24,2,3,7,160,13,6,10,16,8,21,157]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(k,c){if((0,t.isString)(k))return{label:k};if(k&&typeof k=="object"&&typeof k.label=="string"){let w;return Array.isArray(k.highlights)&&(w=k.highlights.filter(y=>y.length===2&&typeof y[0]=="number"&&typeof y[1]=="number"),w=w.length?w:void 0),{label:k.label,highlights:w}}}class p{constructor(c,w,y){this._proxy=c,this.commands=w,this.logService=y,this.treeViews=new Map;function i(o){return o&&o.$treeViewId&&o.$treeItemHandle}w.registerArgumentProcessor({processArgument:o=>i(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(u=>i(u)?this.convertArgument(u):u):o})}registerTreeDataProvider(c,w,y){const i=this.createTreeView(c,{treeDataProvider:w},y);return{dispose:()=>i.dispose()}}createTreeView(c,w,y){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=w.dragAndDropController!==void 0,o=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,canDragAndDrop:i}),u=this.createExtHostTreeView(c,w,y);return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get message(){return u.message},set message(s){u.message=s},get title(){return u.title},set title(s){u.title=s},get description(){return u.description},set description(s){u.description=s},reveal:(s,f)=>u.reveal(s,f),dispose:async()=>{await o,this.treeViews.delete(c),u.dispose()}}}$getChildren(c,w){const y=this.treeViews.get(c);return y?y.getChildren(w):Promise.reject(new Error((0,h.localize)(0,null,c)))}async $onDrop(c,w,y){const i=this.treeViews.get(c);if(!i)return Promise.reject(new Error((0,h.localize)(1,null,c)));const o=a.TreeDataTransferConverter.toITreeDataTransfer(w);if(o.items.has(I.TREE_ITEM_DATA_TRANSFER_TYPE)){const s=JSON.parse(await o.items.get(I.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(f=>i.getExtensionElement(f)).filter(f=>!!f);s.length>0?o.items.set(I.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(s)}):o.items.delete(I.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(o,y)}async $hasResolve(c){const w=this.treeViews.get(c);if(!w)throw new Error((0,h.localize)(2,null,c));return w.hasResolve}$resolve(c,w,y){const i=this.treeViews.get(c);if(!i)throw new Error((0,h.localize)(3,null,c));return i.resolveTreeItem(w,y)}$setExpanded(c,w,y){const i=this.treeViews.get(c);if(!i)throw new Error((0,h.localize)(4,null,c));i.setExpanded(w,y)}$setSelection(c,w){const y=this.treeViews.get(c);if(!y)throw new Error((0,h.localize)(5,null,c));y.setSelection(w)}$setVisible(c,w){const y=this.treeViews.get(c);if(!y)throw new Error((0,h.localize)(6,null,c));y.setVisible(w)}createExtHostTreeView(c,w,y){const i=new v(c,w,this._proxy,this.commands.converter,this.logService,y);return this.treeViews.set(c,i),i}convertArgument(c){const w=this.treeViews.get(c.$treeViewId);return w?w.getExtensionElement(c.$treeItemHandle):null}}e.ExtHostTreeViews=p;class v extends A.Disposable{constructor(c,w,y,i,o,u){super();if(this.viewId=c,this.proxy=y,this.commands=i,this.logService=o,this.extension=u,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,u.contributes&&u.contributes.views)for(const m in u.contributes.views)for(const g of u.contributes.views[m])g.id===c&&(this._title=g.name);this.dataProvider=w.treeDataProvider,this.dndController=w.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(m=>this._onDidChangeData.fire({message:!1,element:m}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(m=>this._onDidChangeData.fire({message:!1,element:m})));let s,f;this._register(T.Event.debounce(this._onDidChangeData.event,(m,g)=>(m||(m={message:!1,elements:[]}),g.element!==!1&&(s||(s=new Promise(b=>f=b),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(g.element)?m.elements.push(...g.element):m.elements.push(g.element)),g.message&&(m.message=!0),m),200,!0)(({message:m,elements:g})=>{g.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=f;return s=null,this.refresh(g).then(()=>b())})),m&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,t.isUndefinedOrNull)(c))}async getChildren(c){const w=c?this.getExtensionElement(c):void 0;if(c&&!w)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let y=this.getChildrenNodes(c);return y||(y=await this.fetchChildrenNodes(w)),y?y.map(i=>i.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,w){w=w||{select:!0,focus:!1};const y=(0,t.isUndefinedOrNull)(w.select)?!0:w.select,i=(0,t.isUndefinedOrNull)(w.focus)?!1:w.focus,o=(0,t.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(u=>this.resolveTreeNode(c,u[u.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:u.map(f=>f.item)},{select:y,focus:i,expand:o})),u=>this.logService.error(u)):this.proxy.$reveal(this.viewId,void 0,{select:y,focus:i,expand:o})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}setExpanded(c,w){const y=this.getExtensionElement(c);y&&(w?this._onDidExpandElement.fire(Object.freeze({element:y})):this._onDidCollapseElement.fire(Object.freeze({element:y})))}setSelection(c){(0,S.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(c,w){const y=this.getExtensionElement(w);if(!!y)return(0,D.asPromise)(()=>this.dndController?.onDrop(c,y))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,w){if(!this.dataProvider.resolveTreeItem)return;const y=this.elements.get(c);if(y){const i=this.nodes.get(y);if(i){const o=await this.dataProvider.resolveTreeItem(i.extensionItem,y,w)??i.extensionItem;return i.item.tooltip=this.getTooltip(o.tooltip),i.item.command=this.getCommand(i.disposableStore,o.command),i.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(w=>w?this.resolveUnknownParentChain(w).then(y=>this.resolveTreeNode(w,y[y.length-1]).then(i=>(y.push(i),y))):Promise.resolve([]))}resolveParent(c){const w=this.nodes.get(c);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,w){const y=this.nodes.get(c);return y?Promise.resolve(y):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(i=>this.createHandle(c,i,w,!0)).then(i=>this.getChildren(w?w.item.handle:void 0).then(()=>{const o=this.getExtensionElement(i);if(o){const u=this.nodes.get(o);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(c){if(c){let w;if(typeof c=="string"){const y=this.getExtensionElement(c);w=y?this.nodes.get(y):void 0}else w=c;return w&&w.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const w=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const y=c?this.nodes.get(c):void 0,i=await this.dataProvider.getChildren(c);if(w.token.isCancellationRequested)return;const o=await Promise.all((0,S.coalesce)(i||[]).map(async u=>{const s=await this.dataProvider.getTreeItem(u);return s&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(u,s,y):null}));return w.token.isCancellationRequested?void 0:(0,S.coalesce)(o)}finally{w.dispose()}}refresh(c){if(c.some(y=>!y))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const y=this.getHandlesToRefresh(c);if(y.length)return this.refreshHandles(y)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const w=new Set,y=c.map(o=>this.nodes.get(o));for(const o of y)if(o&&!w.has(o.item.handle)){let u=o;for(;u&&u.parent&&y.findIndex(s=>u&&u.parent&&s&&s.item.handle===u.parent.item.handle)===-1;){const s=this.elements.get(u.parent.item.handle);u=s?this.nodes.get(s):void 0}u&&!u.parent&&w.add(o.item.handle)}const i=[];return w.forEach(o=>{const u=this.elements.get(o);if(u){const s=this.nodes.get(u);s&&(!s.parent||!w.has(s.parent.item.handle))&&i.push(o)}}),i}refreshHandles(c){const w={};return Promise.all(c.map(y=>this.refreshNode(y).then(i=>{i&&(w[y]=i.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(c){const w=this.getExtensionElement(c);if(w){const y=this.nodes.get(w);if(y)return this.clearChildren(w),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(i=>{if(i){const o=this.createTreeNode(w,i,y.parent);return this.updateNodeCache(w,o,y,y.parent),y.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,w,y){const i=this.createTreeNode(c,w,y);if(w.id&&this.elements.has(i.item.handle))throw new Error((0,h.localize)(7,null,w.id));return this.addNodeToCache(c,i),this.addNodeToParentCache(i,y),i}getTooltip(c){return P.MarkdownString.isMarkdownString(c)?r.MarkdownString.from(c):c}getCommand(c,w){return w?this.commands.toInternal(w,c):void 0}createTreeNode(c,w,y){const i=new A.DisposableStore,o=this.createHandle(c,w,y),u=this.getLightIconPath(w);return{item:{handle:o,parentHandle:y?y.item.handle:void 0,label:l(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(i,w.command),contextValue:w.contextValue,icon:u,iconDark:this.getDarkIconPath(w)||u,themeIcon:this.getThemeIcon(w),collapsibleState:(0,t.isUndefinedOrNull)(w.collapsibleState)?P.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation},extensionItem:w,parent:y,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(c){return c.iconPath instanceof P.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:w,label:y,resourceUri:i},o,u){if(w)return`${v.ID_HANDLE_PREFIX}/${w}`;const s=l(y,this.extension),f=o?o.item.handle:v.LABEL_HANDLE_PREFIX;let m=s?s.label:i?(0,F.basename)(i):"";m=m.indexOf("/")!==-1?m.replace("/","//"):m;const g=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,b=this.getChildrenNodes(o)||[];let C,n=0;do{if(C=`${f}/${n}:${m}`,u||!this.elements.has(C)||g===C)break;n++}while(n<=b.length);return C}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof P.ThemeIcon))return typeof c.iconPath=="string"||E.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof P.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return E.URI.isUri(c)?c:E.URI.file(c)}addNodeToCache(c,w){this.elements.set(w.item.handle,c),this.nodes.set(c,w)}updateNodeCache(c,w,y,i){this.elements.delete(w.item.handle),this.nodes.delete(c),w.item.handle!==y.item.handle&&this.elements.delete(y.item.handle),this.addNodeToCache(c,w);const o=this.getChildrenNodes(i)||[],u=o.filter(s=>s.item.handle===y.item.handle)[0];u&&o.splice(o.indexOf(u),1,w)}addNodeToParentCache(c,w){w?(w.children||(w.children=[]),w.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const w=this.nodes.get(c);if(w){if(w.children)for(const y of w.children){const i=this.elements.get(y.item.handle);i&&this.clear(i)}w.children=void 0}}else this.clearAll()}clear(c){const w=this.nodes.get(c);if(w){if(w.children)for(const y of w.children){const i=this.elements.get(y.item.handle);i&&this.clear(i)}this.nodes.delete(c),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(Ee[173],_e([0,1,13,3,7,10,63,8,89,67]),function(te,e,h,F,E,T,A,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(r){super();this.controllerId=r,this.debounceSendDiff=this._register(new h.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(r){this._resolveHandler=r;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const r=this.diff;return this.diff=[],r}*tags(){const r=new Set;for(const d of this.tree.values())for(const a of d.actual.tags)r.has(a.id)||(r.add(a.id),yield a)}pushDiff(r){const d=this.diff[this.diff.length-1];if(d&&r[0]===1){if(d[0]===1&&d[1].extId===r[1].extId){(0,D.applyTestItemUpdate)(d[1],r[1]);return}if(d[0]===0&&d[1].item.extId===r[1].extId){(0,D.applyTestItemUpdate)(d[1],r[1]);return}}this.diff.push(r),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(r,d){const a=this.tree.get(r);if(!!a){if((a.expandLevels===void 0||d>a.expandLevels)&&(a.expandLevels=d),a.expand===1){const l=this.resolveChildren(a);return l.isOpen()?this.expandChildren(a,d-1):l.wait().then(()=>this.expandChildren(a,d-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,d-1)):this.expandChildren(a,d-1)}}dispose(){for(const r of this.tree.values())(0,A.getPrivateApiFor)(r.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(r,d){switch(d.op){case 2:this.pushDiff([4,r.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(r.fullId,d.id));break;case 0:this.upsertItem(d.item,r);break;case 4:for(const v of d.ops)this.onTestItemEvent(r,v);break;case 3:const{key:a,value:l}=d,p=r.fullId.toString();switch(a){case"canResolveChildren":this.updateExpandability(r);break;case"tags":this.pushDiff([1,{extId:p,item:{tags:l.map(v=>v.id)}}]);break;case"range":this.pushDiff([1,{extId:p,item:{range:I.Range.from(l)}}]);break;case"error":this.pushDiff([1,{extId:p,item:{error:I.MarkdownString.fromStrict(l)||null}}]);break;default:this.pushDiff([1,{extId:p,item:{[a]:l??null}}]);break}break;default:(0,T.assertNever)(d)}}upsertItem(r,d){if(!(r instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${r.id} did not`);const a=P.TestId.fromExtHostTestItem(r,this.root.id,d?.actual),l=(0,A.getPrivateApiFor)(r);l.parent&&l.parent!==d?.actual&&l.parent.children.delete(r.id);let p=this.tree.get(a.toString());if(!p){p={fullId:a,actual:r,parent:d?a.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},this.tree.set(p.fullId.toString(),p),this.setItemParent(r,d),this.pushDiff([0,{parent:p.parent&&p.parent.toString(),controllerId:this.controllerId,expand:p.expand,item:I.TestItem.from(r)}]),this.connectItemAndChildren(r,p,d);return}if(p.actual===r){this.connectItem(r,p,d);return}const v=p.actual.children,k=p.actual,c=(0,A.diffTestItems)(k,r);(0,A.getPrivateApiFor)(k).listener=void 0,p.actual=r,p.expand=0;for(const[w,y]of c)this.onTestItemEvent(p,{op:3,key:w,value:y});this.connectItemAndChildren(r,p,d);for(const w of v)r.children.get(w.id)||this.removeItem(P.TestId.joinToString(a,w.id))}setItemParent(r,d){(0,A.getPrivateApiFor)(r).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(r,d,a){this.setItemParent(r,a);const l=(0,A.getPrivateApiFor)(r);l.parent=a?.actual,l.listener=p=>this.onTestItemEvent(d,p),this.updateExpandability(d)}connectItemAndChildren(r,d,a){this.connectItem(r,d,a);for(const l of r.children)this.upsertItem(l,d)}updateExpandability(r){let d;this._resolveHandler?r.resolveBarrier?d=r.resolveBarrier.isOpen()?3:2:d=r.actual.canResolveChildren?1:0:d=0,d!==r.expand&&(r.expand=d,this.pushDiff([1,{extId:r.fullId.toString(),expand:d}]),d===1&&r.expandLevels!==void 0&&this.resolveChildren(r))}expandChildren(r,d){if(d<0)return;const a=[];for(const l of r.actual.children){const p=this.expand(P.TestId.joinToString(r.fullId,l.id),d);(0,h.isThenable)(p)&&a.push(p)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this._resolveHandler){const p=new h.Barrier;return p.open(),p}r.expand=2,this.pushExpandStateUpdate(r);const d=r.resolveBarrier=new h.Barrier,a=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),r.actual!==this.root&&(r.actual.error=p.stack||p.message||String(p))};let l;try{l=this._resolveHandler(r.actual===this.root?void 0:r.actual)}catch(p){a(p)}return(0,h.isThenable)(l)?l.catch(a).then(()=>{d.open(),this.updateExpandability(r)}):(d.open(),this.updateExpandability(r)),r.resolveBarrier}pushExpandStateUpdate(r){this.pushDiff([1,{extId:r.fullId.toString(),expand:r.expand}])}removeItem(r){const d=this.tree.get(r);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff([2,r]);const a=[d];for(;a.length;){const l=a.pop();if(!!l){(0,A.getPrivateApiFor)(l.actual).listener=void 0,this.tree.delete(l.fullId.toString());for(const p of l.actual.children)a.push(this.tree.get(P.TestId.joinToString(l.fullId,p.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.diffOpEmitter.fire(r)}}e.SingleUseTestCollection=t}),define(Ee[174],_e([0,1,4,141]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,h.refineServiceDecorator)(F.IEnvironmentService)}),define(Ee[175],_e([0,1,25,3,17]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=T;class A{constructor(t){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(h.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(h.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let S of t.activationEvents)S==="onUri"&&(S=`onUri:${h.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(S)||this._activationMap.set(S,[]),this._activationMap.get(S).push(t)}}keepOnly(t){const S=new Set;t.forEach(r=>S.add(h.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>S.has(h.ExtensionIdentifier.toKey(r.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,S){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const r=A._findLoopingExtensions(this._extensionDescriptions);if(S=S.concat(r.map(d=>d.identifier)),S.length>0){const d=new Set;S.forEach(a=>d.add(h.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!d.has(h.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(r)}static _findLoopingExtensions(t){const S=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,v){this.addNode(p),this.addNode(v),this._arcs.has(p)?this._arcs.get(p).push(v):this._arcs.set(p,[v])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,v){const k=S.getArcs(p);for(let c=0;c<k.length;c++)if(!v.has(k[c]))return!1;return!0}getNodes(){return this._nodesArr}};let r=new Map;for(let p of t){const v=h.ExtensionIdentifier.toKey(p.identifier);if(r.set(v,p),p.extensionDependencies)for(let k of p.extensionDependencies){const c=h.ExtensionIdentifier.toKey(k);S.addArc(v,c)}}let d=new Set;S.getNodes().filter(p=>S.getArcs(p).length===0).forEach(p=>d.add(p));let a=S.getNodes().filter(p=>!d.has(p)),l;do{l=!1;for(let p=0;p<a.length;p++){const v=a[p];S.hasOnlyGoodArcs(v,d)&&(a.splice(p,1),p--,d.add(v),l=!0)}}while(l);return a.map(p=>r.get(p))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(h.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const S=this._activationMap.get(t);return S?S.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const S=this._extensionsMap.get(h.ExtensionIdentifier.toKey(t));return S||void 0}}e.ExtensionDescriptionRegistry=A;var I;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(I||(I={}));function D(P,t){const S=P.isBuiltin?0:P.isUnderDevelopment?2:1,r=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(S!==r)return S-r;const d=E.posix.basename(P.extensionLocation.path),a=E.posix.basename(t.extensionLocation.path);return d<a?-1:d>a?1:0}}),define(Ee[176],_e([0,1,23]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function T(I){const D=h.VSBuffer.alloc(1);switch(I){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=T;function A(I,D){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=A}),define(Ee[30],_e([0,1,3,2,4,25,142]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");class I{constructor(k){this.dependency=k}}e.MissingExtensionDependency=I;var D;(function(v){v[v.LocalProcess=0]="LocalProcess",v[v.LocalWebWorker=1]="LocalWebWorker",v[v.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class P{constructor(k,c,w,y){this.codeLoadingTime=k,this.activateCallTime=c,this.activateResolvedTime=w,this.activationReason=y}}e.ActivationTimes=P;class t{constructor(k,c){this.description=k,this.value=c}}e.ExtensionPointContribution=t,e.ExtensionHostLogFileName="exthost";var S;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(S=e.ActivationKind||(e.ActivationKind={}));function r(v){v.enableProposedApi||d(v)}e.checkProposedApiEnabled=r;function d(v){throw new Error(`[${v.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.throwProposedApiError=d;function a(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation}}e.toExtension=a;function l(v,k){return{identifier:new T.ExtensionIdentifier(v.identifier.id),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!!k,extensionLocation:v.location,...v.manifest,uuid:v.identifier.uuid}}e.toExtensionDescription=l;class p{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None}activateByEvent(k){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(k){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(k){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(k){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(k,c){return Promise.resolve()}_onWillActivateExtension(k){}_onDidActivateExtension(k,c,w,y,i){}_onDidActivateExtensionError(k,c){}_onExtensionRuntimeError(k,c){}_onExtensionHostExit(k){}}e.NullExtensionService=p}),define(Ee[177],_e([0,1,25,30,14]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class A{constructor(a,l,p,v){this.startup=a,this.codeLoadingTime=l,this.activateCallTime=p,this.activateResolvedTime=v}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class I{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,l){return a===-1||l===-1?-1:l-a}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class D{constructor(a,l,p,v,k,c){this.activationFailed=a,this.activationFailedError=l,this.activationTimes=p,this.module=v,this.exports=k,this.subscriptions=c}}e.ActivatedExtension=D;class P extends D{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class t extends D{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class S extends D{constructor(a){super(!0,a,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=S;let r=class{constructor(a,l,p,v,k){this._logService=k,this._registry=a,this._resolvedExtensionsSet=new Set,l.forEach(c=>this._resolvedExtensionsSet.add(h.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,p.forEach(c=>this._hostExtensionsMap.set(h.ExtensionIdentifier.toKey(c),c)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const l=h.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(l)}getActivatedExtension(a){const l=h.ExtensionIdentifier.toKey(a),p=this._activatedExtensions.get(l);if(!p)throw new Error("Extension `"+a.value+"` is not known or not activated");return p}activateByEvent(a,l){if(this._alreadyActivatedEvents[a])return T;const p=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(p.map(v=>({id:v.identifier,reason:{startup:l,extensionId:v.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,l){const p=this._registry.getExtensionDescription(a);if(!p)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:p.identifier,reason:l}])}_handleActivateRequest(a,l,p){if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(a.id))){l[h.ExtensionIdentifier.toKey(a.id)]=a;return}const v=this._registry.getExtensionDescription(a.id);if(!v){const w=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,w,new F.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(a.id),new S(w));return}const k=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let c=!0;for(let w=0,y=k.length;w<y;w++){const i=k[w];if(this._resolvedExtensionsSet.has(h.ExtensionIdentifier.toKey(i)))continue;const o=this._activatedExtensions.get(h.ExtensionIdentifier.toKey(i));if(o&&!o.activationFailed)continue;if(o&&o.activationFailed){const m=v.displayName||v.identifier.value,g=this._registry.getExtensionDescription(i),b=g&&g.displayName||i,C=new Error(`Cannot activate the '${m}' extension because its dependency '${b}' failed to activate`);C.detail=o.activationFailedError,this._host.onExtensionActivationError(v.identifier,C,null),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(v.identifier),new S(C));return}if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(i))){c=!1,l[h.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(h.ExtensionIdentifier.toKey(i)),reason:a.reason};continue}const u=this._registry.getExtensionDescription(i);if(u){c=!1,l[h.ExtensionIdentifier.toKey(i)]={id:u.identifier,reason:a.reason};continue}const s=v.displayName||v.identifier.value,f=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(v.identifier,f,new F.MissingExtensionDependency(i)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(v.identifier),new S(f));return}c?l[h.ExtensionIdentifier.toKey(v.identifier)]=a:p.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(k=>!this._activatedExtensions.has(h.ExtensionIdentifier.toKey(k.id))),a.length===0))return Promise.resolve(void 0);const l=Object.create(null),p=[];for(let k=0,c=a.length;k<c;k++)this._handleActivateRequest(a[k],l,p);for(let k=0,c=p.length;k<c;k++){const w=h.ExtensionIdentifier.toKey(p[k].id);l[w]&&delete l[w]}const v=Object.keys(l).map(k=>l[k]);return p.length===0?Promise.all(v.map(k=>this._activateExtension(k.id,k.reason))).then(k=>{}):this._activateExtensions(v).then(k=>this._activateExtensions(p))}_activateExtension(a,l){const p=h.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const v=this._activatingExtensions.get(p);if(v)return v;const k=this._host.actualActivateExtension(a,l).then(void 0,c=>{const w=new Error;return c&&c.name&&(w.name=c.name),c&&c.message?w.message=`Activating extension '${a.value}' failed: ${c.message}.`:w.message=`Activating extension '${a.value}' failed: ${c}.`,c&&c.stack&&(w.stack=c.stack),this._host.onExtensionActivationError(a,w,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(c),new S(c)}).then(c=>{this._activatedExtensions.set(p,c),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,k),k}};r=We([ze(4,E.ILogService)],r),e.ExtensionsActivator=r}),define(Ee[178],_e([0,1,15]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,A)=>{this._actualOk=T,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,h.onUnexpectedError)(T))}then(T,A){return this._ensureActual().then(T,A)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=F}),define(Ee[94],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class h{constructor(D,P){this._proxyIdentifierBrand=void 0,this.isMain=D,this.sid=P,this.nid=++h.count}}e.ProxyIdentifier=h,h.count=0;const F=[];function E(I){const D=new h(!0,I);return F[D.nid]=D,D}e.createMainContextProxyIdentifier=E;function T(I){const D=new h(!1,I);return F[D.nid]=D,D}e.createExtHostContextProxyIdentifier=T;function A(I){return F[I].sid}e.getStringIdentifierForProxy=A}),define(Ee[5],_e([0,1,52,2,94]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var A;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var S;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(S=e.CandidatePortSource||(e.CandidatePortSource={}));var r;(function(c){c.name="$ident";function w(i,o){return Object.defineProperty(i,c.name,{value:o,enumerable:!0}),i}c.mixin=w;function y(i){return i[c.name]}c.of=y})(r=e.ObjectIdentifier||(e.ObjectIdentifier={}));class d{static mixin(w){return w._id=d._n++,w}}e.IdObject=d,d._n=0;var a;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function v(c){if(c&&c.edits)for(const w of c.edits)typeof w.resource=="object"?w.resource=F.URI.revive(w.resource):(w.newUri=F.URI.revive(w.newUri),w.oldUri=F.URI.revive(w.oldUri)),w.metadata&&w.metadata.iconPath&&(w.metadata=(0,h.revive)(w.metadata));return c}e.reviveWorkspaceEditDto=v;var k;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(k=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,E.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[68],_e([0,1,5,3,4]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(I){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(h.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,D){return this._proxy.$getPassword(I,D)}store(I,D,P){return this._proxy.$setPassword(I,D,P)}delete(I,D){return this._proxy.$deletePassword(I,D)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(Ee[69],_e([0,1,4,14,5,12]),function(te,e,h,F,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,h.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(E.MainContext.MainThreadTelemetry)}report(D,P,t){const S=this.getUsageKey(D,P);this._reportedUsages.has(S)||(this._reportedUsages.add(S),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};A=We([ze(0,T.IExtHostRpcService),ze(1,F.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(I,D,P){}})}),define(Ee[179],_e([0,1,3,5,6,25]),function(te,e,h,F,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new h.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,P,t,S={}){const r=T.ExtensionIdentifier.toKey(D.identifier),d=this._inFlightRequests.get(r)||[],a=[...t].sort().join(" ");let l=d.find(p=>p.scopes===a);if(l)return l.result;{const p=this._getSession(D,r,P,t,S);l={scopes:a,result:p},d.push(l),this._inFlightRequests.set(r,d);try{await p}finally{const v=d.findIndex(k=>k.scopes===a);v>-1&&(d.splice(v),this._inFlightRequests.set(r,d))}return p}}async _getSession(D,P,t,S,r={}){await this._proxy.$ensureProvider(t);const d=D.displayName||D.name;return this._proxy.$getSession(t,S,P,d,r)}async removeSession(D,P){const t=this._authenticationProviders.get(D);return t?t.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,t,S){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:t,options:S??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===D)||this._providers.push({id:D,label:P});const r=t.onDidChangeSessions(d=>{this._proxy.$sendDidChangeSessions(D,{added:d.added??[],changed:d.changed??[],removed:d.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,P,S?.supportsMultipleAccounts??!1),new E.Disposable(()=>{r.dispose(),this._authenticationProviders.delete(D);const d=this._providers.findIndex(a=>a.id===D);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(Ee[180],_e([0,1,5,12,8]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(I,D){this._extHostDocumentsAndEditors=D,this._proxy=I.getProxy(h.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const D=E.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};T=We([ze(0,F.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(Ee[181],_e([0,1,5]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(T){const A=T.getProxy(h.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(I){return A.$writeText(I)}})}}e.ExtHostClipboard=F}),define(Ee[46],_e([0,1,10,6,8,22,5,16,14,52,41,111,2,7,4,12]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(i,o){this._commands=new Map,this._apiCommands=new Map,this._proxy=i.getProxy(A.MainContext.MainThreadCommands),this._logService=o,this.converter=new v(this,u=>{const s=this._apiCommands.get(u);return s?.result===c.Void?s:void 0},o),this._argumentProcessors=[{processArgument(u){return(0,P.revive)(u)}},{processArgument(u){return(0,T.cloneAndChange)(u,function(s){if(t.Range.isIRange(s))return E.Range.to(s);if(S.Position.isIPosition(s))return E.Position.to(s);if(t.Range.isIRange(s.range)&&r.URI.isUri(s.uri))return E.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const o=this.registerCommand(!1,i.id,async(...u)=>{const s=i.args.map((m,g)=>{if(!m.validate(u[g]))throw new Error(`Invalid argument '${m.name}' when running '${i.id}', received: ${u[g]}`);return m.convert(u[g])}),f=await this.executeCommand(i.internalId,...s);return i.result.convert(f,u,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new F.Disposable(()=>{o.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,o,u,s,f){if(this._logService.trace("ExtHostCommands#registerCommand",o),!o.trim().length)throw new Error("invalid id");if(this._commands.has(o))throw new Error(`command '${o}' already exists`);return this._commands.set(o,{callback:u,thisArg:s,description:f}),i&&this._proxy.$registerCommand(o),new F.Disposable(()=>{this._commands.delete(o)&&i&&this._proxy.$unregisterCommand(o)})}executeCommand(i,...o){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,o,!0)}async _doExecuteCommand(i,o,u){if(this._commands.has(i))return this._executeContributedCommand(i,o);{const s=(0,T.cloneAndChange)(o,function(f){if(f instanceof F.Position)return E.Position.from(f);if(f instanceof F.Range)return E.Range.from(f);if(f instanceof F.Location)return E.location.from(f);if(F.NotebookRange.isNotebookRange(f))return E.NotebookRange.from(f);if(!Array.isArray(f))return f});try{const f=await this._proxy.$executeCommand(i,s,u);return(0,P.revive)(f)}catch(f){if(f instanceof Error&&f.message==="$executeCommand:retry")return this._doExecuteCommand(i,o,!1);throw f}}}async _executeContributedCommand(i,o){const u=this._commands.get(i);if(!u)throw new Error("Unknown command");let{callback:s,thisArg:f,description:m}=u;if(m)for(let g=0;g<m.args.length;g++)try{(0,h.validateConstraint)(o[g],m.args[g].constraint)}catch(b){throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${m.args[g].name}' - ${m.args[g].description}`)}try{return await s.apply(f,o)}catch(g){if(i===this.converter.delegatingCommandId){const b=this.converter.getActualCommand(...o);b&&(i=b.command)}throw this._logService.error(g,i),new Error(`Running the contributed command: '${i}' failed.`)}}$executeContributedCommand(i,...o){return this._logService.trace("ExtHostCommands#$executeContributedCommand",i),this._commands.has(i)?(o=o.map(u=>this._argumentProcessors.reduce((s,f)=>f.processArgument(s),u)),this._executeContributedCommand(i,o)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),this._proxy.$getCommands().then(o=>(i&&(o=o.filter(u=>u[0]!=="_")),o))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(let[o,u]of this._commands){let{description:s}=u;s&&(i[o]=s)}return Promise.resolve(i)}};p=We([ze(0,l.IExtHostRpcService),ze(1,D.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class v{constructor(i,o,u){this._commands=i,this._lookupApiCommand=o,this._logService=u,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,o){if(!i)return;const u={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return u;const s=this._lookupApiCommand(i.command);if(s)u.id=s.internalId,u.arguments=s.args.map((f,m)=>f.convert(i.arguments&&i.arguments[m]));else if((0,I.isNonEmptyArray)(i.arguments)){const f=++this._cachIdPool;this._cache.set(f,i),o.add((0,d.toDisposable)(()=>{this._cache.delete(f),this._logService.trace("CommandsConverter#DISPOSE",f)})),u.$ident=f,u.id=this.delegatingCommandId,u.arguments=[f],this._logService.trace("CommandsConverter#CREATE",i.command,f)}return u}fromInternal(i){const o=A.ObjectIdentifier.of(i);return typeof o=="number"?this._cache.get(o):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const o=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],o?o.command:"MISSING"),o?this._commands.executeCommand(o.command,...o.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class k{constructor(i,o,u,s){this.name=i,this.description=o,this.validate=u,this.convert=s}optional(){return new k(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,o){return new k(i??this.name,o??this.description,this.validate,this.convert)}}e.ApiCommandArgument=k,k.Uri=new k("uri","Uri of a text document",y=>r.URI.isUri(y),y=>y),k.Position=new k("position","A position in a text document",y=>F.Position.isPosition(y),E.Position.from),k.Range=new k("range","A range in a text document",y=>F.Range.isRange(y),E.Range.from),k.Selection=new k("selection","A selection in a text document",y=>F.Selection.isSelection(y),E.Selection.from),k.Number=new k("number","",y=>typeof y=="number",y=>y),k.String=new k("string","",y=>typeof y=="string",y=>y),k.CallHierarchyItem=new k("item","A call hierarchy item",y=>y instanceof F.CallHierarchyItem,E.CallHierarchyItem.from),k.TypeHierarchyItem=new k("item","A type hierarchy item",y=>y instanceof F.TypeHierarchyItem,E.TypeHierarchyItem.from);class c{constructor(i,o){this.description=i,this.convert=o}}e.ApiCommandResult=c,c.Void=new c("no result",y=>y);class w{constructor(i,o,u,s,f){this.id=i,this.internalId=o,this.description=u,this.args=s,this.result=f}}e.ApiCommand=w}),define(Ee[182],_e([0,1,8,6,57,46,16,79]),function(te,e,h,F,E,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(h.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,d)=>{if((0,A.isFalsyOrEmpty)(r))return;class a extends F.SymbolInformation{static to(p){const v=new a(p.name,h.SymbolKind.to(p.kind),p.containerName||"",new F.Location(d[0],h.Range.to(p.range)));return v.detail=p.detail,v.range=v.location.range,v.selectionRange=h.Range.to(p.selectionRange),v.children=p.children?p.children.map(a.to):[],v}}return r.map(a.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new T.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(h.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(h.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(d=>F.Position.isPosition(d)),r=>r.map(h.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(d=>{let a;for(const l of d.reverse())a=new F.SelectionRange(h.Range.to(l),a);return a}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const d=[];if(Array.isArray(r))for(let a of r)d.push(...a[1].map(h.WorkspaceSymbol.to));return d})),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(h.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(h.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(h.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return h.WorkspaceEdit.to(r)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(h.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new F.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const d=(0,I.decodeSemanticTokensDto)(r);if(d.type==="full")return new F.SemanticTokens(d.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new F.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const d=(0,I.decodeSemanticTokensDto)(r);if(d.type==="full")return new F.SemanticTokens(d.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,d,a)=>{if(!r)return new F.CompletionList([]);const l=r.suggestions.map(p=>h.CompletionItem.to(p,a));return new F.CompletionList(l,r.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return h.SignatureHelp.to(r)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,d,a)=>t(l=>new F.CodeLens(h.Range.to(l.range),l.command&&a.fromInternal(l.command)))(r))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>F.Range.isRange(r),r=>F.Selection.isSelection(r)?h.Selection.from(r):h.Range.from(r)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,d,a)=>t(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(l.command)}else{const p=new F.CodeAction(l.title,l.kind?new F.CodeActionKind(l.kind):void 0);return l.edit&&(p.edit=h.WorkspaceEdit.to(l.edit)),l.command&&(p.command=a.fromInternal(l.command)),p.isPreferred=l.isPreferred,p}})(r))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(d=>new F.ColorInformation(h.Range.to(d.range),h.Color.to(d.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",r=>r instanceof F.Color,h.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:h.Range.from(r.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(h.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(h.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(d=>h.NotebookExclusiveDocumentPattern.to(d))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(h.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[h.ViewColumn.from(r.viewColumn),h.TextEditorOpenOptions.from(r)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[h.ViewColumn.from(r.viewColumn),h.TextEditorOpenOptions.from(r)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[h.ViewColumn.from(r.viewColumn),h.TextEditorOpenOptions.from(r)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(h.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(h.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(h.TypeHierarchyItem.to)))];class P{static register(d){D.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=P;function t(r){return d=>{if(Array.isArray(d))return d.map(r)}}function S(r){if(!Array.isArray(r))return;const d=[];for(const a of r)E.isLocationLink(a)?d.push(h.DefinitionLink.to(a)):d.push(h.location.to(a));return d}}),define(Ee[183],_e([0,1,13,50,3,7,2,57,25,8,6,5]),function(te,e,h,F,E,T,A,I,D,P,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function r(d,a,l){const p=d.getProxy(S.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const f=this._commentControllers.get(s.handle);return f||s}else if(s&&s.$mid===7){const f=this._commentControllers.get(s.commentControlHandle);if(!f)return s;const m=f.getCommentThread(s.commentThreadHandle);return m||s}else if(s&&s.$mid===8){const f=this._commentControllers.get(s.thread.commentControlHandle);if(!f)return s;const m=f.getCommentThread(s.thread.commentThreadHandle);return m?{thread:m,text:s.text}:s}else if(s&&s.$mid===9){const f=this._commentControllers.get(s.thread.commentControlHandle);if(!f)return s;const m=f.getCommentThread(s.thread.commentThreadHandle);if(!m)return s;let g=s.commentUniqueId,b=m.getCommentByUniqueId(g);return b||s}else if(s&&s.$mid===10){const f=this._commentControllers.get(s.thread.commentControlHandle);if(!f)return s;const m=f.getCommentThread(s.thread.commentThreadHandle);if(!m)return s;let g=s.text,b=s.commentUniqueId,C=m.getCommentByUniqueId(b);return C?(C.body=g,C):s}return s}})}createCommentController(s,f,m){const g=v.handlePool++,b=new c(s,g,f,m);this._commentControllers.set(b.handle,b);const C=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(s.identifier))||[];return C.push(b),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(s.identifier),C),b.value}$createCommentThreadTemplate(s,f,m){const g=this._commentControllers.get(s);!g||g.$createCommentThreadTemplate(f,m)}async $updateCommentThreadTemplate(s,f,m){const g=this._commentControllers.get(s);!g||g.$updateCommentThreadTemplate(f,m)}$deleteCommentThread(s,f){const m=this._commentControllers.get(s);m&&m.$deleteCommentThread(f)}$provideCommentingRanges(s,f,m){const g=this._commentControllers.get(s);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const b=l.getDocument(A.URI.revive(f));return(0,h.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(b,m)).then(C=>C?C.map(n=>P.Range.from(n)):void 0)}$toggleReaction(s,f,m,g,b){const C=this._commentControllers.get(s);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,h.asPromise)(()=>{const n=C.getCommentThread(f);if(n){const _=n.getCommentByUniqueId(g.uniqueIdInThread);if(C!==void 0&&_&&C.reactionHandler)return C.reactionHandler(_,i(b))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class k{constructor(s,f,m,g,b,C,n){this._commentControllerHandle=f,this._id=m,this._uri=g,this._range=b,this._comments=C,this.handle=k._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${s}.${this.handle}`),p.$createCommentThread(f,this.handle,this._id,this._uri,P.Range.from(this._range),n),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(f,this.handle)}});const _=this;this.value={get uri(){return _.uri},get range(){return _.range},set range(R){_.range=R},get comments(){return _.comments},set comments(R){_.comments=R},get collapsibleState(){return _.collapsibleState},set collapsibleState(R){_.collapsibleState=R},get canReply(){return _.canReply},set canReply(R){_.canReply=R},get contextValue(){return _.contextValue},set contextValue(R){_.contextValue=R},get label(){return _.label},set label(R){_.label=R},dispose:()=>{_.dispose()}}}set threadId(s){this._id=s}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(s){s.isEqual(this._range)||(this._range=s,this.modifications.range=s,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(s){this._canReply!==s&&(this._canReply=s,this.modifications.canReply=s,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(s){this._label=s,this.modifications.label=s,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(s){this._contextValue=s,this.modifications.contextValue=s,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(s){this._comments=s,this.modifications.comments=s,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(s){this._collapseState=s,this.modifications.collapsibleState=s,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const s=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),f={};s("range")&&(f.range=P.Range.from(this._range)),s("label")&&(f.label=this.label),s("contextValue")&&(f.contextValue=this.contextValue),s("comments")&&(f.comments=this._comments.map(m=>w(this,m,this._commentsMap))),s("collapsibleState")&&(f.collapseState=o(this._collapseState)),s("canReply")&&(f.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(s){for(let f of this._commentsMap){let m=f[0],g=f[1];if(s===g)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(s=>s.dispose())}}k._handlePool=0,We([(0,F.debounce)(100)],k.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(s,f,m,g){this._extension=s,this._handle=f,this._id=m,this._label=g,this._threads=new Map,p.$registerCommentController(this.handle,m,g);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(C){b.options=C},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(C){b.commentingRangeProvider=C},get reactionHandler(){return b.reactionHandler},set reactionHandler(C){b.reactionHandler=C},createCommentThread(C,n,_){return b.createCommentThread(C,n,_).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(s){this._reactionHandler=s,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!s})}get options(){return this._options}set options(s){this._options=s,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(s,f,m,g){if(typeof s=="string"){const b=new k(this.id,this.handle,s,f,m,g,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new k(this.id,this.handle,void 0,s,f,m,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(s,f){const m=new k(this.id,this.handle,void 0,A.URI.revive(s),P.Range.to(f),[],this._extension.identifier);return m.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(s,f){let m=this._threads.get(s);m&&(m.range=P.Range.to(f))}$deleteCommentThread(s){let f=this._threads.get(s);f&&f.dispose(),this._threads.delete(s)}getCommentThread(s){return this._threads.get(s)}dispose(){this._threads.forEach(s=>{s.dispose()}),this._localDisposables.forEach(s=>s.dispose())}}function w(u,s,f){let m=f.get(s);m||(m=++u.commentHandle,f.set(s,m));const g=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:m,body:P.MarkdownString.from(s.body),userName:s.author.name,userIconPath:g,label:s.label,commentReactions:s.reactions?s.reactions.map(b=>y(b)):void 0}}function y(u){return{label:u.label,iconPath:u.iconPath?P.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function i(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?A.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function o(u){if(u!==void 0)switch(u){case t.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new v}e.createExtHostComments=r}),define(Ee[95],_e([0,1,2,5,6,4,12,14,16,9,17]),function(te,e,h,F,E,T,A,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class bi{constructor(d,a){this._logService=a,this._provider=new Map,this._proxy=d.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,a){const l=bi._handlePool++;this._provider.set(l,{provider:d,extensionId:a}),this._proxy.$registerDecorationProvider(l,a.value);const p=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(l,null);return}let k=(0,D.asArray)(v);if(k.length<=bi._maxEventSize){this._proxy.$onDidChange(l,k);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,k.length);const c=k.map(i=>({uri:i,rank:(0,P.count)(i.path,"/")})),w=(0,D.groupBy)(c,(i,o)=>i.rank-o.rank||(0,P.compare)(i.uri.path,o.uri.path));let y=[];e:for(let i of w){let o;for(let u of i){let s=(0,t.dirname)(u.uri.path);if(o!==s&&(o=s,y.push(u.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(l,y)});return new E.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(d,a,l){if(!this._provider.has(d))return Object.create(null);const p=Object.create(null),{provider:v,extensionId:k}=this._provider.get(d);return await Promise.all(a.map(async c=>{try{const{uri:w,id:y}=c,i=await Promise.resolve(v.provideFileDecoration(h.URI.revive(w),l));if(!i)return;try{E.FileDecoration.validate(i),p[y]=[i.propagate,i.tooltip,i.badge,i.color]}catch(o){this._logService.warn(`INVALID decoration from extension '${k.value}': ${o}`)}}catch(w){this._logService.error(w)}})),p}};S._handlePool=0,S._maxEventSize=250,S=We([ze(0,A.IExtHostRpcService),ze(1,I.ILogService)],S),e.ExtHostDecorations=S,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(Ee[184],_e([0,1,123,81,2,5,6,8,3,14,20]),function(te,e,h,F,E,T,A,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class S{constructor(a,l,p,v,k){this._name=a,this._owner=l,this._maxDiagnosticsPerFile=p,this._proxy=v,this._onDidChangeDiagnostics=k,this._isDisposed=!1,this._data=new t.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,l){if(!a){this.clear();return}this._checkDisposed();let p=[];if(E.URI.isUri(a)){if(!l){this.delete(a);return}this._data.set(a,l.slice()),p=[a]}else if(Array.isArray(a)){p=[];let k;a=[...a].sort(S._compareIndexedTuplesByUri);for(const c of a){const[w,y]=c;if((!k||w.toString()!==k.toString())&&(k&&this._data.get(k).length===0&&this._data.delete(k),k=w,p.push(w),this._data.set(w,[])),y){const i=this._data.get(w);i&&i.push(...y)}else{const i=this._data.get(w);i&&(i.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!this._proxy)return;const v=[];for(let k of p){let c=[];const w=this._data.get(k);if(w)if(w.length>this._maxDiagnosticsPerFile){c=[];const y=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(let o of w)if(o.severity===y[i]&&c.push(I.Diagnostic.from(o))===this._maxDiagnosticsPerFile)break e;c.push({severity:F.MarkerSeverity.Info,message:(0,h.localize)(0,null,w.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=w.map(y=>I.Diagnostic.from(y));v.push([k,c])}this._proxy.$changeMany(this._owner,v)}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,l){this._checkDisposed();for(let p of this._data.keys())a.apply(l,[p,this.get(p),this])}get(a){this._checkDisposed();const l=this._data.get(a);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,l){return a[0].toString()<l[0].toString()?-1:a[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=S;let r=class Yt{constructor(a,l){this._logService=l,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:p=>p.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,Yt._mapper),this._proxy=a.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(a){const l=new t.ResourceMap;for(const p of a)l.set(p,p);return{uris:Object.freeze(Array.from(l.values()))}}createDiagnosticCollection(a,l){const{_collections:p,_proxy:v,_onDidChangeDiagnostics:k,_logService:c}=this,w=new class{$changeMany(o,u){v.$changeMany(o,u),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,o,u.length===0?"CLEARING":u)}$clear(o){v.$clear(o),c.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,o)}dispose(){v.dispose()}};let y;if(!l)l="_generated_diagnostic_collection_name_#"+Yt._idPool++,y=l;else if(!p.has(l))y=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do y=l+Yt._idPool++;while(p.has(y))}return new class extends S{constructor(){super(l,y,Yt._maxDiagnosticsPerFile,w,k);p.set(y,this)}dispose(){super.dispose(),p.delete(y)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const l=new Map,p=[];for(const v of this._collections.values())v.forEach((k,c)=>{let w=l.get(k.toString());typeof w=="undefined"&&(w=p.length,l.set(k.toString(),w),p.push([k,[]])),p[w][1]=p[w][1].concat(...c)});return p}}_getDiagnostics(a){let l=[];for(let p of this._collections.values())p.has(a)&&(l=l.concat(p.get(a)));return l}$acceptMarkersChange(a){if(!this._mirrorCollection){const l="_generated_mirror",p=new S(l,l,Yt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(l,p),this._mirrorCollection=p}for(const[l,p]of a)this._mirrorCollection.set(E.URI.revive(l),p.map(I.Diagnostic.to))}};r._idPool=0,r._maxDiagnosticsPerFile=1e3,r=We([ze(1,P.ILogService)],r),e.ExtHostDiagnostics=r}),define(Ee[185],_e([0,1,2,5]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(A){this._proxy=A.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(I=>I?I.map(D=>h.URI.revive(D)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(I=>I?h.URI.revive(I):void 0)}}e.ExtHostDialogs=E}),define(Ee[186],_e([0,1,15,2,6,5,11,21,9]),function(te,e,h,F,E,T,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(S,r,d){this._documentsAndEditors=r,this._logService=d,this._documentContentProviders=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,r){if(Object.keys(A.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const d=P._handlePool++;this._documentContentProviders.set(d,r),this._proxy.$registerTextContentProvider(d,S);let a;return typeof r.onDidChange=="function"&&(a=r.onDidChange(l=>{if(l.scheme!==S){this._logService.warn(`Provider for scheme '${S}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(d,l).then(p=>{if(!p&&typeof p!="string")return;const v=this._documentsAndEditors.getDocument(l);if(!v)return;const k=(0,D.splitLines)(p);if(!v.equalLines(k))return this._proxy.$onVirtualDocumentChange(l,p)},h.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(S,r){const d=this._documentContentProviders.get(S);return d?Promise.resolve(d.provideTextDocumentContent(F.URI.revive(r),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${r.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(Ee[187],_e([0,1,3,7,2,5,87,8,10,22,6]),function(te,e,h,F,E,T,A,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class S{constructor(d,a){this._onDidAddDocument=new h.Emitter,this._onDidRemoveDocument=new h.Emitter,this._onDidChangeDocument=new h.Emitter,this._onDidSaveDocument=new h.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const p of l)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const p of l)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const a=this._documentsAndEditors.getDocument(d);if(a)return a}getDocument(d){const a=this.getDocumentData(d);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return a.document}ensureDocumentData(d){const a=this._documentsAndEditors.getDocument(d);if(a)return Promise.resolve(a);let l=this._documentLoader.get(d.toString());return l||(l=this._proxy.$tryOpenDocument(d).then(p=>{this._documentLoader.delete(d.toString());const v=E.URI.revive(p);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(v))},p=>(this._documentLoader.delete(d.toString()),Promise.reject(p))),this._documentLoader.set(d.toString(),l)),l}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(a=>E.URI.revive(a))}$acceptModelModeChanged(d,a){const l=E.URI.revive(d),p=this._documentsAndEditors.getDocument(l);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(a),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(d){const a=E.URI.revive(d),l=this._documentsAndEditors.getDocument(a);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(d,a){const l=E.URI.revive(d),p=this._documentsAndEditors.getDocument(l);if(!p)throw new Error("unknown document");p._acceptIsDirty(a),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(d,a,l){const p=E.URI.revive(d),v=this._documentsAndEditors.getDocument(p);if(!v)throw new Error("unknown document");v._acceptIsDirty(l),v.onEvents(a);let k;a.isUndoing?k=t.TextDocumentChangeReason.Undo:a.isRedoing&&(k=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:v.document,contentChanges:a.changes.map(c=>({range:I.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:k}))}setWordDefinitionFor(d,a){(0,A.setWordDefinitionFor)(d,a)}}e.ExtHostDocuments=S}),define(Ee[47],_e([0,1,39,3,7,2,4,5,87,12,93,8,14,20,11,188,103]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(w){this.value=w,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let k=class{constructor(w,y){this._extHostRpc=w,this._logService=y,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(w){this.acceptDocumentsAndEditorsDelta(w)}acceptDocumentsAndEditorsDelta(w){const y=[],i=[],o=[];if(w.removedDocuments)for(const u of w.removedDocuments){const s=T.URI.revive(u),f=this._documents.get(s);f?.unref()&&(this._documents.delete(s),y.push(f.value))}if(w.addedDocuments)for(const u of w.addedDocuments){const s=T.URI.revive(u.uri);let f=this._documents.get(s);if(f&&s.scheme!==a.Schemas.vscodeNotebookCell&&s.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);f||(f=new v(new D.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),s,u.lines,u.EOL,u.versionId,u.modeId,u.isDirty,u.notebook)),this._documents.set(s,f),i.push(f.value)),f.ref()}if(w.removedEditors)for(const u of w.removedEditors){const s=this._editors.get(u);this._editors.delete(u),s&&o.push(s)}if(w.addedEditors)for(const u of w.addedEditors){const s=T.URI.revive(u.documentUri);h.ok(this._documents.has(s),`document '${s}' does not exist`),h.ok(!this._editors.has(u.id),`editor '${u.id}' already exists!`);const f=this._documents.get(s).value,m=new t.ExtHostTextEditor(u.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>f.document),u.selections.map(S.Selection.to),u.options,u.visibleRanges.map(g=>S.Range.to(g)),typeof u.editorPosition=="number"?S.ViewColumn.to(u.editorPosition):void 0);this._editors.set(u.id,m)}w.newActiveEditor!==void 0&&(h.ok(w.newActiveEditor===null||this._editors.has(w.newActiveEditor),`active editor '${w.newActiveEditor}' does not exist`),this._activeEditorId=w.newActiveEditor),(0,E.dispose)(y),(0,E.dispose)(o),w.removedDocuments&&this._onDidRemoveDocuments.fire(y),w.addedDocuments&&this._onDidAddDocuments.fire(i),(w.removedEditors||w.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(u=>u.value)),w.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(w){return this._documents.get(w)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),w=>w.value)}getEditor(w){return this._editors.get(w)}activeEditor(w){if(!this._activeEditorId)return;const y=this._editors.get(this._activeEditorId);return w?y:y?.value}allEditors(){return[...this._editors.values()]}};k=We([ze(0,P.IExtHostRpcService),ze(1,r.ILogService)],k),e.ExtHostDocumentsAndEditors=k,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[189],_e([0,1,2,5,7,6,8,231,9,23]),function(te,e,h,F,E,T,A,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const a=this._schemes.indexOf(d);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),a=[];let l,p,v=14,k=14;for(const c of d){let w=l?(0,D.commonPrefixLength)(l,c):0;for(w===0?p=1:p=k;w<c.length;w++)w+1===c.length?(v=k,k=9):k+=1,a.push([p,c.toUpperCase().charCodeAt(w),k]),a.push([p,c.toLowerCase().charCodeAt(w),k]),p=k;l=c,k=v}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new I.StateMachine(a)}}provideDocumentLinks(d){this._initStateMachine();const a=[],l=I.LinkComputer.computeLinks({getLineContent(p){return d.lineAt(p-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const p of l){const v=A.DocumentLink.to(p);v.target&&a.push(v)}return a}}class S{constructor(d,a){this._extHostLanguageFeatures=a,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=d.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,a,l,p={},v){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const k=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(k,l),this._enableProposedApi.set(k,v??!1);let c=2;p.isCaseSensitive&&(c+=1024),p.isReadonly&&(c+=2048),typeof l.copy=="function"&&(c+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&(c+=4),this._proxy.$registerFileSystemProvider(k,a,c).catch(y=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${a}`),console.error(y)});const w=l.onDidChangeFile(y=>{const i=[];for(const o of y){let{uri:u,type:s}=o;if(u.scheme!==a)continue;let f;switch(s){case T.FileChangeType.Changed:f=0;break;case T.FileChangeType.Created:f=1;break;case T.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:u,type:f})}this._proxy.$onFileSystemChange(k,i)});return(0,E.toDisposable)(()=>{w.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(k),this._enableProposedApi.delete(k),this._proxy.$unregisterProvider(k)})}static _asIStat(d,a){const{type:l,ctime:p,mtime:v,size:k,permissions:c}=d;return a?{type:l,ctime:p,mtime:v,size:k,permissions:c}:{type:l,ctime:p,mtime:v,size:k}}$stat(d,a){return Promise.resolve(this._getFsProvider(d).stat(h.URI.revive(a))).then(l=>S._asIStat(l,this._enableProposedApi.get(d)??!1))}$readdir(d,a){return Promise.resolve(this._getFsProvider(d).readDirectory(h.URI.revive(a)))}$readFile(d,a){return Promise.resolve(this._getFsProvider(d).readFile(h.URI.revive(a))).then(l=>P.VSBuffer.wrap(l))}$writeFile(d,a,l,p){return Promise.resolve(this._getFsProvider(d).writeFile(h.URI.revive(a),l.buffer,p))}$delete(d,a,l){return Promise.resolve(this._getFsProvider(d).delete(h.URI.revive(a),l))}$rename(d,a,l,p){return Promise.resolve(this._getFsProvider(d).rename(h.URI.revive(a),h.URI.revive(l),p))}$copy(d,a,l,p){const v=this._getFsProvider(d);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(h.URI.revive(a),h.URI.revive(l),p))}$mkdir(d,a){return Promise.resolve(this._getFsProvider(d).createDirectory(h.URI.revive(a)))}$watch(d,a,l,p){const v=this._getFsProvider(d).watch(h.URI.revive(l),p);this._watches.set(a,v)}$unwatch(d,a){const l=this._watches.get(a);l&&(l.dispose(),this._watches.delete(a))}$open(d,a,l){const p=this._getFsProvider(d);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(h.URI.revive(a),l))}$close(d,a){const l=this._getFsProvider(d);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(a))}$read(d,a,l,p){const v=this._getFsProvider(d);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const k=P.VSBuffer.alloc(p);return Promise.resolve(v.read(a,l,k.buffer,0,p)).then(c=>k.slice(0,c))}$write(d,a,l,p){const v=this._getFsProvider(d);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(a,l,p.buffer,0,p.byteLength))}_getFsProvider(d){const a=this._fsProvider.get(d);if(!a){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return a}}e.ExtHostFileSystem=S}),define(Ee[70],_e([0,1,5,58,6,23,4,12,45]),function(te,e,h,F,E,T,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class xt{constructor(S,r){const d=S.getProxy(h.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return d.$stat(a).catch(xt._handleError)},readDirectory(a){return d.$readdir(a).catch(xt._handleError)},createDirectory(a){return d.$mkdir(a).catch(xt._handleError)},async readFile(a){return d.$readFile(a).then(l=>l.buffer).catch(xt._handleError)},writeFile(a,l){return d.$writeFile(a,T.VSBuffer.wrap(l)).catch(xt._handleError)},delete(a,l){return d.$delete(a,{recursive:!1,useTrash:!1,...l}).catch(xt._handleError)},rename(a,l,p){return d.$rename(a,l,{overwrite:!1,...p}).catch(xt._handleError)},copy(a,l,p){return d.$copy(a,l,{overwrite:!1,...p}).catch(xt._handleError)},isWritableFileSystem(a){const l=r.getCapabilities(a);if(typeof l=="number")return!(l&2048)}})}static _handleError(S){if(!(S instanceof Error))throw new E.FileSystemError(String(S));if(S.name==="ENOPRO")throw E.FileSystemError.Unavailable(S.message);switch(S.name){case F.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(S.message);case F.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(S.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(S.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(S.message);case F.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(S.message);case F.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(S.message);default:throw new E.FileSystemError(S.message,S.name)}}};P=We([ze(0,I.IExtHostRpcService),ze(1,D.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[190],_e([0,1,2,46]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(A,I,D,P){this._extHostNotebooks=I,this._textDocumentsAndEditors=D,this._commands=P;const t=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",S=>!0,S=>S),new F.ApiCommandArgument("resource","Interactive resource Uri",S=>!0,S=>S),new F.ApiCommandArgument("controllerId","Notebook controller Id",S=>!0,S=>S),new F.ApiCommandArgument("title","Interactive editor title",S=>!0,S=>S)],new F.ApiCommandResult("Notebook and input URI",S=>{if(S.notebookEditorId!==void 0){const r=this._extHostNotebooks.getEditorById(S.notebookEditorId);return{notebookUri:h.URI.revive(S.notebookUri),inputUri:h.URI.revive(S.inputUri),notebookEditor:r.apiEditor}}return{notebookUri:h.URI.revive(S.notebookUri),inputUri:h.URI.revive(S.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(A,I,D,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],modeId:D,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(h.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=E}),define(Ee[191],_e([0,1,7,5]),function(te,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(A){this._handlePool=0,this._proxy=A.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,A),(0,h.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=E}),define(Ee[192],_e([0,1,2,22,8,6,5,9,41,16,10,232,7,79,51,61,193,15,3]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(N,q){this._documents=N,this._provider=q}async provideDocumentSymbols(N,q){const X=this._documents.getDocument(N),ie=await this._provider.provideDocumentSymbols(X,q);if(!(0,P.isFalsyOrEmpty)(ie))return ie[0]instanceof T.DocumentSymbol?ie.map(E.DocumentSymbol.from):c._asDocumentSymbolTree(ie)}static _asDocumentSymbolTree(N){N=N.slice(0).sort((ie,W)=>{let ee=ie.location.range.start.compareTo(W.location.range.start);return ee===0&&(ee=W.location.range.end.compareTo(ie.location.range.end)),ee});const q=[],X=[];for(const ie of N){const W={name:ie.name||"!!MISSING: name!!",kind:E.SymbolKind.from(ie.kind),tags:ie.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:ie.containerName,range:E.Range.from(ie.location.range),selectionRange:E.Range.from(ie.location.range),children:[]};for(;;){if(X.length===0){X.push(W),q.push(W);break}const ee=X[X.length-1];if(D.Range.containsRange(ee.range,W.range)&&!D.Range.equalsRange(ee.range,W.range)){ee.children&&ee.children.push(W),X.push(W);break}X.pop()}}return q}}class w{constructor(N,q,X){this._documents=N,this._commands=q,this._provider=X,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(N,q){const X=this._documents.getDocument(N),ie=await this._provider.provideCodeLenses(X,q);if(!ie||q.isCancellationRequested)return;const W=this._cache.add(ie),ee=new r.DisposableStore;this._disposables.set(W,ee);const me={cacheId:W,lenses:[]};for(let Te=0;Te<ie.length;Te++)me.lenses.push({cacheId:[W,Te],range:E.Range.from(ie[Te].range),command:this._commands.toInternal(ie[Te].command,ee)});return me}async resolveCodeLens(N,q){const X=N.cacheId&&this._cache.get(...N.cacheId);if(!X)return;let ie;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?ie=X:ie=await this._provider.resolveCodeLens(X,q),ie||(ie=X),q.isCancellationRequested)return;const W=N.cacheId&&this._disposables.get(N.cacheId[0]);if(!!W)return N.command=this._commands.toInternal(ie.command??w._badCmd,W),N}releaseCodeLenses(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}}w._badCmd={command:"missing",title:"!!MISSING: command!!"};function y(Ke){return Array.isArray(Ke)?Ke.map(E.DefinitionLink.from):Ke?[E.DefinitionLink.from(Ke)]:[]}class i{constructor(N,q){this._documents=N,this._provider=q}async provideDefinition(N,q,X){const ie=this._documents.getDocument(N),W=E.Position.to(q),ee=await this._provider.provideDefinition(ie,W,X);return y(ee)}}class o{constructor(N,q){this._documents=N,this._provider=q}async provideDeclaration(N,q,X){const ie=this._documents.getDocument(N),W=E.Position.to(q),ee=await this._provider.provideDeclaration(ie,W,X);return y(ee)}}class u{constructor(N,q){this._documents=N,this._provider=q}async provideImplementation(N,q,X){const ie=this._documents.getDocument(N),W=E.Position.to(q),ee=await this._provider.provideImplementation(ie,W,X);return y(ee)}}class s{constructor(N,q){this._documents=N,this._provider=q}async provideTypeDefinition(N,q,X){const ie=this._documents.getDocument(N),W=E.Position.to(q),ee=await this._provider.provideTypeDefinition(ie,W,X);return y(ee)}}class f{constructor(N,q){this._documents=N,this._provider=q}async provideHover(N,q,X){const ie=this._documents.getDocument(N),W=E.Position.to(q),ee=await this._provider.provideHover(ie,W,X);if(!(!ee||(0,P.isFalsyOrEmpty)(ee.contents)))return ee.range||(ee.range=ie.getWordRangeAtPosition(W)),ee.range||(ee.range=new T.Range(W,W)),E.Hover.from(ee)}}class m{constructor(N,q){this._documents=N,this._provider=q}async provideEvaluatableExpression(N,q,X){const ie=this._documents.getDocument(N),W=E.Position.to(q),ee=await this._provider.provideEvaluatableExpression(ie,W,X);if(ee)return E.EvaluatableExpression.from(ee)}}class g{constructor(N,q){this._documents=N,this._provider=q}async provideInlineValues(N,q,X,ie){const W=this._documents.getDocument(N),ee=await this._provider.provideInlineValues(W,E.Range.to(q),E.InlineValueContext.to(X),ie);if(Array.isArray(ee))return ee.map(me=>E.InlineValue.from(me))}}class b{constructor(N,q){this._documents=N,this._provider=q}async provideDocumentHighlights(N,q,X){const ie=this._documents.getDocument(N),W=E.Position.to(q),ee=await this._provider.provideDocumentHighlights(ie,W,X);if(Array.isArray(ee))return ee.map(E.DocumentHighlight.from)}}class C{constructor(N,q){this._documents=N,this._provider=q}async provideLinkedEditingRanges(N,q,X){const ie=this._documents.getDocument(N),W=E.Position.to(q),ee=await this._provider.provideLinkedEditingRanges(ie,W,X);if(ee&&Array.isArray(ee.ranges))return{ranges:(0,P.coalesce)(ee.ranges.map(E.Range.from)),wordPattern:ee.wordPattern}}}class n{constructor(N,q){this._documents=N,this._provider=q}async provideReferences(N,q,X,ie){const W=this._documents.getDocument(N),ee=E.Position.to(q),me=await this._provider.provideReferences(W,ee,X,ie);if(Array.isArray(me))return me.map(E.location.from)}}class _{constructor(N,q,X,ie,W,ee,me){this._documents=N,this._commands=q,this._diagnostics=X,this._provider=ie,this._logService=W,this._extension=ee,this._apiDeprecation=me,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(N,q,X,ie){const W=this._documents.getDocument(N),ee=S.Selection.isISelection(q)?E.Selection.to(q):E.Range.to(q),me=[];for(const $ of this._diagnostics.getDiagnostics(N))if(ee.intersection($.range)&&me.push($)>_._maxCodeActionsPerFile)break;const Te={diagnostics:me,only:X.only?new T.CodeActionKind(X.only):void 0,triggerKind:E.CodeActionTriggerKind.to(X.trigger)},Ue=await this._provider.provideCodeActions(W,ee,Te,ie);if(!(0,P.isNonEmptyArray)(Ue)||ie.isCancellationRequested)return;const He=this._cache.add(Ue),be=new r.DisposableStore;this._disposables.set(He,be);const Je=[];for(let $=0;$<Ue.length;$++){const G=Ue[$];!G||(_._isCommand(G)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:G.title,command:this._commands.toInternal(G,be)})):(Te.only&&(G.kind?Te.only.contains(G.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${G.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[He,$],title:G.title,command:G.command&&this._commands.toInternal(G.command,be),diagnostics:G.diagnostics&&G.diagnostics.map(E.Diagnostic.from),edit:G.edit&&E.WorkspaceEdit.from(G.edit),kind:G.kind&&G.kind.value,isPreferred:G.isPreferred,disabled:G.disabled?.reason})))}return{cacheId:He,actions:Je}}async resolveCodeAction(N,q){const[X,ie]=N,W=this._cache.get(X,ie);if(!W||_._isCommand(W)||!this._provider.resolveCodeAction)return;const ee=await this._provider.resolveCodeAction(W,q)??W;return ee?.edit?E.WorkspaceEdit.from(ee.edit):void 0}releaseCodeActions(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}static _isCommand(N){return typeof N.command=="string"&&typeof N.title=="string"}}_._maxCodeActionsPerFile=1e3;class R{constructor(N,q){this._documents=N,this._provider=q}async provideDocumentFormattingEdits(N,q,X){const ie=this._documents.getDocument(N),W=await this._provider.provideDocumentFormattingEdits(ie,q,X);if(Array.isArray(W))return W.map(E.TextEdit.from)}}class U{constructor(N,q){this._documents=N,this._provider=q}async provideDocumentRangeFormattingEdits(N,q,X,ie){const W=this._documents.getDocument(N),ee=E.Range.to(q),me=await this._provider.provideDocumentRangeFormattingEdits(W,ee,X,ie);if(Array.isArray(me))return me.map(E.TextEdit.from)}}class V{constructor(N,q){this._documents=N,this._provider=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,q,X,ie,W){const ee=this._documents.getDocument(N),me=E.Position.to(q),Te=await this._provider.provideOnTypeFormattingEdits(ee,me,X,ie,W);if(Array.isArray(Te))return Te.map(E.TextEdit.from)}}class le{constructor(N,q){this._provider=N,this._logService=q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(N,q){const X=A.IdObject.mixin({symbols:[]}),ie=await this._provider.provideWorkspaceSymbols(N,q);if((0,P.isNonEmptyArray)(ie))for(const W of ie){if(!W)continue;if(!W.name){this._logService.warn("INVALID SymbolInformation, lacks name",W);continue}const ee=A.IdObject.mixin(E.WorkspaceSymbol.from(W));this._symbolCache.set(ee._id,W),X.symbols.push(ee)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(N,q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return N;const X=this._symbolCache.get(N._id);if(X){const ie=await this._provider.resolveWorkspaceSymbol(X,q);return ie&&(0,F.mixin)(N,E.WorkspaceSymbol.from(ie),!0)}}releaseWorkspaceSymbols(N){const q=this._resultCache.get(N);if(q){for(let[X,ie]=q;X<=ie;X++)this._symbolCache.delete(X);this._resultCache.delete(N)}}}class he{constructor(N,q,X){this._documents=N,this._provider=q,this._logService=X}static supportsResolving(N){return typeof N.prepareRename=="function"}async provideRenameEdits(N,q,X,ie){const W=this._documents.getDocument(N),ee=E.Position.to(q);try{const me=await this._provider.provideRenameEdits(W,ee,X,ie);return me?E.WorkspaceEdit.from(me):void 0}catch(me){const Te=he._asMessage(me);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(me)}}async resolveRenameLocation(N,q,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ie=this._documents.getDocument(N),W=E.Position.to(q);try{const ee=await this._provider.prepareRename(ie,W,X);let me,Te;if(T.Range.isRange(ee)?(me=ee,Te=ie.getText(ee)):(0,t.isObject)(ee)&&(me=ee.range,Te=ee.placeholder),!me||!Te)return;if(me.start.line>W.line||me.end.line<W.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(me),text:Te}}catch(ee){const me=he._asMessage(ee);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(ee)}}static _asMessage(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class j{constructor(N,q){this.resultId=N,this.tokens=q}}class H{constructor(N,q){this._documents=N,this._provider=q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(N,q,X){const ie=this._documents.getDocument(N),W=q!==0?this._previousResults.get(q):null;let ee=typeof W?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ie,W.resultId,X):await this._provider.provideDocumentSemanticTokens(ie,X);return W&&this._previousResults.delete(q),ee?(ee=H._fixProvidedSemanticTokens(ee),this._send(H._convertToEdits(W,ee),ee)):null}async releaseDocumentSemanticColoring(N){this._previousResults.delete(N)}static _fixProvidedSemanticTokens(N){return H._isSemanticTokens(N)?H._isCorrectSemanticTokens(N)?N:new T.SemanticTokens(new Uint32Array(N.data),N.resultId):H._isSemanticTokensEdits(N)?H._isCorrectSemanticTokensEdits(N)?N:new T.SemanticTokensEdits(N.edits.map(q=>new T.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),N.resultId):N}static _isSemanticTokens(N){return N&&!!N.data}static _isCorrectSemanticTokens(N){return N.data instanceof Uint32Array}static _isSemanticTokensEdits(N){return N&&Array.isArray(N.edits)}static _isCorrectSemanticTokensEdits(N){for(const q of N.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(N,q){if(!H._isSemanticTokens(q)||!N||!N.tokens)return q;const X=N.tokens,ie=X.length,W=q.data,ee=W.length;let me=0;const Te=Math.min(ie,ee);for(;me<Te&&X[me]===W[me];)me++;if(me===ie&&me===ee)return new T.SemanticTokensEdits([],q.resultId);let Ue=0;const He=Te-me;for(;Ue<He&&X[ie-Ue-1]===W[ee-Ue-1];)Ue++;return new T.SemanticTokensEdits([{start:me,deleteCount:ie-me-Ue,data:W.subarray(me,ee-Ue)}],q.resultId)}_send(N,q){if(H._isSemanticTokens(N)){const X=this._nextResultId++;return this._previousResults.set(X,new j(N.resultId,N.data)),(0,d.encodeSemanticTokensDto)({id:X,type:"full",data:N.data})}if(H._isSemanticTokensEdits(N)){const X=this._nextResultId++;return H._isSemanticTokens(q)?this._previousResults.set(X,new j(q.resultId,q.data)):this._previousResults.set(X,new j(N.resultId)),(0,d.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(N.edits||[]).map(ie=>({start:ie.start,deleteCount:ie.deleteCount,data:ie.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class L{constructor(N,q){this._documents=N,this._provider=q}async provideDocumentRangeSemanticTokens(N,q,X){const ie=this._documents.getDocument(N),W=await this._provider.provideDocumentRangeSemanticTokens(ie,E.Range.to(q),X);return W?this._send(W):null}_send(N){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}e.DocumentRangeSemanticTokensAdapter=L;class K{constructor(N,q,X,ie,W){this._documents=N,this._commands=q,this._provider=X,this._apiDeprecation=ie,this._extension=W,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}async provideCompletionItems(N,q,X,ie){const W=this._documents.getDocument(N),ee=E.Position.to(q),me=W.getWordRangeAtPosition(ee)||new T.Range(ee,ee),Te=me.with({end:ee}),Ue=new p.StopWatch(!0),He=await this._provider.provideCompletionItems(W,ee,ie,E.CompletionContext.to(X));if(!He||ie.isCancellationRequested)return;const be=Array.isArray(He)?new T.CompletionList(He):He,Je=K.supportsResolving(this._provider)?this._cache.add(be.items):this._cache.add([]),$=new r.DisposableStore;this._disposables.set(Je,$);const G=[],fe={x:Je,b:G,a:{replace:E.Range.from(me),insert:E.Range.from(Te)},c:be.isIncomplete||void 0,d:Ue.elapsed()};for(let Le=0;Le<be.items.length;Le++){const Ve=be.items[Le],et=this._convertCompletionItem(Ve,[Je,Le],Te,me);G.push(et)}return fe}async resolveCompletionItem(N,q){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...N);if(!X)return;const ie=await this._provider.resolveCompletionItem(X,q);if(!!ie)return this._convertCompletionItem(ie,N)}releaseCompletionItems(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}_convertCompletionItem(N,q,X,ie){const W=this._disposables.get(q[0]);if(!W)throw Error("DisposableStore is missing...");const ee={x:q,a:N.label,b:N.kind!==void 0?E.CompletionItemKind.from(N.kind):void 0,n:N.tags&&N.tags.map(E.CompletionItemTag.from),c:N.detail,d:typeof N.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters,l:N.additionalTextEdits&&N.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(N.command,W)};N.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ee.h=N.textEdit.newText):typeof N.insertText=="string"?ee.h=N.insertText:N.insertText instanceof T.SnippetString&&(ee.h=N.insertText.value,ee.i|=4);let me;return N.textEdit?me=N.textEdit.range:N.range&&(me=N.range),T.Range.isRange(me)?ee.j=E.Range.from(me):me&&(!X?.isEqual(me.inserting)||!ie?.isEqual(me.replacing))&&(ee.j={insert:E.Range.from(me.inserting),replace:E.Range.from(me.replacing)}),ee}}class x{constructor(N,q,X){this._documents=N,this._provider=q,this._commands=X,this._cache=new l.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(N,q,X,ie){const W=this._documents.getDocument(N),ee=E.Position.to(q),me=await this._provider.provideInlineCompletionItems(W,ee,X,ie);if(!me||ie.isCancellationRequested)return;const Te=(0,t.isArray)(me)?{items:me}:me,Ue=this._cache.add(Te.items);let He;return{pid:Ue,items:Te.items.map((be,Je)=>{let $;return be.command&&(He||(He=new r.DisposableStore,this._disposables.set(Ue,He)),$=this._commands.toInternal(be.command,He)),{text:be.text,range:be.range?E.Range.from(be.range):void 0,command:$,idx:Je}})}}disposeCompletions(N){this._cache.delete(N);const q=this._disposables.get(N);q&&q.clear(),this._disposables.delete(N)}handleDidShowCompletionItem(N,q){const X=this._cache.get(N,q);X&&Y.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class Y{constructor(){this._onDidShowCompletionItemEmitter=new k.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(N){let q=Y.map.get(N);return q||(q=new Y,Y.map.set(N,q)),q}fireOnDidShowCompletionItem(N){this._onDidShowCompletionItemEmitter.fire(N)}}e.InlineCompletionController=Y,Y.map=new WeakMap;class ce{constructor(N,q){this._documents=N,this._provider=q,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(N,q,X,ie){const W=this._documents.getDocument(N),ee=E.Position.to(q),me=this.reviveContext(X),Te=await this._provider.provideSignatureHelp(W,ee,ie,me);if(Te){const Ue=this._cache.add([Te]);return{...E.SignatureHelp.from(Te),id:Ue}}}reviveContext(N){let q;if(N.activeSignatureHelp){const X=E.SignatureHelp.to(N.activeSignatureHelp),ie=this._cache.get(N.activeSignatureHelp.id,0);ie?(q=ie,q.activeSignature=X.activeSignature,q.activeParameter=X.activeParameter):q=X}return{...N,activeSignatureHelp:q}}releaseSignatureHelp(N){this._cache.delete(N)}}class z{constructor(N,q){this._documents=N,this._provider=q}async provideInlayHints(N,q,X){const ie=this._documents.getDocument(N),W=await this._provider.provideInlayHints(ie,E.Range.to(q),X);return W?{hints:W.map(E.InlayHint.from)}:void 0}}class se{constructor(N,q){this._documents=N,this._provider=q,this._cache=new l.Cache("DocumentLink")}async provideLinks(N,q){const X=this._documents.getDocument(N),ie=await this._provider.provideDocumentLinks(X,q);if(!(!Array.isArray(ie)||ie.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ie.filter(se._validateLink).map(E.DocumentLink.from)};{const W=this._cache.add(ie),ee={links:[],id:W};for(let me=0;me<ie.length;me++){if(!se._validateLink(ie[me]))continue;const Te=E.DocumentLink.from(ie[me]);Te.cacheId=[W,me],ee.links.push(Te)}return ee}}}static _validateLink(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,q){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...N);if(!X)return;const ie=await this._provider.resolveDocumentLink(X,q);if(!(!ie||!se._validateLink(ie)))return E.DocumentLink.from(ie)}releaseLinks(N){this._cache.delete(N)}}class re{constructor(N,q){this._documents=N,this._provider=q}async provideColors(N,q){const X=this._documents.getDocument(N),ie=await this._provider.provideDocumentColors(X,q);return Array.isArray(ie)?ie.map(ee=>({color:E.Color.from(ee.color),range:E.Range.from(ee.range)})):[]}async provideColorPresentations(N,q,X){const ie=this._documents.getDocument(N),W=E.Range.to(q.range),ee=E.Color.to(q.color),me=await this._provider.provideColorPresentations(ee,{document:ie,range:W},X);if(!!Array.isArray(me))return me.map(E.ColorPresentation.from)}}class we{constructor(N,q){this._documents=N,this._provider=q}async provideFoldingRanges(N,q,X){const ie=this._documents.getDocument(N),W=await this._provider.provideFoldingRanges(ie,q,X);if(!!Array.isArray(W))return W.map(E.FoldingRange.from)}}class Re{constructor(N,q,X){this._documents=N,this._provider=q,this._logService=X}async provideSelectionRanges(N,q,X){const ie=this._documents.getDocument(N),W=q.map(E.Position.to),ee=await this._provider.provideSelectionRanges(ie,W,X);if(!(0,P.isNonEmptyArray)(ee))return[];if(ee.length!==W.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let Te=0;Te<W.length;Te++){const Ue=[];me.push(Ue);let He=W[Te],be=ee[Te];for(;;){if(!be.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(E.SelectionRange.from(be)),!be.parent)break;He=be.range,be=be.parent}}return me}}class Fe{constructor(N,q){this._documents=N,this._provider=q,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(N,q,X){const ie=this._documents.getDocument(N),W=E.Position.to(q),ee=await this._provider.prepareCallHierarchy(ie,W,X);if(!ee)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(ee)?ee.map(Te=>this._cacheAndConvertItem(me,Te)):[this._cacheAndConvertItem(me,ee)]}async provideCallsTo(N,q,X){const ie=this._itemFromCache(N,q);if(!ie)throw new Error("missing call hierarchy item");const W=await this._provider.provideCallHierarchyIncomingCalls(ie,X);if(!!W)return W.map(ee=>({from:this._cacheAndConvertItem(N,ee.from),fromRanges:ee.fromRanges.map(me=>E.Range.from(me))}))}async provideCallsFrom(N,q,X){const ie=this._itemFromCache(N,q);if(!ie)throw new Error("missing call hierarchy item");const W=await this._provider.provideCallHierarchyOutgoingCalls(ie,X);if(!!W)return W.map(ee=>({to:this._cacheAndConvertItem(N,ee.to),fromRanges:ee.fromRanges.map(me=>E.Range.from(me))}))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,q){const X=this._cache.get(N),ie=E.CallHierarchyItem.from(q,N,X.size.toString(36));return X.set(ie._itemId,q),ie}_itemFromCache(N,q){return this._cache.get(N)?.get(q)}}class Ne{constructor(N,q){this._documents=N,this._provider=q,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(N,q,X){const ie=this._documents.getDocument(N),W=E.Position.to(q),ee=await this._provider.prepareTypeHierarchy(ie,W,X);if(!ee)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(ee)?ee.map(Te=>this._cacheAndConvertItem(me,Te)):[this._cacheAndConvertItem(me,ee)]}async provideSupertypes(N,q,X){const ie=this._itemFromCache(N,q);if(!ie)throw new Error("missing type hierarchy item");const W=await this._provider.provideTypeHierarchySupertypes(ie,X);if(!!W)return W.map(ee=>this._cacheAndConvertItem(N,ee))}async provideSubtypes(N,q,X){const ie=this._itemFromCache(N,q);if(!ie)throw new Error("missing type hierarchy item");const W=await this._provider.provideTypeHierarchySubtypes(ie,X);if(!!W)return W.map(ee=>this._cacheAndConvertItem(N,ee))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,q){const X=this._cache.get(N),ie=E.TypeHierarchyItem.from(q,N,X.size.toString(36));return X.set(ie._itemId,q),ie}_itemFromCache(N,q){return this._cache.get(N)?.get(q)}}class Qe{constructor(N,q){this.adapter=N,this.extension=q}}class qe{constructor(N,q,X,ie,W,ee,me){this._adapter=new Map,this._uriTransformer=q,this._proxy=N.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=ie,this._diagnostics=W,this._logService=ee,this._apiDeprecation=me}_transformDocumentSelector(N){return(0,P.coalesce)((0,P.asArray)(N).map(q=>this._doTransformDocumentSelector(q)))}_doTransformDocumentSelector(N){if(typeof N=="string")return{$serialized:!0,language:N};if(N)return{$serialized:!0,language:N.language,scheme:this._transformScheme(N.scheme),pattern:typeof N.pattern=="undefined"?void 0:E.GlobPattern.from(N.pattern),exclusive:N.exclusive}}_transformScheme(N){return this._uriTransformer&&typeof N=="string"?this._uriTransformer.transformOutgoingScheme(N):N}_createDisposable(N){return new T.Disposable(()=>{this._adapter.delete(N),this._proxy.$unregister(N)})}_nextHandle(){return qe._handlePool++}_withAdapter(N,q,X,ie,W=!1){const ee=this._adapter.get(N);if(!ee)return Promise.resolve(ie);if(ee.adapter instanceof q){let me;ee.extension&&(me=Date.now(),this._logService.trace(`[${ee.extension.identifier.value}] INVOKE provider '${q.name}'`));const Te=X(ee.adapter,ee.extension),Ue=ee.extension;return Ue&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Ue.identifier.value}] provider DONE after ${Date.now()-me}ms`),He=>{W&&He instanceof v.CancellationError||(this._logService.error(`[${Ue.identifier.value}] provider FAILED`),this._logService.error(He))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(N,q){const X=this._nextHandle();return this._adapter.set(X,new Qe(N,q)),X}static _extLabel(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,q,X,ie){const W=this._addNewAdapter(new c(this._documents,X),N),ee=ie&&ie.label||qe._extLabel(N);return this._proxy.$registerDocumentSymbolProvider(W,this._transformDocumentSelector(q),ee),this._createDisposable(W)}$provideDocumentSymbols(N,q,X){return this._withAdapter(N,c,ie=>ie.provideDocumentSymbols(h.URI.revive(q),X),void 0)}registerCodeLensProvider(N,q,X){const ie=this._nextHandle(),W=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ie,new Qe(new w(this._documents,this._commands.converter,X),N)),this._proxy.$registerCodeLensSupport(ie,this._transformDocumentSelector(q),W);let ee=this._createDisposable(ie);if(W!==void 0){const me=X.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(W));ee=T.Disposable.from(ee,me)}return ee}$provideCodeLenses(N,q,X){return this._withAdapter(N,w,ie=>ie.provideCodeLenses(h.URI.revive(q),X),void 0)}$resolveCodeLens(N,q,X){return this._withAdapter(N,w,ie=>ie.resolveCodeLens(q,X),void 0)}$releaseCodeLenses(N,q){this._withAdapter(N,w,X=>Promise.resolve(X.releaseCodeLenses(q)),void 0)}registerDefinitionProvider(N,q,X){const ie=this._addNewAdapter(new i(this._documents,X),N);return this._proxy.$registerDefinitionSupport(ie,this._transformDocumentSelector(q)),this._createDisposable(ie)}$provideDefinition(N,q,X,ie){return this._withAdapter(N,i,W=>W.provideDefinition(h.URI.revive(q),X,ie),[])}registerDeclarationProvider(N,q,X){const ie=this._addNewAdapter(new o(this._documents,X),N);return this._proxy.$registerDeclarationSupport(ie,this._transformDocumentSelector(q)),this._createDisposable(ie)}$provideDeclaration(N,q,X,ie){return this._withAdapter(N,o,W=>W.provideDeclaration(h.URI.revive(q),X,ie),[])}registerImplementationProvider(N,q,X){const ie=this._addNewAdapter(new u(this._documents,X),N);return this._proxy.$registerImplementationSupport(ie,this._transformDocumentSelector(q)),this._createDisposable(ie)}$provideImplementation(N,q,X,ie){return this._withAdapter(N,u,W=>W.provideImplementation(h.URI.revive(q),X,ie),[])}registerTypeDefinitionProvider(N,q,X){const ie=this._addNewAdapter(new s(this._documents,X),N);return this._proxy.$registerTypeDefinitionSupport(ie,this._transformDocumentSelector(q)),this._createDisposable(ie)}$provideTypeDefinition(N,q,X,ie){return this._withAdapter(N,s,W=>W.provideTypeDefinition(h.URI.revive(q),X,ie),[])}registerHoverProvider(N,q,X,ie){const W=this._addNewAdapter(new f(this._documents,X),N);return this._proxy.$registerHoverProvider(W,this._transformDocumentSelector(q)),this._createDisposable(W)}$provideHover(N,q,X,ie){return this._withAdapter(N,f,W=>W.provideHover(h.URI.revive(q),X,ie),void 0)}registerEvaluatableExpressionProvider(N,q,X,ie){const W=this._addNewAdapter(new m(this._documents,X),N);return this._proxy.$registerEvaluatableExpressionProvider(W,this._transformDocumentSelector(q)),this._createDisposable(W)}$provideEvaluatableExpression(N,q,X,ie){return this._withAdapter(N,m,W=>W.provideEvaluatableExpression(h.URI.revive(q),X,ie),void 0)}registerInlineValuesProvider(N,q,X,ie){const W=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new g(this._documents,X),N);this._proxy.$registerInlineValuesProvider(ee,this._transformDocumentSelector(q),W);let me=this._createDisposable(ee);if(W!==void 0){const Te=X.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(W));me=T.Disposable.from(me,Te)}return me}$provideInlineValues(N,q,X,ie,W){return this._withAdapter(N,g,ee=>ee.provideInlineValues(h.URI.revive(q),X,ie,W),void 0)}registerDocumentHighlightProvider(N,q,X){const ie=this._addNewAdapter(new b(this._documents,X),N);return this._proxy.$registerDocumentHighlightProvider(ie,this._transformDocumentSelector(q)),this._createDisposable(ie)}$provideDocumentHighlights(N,q,X,ie){return this._withAdapter(N,b,W=>W.provideDocumentHighlights(h.URI.revive(q),X,ie),void 0)}registerLinkedEditingRangeProvider(N,q,X){const ie=this._addNewAdapter(new C(this._documents,X),N);return this._proxy.$registerLinkedEditingRangeProvider(ie,this._transformDocumentSelector(q)),this._createDisposable(ie)}$provideLinkedEditingRanges(N,q,X,ie){return this._withAdapter(N,C,async W=>{const ee=await W.provideLinkedEditingRanges(h.URI.revive(q),X,ie);if(ee)return{ranges:ee.ranges,wordPattern:ee.wordPattern?qe._serializeRegExp(ee.wordPattern):void 0}},void 0)}registerReferenceProvider(N,q,X){const ie=this._addNewAdapter(new n(this._documents,X),N);return this._proxy.$registerReferenceSupport(ie,this._transformDocumentSelector(q)),this._createDisposable(ie)}$provideReferences(N,q,X,ie,W){return this._withAdapter(N,n,ee=>ee.provideReferences(h.URI.revive(q),X,ie,W),void 0)}registerCodeActionProvider(N,q,X,ie){const W=new r.DisposableStore,ee=this._addNewAdapter(new _(this._documents,this._commands.converter,this._diagnostics,X,this._logService,N,this._apiDeprecation),N);return this._proxy.$registerQuickFixSupport(ee,this._transformDocumentSelector(q),{providedKinds:ie?.providedCodeActionKinds?.map(me=>me.value),documentation:ie?.documentation?.map(me=>({kind:me.kind.value,command:this._commands.converter.toInternal(me.command,W)}))},qe._extLabel(N),Boolean(X.resolveCodeAction)),W.add(this._createDisposable(ee)),W}$provideCodeActions(N,q,X,ie,W){return this._withAdapter(N,_,ee=>ee.provideCodeActions(h.URI.revive(q),X,ie,W),void 0)}$resolveCodeAction(N,q,X){return this._withAdapter(N,_,ie=>ie.resolveCodeAction(q,X),void 0)}$releaseCodeActions(N,q){this._withAdapter(N,_,X=>Promise.resolve(X.releaseCodeActions(q)),void 0)}registerDocumentFormattingEditProvider(N,q,X){const ie=this._addNewAdapter(new R(this._documents,X),N);return this._proxy.$registerDocumentFormattingSupport(ie,this._transformDocumentSelector(q),N.identifier,N.displayName||N.name),this._createDisposable(ie)}$provideDocumentFormattingEdits(N,q,X,ie){return this._withAdapter(N,R,W=>W.provideDocumentFormattingEdits(h.URI.revive(q),X,ie),void 0)}registerDocumentRangeFormattingEditProvider(N,q,X){const ie=this._addNewAdapter(new U(this._documents,X),N);return this._proxy.$registerRangeFormattingSupport(ie,this._transformDocumentSelector(q),N.identifier,N.displayName||N.name),this._createDisposable(ie)}$provideDocumentRangeFormattingEdits(N,q,X,ie,W){return this._withAdapter(N,U,ee=>ee.provideDocumentRangeFormattingEdits(h.URI.revive(q),X,ie,W),void 0)}registerOnTypeFormattingEditProvider(N,q,X,ie){const W=this._addNewAdapter(new V(this._documents,X),N);return this._proxy.$registerOnTypeFormattingSupport(W,this._transformDocumentSelector(q),ie,N.identifier),this._createDisposable(W)}$provideOnTypeFormattingEdits(N,q,X,ie,W,ee){return this._withAdapter(N,V,me=>me.provideOnTypeFormattingEdits(h.URI.revive(q),X,ie,W,ee),void 0)}registerWorkspaceSymbolProvider(N,q){const X=this._addNewAdapter(new le(q,this._logService),N);return this._proxy.$registerNavigateTypeSupport(X),this._createDisposable(X)}$provideWorkspaceSymbols(N,q,X){return this._withAdapter(N,le,ie=>ie.provideWorkspaceSymbols(q,X),{symbols:[]})}$resolveWorkspaceSymbol(N,q,X){return this._withAdapter(N,le,ie=>ie.resolveWorkspaceSymbol(q,X),void 0)}$releaseWorkspaceSymbols(N,q){this._withAdapter(N,le,X=>X.releaseWorkspaceSymbols(q),void 0)}registerRenameProvider(N,q,X){const ie=this._addNewAdapter(new he(this._documents,X,this._logService),N);return this._proxy.$registerRenameSupport(ie,this._transformDocumentSelector(q),he.supportsResolving(X)),this._createDisposable(ie)}$provideRenameEdits(N,q,X,ie,W){return this._withAdapter(N,he,ee=>ee.provideRenameEdits(h.URI.revive(q),X,ie,W),void 0)}$resolveRenameLocation(N,q,X,ie){return this._withAdapter(N,he,W=>W.resolveRenameLocation(h.URI.revive(q),X,ie),void 0)}registerDocumentSemanticTokensProvider(N,q,X,ie){const W=this._nextHandle(),ee=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(W,new Qe(new H(this._documents,X),N)),this._proxy.$registerDocumentSemanticTokensProvider(W,this._transformDocumentSelector(q),ie,ee);let me=this._createDisposable(W);if(ee){const Te=X.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(ee));me=T.Disposable.from(me,Te)}return me}$provideDocumentSemanticTokens(N,q,X,ie){return this._withAdapter(N,H,W=>W.provideDocumentSemanticTokens(h.URI.revive(q),X,ie),null,!0)}$releaseDocumentSemanticTokens(N,q){this._withAdapter(N,H,X=>X.releaseDocumentSemanticColoring(q),void 0)}registerDocumentRangeSemanticTokensProvider(N,q,X,ie){const W=this._addNewAdapter(new L(this._documents,X),N);return this._proxy.$registerDocumentRangeSemanticTokensProvider(W,this._transformDocumentSelector(q),ie),this._createDisposable(W)}$provideDocumentRangeSemanticTokens(N,q,X,ie){return this._withAdapter(N,L,W=>W.provideDocumentRangeSemanticTokens(h.URI.revive(q),X,ie),null,!0)}registerCompletionItemProvider(N,q,X,ie){const W=this._addNewAdapter(new K(this._documents,this._commands.converter,X,this._apiDeprecation,N),N);return this._proxy.$registerSuggestSupport(W,this._transformDocumentSelector(q),ie,K.supportsResolving(X),`${N.identifier.value}(${ie.join("")})`),this._createDisposable(W)}$provideCompletionItems(N,q,X,ie,W){return this._withAdapter(N,K,ee=>ee.provideCompletionItems(h.URI.revive(q),X,ie,W),void 0)}$resolveCompletionItem(N,q,X){return this._withAdapter(N,K,ie=>ie.resolveCompletionItem(q,X),void 0)}$releaseCompletionItems(N,q){this._withAdapter(N,K,X=>X.releaseCompletionItems(q),void 0)}registerInlineCompletionsProvider(N,q,X){const ie=this._addNewAdapter(new x(this._documents,X,this._commands.converter),N);return this._proxy.$registerInlineCompletionsSupport(ie,this._transformDocumentSelector(q)),this._createDisposable(ie)}$provideInlineCompletions(N,q,X,ie,W){return this._withAdapter(N,x,ee=>ee.provideInlineCompletions(h.URI.revive(q),X,ie,W),void 0)}$handleInlineCompletionDidShow(N,q,X){this._withAdapter(N,x,async ie=>{ie.handleDidShowCompletionItem(q,X)},void 0)}$freeInlineCompletionsList(N,q){this._withAdapter(N,x,async X=>{X.disposeCompletions(q)},void 0)}registerSignatureHelpProvider(N,q,X,ie){const W=Array.isArray(ie)?{triggerCharacters:ie,retriggerCharacters:[]}:ie,ee=this._addNewAdapter(new ce(this._documents,X),N);return this._proxy.$registerSignatureHelpProvider(ee,this._transformDocumentSelector(q),W),this._createDisposable(ee)}$provideSignatureHelp(N,q,X,ie,W){return this._withAdapter(N,ce,ee=>ee.provideSignatureHelp(h.URI.revive(q),X,ie,W),void 0)}$releaseSignatureHelp(N,q){this._withAdapter(N,ce,X=>X.releaseSignatureHelp(q),void 0)}registerInlayHintsProvider(N,q,X){const ie=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,W=this._addNewAdapter(new z(this._documents,X),N);this._proxy.$registerInlayHintsProvider(W,this._transformDocumentSelector(q),ie);let ee=this._createDisposable(W);if(ie!==void 0){const me=X.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(ie));ee=T.Disposable.from(ee,me)}return ee}$provideInlayHints(N,q,X,ie){return this._withAdapter(N,z,W=>W.provideInlayHints(h.URI.revive(q),X,ie),void 0)}registerDocumentLinkProvider(N,q,X){const ie=this._addNewAdapter(new se(this._documents,X),N);return this._proxy.$registerDocumentLinkProvider(ie,this._transformDocumentSelector(q),typeof X.resolveDocumentLink=="function"),this._createDisposable(ie)}$provideDocumentLinks(N,q,X){return this._withAdapter(N,se,ie=>ie.provideLinks(h.URI.revive(q),X),void 0)}$resolveDocumentLink(N,q,X){return this._withAdapter(N,se,ie=>ie.resolveLink(q,X),void 0)}$releaseDocumentLinks(N,q){this._withAdapter(N,se,X=>X.releaseLinks(q),void 0)}registerColorProvider(N,q,X){const ie=this._addNewAdapter(new re(this._documents,X),N);return this._proxy.$registerDocumentColorProvider(ie,this._transformDocumentSelector(q)),this._createDisposable(ie)}$provideDocumentColors(N,q,X){return this._withAdapter(N,re,ie=>ie.provideColors(h.URI.revive(q),X),[])}$provideColorPresentations(N,q,X,ie){return this._withAdapter(N,re,W=>W.provideColorPresentations(h.URI.revive(q),X,ie),void 0)}registerFoldingRangeProvider(N,q,X){const ie=this._nextHandle(),W=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ie,new Qe(new we(this._documents,X),N)),this._proxy.$registerFoldingRangeProvider(ie,this._transformDocumentSelector(q),W);let ee=this._createDisposable(ie);if(W!==void 0){const me=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(W));ee=T.Disposable.from(ee,me)}return ee}$provideFoldingRanges(N,q,X,ie){return this._withAdapter(N,we,W=>W.provideFoldingRanges(h.URI.revive(q),X,ie),void 0)}registerSelectionRangeProvider(N,q,X){const ie=this._addNewAdapter(new Re(this._documents,X,this._logService),N);return this._proxy.$registerSelectionRangeProvider(ie,this._transformDocumentSelector(q)),this._createDisposable(ie)}$provideSelectionRanges(N,q,X,ie){return this._withAdapter(N,Re,W=>W.provideSelectionRanges(h.URI.revive(q),X,ie),[])}registerCallHierarchyProvider(N,q,X){const ie=this._addNewAdapter(new Fe(this._documents,X),N);return this._proxy.$registerCallHierarchyProvider(ie,this._transformDocumentSelector(q)),this._createDisposable(ie)}$prepareCallHierarchy(N,q,X,ie){return this._withAdapter(N,Fe,W=>Promise.resolve(W.prepareSession(h.URI.revive(q),X,ie)),void 0)}$provideCallHierarchyIncomingCalls(N,q,X,ie){return this._withAdapter(N,Fe,W=>W.provideCallsTo(q,X,ie),void 0)}$provideCallHierarchyOutgoingCalls(N,q,X,ie){return this._withAdapter(N,Fe,W=>W.provideCallsFrom(q,X,ie),void 0)}$releaseCallHierarchy(N,q){this._withAdapter(N,Fe,X=>Promise.resolve(X.releaseSession(q)),void 0)}registerTypeHierarchyProvider(N,q,X){const ie=this._addNewAdapter(new Ne(this._documents,X),N);return this._proxy.$registerTypeHierarchyProvider(ie,this._transformDocumentSelector(q)),this._createDisposable(ie)}$prepareTypeHierarchy(N,q,X,ie){return this._withAdapter(N,Ne,W=>Promise.resolve(W.prepareSession(h.URI.revive(q),X,ie)),void 0)}$provideTypeHierarchySupertypes(N,q,X,ie){return this._withAdapter(N,Ne,W=>W.provideSupertypes(q,X,ie),void 0)}$provideTypeHierarchySubtypes(N,q,X,ie){return this._withAdapter(N,Ne,W=>W.provideSubtypes(q,X,ie),void 0)}$releaseTypeHierarchy(N,q){this._withAdapter(N,Ne,X=>Promise.resolve(X.releaseSession(q)),void 0)}static _serializeRegExp(N){return{pattern:N.source,flags:(0,I.regExpFlags)(N)}}static _serializeIndentationRule(N){return{decreaseIndentPattern:qe._serializeRegExp(N.decreaseIndentPattern),increaseIndentPattern:qe._serializeRegExp(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?qe._serializeRegExp(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?qe._serializeRegExp(N.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(N){return{beforeText:qe._serializeRegExp(N.beforeText),afterText:N.afterText?qe._serializeRegExp(N.afterText):void 0,previousLineText:N.previousLineText?qe._serializeRegExp(N.previousLineText):void 0,action:N.action}}static _serializeOnEnterRules(N){return N.map(qe._serializeOnEnterRule)}setLanguageConfiguration(N,q,X){let{wordPattern:ie}=X;if(ie&&(0,I.regExpLeadsToEndlessLoop)(ie))throw new Error(`Invalid language configuration: wordPattern '${ie}' is not allowed to match the empty string.`);ie?this._documents.setWordDefinitionFor(q,ie):this._documents.setWordDefinitionFor(q,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const W=this._nextHandle(),ee={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?qe._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?qe._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?qe._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(W,q,ee),this._createDisposable(W)}$setWordDefinitions(N){for(const q of N)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=qe,qe._handlePool=0}),define(Ee[194],_e([0,1,5,8,6,35,13]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class I{constructor(P,t){this._handlePool=0,this._proxy=P.getProxy(h.MainContext.MainThreadLanguages),this._documents=t}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,t){await this._proxy.$changeLanguage(P,t);const S=this._documents.getDocumentData(P);if(!S)throw new Error(`document '${P.toString}' NOT found`);return S.document}async tokenAtPosition(P,t){const S=P.version,r=F.Position.from(t),d=await this._proxy.$tokensAtPosition(P.uri,r),a={type:E.StandardTokenType.Other,range:P.getWordRangeAtPosition(t)??new E.Range(t.line,t.character,t.line,t.character)};if(!d)return a;const l={range:F.Range.to(d.range),type:F.TokenType.to(d.type)};return!l.range.contains(t)||S!==P.version?a:l}createLanguageStatusItem(P){const t=this._handlePool++,S=this._proxy,r={selector:P,text:"",detail:"",severity:E.LanguageStatusSeverity.Information};let d;const a=()=>{d?.dispose(),d=(0,A.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(t,{selector:r.selector,text:r.text,message:typeof r.detail=="string"?r.detail:F.MarkdownString.from(r.detail),severity:r.severity===E.LanguageStatusSeverity.Error?T.default.Error:r.severity===E.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info})},0)},l={get selector(){return r.selector},set selector(p){r.selector=p,a()},get text(){return r.text},set text(p){r.text=p,a()},get detail(){return r.detail},set detail(p){r.detail=p,a()},get severity(){return r.severity},set severity(p){r.severity=p,a()},dispose(){d?.dispose(),S.$removeLanguageStatus(t)}};return a(),l}}e.ExtHostLanguages=I}),define(Ee[195],_e([0,1,5,14,30]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(I){return I&&I.title}let A=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(h.MainContext.MainThreadMessageService)}showMessage(D,P,t,S,r){const d={extension:D};let a;typeof S=="string"||T(S)?a=[S,...r]:(d.modal=S?.modal,d.useCustom=S?.useCustom,d.detail=S?.detail,a=r),d.useCustom&&(0,E.checkProposedApiEnabled)(D);const l=[];for(let p=0;p<a.length;p++){const v=a[p];if(typeof v=="string")l.push({title:v,handle:p,isCloseAffordance:!1});else if(typeof v=="object"){let{title:k,isCloseAffordance:c}=v;l.push({title:k,isCloseAffordance:!!c,handle:p})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(P,t,d,l).then(p=>{if(typeof p=="number")return a[p]})}};A=We([ze(1,F.ILogService)],A),e.ExtHostMessageService=A}),define(Ee[196],_e([0,1,23,3,56,7,20,9,10,2,61,5,8,6,170,92]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class p{constructor(k,c,w,y,i){this._textDocumentsAndEditors=w,this._textDocuments=y,this._extensionStoragePaths=i,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=k.getProxy(S.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=k.getProxy(S.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=k.getProxy(S.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const u=o.notebookEditor?.notebookUri,s=o.cell.handle,m=this._documents.get(u)?.getCell(s);if(m)return m.apiCell}return o}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(k=>k.apiEditor)}getEditorById(k){const c=this._editors.get(k);if(!c)throw new Error(`unknown text editor: ${k}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(k){for(const[c,w]of this._editors)if(w.apiEditor===k)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(k,c){const w=this._documents.get(k);if(!w&&!c)throw new Error(`NO notebook document for '${k}'`);return w}_getProviderData(k){const c=this._notebookContentProviders.get(k);if(!c)throw new Error(`NO provider for '${k}'`);return c}registerNotebookContentProvider(k,c,w,y,i){if((0,I.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:k,provider:w});let o;return w.onDidChangeNotebookContentOptions&&(o=w.onDidChangeNotebookContentOptions(()=>{const u=r.NotebookDocumentContentOptions.from(w.options);this._notebookProxy.$updateNotebookProviderOptions(c,u)})),this._notebookProxy.$registerNotebookProvider({id:k.identifier,location:k.extensionLocation},c,r.NotebookDocumentContentOptions.from(y),p._convertNotebookRegistrationData(k,i)),new d.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(k,c){if(!c)return;const w=c.filenamePattern.map(y=>r.NotebookExclusiveDocumentPattern.from(y)).filter(y=>y!==void 0);if(c.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:k.identifier,providerDisplayName:k.displayName||k.name,displayName:c.displayName,filenamePattern:w,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(k,c,w){const y=p._notebookStatusBarItemProviderHandlePool++,i=typeof w.onDidChangeCellStatusBarItems=="function"?p._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(y,w),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(y,i,c);let o;return i!==void 0&&(o=w.onDidChangeCellStatusBarItems(u=>this._notebookProxy.$emitCellStatusBarEvent(i))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(y),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(y,i),o&&o.dispose()})}async createNotebookDocument(k){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:k.viewType,content:k.content&&r.NotebookData.from(k.content)});return P.URI.revive(c)}async openNotebookDocument(k){const c=this._documents.get(k);if(c)return c.apiNotebook;const w=await this._notebookDocumentsProxy.$tryOpenNotebook(k),y=this._documents.get(P.URI.revive(w));return(0,D.assertIsDefined)(y?.apiNotebook)}async showNotebookDocument(k,c){P.URI.isUri(k)&&(k=await this.openNotebookDocument(k));let w;typeof c=="object"?w={position:r.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(r.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:w={preserveFocus:!1};const y=await this._notebookEditorsProxy.$tryShowNotebookDocument(k.uri,k.notebookType,w),i=y&&this._editors.get(y)?.apiEditor;if(i)return i;throw y?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(k,c,w,y){const i=this._notebookStatusBarItemProviders.get(k),o=P.URI.revive(c),u=this._documents.get(o);if(!u||!i)return;const s=u.getCellFromIndex(w);if(!s)return;const f=await i.provideCellStatusBarItems(s.apiCell,y);if(!f)return;const m=new T.DisposableStore,g=this._statusBarCache.add([m]),C=(Array.isArray(f)?f:[f]).map(n=>r.NotebookStatusBarItem.from(n,this._commandsConverter,m));return{cacheId:g,items:C}}$releaseNotebookCellStatusBarItems(k){this._statusBarCache.delete(k)}registerNotebookSerializer(k,c,w,y,i){if((0,I.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,w),this._notebookProxy.$registerNotebookSerializer(o,{id:k.identifier,location:k.extensionLocation},c,r.NotebookDocumentContentOptions.from(y),p._convertNotebookRegistrationData(k,i)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(k,c,w){const y=this._notebookSerializer.get(k);if(!y)throw new Error("NO serializer found");const i=await y.deserializeNotebook(c.buffer,w);return r.NotebookData.from(i)}async $notebookToData(k,c,w){const y=this._notebookSerializer.get(k);if(!y)throw new Error("NO serializer found");const i=await y.serializeNotebook(r.NotebookData.to(c),w);return h.VSBuffer.wrap(i)}async $openNotebook(k,c,w,y,i){const{provider:o}=this._getProviderData(k),u=await o.openNotebook(P.URI.revive(c),{backupId:w,untitledDocumentData:y?.buffer},i);return{metadata:u.metadata??Object.create(null),cells:u.cells.map(r.NotebookCellData.from)}}async $saveNotebook(k,c,w){const y=this.getNotebookDocument(P.URI.revive(c)),{provider:i}=this._getProviderData(k);return await i.saveNotebook(y.apiNotebook,w),!0}async $saveNotebookAs(k,c,w,y){const i=this.getNotebookDocument(P.URI.revive(c)),{provider:o}=this._getProviderData(k);return await o.saveNotebookAs(P.URI.revive(w),i.apiNotebook,y),!0}async $backupNotebook(k,c,w){const y=this.getNotebookDocument(P.URI.revive(c)),i=this._getProviderData(k),o=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension),u=String((0,E.hash)([y.uri.toString(),this._backupIdPool++])),s=P.URI.joinPath(o,u),f=await i.provider.backupNotebook(y.apiNotebook,{destination:s},w);return y.updateBackup(f),f.id}_createExtHostEditor(k,c,w){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const y=new l.ExtHostNotebookEditor(c,this._notebookEditorsProxy,k,w.visibleRanges.map(r.NotebookRange.to),w.selections.map(r.NotebookRange.to),typeof w.viewColumn=="number"?r.ViewColumn.to(w.viewColumn):void 0);this._editors.set(c,y)}$acceptDocumentAndEditorsDelta(k){if(k.removedDocuments)for(const w of k.removedDocuments){const y=P.URI.revive(w),i=this._documents.get(y);i&&(i.dispose(),this._documents.delete(y),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:i.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(i.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===y.toString()&&this._editors.delete(o.id)}if(k.addedDocuments){const w=[];for(const y of k.addedDocuments){const i=P.URI.revive(y.uri);if(this._documents.has(i))throw new Error(`adding EXISTING notebook ${i} `);const o=this,u=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(s){o._onDidChangeNotebookCells.fire(s)},emitCellOutputsChange(s){o._onDidChangeCellOutputs.fire(s)},emitCellMetadataChange(s){o._onDidChangeCellMetadata.fire(s)},emitCellExecutionStateChange(s){o._onDidChangeCellExecutionState.fire(s)}},i,y);w.push(...y.cells.map(s=>a.ExtHostCell.asModelAddData(u.apiNotebook,s))),this._documents.get(i)?.dispose(),this._documents.set(i,u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this._onDidOpenNotebookDocument.fire(u.apiNotebook)}}if(k.addedEditors)for(const w of k.addedEditors){if(this._editors.has(w.id))return;const y=P.URI.revive(w.documentUri),i=this._documents.get(y);i&&this._createExtHostEditor(i,w.id,w)}const c=[];if(k.removedEditors)for(const w of k.removedEditors){const y=this._editors.get(w);y&&(this._editors.delete(w),this._activeNotebookEditor?.id===y.id&&(this._activeNotebookEditor=void 0),c.push(y))}if(k.visibleEditors){this._visibleNotebookEditors=k.visibleEditors.map(y=>this._editors.get(y)).filter(y=>!!y);const w=new Set;this._visibleNotebookEditors.forEach(y=>w.add(y.id));for(const y of this._editors.values()){const i=w.has(y.id);y._acceptVisibility(i)}this._visibleNotebookEditors=[...this._editors.values()].map(y=>y).filter(y=>y.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}k.newActiveEditor===null?this._activeNotebookEditor=void 0:k.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(k.newActiveEditor)),k.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=p,p._notebookStatusBarItemProviderHandlePool=0}),define(Ee[197],_e([0,1,3,51,14,5,12,8]),function(te,e,h,F,E,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(S,r){const d=D._Keys.nextId();S.$registerNotebookEditorDecorationType(d,I.NotebookDecorationRenderOptions.from(r)),this.value={key:d,dispose(){S.$removeNotebookEditorDecorationType(d)}}}}D._Keys=new F.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(S,r,d){this._logService=S,this._extHostRpc=r,this._notebooksAndEditors=d,this._onDidChangeNotebookEditorSelection=new h.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new h.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(S){return new D(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),S).value}$acceptEditorPropertiesChanged(S,r){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",S,r);const d=this._notebooksAndEditors.getEditorById(S);r.visibleRanges&&d._acceptVisibleRanges(r.visibleRanges.ranges.map(I.NotebookRange.to)),r.selections&&d._acceptSelections(r.selections.selections.map(I.NotebookRange.to)),r.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.apiEditor,visibleRanges:d.apiEditor.visibleRanges}),r.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.apiEditor,selections:d.apiEditor.selections}))}$acceptEditorViewColumns(S){for(const r in S)this._notebooksAndEditors.getEditorById(r)._acceptViewColumn(I.ViewColumn.to(S[r]))}};P=We([ze(0,E.ILogService),ze(1,A.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(Ee[198],_e([0,1,16,13,21,3,7,20,2,25,14,5,8,6,66,163,30]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let v=class{constructor(i,o,u,s){this._initData=o,this._extHostNotebook=u,this._logService=s,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=i.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(i,o,u,s,f,m){for(let x of this._kernelData.values())if(x.controller.id===o&&P.ExtensionIdentifier.equals(i.identifier,x.extensionId))throw new Error(`notebook controller with id '${o}' ALREADY exist`);const g=this._handlePool++,b=this;this._logService.trace(`NotebookController[${g}], CREATED by ${i.identifier.value}, ${o}`);const C=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${i.identifier}'`);let n=!1;const _=new A.DisposableStore,R=new T.Emitter,U=new T.Emitter,V={id:`${i.identifier.value}/${o}`,notebookType:u,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:s||i.identifier.value,preloads:m?m.map(r.NotebookRendererScript.from):[]};let le=f??C,he;this._proxy.$addKernel(g,V).catch(x=>{console.log(x),n=!0});let j=0;const H=()=>{if(n)return;const x=++j;Promise.resolve().then(()=>{x===j&&this._proxy.$updateKernel(g,V)})},L=new I.ResourceMap,K={get id(){return o},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return V.label},set label(x){V.label=x??i.displayName??i.name,H()},get detail(){return V.detail??""},set detail(x){V.detail=x,H()},get description(){return V.description??""},set description(x){V.description=x,H()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(x){V.supportedLanguages=x,H()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(x){V.supportsExecutionOrder=x,H()},get rendererScripts(){return V.preloads?V.preloads.map(r.NotebookRendererScript.to):[]},get executeHandler(){return le},set executeHandler(x){le=x??C},get interruptHandler(){return he},set interruptHandler(x){he=x,V.supportsInterrupt=Boolean(x),H()},createNotebookCellExecution(x){if(n)throw new Error("notebook controller is DISPOSED");if(!L.has(x.notebook.uri))throw b._logService.trace(`NotebookController[${g}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(L.keys()).map(Y=>Y.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.notebook.uri.toString()}`);return b._createNotebookCellExecution(x)},dispose:()=>{n||(this._logService.trace(`NotebookController[${g}], DISPOSED`),n=!0,this._kernelData.delete(g),_.dispose(),R.dispose(),U.dispose(),this._proxy.$removeKernel(g))},updateNotebookAffinity(x,Y){b._proxy.$updateNotebookPriority(g,x.uri,Y)},onDidReceiveMessage:U.event,postMessage(x,Y){return(0,p.checkProposedApiEnabled)(i),b._proxy.$postMessage(g,Y&&b._extHostNotebook.getIdByEditor(Y),x)},asWebviewUri(x){return(0,p.checkProposedApiEnabled)(i),(0,a.asWebviewUri)(x,b._initData.remote)}};return this._kernelData.set(g,{extensionId:i.identifier,controller:K,onDidReceiveMessage:U,onDidChangeSelection:R,associatedNotebooks:L}),K}$acceptNotebookAssociation(i,o,u){const s=this._kernelData.get(i);if(s){const f=this._extHostNotebook.getNotebookDocument(D.URI.revive(o));u?s.associatedNotebooks.set(f.uri,!0):s.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,f.uri.toString(),u),s.onDidChangeSelection.fire({selected:u,notebook:f.apiNotebook})}}async $executeCells(i,o,u){const s=this._kernelData.get(i);if(!s)return;const f=this._extHostNotebook.getNotebookDocument(D.URI.revive(o)),m=[];for(let g of u){const b=f.getCell(g);b&&m.push(b.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,f.uri.toString(),m.length),await s.controller.executeHandler.call(s.controller,m,f.apiNotebook,s.controller)}catch(g){this._logService.error(`NotebookController[${i}] execute cells FAILED`,g),console.error(g)}}async $cancelCells(i,o,u){const s=this._kernelData.get(i);if(!s)return;const f=this._extHostNotebook.getNotebookDocument(D.URI.revive(o));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,f.apiNotebook);else for(let m of u){const g=f.getCell(m);g&&this._activeExecutions.get(g.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,o,u){const s=this._kernelData.get(i);if(!s)return;const f=this._extHostNotebook.getEditorById(o);s.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:u}))}_createNotebookCellExecution(i){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!u)throw new Error("invalid cell");if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const s=new c(u.notebook,u,this._proxy);this._activeExecutions.set(u.uri,s);const f=s.onDidChangeState(()=>{s.state===k.Resolved&&(s.dispose(),f.dispose(),this._activeExecutions.delete(u.uri))});return s.asApiObject()}};v=We([ze(3,t.ILogService)],v),e.ExtHostNotebookKernels=v;var k;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(k||(k={}));class c extends A.Disposable{constructor(i,o,u){super();this._document=i,this._cell=o,this._proxy=u,this._handle=c.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=k.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new w(10,s=>this.update(s)),this._executionOrder=o.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const o=Array.isArray(i)?i:[i];return this._proxy.$updateExecutions(o)}verifyStateForOutput(){if(this._state===k.Init)throw new Error("Must call start before modifying cell output");if(this._state===k.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let o=this._cell;if(i&&(o=this._document.getCellFromApiCell(i)),!o)throw new Error("INVALID cell");return o.handle}validateAndConvertOutputs(i){return i.map(o=>{const u=d.NotebookCellOutput.ensureUniqueMimeTypes(o.items,!0);return u===o.items?r.NotebookCellOutput.from(o):r.NotebookCellOutput.from({items:u,id:o.id,metadata:o.metadata})})}async updateOutputs(i,o,u){const s=this.cellIndexToHandle(o),f=this.validateAndConvertOutputs((0,h.asArray)(i));return this.updateSoon({editType:l.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:s,append:u,outputs:f})}async updateOutputItems(i,o,u){return i=d.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(i),!0),this.updateSoon({editType:l.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:i.map(r.NotebookCellOutputItem.from),outputId:o.id,append:u})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(u){i._executionOrder=u,i.update([{editType:l.CellExecutionUpdateType.ExecutionState,executionHandle:i._handle,executionOrder:i._executionOrder}])},start(u){if(i._state===k.Resolved||i._state===k.Started)throw new Error("Cannot call start again");i._state=k.Started,i._onDidChangeState.fire(),i.update({editType:l.CellExecutionUpdateType.ExecutionState,executionHandle:i._handle,runStartTime:u})},end(u,s){if(i._state===k.Resolved)throw new Error("Cannot call resolve twice");i._state=k.Resolved,i._onDidChangeState.fire(),i.updateSoon({editType:l.CellExecutionUpdateType.Complete,executionHandle:i._handle,runEndTime:s,lastRunSuccess:u}),i._collector.flush(),i._proxy.$removeExecution(i._handle)},clearOutput(u){return i.verifyStateForOutput(),i.updateOutputs([],u,!1)},appendOutput(u,s){return i.verifyStateForOutput(),i.updateOutputs(u,s,!0)},replaceOutput(u,s){return i.verifyStateForOutput(),i.updateOutputs(u,s,!1)},appendOutputItems(u,s){return i.verifyStateForOutput(),i.updateOutputItems(u,s,!0)},replaceOutputItems(u,s){return i.verifyStateForOutput(),i.updateOutputItems(u,s,!1)}})}}c.HANDLE=0;class w{constructor(i,o){this.delay=i,this.callback=o,this.batch=[]}addItem(i){return this.batch.push(i),this.waitPromise||(this.waitPromise=(0,F.timeout)(this.delay).then(()=>this.flush())),this.waitPromise}flush(){this.waitPromise=void 0;const i=this.batch;return this.batch=[],this.callback(i)}}}),define(Ee[199],_e([0,1,3,5,92]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(I,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,D,P){const t=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(D)?.fire({editor:t.apiEditor,message:P})}createRendererMessaging(I,D){if(!I.contributes?.notebookRenderer?.some(r=>r.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const P=!!I.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(r,d,a)=>{const l=P?r:p=>{const v={};t.set(v,p.editor),r({editor:v,message:p.message})};return this.getOrCreateEmitterFor(D).event(l,d,a)},postMessage:(r,d)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(r)&&([r,d]=[d,r]);const a=P?d:t.get(d),l=a&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(a);return this.proxy.$postMessage(l?.id,D,r)}}}getOrCreateEmitterFor(I){let D=this._rendererMessageEmitters.get(I);return D||(D=new h.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,D),D)}}e.ExtHostNotebookRenderers=T}),define(Ee[96],_e([0,1,5,3,7,23,4,12]),function(te,e,h,F,E,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends E.Disposable{constructor(a,l,p,v,k){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=k,this._id=k.$register(this.name,l,p,v),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?T.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(l=>this._proxy.$clear(l,a))}show(a,l){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof a=="boolean"?a:l)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class P extends D{constructor(a,l,p){super(a,!1,void 0,l,p)}append(a){super.append(a),this._id.then(l=>this._proxy.$append(l,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class t extends D{constructor(a,l,p){super(a,!0,l,void 0,p)}append(a){throw new Error("Not supported")}}class S{constructor(a,l){this.name=a,this._channel=l}append(a){this._channel.then(l=>l.append(a))}appendLine(a){this._channel.then(l=>l.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,l){this._channel.then(p=>p.show(a,l))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=S;let r=class{constructor(a){this._proxy=a.getProxy(h.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a,l){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new P(a,l.identifier.value,this._proxy)}createOutputChannelFromLogFile(a,l){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!l)throw new Error("illegal argument `file`. must not be falsy");return new t(a,l,this._proxy)}};r=We([ze(0,I.IExtHostRpcService)],r),e.ExtHostOutputService=r,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(Ee[200],_e([0,1,13,21,3,7,5,2,6,15,16,35,43]),function(te,e,h,F,E,T,A,I,D,P,t,S,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(a,l,p){const v=a.getProxy(A.MainContext.MainThreadQuickOpen);class k{constructor(m,g){this._sessions=new Map,this._instances=0,this._workspace=m,this._commands=g}showQuickPick(m,g,b,C=F.CancellationToken.None){this._onDidSelectItem=void 0;const n=Promise.resolve(m),_=++this._instances,R=v.$show(_,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},C),U={},V=R.then(()=>U);return Promise.race([V,n]).then(le=>{if(le!==U)return n.then(he=>{const j=[];for(let H=0;H<he.length;H++){const L=he[H];let K,x,Y,ce,z;typeof L=="string"?K=L:(K=L.label,x=L.description,Y=L.detail,ce=L.picked,z=L.alwaysShow),j.push({label:K,description:x,handle:H,detail:Y,picked:ce,alwaysShow:z})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{b.onDidSelectItem(he[H])}),v.$setItems(_,j),R.then(H=>{if(typeof H=="number")return he[H];if(Array.isArray(H))return H.map(L=>he[L])})})}).then(void 0,le=>{if(!(0,P.isPromiseCanceledError)(le))return v.$setError(_,le),Promise.reject(le)})}$onItemSelected(m){this._onDidSelectItem&&this._onDidSelectItem(m)}showInput(m,g=F.CancellationToken.None){return this._validateInput=m?m.validateInput:void 0,v.$input(m,typeof this._validateInput=="function",g).then(void 0,b=>{if(!(0,P.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(m){return this._validateInput?(0,h.asPromise)(()=>this._validateInput(m)):Promise.resolve(void 0)}async showWorkspaceFolderPick(m,g=F.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[m]);if(!b)return;const C=await this._workspace.getWorkspaceFolders2();if(!!C)return C.find(n=>n.uri.toString()===b.uri.toString())}createQuickPick(m,g){const b=new u(m,g,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(m){const g=new s(m,()=>this._sessions.delete(g._id));return this._sessions.set(g._id,g),g}$onDidChangeValue(m,g){const b=this._sessions.get(m);b&&b._fireDidChangeValue(g)}$onDidAccept(m){const g=this._sessions.get(m);g&&g._fireDidAccept()}$onDidChangeActive(m,g){const b=this._sessions.get(m);b instanceof u&&b._fireDidChangeActive(g)}$onDidChangeSelection(m,g){const b=this._sessions.get(m);b instanceof u&&b._fireDidChangeSelection(g)}$onDidTriggerButton(m,g){const b=this._sessions.get(m);b&&b._fireDidTriggerButton(g)}$onDidTriggerItemButton(m,g,b){const C=this._sessions.get(m);C instanceof u&&C._fireDidTriggerItemButton(g,b)}$onDidHide(m){const g=this._sessions.get(m);g&&g._fireDidHide()}}class c{constructor(m,g){this._extensionId=m,this._onDidDispose=g,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(m){this._title=m,this.update({title:m})}get step(){return this._steps}set step(m){this._steps=m,this.update({step:m})}get totalSteps(){return this._totalSteps}set totalSteps(m){this._totalSteps=m,this.update({totalSteps:m})}get enabled(){return this._enabled}set enabled(m){this._enabled=m,this.update({enabled:m})}get busy(){return this._busy}set busy(m){this._busy=m,this.update({busy:m})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(m){this._ignoreFocusOut=m,this.update({ignoreFocusOut:m})}get value(){return this._value}set value(m){this._value=m,this.update({value:m})}get placeholder(){return this._placeholder}set placeholder(m){this._placeholder=m,this.update({placeholder:m})}get buttons(){return this._buttons}set buttons(m){this._buttons=m.slice(),this._handlesToButtons.clear(),m.forEach((g,b)=>{const C=g===D.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(C,g)}),this.update({buttons:m.map((g,b)=>({...o(g),tooltip:g.tooltip,handle:g===D.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(m){this._value=m,this._onDidChangeValueEmitter.fire(m)}_fireDidTriggerButton(m){const g=this._handlesToButtons.get(m);g&&this._onDidTriggerButtonEmitter.fire(g)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),v.$dispose(this._id))}update(m){if(!this._disposed){for(const g of Object.keys(m)){const b=m[g];this._pendingUpdate[g]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){v.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}c._nextId=1;function w(f){if(f instanceof D.ThemeIcon)return{id:f.id};const m=i(f),g=y(f);return{dark:typeof m=="string"?I.URI.file(m):m,light:typeof g=="string"?I.URI.file(g):g}}function y(f){return typeof f=="object"&&"light"in f?f.light:f}function i(f){return typeof f=="object"&&"dark"in f?f.dark:f}function o(f){const m=w(f.iconPath);let g,b;return"id"in m?b=r.ThemeIcon.asClassName(m):g=m,{iconPath:g,iconClass:b}}class u extends c{constructor(m,g,b){super(m,b);this.enableProposedApi=g,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(m){this._items=m.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),m.forEach((g,b)=>{this._handlesToItems.set(b,g),this._itemsToHandles.set(g,b)}),this.update({items:m.map((g,b)=>({label:g.label,description:g.description,handle:b,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,buttons:g.buttons&&this.enableProposedApi?g.buttons.map((C,n)=>({...o(C),tooltip:C.tooltip,handle:n})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(m){this._canSelectMany=m,this.update({canSelectMany:m})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(m){this._matchOnDescription=m,this.update({matchOnDescription:m})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(m){this._matchOnDetail=m,this.update({matchOnDetail:m})}get sortByLabel(){return this._sortByLabel}set sortByLabel(m){this._sortByLabel=m,this.update({sortByLabel:m})}get activeItems(){return this._activeItems}set activeItems(m){this._activeItems=m.filter(g=>this._itemsToHandles.has(g)),this.update({activeItems:this._activeItems.map(g=>this._itemsToHandles.get(g))})}get selectedItems(){return this._selectedItems}set selectedItems(m){this._selectedItems=m.filter(g=>this._itemsToHandles.has(g)),this.update({selectedItems:this._selectedItems.map(g=>this._itemsToHandles.get(g))})}_fireDidChangeActive(m){const g=(0,t.coalesce)(m.map(b=>this._handlesToItems.get(b)));this._activeItems=g,this._onDidChangeActiveEmitter.fire(g)}_fireDidChangeSelection(m){const g=(0,t.coalesce)(m.map(b=>this._handlesToItems.get(b)));this._selectedItems=g,this._onDidChangeSelectionEmitter.fire(g)}_fireDidTriggerItemButton(m,g){const b=this._handlesToItems.get(m);if(!b||!b.buttons||!b.buttons.length)return;const C=b.buttons[g];C&&this._onDidTriggerItemButtonEmitter.fire({button:C,item:b})}}class s extends c{constructor(m,g){super(m,g);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(m){this._password=m,this.update({password:m})}get prompt(){return this._prompt}set prompt(m){this._prompt=m,this.update({prompt:m})}get validationMessage(){return this._validationMessage}set validationMessage(m){this._validationMessage=m,this.update({validationMessage:m,severity:m?S.default.Error:S.default.Ignore})}}return new k(l,p)}e.createExtHostQuickOpen=d}),define(Ee[201],_e([0,1,2,3,50,7,13,5,16,107,14,25,30,43,8]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(m){if(m)return typeof m.iconPath=="string"?h.URI.file(m.iconPath):h.URI.isUri(m.iconPath)||d.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function p(m,g){if(!m.iconPath&&!g.iconPath)return 0;if(m.iconPath){if(!g.iconPath)return 1}else return-1;const b=typeof m.iconPath=="string"?m.iconPath:h.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,C=typeof g.iconPath=="string"?g.iconPath:h.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,P.comparePaths)(b,C)}function v(m,g){let b=0;if(m.strikeThrough!==g.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==g.faded)return m.faded?1:-1;if(m.tooltip!==g.tooltip)return(m.tooltip||"").localeCompare(g.tooltip||"");if(b=p(m,g),b!==0)return b;if(m.light&&g.light)b=p(m.light,g.light);else{if(m.light)return 1;if(g.light)return-1}if(b!==0)return b;if(m.dark&&g.dark)b=p(m.dark,g.dark);else{if(m.dark)return 1;if(g.dark)return-1}return b}function k(m,g){if(m.command!==g.command)return m.command<g.command?-1:1;if(m.title!==g.title)return m.title<g.title?-1:1;if(m.tooltip!==g.tooltip){if(m.tooltip!==void 0&&g.tooltip!==void 0)return m.tooltip<g.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(m.arguments===g.arguments)return 0;if(m.arguments)if(g.arguments){if(m.arguments.length!==g.arguments.length)return m.arguments.length-g.arguments.length}else return 1;else return-1;for(let b=0;b<m.arguments.length;b++){const C=m.arguments[b],n=g.arguments[b];if(C!==n)return C<n?-1:1}return 0}function c(m,g){let b=(0,P.comparePaths)(m.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(b!==0)return b;if(m.command&&g.command)b=k(m.command,g.command);else{if(m.command)return 1;if(g.command)return-1}if(b!==0)return b;if(m.decorations&&g.decorations)b=v(m.decorations,g.decorations);else{if(m.decorations)return 1;if(g.decorations)return-1}return b}function w(m,g){for(let b=0;b<m.length;b++)if(m[b]!==g[b])return!1;return!0}function y(m,g){return m.command===g.command&&m.title===g.title&&m.tooltip===g.tooltip&&(m.arguments&&g.arguments?w(m.arguments,g.arguments):m.arguments===g.arguments)}function i(m,g){return(0,D.equals)(m,g,y)}class o{constructor(g,b,C){this._extension=g,this._proxy=b,this._sourceControlHandle=C,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(g){this._proxy.$setInputBoxValue(this._sourceControlHandle,g),this.updateValue(g)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(g){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,g),this._placeholder=g}get validateInput(){return(0,r.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(g){if((0,r.checkProposedApiEnabled)(this._extension),g&&typeof g!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=g,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!g)}get visible(){return this._visible}set visible(g){g=!!g,this._visible!==g&&(this._visible=g,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,g))}focus(){(0,r.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(g,b){(0,r.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,g,b)}$onInputBoxValueChange(g){this.updateValue(g)}updateValue(g){this._value=g,this._onDidChange.fire(g)}}e.ExtHostSCMInputBox=o;class u{constructor(g,b,C,n,_){this._proxy=g,this._commands=b,this._sourceControlHandle=C,this._id=n,this._label=_,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=u._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(g){this._label=g,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,g)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(g){this._hideWhenEmpty=g,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(g){this._resourceStates=[...g],this._onDidUpdateResourceStates.fire()}getResourceState(g){return this._resourceStatesMap.get(g)}$executeResourceCommand(g,b){const C=this._resourceStatesCommandsMap.get(g);return C?(0,A.asPromise)(()=>this._commands.executeCommand(C.command,...C.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this._resourceStates].sort(c),C=(0,D.sortedDiff)(this._resourceSnapshot,g,c).map(R=>{const U=R.toInsert.map(V=>{const le=this._resourceHandlePool++;this._resourceStatesMap.set(le,V);const he=V.resourceUri;let j;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"){const we=new T.DisposableStore;j=this._commands.converter.toInternal(V.command,we),this._resourceStatesDisposablesMap.set(le,we)}else this._resourceStatesCommandsMap.set(le,V.command);const H=l(V.decorations),L=V.decorations&&l(V.decorations.light)||H,K=V.decorations&&l(V.decorations.dark)||H,x=[L,K],Y=V.decorations&&V.decorations.tooltip||"",ce=V.decorations&&!!V.decorations.strikeThrough,z=V.decorations&&!!V.decorations.faded,se=V.contextValue||"";return{rawResource:[le,he,x,Y,ce,z,se,j],handle:le}});return{start:R.start,deleteCount:R.deleteCount,toInsert:U}}),n=C.map(({start:R,deleteCount:U,toInsert:V})=>[R,U,V.map(le=>le.rawResource)]),_=C.reverse();for(const{start:R,deleteCount:U,toInsert:V}of _){const le=V.map(j=>j.handle),he=this._handlesSnapshot.splice(R,U,...le);for(const j of he)this._resourceStatesMap.delete(j),this._resourceStatesCommandsMap.delete(j),this._resourceStatesDisposablesMap.get(j)?.dispose(),this._resourceStatesDisposablesMap.delete(j)}return this._resourceSnapshot=g,n}dispose(){this._disposed=!0,this._onDidDispose.fire()}}u._handlePool=0;class s{constructor(g,b,C,n,_,R){this._proxy=b,this._commands=C,this._id=n,this._label=_,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new o(g,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,n,_,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(g){this._count!==g&&(this._count=g,this._proxy.$updateSourceControl(this.handle,{count:g}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(g){this._quickDiffProvider=g,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this._commitTemplate}set commitTemplate(g){g!==this._commitTemplate&&(this._commitTemplate=g,this._proxy.$updateSourceControl(this.handle,{commitTemplate:g}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(g){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=g;const b=this._commands.converter.toInternal(g,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(g){if(this._statusBarCommands&&g&&i(this._statusBarCommands,g))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=g;const b=(g||[]).map(C=>this._commands.converter.toInternal(C,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(g,b){const C=new u(this._proxy,this._commands,this.handle,g,b),n=F.Event.once(C.onDidDispose)(()=>this.createdResourceGroups.delete(C));return this.createdResourceGroups.set(C,n),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const g=[],b=[];for(const[C,n]of this.createdResourceGroups){n.dispose();const _=C.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(C),this.eventuallyUpdateResourceStates()});F.Event.once(C.onDidDispose)(()=>{this.updatedResourceGroups.delete(C),_.dispose(),this._groups.delete(C.handle),this._proxy.$unregisterGroup(this.handle,C.handle)}),g.push([C.handle,C.id,C.label,C.features]);const R=C._takeResourceStateSnapshot();R.length>0&&b.push([C.handle,R]),this._groups.set(C.handle,C)}this._proxy.$registerGroups(this.handle,g,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const g=[];this.updatedResourceGroups.forEach(b=>{const C=b._takeResourceStateSnapshot();C.length!==0&&g.push([b.handle,C])}),g.length>0&&this._proxy.$spliceResourceStates(this.handle,g),this.updatedResourceGroups.clear()}getResourceGroup(g){return this._groups.get(g)}setSelectionState(g){this._selected=g,this._onDidChangeSelection.fire(g)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(g=>g.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,We([(0,E.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),We([(0,E.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let f=class xi{constructor(g,b,C){this._commands=b,this.logService=C,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=g.getProxy(I.MainContext.MainThreadSCM),this._telemetry=g.getProxy(I.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===3){const _=this._sourceControls.get(n.sourceControlHandle);if(!_)return n;const R=_.getResourceGroup(n.groupHandle);return R?R.getResourceState(n.handle):n}else if(n&&n.$mid===4){const _=this._sourceControls.get(n.sourceControlHandle);return _?_.getResourceGroup(n.groupHandle):n}else if(n&&n.$mid===5){const _=this._sourceControls.get(n.handle);return _||n}return n}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(g,b,C,n){this.logService.trace("ExtHostSCM#createSourceControl",g.identifier.value,b,C,n),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const _=xi._handlePool++,R=new s(g,this._proxy,this._commands,b,C,n);this._sourceControls.set(_,R);const U=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(g.identifier))||[];return U.push(R),this._sourceControlsByExtension.set(S.ExtensionIdentifier.toKey(g.identifier),U),R}getLastInputBox(g){this.logService.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const b=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(g.identifier)),C=b&&b[b.length-1];return C&&C.inputBox}$provideOriginalResource(g,b,C){const n=h.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",g,n.toString());const _=this._sourceControls.get(g);return!_||!_.quickDiffProvider||!_.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>_.quickDiffProvider.provideOriginalResource(n,C)).then(R=>R||null)}$onInputBoxValueChange(g,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",g);const C=this._sourceControls.get(g);return C&&C.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(g,b,C,n){this.logService.trace("ExtHostSCM#$executeResourceCommand",g,b,C);const _=this._sourceControls.get(g);if(!_)return Promise.resolve(void 0);const R=_.getResourceGroup(b);return R?R.$executeResourceCommand(C,n):Promise.resolve(void 0)}$validateInput(g,b,C){this.logService.trace("ExtHostSCM#$validateInput",g);const n=this._sourceControls.get(g);return!n||!n.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>n.inputBox.validateInput(b,C)).then(_=>{if(!_)return Promise.resolve(void 0);const R=a.MarkdownString.fromStrict(_.message);return R?Promise.resolve([R,_.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this._sourceControls.get(g)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=g,Promise.resolve(void 0)}};f._handlePool=0,f=We([ze(2,t.ILogService)],f),e.ExtHostSCM=f});var Ze=this&&this.__classPrivateFieldSet||function(te,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!E:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(te,h):E?E.value=h:e.set(te,h),h},Oe=this&&this.__classPrivateFieldGet||function(te,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!F:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(te):F?F.value:e.get(te)};define(Ee[202],_e([0,1,6,5,126,7,8]),function(te,e,h,F,E,T,A){"use strict";var I,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(d,a,l,p,v=h.StatusBarAlignment.Left,k){I.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Ze(this,I,d,"f"),Ze(this,D,a,"f"),this._entryId=P.ID_GEN++,this._extension=l,this._id=p,this._alignment=v,this._priority=k}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!P.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Oe(this,D,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Oe(this,D,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,I,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let a;this._name?a=this._name:a=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let l=this._color;this._backgroundColor&&(l=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const p=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,I,"f").$setEntry(this._entryId,d,a,this._text,p,this._command?.internal,l,this._backgroundColor,this._alignment===h.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,I=new WeakMap,D=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new h.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.ThemeColor("statusBarItem.warningForeground")]]);class t{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const a={message:d};return this._messages.unshift(a),this._update(),new h.Disposable(()=>{const l=this._messages.indexOf(a);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class S{constructor(d,a){this._proxy=d.getProxy(F.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new t(this)}createStatusBarEntry(d,a,l,p){return new P(this._proxy,this._commands,d,a,l,p)}setStatusBarMessage(d,a){const l=this._statusMessage.setMessage(d);let p;return typeof a=="number"?p=setTimeout(()=>l.dispose(),a):typeof a!="undefined"&&a.then(()=>l.dispose(),()=>l.dispose()),new h.Disposable(()=>{l.dispose(),clearTimeout(p)})}}e.ExtHostStatusBar=S}),define(Ee[71],_e([0,1,5,3,4]),function(te,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(I){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(h.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,D){this._proxy.$registerExtensionStorageKeysToSync(I,D)}getValue(I,D,P){return this._proxy.$getValue(I,D).then(t=>t||P)}setValue(I,D,P){return this._proxy.$setValue(I,D,P)}$acceptValue(I,D,P){this._onDidChangeStorage.fire({shared:I,key:D,value:P})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(Ee[72],_e([0,1,4,29,14,70,2]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,h.createDecorator)("IExtensionStoragePaths");let I=class{constructor(P,t,S){this._logService=t,this._extHostFileSystem=S,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(r=>this._value=r)}async _getWorkspaceStorageURI(P){return A.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,t=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(S){this._logService.error("[ExtHostStorage]",S);return}}workspaceValue(P){if(this._value)return A.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return A.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=We([ze(0,F.IExtHostInitDataService),ze(1,E.ILogService),ze(2,T.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(Ee[37],_e([0,1,3,5,4,2,12,7,6,127,15,165,21,36,148,43,10]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class v{constructor(f,m,g,b){this._proxy=f,this._id=m,this._creationOptions=g,this._name=b,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(n=>this._pidPromiseComplete=n);const C=this;this.value={get name(){return C._name||""},get processId(){return C._pidPromise},get creationOptions(){return C._creationOptions},get exitStatus(){return C._exitStatus},get state(){return C._state},sendText(n,_=!0){C._checkDisposed(),C._proxy.$sendText(C._id,n,_)},show(n){C._checkDisposed(),C._proxy.$show(C._id,n)},hide(){C._checkDisposed(),C._proxy.$hide(C._id)},dispose(){C._disposed||(C._disposed=!0,C._proxy.$dispose(C._id))},get dimensions(){if(!(C._cols===void 0||C._rows===void 0))return{columns:C._cols,rows:C._rows}}}}async create(f,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:(0,p.withNullAsUndefined)(f.shellPath),shellArgs:(0,p.withNullAsUndefined)(f.shellArgs),cwd:(0,p.withNullAsUndefined)(f.cwd),env:(0,p.withNullAsUndefined)(f.env),icon:(0,p.withNullAsUndefined)(o(f.iconPath)),color:l.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:(0,p.withNullAsUndefined)(f.message),strictEnv:(0,p.withNullAsUndefined)(f.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(f.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(m?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(m?.useShellEnvironment),isSplitTerminal:m?.isSplitTerminal,target:m?.target})}async createExtensionTerminal(f,m,g,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:g,color:l.ThemeColor.isThemeColor(b)?b.id:void 0,isSplitTerminal:f,target:m}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitCode(f){this._exitStatus=Object.freeze({code:f})}setDimensions(f,m){return f===this._cols&&m===this._rows||f===0||m===0?!1:(this._cols=f,this._rows=m,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(m=>{m!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=v;class k{constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._onProcessData=new h.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new h.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new h.Emitter,this._onProcessTitleChanged=new h.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new h.Emitter,this._onProcessShellTypeChanged=new h.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput&&this._pty.handleInput(f)}resize(f,m){this._pty.setDimensions&&this._pty.setDimensions({columns:f,rows:m})}async processBinary(f){}acknowledgeDataEvent(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(f){this._pty.onDidWrite(m=>this._onProcessData.fire(m)),this._pty.onDidClose&&this._pty.onDidClose((m=void 0)=>{this._onProcessExit.fire(m===void 0?void 0:m)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(m=>this._onProcessOverrideDimensions.fire(m&&{cols:m.columns,rows:m.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(m=>this._onProcessTitleChanged.fire(m)),this._pty.open(f||void 0),this._pty.setDimensions&&f&&this._pty.setDimensions(f),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=k;let c=1,w=class extends I.Disposable{constructor(f,m){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new h.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new h.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new h.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new h.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new h.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=m.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new h.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(f),this._register({dispose:()=>{for(const[g,b]of this._terminalProcesses)b.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,m){const g=new v(this._proxy,(0,d.generateUuid)(),f,f.name),b=new k(f.pty);return g.createExtensionTerminal(m?.isSplitTerminal,m?.target,o(f.iconPath),u(f.color)).then(C=>{const n=this._setupExtHostProcessListeners(C,b);this._terminalProcessDisposables[C]=n}),this._terminals.push(g),g.value}attachPtyToTerminal(f,m){if(!this._getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const b=new k(m),C=this._setupExtHostProcessListeners(f,b);this._terminalProcessDisposables[f]=C}async $acceptActiveTerminalChanged(f){const m=this._activeTerminal;if(f===null){this._activeTerminal=void 0,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const g=this._getTerminalById(f);g&&(this._activeTerminal=g,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,m){const g=this._getTerminalById(f);g&&this._onDidWriteTerminalData.fire({terminal:g.value,data:m})}async $acceptTerminalDimensions(f,m,g){const b=this._getTerminalById(f);b&&b.setDimensions(m,g)&&this._onDidChangeTerminalDimensions.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(f,m,g){this._terminalProcesses.get(f)?.resize(m,g)}async $acceptTerminalTitleChange(f,m){const g=this._getTerminalById(f);g&&(g.name=m)}async $acceptTerminalClosed(f,m){const g=this._getTerminalObjectIndexById(this._terminals,f);if(g!==null){const b=this._terminals.splice(g,1)[0];b.setExitCode(m),this._onDidCloseTerminal.fire(b.value)}}$acceptTerminalOpened(f,m,g,b){if(m){const _=this._getTerminalObjectIndexById(this._terminals,m);if(_!==null){this._terminals[_]._id=f,this._onDidOpenTerminal.fire(this.terminals[_]),this._terminals[_].isOpen=!0;return}}const C={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:T.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},n=new v(this._proxy,f,C,g);this._terminals.push(n),this._onDidOpenTerminal.fire(n.value),n.isOpen=!0}async $acceptTerminalProcessId(f,m){const g=this._getTerminalById(f);g&&g._setProcessId(m)}async $startExtensionTerminal(f,m){const g=this._getTerminalById(f);if(!g)return{message:(0,P.localize)(0,null,f)};g.isOpen||await new Promise(C=>{const n=this.onDidOpenTerminal(async _=>{_===g.value&&(n.dispose(),C())})});const b=this._terminalProcesses.get(f);b?b.startSendingEvents(m):this._extensionTerminalAwaitingStart[f]={initialDimensions:m}}_setupExtHostProcessListeners(f,m){const g=new I.DisposableStore;g.add(m.onProcessReady(C=>this._proxy.$sendProcessReady(f,C.pid,C.cwd))),g.add(m.onProcessTitleChanged(C=>this._proxy.$sendProcessTitle(f,C))),this._bufferer.startBuffering(f,m.onProcessData),g.add(m.onProcessExit(C=>this._onProcessExit(f,C))),m.onProcessOverrideDimensions&&g.add(m.onProcessOverrideDimensions(C=>this._proxy.$sendOverrideDimensions(f,C))),this._terminalProcesses.set(f,m);const b=this._extensionTerminalAwaitingStart[f];return b&&m instanceof k&&(m.startSendingEvents(b.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),g}$acceptProcessAckDataEvent(f,m){this._terminalProcesses.get(f)?.acknowledgeDataEvent(m)}$acceptProcessInput(f,m){this._terminalProcesses.get(f)?.input(m)}$acceptTerminalInteraction(f){const m=this._getTerminalById(f);m?.setInteractedWith()&&this._onDidChangeTerminalState.fire({terminal:m.value,state:m.value.state})}$acceptProcessResize(f,m,g){try{this._terminalProcesses.get(f)?.resize(m,g)}catch(b){if(b.code!=="EPIPE"&&b.code!=="ERR_IPC_CHANNEL_CLOSED")throw b}}$acceptProcessShutdown(f,m){this._terminalProcesses.get(f)?.shutdown(m)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(m=>this._proxy.$sendProcessInitialCwd(f,m))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(m=>this._proxy.$sendProcessCwd(f,m))}$acceptProcessRequestLatency(f){return f}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,m,g){if(this._profileProviders.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this._profileProviders.set(m,g),this._proxy.$registerProfileProvider(m,f.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(m),this._proxy.$unregisterProfileProvider(m)})}async $createContributedProfileTerminal(f,m){const g=new r.CancellationTokenSource().token,b=await this._profileProviders.get(f)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(!b||!("options"in b))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in b.options){this.createExtensionTerminal(b.options,m);return}this.createTerminalFromOptions(b.options,m)}}async $provideLinks(f,m){const g=this._getTerminalById(f);if(!g)return[];this._terminalLinkCache.delete(f);const b=this._terminalLinkCancellationSource.get(f);b&&b.dispose(!0);const C=new r.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,C);const n=[],_={terminal:g.value,line:m},R=[];for(const le of this._linkProviders)R.push(new Promise(async he=>{C.token.onCancellationRequested(()=>he({provider:le,links:[]}));const j=await le.provideTerminalLinks(_,C.token)||[];C.token.isCancellationRequested||he({provider:le,links:j})}));const U=await Promise.all(R);if(C.token.isCancellationRequested)return[];const V=new Map;for(const le of U)le&&le.links.length>0&&n.push(...le.links.map(he=>{const j={id:c++,startIndex:he.startIndex,length:he.length,label:he.tooltip};return V.set(j.id,{provider:le.provider,link:he}),j}));return this._terminalLinkCache.set(f,V),n}$activateLink(f,m){const g=this._terminalLinkCache.get(f)?.get(m);!g||g.provider.handleTerminalLink(g.link)}_onProcessExit(f,m){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const g=this._terminalProcessDisposables[f];g&&(g.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,m)}_getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}_getTerminalObjectById(f,m){const g=this._getTerminalObjectIndexById(f,m);return g!==null?f[g]:null}_getTerminalObjectIndexById(f,m){let g=null;return f.some((b,C)=>b._id===m?(g=C,!0):!1),g}getEnvironmentVariableCollection(f){let m=this._environmentVariableCollections.get(f.identifier.value);return m||(m=new y,this._setEnvironmentVariableCollection(f.identifier.value,m)),m}_syncEnvironmentVariableCollection(f,m){const g=(0,S.serializeEnvironmentVariableCollection)(m.map);this._proxy.$setEnvironmentVariableCollection(f,m.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(f){f.forEach(m=>{const g=m[0],b=new y(m[1]);this._setEnvironmentVariableCollection(g,b)})}$acceptDefaultProfile(f,m){this._defaultProfile=f,this._defaultAutomationProfile=m}_setEnvironmentVariableCollection(f,m){this._environmentVariableCollections.set(f,m),m.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,m)})}};w=We([ze(1,A.IExtHostRpcService)],w),e.BaseExtHostTerminalService=w;class y{constructor(f){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new h.Emitter,this.map=new Map(f)}get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(f,m){this._setIfDiffers(f,{value:m,type:D.EnvironmentVariableMutatorType.Replace})}append(f,m){this._setIfDiffers(f,{value:m,type:D.EnvironmentVariableMutatorType.Append})}prepend(f,m){this._setIfDiffers(f,{value:m,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(f,m){const g=this.map.get(f);(!g||g.value!==m.value||g.type!==m.type)&&(this.map.set(f,m),this._onDidChangeCollection.fire())}get(f){return this.map.get(f)}forEach(f,m){this.map.forEach((g,b)=>f.call(m,b,g,this))}delete(f){this.map.delete(f),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=y;let i=class extends w{constructor(f){super(!1,f)}createTerminal(f,m,g){throw new t.NotSupportedError}createTerminalFromOptions(f,m){throw new t.NotSupportedError}};i=We([ze(0,A.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function o(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function u(s){return l.ThemeColor.isThemeColor(s)?s:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(te,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!E:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(te,h):E?E.value=h:e.set(te,h),h},Oe=this&&this.__classPrivateFieldGet||function(te,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!F:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(te):F?F.value:e.get(te)};define(Ee[203],_e([0,1,23,21,3,233,56,188,7,22,10,36,5,12,63,8,6,173,89,67]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p,v,k,c){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let y=class{constructor(R,U){this.resultsChangedEmitter=new E.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(r.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new o(this.proxy),U.registerArgumentProcessor({processArgument:V=>V?.$mid===13?l.TestItem.toItemFromContext(V):V})}createTestController(R,U){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const V=new D.DisposableStore,le=V.add(new v.SingleUseTestCollection(R));le.root.label=U;const he=new Map,j=this.proxy,H={items:le.root.children,get label(){return U},set label(K){U=K,le.root.label=K,j.$updateControllerLabel(R,U)},get id(){return R},createRunProfile:(K,x,Y,ce,z)=>{let se=(0,A.hash)(K);for(;he.has(se);)se++;const re=new C(this.proxy,R,se,K,x,Y,ce,z);return he.set(se,re),re},createTestItem(K,x,Y){return new a.TestItemImpl(R,K,x,Y)},createTestRun:(K,x,Y=!0)=>this.runTracker.createTestRun(R,le,K,x,Y),set resolveHandler(K){le.resolveHandler=K},get resolveHandler(){return le.resolveHandler},dispose:()=>{V.dispose()}};H.createRunConfiguration=H.createRunProfile,j.$registerTestController(R,U),V.add((0,D.toDisposable)(()=>j.$unregisterTestController(R)));const L={controller:H,collection:le,profiles:he};return this.controllers.set(R,L),V.add((0,D.toDisposable)(()=>this.controllers.delete(R))),V.add(le.onDidGenerateDiff(K=>j.$publishDiff(R,K))),H}createTestObserver(){return this.observer.checkout()}async runTests(R,U=F.CancellationToken.None){const V=u(R);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const le=this.controllers.get(V.controllerId);if(!le)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(he=>he.id)??[le.collection.root.id],profileGroup:n[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:R.exclude?.map(he=>he.id)},U)}$provideFileCoverage(R,U,V){return I.Iterable.find(this.runTracker.trackers,le=>le.id===R)?.getCoverage(U)?.provideFileCoverage(V)??Promise.resolve([])}$resolveFileCoverage(R,U,V,le){return I.Iterable.find(this.runTracker.trackers,he=>he.id===R)?.getCoverage(U)?.resolveFileCoverage(V,le)??Promise.resolve([])}$configureRunProfile(R,U){this.controllers.get(R)?.profiles.get(U)?.configureHandler?.()}$getTestTags(R){const U=this.controllers.get(R);if(!U)return Promise.resolve([]);const V=new Map;for(const le of U.profiles.values())if(le.tag){const he=l.TestTag.display(R,le.tag);V.set(he.id,he)}for(const le of U.collection.tags()){const he=l.TestTag.display(R,le);V.set(he.id,he)}return Promise.resolve([...V.values()])}$publishTestResults(R){this.results=Object.freeze(R.map(U=>(0,P.deepFreeze)(l.TestResults.to(U))).concat(this.results).sort((U,V)=>V.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,U){const V=this.controllers.get(c.TestId.fromString(R).controllerId)?.collection;V&&(await V.expand(R,U<0?Infinity:U),V.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,U){const V=this.controllers.get(R.controllerId);if(!V)return;const{collection:le,profiles:he}=V,j=he.get(R.profileId);if(!j)return;const H=R.testIds.map(Y=>le.tree.get(Y)).filter(t.isDefined),L=R.excludeExtIds.map(Y=>V.collection.tree.get(Y)).filter(t.isDefined).filter(Y=>H.some(ce=>ce.fullId.compare(Y.fullId)===2));if(!H.length)return;const K=new p.TestRunRequest(H.some(Y=>Y.actual instanceof a.TestItemRootImpl)?void 0:H.map(Y=>Y.actual),L.map(Y=>Y.actual),j),x=this.runTracker.prepareForMainThreadTestRun(K,s.fromInternal(R,V.collection),U);try{await j.runHandler(K,U)}finally{x.isRunning&&!U.isCancellationRequested&&await E.Event.toPromise(x.onEnd),this.runTracker.cancelRunById(R.runId)}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};y=We([ze(0,d.IExtHostRpcService)],y),e.ExtHostTesting=y;class i extends D.Disposable{constructor(R,U,V){super();this.dto=R,this.proxy=U,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new E.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new F.CancellationTokenSource(V)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:le}of this.tasks.values())le.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const U=this.dto.id,V=this.dto.controllerId,le=(0,S.generateUuid)(),he=new f(this.proxy,U,le),j=K=>(x,...Y)=>{if(H){console.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(x)||(this.ensureTestIsKnown(x),K(x,...Y))};let H=!1;const L={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return he.coverageProvider},set coverageProvider(K){he.coverageProvider=K},enqueued:j(K=>{this.proxy.$updateTestStateInRun(U,le,c.TestId.fromExtHostTestItem(K,V).toString(),1)}),skipped:j(K=>{this.proxy.$updateTestStateInRun(U,le,c.TestId.fromExtHostTestItem(K,V).toString(),5)}),started:j(K=>{this.proxy.$updateTestStateInRun(U,le,c.TestId.fromExtHostTestItem(K,V).toString(),2)}),errored:j((K,x,Y)=>{this.proxy.$appendTestMessagesInRun(U,le,c.TestId.fromExtHostTestItem(K,V).toString(),x instanceof Array?x.map(l.TestMessage.from):[l.TestMessage.from(x)]),this.proxy.$updateTestStateInRun(U,le,c.TestId.fromExtHostTestItem(K,V).toString(),6,Y)}),failed:j((K,x,Y)=>{this.proxy.$appendTestMessagesInRun(U,le,c.TestId.fromExtHostTestItem(K,V).toString(),x instanceof Array?x.map(l.TestMessage.from):[l.TestMessage.from(x)]),this.proxy.$updateTestStateInRun(U,le,c.TestId.fromExtHostTestItem(K,V).toString(),4,Y)}),passed:j((K,x)=>{this.proxy.$updateTestStateInRun(U,le,c.TestId.fromExtHostTestItem(K,this.dto.controllerId).toString(),3,x)}),appendOutput:(K,x,Y)=>{H||(Y&&(this.dto.isIncluded(Y)?this.ensureTestIsKnown(Y):Y=void 0),this.proxy.$appendOutputToRun(U,le,h.VSBuffer.fromString(K),x&&l.location.from(x),Y&&c.TestId.fromExtHostTestItem(Y,V).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(U,le),this.tasks.delete(le),this.isRunning||this.dispose())}};return this.tasks.set(le,{run:L,coverage:he}),this.proxy.$startedTestRunTask(U,{id:le,name:R,running:!0}),L}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof a.TestItemImpl))throw new a.InvalidTestItemError(R.id);if(this.sharedTestIds.has(R.id))return;const U=[];for(;U.unshift(l.TestItem.from(R)),!(this.sharedTestIds.has(R.id)||(this.sharedTestIds.add(R.id),!R.parent));)R=R.parent;const V=this.dto.colllection.root;this.sharedTestIds.has(V.id)||(this.sharedTestIds.add(V.id),U.unshift(l.TestItem.from(V))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class o{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,U,V){return this.getTracker(R,U,V)}cancelRunById(R){for(const U of this.tracked.values())if(U.id===R){U.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,U,V,le,he){const j=this.tracked.get(V);if(j)return j.createRun(le);const H=s.fromPublic(R,U,V,he),L=u(V);this.proxy.$startedExtensionTestRun({controllerId:R,profile:L&&{group:n[L.kind],id:L.profileId},exclude:V.exclude?.map(x=>x.id)??[],id:H.id,include:V.include?.map(x=>x.id)??[U.root.id],persist:he});const K=this.getTracker(V,H);return K.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),K.createRun(le)}getTracker(R,U,V){const le=new i(U,this.proxy,V);return this.tracked.set(R,le),le.onEnd(()=>this.tracked.delete(R)),le}}e.TestRunCoordinator=o;const u=_=>{if(!!_.profile){if(!(_.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return _.profile}};class s{constructor(R,U,V,le,he,j){this.controllerId=R,this.id=U,this.isPersisted=he,this.colllection=j,this.includePrefix=V.map(H=>H+"\0"),this.excludePrefix=le.map(H=>H+"\0")}static fromPublic(R,U,V,le){return new s(R,(0,S.generateUuid)(),V.include?.map(he=>c.TestId.fromExtHostTestItem(he,R).toString())??[R],V.exclude?.map(he=>c.TestId.fromExtHostTestItem(he,R).toString())??[],le,U)}static fromInternal(R,U){return new s(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,U)}isIncluded(R){const U=c.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const V of this.excludePrefix)if(U===V||U.startsWith(V))return!1;for(const V of this.includePrefix)if(U===V||U.startsWith(V))return!0;return!1}}e.TestRunDto=s;class f{constructor(R,U,V){this.proxy=R,this.runId=U,this.taskId=V}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(l.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(R,U){const V=await this.fileCoverage;let le=V?.[R];return!this._coverageProvider||!V||!le?[]:(le.detailedCoverage||(le=V[R]=await this._coverageProvider.resolveFileCoverage?.(le,U)??le),le.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class m extends k.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,l.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:U,removed:V}=this;return{get added(){return[...R].map(le=>le.revived)},get updated(){return[...U].map(le=>le.revived)},get removed(){return[...V].map(le=>le.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends k.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new E.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,U){return{...R,revived:l.TestItem.toPlain(R.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new m(this.changeEmitter)}}e.MirroredTestCollection=g;class b{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(U=>U.revived)},dispose:(0,T.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new g;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class C{constructor(R,U,V,le,he,j,H=!1,L=void 0){this.controllerId=U,this.profileId=V,this._label=le,this.kind=he,this.runHandler=j,this._isDefault=H,this._tag=L,w.set(this,void 0),Ze(this,w,R,"f");const K=n[he];if(typeof K!="number")throw new Error(`Unknown TestRunProfile.group ${he}`);Oe(this,w,"f").$publishTestRunProfile({profileId:V,controllerId:U,tag:L?l.TestTag.namespace(this.controllerId,L.id):null,label:le,group:K,isDefault:H,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?l.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Oe(this,w,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=C,w=new WeakMap;const n={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(Ee[204],_e([0,1,3,16,5,93,8,6]),function(te,e,h,F,E,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(t,S){this._extHostDocumentsAndEditors=S,this._onDidChangeTextEditorSelection=new h.Emitter,this._onDidChangeTextEditorOptions=new h.Emitter,this._onDidChangeTextEditorVisibleRanges=new h.Emitter,this._onDidChangeTextEditorViewColumn=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(r=>this._onDidChangeVisibleTextEditors.fire(r)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(r=>this._onDidChangeActiveTextEditor.fire(r))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const S=this._extHostDocumentsAndEditors.allEditors();return t?S:S.map(r=>r.value)}async showTextDocument(t,S,r){let d;typeof S=="number"?d={position:A.ViewColumn.from(S),preserveFocus:r}:typeof S=="object"?d={position:A.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?A.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:d={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(t.uri,d),l=a&&this._extHostDocumentsAndEditors.getEditor(a);if(l)return l.value;throw a?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,S){return new T.TextEditorDecorationType(this._proxy,t,S).value}$acceptEditorPropertiesChanged(t,S){const r=this._extHostDocumentsAndEditors.getEditor(t);if(!r)throw new Error("unknown text editor");if(S.options&&r._acceptOptions(S.options),S.selections){const d=S.selections.selections.map(A.Selection.to);r._acceptSelections(d)}if(S.visibleRanges){const d=F.coalesce(S.visibleRanges.map(A.Range.to));r._acceptVisibleRanges(d)}if(S.options&&this._onDidChangeTextEditorOptions.fire({textEditor:r.value,options:{...S.options,lineNumbers:A.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const d=I.TextEditorSelectionChangeKind.fromValue(S.selections.source),a=S.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:r.value,selections:a,kind:d})}if(S.visibleRanges){const d=F.coalesce(S.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:r.value,visibleRanges:d})}}$acceptEditorPositionData(t){for(const S in t){const r=this._extHostDocumentsAndEditors.getEditor(S);if(!r)throw new Error("Unknown text editor");const d=A.ViewColumn.to(t[S]);r.value.viewColumn!==d&&(r._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:r.value,viewColumn:d}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=D}),define(Ee[205],_e([0,1,2,4,5,7,6]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class I{constructor(t,S){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),S.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===11){const d=r.uri===void 0?void 0:h.URI.revive(r.uri);return this._itemsBySourceAndUriMap.get(r.source)?.get(D(d))?.get(r.handle)}return r}})}async $getTimeline(t,S,r,d,a){return this._providers.get(t)?.provideTimeline(h.URI.revive(S),r,d,a)}registerTimelineProvider(t,S,r,d){const a=new T.DisposableStore,l=this.convertTimelineItem(S.id,d,a).bind(this);let p;S.onDidChange&&(p=S.onDidChange(k=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...k,id:S.id}),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...S,scheme:t,onDidChange:void 0,async provideTimeline(k,c,w,y){y?.resetCache&&(a.clear(),v.get(S.id)?.clear());const i=await S.provideTimeline(k,c,w);if(i==null)return;const o=l(k,y);return{...i,source:S.id,items:i.items.map(o)}},dispose(){for(const k of v.values())k.get(S.id)?.clear();p?.dispose(),a.dispose()}})}convertTimelineItem(t,S,r){return(d,a)=>{let l;if(a?.cacheResults){let p=this._itemsBySourceAndUriMap.get(t);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(t,p));const v=D(d);l=p.get(v),l===void 0&&(l=new Map,p.set(v,l))}return p=>{const{iconPath:v,...k}=p,c=`${t}|${p.id??p.timestamp}`;l?.set(c,p);let w,y,i;return p.iconPath&&(v instanceof A.ThemeIcon?i={id:v.id,color:v.color}:h.URI.isUri(v)?(w=v,y=v):{light:w,dark:y}=v),{...k,id:k.id??void 0,handle:c,source:t,command:p.command?S.toInternal(p.command,r):void 0,icon:w,iconDark:y,themeIcon:i,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,T.toDisposable)(()=>{for(const r of this._itemsBySourceAndUriMap.values())r.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=I;function D(P){return P?.toString()}}),define(Ee[206],_e([0,1,7,11,2,5]),function(te,e,h,F,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(D){this._openers=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,t,S){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const r=S.schemes.find(d=>!A.supportedSchemes.has(d));if(r)throw new Error(`Scheme '${r}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,t),this._proxy.$registerUriOpener(P,S.schemes,D,S.label),(0,h.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,t){const S=this._openers.get(D);if(!S)throw new Error(`Unknown opener with id: ${D}`);const r=E.URI.revive(P);return S.canOpenExternalUri(r,t)}async $openUri(D,P,t){const S=this._openers.get(D);if(!S)throw new Error(`Unknown opener id: '${D}'`);return S.openExternalUri(E.URI.revive(P.resolvedUri),{sourceUri:E.URI.revive(P.sourceUri)},t)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(Ee[207],_e([0,1,5,2,7,15,25]),function(te,e,h,F,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(h.MainContext.MainThreadUrls)}registerUriHandler(P,t){if(this.handles.has(A.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const S=I.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(P)),this.handlers.set(S,t),this._proxy.$registerUriHandler(S,P),(0,E.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(P)),this.handlers.delete(S),this._proxy.$unregisterUriHandler(S)})}$handleExternalUri(P,t){const S=this.handlers.get(P);if(!S)return Promise.resolve(void 0);try{S.handleUri(F.URI.revive(t))}catch(r){(0,T.onUnexpectedError)(r)}return Promise.resolve(void 0)}async createAppUri(P){return F.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=I,I.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(te,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!E:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(te,h):E?E.value=h:e.set(te,h),h},Oe=this&&this.__classPrivateFieldGet||function(te,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!F:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(te):F?F.value:e.get(te)};define(Ee[48],_e([0,1,3,2,137,156,66,5]),function(te,e,h,F,E,T,A,I){"use strict";var D,P,t,S,r,d,a,l,p,v,k,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class w{constructor(g,b,C,n,_,R,U){D.set(this,void 0),P.set(this,void 0),t.set(this,void 0),S.set(this,void 0),r.set(this,void 0),d.set(this,void 0),a.set(this,""),l.set(this,void 0),p.set(this,!1),v.set(this,!1),k.set(this,!1),this._onMessageEmitter=new h.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new h.Emitter),this._onDidDispose=Oe(this,c,"f").event,Ze(this,D,g,"f"),Ze(this,P,b,"f"),Ze(this,l,C,"f"),Ze(this,S,n,"f"),Ze(this,r,_,"f"),Ze(this,d,R,"f"),Ze(this,k,y(R),"f"),Ze(this,t,U,"f")}dispose(){Ze(this,p,!0,"f"),Oe(this,c,"f").fire(),Oe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return Ze(this,v,!0,"f"),(0,A.asWebviewUri)(g,Oe(this,S,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,a,"f")}set html(g){this.assertNotDisposed(),Oe(this,a,"f")!==g&&(Ze(this,a,g,"f"),!Oe(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(Ze(this,v,!0,"f"),Oe(this,t,"f").report("Webview vscode-resource: uris",Oe(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,P,"f").$setHtml(Oe(this,D,"f"),g))}get options(){return this.assertNotDisposed(),Oe(this,l,"f")}set options(g){this.assertNotDisposed(),Oe(this,P,"f").$setOptions(Oe(this,D,"f"),u(Oe(this,d,"f"),Oe(this,r,"f"),g)),Ze(this,l,g,"f")}async postMessage(g){if(Oe(this,p,"f"))return!1;const b=(0,T.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:Oe(this,k,"f")});return Oe(this,P,"f").$postMessage(Oe(this,D,"f"),b.message,...b.buffers)}assertNotDisposed(){if(Oe(this,p,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=w,D=new WeakMap,P=new WeakMap,t=new WeakMap,S=new WeakMap,r=new WeakMap,d=new WeakMap,a=new WeakMap,l=new WeakMap,p=new WeakMap,v=new WeakMap,k=new WeakMap,c=new WeakMap;function y(m){try{const g=(0,E.normalizeVersion)((0,E.parseVersion)(m.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=y;class i{constructor(g,b,C,n,_){this.initData=b,this.workspace=C,this._logService=n,this._deprecationService=_,this._webviews=new Map,this._webviewProxy=g.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(g,b,...C){const n=this.getWebview(g);if(n){const{message:_}=(0,T.deserializeWebviewMessage)(b,C);n._onMessageEmitter.fire(_)}}$onMissingCsp(g,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,b,C){const n=new w(g,this._webviewProxy,s(b),this.initData,this.workspace,C,this._deprecationService);return this._webviews.set(g,n),n._onDidDispose(()=>{this._webviews.delete(g)}),n}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=i;function o(m){return{id:m.identifier,location:m.extensionLocation}}e.toExtensionData=o;function u(m,g,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||f(m,g)}}e.serializeWebviewOptions=u;function s(m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots?.map(g=>F.URI.from(g))}}e.reviveOptions=s;function f(m,g){return[...(g?.getWorkspaceFolders()||[]).map(b=>b.uri),m.extensionLocation]}}),define(Ee[208],_e([0,1,21,56,7,11,24,2,8,48,61,5,6]),function(te,e,h,F,E,T,A,I,D,P,t,S,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(i,o){this.document=i,this._storagePath=o,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,o){await this.getEdit(i).undo(),o||this.disposeBackup()}async redo(i,o){await this.getEdit(i).redo(),o||this.disposeBackup()}disposeEdits(i){for(const o of i)this._edits.delete(o)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=w(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const o=this._edits.get(i,0);if(!o)throw new Error("No edit found");return o}}class a{constructor(){this._documents=new Map}get(i,o){return this._documents.get(this.key(i,o))}add(i,o,u){const s=this.key(i,o.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${i} resource:${o.uri}`);const f=new d(o,u);return this._documents.set(s,f),f}delete(i,o){const u=this.key(i,o.uri);this._documents.delete(u)}key(i,o){return`${i}@@@${o}`}}var l;(function(y){y[y.Text=0]="Text",y[y.Custom=1]="Custom"})(l||(l={}));class p{constructor(){this._providers=new Map}addTextProvider(i,o,u){return this.add(0,i,o,u)}addCustomProvider(i,o,u){return this.add(1,i,o,u)}get(i){return this._providers.get(i)}add(i,o,u,s){if(this._providers.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this._providers.set(o,{type:i,extension:u,provider:s}),new r.Disposable(()=>this._providers.delete(o))}}class v{constructor(i,o,u,s,f){this._extHostDocuments=o,this._extensionStoragePaths=u,this._extHostWebview=s,this._extHostWebviewPanels=f,this._editorProviders=new p,this._documents=new a,this._proxy=i.getProxy(S.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,o,u,s){const f=new E.DisposableStore;return k(u)?(f.add(this._editorProviders.addTextProvider(o,i,u)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(i),o,s.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(i))):(f.add(this._editorProviders.addCustomProvider(o,i,u)),this.supportEditing(u)&&f.add(u.onDidChangeCustomDocument(m=>{const g=this.getCustomDocumentEntry(o,m.document.uri);if(c(m)){const b=g.addEdit(m);this._proxy.$onDidEdit(m.document.uri,o,b,m.label)}else this._proxy.$onContentChange(m.document.uri,o)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(i),o,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(i))),r.Disposable.from(f,new r.Disposable(()=>{this._proxy.$unregisterEditorProvider(o)}))}async $createCustomDocument(i,o,u,s,f){const m=this._editorProviders.get(o);if(!m)throw new Error(`No provider found for '${o}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${o}'`);const g=I.URI.revive(i),b=await m.provider.openCustomDocument(g,{backupId:u,untitledDocumentData:s?.buffer},f);let C;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(C=this._extensionStoragePaths.workspaceValue(m.extension)??this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(o,b,C),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(i,o){const u=this._editorProviders.get(o);if(!u)throw new Error(`No provider found for '${o}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${o}'`);const s=I.URI.revive(i),{document:f}=this.getCustomDocumentEntry(o,s);this._documents.delete(o,f),f.dispose()}async $resolveWebviewEditor(i,o,u,s,f,m){const g=this._editorProviders.get(u);if(!g)throw new Error(`No provider found for '${u}'`);const b=D.ViewColumn.to(f),C=this._extHostWebview.createNewWebview(o,s.webviewOptions,g.extension),n=this._extHostWebviewPanels.createNewWebviewPanel(o,u,s.title,b,s.panelOptions,C),_=I.URI.revive(i);switch(g.type){case 1:{const{document:R}=this.getCustomDocumentEntry(u,_);return g.provider.resolveCustomEditor(R,n,m)}case 0:{const R=this._extHostDocuments.getDocument(_);return g.provider.resolveCustomTextEditor(R,n,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,o,u){this.getCustomDocumentEntry(o,i).disposeEdits(u)}async $onMoveCustomEditor(i,o,u){const s=this._editorProviders.get(u);if(!s)throw new Error(`No provider found for '${u}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const f=this._extHostWebviewPanels.getWebviewPanel(i);if(!f)throw new Error("No webview found");const m=I.URI.revive(o),g=this._extHostDocuments.getDocument(m);await s.provider.moveCustomTextEditor(g,f,h.CancellationToken.None)}async $undo(i,o,u,s){return this.getCustomDocumentEntry(o,i).undo(u,s)}async $redo(i,o,u,s){return this.getCustomDocumentEntry(o,i).redo(u,s)}async $revert(i,o,u){const s=this.getCustomDocumentEntry(o,i);await this.getCustomEditorProvider(o).revertCustomDocument(s.document,u),s.disposeBackup()}async $onSave(i,o,u){const s=this.getCustomDocumentEntry(o,i);await this.getCustomEditorProvider(o).saveCustomDocument(s.document,u),s.disposeBackup()}async $onSaveAs(i,o,u,s){const f=this.getCustomDocumentEntry(o,i);return this.getCustomEditorProvider(o).saveCustomDocumentAs(f.document,I.URI.revive(u),s)}async $backup(i,o,u){const s=this.getCustomDocumentEntry(o,i),m=await this.getCustomEditorProvider(o).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},u);return s.updateBackup(m),m.id}getCustomDocumentEntry(i,o){const u=this._documents.get(i,I.URI.revive(o));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(i){const u=this._editorProviders.get(i)?.provider;if(!u||!this.supportEditing(u))throw new Error("Custom document is not editable");return u}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function k(y){return typeof y.resolveCustomTextEditor=="function"}function c(y){return typeof y.undo=="function"&&typeof y.redo=="function"}function w(y){const i=y.scheme===T.Schemas.file||y.scheme===T.Schemas.untitled?y.fsPath:y.toString();return(0,F.hash)(i)+""}});var Ze=this&&this.__classPrivateFieldSet||function(te,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!E:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(te,h):E?E.value=h:e.set(te,h),h},Oe=this&&this.__classPrivateFieldGet||function(te,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!F:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(te):F?F.value:e.get(te)};define(Ee[209],_e([0,1,3,7,2,36,8,48,5,6]),function(te,e,h,F,E,T,A,I,D,P){"use strict";var t,S,r,d,a,l,p,v,k,c,w,y,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends F.Disposable{constructor(m,g,b,C,n,_,R){super();t.set(this,void 0),S.set(this,void 0),r.set(this,void 0),d.set(this,void 0),a.set(this,void 0),l.set(this,void 0),p.set(this,void 0),v.set(this,void 0),k.set(this,!0),c.set(this,!0),w.set(this,!1),y.set(this,this._register(new h.Emitter)),this.onDidDispose=Oe(this,y,"f").event,i.set(this,this._register(new h.Emitter)),this.onDidChangeViewState=Oe(this,i,"f").event,Ze(this,t,m,"f"),Ze(this,S,g,"f"),Ze(this,r,b,"f"),Ze(this,a,_,"f"),Ze(this,v,n,"f"),Ze(this,l,C,"f"),Ze(this,d,R,"f")}dispose(){Oe(this,w,"f")||(Ze(this,w,!0,"f"),Oe(this,y,"f").fire(),Oe(this,S,"f").$disposeWebview(Oe(this,t,"f")),Oe(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,d,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,r,"f")}get title(){return this.assertNotDisposed(),Oe(this,l,"f")}set title(m){this.assertNotDisposed(),Oe(this,l,"f")!==m&&(Ze(this,l,m,"f"),Oe(this,S,"f").$setTitle(Oe(this,t,"f"),m))}get iconPath(){return this.assertNotDisposed(),Oe(this,p,"f")}set iconPath(m){this.assertNotDisposed(),Oe(this,p,"f")!==m&&(Ze(this,p,m,"f"),Oe(this,S,"f").$setIconPath(Oe(this,t,"f"),E.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Oe(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,v,"f")=="number"&&Oe(this,v,"f")<0))return Oe(this,v,"f")}get active(){return this.assertNotDisposed(),Oe(this,c,"f")}get visible(){return this.assertNotDisposed(),Oe(this,k,"f")}_updateViewState(m){Oe(this,w,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(Ze(this,c,m.active,"f"),Ze(this,k,m.visible,"f"),Ze(this,v,m.viewColumn,"f"),Oe(this,i,"f").fire({webviewPanel:this}))}reveal(m,g){this.assertNotDisposed(),Oe(this,S,"f").$reveal(Oe(this,t,"f"),{viewColumn:m?A.ViewColumn.from(m):void 0,preserveFocus:!!g})}assertNotDisposed(){if(Oe(this,w,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,S=new WeakMap,r=new WeakMap,d=new WeakMap,a=new WeakMap,l=new WeakMap,p=new WeakMap,v=new WeakMap,k=new WeakMap,c=new WeakMap,w=new WeakMap,y=new WeakMap,i=new WeakMap;class u{constructor(m,g,b){this.webviews=g,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(m,g,b,C,n={}){const _=typeof C=="object"?C.viewColumn:C,R={viewColumn:A.ViewColumn.from(_),preserveFocus:typeof C=="object"&&!!C.preserveFocus},U=(0,I.shouldSerializeBuffersForPostMessage)(m),V=u.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(m),V,g,{title:b,panelOptions:s(n),webviewOptions:(0,I.serializeWebviewOptions)(m,this.workspace,n),serializeBuffersForPostMessage:U},R);const le=this.webviews.createNewWebview(V,n,m);return this.createNewWebviewPanel(V,g,b,_,n,le)}$onDidChangeWebviewPanelViewStates(m){const g=Object.keys(m);g.sort((b,C)=>{const n=m[b],_=m[C];return n.active?1:_.active?-1:+n.visible-+_.visible});for(const b of g){const C=this.getWebviewPanel(b);if(!C)continue;const n=m[b];C._updateViewState({active:n.active,visible:n.visible,viewColumn:A.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,g,b){if(this._serializers.has(g))throw new Error(`Serializer for '${g}' already registered`);return this._serializers.set(g,{serializer:b,extension:m}),this._proxy.$registerSerializer(g,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(m)}),new P.Disposable(()=>{this._serializers.delete(g),this._proxy.$unregisterSerializer(g)})}async $deserializeWebviewPanel(m,g,b,C){const n=this._serializers.get(g);if(!n)throw new Error(`No serializer found for '${g}'`);const{serializer:_,extension:R}=n,U=this.webviews.createNewWebview(m,b.webviewOptions,R),V=this.createNewWebviewPanel(m,g,b.title,C,b.panelOptions,U);await _.deserializeWebviewPanel(V,b.state)}createNewWebviewPanel(m,g,b,C,n,_){const R=new o(m,this._proxy,g,b,C,n,_);return this._webviewPanels.set(m,R),R}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=u;function s(f){return{enableFindWidget:f.enableFindWidget,retainContextWhenHidden:f.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(te,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!E:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(te,h):E?E.value=h:e.set(te,h),h},Oe=this&&this.__classPrivateFieldGet||function(te,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!F:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(te):F?F.value:e.get(te)};define(Ee[210],_e([0,1,3,7,48,5,6]),function(te,e,h,F,E,T,A){"use strict";var I,D,P,t,S,r,d,a,l,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends F.Disposable{constructor(w,y,i,o,u,s){super();I.set(this,void 0),D.set(this,void 0),P.set(this,void 0),t.set(this,void 0),S.set(this,!1),r.set(this,void 0),d.set(this,void 0),a.set(this,void 0),l.set(this,this._register(new h.Emitter)),this.onDidChangeVisibility=Oe(this,l,"f").event,p.set(this,this._register(new h.Emitter)),this.onDidDispose=Oe(this,p,"f").event,Ze(this,P,i,"f"),Ze(this,d,o,"f"),Ze(this,I,w,"f"),Ze(this,D,y,"f"),Ze(this,t,u,"f"),Ze(this,r,s,"f")}dispose(){Oe(this,S,"f")||(Ze(this,S,!0,"f"),Oe(this,p,"f").fire(),Oe(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,d,"f")}set title(w){this.assertNotDisposed(),Oe(this,d,"f")!==w&&(Ze(this,d,w,"f"),Oe(this,D,"f").$setWebviewViewTitle(Oe(this,I,"f"),w))}get description(){return this.assertNotDisposed(),Oe(this,a,"f")}set description(w){this.assertNotDisposed(),Oe(this,a,"f")!==w&&(Ze(this,a,w,"f"),Oe(this,D,"f").$setWebviewViewDescription(Oe(this,I,"f"),w))}get visible(){return Oe(this,r,"f")}get webview(){return Oe(this,t,"f")}get viewType(){return Oe(this,P,"f")}_setVisible(w){w===Oe(this,r,"f")||Oe(this,S,"f")||(Ze(this,r,w,"f"),Oe(this,l,"f").fire())}show(w){this.assertNotDisposed(),Oe(this,D,"f").$show(Oe(this,I,"f"),!!w)}assertNotDisposed(){if(Oe(this,S,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,D=new WeakMap,P=new WeakMap,t=new WeakMap,S=new WeakMap,r=new WeakMap,d=new WeakMap,a=new WeakMap,l=new WeakMap,p=new WeakMap;class k{constructor(w,y){this._extHostWebview=y,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=w.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(w,y,i,o){if(this._viewProviders.has(y))throw new Error(`View provider for '${y}' already registered`);return this._viewProviders.set(y,{provider:i,extension:w}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(w),y,{retainContextWhenHidden:o?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(y),this._proxy.$unregisterWebviewViewProvider(y)})}async $resolveWebviewView(w,y,i,o,u){const s=this._viewProviders.get(y);if(!s)throw new Error(`No view provider found for '${y}'`);const{provider:f,extension:m}=s,g=this._extHostWebview.createNewWebview(w,{},m),b=new v(w,this._proxy,y,i,g,!0);this._webviewViews.set(w,b),await f.resolveWebviewView(b,{state:o},u)}async $onDidChangeWebviewViewVisibility(w,y){this.getWebviewView(w)._setVisible(y)}async $disposeWebviewView(w){const y=this.getWebviewView(w);this._webviewViews.delete(w),y.dispose(),this._extHostWebview.deleteWebview(w)}getWebviewView(w){const y=this._webviewViews.get(w);if(!y)throw new Error("No webview found");return y}}e.ExtHostWebviewViews=k}),define(Ee[97],_e([0,1,3,5,2,11,9,4,12]),function(te,e,h,F,E,T,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Ui{constructor(S){this._onDidChangeWindowState=new h.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=S.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(r=>this.$onDidChangeWindowFocus(r))}get state(){return this._state}$onDidChangeWindowFocus(S){S!==this._state.focused&&(this._state={...this._state,focused:S},this._onDidChangeWindowState.fire(this._state))}openUri(S,r){let d;if(typeof S=="string"){d=S;try{S=E.URI.parse(S)}catch(a){return Promise.reject(`Invalid uri - '${S}'`)}}return(0,A.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,d,r)}async asExternalUri(S,r){if((0,A.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(S,r);return E.URI.from(d)}};P.InitialState={focused:!0},P=We([ze(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(Ee[211],_e([0,1,14,5,29,12]),function(te,e,h,F,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends h.AbstractLogger{constructor(D,P){super();this._proxy=D.getProxy(F.MainContext.MainThreadLog),this._logFile=P.logFile.toJSON(),this.setLevel(P.logLevel)}$setLevel(D){this.setLevel(D)}trace(D,...P){this.getLevel()<=h.LogLevel.Trace&&this._proxy.$log(this._logFile,h.LogLevel.Trace,Array.from(arguments))}debug(D,...P){this.getLevel()<=h.LogLevel.Debug&&this._proxy.$log(this._logFile,h.LogLevel.Debug,Array.from(arguments))}info(D,...P){this.getLevel()<=h.LogLevel.Info&&this._proxy.$log(this._logFile,h.LogLevel.Info,Array.from(arguments))}warn(D,...P){this.getLevel()<=h.LogLevel.Warning&&this._proxy.$log(this._logFile,h.LogLevel.Warning,Array.from(arguments))}error(D,...P){this.getLevel()<=h.LogLevel.Error&&this._proxy.$log(this._logFile,h.LogLevel.Error,Array.from(arguments))}critical(D,...P){this.getLevel()<=h.LogLevel.Critical&&this._proxy.$log(this._logFile,h.LogLevel.Critical,Array.from(arguments))}flush(){}};A=We([ze(0,T.IExtHostRpcService),ze(1,E.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(Ee[212],_e([0,1,13,21,15,3,7,108,178,94,23]),function(te,e,h,F,E,T,A,I,D,P,t){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function r(s,f){try{return JSON.stringify(s,f)}catch(m){return"null"}}function d(s,f){return JSON.stringify(s,f)}function a(s){return s?(f,m)=>m&&m.$mid===1?s.transformOutgoing(m):m:null}var l;(function(s){s[s.LocalSide=0]="LocalSide",s[s.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(s){s[s.Responsive=0]="Responsive",s[s.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},k=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class w extends A.Disposable{constructor(f,m=null,g=null){super();this[S]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=f,this._logger=m,this._uriTransformer=g,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let b=0,C=P.ProxyIdentifier.count;b<C;b++)this._locals[b]=null,this._proxies[b]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new h.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(b=>this._receiveOneMessage(b))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(f=>{this._pendingRPCReplies[f].resolveErr(E.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(f){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+w.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(f){this._unresponsiveTime=Date.now()+w.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(f){this._responsiveState!==f&&(this._responsiveState=f,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(f){return this._uriTransformer?(0,I.transformIncomingURIs)(f,this._uriTransformer):f}getProxy(f){const{nid:m,sid:g}=f;return this._proxies[m]||(this._proxies[m]=this._createProxy(m,g)),this._proxies[m]}_createProxy(f,m){let g={get:(b,C)=>(typeof C=="string"&&!b[C]&&C.charCodeAt(0)===36&&(b[C]=(...n)=>this._remoteCall(f,C,n)),C===c?m:b[C])};return new Proxy(Object.create(null),g)}set(f,m){return this._locals[f.nid]=m,m}assertRegistered(f){for(let m=0,g=f.length;m<g;m++){const b=f[m];if(!this._locals[b.nid])throw new Error(`Missing actor ${b.sid} (isMain: ${b.isMain})`)}}_receiveOneMessage(f){if(this._isDisposed)return;const m=f.byteLength,g=y.read(f,0),b=g.readUInt8(),C=g.readUInt32();switch(b){case 1:case 2:{let{rpcId:n,method:_,args:R}=i.deserializeRequestJSONArgs(g);this._uriTransformer&&(R=(0,I.transformIncomingURIs)(R,this._uriTransformer)),this._receiveRequest(m,C,n,_,R,b===2);break}case 3:case 4:{let{rpcId:n,method:_,args:R}=i.deserializeRequestMixedArgs(g);this._uriTransformer&&(R=(0,I.transformIncomingURIs)(R,this._uriTransformer)),this._receiveRequest(m,C,n,_,R,b===4);break}case 5:{this._logger&&this._logger.logIncoming(m,C,0,"ack"),this._onDidReceiveAcknowledge(C);break}case 6:{this._receiveCancel(m,C);break}case 7:{this._receiveReply(m,C,void 0);break}case 9:{let n=i.deserializeReplyOKJSON(g);this._uriTransformer&&(n=(0,I.transformIncomingURIs)(n,this._uriTransformer)),this._receiveReply(m,C,n);break}case 8:{let n=i.deserializeReplyOKVSBuffer(g);this._receiveReply(m,C,n);break}case 10:{let n=i.deserializeReplyErrError(g);this._uriTransformer&&(n=(0,I.transformIncomingURIs)(n,this._uriTransformer)),this._receiveReplyErr(m,C,n);break}case 11:{this._receiveReplyErr(m,C,void 0);break}default:console.error("received unexpected message"),console.error(f)}}_receiveRequest(f,m,g,b,C,n){this._logger&&this._logger.logIncoming(f,m,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(g)}.${b}(`,C);const _=String(m);let R,U;if(n){const le=new F.CancellationTokenSource;C.push(le.token),R=this._invokeHandler(g,b,C),U=()=>le.cancel()}else R=this._invokeHandler(g,b,C),U=v;this._cancelInvokedHandlers[_]=U;const V=i.serializeAcknowledged(m);this._logger&&this._logger.logOutgoing(V.byteLength,m,1,"ack"),this._protocol.send(V),R.then(le=>{delete this._cancelInvokedHandlers[_];const he=i.serializeReplyOK(m,le,this._uriReplacer);this._logger&&this._logger.logOutgoing(he.byteLength,m,1,"reply:",le),this._protocol.send(he)},le=>{delete this._cancelInvokedHandlers[_];const he=i.serializeReplyErr(m,le);this._logger&&this._logger.logOutgoing(he.byteLength,m,1,"replyErr:",le),this._protocol.send(he)})}_receiveCancel(f,m){this._logger&&this._logger.logIncoming(f,m,1,"receiveCancel");const g=String(m);this._cancelInvokedHandlers[g]&&this._cancelInvokedHandlers[g]()}_receiveReply(f,m,g){this._logger&&this._logger.logIncoming(f,m,0,"receiveReply:",g);const b=String(m);if(!this._pendingRPCReplies.hasOwnProperty(b))return;const C=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b],C.resolveOk(g)}_receiveReplyErr(f,m,g){this._logger&&this._logger.logIncoming(f,m,0,"receiveReplyErr:",g);const b=String(m);if(!this._pendingRPCReplies.hasOwnProperty(b))return;const C=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b];let n;g&&(g.$isError?(n=new Error,n.name=g.name,n.message=g.message,n.stack=g.stack):n=g),C.resolveErr(n)}_invokeHandler(f,m,g){try{return Promise.resolve(this._doInvokeHandler(f,m,g))}catch(b){return Promise.reject(b)}}_doInvokeHandler(f,m,g){const b=this._locals[f];if(!b)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(f));let C=b[m];if(typeof C!="function")throw new Error("Unknown method "+m+" on actor "+(0,P.getStringIdentifierForProxy)(f));return C.apply(b,g)}_remoteCall(f,m,g){if(this._isDisposed)return Promise.reject(E.canceled());let b=null;if(g.length>0&&F.CancellationToken.isCancellationToken(g[g.length-1])&&(b=g.pop()),b&&b.isCancellationRequested)return Promise.reject(E.canceled());const C=i.serializeRequestArguments(g,this._uriReplacer),n=++this._lastMessageId,_=String(n),R=new D.LazyPromise;b&&b.onCancellationRequested(()=>{const V=i.serializeCancel(n);this._logger&&this._logger.logOutgoing(V.byteLength,n,0,"cancel"),this._protocol.send(i.serializeCancel(n))}),this._pendingRPCReplies[_]=R,this._onWillSendRequest(n);const U=i.serializeRequest(n,f,m,C,!!b);return this._logger&&this._logger.logOutgoing(U.byteLength,n,0,`request: ${(0,P.getStringIdentifierForProxy)(f)}.${m}(`,g),this._protocol.send(U),R}}e.RPCProtocol=w,S=k,w.UNRESPONSIVE_TIME=3*1e3;class y{constructor(f,m){this._buff=f,this._offset=m}static alloc(f,m,g){let b=new y(t.VSBuffer.alloc(g+1+4),0);return b.writeUInt8(f),b.writeUInt32(m),b}static read(f,m){return new y(f,m)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(f){this._buff.writeUInt8(f,this._offset),this._offset+=1}readUInt8(){const f=this._buff.readUInt8(this._offset);return this._offset+=1,f}writeUInt32(f){this._buff.writeUInt32BE(f,this._offset),this._offset+=4}readUInt32(){const f=this._buff.readUInt32BE(this._offset);return this._offset+=4,f}static sizeShortString(f){return 1+f.byteLength}writeShortString(f){this._buff.writeUInt8(f.byteLength,this._offset),this._offset+=1,this._buff.set(f,this._offset),this._offset+=f.byteLength}readShortString(){const f=this._buff.readUInt8(this._offset);this._offset+=1;const g=this._buff.slice(this._offset,this._offset+f).toString();return this._offset+=f,g}static sizeLongString(f){return 4+f.byteLength}writeLongString(f){this._buff.writeUInt32BE(f.byteLength,this._offset),this._offset+=4,this._buff.set(f,this._offset),this._offset+=f.byteLength}readLongString(){const f=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+f).toString();return this._offset+=f,g}writeBuffer(f){this._buff.writeUInt32BE(f.byteLength,this._offset),this._offset+=4,this._buff.set(f,this._offset),this._offset+=f.byteLength}static sizeVSBuffer(f){return 4+f.byteLength}writeVSBuffer(f){this._buff.writeUInt32BE(f.byteLength,this._offset),this._offset+=4,this._buff.set(f,this._offset),this._offset+=f.byteLength}readVSBuffer(){const f=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+f);return this._offset+=f,m}static sizeMixedArray(f,m){let g=0;g+=1;for(let b=0,C=f.length;b<C;b++){const n=f[b],_=m[b];switch(g+=1,_){case 1:g+=this.sizeLongString(n);break;case 2:g+=this.sizeVSBuffer(n);break;case 3:break}}return g}writeMixedArray(f,m){this._buff.writeUInt8(f.length,this._offset),this._offset+=1;for(let g=0,b=f.length;g<b;g++){const C=f[g];switch(m[g]){case 1:this.writeUInt8(1),this.writeLongString(C);break;case 2:this.writeUInt8(2),this.writeVSBuffer(C);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const f=this._buff.readUInt8(this._offset);this._offset+=1;let m=new Array(f);for(let g=0;g<f;g++)switch(this.readUInt8()){case 1:m[g]=this.readLongString();break;case 2:m[g]=this.readVSBuffer();break;case 3:m[g]=void 0;break}return m}}class i{static _arrayContainsBufferOrUndefined(f){for(let m=0,g=f.length;m<g;m++)if(f[m]instanceof t.VSBuffer||typeof f[m]=="undefined")return!0;return!1}static serializeRequestArguments(f,m){if(this._arrayContainsBufferOrUndefined(f)){let g=[],b=[];for(let C=0,n=f.length;C<n;C++){const _=f[C];_ instanceof t.VSBuffer?(g[C]=_,b[C]=2):typeof _=="undefined"?(g[C]=t.VSBuffer.alloc(0),b[C]=3):(g[C]=t.VSBuffer.fromString(d(_,m)),b[C]=1)}return{type:"mixed",args:g,argsType:b}}return{type:"simple",args:d(f,m)}}static serializeRequest(f,m,g,b,C){return b.type==="mixed"?this._requestMixedArgs(f,m,g,b.args,b.argsType,C):this._requestJSONArgs(f,m,g,b.args,C)}static _requestJSONArgs(f,m,g,b,C){const n=t.VSBuffer.fromString(g),_=t.VSBuffer.fromString(b);let R=0;R+=y.sizeUInt8(),R+=y.sizeShortString(n),R+=y.sizeLongString(_);let U=y.alloc(C?2:1,f,R);return U.writeUInt8(m),U.writeShortString(n),U.writeLongString(_),U.buffer}static deserializeRequestJSONArgs(f){const m=f.readUInt8(),g=f.readShortString(),b=f.readLongString();return{rpcId:m,method:g,args:JSON.parse(b)}}static _requestMixedArgs(f,m,g,b,C,n){const _=t.VSBuffer.fromString(g);let R=0;R+=y.sizeUInt8(),R+=y.sizeShortString(_),R+=y.sizeMixedArray(b,C);let U=y.alloc(n?4:3,f,R);return U.writeUInt8(m),U.writeShortString(_),U.writeMixedArray(b,C),U.buffer}static deserializeRequestMixedArgs(f){const m=f.readUInt8(),g=f.readShortString(),b=f.readMixedArray(),C=new Array(b.length);for(let n=0,_=b.length;n<_;n++){const R=b[n];typeof R=="string"?C[n]=JSON.parse(R):C[n]=R}return{rpcId:m,method:g,args:C}}static serializeAcknowledged(f){return y.alloc(5,f,0).buffer}static serializeCancel(f){return y.alloc(6,f,0).buffer}static serializeReplyOK(f,m,g){return typeof m=="undefined"?this._serializeReplyOKEmpty(f):m instanceof t.VSBuffer?this._serializeReplyOKVSBuffer(f,m):this._serializeReplyOKJSON(f,r(m,g))}static _serializeReplyOKEmpty(f){return y.alloc(7,f,0).buffer}static _serializeReplyOKVSBuffer(f,m){let g=0;g+=y.sizeVSBuffer(m);let b=y.alloc(8,f,g);return b.writeVSBuffer(m),b.buffer}static deserializeReplyOKVSBuffer(f){return f.readVSBuffer()}static _serializeReplyOKJSON(f,m){const g=t.VSBuffer.fromString(m);let b=0;b+=y.sizeLongString(g);let C=y.alloc(9,f,b);return C.writeLongString(g),C.buffer}static deserializeReplyOKJSON(f){const m=f.readLongString();return JSON.parse(m)}static serializeReplyErr(f,m){return m?this._serializeReplyErrEror(f,m):this._serializeReplyErrEmpty(f)}static _serializeReplyErrEror(f,m){const g=t.VSBuffer.fromString(r(E.transformErrorForSerialization(m),null));let b=0;b+=y.sizeLongString(g);let C=y.alloc(10,f,b);return C.writeLongString(g),C.buffer}static deserializeReplyErrError(f){const m=f.readLongString();return JSON.parse(m)}static _serializeReplyErrEmpty(f){return y.alloc(11,f,0).buffer}}var o;(function(s){s[s.RequestJSONArgs=1]="RequestJSONArgs",s[s.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",s[s.RequestMixedArgs=3]="RequestMixedArgs",s[s.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",s[s.Acknowledged=5]="Acknowledged",s[s.Cancel=6]="Cancel",s[s.ReplyOKEmpty=7]="ReplyOKEmpty",s[s.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",s[s.ReplyOKJSON=9]="ReplyOKJSON",s[s.ReplyErrError=10]="ReplyErrError",s[s.ReplyErrEmpty=11]="ReplyErrEmpty"})(o||(o={}));var u;(function(s){s[s.String=1]="String",s[s.VSBuffer=2]="VSBuffer",s[s.Undefined=3]="Undefined"})(u||(u={}))}),define(Ee[213],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const h=function(T){const A=I=>{self.removeEventListener("message",A);const D=I.data;Object.defineProperties(self,{postMessage:{value(P,t){D.postMessage(P,t)}},onmessage:{get(){return D.onmessage},set(P){D.onmessage=P}}}),D.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",A)}.toString();class F extends EventTarget{constructor(T,A,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${h})('${A}'))`,P=new Blob([D],{type:"application/javascript"}),t=URL.createObjectURL(P),S=new MessageChannel,r=t,d={type:"_newWorker",id:r,port:S.port2,url:t,options:I};T(d,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:r};S.port1.postMessage(a),URL.revokeObjectURL(t),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(a){S.port1.onmessage=a}},onmessageerror:{get(){return S.port1.onmessageerror},set(a){S.port1.onmessageerror=a}}}),S.port1.addEventListener("messageerror",a=>{const l=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(l)}),S.port1.addEventListener("message",a=>{const l=new MessageEvent("message",{data:a.data});this.dispatchEvent(l)}),S.port1.start()}}e.NestedWorker=F}),define(Ee[214],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,h.createDecorator)("remoteAgentService")}),define(Ee[215],_e([0,1,11,17,26,2,4,85,44,174,214]),function(te,e,h,F,E,T,A,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,A.createDecorator)("pathService");let S=class Bi{constructor(d,a,l,p){this.localUserHome=d,this.remoteAgentService=a,this.environmentService=l,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const v=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=v?.userHome||d})()}get defaultUriScheme(){return Bi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,a){if(d.remoteAuthority)return h.Schemas.vscodeRemote;const l=(0,I.getVirtualWorkspaceScheme)(a.getWorkspace());if(l)return l;const p=a.getWorkspace().folders[0];if(p)return p.uri.scheme;const v=a.getWorkspace().configuration;return v?v.scheme:h.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?F.win32:F.posix)}async fileURI(d){let a="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const p=d.indexOf("/",2);p===-1?(a=d.substring(2),d="/"):(a=d.substring(2,p),d=d.substring(p)||"/")}return T.URI.from({scheme:h.Schemas.file,authority:a,path:d,query:"",fragment:""})}};S=We([ze(1,t.IRemoteAgentService),ze(2,P.IWorkbenchEnvironmentService),ze(3,D.IWorkspaceContextService)],S),e.AbstractPathService=S}),define(Ee[98],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class h{constructor(A,I){this.line=A,this.character=I}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,I){return new h(0,0)}with(A){return new h(0,0)}}e.Position=h;class F{constructor(A,I,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(A,I),this.end=new h(D,P)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.Range=F;var E;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[38],_e([0,1,16,27,22,40,9,4,17,15,98]),function(te,e,h,F,E,T,A,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const S="\u27EA ",r=" characters skipped \u27EB",d=(S.length+r.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var a;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var l;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(l=e.QueryType||(e.QueryType={}));function p(L){return!!L.preview}e.resultIsMatch=p;function v(L){return!!L.resource}e.isFileMatch=v;function k(L){return!!L.message}e.isProgressMessage=k;var c;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(K){this.resource=K,this.results=[]}}e.FileMatch=w;class y{constructor(K,x,Y){this.ranges=x;const ce=Array.isArray(x)?x:[x];if(Y&&Y.matchLines===1&&i(ce)){K=(0,A.getNLines)(K,Y.matchLines);let z="",se=0,re=0;const we=Math.floor(Y.charsPerLine/5),Re=[];for(const Fe of ce){const Ne=Math.max(Fe.startColumn-we,0),Qe=Fe.startColumn+Y.charsPerLine;if(Ne>re+we+d){const qe=S+(Ne-re)+r;z+=qe+K.slice(Ne,Qe),se+=Ne-(re+qe.length)}else z+=K.slice(re,Qe);Re.push(new u(0,Fe.startColumn-se,Fe.endColumn-se)),re=Qe}this.preview={text:z,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const z=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:K,matches:(0,h.mapArrayOrNot)(x,se=>new o(se.startLineNumber-z,se.startColumn,se.endLineNumber-z,se.endColumn))}}}}e.TextSearchMatch=y;function i(L){const K=L[0].startLineNumber;for(const x of L)if(x.startLineNumber!==K||x.endLineNumber!==K)return!1;return!0}class o{constructor(K,x,Y,ce){this.startLineNumber=K,this.startColumn=x,this.endLineNumber=Y,this.endColumn=ce}}e.SearchRange=o;class u extends o{constructor(K,x,Y){super(K,x,K,Y)}}e.OneLineRange=u;var s;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function f(L,K=!0){const x=L&&L.files&&L.files.exclude,Y=K&&L&&L.search&&L.search.exclude;if(!x&&!Y)return;if(!x||!Y)return x||Y;let ce=Object.create(null);return ce=E.mixin(ce,E.deepClone(x)),ce=E.mixin(ce,E.deepClone(Y),!0),ce}e.getExcludes=f;function m(L,K){return L.excludePattern&&F.match(L.excludePattern,K)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&F.match(L.includePattern,K)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(x=>{const Y=x.folder.fsPath;if(T.isEqualOrParent(K,Y)){const ce=D.relative(Y,K);return!x.includePattern||!!F.match(x.includePattern,ce)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var g;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(K,x){super(K);this.code=x}}e.SearchError=b;function C(L){const K=L.message;if((0,P.isPromiseCanceledError)(L))return new b(K,g.canceled);try{const x=JSON.parse(K);return new b(x.message,x.code)}catch(x){return new b(K,g.other)}}e.deserializeSearchError=C;function n(L){const K={message:L.message,code:L.code};return new Error(JSON.stringify(K))}e.serializeSearchError=n;function _(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=_;function R(L){return L.type==="success"}e.isSerializedSearchSuccess=R;function U(L){return!!L.path}e.isSerializedFileMatch=U;function V(L,K){const x=L.searchPath?L.searchPath:L.relativePath;return(0,A.fuzzyContains)(x,K)}e.isFilePatternMatch=V;class le{constructor(K){this.path=K,this.results=[]}addMatch(K){this.results.push(K)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=le;function he(L,K){const x={...L||{},...K||{}};return Object.keys(x).filter(Y=>{const ce=x[Y];return typeof ce=="boolean"&&ce})}e.resolvePatternsForProvider=he;class j{constructor(K,x){this._parsedIncludeExpression=null,this._excludeExpression={...K.excludePattern||{},...x.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let Y=K.includePattern;x.includePattern&&(Y?Y={...Y,...x.includePattern}:Y=x.includePattern),Y&&(this._parsedIncludeExpression=F.parse(Y))}includedInQuerySync(K,x,Y){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(K,x,Y)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(K,x,Y))}includedInQuery(K,x,Y){return Promise.resolve(this._parsedExcludeExpression(K,x,Y)).then(z=>!!z).then(z=>z?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(K,x,Y)).then(se=>!!se):Promise.resolve(!0)).then(z=>z)}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=j;function H(L){for(const K in L)if(typeof L[K]!="boolean")return!0;return!1}}),define(Ee[31],_e([0,1,16,13,21,3,20,11,74,24,9,10,2,129,4,14,144,44,45,29,12,6,38,5]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p,v,k,c,w,y,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(_,R,U){return new P.ExtUri(V=>g(V,U)).isEqual(_,R)}function s(_,R,U){return u(_.uri,R.uri,U)?0:(0,t.compare)(_.uri.toString(),R.uri.toString())}function f(_,R,U){return _.index!==R.index?_.index<R.index?-1:1:u(_.uri,R.uri,U)?(0,t.compare)(_.name,R.name):(0,t.compare)(_.uri.toString(),R.uri.toString())}function m(_,R,U,V){const le=_.slice(0).sort((j,H)=>U(j,H,V)),he=R.slice(0).sort((j,H)=>U(j,H,V));return(0,h.delta)(le,he,(j,H)=>U(j,H,V))}function g(_,R){const U=R.getCapabilities(_.scheme);return!(U&&U&1024)}class b extends v.Workspace{constructor(R,U,V,le,he,j){super(R,V.map(H=>new v.WorkspaceFolder(H)),le,j);this._name=U,this._isUntitled=he,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(j),V.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(R,U,V,le){if(!R)return{workspace:null,added:[],removed:[]};const{id:he,name:j,folders:H,configuration:L,isUntitled:K}=R,x=[],Y=U;U?H.forEach((re,we)=>{const Re=r.URI.revive(re.uri),Fe=b._findFolder(V||U,Re,le);Fe?(Fe.name=re.name,Fe.index=re.index,x.push(Fe)):x.push({uri:Re,name:re.name,index:we})}):x.push(...H.map(({uri:re,name:we,index:Re})=>({uri:r.URI.revive(re),name:we,index:Re}))),x.sort((re,we)=>re.index<we.index?-1:1);const ce=new b(he,j,x,L?r.URI.revive(L):null,!!K,re=>g(re,le)),{added:z,removed:se}=m(Y?Y.workspaceFolders:[],ce.workspaceFolders,s,le);return{workspace:ce,added:z,removed:se}}static _findFolder(R,U,V){for(let le=0;le<R.folders.length;le++){const he=R.workspaceFolders[le];if(u(he.uri,U,V))return he}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,U){return U&&this._structure.get(R)&&(R=(0,P.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let C=class{constructor(R,U,V,le){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=le,this._extHostFileSystemInfo=V,this._requestIdProvider=new D.Counter,this._barrier=new F.Barrier,this._proxy=R.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(o.MainContext.MainThreadMessageService);const he=U.workspace;this._confirmedWorkspace=he?new b(he.id,he.name,[],he.configuration?r.URI.revive(he.configuration):null,!!he.isUntitled,j=>g(j,V)):void 0}$initializeWorkspace(R,U){this._trusted=U,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?r.URI.from({scheme:I.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,U,V,...le){const he=[];if(Array.isArray(le)&&le.forEach(x=>{r.URI.isUri(x.uri)&&!he.some(Y=>u(Y.uri,x.uri,this._extHostFileSystemInfo))&&he.push({uri:x.uri,name:x.name||(0,P.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[U,V].some(x=>typeof x!="number"||x<0)||V===0&&he.length===0)return!1;const j=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+V>j.length)return!1;const H=j.slice(0);H.splice(U,V,...he.map(x=>({uri:x.uri,name:x.name||(0,P.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<H.length;x++){const Y=H[x];if(H.some((ce,z)=>z!==x&&u(Y.uri,ce.uri,this._extHostFileSystemInfo)))return!1}H.forEach((x,Y)=>x.index=Y);const{added:L,removed:K}=m(j,H,f,this._extHostFileSystemInfo);if(L.length===0&&K.length===0)return!1;if(this._proxy){const x=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(x,U,V,he).then(void 0,Y=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,d.localize)(0,null,x,Y.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(R,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,U)}async getWorkspaceFolder2(R,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,U)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,U){let V,le="";if(typeof R=="string"?(V=r.URI.file(R),le=R):typeof R!="undefined"&&(V=R,le=R.fsPath),!V)return le;const he=this.getWorkspaceFolder(V,!0);if(!he)return le;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let j=(0,P.relativePath)(he.uri,V);return U&&he.name&&(j=`${he.name}/${j}`),j}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:U,added:V,removed:le}=b.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:V,removed:le}))}findFiles(R,U,V,le,he=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${le.value}, entryPoint: findFiles`);let j;if(U===null?j=!1:U&&(typeof U=="string"?j=U:j=U.pattern),he&&he.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:L}=n(R);return this._proxy.$startFileSearch((0,S.withUndefinedAsNull)(H),(0,S.withUndefinedAsNull)(L),(0,S.withUndefinedAsNull)(j),(0,S.withUndefinedAsNull)(V),he).then(K=>Array.isArray(K)?K.map(x=>r.URI.revive(x)):[])}async findTextInFiles(R,U,V,le,he=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${le.value}, entryPoint: findTextInFiles`);const j=this._requestIdProvider.getNext(),H=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:L,folder:K}=n(U.include),x=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,Y={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:H,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:L,excludePattern:x},ce=!1;if(this._activeSearchCallbacks[j]=z=>{if(ce)return;const se=r.URI.revive(z.resource);z.results.forEach(re=>{(0,i.resultIsMatch)(re)?V({uri:se,preview:{text:re.preview.text,matches:(0,h.mapArrayOrNot)(re.preview.matches,we=>new y.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,h.mapArrayOrNot)(re.ranges,we=>new y.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):V({uri:se,text:re.text,lineNumber:re.lineNumber})})},he.isCancellationRequested)return{};try{const z=await this._proxy.$startTextSearch(R,(0,S.withUndefinedAsNull)(K),Y,j,he);return delete this._activeSearchCallbacks[j],z||{}}catch(z){throw delete this._activeSearchCallbacks[j],z}}$handleTextSearchResult(R,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};C=We([ze(0,w.IExtHostRpcService),ze(1,c.IExtHostInitDataService),ze(2,k.IExtHostFileSystemInfo),ze(3,l.ILogService)],C),e.ExtHostWorkspace=C,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function n(_){let R,U;return _&&(typeof _=="string"?R=_:(R=_.pattern,U=_.baseFolder||r.URI.file(_.base))),{includePattern:R,folder:U}}}),define(Ee[32],_e([0,1,22,3,31,5,6,147,60,10,13,4,12,14,2]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(o,u){if(u){const s=u.split(".");let f=o;for(let m=0;f&&m<s.length;m++)f=f[s[m]];return f}}function p(o){return o instanceof a.URI}function v(o){return o&&o.uri instanceof a.URI&&o.languageId&&typeof o.languageId=="string"}function k(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function c(o){return o&&o.uri instanceof a.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function w(o){if(p(o))return{resource:o};if(v(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(k(o))return{overrideIdentifier:o.languageId};if(c(o))return{resource:o.uri};if(o===null)return{resource:null}}let y=class{constructor(u,s,f){this._proxy=u.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=f,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new i(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,s){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(u,s))}};y=We([ze(0,r.IExtHostRpcService),ze(1,E.IExtHostWorkspace),ze(2,d.ILogService)],y),e.ExtHostConfiguration=y;class i{constructor(u,s,f,m){this._onDidChangeConfiguration=new F.Emitter,this._proxy=u,this._logService=m,this._extHostWorkspace=s,this._configuration=I.Configuration.parse(f),this._configurationScopes=this._toMap(f.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,s){const f={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,f))}getConfiguration(u,s,f){const m=w(s)||{},g=this._toReadonlyValue(u?l(this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,m,f?.identifier);function b(n){if(n==null)return null;if(typeof n=="boolean")return n?1:4;switch(n){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const C={has(n){return typeof l(g,n)!="undefined"},get:(n,_)=>{this._validateConfigurationAccess(u?`${u}.${n}`:n,m,f?.identifier);let R=l(g,n);if(typeof R=="undefined")R=_;else{let U;const V=(le,he)=>{let j;const H=()=>{U=U||(0,h.deepClone)(g),j=j||l(U,he)};return(0,P.isObject)(le)?new Proxy(le,{get:(L,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return H(),()=>j;if(U)return j=j||l(U,he),j[K];const x=L[K];return typeof K=="string"?V(x,`${he}.${K}`):x},set:(L,K,x)=>(H(),j&&(j[K]=x),!0),deleteProperty:(L,K)=>(H(),j&&delete j[K],!0),defineProperty:(L,K,x)=>(H(),j&&Object.defineProperty(j,K,x),!0)}):le};R=V(R,n)}return R},update:(n,_,R,U)=>{n=u?`${u}.${n}`:n;const V=b(R);return _!==void 0?this._proxy.$updateConfigurationOption(V,n,_,m,U):this._proxy.$removeConfigurationOption(V,n,m,U)},inspect:n=>{n=u?`${u}.${n}`:n;const _=(0,h.deepClone)(this._configuration.inspect(n,m,this._extHostWorkspace.workspace));if(_)return{key:n,defaultValue:_.default?.value,globalValue:_.user?.value,workspaceValue:_.workspace?.value,workspaceFolderValue:_.workspaceFolder?.value,defaultLanguageValue:_.default?.override,globalLanguageValue:_.user?.override,workspaceLanguageValue:_.workspace?.override,workspaceFolderLanguageValue:_.workspaceFolder?.override,languageIds:_.overrideIdentifiers}}};return typeof g=="object"&&(0,h.mixin)(C,g,!1),Object.freeze(C)}_toReadonlyValue(u){const s=f=>(0,P.isObject)(f)?new Proxy(f,{get:(m,g)=>s(m[g]),set:(m,g,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(m,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(m,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return s(u)}_validateConfigurationAccess(u,s,f){const m=D.OVERRIDE_PROPERTY_PATTERN.test(u)?4:this._configurationScopes.get(u),g=f?`[${f.value}] `:"";if(m===4){typeof s?.resource=="undefined"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){s?.resource&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,s){const f=new I.ConfigurationChangeEvent(u,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(m,g)=>f.affectsConfiguration(m,w(g))})}_toMap(u){return u.reduce((s,f)=>(s.set(f[0],f[1]),s),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,S.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(te,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!E:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(te,h):E?E.value=h:e.set(te,h),h},Oe=this&&this.__classPrivateFieldGet||function(te,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!F:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(te):F?F.value:e.get(te)};define(Ee[99],_e([0,1,2,13,3,5,22,6,31,47,32,21,37,12,29,4,11,26,14,69,164,15]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p,v,k,c,w,y){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(j){function H(K){if(K!=null)return K}j.from=H;function L(K){if(K!=null)return K}j.to=L})(o=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(j){function H(K){if(K!=null)return K}j.from=H;function L(K){if(K!=null)return K}j.to=L})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(j){function H(K){if(K!=null)return K}j.from=H;function L(K){if(K!=null)return K}j.to=L})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var f;(function(j){function H(x){if(x){const Y=x;return Y&&!!Y.process}else return!1}j.is=H;function L(x){if(x==null)return;const Y={process:x.process,args:x.args};return x.options&&(Y.options=s.from(x.options)),Y}j.from=L;function K(x){if(x!=null)return new I.ProcessExecution(x.process,x.args,x.options)}j.to=K})(f=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var m;(function(j){function H(K){if(K!=null)return K}j.from=H;function L(K){if(K!=null)return K}j.to=L})(m=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(j){function H(x){if(x){const Y=x;return Y&&(!!Y.commandLine||!!Y.command)}else return!1}j.is=H;function L(x){if(x==null)return;const Y={};return x.commandLine!==void 0?Y.commandLine=x.commandLine:(Y.command=x.command,Y.args=x.args),x.options&&(Y.options=m.from(x.options)),Y}j.from=L;function K(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new I.ShellExecution(x.commandLine,x.options):new I.ShellExecution(x.command,x.args?x.args:[],x.options)}j.to=K})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(j){function H(x){if(x){let Y=x;return Y&&Y.customExecution==="customExecution"}else return!1}j.is=H;function L(x){return{customExecution:"customExecution"}}j.from=L;function K(x,Y){return Y.get(x)}j.to=K})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var C;(function(j){function H(L,K){let x;return L.scope!==void 0&&typeof L.scope!="number"?x=L.scope.uri:L.scope!==void 0&&typeof L.scope=="number"&&(L.scope===I.TaskScope.Workspace&&K&&K.workspaceFile?x=K.workspaceFile:x=w.USER_TASKS_GROUP_KEY),{id:L._id,workspaceFolder:x}}j.from=H})(C=e.TaskHandleDTO||(e.TaskHandleDTO={}));var n;(function(j){function H(L){if(L!=null)return{_id:L.id,isDefault:L.isDefault}}j.from=H})(n=e.TaskGroupDTO||(e.TaskGroupDTO={}));var _;(function(j){function H(x,Y){if(x==null)return[];const ce=[];for(let z of x){const se=L(z,Y);se&&ce.push(se)}return ce}j.fromMany=H;function L(x,Y){if(x==null)return;let ce;x.execution instanceof I.ProcessExecution?ce=f.from(x.execution):x.execution instanceof I.ShellExecution?ce=g.from(x.execution):x.execution&&x.execution instanceof I.CustomExecution&&(ce=b.from(x.execution));const z=o.from(x.definition);let se;return x.scope?typeof x.scope=="number"?se=x.scope:se=x.scope.uri:se=I.TaskScope.Workspace,!z||!se?void 0:{_id:x._id,definition:z,name:x.name,source:{extensionId:Y.identifier.value,label:x.source,scope:se},execution:ce,isBackground:x.isBackground,group:n.from(x.group),presentationOptions:u.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}j.from=L;async function K(x,Y,ce){if(x==null)return;let z;f.is(x.execution)?z=f.to(x.execution):g.is(x.execution)?z=g.to(x.execution):b.is(x.execution)&&(z=b.to(x._id,ce));const se=o.to(x.definition);let re;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?re=x.source.scope:re=await Y.resolveWorkspaceFolder(h.URI.revive(x.source.scope)):re=I.TaskScope.Workspace),!se||!re)return;const we=new I.Task(se,re,x.name,x.source.label,z,x.problemMatchers);return x.isBackground!==void 0&&(we.isBackground=x.isBackground),x.group!==void 0&&(we.group=I.TaskGroup.from(x.group._id),we.group&&(we.group=A.deepClone(we.group),x.group.isDefault&&(we.group.isDefault=x.group.isDefault))),x.presentationOptions&&(we.presentationOptions=u.to(x.presentationOptions)),x._id&&(we._id=x._id),x.detail&&(we.detail=x.detail),we}j.to=K})(_=e.TaskDTO||(e.TaskDTO={}));var R;(function(j){function H(K){return K}j.from=H;function L(K){if(!!K)return Object.assign(Object.create(null),K)}j.to=L})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class U{constructor(H,L,K){this._id=L,this._task=K,i.set(this,void 0),Ze(this,i,H,"f")}get task(){return this._task}terminate(){Oe(this,i,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}i=new WeakMap;var V;(function(j){function H(L){return{id:L._id,task:void 0}}j.from=H})(V=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let le=class{constructor(H,L,K,x,Y,ce,z,se){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=H.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=K,this._editorService=x,this._configurationService=Y,this._terminalService=ce,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=z,this._deprecationService=se,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,L,K){if(!K)return new I.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:L,provider:K,extension:H}),this._proxy.$registerTaskProvider(x,L),new I.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(H,L){this._proxy.$registerTaskSystem(H,L)}fetchTasks(H){return this._proxy.$fetchTasks(R.from(H)).then(async L=>{const K=[];for(let x of L){const Y=await _.to(x,this._workspaceProvider,this._providedCustomExecutions2);Y&&K.push(Y)}return K})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(L=>H.push(L)),H}terminateTask(H){if(!(H instanceof U))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,L,K){const x=this._providedCustomExecutions2.get(H.id);if(x){if(this._activeCustomExecutions2.get(H.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(H.id,x),this._terminalService.attachPtyToTerminal(L,await x.callback(K))}this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const L=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:L})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const L=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:L,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const L=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:L,exitCode:H.exitCode})}$provideTasks(H,L){const K=this._handlers.get(H);if(!K)return Promise.reject(new Error("no handler found"));const x=[],Y=(0,F.asPromise)(()=>K.provider.provideTasks(S.CancellationToken.None)).then(ce=>this.provideTasksInternal(L,x,K,ce));return new Promise(ce=>{Y.then(z=>{Promise.all(x).then(()=>{ce(z)})})})}async $resolveTask(H,L){const K=this._handlers.get(H);if(!K)return Promise.reject(new Error("no handler found"));if(L.definition.type!==K.type)throw new Error(`Unexpected: Task of type [${L.definition.type}] cannot be resolved by provider of type [${K.type}].`);const x=await _.to(L,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const Y=await K.provider.resolveTask(x,S.CancellationToken.None);if(!Y)return;this.checkDeprecation(Y,K);const ce=_.from(Y,K.extension);if(!ce)throw new Error("Unexpected: Task cannot be resolved.");if(Y.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(ce.execution)&&await this.addCustomExecution(ce,Y,!0),await this.resolveTaskInternal(ce)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,L,K){const x=await this._proxy.$createTaskId(H);!K&&!this._providedCustomExecutions2.has(x)&&this._notProvidedCustomExecutions.add(x),this._providedCustomExecutions2.set(x,L.execution)}async getTaskExecution(H,L){if(typeof H=="string"){const Y=this._taskExecutionPromises.get(H);if(!Y)throw new Error("Unexpected: The specified task is missing an execution");return Y}let K=this._taskExecutionPromises.get(H.id);if(K)return K;const x=new Promise(async(Y,ce)=>{const z=L||await _.to(H.task,this._workspaceProvider,this._providedCustomExecutions2);z?Y(new U(this,H.id,z)):ce("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(H.id,x),x.then(Y=>(this._taskExecutions.set(H.id,Y),Y),Y=>Promise.reject(Y))}checkDeprecation(H,L){H._deprecated&&this._deprecationService.report("Task.constructor",L.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let K=this._notProvidedCustomExecutions.values(),x=K.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=K.next()}};le=We([ze(0,d.IExtHostRpcService),ze(1,a.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,P.IExtHostDocumentsAndEditors),ze(4,t.IExtHostConfiguration),ze(5,r.IExtHostTerminalService),ze(6,k.ILogService),ze(7,c.IExtHostApiDeprecationService)],le),e.ExtHostTaskBase=le;let he=class extends le{constructor(H,L,K,x,Y,ce,z,se){super(H,L,K,x,Y,ce,z,se);this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(H,L){if(!L.execution)throw new Error("Tasks to execute must include an execution");const K=_.from(L,H);if(K===void 0)throw new Error("Task is not valid");if(b.is(K.execution))await this.addCustomExecution(K,L,!1);else throw new y.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(K),L);return this._proxy.$executeTask(K).catch(Y=>{throw new Error(Y)}),x}provideTasksInternal(H,L,K,x){const Y=[];if(x)for(let ce of x){this.checkDeprecation(ce,K),(!ce.definition||!H[ce.definition.type])&&this._logService.warn(`The task [${ce.source}, ${ce.name}] uses an undefined task type. The task will be ignored in the future.`);const z=_.from(ce,K.extension);z&&b.is(z.execution)?(Y.push(z),L.push(this.addCustomExecution(z,ce,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:Y,extension:K.extension}}async resolveTaskInternal(H){if(b.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,L){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,L,K){}};he=We([ze(0,d.IExtHostRpcService),ze(1,a.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,P.IExtHostDocumentsAndEditors),ze(4,t.IExtHostConfiguration),ze(5,r.IExtHostTerminalService),ze(6,k.ILogService),ze(7,c.IExtHostApiDeprecationService)],he),e.WorkerExtHostTask=he,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(Ee[216],_e([0,1,16,49,27,76,20,11,17,24,9,10,2,110,133,83,44,91,215,38]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p,v,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(b,C,n,_){this.configurationService=b,this.workspaceContextService=C,this.editorGroupsService=n,this.pathService=_}text(b,C,n={}){b=this.getContentPattern(b,n);const _=this.configurationService.getValue(),R=C&&C.some(V=>!this.configurationService.getValue({resource:V}).search.useRipgrep);return{...this.commonQuery(C?.map(p.toWorkspaceFolder),n),type:2,contentPattern:b,previewOptions:n.previewOptions,maxFileSize:n.maxFileSize,usePCRE2:_.search.usePCRE2||R||!1,beforeContext:n.beforeContext,afterContext:n.afterContext,userDisabledExcludesAndIgnoreFiles:n.disregardExcludeSettings&&n.disregardIgnoreFiles}}getContentPattern(b,C){const n=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const _={...b,wordSeparators:n.editor.wordSeparators};return this.isCaseSensitive(b,C)&&(_.isCaseSensitive=!0),this.isMultiline(b)&&(_.isMultiline=!0),_}file(b,C={}){return{...this.commonQuery(b,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}handleIncludeExclude(b,C){return b?(b=Array.isArray(b)?b.map(s):s(b),C?this.parseSearchPaths(b):{pattern:i(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],C={}){const n=this.handleIncludeExclude(C.includePattern,C.expandPatterns),_=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),R=b.length>1,U=(n.searchPaths&&n.searchPaths.length?n.searchPaths.map(he=>this.getFolderQueryForSearchPath(he,C,_)):b.map(he=>this.getFolderQueryForRoot(he,C,_,R))).filter(he=>!!he),V={_reason:C._reason,folderQueries:U,usingSearchPaths:!!(n.searchPaths&&n.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:_.pattern,includePattern:n.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const j=h.coalesce(h.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(K=>K.resource)))).filter(L=>(0,c.pathIncludedInQuery)(V,L.fsPath)),H=this.commonQueryFromFileList(j);return{...V,...H}}const le=C.extraFileResources&&C.extraFileResources.filter(he=>(0,c.pathIncludedInQuery)(V,he.fsPath));return V.extraFileResources=le&&le.length?le:void 0,V}commonQueryFromFileList(b){const C=[],n=new A.ResourceMap,_={};let R=!1;return b.forEach(U=>{if(U.scheme===I.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(U)){const le=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:D.dirname(U.fsPath)});let he=n.get(le);he||(R=!0,he={folder:le,includePattern:{}},C.push(he),n.set(le,he));const j=D.relative(le.fsPath,U.fsPath);(0,S.assertIsDefined)(he.includePattern)[j.replace(/\\/g,"/")]=!0}else U.fsPath&&(R=!0,_[U.fsPath]=!0)}),{folderQueries:C,includePattern:_,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(b,C){if(C.isSmartCase){if(b.isRegExp){if(t.containsUppercaseCharacter(b.pattern,!0))return!0}else if(t.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,d.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const C=H=>D.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),_=(Array.isArray(b)?b:o(b)).map(H=>{const L=this.pathService.resolvedUserHome;return L?(0,T.untildify)(H,L.scheme===I.Schemas.file?L.fsPath:L.path):H}),R=F.groupBy(_,H=>C(H)?"searchPaths":"exprSegments"),U=(R.exprSegments||[]).map(H=>t.rtrim(H,"/")).map(H=>t.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),u(H))),V={},le=this.expandSearchPathPatterns(R.searchPaths||[]);le&&le.length&&(V.searchPaths=le);const he=h.flatten(U),j=i(...he);return j&&(V.pattern=j),V}getExcludesForFolder(b,C){return C.disregardExcludeSettings?void 0:(0,c.getExcludes)(b,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const C=h.flatten(b.map(_=>{let{pathPortion:R,globPortion:U}=y(_);U&&(U=f(U));const V=this.expandOneSearchPath(R);return h.flatten(V.map(le=>this.resolveOneSearchPathPattern(le,U)))})),n=new Map;return C.forEach(_=>{const R=_.searchPath.toString(),U=n.get(R);U?_.pattern&&(U.pattern=U.pattern||{},U.pattern[_.pattern]=!0):n.set(R,{searchPath:_.searchPath,pattern:_.pattern?i(_.pattern):void 0})}),Array.from(n.values())}expandOneSearchPath(b){if(D.isAbsolute(b)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==I.Schemas.file?[{searchPath:C[0].uri.with({path:b})}]:[{searchPath:r.URI.file(D.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=s(b),b.startsWith("../")||b===".."){const _=D.posix.resolve(C.path,b);return[{searchPath:C.with({path:_})}]}const n=f(b);return[{searchPath:C,pattern:n}]}else{if(b==="./"||b===".\\")return[];{const C=b.replace(/^\.[\/\\]/,""),_=this.workspaceContextService.getWorkspace().folders.map(R=>{const U=C.match(new RegExp(`^${t.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return U?{match:U,folder:R}:null}).filter(S.isDefined);if(_.length)return _.map(R=>{const U=R.match[1];return{searchPath:R.folder.uri,pattern:U&&f(U)}});{const R=b.match(/\.[\/\\](.+)[\/\\]?/),U=R?R[1]:b,V=a.localize(0,null,U);throw new Error(V)}}}}resolveOneSearchPathPattern(b,C){const n=b.pattern&&C?`${b.pattern}/${C}`:b.pattern||C,_=[{searchPath:b.searchPath,pattern:n}];return n&&!n.endsWith("**")&&_.push({searchPath:b.searchPath,pattern:n+"/**"}),_}getFolderQueryForSearchPath(b,C,n){const _=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(b.searchPath),C,n,!1);return _?{..._,includePattern:b.pattern}:null}getFolderQueryForRoot(b,C,n,_){let R;const U=r.URI.isUri(b)?b:b.uri;if(n.searchPaths){const H=n.searchPaths.filter(L=>(0,P.isEqual)(L.searchPath,U))[0];if(H&&!H.pattern)return null;H&&(R=H.pattern)}const V=this.configurationService.getValue({resource:U}),he={...this.getExcludesForFolder(V,C)||{},...R||{}},j=r.URI.isUri(b)?(0,P.basename)(b):b.name;return{folder:U,folderName:_?j:void 0,excludePattern:Object.keys(he).length>0?he:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!V.search.followSymlinks}}};w=We([ze(0,l.IConfigurationService),ze(1,p.IWorkspaceContextService),ze(2,v.IEditorGroupsService),ze(3,k.IPathService)],w),e.QueryBuilder=w;function y(g){const b=g.match(/[\*\{\}\(\)\[\]\?]/);if(b){const C=b.index,n=g.substr(0,C).match(/[/|\\][^/\\]*$/);if(n){let _=g.substr(0,n.index);return _.match(/[/\\]/)||(_+="/"),{pathPortion:_,globPortion:g.substr((n.index||0)+1)}}}return{pathPortion:g}}function i(...g){return g.length?g.reduce((b,C)=>(b[C]=!0,b),Object.create(null)):void 0}function o(g){return E.splitGlobAware(g,",").map(b=>b.trim()).filter(b=>!!b.length)}function u(g){return[`**/${g}/**`,`**/${g}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function s(g){return g.replace(/\\/g,"/")}function f(g){return s(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(g,b){g=h.distinct(g,_=>_.toString());const C=[],n=b.getWorkspace();return g&&g.forEach(_=>{let R;if(b.getWorkbenchState()===2)R=(0,P.relativePath)(n.folders[0].uri,_),R&&R!=="."&&(R="./"+R);else{const U=b.getWorkspaceFolder(_);if(U){const V=U.name;if(n.folders.filter(he=>he.name===V).length===1){const he=(0,P.relativePath)(U.uri,_);he===""?R=`./${U.name}`:R=`./${U.name}/${he}`}else R=_.fsPath}}R&&C.push(R)}),C}e.resolveResourcesForSearchIncludes=m}),define(Ee[217],_e([0,1,24,2,21,15,4,216,38,44]),function(te,e,h,F,E,T,A,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function S(l,p){const v=p.activationEvents;if(!v)return Promise.resolve(void 0);const k=[],c=[];for(const s of v)if(/^workspaceContains:/.test(s)){const f=s.substr("workspaceContains:".length);f.indexOf("*")>=0||f.indexOf("?")>=0||l.forceUsingSearch?c.push(f):k.push(f)}if(k.length===0&&c.length===0)return Promise.resolve(void 0);let w;const y=new Promise((s,f)=>{w=s}),i=s=>w({activationEvent:s}),o=Promise.all(k.map(s=>r(l,s,i))).then(()=>{}),u=d(l,p.identifier,c,i);return Promise.all([o,u]).then(()=>{w(void 0)}),y}e.checkActivateWorkspaceContainsExtension=S;async function r(l,p,v){for(const k of l.folders)if(await l.exists(h.joinPath(F.URI.revive(k),p))){v(`workspaceContains:${p}`);return}}async function d(l,p,v,k){if(v.length===0)return Promise.resolve(void 0);const c=new E.CancellationTokenSource,w=l.checkExists(l.folders,v,c.token),y=setTimeout(async()=>{c.cancel(),k(`workspaceContainsTimeout:${v.join(",")}`)},t);let i=!1;try{i=await w}catch(o){T.isPromiseCanceledError(o)||T.onUnexpectedError(o)}c.dispose(),clearTimeout(y),i&&k(`workspaceContains:${v.join(",")}`)}function a(l,p,v,k){const c=l.get(A.IInstantiationService),w=l.get(D.ISearchService),i=c.createInstance(I.QueryBuilder).file(p.map(o=>(0,P.toWorkspaceFolder)(F.URI.revive(o))),{_reason:"checkExists",includePattern:v,exists:!0});return w.fileSearch(i,k).then(o=>!!o.limitHit,o=>T.isPromiseCanceledError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=a});var Ze=this&&this.__classPrivateFieldSet||function(te,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!E:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(te,h):E?E.value=h:e.set(te,h),h},Oe=this&&this.__classPrivateFieldGet||function(te,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!F:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(te):F?F.value:e.get(te)};define(Ee[33],_e([0,1,124,17,73,24,13,7,20,2,14,5,32,177,71,31,30,175,15,25,23,151,6,84,4,29,72,12,59,64,37,3,217,68,153]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p,v,k,c,w,y,i,o,u,s,f,m,g,b,C,n,_,R,U){"use strict";var V,le,he;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,u.createDecorator)("IHostUtils");let j=class $i extends I.Disposable{constructor(x,Y,ce,z,se,re,we,Re,Fe,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new n.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Y,this._extHostContext=ce,this._initData=we,this._extHostWorkspace=z,this._extHostConfiguration=se,this._logService=re,this._extHostTunnelService=Fe,this._extHostTerminalService=Ne,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(S.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(S.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(S.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=x.createChild(new g.ServiceCollection([a.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(qe=>Qe.add(c.ExtensionIdentifier.toKey(qe))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(qe,Ke,N)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(qe,k.transformErrorForSerialization(Ke),N)},actualActivateExtension:async(qe,Ke)=>{if(Qe.has(c.ExtensionIdentifier.toKey(qe)))return await this._mainThreadExtensionsProxy.$activateExtension(qe,Ke),new d.HostExtension;const N=this._registry.getExtensionDescription(qe);return this._activateExtension(N,Ke)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(x){k.onUnexpectedError(x)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let x=[];try{x=this._registry.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this._deactivate(se))}catch(Y){}await Promise.all(x)}isActivated(x){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(x):!1}_activateByEvent(x,Y){return this._activator.activateByEvent(x,Y)}_activateById(x,Y){return this._activator.activateById(x,Y)}activateByIdWithErrors(x,Y){return this._activateById(x,Y).then(()=>{const ce=this._activator.getActivatedExtension(x);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(x=>this._registry)}getExtensionExports(x){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(x).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const x=D.TernarySearchTree.forPaths(),Y=this._registry.getAllExtensionDescriptions().map(ce=>{if(!!this._getEntryPoint(ce))return this._hostUtils.realpath(ce.extensionLocation.fsPath).then(z=>x.set(P.URI.file(z).fsPath,ce))});this._extensionPathIndex=Promise.all(Y).then(()=>x)}return this._extensionPathIndex}_deactivate(x){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(x))return Y;const ce=this._activator.getActivatedExtension(x);if(!ce)return Y;try{typeof ce.module.deactivate=="function"&&(Y=Promise.resolve(ce.module.deactivate()).then(void 0,z=>(this._logService.error(z),Promise.resolve(void 0))))}catch(z){this._logService.error(z)}try{(0,I.dispose)(ce.subscriptions)}catch(z){this._logService.error(z)}return Y}async _activateExtension(x,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier),this._doActivateExtension(x,Y).then(ce=>{const z=ce.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(x.identifier,z.codeLoadingTime,z.activateCallTime,z.activateResolvedTime,Y),this._logExtensionActivationTimes(x,Y,"success",z),ce},ce=>{throw this._logExtensionActivationTimes(x,Y,"failure"),ce})}_logExtensionActivationTimes(x,Y,ce,z){const se=H(x,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...se,...z||{},outcome:ce})}_doActivateExtension(x,Y){const ce=H(x,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ce);const z=this._getEntryPoint(x);if(!z)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${x.identifier.value} ${JSON.stringify(Y)}`),this._logService.flush();const se=new d.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(x.identifier,(0,T.joinPath)(x.extensionLocation,z),se),this._loadExtensionContext(x)]).then(re=>(E.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),$i._callActivate(this._logService,x.identifier,re[0],re[1],se))).then(re=>(E.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),re))}_loadExtensionContext(x){const Y=new y.ExtensionGlobalMemento(x,this._storage),ce=new y.ExtensionMemento(x.identifier.value,!1,this._storage),z=new U.ExtensionSecrets(x,this._secretState),se=x.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,re=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([Y.whenReady,ce.whenReady,this._storagePath.whenReady]).then(()=>{const we=this;let Re;return Object.freeze({globalState:Y,workspaceState:ce,secrets:z,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(Fe){return F.join(x.extensionLocation.fsPath,Fe)},get storagePath(){return we._storagePath.workspaceValue(x)?.fsPath},get globalStoragePath(){return we._storagePath.globalValue(x).fsPath},get logPath(){return F.join(we._initData.logsLocation.fsPath,x.identifier.value)},get logUri(){return P.URI.joinPath(we._initData.logsLocation,x.identifier.value)},get storageUri(){return we._storagePath.workspaceValue(x)},get globalStorageUri(){return we._storagePath.globalValue(x)},get extensionMode(){return se},get extension(){return Re===void 0&&(Re=new L(we,x.identifier,x,re)),Re},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(x),we.extensionRuntime},get environmentVariableCollection(){return we._extHostTerminalService.getEnvironmentVariableCollection(x)}})})}static _callActivate(x,Y,ce,z,se){return ce=ce||{activate:void 0,deactivate:void 0},this._callActivateOptional(x,Y,ce,z,se).then(re=>new d.ActivatedExtension(!1,null,se.build(),ce,re,z.subscriptions))}static _callActivateOptional(x,Y,ce,z,se){if(typeof ce.activate=="function")try{se.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const re=typeof global=="object"?global:self,we=ce.activate.apply(re,[z]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(we).then(Re=>(se.activateResolveStop(),Re))}catch(re){return Promise.reject(re)}else return Promise.resolve(ce)}_activateOneStartupFinished(x,Y){this._activateById(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:Y}).then(void 0,ce=>{this._logService.error(ce)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const x of this._registry.getAllExtensionDescriptions())if(x.activationEvents)for(const Y of x.activationEvents)Y==="onStartupFinished"&&this._activateOneStartupFinished(x,Y)}_handleEagerExtensions(){const x=this._activateByEvent("*",!0).then(void 0,se=>{this._logService.error(se)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(se=>this._handleWorkspaceContainsEagerExtensions(se.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ce=this._handleWorkspaceContainsEagerExtensions(Y),z=Promise.all([x,ce]).then(()=>{});return Promise.race([z,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),z}_handleWorkspaceContainsEagerExtensions(x){return x.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(x,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(x,Y){if(this.isActivated(Y.identifier))return;const ce=!this._initData.remote.isRemote&&!!this._initData.remote.authority,z={folders:x.map(re=>re.uri),forceUsingSearch:ce,exists:re=>this._hostUtils.exists(re.fsPath),checkExists:(re,we,Re)=>this._mainThreadWorkspaceProxy.$checkExists(re,we,Re)},se=await(0,_.checkActivateWorkspaceContainsExtension)(z,Y);if(!!se)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:se.activationEvent}).then(void 0,re=>this._logService.error(re))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(x){throw console.error(x),x}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:Y}=this._initData.environment;if(!x||!Y)throw new Error(h.localize(0,null));const ce=await this._loadCommonJSModule(null,Y,new d.ExtensionActivationTimesBuilder(!1));if(!ce||typeof ce.run!="function")throw new Error(h.localize(1,null,Y.toString()));return new Promise((z,se)=>{const re=(Fe,Ne)=>{Fe?se(Fe):z(typeof Ne=="number"&&Ne>0?1:0)},we=(0,T.originalFSPath)(Y),Re=ce.run(we,re);Re&&Re.then&&Re.then(()=>{z(0)}).catch(Fe=>{se(Fe.toString())})})}async $extensionTestsExit(x){this._logService.info(`extension host terminating: test runner requested exit with code ${x}`),this._logService.info(`exiting with code ${x}`),this._logService.flush(),this._hostUtils.exit(x)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(x,Y){return this._resolvers[x]=Y,(0,I.toDisposable)(()=>{delete this._resolvers[x]})}async _activateAndGetResolver(x){const Y=x.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const ce=x.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this._resolvers[ce]}}async $resolveAuthority(x,Y){const{authorityPrefix:ce,resolver:z}=await this._activateAndGetResolver(x);if(!z)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ce}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(z)),E.mark(`code/extHost/willResolveAuthority/${ce}`);const se=await z.resolve(x,{resolveAttempt:Y});E.mark(`code/extHost/didResolveAuthorityOK/${ce}`);const re={authority:x,host:se.host,port:se.port,connectionToken:se.connectionToken},we={extensionHostEnv:se.extensionHostEnv,isTrusted:se.isTrusted};return{type:"ok",value:{authority:re,options:we,tunnelInformation:{environmentTunnels:se.environmentTunnels}}}}catch(se){if(E.mark(`code/extHost/didResolveAuthorityError/${ce}`),se instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se}}async $getCanonicalURI(x,Y){const{authorityPrefix:ce,resolver:z}=await this._activateAndGetResolver(x);if(!z)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ce}`);const se=P.URI.revive(Y);if(typeof z.getCanonicalURI=="undefined")return se;const re=await(0,A.asPromise)(()=>z.getCanonicalURI(se));return re||se}$startExtensionHost(x){return this._registry.keepOnly(x),this._startExtensionHost()}$activateByEvent(x,Y){return Y===1?this._activateByEvent(x,!1):this._readyToRunExtensions.wait().then(ce=>this._activateByEvent(x,!1))}async $activate(x,Y){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(x)?(await this._activateById(x,Y),!0):!1}async $deltaExtensions(x,Y){x.forEach(z=>z.extensionLocation=P.URI.revive(z.extensionLocation));const ce=await this.getExtensionPathIndex();return await Promise.all(Y.map(async z=>{const se=this._registry.getExtensionDescription(z);if(!se)return;const re=await this._hostUtils.realpath(se.extensionLocation.fsPath);ce.delete(P.URI.file(re).fsPath)})),await Promise.all(x.map(async z=>{const se=await this._hostUtils.realpath(z.extensionLocation.fsPath);ce.set(P.URI.file(se).fsPath,z)})),this._registry.deltaExtensions(x,Y),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){let Y=w.VSBuffer.alloc(x),ce=Math.random()%256;for(let z=0;z<x;z++)Y.writeUInt8(ce,z);return Y}async $updateRemoteConnectionData(x){this._remoteConnectionData=x,this._onDidChangeRemoteConnectionData.fire()}};j=We([ze(0,u.IInstantiationService),ze(1,e.IHostUtils),ze(2,m.IExtHostRpcService),ze(3,l.IExtHostWorkspace),ze(4,r.IExtHostConfiguration),ze(5,t.ILogService),ze(6,s.IExtHostInitDataService),ze(7,f.IExtensionStoragePaths),ze(8,b.IExtHostTunnelService),ze(9,C.IExtHostTerminalService)],j),e.AbstractExtHostExtensionService=j;function H(K,x){return{id:K.identifier.value,name:K.name,extensionVersion:K.version,publisherDisplayName:K.publisher,activationEvents:K.activationEvents?K.activationEvents.join(","):null,isBuiltin:K.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,u.createDecorator)("IExtHostExtensionService");class L{constructor(x,Y,ce,z){V.set(this,void 0),le.set(this,void 0),he.set(this,void 0),Ze(this,V,x,"f"),Ze(this,le,Y,"f"),Ze(this,he,ce.identifier,"f"),this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=F.normalize((0,T.originalFSPath)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=z}get isActive(){return Oe(this,V,"f").isActivated(Oe(this,he,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,V,"f").getExtensionExports(Oe(this,he,"f"))}activate(){return Oe(this,V,"f").activateByIdWithErrors(Oe(this,he,"f"),{startup:!1,extensionId:Oe(this,le,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=L,V=new WeakMap,le=new WeakMap,he=new WeakMap}),define(Ee[100],_e([0,1,17,2,3,13,5,6,161,31,33,47,166,32,162,12,4,10,90,62]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p,v,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let w=class{constructor(g,b,C,n,_,R){this._workspaceService=b,this._extensionService=C,this._editorsService=n,this._configurationService=_,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=g.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(V=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(g,b){const C=g;if(typeof C.sourceReference=="number"&&C.sourceReference>0){let n=`debug:${encodeURIComponent(C.path||"")}`,_="?";return b&&(n+=`${_}session=${encodeURIComponent(b.id)}`,_="&"),n+=`${_}ref=${C.sourceReference}`,F.URI.parse(n)}else{if(C.path)return F.URI.file(C.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(g){const b=[];for(const C of g.getAllExtensionDescriptions())if(C.contributes){const n=C.contributes.debuggers;if(n&&n.length>0)for(const _ of n)(0,a.isDebuggerMainContribution)(_)&&b.push(_.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const g=[];return this._breakpoints.forEach(b=>g.push(b)),g}addBreakpoints(g){this.startBreakpoints();const b=g.filter(_=>{const R=_.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,_),!0)});this.fireBreakpointChanges(b,[],[]);const C=[],n=new Map;for(const _ of b)if(_ instanceof I.SourceBreakpoint){let R=n.get(_.location.uri.toString());R||(R={type:"sourceMulti",uri:_.location.uri,lines:[]},n.set(_.location.uri.toString(),R),C.push(R)),R.lines.push({id:_.id,enabled:_.enabled,condition:_.condition,hitCondition:_.hitCondition,logMessage:_.logMessage,line:_.location.range.start.line,character:_.location.range.start.character})}else _ instanceof I.FunctionBreakpoint&&C.push({type:"function",id:_.id,enabled:_.enabled,hitCondition:_.hitCondition,logMessage:_.logMessage,condition:_.condition,functionName:_.functionName});return this._debugServiceProxy.$registerBreakpoints(C)}removeBreakpoints(g){this.startBreakpoints();const b=g.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],b,[]);const C=b.filter(R=>R instanceof I.SourceBreakpoint).map(R=>R.id),n=b.filter(R=>R instanceof I.FunctionBreakpoint).map(R=>R.id),_=b.filter(R=>R instanceof I.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(C,n,_)}startDebugging(g,b,C){return this._debugServiceProxy.$startDebugging(g?g.uri:void 0,b,{parentSessionID:C.parentSession?C.parentSession.id:void 0,lifecycleManagedByParent:C.lifecycleManagedByParent,repl:C.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:C.noDebug,compact:C.compact,debugUI:C.debugUI})}stopDebugging(g){return this._debugServiceProxy.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,b,C){if(!b)return new I.Disposable(()=>{});const n=this._configProviderHandleCounter++;return this._configProviders.push({type:g,handle:n,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(g,C,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,n),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(_=>_.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(n)})}registerDebugAdapterDescriptorFactory(g,b,C){if(!C)return new I.Disposable(()=>{});if(!this.definesDebugType(g,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const n=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:n,factory:C}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,n),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(_=>_.factory!==C),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(n)})}registerDebugAdapterTrackerFactory(g,b){if(!b)return new I.Disposable(()=>{});const C=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:g,handle:C,factory:b}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(n=>n.factory!==b)})}async $runInTerminal(g,b){return Promise.resolve(void 0)}async $substituteVariables(g,b){if(!this._variableResolver){const[_,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(_||[],this._editorsService,R)}let C;const n=await this.getFolder(g);return n&&(C={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(C,b)}createDebugAdapter(g,b){if(g.type==="implementation")return new s(g.implementation)}createSignService(){}async $startDASession(g,b){const C=this,n=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(n.type),n).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}' (extension might have failed to activate)`);const R=this.convertToDto(_),U=this.createDebugAdapter(R,n);if(!U)throw new Error(`Couldn't create a debug adapter for type '${n.type}'.`);const V=U;return this._debugAdapters.set(g,V),this.getDebugAdapterTrackers(n).then(le=>(le&&this._debugAdaptersTrackers.set(g,le),V.onMessage(async he=>{if(he.type==="request"&&he.command==="handshake"){const j=he,H={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(j.arguments.value);H.body={signature:L},V.sendResponse(H)}else throw new Error("no signer")}catch(L){H.success=!1,H.message=L.message,V.sendResponse(H)}}else le&&le.onDidSendMessage&&le.onDidSendMessage(he),he=(0,a.convertToVSCPaths)(he,!0),C._debugServiceProxy.$acceptDAMessage(g,he)}),V.onError(he=>{le&&le.onError&&le.onError(he),this._debugServiceProxy.$acceptDAError(g,he.name,he.message,he.stack)}),V.onExit(he=>{le&&le.onExit&&le.onExit((0,v.withNullAsUndefined)(he),void 0),this._debugServiceProxy.$acceptDAExit(g,(0,v.withNullAsUndefined)(he),void 0)}),le&&le.onWillStartSession&&le.onWillStartSession(),V.startSession()))})}$sendDAMessage(g,b){b=(0,a.convertToDAPaths)(b,!1);const C=this._debugAdaptersTrackers.get(g);C&&C.onWillReceiveMessage&&C.onWillReceiveMessage(b);const n=this._debugAdapters.get(g);n&&n.sendMessage(b)}$stopDASession(g){const b=this._debugAdaptersTrackers.get(g);this._debugAdaptersTrackers.delete(g),b&&b.onWillStopSession&&b.onWillStopSession();const C=this._debugAdapters.get(g);return this._debugAdapters.delete(g),C?C.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const b=[],C=[],n=[];if(g.added)for(const _ of g.added){const R=_.id;if(R&&!this._breakpoints.has(R)){let U;if(_.type==="function")U=new I.FunctionBreakpoint(_.functionName,_.enabled,_.condition,_.hitCondition,_.logMessage);else if(_.type==="data")U=new I.DataBreakpoint(_.label,_.dataId,_.canPersist,_.enabled,_.hitCondition,_.condition,_.logMessage);else{const V=F.URI.revive(_.uri);U=new I.SourceBreakpoint(new I.Location(V,new I.Position(_.line,_.character)),_.enabled,_.condition,_.hitCondition,_.logMessage)}U._id=R,this._breakpoints.set(R,U),b.push(U)}}if(g.removed)for(const _ of g.removed){const R=this._breakpoints.get(_);R&&(this._breakpoints.delete(_),C.push(R))}if(g.changed){for(const _ of g.changed)if(_.id){const R=this._breakpoints.get(_.id);if(R){if(R instanceof I.FunctionBreakpoint&&_.type==="function"){const U=R;U.enabled=_.enabled,U.condition=_.condition,U.hitCondition=_.hitCondition,U.logMessage=_.logMessage,U.functionName=_.functionName}else if(R instanceof I.SourceBreakpoint&&_.type==="source"){const U=R;U.enabled=_.enabled,U.condition=_.condition,U.hitCondition=_.hitCondition,U.logMessage=_.logMessage,U.location=new I.Location(F.URI.revive(_.uri),new I.Position(_.line,_.character))}n.push(R)}}}this.fireBreakpointChanges(b,C,n)}$provideDebugConfigurations(g,b,C){return(0,T.asPromise)(async()=>{const n=this.getConfigProviderByHandle(g);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const _=await this.getFolder(b);return n.provideDebugConfigurations(_,C)}).then(n=>{if(!n)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return n})}$resolveDebugConfiguration(g,b,C,n){return(0,T.asPromise)(async()=>{const _=this.getConfigProviderByHandle(g);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(b);return _.resolveDebugConfiguration(R,C,n)})}$resolveDebugConfigurationWithSubstitutedVariables(g,b,C,n){return(0,T.asPromise)(async()=>{const _=this.getConfigProviderByHandle(g);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(b);return _.resolveDebugConfigurationWithSubstitutedVariables(R,C,n)})}async $provideDebugAdapter(g,b){const C=this.getAdapterDescriptorFactoryByHandle(g);if(!C)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const n=await this.getSession(b);return this.getAdapterDescriptor(C,n).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}'`);return this.convertToDto(_)})}async $acceptDebugSessionStarted(g){const b=await this.getSession(g);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(g){const b=await this.getSession(g);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(g){this._activeDebugSession=g?await this.getSession(g):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(g,b){const C=await this.getSession(g);C&&C._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(g,b){const n={session:await this.getSession(g),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(n)}convertToDto(g){if(g instanceof I.DebugAdapterExecutable)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof I.DebugAdapterServer)return{type:"server",port:g.port,host:g.host};if(g instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:g.path};if(g instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(g){const b=this._adapterFactories.filter(C=>C.type===g);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(g){const b=this._adapterFactories.filter(C=>C.handle===g);if(b.length>0)return b[0].factory}getConfigProviderByHandle(g){const b=this._configProviders.filter(C=>C.handle===g);if(b.length>0)return b[0].provider}definesDebugType(g,b){if(g.contributes){const C=g.contributes.debuggers;if(C&&C.length>0){for(const n of C)if(n.label&&n.type&&n.type===b)return!0}}return!1}getDebugAdapterTrackers(g){const C=g.configuration.type,n=this._trackerFactories.filter(_=>_.type===C||_.type==="*").map(_=>(0,T.asPromise)(()=>_.factory.createDebugAdapterTracker(g)).then(R=>R,R=>null));return Promise.race([Promise.all(n).then(_=>{const R=_.filter(U=>!!U);if(R.length>0)return new u(R)}),new Promise((_,R)=>{const U=setTimeout(()=>{clearTimeout(U),R(new Error("timeout"))},1e3)})]).catch(_=>{})}async getAdapterDescriptor(g,b){const C=b.configuration.debugServer;if(typeof C=="number")return Promise.resolve(new I.DebugAdapterServer(C));if(g){const _=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>g.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,_))).then(R=>{if(R)return R})}const n=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,n))}daExecutableFromPackage(g,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(g,b,C){(g.length>0||b.length>0||C.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:g,removed:b,changed:C}))}async getSession(g){if(g)if(typeof g=="string"){const b=this._debugSessions.get(g);if(b)return b}else{let b=this._debugSessions.get(g.id);if(!b){const C=await this.getFolder(g.folderUri),n=g.parent?this._debugSessions.get(g.parent):void 0;b=new y(this._debugServiceProxy,g.id,g.type,g.name,C,g.configuration,n),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(g){if(g){const b=F.URI.revive(g);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};w=We([ze(0,l.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,S.IExtHostDocumentsAndEditors),ze(4,d.IExtHostConfiguration),ze(5,c.IExtHostEditorTabs)],w),e.ExtHostDebugServiceBase=w;class y{constructor(g,b,C,n,_,R,U){this._debugServiceProxy=g,this._id=b,this._type=C,this._name=n,this._workspaceFolder=_,this._configuration=R,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(g){this._name=g,this._debugServiceProxy.$setDebugSessionName(this._id,g)}get parentSession(){return this._parentSession}_acceptNameChanged(g){this._name=g}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(g,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,g,b)}getDebugProtocolBreakpoint(g){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,g.id)}}e.ExtHostDebugSession=y;class i{constructor(g){this.value=Object.freeze({append(b){g.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=i;class o extends r.AbstractVariableResolverService{constructor(g,b,C,n,_){function R(){if(b){const U=b.activeEditor();if(U)return U.document.uri;const V=n.tabs.filter(le=>le.isActive);if(V.length>0)return V[0].resource}}super({getFolderUri:U=>{const V=g.filter(le=>le.name===U);if(V&&V.length>0)return V[0].uri},getWorkspaceFolderCount:()=>g.length,getConfigurationValue:(U,V)=>C.getConfiguration(void 0,U).get(V),getAppRoot:()=>k.cwd(),getExecPath:()=>k.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=R();if(U)return h.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(_){const U=R();if(U){const V=_.getWorkspaceFolder(U);if(V)return h.normalize(V.uri.fsPath)}}},getSelectedText:()=>{if(b){const U=b.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(b){const U=b.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(k.env))}}e.ExtHostVariableResolverService=o;class u{constructor(g){this.trackers=g}onWillStartSession(){this.trackers.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(g):void 0)}onWillStopSession(){this.trackers.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.trackers.forEach(b=>b.onError?b.onError(g):void 0)}onExit(g,b){this.trackers.forEach(C=>C.onExit?C.onExit(g,b):void 0)}}class s extends D.AbstractDebugAdapter{constructor(g){super();this.implementation=g,g.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.implementation.handleMessage(g)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let f=class extends w{constructor(g,b,C,n,_,R){super(g,b,C,n,_,R)}createVariableResolver(g,b,C){return new o(g,b,C,this._editorTabs)}};f=We([ze(0,l.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,S.IExtHostDocumentsAndEditors),ze(4,d.IExtHostConfiguration),ze(5,c.IExtHostEditorTabs)],f),e.WorkerExtHostDebugService=f}),define(Ee[218],_e([0,1,73,2,5,32,30,25,12,29,4,33,90,14]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(c,w,y,i,o,u,s){this._apiFactory=c,this._extensionRegistry=w,this._instaService=y,this._extHostConfiguration=i,this._extHostExtensionService=o,this._initData=u,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),h.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const w=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,w,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,w,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let w of c.nodeModuleName)this._factories.set(w,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(w=>c.alternativeModuleName(w))}};a=We([ze(2,t.IInstantiationService),ze(3,T.IExtHostConfiguration),ze(4,S.IExtHostExtensionService),ze(5,P.IExtHostInitDataService),ze(6,d.ILogService)],a),e.RequireInterceptor=a;class l{constructor(c,w,y,i,o){this._apiFactory=c,this._extensionPaths=w,this._extensionRegistry=y,this._configProvider=i,this._logService=o,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,w){const y=this._extensionPaths.findSubstr(w.fsPath);if(y){let i=this._extApiImpl.get(I.ExtensionIdentifier.toKey(y.identifier));return i||(i=this._apiFactory(y,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(y.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((o,u)=>i+=`	${u} -> ${o.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${w.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(c,w){this.nodeModuleName="keytar";const{environment:y}=w,i=c.getProxy(E.MainContext.MainThreadKeytar);if(y.appRoot){let o=y.appRoot.fsPath;r.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,u)=>i.$getPassword(o,u),setPassword:(o,u,s)=>i.$setPassword(o,u,s),deletePassword:(o,u)=>i.$deletePassword(o,u),findPassword:o=>i.$findPassword(o),findCredentials(o){return i.$findCredentials(o)}}}load(c,w){return this._impl}alternativeModuleName(c){const w=c.length;if(w<=7||!this.alternativeNames)return;const y=w-7;if((c.charAt(y)==="/"||c.charAt(y)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}};p=We([ze(0,D.IExtHostRpcService),ze(1,P.IExtHostInitDataService)],p);let v=class{constructor(c,w,y){this._extensionPaths=c,this._appUriScheme=w,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=y.getProxy(E.MainContext.MainThreadTelemetry);const i=y.getProxy(E.MainContext.MainThreadWindow);this._impl=(o,u)=>{const s=F.URI.parse(o);return u?this.callOriginal(o,u):s.scheme==="http"||s.scheme==="https"?i.$openUri(s,o,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?i.$openUri(s,o,{}):this.callOriginal(o,u)}}load(c,w,y){const i=this._extensionPaths.findSubstr(w.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=y(c),this._impl}callOriginal(c,w){return this.sendNoForwardTelemetry(),this._original(c,w)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=We([ze(2,D.IExtHostRpcService)],v)}),define(Ee[219],_e([0,1,13,15,73,7,2,5,212,14,55,59,29,143,12,65,33,37]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class k{constructor(w,y,i,o){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new D.RPCProtocol(w,null,o),y=k._transform(y,this._rpcProtocol);const u=new S.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());u.set(r.IExtHostInitDataService,{_serviceBrand:void 0,...y}),u.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),u.set(l.IURITransformerService,new l.URITransformerService(o)),u.set(p.IHostUtils,i);const s=new d.InstantiationService(u,!0),f=s.invokeFunction(C=>C.get(v.IExtHostTerminalService));this._disposables.add(f),this._logService=s.invokeFunction(C=>C.get(P.ILogService)),E.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",y),this._extensionService=s.invokeFunction(C=>C.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const m=new WeakMap;this._extensionService.getExtensionPathIndex().then(C=>{Error.prepareStackTrace=(n,_)=>{let R="",U,V;for(const le of _)R+=`
	at ${le.toString()}`,V=le.getFileName(),!U&&V&&(U=C.findSubstr(V));return m.set(n,U),`${n.name||"Error"}: ${n.message||""}${R}`}});const g=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(C=>{const n=F.transformErrorForSerialization(C),_=m.get(C);_?g.$onExtensionRuntimeError(_.identifier,n):b.$onUnexpectedError(n)})}terminate(w){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${w}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const y=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,h.timeout)(4e3),y]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(w,y){w.extensions.forEach(o=>o.extensionLocation=A.URI.revive(y.transformIncomingURIs(o.extensionLocation))),w.environment.appRoot=A.URI.revive(y.transformIncomingURIs(w.environment.appRoot));const i=w.environment.extensionDevelopmentLocationURI;return i&&(w.environment.extensionDevelopmentLocationURI=i.map(o=>A.URI.revive(y.transformIncomingURIs(o)))),w.environment.extensionTestsLocationURI=A.URI.revive(y.transformIncomingURIs(w.environment.extensionTestsLocationURI)),w.environment.globalStorageHome=A.URI.revive(y.transformIncomingURIs(w.environment.globalStorageHome)),w.environment.workspaceStorageHome=A.URI.revive(y.transformIncomingURIs(w.environment.workspaceStorageHome)),w.logsLocation=A.URI.revive(y.transformIncomingURIs(w.logsLocation)),w.logFile=A.URI.revive(y.transformIncomingURIs(w.logFile)),w.workspace=y.transformIncomingURIs(w.workspace),w}}e.ExtensionHostMain=k}),define(Ee[220],_e([0,1,17,21,54,27,24,193,38]),function(te,e,h,F,E,T,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(r,d,a){this.config=r,this.provider=d,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=r.filePattern,this.includePattern=r.includePattern&&T.parse(r.includePattern),this.maxResults=r.maxResults||void 0,this.exists=r.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=r.excludePattern&&T.parse(r.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(r=>r.cancel()),this.activeCancellationTokens=new Set}search(r){const d=this.config.folderQueries||[];return new Promise((a,l)=>{const p=v=>{this.resultCount++,r(v)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const k=v.toString(),c=h.basename(k);this.globalExcludePattern&&this.globalExcludePattern(k,c)||this.matchFile(p,{base:v,basename:c})}),Promise.all(d.map(v=>this.searchInFolder(v,p))).then(v=>{a({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{l(new Error((0,E.toErrorMessage)(v)))})})}async searchInFolder(r,d){const a=new F.CancellationTokenSource,l=this.getSearchOptionsForFolder(r),p=this.initDirectoryTree(),v=new D.QueryGlobTester(this.config,r),k=!v.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(a),c=I.StopWatch.create();const w=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,a.token),y=c.elapsed(),i=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(w&&w.forEach(o=>{const u=h.posix.relative(r.folder.path,o.path);if(k){const s=h.basename(o.path);this.matchFile(d,{base:r.folder,relativePath:u,basename:s});return}this.addDirectoryEntries(p,r.folder,u,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,v,d),{providerTime:y,postProcessTime:i.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(r){const d=(0,D.resolvePatternsForProvider)(this.config.includePattern,r.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,r.excludePattern);return{folder:r.folder,excludes:a,includes:d,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,followSymlinks:!r.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries({pathToEntries:r},d,a,l){if(a===this.filePattern){const v=h.basename(this.filePattern);this.matchFile(l,{base:d,relativePath:this.filePattern,basename:v})}function p(v){const k=h.basename(v),c=h.dirname(v);let w=r[c];w||(w=r[c]=[],p(c)),w.push({base:d,relativePath:v,basename:k})}p(a)}matchDirectoryTree({rootEntries:r,pathToEntries:d},a,l){const p=this,v=this.filePattern;function k(c){const w=T.hasSiblingFn(()=>c.map(y=>y.basename));for(let y=0,i=c.length;y<i;y++){const o=c[y],{relativePath:u,basename:s}=o;if(!a.includedInQuerySync(u,s,v!==s?w:void 0))continue;const f=d[u];if(f)k(f);else{if(u===v)continue;p.matchFile(l,o)}if(p.isLimitHit)break}}k(r)}matchFile(r,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||r(d))}}class t{constructor(){this.sessions=new Map}fileSearch(r,d,a,l){const p=this.getSessionTokenSource(r.cacheKey),v=new P(r,d,p&&p.token);let k=0;const c=w=>{k+=w.length,a(w.map(y=>this.rawMatchToSearchItem(y)))};return this.doSearch(v,t.BATCH_SIZE,c,l).then(w=>({limitHit:w.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:k,detailStats:w.stats}}))}clearCache(r){const d=this.getSessionTokenSource(r);d&&d.cancel()}getSessionTokenSource(r){if(!!r)return this.sessions.has(r)||this.sessions.set(r,new F.CancellationTokenSource),this.sessions.get(r)}rawMatchToSearchItem(r){return r.relativePath?{resource:A.joinPath(r.base,r.relativePath)}:{resource:r.base}}doSearch(r,d,a,l){l.onCancellationRequested(()=>{r.cancel()});const p=k=>{k&&(v.push(k),d>0&&v.length>=d&&(a(v),v=[]))};let v=[];return r.search(p).then(k=>(v.length&&a(v),k),k=>(v.length&&a(v),Promise.reject(k)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(Ee[221],_e([0,1,17,16,21,54,24,27,2,38,11,10]),function(te,e,h,F,E,T,A,I,D,P,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class r{constructor(c,w,y){this.query=c,this.provider=w,this.fileUtils=y,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,w){const y=this.query.folderQueries||[],i=new E.CancellationTokenSource;return w.onCancellationRequested(()=>i.cancel()),new Promise((o,u)=>{this.collector=new a(c);let s=!1;const f=(m,g)=>{if(!s&&!this.isLimitHit){const b=this.resultSize(m);p(m)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,s=!0,i.cancel(),m=this.trimResultToSize(m,this.query.maxResults-this.resultCount));const C=this.resultSize(m);this.resultCount+=C,(C>0||!p(m))&&this.collector.add(m,g)}};Promise.all(y.map((m,g)=>this.searchInFolder(m,b=>f(b,g),i.token))).then(m=>{i.dispose(),this.collector.flush();const g=m.some(b=>!!b&&!!b.limitHit);o({limitHit:this.isLimitHit||g,messages:(0,F.flatten)(m.map(b=>b?.message?(0,S.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:"textSearchProvider"}})},m=>{i.dispose();const g=(0,T.toErrorMessage)(m);u(new Error(g))})})}resultSize(c){return p(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,w){const y=Array.isArray(c.ranges)?c.ranges:[c.ranges],i=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:y.slice(0,w),preview:{matches:i.slice(0,w),text:c.preview.text},uri:c.uri}}async searchInFolder(c,w,y){const i=new P.QueryGlobTester(this.query,c),o=[],u={report:m=>{if(!this.validateProviderResult(m))return;const g=c.folder.scheme===t.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(A.dirname(m.uri))):void 0,b=A.relativePath(c.folder,m.uri);b&&o.push(i.includedInQuery(b,h.basename(b),g).then(C=>{C&&w(m)}))}},s=this.getSearchOptionsForFolder(c),f=await this.provider.provideTextSearchResults(d(this.query.contentPattern),s,u,y);return await Promise.all(o),f}validateProviderResult(c){if(p(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const w=(0,P.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),y=(0,P.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),i={folder:D.URI.from(c.folder),excludes:y,includes:w,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=r;function d(k){return{isCaseSensitive:k.isCaseSensitive||!1,isRegExp:k.isRegExp||!1,isWordMatch:k.isWordMatch||!1,isMultiline:k.isMultiline||!1,pattern:k.pattern}}class a{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,w=>this.sendItems(w))}add(c,w){this._currentFileMatch&&(this._currentFolderIdx!==w||!A.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=w,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(l(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=a;function l(k){return p(k)?{preview:{matches:(0,F.mapArrayOrNot)(k.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:k.preview.text},ranges:(0,F.mapArrayOrNot)(k.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:k.text,lineNumber:k.lineNumber}}function p(k){return!!k.preview}e.extensionResultIsMatch=p;class v{constructor(c,w){this.maxBatchSize=c,this.cb=w,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,w){!c||this.addItemToBatch(c,w)}addItems(c,w){!c||this.addItemsToBatch(c,w)}addItemToBatch(c,w){this.batch.push(c),this.batchSize+=w,this.onUpdate()}addItemsToBatch(c,w){this.batch=this.batch.concat(c),this.batchSize+=w,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(Ee[101],_e([0,1,7,5,4,220,12,65,14,2,221]),function(te,e,h,F,E,T,A,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let S=class{constructor(l,p,v){this.extHostRpc=l,this._uriTransformer=p,this._logService=v,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,p){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const v=this._handlePool++;return this._textSearchProvider.set(v,p),this._proxy.$registerTextSearchProvider(v,this._transformScheme(l)),(0,h.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(l,p){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const v=this._handlePool++;return this._fileSearchProvider.set(v,p),this._proxy.$registerFileSearchProvider(v,this._transformScheme(l)),(0,h.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(l,p,v,k){const c=r(v),w=this._fileSearchProvider.get(l);if(w)return this._fileSearchManager.fileSearch(c,w,y=>{this._proxy.$handleFileMatch(l,p,y.map(i=>i.resource))},k);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,p,v,k){const c=this._textSearchProvider.get(l);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const w=r(v);return this.createTextSearchManager(w,c).search(i=>this._proxy.$handleTextMatch(l,p,i),k)}createTextSearchManager(l,p){return new t.TextSearchManager(l,p,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};S=We([ze(0,A.IExtHostRpcService),ze(1,I.IURITransformerService),ze(2,D.ILogService)],S),e.ExtHostSearch=S;function r(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(d),extraFileResources:a.extraFileResources&&a.extraFileResources.map(l=>P.URI.revive(l))}}e.reviveQuery=r;function d(a){return{...a,folder:P.URI.revive(a.folder)}}}),define(Ee[222],_e([0,1,21,15,3,35,2,116,78,112,53,58,5,182,181,46,183,32,184,185,186,168,187,47,33,189,169,192,194,195,96,171,200,201,202,71,37,204,172,8,6,207,48,97,31,30,49,158,191,85,95,99,100,101,14,65,12,29,196,155,64,69,179,205,154,72,70,210,208,209,180,45,203,206,68,62,86,198,98,199,11,145,197,152,190]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p,v,k,c,w,y,i,o,u,s,f,m,g,b,C,n,_,R,U,V,le,he,j,H,L,K,x,Y,ce,z,se,re,we,Re,Fe,Ne,Qe,qe,Ke,N,q,X,ie,W,ee,me,Te,Ue,He,be,Je,$,G,fe,Le,Ve,et,rt,pt,St,Ct,ct,_t,ht,wt,Ye,Pt,Pe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(J){const oe=J.get(X.IExtHostInitDataService),pe=J.get(Ve.IExtHostFileSystemInfo),ge=J.get(Je.IExtHostConsumerFileSystem),Ie=J.get(u.IExtHostExtensionService),Be=J.get(ce.IExtHostWorkspace),Me=J.get(Ct.IExtHostTelemetry),je=J.get(v.IExtHostConfiguration),de=J.get(N.IURITransformerService),ae=J.get(q.IExtHostRpcService),ne=J.get(V.IExtHostStorage),B=J.get(be.IExtensionStoragePaths),ve=J.get(Ke.ILogService),ke=J.get(ee.IExtHostTunnelService),$e=J.get(me.IExtHostApiDeprecationService),xe=J.get(Y.IExtHostWindow),lt=J.get(pt.IExtHostSecretState),at=J.get(St.IExtHostEditorTabs);ae.set(r.ExtHostContext.ExtHostFileSystemInfo,pe),ae.set(r.ExtHostContext.ExtHostLogService,ve),ae.set(r.ExtHostContext.ExtHostWorkspace,Be),ae.set(r.ExtHostContext.ExtHostConfiguration,je),ae.set(r.ExtHostContext.ExtHostExtensionService,Ie),ae.set(r.ExtHostContext.ExtHostStorage,ne),ae.set(r.ExtHostContext.ExtHostTunnelService,ke),ae.set(r.ExtHostContext.ExtHostWindow,xe),ae.set(r.ExtHostContext.ExtHostSecretState,lt),ae.set(r.ExtHostContext.ExtHostTelemetry,Me),ae.set(r.ExtHostContext.ExtHostEditorTabs,at);const bt=ae.set(r.ExtHostContext.ExtHostDecorations,J.get(Fe.IExtHostDecorations)),dt=ae.set(r.ExtHostContext.ExtHostDocumentsAndEditors,J.get(o.IExtHostDocumentsAndEditors)),nt=ae.set(r.ExtHostContext.ExtHostCommands,J.get(l.IExtHostCommands)),st=ae.set(r.ExtHostContext.ExtHostTerminalService,J.get(le.IExtHostTerminalService)),ft=ae.set(r.ExtHostContext.ExtHostDebugService,J.get(Qe.IExtHostDebugService)),kt=ae.set(r.ExtHostContext.ExtHostSearch,J.get(qe.IExtHostSearch)),Tt=ae.set(r.ExtHostContext.ExtHostTask,J.get(Ne.IExtHostTask)),Wt=ae.set(r.ExtHostContext.ExtHostOutputService,J.get(C.IExtHostOutputService)),qt=ae.set(r.ExtHostContext.ExtHostUrls,new K.ExtHostUrls(ae)),Et=ae.set(r.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ae,dt)),Jt=ae.set(r.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(ae,dt,ve)),Xt=ae.set(r.ExtHostContext.ExtHostDocumentSaveParticipant,new y.ExtHostDocumentSaveParticipant(ve,Et,ae.getProxy(r.MainContext.MainThreadBulkEdits))),mt=ae.set(r.ExtHostContext.ExtHostNotebook,new ie.ExtHostNotebookController(ae,nt,dt,Et,B)),jt=ae.set(r.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(ve,mt)),Ht=ae.set(r.ExtHostContext.ExtHostNotebookEditors,new Pt.ExtHostNotebookEditors(ve,ae,mt)),Zt=ae.set(r.ExtHostContext.ExtHostNotebookKernels,new ct.ExtHostNotebookKernels(ae,oe,mt,ve)),ei=ae.set(r.ExtHostContext.ExtHostNotebookRenderers,new ht.ExtHostNotebookRenderers(ae,mt)),It=ae.set(r.ExtHostContext.ExtHostEditors,new he.ExtHostEditors(ae,dt)),hi=ae.set(r.ExtHostContext.ExtHostTreeViews,new j.ExtHostTreeViews(ae.getProxy(r.MainContext.MainThreadTreeViews),nt,ve)),ti=ae.set(r.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(ae.getProxy(r.MainContext.MainThreadEditorInsets),It,oe)),Ut=ae.set(r.ExtHostContext.ExtHostDiagnostics,new k.ExtHostDiagnostics(ae,ve)),ut=ae.set(r.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(ae,de,Et,nt,Ut,ve,$e)),ii=ae.set(r.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(ae,ut)),Lt=ae.set(r.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(ae,ve,dt)),Ot=ae.set(r.ExtHostContext.ExtHostQuickOpen,(0,_.createExtHostQuickOpen)(ae,Be,nt)),Gt=ae.set(r.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(ae,nt,ve)),Ei=ae.set(r.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(ae,nt,Et)),fi=ae.set(r.ExtHostContext.ExtHostProgress,new n.ExtHostProgress(ae.getProxy(r.MainContext.MainThreadProgress))),_i=ae.set(r.ExtHostContext.ExtHosLabelService,new we.ExtHostLabelService(ae)),mi=ae.set(r.ExtHostContext.ExtHostTheming,new W.ExtHostTheming(ae)),ni=ae.set(r.ExtHostContext.ExtHostAuthentication,new Te.ExtHostAuthentication(ae)),ri=ae.set(r.ExtHostContext.ExtHostTimeline,new Ue.ExtHostTimeline(ae,nt)),zt=ae.set(r.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(ae,{remote:oe.remote},Be,ve,$e)),si=ae.set(r.ExtHostContext.ExtHostWebviewPanels,new fe.ExtHostWebviewPanels(ae,zt,Be)),yi=ae.set(r.ExtHostContext.ExtHostCustomEditors,new G.ExtHostCustomEditors(ae,Et,B,zt,si)),Si=ae.set(r.ExtHostContext.ExtHostWebviewViews,new $.ExtHostWebviewViews(ae,zt)),Vt=ae.set(r.ExtHostContext.ExtHostTesting,new et.ExtHostTesting(ae,nt)),Kt=ae.set(r.ExtHostContext.ExtHostUriOpeners,new rt.ExtHostUriOpeners(ae));ae.set(r.ExtHostContext.ExtHostInteractive,new Se.ExtHostInteractive(ae,mt,dt,nt));const Di=(0,se.values)(r.ExtHostContext);ae.assertRegistered(Di);const Ci=new Le.ExtHostBulkEdits(ae,dt),oi=new a.ExtHostClipboard(ae),ai=new b.ExtHostMessageService(ae,ve),Bt=new c.ExtHostDialogs(ae),Ft=new U.ExtHostStatusBar(ae,nt.converter),Qt=new g.ExtHostLanguages(ae,Et);return d.ExtHostApiCommands.register(nt),function(Ae,$t,gi){const gt=function(){let Q=!Ae.isUnderDevelopment;function ue(De){Q||(ve.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Q=!0)}return function De(it){if(Array.isArray(it))it.forEach(De);else if(typeof it=="string")ue(it);else{const vt=it;typeof vt.scheme=="undefined"&&ue(it),!Ae.enableProposedApi&&typeof vt.exclusive=="boolean"&&(0,z.throwProposedApiError)(Ae)}return it}}(),ki={getSession(Q,ue,De){return De?.forceNewSession&&(0,z.checkProposedApiEnabled)(Ae),ni.getSession(Ae,Q,ue,De)},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(Q,ue,De,it){return ni.registerAuthenticationProvider(Q,ue,De,it)}},Ii={registerCommand(Q,ue,De){return nt.registerCommand(!0,Q,ue,De)},registerTextEditorCommand(Q,ue,De){return nt.registerCommand(!0,Q,(...it)=>{const vt=It.getActiveTextEditor();if(!vt){ve.warn("Cannot execute "+Q+" because there is no active text editor.");return}return vt.edit(Dt=>{ue.apply(De,[vt,Dt,...it])}).then(Dt=>{Dt||ve.warn("Edits from command "+Q+" were not applied.")},Dt=>{ve.warn("An error occurred while running command "+Q,Dt)})})},registerDiffInformationCommand:(Q,ue,De)=>((0,z.checkProposedApiEnabled)(Ae),nt.registerCommand(!0,Q,async(...it)=>{const vt=dt.activeEditor(!0);if(!vt){ve.warn("Cannot execute "+Q+" because there is no active text editor.");return}const Dt=await It.getDiffInformation(vt.id);ue.apply(De,[Dt,...it])})),executeCommand(Q,...ue){return nt.executeCommand(Q,...ue)},getCommands(Q=!1){return nt.getCommands(Q)}},pi={get machineId(){return oe.telemetryInfo.machineId},get sessionId(){return oe.telemetryInfo.sessionId},get language(){return oe.environment.appLanguage},get appName(){return oe.environment.appName},get appRoot(){return oe.environment.appRoot?.fsPath??""},get embedderIdentifier(){return oe.environment.embedderIdentifier},get uriScheme(){return oe.environment.appUriScheme},get clipboard(){return oi.value},get shell(){return st.getDefaultShell(!1)},get isTelemetryEnabled(){return Me.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Me.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Q=Date.now()-new Date(oe.telemetryInfo.firstSessionDate).getTime();return isNaN(Q)?!1:Q<1e3*60*60*24},openExternal(Q,ue){return xe.openUri(Q,{allowTunneling:!!oe.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(Q){if(Q.scheme===oe.environment.appUriScheme)return qt.createAppUri(Q);try{return await xe.asExternalUri(Q,{allowTunneling:!!oe.remote.authority})}catch(ue){if((0,Ye.matchesScheme)(Q,wt.Schemas.http)||(0,Ye.matchesScheme)(Q,wt.Schemas.https))return Q;throw ue}},get remoteName(){return(0,Re.getRemoteName)(oe.remote.authority)},get uiKind(){return oe.uiKind}};oe.environment.extensionTestsLocationURI||Object.freeze(pi);const vi=oe.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Pi={createTestController(Q,ue){return Vt.createTestController(Q,ue)},createTestObserver(){return(0,z.checkProposedApiEnabled)(Ae),Vt.createTestObserver()},runTests(Q){return(0,z.checkProposedApiEnabled)(Ae),Vt.runTests(Q)},get onDidChangeTestResults(){return(0,z.checkProposedApiEnabled)(Ae),Vt.onResultsChanged},get testResults(){return(0,z.checkProposedApiEnabled)(Ae),Vt.results}},li={getExtension(Q){const ue=$t.getExtensionDescription(Q);if(ue)return new u.Extension(Ie,Ae.identifier,ue,vi)},get all(){return $t.getAllExtensionDescriptions().map(Q=>new u.Extension(Ie,Ae.identifier,Q,vi))},get onDidChange(){return $t.onDidChange}},Ti={createDiagnosticCollection(Q){return Ut.createDiagnosticCollection(Ae.identifier,Q)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:Q=>Ut.getDiagnostics(Q),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(Q,ue){return Qt.changeLanguage(Q.uri,ue)},match(Q,ue){return(0,t.score)(H.LanguageSelector.from(Q),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(Q,ue,De){return ut.registerCodeActionProvider(Ae,gt(Q),ue,De)},registerCodeLensProvider(Q,ue){return ut.registerCodeLensProvider(Ae,gt(Q),ue)},registerDefinitionProvider(Q,ue){return ut.registerDefinitionProvider(Ae,gt(Q),ue)},registerDeclarationProvider(Q,ue){return ut.registerDeclarationProvider(Ae,gt(Q),ue)},registerImplementationProvider(Q,ue){return ut.registerImplementationProvider(Ae,gt(Q),ue)},registerTypeDefinitionProvider(Q,ue){return ut.registerTypeDefinitionProvider(Ae,gt(Q),ue)},registerHoverProvider(Q,ue){return ut.registerHoverProvider(Ae,gt(Q),ue,Ae.identifier)},registerEvaluatableExpressionProvider(Q,ue){return ut.registerEvaluatableExpressionProvider(Ae,gt(Q),ue,Ae.identifier)},registerInlineValuesProvider(Q,ue){return ut.registerInlineValuesProvider(Ae,gt(Q),ue,Ae.identifier)},registerDocumentHighlightProvider(Q,ue){return ut.registerDocumentHighlightProvider(Ae,gt(Q),ue)},registerLinkedEditingRangeProvider(Q,ue){return ut.registerLinkedEditingRangeProvider(Ae,gt(Q),ue)},registerReferenceProvider(Q,ue){return ut.registerReferenceProvider(Ae,gt(Q),ue)},registerRenameProvider(Q,ue){return ut.registerRenameProvider(Ae,gt(Q),ue)},registerDocumentSymbolProvider(Q,ue,De){return ut.registerDocumentSymbolProvider(Ae,gt(Q),ue,De)},registerWorkspaceSymbolProvider(Q){return ut.registerWorkspaceSymbolProvider(Ae,Q)},registerDocumentFormattingEditProvider(Q,ue){return ut.registerDocumentFormattingEditProvider(Ae,gt(Q),ue)},registerDocumentRangeFormattingEditProvider(Q,ue){return ut.registerDocumentRangeFormattingEditProvider(Ae,gt(Q),ue)},registerOnTypeFormattingEditProvider(Q,ue,De,...it){return ut.registerOnTypeFormattingEditProvider(Ae,gt(Q),ue,[De].concat(it))},registerDocumentSemanticTokensProvider(Q,ue,De){return ut.registerDocumentSemanticTokensProvider(Ae,gt(Q),ue,De)},registerDocumentRangeSemanticTokensProvider(Q,ue,De){return ut.registerDocumentRangeSemanticTokensProvider(Ae,gt(Q),ue,De)},registerSignatureHelpProvider(Q,ue,De,...it){return typeof De=="object"?ut.registerSignatureHelpProvider(Ae,gt(Q),ue,De):ut.registerSignatureHelpProvider(Ae,gt(Q),ue,typeof De=="undefined"?[]:[De,...it])},registerCompletionItemProvider(Q,ue,...De){return ut.registerCompletionItemProvider(Ae,gt(Q),ue,De)},registerInlineCompletionItemProvider(Q,ue){return(0,z.checkProposedApiEnabled)(Ae),ut.registerInlineCompletionsProvider(Ae,gt(Q),ue)},registerDocumentLinkProvider(Q,ue){return ut.registerDocumentLinkProvider(Ae,gt(Q),ue)},registerColorProvider(Q,ue){return ut.registerColorProvider(Ae,gt(Q),ue)},registerFoldingRangeProvider(Q,ue){return ut.registerFoldingRangeProvider(Ae,gt(Q),ue)},registerSelectionRangeProvider(Q,ue){return ut.registerSelectionRangeProvider(Ae,Q,ue)},registerCallHierarchyProvider(Q,ue){return ut.registerCallHierarchyProvider(Ae,Q,ue)},setLanguageConfiguration:(Q,ue)=>ut.setLanguageConfiguration(Ae,Q,ue),getTokenInformationAtPosition(Q,ue){return(0,z.checkProposedApiEnabled)(Ae),Qt.tokenAtPosition(Q,ue)},registerInlayHintsProvider(Q,ue){return(0,z.checkProposedApiEnabled)(Ae),ut.registerInlayHintsProvider(Ae,Q,ue)},registerTypeHierarchyProvider(Q,ue){return(0,z.checkProposedApiEnabled)(Ae),ut.registerTypeHierarchyProvider(Ae,Q,ue)},createLanguageStatusItem(Q){return(0,z.checkProposedApiEnabled)(Ae),Qt.createLanguageStatusItem(Q)}},Ai={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return st.activeTerminal},get terminals(){return st.terminals},async showTextDocument(Q,ue,De){const it=await(A.URI.isUri(Q)?Promise.resolve(wi.openTextDocument(Q)):Promise.resolve(Q));return It.showTextDocument(it,ue,De)},createTextEditorDecorationType(Q){return It.createTextEditorDecorationType(Ae,Q)},onDidChangeActiveTextEditor(Q,ue,De){return It.onDidChangeActiveTextEditor(Q,ue,De)},onDidChangeVisibleTextEditors(Q,ue,De){return It.onDidChangeVisibleTextEditors(Q,ue,De)},onDidChangeTextEditorSelection(Q,ue,De){return It.onDidChangeTextEditorSelection(Q,ue,De)},onDidChangeTextEditorOptions(Q,ue,De){return It.onDidChangeTextEditorOptions(Q,ue,De)},onDidChangeTextEditorVisibleRanges(Q,ue,De){return It.onDidChangeTextEditorVisibleRanges(Q,ue,De)},onDidChangeTextEditorViewColumn(Q,ue,De){return It.onDidChangeTextEditorViewColumn(Q,ue,De)},onDidCloseTerminal(Q,ue,De){return st.onDidCloseTerminal(Q,ue,De)},onDidOpenTerminal(Q,ue,De){return st.onDidOpenTerminal(Q,ue,De)},onDidChangeActiveTerminal(Q,ue,De){return st.onDidChangeActiveTerminal(Q,ue,De)},onDidChangeTerminalDimensions(Q,ue,De){return(0,z.checkProposedApiEnabled)(Ae),st.onDidChangeTerminalDimensions(Q,ue,De)},onDidChangeTerminalState(Q,ue,De){return(0,z.checkProposedApiEnabled)(Ae),st.onDidChangeTerminalState(Q,ue,De)},onDidWriteTerminalData(Q,ue,De){return(0,z.checkProposedApiEnabled)(Ae),st.onDidWriteTerminalData(Q,ue,De)},get state(){return xe.state},onDidChangeWindowState(Q,ue,De){return xe.onDidChangeWindowState(Q,ue,De)},showInformationMessage(Q,...ue){return ai.showMessage(Ae,T.default.Info,Q,ue[0],ue.slice(1))},showWarningMessage(Q,...ue){return ai.showMessage(Ae,T.default.Warning,Q,ue[0],ue.slice(1))},showErrorMessage(Q,...ue){return ai.showMessage(Ae,T.default.Error,Q,ue[0],ue.slice(1))},showQuickPick(Q,ue,De){return Ot.showQuickPick(Q,!!Ae.enableProposedApi,ue,De)},showWorkspaceFolderPick(Q){return Ot.showWorkspaceFolderPick(Q)},showInputBox(Q,ue){return Ot.showInput(Q,ue)},showOpenDialog(Q){return Bt.showOpenDialog(Q)},showSaveDialog(Q){return Bt.showSaveDialog(Q)},createStatusBarItem(Q,ue,De){let it,vt,Dt;return typeof Q=="string"?(it=Q,vt=ue,Dt=De):(vt=Q,Dt=ue),Ft.createStatusBarEntry(Ae,it,vt,Dt)},setStatusBarMessage(Q,ue){return Ft.setStatusBarMessage(Q,ue)},withScmProgress(Q){return $e.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),fi.withProgress(Ae,{location:L.ProgressLocation.SourceControl},(ue,De)=>Q({report(it){}}))},withProgress(Q,ue){return fi.withProgress(Ae,Q,ue)},createOutputChannel(Q){return Wt.createOutputChannel(Q,Ae)},createWebviewPanel(Q,ue,De,it){return si.createWebviewPanel(Ae,Q,ue,De,it)},createWebviewTextEditorInset(Q,ue,De,it){return(0,z.checkProposedApiEnabled)(Ae),ti.createWebviewEditorInset(Q,ue,De,it,Ae)},createTerminal(Q,ue,De){return typeof Q=="object"?"pty"in Q?st.createExtensionTerminal(Q):st.createTerminalFromOptions(Q):st.createTerminal(Q,ue,De)},registerTerminalLinkProvider(Q){return st.registerLinkProvider(Q)},registerTerminalProfileProvider(Q,ue){return st.registerProfileProvider(Ae,Q,ue)},registerTreeDataProvider(Q,ue){return hi.registerTreeDataProvider(Q,ue,Ae)},createTreeView(Q,ue){return hi.createTreeView(Q,ue,Ae)},registerWebviewPanelSerializer:(Q,ue)=>si.registerWebviewPanelSerializer(Ae,Q,ue),registerCustomEditorProvider:(Q,ue,De={})=>yi.registerCustomEditorProvider(Ae,Q,ue,De),registerFileDecorationProvider(Q){return bt.registerFileDecorationProvider(Q,Ae.identifier)},registerUriHandler(Q){return qt.registerUriHandler(Ae.identifier,Q)},createQuickPick(){return Ot.createQuickPick(Ae.identifier,!!Ae.enableProposedApi)},createInputBox(){return Ot.createInputBox(Ae.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Q,ue,De){return mi.onDidChangeActiveColorTheme(Q,ue,De)},registerWebviewViewProvider(Q,ue,De){return Si.registerWebviewViewProvider(Ae,Q,ue,De?.webviewOptions)},get activeNotebookEditor(){return(0,z.checkProposedApiEnabled)(Ae),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Q,ue,De){return(0,z.checkProposedApiEnabled)(Ae),mt.onDidChangeActiveNotebookEditor(Q,ue,De)},get visibleNotebookEditors(){return(0,z.checkProposedApiEnabled)(Ae),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,z.checkProposedApiEnabled)(Ae),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Q,ue,De){return(0,z.checkProposedApiEnabled)(Ae),Ht.onDidChangeNotebookEditorSelection(Q,ue,De)},onDidChangeNotebookEditorVisibleRanges(Q,ue,De){return(0,z.checkProposedApiEnabled)(Ae),Ht.onDidChangeNotebookEditorVisibleRanges(Q,ue,De)},showNotebookDocument(Q,ue){return(0,z.checkProposedApiEnabled)(Ae),mt.showNotebookDocument(Q,ue)},registerExternalUriOpener(Q,ue,De){return(0,z.checkProposedApiEnabled)(Ae),Kt.registerExternalUriOpener(Ae.identifier,Q,ue,De)},get openEditors(){return(0,z.checkProposedApiEnabled)(Ae),at.tabs},get onDidChangeOpenEditors(){return(0,z.checkProposedApiEnabled)(Ae),at.onDidChangeTabs},getInlineCompletionItemController(Q){return(0,z.checkProposedApiEnabled)(Ae),m.InlineCompletionController.get(Q)}},wi={get rootPath(){return $e.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Be.getPath()},set rootPath(Q){throw F.readonly()},getWorkspaceFolder(Q){return Be.getWorkspaceFolder(Q)},get workspaceFolders(){return Be.getWorkspaceFolders()},get name(){return Be.name},set name(Q){throw F.readonly()},get workspaceFile(){return Be.workspaceFile},set workspaceFile(Q){throw F.readonly()},updateWorkspaceFolders:(Q,ue,...De)=>Be.updateWorkspaceFolders(Ae,Q,ue||0,...De),onDidChangeWorkspaceFolders:function(Q,ue,De){return Be.onDidChangeWorkspace(Q,ue,De)},asRelativePath:(Q,ue)=>Be.getRelativePath(Q,ue),findFiles:(Q,ue,De,it)=>Be.findFiles(H.GlobPattern.from(Q),H.GlobPattern.from(ue),De,Ae.identifier,it),findTextInFiles:(Q,ue,De,it)=>{let vt,Dt;return typeof ue=="object"?(vt=ue,Dt=De):(vt={},Dt=ue,it=De),Be.findTextInFiles(Q,vt||{},Dt,Ae.identifier,it)},saveAll:Q=>Be.saveAll(Q),applyEdit(Q){return Ci.applyWorkspaceEdit(Q)},createFileSystemWatcher:(Q,ue,De,it)=>Lt.createFileSystemWatcher(H.GlobPattern.from(Q),ue,De,it),get textDocuments(){return Et.getAllDocumentData().map(Q=>Q.document)},set textDocuments(Q){throw F.readonly()},openTextDocument(Q){let ue;const De=Q;if(typeof Q=="string")ue=Promise.resolve(A.URI.file(Q));else if(A.URI.isUri(Q))ue=Promise.resolve(Q);else if(!De||typeof De=="object")ue=Et.createDocumentData(De);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(it=>Et.ensureDocumentData(it).then(vt=>vt.document))},onDidOpenTextDocument:(Q,ue,De)=>Et.onDidAddDocument(Q,ue,De),onDidCloseTextDocument:(Q,ue,De)=>Et.onDidRemoveDocument(Q,ue,De),onDidChangeTextDocument:(Q,ue,De)=>Et.onDidChangeDocument(Q,ue,De),onDidSaveTextDocument:(Q,ue,De)=>Et.onDidSaveDocument(Q,ue,De),onWillSaveTextDocument:(Q,ue,De)=>Xt.getOnWillSaveTextDocumentEvent(Ae)(Q,ue,De),get notebookDocuments(){return mt.notebookDocuments.map(Q=>Q.apiNotebook)},async openNotebookDocument(Q,ue){let De;if(A.URI.isUri(Q))De=Q,await mt.openNotebookDocument(Q);else if(typeof Q=="string")De=A.URI.revive(await mt.createNotebookDocument({viewType:Q,content:ue}));else throw new Error("Invalid arguments");return mt.getNotebookDocument(De).apiNotebook},get onDidOpenNotebookDocument(){return mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return mt.onDidCloseNotebookDocument},registerNotebookSerializer(Q,ue,De,it){return mt.registerNotebookSerializer(Ae,Q,ue,De,Ae.enableProposedApi?it:void 0)},registerNotebookContentProvider:(Q,ue,De,it)=>((0,z.checkProposedApiEnabled)(Ae),mt.registerNotebookContentProvider(Ae,Q,ue,De,Ae.enableProposedApi?it:void 0)),onDidChangeConfiguration:(Q,ue,De)=>gi.onDidChangeConfiguration(Q,ue,De),getConfiguration(Q,ue){return ue=arguments.length===1?void 0:ue,gi.getConfiguration(Q,ue,Ae)},registerTextDocumentContentProvider(Q,ue){return Jt.registerTextDocumentContentProvider(Q,ue)},registerTaskProvider:(Q,ue)=>($e.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),Tt.registerTaskProvider(Ae,Q,ue)),registerFileSystemProvider(Q,ue,De){return ii.registerFileSystemProvider(Ae.identifier,Q,ue,De,Ae.enableProposedApi)},get fs(){return ge.value},registerFileSearchProvider:(Q,ue)=>((0,z.checkProposedApiEnabled)(Ae),kt.registerFileSearchProvider(Q,ue)),registerTextSearchProvider:(Q,ue)=>((0,z.checkProposedApiEnabled)(Ae),kt.registerTextSearchProvider(Q,ue)),registerRemoteAuthorityResolver:(Q,ue)=>((0,z.checkProposedApiEnabled)(Ae),Ie.registerRemoteAuthorityResolver(Q,ue)),registerResourceLabelFormatter:Q=>((0,z.checkProposedApiEnabled)(Ae),_i.$registerResourceLabelFormatter(Q)),onDidCreateFiles:(Q,ue,De)=>Lt.onDidCreateFile(Q,ue,De),onDidDeleteFiles:(Q,ue,De)=>Lt.onDidDeleteFile(Q,ue,De),onDidRenameFiles:(Q,ue,De)=>Lt.onDidRenameFile(Q,ue,De),onWillCreateFiles:(Q,ue,De)=>Lt.getOnWillCreateFileEvent(Ae)(Q,ue,De),onWillDeleteFiles:(Q,ue,De)=>Lt.getOnWillDeleteFileEvent(Ae)(Q,ue,De),onWillRenameFiles:(Q,ue,De)=>Lt.getOnWillRenameFileEvent(Ae)(Q,ue,De),openTunnel:Q=>((0,z.checkProposedApiEnabled)(Ae),ke.openTunnel(Ae,Q).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,z.checkProposedApiEnabled)(Ae),ke.getTunnels()},onDidChangeTunnels:(Q,ue,De)=>((0,z.checkProposedApiEnabled)(Ae),ke.onDidChangeTunnels(Q,ue,De)),registerPortAttributesProvider:(Q,ue)=>((0,z.checkProposedApiEnabled)(Ae),ke.registerPortsAttributesProvider(Q,ue)),registerTimelineProvider:(Q,ue)=>((0,z.checkProposedApiEnabled)(Ae),ri.registerTimelineProvider(Q,ue,Ae.identifier,nt.converter)),get isTrusted(){return Be.trusted},requestWorkspaceTrust:Q=>((0,z.checkProposedApiEnabled)(Ae),Be.requestWorkspaceTrust(Q)),onDidGrantWorkspaceTrust:(Q,ue,De)=>Be.onDidGrantWorkspaceTrust(Q,ue,De)},Ri={get inputBox(){return $e.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),Gt.getLastInputBox(Ae)},createSourceControl(Q,ue,De){return Gt.createSourceControl(Ae,Q,ue,De)}},Fi={createCommentController(Q,ue){return Ei.createCommentController(Ae,Q,ue)}},Mi={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(Q,ue,De){return ft.onDidStartDebugSession(Q,ue,De)},onDidTerminateDebugSession(Q,ue,De){return ft.onDidTerminateDebugSession(Q,ue,De)},onDidChangeActiveDebugSession(Q,ue,De){return ft.onDidChangeActiveDebugSession(Q,ue,De)},onDidReceiveDebugSessionCustomEvent(Q,ue,De){return ft.onDidReceiveDebugSessionCustomEvent(Q,ue,De)},onDidChangeBreakpoints(Q,ue,De){return ft.onDidChangeBreakpoints(Q,ue,De)},registerDebugConfigurationProvider(Q,ue,De){return ft.registerDebugConfigurationProvider(Q,ue,De||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Q,ue){return ft.registerDebugAdapterDescriptorFactory(Ae,Q,ue)},registerDebugAdapterTrackerFactory(Q,ue){return ft.registerDebugAdapterTrackerFactory(Q,ue)},startDebugging(Q,ue,De){return!De||typeof De=="object"&&"configuration"in De?ft.startDebugging(Q,ue,{parentSession:De}):ft.startDebugging(Q,ue,De||{})},stopDebugging(Q){return ft.stopDebugging(Q)},addBreakpoints(Q){return ft.addBreakpoints(Q)},removeBreakpoints(Q){return ft.removeBreakpoints(Q)},asDebugSourceUri(Q,ue){return ft.asDebugSourceUri(Q,ue)}},Li={registerTaskProvider:(Q,ue)=>Tt.registerTaskProvider(Ae,Q,ue),fetchTasks:Q=>Tt.fetchTasks(Q),executeTask:Q=>Tt.executeTask(Ae,Q),get taskExecutions(){return Tt.taskExecutions},onDidStartTask:(Q,ue,De)=>Tt.onDidStartTask(Q,ue,De),onDidEndTask:(Q,ue,De)=>Tt.onDidEndTask(Q,ue,De),onDidStartTaskProcess:(Q,ue,De)=>Tt.onDidStartTaskProcess(Q,ue,De),onDidEndTaskProcess:(Q,ue,De)=>Tt.onDidEndTaskProcess(Q,ue,De)},ui={createNotebookController(Q,ue,De,it,vt){return Zt.createNotebookController(Ae,Q,ue,De,it,Ae.enableProposedApi?vt:void 0)},registerNotebookCellStatusBarItemProvider:(Q,ue)=>mt.registerNotebookCellStatusBarItemProvider(Ae,Q,ue),get onDidSaveNotebookDocument(){return(0,z.checkProposedApiEnabled)(Ae),jt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Q){return(0,z.checkProposedApiEnabled)(Ae),Ht.createNotebookEditorDecorationType(Q)},createRendererMessaging(Q){return ei.createRendererMessaging(Ae,Q)},onDidChangeNotebookDocumentMetadata(Q,ue,De){return(0,z.checkProposedApiEnabled)(Ae),jt.onDidChangeNotebookDocumentMetadata(Q,ue,De)},onDidChangeNotebookCells(Q,ue,De){return(0,z.checkProposedApiEnabled)(Ae),mt.onDidChangeNotebookCells(Q,ue,De)},onDidChangeNotebookCellExecutionState(Q,ue,De){return(0,z.checkProposedApiEnabled)(Ae),mt.onDidChangeNotebookCellExecutionState(Q,ue,De)},onDidChangeCellOutputs(Q,ue,De){return(0,z.checkProposedApiEnabled)(Ae),mt.onDidChangeCellOutputs(Q,ue,De)},onDidChangeCellMetadata(Q,ue,De){return(0,z.checkProposedApiEnabled)(Ae),mt.onDidChangeCellMetadata(Q,ue,De)},createConcatTextDocument(Q,ue){return(0,z.checkProposedApiEnabled)(Ae),new He.ExtHostNotebookConcatDocument(mt,Et,Q,ue)}};return{version:oe.version,authentication:ki,commands:Ii,comments:Fi,debug:Mi,env:pi,extensions:li,languages:Ti,notebooks:ui,scm:Ri,tasks:Li,tests:Pi,window:Ai,workspace:wi,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:h.CancellationTokenSource,CandidatePortSource:r.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:L.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,InlineCompletionItem:L.InlineSuggestion,InlineCompletionList:L.InlineSuggestions,Hover:L.Hover,IndentAction:P.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TerminalLink:L.TerminalLink,TerminalProfile:L.TerminalProfile,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,TextDocumentChangeReason:L.TextDocumentChangeReason,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,TypeHierarchyItem:L.TypeHierarchyItem,UIKind:r.UIKind,Uri:A.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookRendererScript:L.NotebookRendererScript,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,PortAttributes:L.PortAttributes,LinkedEditingRanges:L.LinkedEditingRanges,TestResultState:L.TestResultState,TestRunRequest:L.TestRunRequest,TestMessage:L.TestMessage,TestTag:L.TestTag,TestRunProfileKind:L.TestRunProfileKind,TextSearchCompleteMessageType:_t.TextSearchCompleteMessageType,CoveredCount:L.CoveredCount,FileCoverage:L.FileCoverage,StatementCoverage:L.StatementCoverage,BranchCoverage:L.BranchCoverage,FunctionCoverage:L.FunctionCoverage,WorkspaceTrustState:L.WorkspaceTrustState,LanguageStatusSeverity:L.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(Ee[223],_e([0,1,55,96,31,95,32,46,47,37,99,100,101,71,64,69,97,70,45,68,86,62]),function(te,e,h,F,E,T,A,I,D,P,t,S,r,d,a,l,p,v,k,c,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService),(0,h.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,h.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,h.registerSingleton)(v.IExtHostConsumerFileSystem,v.ExtHostConsumerFileSystem),(0,h.registerSingleton)(S.IExtHostDebugService,S.WorkerExtHostDebugService),(0,h.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,h.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,h.registerSingleton)(k.IExtHostFileSystemInfo,k.ExtHostFileSystemInfo),(0,h.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,h.registerSingleton)(r.IExtHostSearch,r.ExtHostSearch),(0,h.registerSingleton)(d.IExtHostStorage,d.ExtHostStorage),(0,h.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,h.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,h.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,h.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,h.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,h.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,h.registerSingleton)(w.IExtHostTelemetry,w.ExtHostTelemetry),(0,h.registerSingleton)(y.IExtHostEditorTabs,y.ExtHostEditorTabs)}),define(Ee[224],_e([0,1,222,33,218,6,13,5,11]),function(te,e,h,F,E,T,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var P;(function(a){const l=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(v,...k)=>{k.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const c=k.slice(0,-1).join(","),w=k.pop().toString();return`(function anonymous(${c}) {
${w}
})`}});function p(...v){return l?self.eval(l.createScript("",...v)):new Function(...v)}a.create=p})(P||(P={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(l,p){for(let v of this._alternatives){let k=v(l);if(k){l=k;break}}if(this._factories.has(l))return this._factories.get(l).load(l,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class S extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);d(l,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(h.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,p,v){p=p.with({path:r(p.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const k=await fetch(D.FileAccess.asBrowserUri(p).toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),k.status!==200)throw new Error(k.statusText);const c=await k.text(),w=`${p.toString(!0)}#vscode-extension`,y=`${c}
//# sourceURL=${w}`;let i;try{i=P.create(S._ttpExtensionScripts?.createScript("module")??"module",S._ttpExtensionScripts?.createScript("exports")??"exports",S._ttpExtensionScripts?.createScript("require")??"require",S._ttpExtensionScripts?.createScript(y)??y)}catch(f){throw console.error(l?`Loading code for extension ${l.value} failed: ${f.message}`:`Loading code failed: ${f.message}`),console.error(`${p.toString(!0)}${typeof f.line=="number"?` line ${f.line}`:""}${typeof f.column=="number"?` column ${f.column}`:""}`),console.error(f),f}const o={},u={exports:o},s=f=>{const m=this._fakeModules.getModule(f,p);if(m===void 0)throw new Error(`Cannot load module '${f}'`);return m};try{return v.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),i(u,o,s),u.exports!==o?u.exports:o}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),v.codeLoadingStop()}}async $setRemoteEnvironment(l){throw new Error("Not supported")}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+l;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=S,S._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:a=>a});function r(a,l){return a.endsWith(l)?a:a+l}function d(a,l){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(c,w){const y=console[c];console[c]=function(){a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:k(arguments)}),l&&y.apply(console,arguments)}}const v=1e5;function k(c){const w=[],y=[];if(c.length)for(let i=0;i<c.length;i++){if(typeof c[i]=="undefined")c[i]="undefined";else if(c[i]instanceof Error){const o=c[i];o.stack?c[i]=o.stack:c[i]=o.toString()}y.push(c[i])}try{const i=JSON.stringify(y,function(o,u){if(u&&typeof u=="object"){if(w.indexOf(u)!==-1)return"[Circular]";w.push(u)}return u});return i.length>v?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(Ee[225],_e([0,1,55,14,33,72,224,211]),function(te,e,h,F,E,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(E.IExtHostExtensionService,A.ExtHostExtensionService),(0,h.registerSingleton)(F.ILogService,I.ExtHostLogService),(0,h.registerSingleton)(T.IExtensionStoragePaths,T.ExtensionStoragePaths)}),define(Ee[234],_e([0,1,23,3,176,219,213,17,73,11,2,223,225]),function(te,e,h,F,E,T,A,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const r=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const k=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:w=>w}),c=self.Worker;Worker=function(w,y){/^file:/i.test(w.toString())&&(w=P.FileAccess.asBrowserUri(t.URI.parse(w.toString())).toString(!0));const i=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${w}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;y=y||{},y.name=y.name||I.basename(w.toString());const o=new Blob([i],{type:"application/javascript"}),u=URL.createObjectURL(o);return new c(k?k.createScriptURL(u):u,y)}}else self.Worker=class extends A.NestedWorker{constructor(k,c){super(r,k,{name:I.basename(k.toString()),...c})}};const d=new class{exit(k){S()}async exists(k){return!0}async realpath(k){return k}};class a{constructor(){const c=new MessageChannel,w=new F.Emitter;let y=!1;r(c.port2,[c.port2]),c.port1.onmessage=i=>{const{data:o}=i;if(!(o instanceof ArrayBuffer)){console.warn("UNKNOWN data received",o);return}const u=h.VSBuffer.wrap(new Uint8Array(o,0,o.byteLength));if((0,E.isMessageOfType)(u,2)){y=!0,p("received terminate message from renderer");return}w.fire(u)},this.protocol={onMessage:w.event,send:i=>{if(!y){const o=i.buffer.buffer.slice(i.buffer.byteOffset,i.buffer.byteOffset+i.buffer.byteLength);c.port1.postMessage(o,[o])}}}}}function l(k){return new Promise(c=>{const w=k.onMessage(y=>{w.dispose();const i=JSON.parse(y.toString());k.send((0,E.createMessageOfType)(0)),c({protocol:k,initData:i})});k.send((0,E.createMessageOfType)(1))})}let p=k=>S();function v(){const k=new a;D.mark("code/extHost/willConnectToRenderer"),l(k.protocol).then(c=>{D.mark("code/extHost/didWaitForInitData");const w=new T.ExtensionHostMain(c.protocol,c.initData,d,null);p=y=>w.terminate(y)})}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f0913d7718bbc4a805cd3a051335b4df60ca5d77/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
